/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
/* versin asegurada, 18 de mayo de 2007, JLAbreu */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.HTMLEditorKit;
import javax.swing.text.rtf.RTFEditorKit;
//import netscape.javascript.JSObject;


public class BottomMenu extends JApplet implements ActionListener {
	
	static final String[] title = {
		"Instrucciones",
		"Propsitos",
		"Sugerencias_didcticas",
		"",
		"",
		"",
		""
	};
	
//	static final String[] paramName = {
//		"instrucciones",
//		"propositos",
//		"sugerencias",
//		"ayuda",
//		"creditos",
//		"herramientas",
//		"cerrar"
//	};

	static final String[] defaultValue = {
		"docs/instrucciones.rtf",
		"docs/proposito.rtf",
		"docs/sugerenciasDidacticas.rtf",
		"",
		"docs/creditos.rtf",
		"",
		""
	};
	
	static final String[] imageName = {
		"instrucciones",
		"propositos",
		"sugerencias",
		"ayuda",
		"creditos",
		"herramientas",
		"cerrar"
	};
	
	JButton[] b=new JButton[imageName.length];
	
	final static int ayuda=3,creditos=4,herramientas=5,cerrar=6;
	private String level_str="parent.parent.";
	private Color background=Color.black;
	
	public void init() {
		if (getParameter("level")!=null) {
			try {
				int N=Integer.parseInt(getParameter("level"));
				level_str="";
				while (N>0) {
					level_str+="parent.";
					N--;
				}
			} catch (NumberFormatException ex) {
				level_str="parent.";
			}
		}
		if (getParameter("background")!=null) {
			try {
				int N=Integer.parseInt(getParameter("background"),16);
				background=new Color(N);
			} catch (NumberFormatException ex) {
			}
		}
		setBackground(background);
		Image[] img=new Image[imageName.length];
		MediaTracker mt=new MediaTracker(this);
		for (int i=0;i<imageName.length;i++) {
			try {
				img[i]=Toolkit.getDefaultToolkit().getImage(getClass().getResource("/resources/images/"+imageName[i]+".png"));
				mt.addImage(img[i],i);
				mt.waitForID(i);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
//		for (int i=0;i<paramName.length;i++) {
//			b[i]=new MenuButton(this,title[i],img[i],getValue(paramName[i],defaultValue[i]));
		for (int i=0;i<imageName.length;i++) {
			b[i]=new MenuButton(this,title[i],img[i],getValue(imageName[i],defaultValue[i]));
			b[i].setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		}
		b[ayuda]=new JButton(new ImageIcon(img[ayuda]));
		b[ayuda].setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
//		b[creditos]=new JButton(new ImageIcon(img[creditos]));
//		b[creditos].setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		b[herramientas]=new JButton(new ImageIcon(img[herramientas]));
		b[herramientas].setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		b[cerrar]=new JButton(new ImageIcon(img[cerrar]));
		b[cerrar].setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

		Container contentPane = getContentPane();
		contentPane.setBackground(background);
		contentPane.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		boolean hayBoton=false;
		boolean primerChiquito=true;
		for (int i=0;i<imageName.length;i++) {
			boolean poner=true;
//			if ((i<herramientas) && "no".equals(getParameter(paramName[i]))) {
			if ((i<herramientas) && "no".equals(getParameter(imageName[i]))) {
				poner=false;
			}
			if ((i==ayuda) && ((getParameter(imageName[i])==null)||(getParameter(imageName[i]).length()==0))) {
				poner=false;
			}
			if (i>=herramientas) {
				poner=true;
			}
//			if (i<herramientas) {
//				hayBoton|=poner;
//			}
			if (poner) {
				if (i>0 && hayBoton) {
					Canvas C=new Canvas();
					int dx=3;
					if ((i>=3) && primerChiquito) {
						dx=45;
					}
					C.setSize(dx,22);
					C.setBackground(background);
					contentPane.add(C);
				}
				b[i].setBackground(background);
				b[i].setMargin(new Insets(0,0,0,0));
				b[i].setBorder(null);
				b[i].setBorderPainted(false);
				if (i>=ayuda) {
					b[i].addActionListener(this);
					primerChiquito=false;
				}
				contentPane.add(b[i]);
				hayBoton=true;
			}
		}
	}

	public String getValue(String paramName,String paramDefault) {
		String value=getParameter(paramName);
		if ( value==null || value.length()==0 ) {
			value=paramDefault;
		}
		return value;
	}
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b[creditos]||e.getSource()==b[ayuda]) {
			Dimension S=Toolkit.getDefaultToolkit().getScreenSize();
			Point p=getLocationOnScreen();
			int left=(e.getSource()==b[creditos])?p.x+5:(S.width-710)/2;
			if (left+710 > S.width) {
				left=S.width-710;
			}
			int top=(e.getSource()==b[creditos])?p.y-520:40;
			if (top<0) top=0;
			if (left<0) left=0;
			String filename=(e.getSource()==b[creditos])?"creditos":"ayuda";
			String cmd="window.open('../../"+filename+".html','"+"filename"+
						"','top="+top+",left="+left+
						",width=700,height=490,"+
						"toolbar=0,menubar=0,scrollbars=1,resizable=1,location=0,status=0');void(0);";
			JavaScriptCall(this,cmd);
		} else if (e.getSource()==b[herramientas]) {
//			JavaScriptCall(this,level_str+"showBar()");
			JavaScriptCall(this,level_str+"mostrarBarra('si')");
		} else if (e.getSource()==b[cerrar]) {
//			JavaScriptCall(this,level_str+"closeWindow()");
			JavaScriptCall(this,level_str+"cerrar()");
		}
	}

	public static void JavaScriptCall(Applet A,String jsCommand) {
		try {
			URL url=new URL("javascript:"+jsCommand);
			System.out.println(url.toExternalForm());
			A.getAppletContext().showDocument(url,"_self");
		} catch (MalformedURLException mue) {
			System.out.println(mue);
		}
	}

}

class MenuButton extends JButton implements ActionListener {
	
	static final Dimension D=new Dimension(760,540);
	static final Color fgColor = new Color(0x000000);
	static final JFrame popUpF = new JFrame();
	static final Font fuente = new Font("SansSerif", Font.BOLD, 12);
	private VentanaInformativa V;
	private Applet A;
	private String title, infoSource;
	private boolean own;
	private int left=40,top=40;
	
	MenuButton(Applet A,String title,Image img,String infoSource) {
		super(new ImageIcon(img));
		this.A=A;
		this.title=title;
		this.infoSource=infoSource;
		setFont(fuente);
		setForeground(fgColor);
		own=infoSource.toLowerCase().endsWith(".rtf");
		if (own) {
			V=new VentanaInformativa(A,popUpF,title,infoSource);
			V.setSize(D);
			Dimension S=Toolkit.getDefaultToolkit().getScreenSize();
			V.setLocation((S.width-D.width)/2,(S.height-D.height)/2);
		} 
		addActionListener(this);
	}

	public void actionPerformed(ActionEvent e) {
		if (own) {
			V.setVisible(true);
		} else {
			Dimension S=Toolkit.getDefaultToolkit().getScreenSize();
			Point p=A.getLocationOnScreen();
			left=p.x+40;
			if (left+650 > S.width) {
				left=S.width-650;
			}
			top=p.y-500;
			if (top<0) top=0;
			if (left<0) left=0;
			String cmd="window.open('"+infoSource+"','"+title+
						"','top="+top+",left="+left+
						",width=640,height=400,"+
						"toolbar=0,menubar=1,scrollbars=1,resizable=1,location=0,status=0');void(0);";
			BottomMenu.JavaScriptCall(A,cmd);
		}
	}

}

class VentanaInformativa extends JDialog implements ActionListener {

	private JTextPane area;
	
	VentanaInformativa(Applet A,JFrame popUpF,String title,String infoSource) {
		super(popUpF, title);
		getContentPane().setLayout(new BorderLayout());
		area = new JTextPane();
		area.setEditable(false);
		JScrollPane jscrollpane = new JScrollPane(area);
		getContentPane().add(jscrollpane, "Center");
		JPanel flow = new JPanel(new FlowLayout());
		JButton cerrar = new JButton("Cerrar");
		cerrar.addActionListener(this);
		flow.add(cerrar);
		getContentPane().add(flow, "Last");
		pack();
		setInfoSource(A,infoSource);
	}
	
	void setInfoSource(Applet A,String infoSource0) {
		String infoSource=replaceSpaceCode(infoSource0);
		if (infoSource==null || infoSource.length()==0 || infoSource.equalsIgnoreCase("no")) {
			return;
		}
		try {
			URL url=new URL(A.getDocumentBase(),infoSource);
			setURL(url);
		} catch(Exception e1) {
			try {
				URL url=new URL(A.getCodeBase(),infoSource);
				setURL(url);
			} catch (Exception e2) {
				if (!"no".equalsIgnoreCase(infoSource)) {
					System.out.println(infoSource+" not found");
				}
			}
		}
	}
	
	String replaceSpaceCode(String s0) {
		String s=new String(s0);
		while(s.indexOf("%20")>=0){
			int pos=s.indexOf("%20");
			s=s.substring(0,pos)+" "+s.substring(pos+3,s.length());
		}
		return s;
	}
	
	void setURL(URL url) throws Exception {
		String infoSource=url.toExternalForm();
		boolean isHTML=infoSource.toLowerCase().endsWith(".html")||infoSource.toLowerCase().endsWith(".htm");
		if (isHTML) {
			area.setEditorKit(new HTMLEditorKit());
			area.setDocument(area.getStyledDocument());
			area.setPage(url);
		} else {
			area.setEditorKit(new RTFEditorKit());
			area.setDocument(area.getStyledDocument());
			area.getEditorKit().read(url.openStream(), area.getDocument(), 0);
		}
	}
	
	public void actionPerformed(ActionEvent actionevent) {
		setVisible(false);
	}

}