/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.image.BufferedImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriter;
import javax.imageio.stream.FileImageOutputStream;
import javax.swing.JButton;
import com.mja.gui.mjaText;
import com.mja.lang.translator;
import com.mja.util.BasicStr;
import com.mja.file.mjaFont;
import com.mja.file.mjaFile;
import com.mja.text.MathText;
import com.mja.text.Formula;

import com.mja.textedit.FormulaEditor;

public class FormulaViewer extends Applet implements Runnable , MouseListener, WindowListener, ActionListener, FilenameFilter {
	
	private static Font font=new Font("SansSerif",Font.PLAIN,17);
	private static translator Tr;
	private static boolean first_time=true;
	private static final String formula0="{\\rtf1{\\fonttbl\\f0\\fcharset0 Times New Roman;}\\f0\\fs34{\\*\\mjaformula\\u960 ={\\limit{\\from a}{\\to\\u8734 }{\\what{\\integral{\\from -a}{\\to a}{\\what{\\fraction{\\num f(x)}{\\den 1+x{\\supix 2}}} dx}}}}}}";

	private Color bgcolor=Color.white,fgcolor=Color.black;
	private String str_bgcolor, str_fgcolor;
	private String formula=formula0, nombre="formula_01";
	private MathText MT;
	private BufferedImage bima,texbima;
	private String formulaName="";
	private FileDialog FDL,FDS;
	private boolean formulaModified=false;
	
	FormulaEditor FE;
	MenuBar MB;
	MenuItem mi_new,mi_open,mi_close,mi_undo,mi_reload,mi_save,mi_saveas,mi_exit;
	Frame F=new Frame("Editor de Frmulas");
	private JButton b_ok;
	
	public static void main(String[] args) {
		new FormulaViewer(args);
	} 
	
	public FormulaViewer (String[] args) {
		// Preparaciones
		mjaFont.prepareFonts(this);
		Tr=new translator(this);
		try {
			while (mjaFont.MathFont()== null || Tr==null) {
				Thread.sleep(50);
			}
		} catch (InterruptedException e) {
		}
		BasicStr.antialias=true;
		Formula.sixp=0.75;
	    Formula.ixp=0.85;
	    Formula.frp=1.0;
	    Formula.useMinFont=false;

		// Construir ventana 
		MB=new MenuBar();
		Menu mArchivo=new Menu("Archivo");
		mArchivo.add(mi_new=new MenuItem("Nuevo"));
		mArchivo.add(mi_open=new MenuItem("Abrir"));
		mArchivo.add(mi_undo=new MenuItem("Deshacer"));
		mArchivo.add(mi_close=new MenuItem("Cerrar"));
		mArchivo.add(mi_reload=new MenuItem("Actualizar"));
		mArchivo.add(mi_save=new MenuItem("Guardar"));
		mArchivo.add(mi_saveas=new MenuItem("Guardar como"));
		mArchivo.add(mi_exit=new MenuItem("Salir"));
		MB.add(mArchivo);
		mi_new.addActionListener(this);
		mi_open.addActionListener(this);
		mi_close.addActionListener(this);
		mi_undo.addActionListener(this);
		mi_reload.addActionListener(this);
		mi_save.addActionListener(this);
		mi_saveas.addActionListener(this);
		mi_exit.addActionListener(this);
		F.setMenuBar(MB);
		F.setBackground(Color.lightGray);
		F.setResizable(true);
		F.setSize(790,565);
		F.setLocation(40,30);
		F.addWindowListener(this);

		F.setLayout(new BorderLayout());
		Panel CP=new Panel();
		CP.setBackground(Color.lightGray);
		CP.setLayout(new GridLayout(2,1));
		this.setBackground(Color.lightGray);
		this.addMouseListener(this);
		CP.add(this);
		String formula_ant=formula;
		FE=new FormulaEditor(F,Tr,formula_ant);
		CP.add(FE);
		F.add("Center",CP);
		b_ok=new JButton("Aplicar");
		b_ok.addActionListener(this);
		Panel MP=new Panel();
		MP.setLayout(new FlowLayout());
		MP.add(b_ok);
		F.add("South",MP);

		FDL=new FileDialog(F,"Abrir html",FileDialog.LOAD);
		FDS=new FileDialog(F,"Guardar html",FileDialog.SAVE);

		File tf=new File("");
		if (!tf.exists()) {
			tf.mkdir();
		}
		if (tf.exists()) {
			FDL.setDirectory("");
			FDS.setDirectory("");
		} else {
			FDL.setDirectory(".");
			FDS.setDirectory(".");
		}
		FDL.setFilenameFilter(this);
		FDS.setFilenameFilter(this);

		F.setVisible(true);

		if (!formula.equals(formula_ant)) {
			formulaModified=true;
			texbima=null;
			MT=new MathText(null,Tr,formula,null,false,font,fgcolor);
			repaint();
		}
		if (args.length>0 && args[0]!=null) {
			formulaName=args[0];
			if (formulaName.toLowerCase().endsWith(".for")||formulaName.toLowerCase().endsWith(".png")) {
				formulaName=formulaName.substring(0,formulaName.lastIndexOf("."));
			}
			refresh();
		} else {
			start();
		}
	}
	
	public void start() {
		FE.setText(formula);
		MT=new MathText(null,Tr,formula,null,false,font,fgcolor);
		texbima=null;
		repaint();
	}

	void refresh() {
		formula=mjaFile.readFile(formulaName+".for");
		FE.setText(formula);
		F.setTitle("Editor de Frmulas: "+formulaName);
		start();
		formulaModified=false;
	}

	private int getAncho() {
		return MT.ancho(this);
	}
	
	private int getAlto() {
		return MT.alto(this);
	}
	
	public String getWidthStr() {
		return Integer.toString(getAncho());
	}

	public String getHeightStr() {
		return Integer.toString(getAlto());
	}

	public String getFormulaCode() {
		return MT.toRTF(false);
	}
	
	public void paint(Graphics g) {
		if (MT!=null) {
			Graphics[] G;
			bima=new BufferedImage(getAncho(),getAlto()+1,BufferedImage.TYPE_INT_RGB);
			G=new Graphics[1];
			G[0]=bima.createGraphics();
			G[0].setColor(Color.white);
			G[0].fillRect(0,0,bima.getWidth(this),bima.getHeight(this));
			MT.draw(this,3,0,G);
			int left=0;
			if (bima!=null) {
				left=(getSize().width-bima.getWidth(this))/2;
				g.drawImage(bima,left,32,this);
			}
			if (texbima==null) {
				Thread thr=new Thread(this);
				thr.start();
			}
			if (texbima!=null) {
				left=(getSize().width-texbima.getWidth(this))/2;
				g.drawImage(texbima,left,64+bima.getHeight(this),this);
			}
		}
	}
	
	
/* ------------ Runnable ---------- */

	public void run() {
		try {
			String str=BasicStr.replace(MT.toTeX()," ","%20");
			URL url=new URL("http://www.forkosh.dreamhost.com/mathtex.cgi?"+str);
			Proxy tmpProxy = mjaFile.getProxyFor(url);
			url.openConnection(tmpProxy);
			Image image = Toolkit.getDefaultToolkit().getImage(url);

			MediaTracker mt=new MediaTracker(this);
			mt.addImage(image,0);
			mt.waitForID(0);
			if (mt.isErrorAny()||image.getWidth(this)==0||image.getHeight(this)==0) {
				throw new Exception("Exception loading image");
			}
			int tex_w=image.getWidth(this)+12;
			int tex_h=image.getHeight(this)+8;
			texbima=new BufferedImage(tex_w,tex_h,BufferedImage.TYPE_INT_RGB);
			if (texbima!=null) {
				Graphics Gtex=texbima.getGraphics();
				Gtex.setColor(Color.white);
				Gtex.fillRect(0,0,texbima.getWidth(this),texbima.getHeight(this));
				Gtex.drawImage(image,6,4,this);
			}
			repaint();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

/* ------------ FileFilter ---------- */

	public boolean accept(File f,String filename) {
		return filename.toLowerCase().endsWith(".for");
	}


/* ------------ Mouse Listener ---------- */

	public void mouseClicked(MouseEvent e) {
		if (e.getClickCount()==2) {
			FE.setText(formula);
		} else if (e.getClickCount()==1 && e.getModifiers()==e.BUTTON3_MASK) {
			mjaText.showPlainTextFrame("Cdigo TeX",MT.toTeX());
		}
	}
	
	public void mousePressed(MouseEvent e) {}

	public void mouseReleased(MouseEvent e) {}

	public void mouseEntered(MouseEvent e) {}

	public void mouseExited(MouseEvent e) {}
	
		int getPixel(int i,int j) {
		if (bima!=null) {
			int color=bima.getRGB(i,j);
			Color c=new Color(color);
			int res = ( c.getRed()+c.getGreen()+c.getBlue() )/3;
			return res;
		}
		return 0;
	}
	
	void newFormula() {
		if ( formulaModified && mjaText.ask("Nueva frmula","Desea guardar los cambios?","si","no"))  {
			save();
		}
		formula=formula0;
		formulaName="";
		F.setTitle("Editor de Frmulas: "+formulaName);
		start();
	}
	
	static final String[] posext={
		"bmp","png","for","txt"
	};
	
	private String cleanFileName(String str) {
		for (int i=0;i<posext.length;i++) {
			int n=str.indexOf("."+posext[i]);
			if (n>0) {
				str=str.substring(0,n);
			}
		}
		return str;
	}

	void read() {
		FDL.show();
		boolean changed=true;
		if (FDL.getFile()!=null && FDL.getDirectory()!=null) {
			changed=false;
			if ( formulaModified && mjaText.ask("Abrir frmula","Desea guardar los cambios?","si","no"))  {
				save();
			}
			String str=FDL.getDirectory()+FDL.getFile();
			if (BasicStr.hasContent(str)) {
				formulaName=cleanFileName(str);
				FDS.setFile(formulaName+".for");
				texbima=null;
				refresh();
			}
		}
	}

	void save() {
		int width=bima.getWidth(this);
		int height=bima.getHeight(this);
		
		Iterator it=ImageIO.getImageWritersByFormatName("png");
		boolean pngok=false;
		if (it.hasNext()) {
			try {
				ImageWriter iw=(ImageWriter) it.next();
				File file=new File(formulaName+".png");
				FileImageOutputStream fios=new FileImageOutputStream(file);
				iw.setOutput(fios);
				iw.write(bima);
				fios.flush();
				fios.close();
				File filetex=new File(formulaName+"_tex.png");
				FileImageOutputStream fiostex=new FileImageOutputStream(filetex);
				iw.setOutput(fiostex);
				iw.write(texbima);
				fiostex.flush();
				fiostex.close();
				pngok=true;
				iw.dispose();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
//		mjaFile.save(formulaName+".for",MT.toRTF(false));
//		mjaFile.save(formulaName+".tex",MT.toTeX());
		com.mja.file.mjaHtml.writeInUTF8File(MT.toRTF(false),formulaName+".for");
		com.mja.file.mjaHtml.writeInUTF8File(MT.toTeX(),formulaName+".tex");
		formulaModified=false;
	}
	
	private boolean trySaveAs() {
		FDS.show();
		if (FDS.getDirectory()!=null && FDS.getFile()!=null) {
			String filename=FDS.getDirectory()+FDS.getFile();
			if (BasicStr.hasContent(filename)) {
				formulaName=cleanFileName(filename);
				save();
				FDL.setDirectory(FDS.getDirectory());
				F.setTitle("Editor de Frmulas: "+formulaName);
				refresh();
				save();
				return true;
			}
		}
		return false;
	}
	
	private boolean tryClosing() {
		if (formulaModified) {
			if (mjaText.ask("Guardar","Desea guardar los cambios?","si","no")) {
				save();
				return true;
			} else if (mjaText.ask("Salir","Desea cerrar el Editor de Frmulas?","si","no") ) {
				return true;
			} else {
				return false;
			}
		} else {
			return true;
		}
	}

	public void actionPerformed(ActionEvent e) {
		String ac=e.getActionCommand();
		if ("Nuevo".equals(ac)) {
			newFormula();
		} else if ("Abrir".equals(ac)) {
			read();
		} else if ("Cerrar".equals(ac)) {
			if (formulaModified && (mjaText.ask("Guardar","Desea guardar los cambios?","si","no"))) {
				save();
			}
			formula=formula0;
			formulaName="";
			F.setTitle("Editor de Frmulas: "+formulaName);
			start();
		} else if ("Actualizar".equals(ac)) {
			boolean doit=true;
			if ( formulaModified && !mjaText.ask("Actualizar","Si contina se perdern los cambios.\nDesea continuar?","si","no"))  {
				doit=false;
			}
			if (doit) {
				refresh();
			}
		} else if ("Guardar".equals(ac)) {
			if (formulaName.equals("")) {
				if (trySaveAs()) {
					save();
					refresh();
				}
			} else {
				save();
			}
		} else if ("Guardar como".equals(ac)) {
			if (trySaveAs()) {
				F.setTitle("Editor de Frmulas: "+formulaName);
				save();
				refresh();
			}
		} else if ("Salir".equals(ac)) {
			if (tryClosing()) {
				System.exit(0);
			}
		} else if ("Deshacer".equals(ac)) {
			FE.setText(formula);
		} else if (e.getSource()==b_ok) {
			formulaModified=true;
			texbima=null;
			MT=new MathText(null,Tr,FE.getText(),null,false,font,fgcolor);
			repaint();
		}			
	}
	
	public void windowOpened(WindowEvent e) {
	}
	public void windowActivated(WindowEvent e) {}
	public void windowDeactivated(WindowEvent e) {}
	public void windowIconified(WindowEvent e) {}
	public void windowDeiconified(WindowEvent e) {}
	public void windowClosing(WindowEvent e) { 
		if (tryClosing()) {
			System.exit(0);
		}
	}
	public void windowClosed(WindowEvent e) {}

}