/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.net.*;
import org.cnice.rad.server.Server;
import org.cnice.rad.server.CrearSesionGrupo;
import org.cnice.rad.server.ServerClose;

public class RAD_Applet extends Applet implements Runnable, ActionListener {
	
	private Server server;
	private Thread thr;
	private Button b_iniciarRAD=new Button("Iniciar RAD");
	private Button b_abrirSesionDeGrupo=new Button("Abrir sesin de grupo");
	private Button b_cerrarRAD=new Button("Cerrar RAD");
	private	String db_driver="org.gjt.mm.mysql.Driver";
	private String db_host="jdbc:mysql://localhost/RAD";
	private String db_user="RADServer";
	private String db_password="cnice080622";
	private String db_initial_port="8082",db_final_port="8082";
	private Font font=new Font("SansSerif",Font.PLAIN,16);
	private boolean RAD_running=false;
	private String grupo="";

	public void init() {
		setFont(font);
		setBackground(new Color(0xeee8ef));
		setLayout(new FlowLayout(FlowLayout.CENTER,64,48));
		b_iniciarRAD.addActionListener(this);
		add(b_iniciarRAD);
		b_abrirSesionDeGrupo.setEnabled(false);
		b_abrirSesionDeGrupo.addActionListener(this);
		add(b_abrirSesionDeGrupo);
		b_cerrarRAD.setEnabled(false);
		b_cerrarRAD.addActionListener(this);
		add(b_cerrarRAD);
	}

	public void start() {
		thr=new Thread(this);
		thr.start();
	}
	
	public void actionPerformed(ActionEvent ae) {
		if (ae.getSource()==b_iniciarRAD) {
			thr=new Thread(this);
			thr.start();
		} else if (ae.getSource()==b_abrirSesionDeGrupo) {
			grupo=CrearSesionGrupo.crear(false);
			repaint();
		} else if (ae.getSource()==b_cerrarRAD) {
			new ServerClose("",db_initial_port,db_final_port,"ROOT","rpw1");
		}
	}
	
	public void run() {
		try{
	 		server=new Server(db_driver,db_host,db_user,db_password,db_initial_port,db_final_port);
		    RAD_running=true;
		  	repaint();
			b_abrirSesionDeGrupo.setEnabled(true);
			b_cerrarRAD.setEnabled(true);
		    b_iniciarRAD.setEnabled(false);
		    server.startProcessing();
		} catch(Exception e){
		    e.printStackTrace();
		}
	    RAD_running=false;
	    grupo="";
	    repaint();
		b_abrirSesionDeGrupo.setEnabled(false);
	    b_iniciarRAD.setEnabled(true);
		b_cerrarRAD.setEnabled(false);
	    thr=null;
	}

	public void stop() {
		new ServerClose("",db_initial_port,db_final_port,"ROOT","rpw1");
	}

	public void destroy() {
	}

	public void paint(Graphics g) {
		g.setFont(font);
		g.setColor(new Color(0x000077));
		if (RAD_running) {
			g.drawString("RAD activado",115,105);
		} else {
			g.drawString("RAD desactivado",100,105);
		}
		if (RAD_running && grupo!=null && grupo.length()>0) {
			g.drawString("Abierta sesin del grupo: "+grupo,50,178);
		} else {
			g.drawString("No hay sesin de grupo",80,178);
		}
	}
	
}