/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
/*
 * @(#)calcWin.java	2.0 02/04/20
 *
 * Copyright 2002 Marta Oliver & Jos Luis Abreu.
 * Use is free. (Uso gratuito)
 */

/**
 * A graphic calculator in a window.
 * (Una calculadora en una ventana "windows".)
 * calcWin.java, 1999.
 *
 * @author Jos Luis Abreu
 * @author Marta Oliver
 * @version 	2.0, 20 Apr 2002
 */

package com.jla.calc;

import java.awt.*;
import java.awt.event.*;

public class calcWin extends Dialog implements WindowListener, ActionListener {

	private static Frame F=new Frame();
	private boolean modal=false;
	private calcApplet a;
	private String value;
	private Button yes, no;

    /**
     * Crea un objeto calcWin.
     */
	public static void main(String[] args) {
		new calcWin(false,false);
	}

    /**
     * El constructor nico crea la ventana,
     * le da dimensiones 200x300, la coloca en (80,60),
     * crea un objeto calcApplet y lo coloca en la ventana.
     * Finalmente muestra la ventana.
     */
	public calcWin(boolean modal,boolean alfanumeric) {
		super(F," Calculadora Descartes ",modal);
		if (alfanumeric) {
			setTitle(" Teclado Descartes ");
		}
		this.modal=modal;
		addWindowListener(this);
		a=new calcApplet();
		if (alfanumeric) {
			a.setAlphanumeric(true);
		}
		a.init();
		setLayout(new BorderLayout());
		add("Center",a);

		Panel P=new Panel();
		P.setBackground(Color.gray);
		P.setLayout(new FlowLayout(FlowLayout.CENTER,24,4));
		yes=new Button(" aceptar ");
		yes.setFont(new Font("SansSerif",Font.PLAIN,15)); 
		yes.setBackground(Color.blue);
		yes.setForeground(Color.cyan);
		yes.addActionListener(this);
		P.add(yes);
		no=new Button("cancelar");
		no.setFont(new Font("SansSerif",Font.PLAIN,15)); 
		no.setBackground(Color.blue);
		no.setForeground(Color.cyan);
		no.addActionListener(this);
		P.add(no);
		add("South",P);

		pack();
		if (alfanumeric) {
			setSize(404,300);
		} else {
			setSize(200,300);
		}
		setLocation(80,60);
		if (!modal) {
			show();
		}
	}
	
	private Dimension sz;
	
	public Dimension getSize() {
		if (sz!=null) {
			return sz;
		} else {
			return super.getSize();
		}
	}
	
	public void setSize(int w,int h) {
		super.setSize(w,h);
		sz=new Dimension(w,h);
	}
	
	public String getValue() {
		return value;
	}

	public void actionPerformed(ActionEvent ae) {
		if (ae.getSource()==yes) {
			a.performPendingOperation();
			value=a.getValue();
			setVisible(false);
			if (!modal) {
				dispose();
				System.exit(0);
			}
		} else if (ae.getSource()==no) {
			value=null;
			setVisible(false);
			if (!modal) {
				dispose();
				System.exit(0);
			}
		}
	}

    /**
     * Libera la ventana y termina el programa.
     */
	public void windowClosing(WindowEvent e){
		setVisible(false);
		if (modal) {
			value=null;
		} else {
			dispose();
			System.exit(0);
		}
	}
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
    
}