/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.descartes;
/*------------------------------------------------------------*/
/*                         Descartes                          */
/*                          (c) MJA                           */
/*                        Marzo de 2002                       */
/*------------------------------------------------------------*/


import com.jla.nippe.*;
import com.jla.desc2.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.parser.*;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import org.unam.matem.Communicator;


/**
 * Main class of Descartes2.
 *
 * @author Jos Luis Abreu
 * @author Marta Oliver
 * @version 2.41  March 2002
 */

public class Descartes extends AbstractNippe implements ActionListener, MouseListener {

/* ------------- Communicator implementation --------------- */

	public org.unam.matem.Attribute[] getState() {
		return new org.unam.matem.Attribute[0];
	}
	
	public void changed(Communicator cc) {
	}
	
/* --------------------------------------------------------- */
	
	public volatile config cfg,cfg0;
	public int language;

	private static final int ixhelp=0, ixcfg=1, ixini=2, ixclear=3;
	Parser p;
	R2Space cs;

	private static boolean verShown=false;

	private edu.cr.descartes.copyright cr;
	private mjaButton[] b,be;
	private mjaButton banim,banime;//,bcode;
	private Panel north,south;
	private GridBagLayout gbln,gbls;
	private Panel nsp,ssp,esp,ecuPanel;
	private editFrame extspf;
	private Spinner[] spinners;
	private editFrame ecfg;
	private boolean pause;
	private Attribute Space,Buttons,Animation;
	private Attribute Space0,Buttons0,Animation0;
	private Vector Params, Graphs, Aux, Controls;
	private Vector Params0, Graphs0, Aux0, Controls0;
	private int extra=0;

	/**
	  * Called once by the web navigator.<br>
	  * This method should not be called by users either from JavaScript or from other applets.
	  */

	public String class_Id() {
		return "Descartes 2";
	}

	public String[] getFilePaths() {
		return new String[0];
	}

	private static String getVersion() {
		return data.Version;
	}
	
	public Dimension getRealSize() {
		return getSize();
	}

	public static String getDefaultConfig(String codebase) {
		String s="<applet ";
		s+="code=\"Descartes.class\"\n"+
		"        codebase=\""+codebase+"\"\n"+
		"        archive=\"lib/Descartes2.jar";
		s+="\"\n"+
		"        MAYSCRIPT\n";
		s+="        width=750 height=500>\n";
		s+="<param name=\"Versin\" value=\""+getVersion()+"\">";
		s+="<param name=\"Idioma\" value=\"espaol\">";
		s+="<param name=\"Botones\" value=\"crditos=si config=si inicio=si limpiar=si\">";
		s+="<param name=\"Espacio\" value=\"fondo=blanco red=grisClaro red10=gris ejes=gris texto=grisObscuro eje-x=no eje-y=no\">";
		s=s+"</applet>\n";
		return s;
	}

	public void init() {
		if (!verShown) {
			System.out.println(class_Id()+" ver. "+data.Version);
			verShown=true;
		}
		super.init();
		setBackground(Color.lightGray);
		if (mjaStr.osIsWindows()) {
			setFont(mjaGui.Arial);
		} else {
			setFont(mjaGui.Arial);
		}
		data.expandNames();
		b=new mjaButton[data.bnameix.length];
		be=new mjaButton[data.bnameix.length];
		for (int i=0;i<data.bnameix.length;i++) {
			b[i]=new mjaButton();
			b[i].addActionListener(this);
			b[i].addMouseListener(this);
			be[i]=new mjaButton();
			be[i].addActionListener(this);
			be[i].addMouseListener(this);
		}
		banim=new mjaButton();
		banim.addActionListener(this);
		banim.setVisible(false);
		banime=new mjaButton();
		banime.addActionListener(this);
		banime.setVisible(false);
//		bcode=new mjaButton();
//		bcode.addActionListener(this);
		cs=new R2Space(this);
		north=new Panel();
		south=new Panel();
		Panel center=new Panel();
		setLayout(new BorderLayout());
		add("North",north);
		add("Center",center);
		center.setLayout(new BorderLayout());
		center.add("Center",cs);
		center.add("South",ecuPanel=new Panel());
		ecuPanel.setLayout(new GridLayout(1,1));
		ecuPanel.add(new TextField());
		add("South",south);
		gbln=new GridBagLayout();
		north.setLayout(gbln);
		GridBagConstraints c=new GridBagConstraints();
		c.insets=new Insets(0,0,0,0);
		c.anchor=GridBagConstraints.CENTER;
		c.fill  =GridBagConstraints.BOTH;
		c.gridwidth=1; c.gridheight=1; c.weighty=1; c.gridy=0;
		c.weightx=0;
		c.gridx=0; gbln.setConstraints(b[ixhelp],c);
		north.add(b[ixhelp]);
		c.weightx=1;
		c.gridx=1; gbln.setConstraints(nsp=new Panel(),c);
		nsp.setLayout(new GridLayout(1,1));
		north.add(nsp);
		c.weightx=0;
		c.gridx=2; gbln.setConstraints(b[ixcfg],c);
		north.add(b[ixcfg]);
		c.gridx=3; gbln.setConstraints(b[ixcfg],c);

		gbls=new GridBagLayout();
		south.setLayout(gbls);
		c.gridwidth=1; c.gridheight=1; c.weighty=1; c.gridy=0;
		c.weightx=0;
		c.gridx=0; gbls.setConstraints(b[ixini],c);
		south.add(b[ixini]);
		c.weightx=1;
		c.gridx=1; gbls.setConstraints(ssp=new Panel(),c);
		south.add(ssp);
		ssp.setLayout(new GridLayout(1,1));
		c.weightx=0;
		c.gridx=2; gbln.setConstraints(b[ixclear],c);
		south.add(b[ixclear]);
		c.gridx=3; gbln.setConstraints(b[ixclear],c);
		south.add(banim);
		esp=new Panel();
		esp.setLayout(new GridLayout(1,1));

		cfg0=new config(getConfigParameters());
		cfg=cfg0.cloneConfig();

		extspf=new editFrame("Descartes","",null,null);
		extspf.setLocation(40,40);
		extspf.setResizable(false);
		extspf.pack=true;
		Panel extp=new Panel();
		extspf.add("Center",extp);
		extp.setLayout(new BorderLayout());
		extp.add("Center",esp);
		Panel exnbp=new Panel();
		Panel exsbp=new Panel();
		extp.add("North",exnbp);
		extp.add("South",exsbp);
		exnbp.setLayout(new GridLayout(1,2));
		exnbp.add(be[0]);
		exnbp.add(be[1]);
//		exnbp.add(bcode);
		exsbp.setLayout(new GridLayout(1,3));
		exsbp.add(be[2]);
		exsbp.add(be[3]);
		exsbp.add(banime);
		define();
	}

	private Attribute[] getConfigParameters() {
		Attribute[] aa;
		int L=data.getLanguage(data.getParam(this,0,data.p_language).value);
		String ver=data.getParam(this,L,data.p_version).value;
		if (mjaStr.hasContent(ver) && !ver.startsWith("1")) {
			Params=new Vector();
			Params.addElement(data.getParam(this,L,data.name));
			Params.addElement(data.getParam(this,L,data.p_version));
			Params.addElement(data.getParam(this,L,data.p_language));

			Buttons=data.getParam(this,L,data.p_buttons);
			Space=data.getParam(this,L,data.p_space);

			Graphs=new Vector();
			addParamAttributes(Graphs,data.graphPrefix);

			Aux=new Vector();
			addParamAttributes(Aux,data.auxPrefix);

			Controls=new Vector();
			addParamAttributes(Controls,data.controlPrefix);

			Animation=data.getParam(this,L,data.p_anim);
			Params0=Params;
			Buttons0=Buttons;
			Space0=Space;
			Graphs0=Graphs;
			Aux0=Aux;
			Controls0=Controls;
			Animation0=Animation;

			return makeAttributes();

		} else {
			return oldConfig.getNewParams(this);
		}
	}

	private Attribute[] makeAttributes() {
		Attribute[] aa=new Attribute[Params.size()+3+Graphs.size()+Aux.size()+Controls.size()];
		int j=0;
		for (int i=0;i<Params.size();i++) {
			aa[j++]=(Attribute) Params.elementAt(i);
		}
		aa[j++]=Buttons;
		aa[j++]=Space;
		for (int i=0;i<Graphs.size();i++) {
			aa[j++]=(Attribute) Graphs.elementAt(i);
		}
		for (int i=0;i<Aux.size();i++) {
			aa[j++]=(Attribute) Aux.elementAt(i);
		}
		for (int i=0;i<Controls.size();i++) {
			aa[j++]=(Attribute) Controls.elementAt(i);
		}
		aa[j++]=Animation;
		return aa;
	}

	private void addParamAttributes(Vector v,String prefix) {
		for (int i=0;i<100;i++) {
			String auxs=getParameter(prefix+mjaStr.IntegerToString(i,2));
			if (mjaStr.hasContent(auxs)) {
				v.addElement(new Attribute(prefix+mjaStr.IntegerToString(i,2),auxs));
			}
		}
		for (int i=100;i<1000;i++) {
			String auxs=getParameter(prefix+mjaStr.IntegerToString(i,3));
			if (mjaStr.hasContent(auxs)) {
				v.addElement(new Attribute(prefix+mjaStr.IntegerToString(i,3),auxs));
			}
		}
	}
	
// Se usar en futuras versiones probablemente definiendo la precisin
// de manera que no pueda ser menor que la necesaria para respetar los incrementos.

	void updateSpinnersFromTextFields() {
		for (int i=0;i<spinners.length;i++) {
			if (spinners[i]!=null) {
				spinners[i].updateFromTextField();
			}
		}
	}

	private Spinner[] getSpinners(controlConfig[] a) {
		Spinner[] spa=new Spinner[a.length];
		for (int i=0;i<a.length;i++) {
			if (a[i].type==data.c_numeric) {
				spa[i]=a[i].param.makeSpinner(p);
				spa[i].addActionListener(this);
			} else {
				spa[i]=null;
			}
		}
		return spa;
	}

	private void define() {
		language=cfg.language;
		p=new Parser();
		p.Var("escala").r=cfg.escala0;
		p.Var("Ox").r=0;
		p.Var("Oy").r=0;
		banim.setLabel(data.newName[cfg.language][data.anim]);
		banime.setLabel(data.newName[cfg.language][data.anim]);
//		bcode.setLabel(data.newName[cfg.language][data.appletc]);
		if (cfg.animCfg.active) {
			banim.setVisible(true);
			banime.setVisible(true);
		} else {
			banim.setVisible(false);
			banime.setVisible(false);
		}
		for (int n=0;n<cfg.buttonVisible.length;n++) {
			b[n].setLabel(data.newName[cfg.language][data.bnameix[n]]);
			be[n].setLabel(data.newName[cfg.language][data.bnameix[n]]);
			if (cfg.buttonVisible[n]) {
				b[n].setVisible(true);
			} else {
				b[n].setVisible(false);
			}
		}
		nsp.removeAll();
		ssp.removeAll();
		esp.removeAll();
		spinners=getSpinners(cfg.cc);
		statePanel sp=new statePanel(cfg.cc,spinners,data.south);
		statePanel np=new statePanel(cfg.cc,spinners,data.north);
		statePanel es=new statePanel(cfg.cc,spinners,data.external);
		nsp.add(np);
		ssp.add(sp);
		esp.add(es);
		extra=0;
		if (np.countSpinners()>0 || b[ixhelp].isVisible() || b[ixcfg].isVisible()) {
			north.setVisible(true);
			extra+=24;
		} else {
			north.setVisible(false);
		}
		if (sp.countSpinners()>0 || b[ixini].isVisible() || b[ixclear].isVisible()) {
			south.setVisible(true);
			extra+=24;
		} else {
			south.setVisible(false);
		}
		for (int i=0;i<cfg.auxiliar.length;i++) {
			if (cfg.auxiliar[i].type==data.func) {
				if (cfg.auxiliar[i].hasAlg) {
					p.defineFunc(cfg.auxiliar[i].funcName,cfg.auxiliar[i].VarName,
						cfg.auxiliar[i].expr,cfg.auxiliar[i].range,
						cfg.auxiliar[i].s_do,cfg.auxiliar[i].s_ini,
						cfg.auxiliar[i].s_while);
				} else {
					p.defineFunc(cfg.auxiliar[i].funcName,cfg.auxiliar[i].VarName,cfg.auxiliar[i].expr,cfg.auxiliar[i].range);
				}
			} else if (cfg.auxiliar[i].type==data.constant) {
				if (cfg.auxiliar[i].evOnce) {
					Node AN=p.Analyse(cfg.auxiliar[i].expr,"0");
					p.Var(cfg.auxiliar[i].name).r=AN.Evaluate(0);
				} else {
					p.defineAlgorithm(false,cfg.auxiliar[i].name+"="+cfg.auxiliar[i].expr,"","");
				}
			} else if (cfg.auxiliar[i].type==data.alg) {
				p.defineAlgorithm(cfg.auxiliar[i].evOnce,cfg.auxiliar[i].s_do,cfg.auxiliar[i].s_ini,cfg.auxiliar[i].s_while);
			} else if (cfg.auxiliar[i].type==data.array) {
				p.defineArray(cfg.auxiliar[i].s_size,cfg.auxiliar[i].name,cfg.auxiliar[i].expr,cfg.auxiliar[i].evOnce);
			} else {
				p.defineExpr(cfg.auxiliar[i].name,cfg.auxiliar[i].expr);
			}
		}
		ecuPanel.removeAll();
		Panel ecp=cs.initializeObjects(cfg);
		if (ecp!=null) {
			ecuPanel.add(ecp);
			ecuPanel.setVisible(true);
			extra+=23;
		} else {
			ecuPanel.setVisible(false);
		}
		boolean extvis=extspf.isVisible();
		extspf.setVisible(false);
		extspf.setLabels(data.newName[cfg.language][data.close],"","");
		if (extvis) {
			extspf.display(false);
		}
	}

	void updateSpinners() {
		for (int i=0;i<spinners.length;i++) {
			if (spinners[i]!=null) {
				spinners[i].updateFromNode();
			}
		}
	}


	private void stopAnimation() {
		cs.stop();
		draw(false,false);
	}

	void animStarted() {
		b[ixini].setEnabled(false);
		be[ixini].setEnabled(false);
		banim.setLabel(data.newName[cfg.language][data.pause]);
		banime.setLabel(data.newName[cfg.language][data.pause]);
	}

	void animEnded() {
		b[ixini].setEnabled(true);
		be[ixini].setEnabled(true);
		banim.setLabel(data.newName[cfg.language][data.anim]);
		banime.setLabel(data.newName[cfg.language][data.anim]);
	}

	public void doCalculations(boolean firstTime) {
		p.prepareArrays(firstTime);
		try {
			p.doAlgorithms(firstTime);
		} catch (Exception e) {
			R2Space.limitExceeded();
		}
	}

	public void reset(boolean run,boolean clear) {
		define();
		pause=false;
		doCalculations(true); 
		paintAll(getGraphics());
		cs.setSize(getSize().width,getSize().height-extra);
		cs.draw(run&&cfg.animCfg.autorun,clear,true);
	}

	void draw(boolean starting,boolean clearing) {
		doCalculations(false);
		cs.draw(starting,clearing,false);
	}

	/* ---------------------- event handling ----------------------- */

	private boolean canEdit() {
		try {
			Class cl=Class.forName("com.jla.desc2.editdesc.configEdit");
			return true;
		} catch (Exception ex) {
			return false;
		}
	}

	void showExternalSpinners() {
		extspf.setVisible(false);
		extspf.display(false);
	}

	public void actionPerformed(ActionEvent ev) {
		if ("updateSpinnersFromTextFields".equals(ev.getActionCommand())) {
			updateSpinnersFromTextFields();
		}
		if (ev.getSource()==banim||ev.getSource()==banime) {
			toggleAnimation();
		} else if (ev.getSource()==b[ixini]||ev.getSource()==be[ixini]) {
			stopAnimation();
			if (!cs.running) {
				reset(false,true);
			}
		} else if (ev.getSource()==b[ixclear]||ev.getSource()==be[ixclear]) {
			clear();
//		} else if (ev.getSource() instanceof Spinner) {
//			updateSpinnersFromTextFields();
//			refresh();
		} else {
			refresh();
		}
	}

	public void updateProposedDimension() {
		if ( dd!=null && ecfg!=null) {
			proposedDimension=((doed)dd).getProposedDimension();
		} else {
			proposedDimension=getSize();
		}
	}


/* ---------------------- Mouse Listener ----------------------- */

	public void mousePressed(MouseEvent ev) {}

	public void mouseReleased(MouseEvent ev) {
		if (ev.getSource()==b[ixhelp]||ev.getSource()==be[ixhelp]) {
			about();
		} else if (ev.getSource()==b[ixcfg]||ev.getSource()==be[ixcfg]) {
			edit();
		}
	}
	public void mouseClicked(MouseEvent ev) { }
	public void mouseEntered(MouseEvent ev) { }
	public void mouseExited(MouseEvent ev) { }

	/* ----- public interface for use with JavaScript ----- */

	/**
	  * Starts the applet.<br>
	  * If called when the applet is running then it re-starts.
	  */

	public void start() {
		super.start();
		updateProposedDimension();
		reset(true,true);
	}

	/**
	  * Stops the applet.<br>
	  * Disposes external controls window and edit window.
	  */

	public void stop() {
		cs.stop();
		extspf.setVisible(false);
		extspf.dispose();
		if (ecfg!=null) {
			ecfg.setVisible(false);
			ecfg.dispose();
		}
	}

	/**
	  * Displays the "about" or Copyright dialog box.
	  */

	public void about() {
		if (cr==null) {
			cr=new edu.cr.descartes.copyright(this,"Descartes 2",true);
		}
		cr.display();
	}

	/**
	  * Cleans the screen form any traces left by graphs. <br>
	  * It doesn't change parameter or auxiliary values. <br>
	  * The function may be called while the animation is running. <br>
	  */

	public void clear() {
		draw(false,true);
	}

	/**
	  * Recovers the original configuration, i.e. the one provided by the applet parameters.
	  */

	public void original() {
		cfg=cfg0;
		Params=Params0;
		Buttons=Buttons0;
		Space=Space0;
		Graphs=Graphs0;
		Aux=Aux0;
		Controls=Controls0;
		Animation=Animation0;
		start();
	}

	/**
	  * Continues or pauses animation. <br>
	  * If the animation has not started starts it.<br>
	  * If the animation is running it puts it in "pause" mode.<br>
	  * If the animation is in "pause" mode then it continues running.<br>
	  */

	public void toggleAnimation() {
		if (cs.running) {
			stopAnimation();
			pause=true;
		} else {
			cs.draw(true,false,!pause);
			pause=false;
		}
	}

	/**
	  * Refresheds the screen. <br>
	  * This method redraws the screen without cleaning the trace left by moving graphs.
	  */

	public void refresh() {
		draw(false,false);
	}

	/**
	 * Opens the configuration editor window.
	 */
	Object dd;

	public void edit() {
		stopAnimation();
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		if (ecfg==null) {
			if (canEdit()) {
				if (dd==null) {
					dd=new doed(this);
				}
				ecfg=((doed)dd).getEditor();
				ecfg.setSize(640,285);
				ecfg.setInfo();
				ecfg.display("up");
			} else {
				mjaGui.ask(null,"Descartes",data.newName[language][data.noedit],data.newName[language][data.accept],null);
			}
		} else {
			if (!ecfg.isShowing()) {
				ecfg.show();
			}
		}
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	}

	/* ----------------- Buttons ----------------- */

	/**
	  * Sets the configuration of the buttons.<br>
	  * @param s Configuration String for the buttons.<br>
	  * <br>
	  * A typical form is<br>
	  * <br>
      * s="crditos=si config=no inicio=si limpiar=si"
	  */
	public void setButtons(String s) {
		Buttons=new Attribute(data.newName[language][data.p_buttons],s);
		cfg=new config(makeAttributes());
		start();
	}

	/* ----------------- Space ----------------- */

	/**
	  * Sets the configuration of the Descartes space.<br>
	  * @param s Configuration String for the space.<br>
	  * <br>
	  * A typical form is<br>
	  * <br>
      * s="fondo=blanco red=no red10=gris ejes=gris texto=grisObscuro"
	  */
	public void setSpace(String s) {
		Space=new Attribute(data.newName[language][data.p_space],s);
		cfg=new config(makeAttributes());
		start();
	}

	/* ----------------- Controls ----------------- */

	/**
	  * Removes all numerical and graphics controls from the configuration.<br>
	  */
	public void removeControls() {
		Controls=new Vector();
		cfg=new config(makeAttributes());
		start();
	}

	/**
	  * Adds a new control object.<br>
	  * @param s Configuration String for the control object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
      * s="id=p tipo=numrico valor='1.5' decimales='2' incr='0.1'"<br>
      * s="id=C tipo=grfico expresin='[1,0]' constriccin='x^2+y^2=1' text='([C.x],[C.y])'"<br>
	  */
	public void addControl(String s) {
		if (mjaStr.hasContent(s)) {
			Controls.addElement(new Attribute(data.controlPrefix+mjaStr.IntegerToString(Controls.size(),2),s));
		}
		cfg=new config(makeAttributes());
		start();
	}

	/**
	  * Replaces the num control object.<br>
	  * @param num String represinting the number of the control object.<br>
	  * @param s Configuration String for the new control object.<br>
	  * <br>
	  * Typical forms for s are:<br>
      * s="id=p tipo=numrico valor='1.5' decimales='2' incr='0.1'"<br>
      * s="id=C tipo=grfico expresin='[1,0]' constriccin='x^2+y^2=1' text='([C.x],[C.y])'"<br>
	  * <br>
	  */
	public void replaceControl(String num,String s) {
		try {
			int n=Integer.parseInt(num);
			if (Controls.size()>n) {
				((Attribute) Controls.elementAt(n)).value=s;
				cfg=new config(makeAttributes());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/**
	  * Returns the num-th control configuration String.<br>
	  * @param num String represinting the number of the control object.<br>
	  */
	public String getControl(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Controls.size()>n) {
				String s=((Attribute) Controls.elementAt(n)).value;
				return s;
			} else {
				return null;
			}
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	  * Deletes the num-th control object.<br>
	  * @param num String representing the number of the control object to be deleted.<br>
	  */
	public void deleteControl(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Controls.size()>n) {
				Controls.removeElement(Controls.elementAt(n));
			}
			cfg=new config(makeAttributes());
			start();
		} catch (NumberFormatException e) {
		}
	}

	/* ----------------- Auxiliars ----------------- */

	/**
	  * Removes all auxiliar objects from the configuration.<br>
	  */
	public void removeAux() {
		Aux=new Vector();
		cfg=new config(makeAttributes());
		start();
	}

	/**
	  * Adds a new auxiliar object.<br>
	  * @param s Configuration String for the auxiliar object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
      * s="id=Ta expresin='0' constante=si evaluar=una-sola-vez"<br>
      * s="id=f(x) expresin='P*cos(x)'"<br>
	  */
	public void addAux(String s) {
		if (mjaStr.hasContent(s)) {
			Aux.addElement(new Attribute(data.auxPrefix+mjaStr.IntegerToString(Aux.size(),2),s));
		}
		cfg=new config(makeAttributes());
		start();
	}

	/**
	  * Replaces the num-th auxiliar object.<br>
	  * @param num String represinting the number of the auxiliar object.<br>
	  * @param s Configuration String for the new auxiliar object.<br>
	  * <br>
	  * Typical forms for s are:<br>
      * s="id=Ta expresin='0' constante=si evaluar=una-sola-vez"<br>
      * s="id=f(x) expresin='P*cos(x)'"<br>
	  * <br>
	  */
	public void replaceAux(String num,String s) {
		try {
			int n=Integer.parseInt(num);
			if (Aux.size()>n) {
				((Attribute) Aux.elementAt(n)).value=s;
				cfg=new config(makeAttributes());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/**
	  * Returns the num-th auxiliar configuration String.<br>
	  * @param num String represinting the number of the auxiliar object.<br>
	  */
	public String getAux(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Aux.size()>n) {
				String s=((Attribute) Aux.elementAt(n)).value;
				return s;
			} else {
				return null;
			}
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	  * Deletes the num-th auxiliar object.<br>
	  * @param num String representing the number of the auxiliar object to be deleted.<br>
	  */
	public void deleteAux(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Aux.size()>n) {
				Aux.removeElement(Aux.elementAt(n));
			}
			cfg=new config(makeAttributes());
			start();
		} catch (NumberFormatException e) {
		}
	}

	/* ----------------- Graphs ----------------- */

	/**
	  * Removes all graphic objects from the configuration.<br>
	  */
	public void removeGraphs() {
		Graphs=new Vector();
		cfg=new config(makeAttributes());
		start();
	}

	/**
	  * Adds a new graphic object.<br>
	  * @param s Configuration String for the graphic object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
      * s="tipo=ecuacin expresin='y=f(x)' rastro=turquesa"<br>
      * s="tipo=segmento expresin='(-3,-1)(4,3)' color=magenta"<br>
      * s="tipo=curva expresin='(R*t*cos(2*pi*t),R*t*sen(2*pi*t))' color=rojo visible=no parmetro=t t.intervalo=[0,1] t.pasos=32 ancho=3"<br>
      * s="tipo=polgono expresin='(0,0)(1,1)(2,-1)(0,0)' color=gris"<br>
	  */
	public void addGraph(String s) {
		if (mjaStr.hasContent(s)) {
			Graphs.addElement(new Attribute(data.graphPrefix+mjaStr.IntegerToString(Graphs.size(),2),s));
		}
		cfg=new config(makeAttributes());
		start();
	}

	/**
	  * Replaces the num-th graphic object.<br>
	  * @param num String representing the number of the graphic object.<br>
	  * @param s Configuration String for the new graphic object.<br>
	  * <br>
	  * Typical forms for s are:<br>
	  * <br>
      * s="tipo=ecuacin expresin='y=f(x)' rastro=turquesa"<br>
      * s="tipo=segmento expresin='(-3,-1)(4,3)' color=magenta"<br>
      * s="tipo=curva expresin='(R*t*cos(2*pi*t),R*t*sen(2*pi*t))' color=rojo visible=no parmetro=t t.intervalo=[0,1] t.pasos=32 ancho=3"<br>
      * s="tipo=polgono expresin='(0,0)(1,1)(2,-1)(0,0)' color=gris"<br>
	  */
	public void replaceGraph(String num,String s) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs.size()>n) {
				((Attribute) Graphs.elementAt(n)).value=s;
				cfg=new config(makeAttributes());
				start();
			}
		} catch (NumberFormatException e) {
		}
	}

	/**
	  * Returns the num-th graphic configuration String.<br>
	  * @param num String representing the number of the graphic object.<br>
	  */
	public String getGraph(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs.size()>n) {
				String s=((Attribute) Graphs.elementAt(n)).value;
				return s;
			} else {
				return null;
			}
		} catch (NumberFormatException e) {
			return null;
		}
	}

	/**
	  * Deletes the num-th graphic object.<br>
	  * @param num String representing the number of the graphic object to be deleted.<br>
	  */
	public void deleteGraph(String num) {
		try {
			int n=Integer.parseInt(num);
			if (Graphs.size()>n) {
				Graphs.removeElement(Graphs.elementAt(n));
			}
			cfg=new config(makeAttributes());
			start();
		} catch (NumberFormatException e) {
		}
	}

	/* ----------------- Animation ----------------- */

	/**
	  * Removes the animation.<br>
	  */
	public void removeAnimation() {
		Animation=new Attribute(data.newName[language][data.p_anim],"");
		cfg=new config(makeAttributes());
		start();
	}

	/**
	  * Returns the animation configuration String.<br>
	  */
	public String getAnimation() {
		return Animation.value;
	}

	/**
	  * Defines a new animation.<br>
	  * @param s Configuration String for the new animation.<br>
	  * <br>
	  * A typical form for s:<br>
	  * <br>
      * s="id=Animacin algoritmo=si inicio='Ta=0' hacer='Ta=Ta+0.05' mientras='Ta<2' auto=si repetir=si controles=no evaluar=siempre"<br>
	  */
	public void setAnimation(String s) {
		Animation=new Attribute(data.newName[language][data.p_anim],s);
		cfg=new config(makeAttributes());
		start();
	}

	/* ----------------- Applet Code ----------------- */

	/**
	  * Returns the applet configuration i.e. the html code that defines the applet configuration.<br>
	  */
	public String getAppliedCode() {
		if (dd==null) {
			dd=new doed(this);
		}
		return ((doed)dd).getAppliedCode();
	}

	public String getCode(boolean HTML_encoded) {
		return getCode();
	}

	public String getCode() {
		if (dd==null) {
			dd=new doed(this);
		}
		return ((doed)dd).getCode();
	}
	/* ----------------- AddActionListener ----------------- */

	/**
	  * to perform actions in ownwers of this object <br>
	  */
//	private ActionListener al;
//	public void addActionListener(ActionListener al) {
//		this.al=al;
//	}

/* ----------------- AbstractNippe implementation ----------------- */

	public String getInfo(String type,String param) {
		String varName=type;
		StringTokenizer st=new StringTokenizer(param,"_");
		if (st.hasMoreTokens()) {
			int i=mjaStr.parseInteger(st.nextToken(),0,0);
			if (st.hasMoreTokens()) {
				int j=mjaStr.parseInteger(st.nextToken(),0,0);
				String var=varName+"_"+i+"_"+j;
				if (p.isVar(var)) {
					return mjaStr.DoubleToString(p.value(var),6,false);
				} else {
					return "Error";
				}
			}
		}
		return "";
	}

	public void doAction(String actionName,String actionParam) {
		if ("restart".equalsIgnoreCase(actionName)) {
			reset(true,true);
//			restart();
		} else if ("refresh".equalsIgnoreCase(actionName)) {
			refresh();
		}
	}


}