/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.descartes;
/*------------------------------------------------------------*/
/*                         auxConfig                          */
/*                         (c)  MJA                           */
/*                      Febrero de 2001                       */
/*------------------------------------------------------------*/

import java.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.util.*;

public class auxConfig extends editObject {

	public int type=data.var;
	public String name,expr,range="",s_ini,s_do,s_while,s_delay,funcName,s_size;
	public String[] VarName;
	public boolean active=true,evOnce,hasAlg,loop=false,autorun=true,controls=true;

	private int L;

	public auxConfig(int L,String id,int type) {
		ID=id;
		this.type=type;
		expr="0";
		if (type==data.alg) {
			s_ini="n=1";
			s_do="n=n+1";
			s_while="n<=8";
			s_delay="50";
		} else if (type==data.array) {
			s_size="3";
			expr=id+"[0]=0;"+id+"[1]=0;"+id+"[2]=0";
			evOnce=true;
		} else if (type==data.func) {
			if (ID.indexOf("(")<0) {
				ID+="(x)";
			}
			expr="x";
		} else if (type==data.constant) {
			evOnce=true;
		}
		setName(ID);
		resetId(L);
	}

	public auxConfig(int L,String auxvalue) {
		Attribute[] aa=Attribute.parse(auxvalue);
		setName(Attribute.getValue(aa,"id"));
		expr=data.getValue(L,aa,data.expr);
		range=data.getValue(L,aa,data.range);
		s_while=data.getValue(L,aa,data.whileWord);
		s_ini=data.getValue(L,aa,data.ini);
		s_do=data.getValue(L,aa,data.doWord);
		loop=data.isTrue(data.getValue(L,aa,data.loop));
		autorun=data.isNotFalse(data.getValue(L,aa,data.auto));
		controls=data.isNotFalse(data.getValue(L,aa,data.controls));
		hasAlg=data.isTrue(data.getValue(L,aa,data.alg));
		String evals=data.getValue(L,aa,data.evaluate);
		evOnce=data.newName[L][data.once].equals(evals);
		s_delay=data.getValue(L,aa,data.delay,s_delay);
		boolean isConst=data.isTrue(data.getValue(L,aa,data.constant));
		boolean isArray=data.isTrue(data.getValue(L,aa,data.array));
		if (isFunction()) {
			type=data.func;
		} else if (hasAlg) {
			type=data.alg;
			if (!mjaStr.hasContent(s_do)) {
				s_do=expr;
				expr="";
			}
		} else if (isArray) {
			s_size=data.getValue(L,aa,data.size);
			type=data.array;
			if (!mjaStr.hasContent(evals)) {
				evOnce=true;
			}
		} else if (isConst) {
			type=data.constant;
		}
		resetId(L);
	}

	public void setName(String name) {
		this.name=name;
		if (name.indexOf("(")>0) {
			StringTokenizer st=new StringTokenizer(name,"()");
			funcName=st.nextToken().trim();
			if (st.hasMoreTokens()) {
				String auxs=st.nextToken().trim();
				st=new StringTokenizer(auxs,",");
				VarName=new String[st.countTokens()];
				for (int i=0;i<VarName.length;i++) {
					VarName[i]=st.nextToken();
				}
			} else {
				VarName=new String[0];
			}
		} else {
			VarName=null;
			funcName=null;
		}
	}

/*
	public void setName(String name) {
		this.name=name;
		StringTokenizer st=new StringTokenizer(name,"()");
		if (st.hasMoreTokens()) {
			funcName=st.nextToken().trim();
			if (st.hasMoreTokens()) {
				String auxs=st.nextToken().trim();
				st=new StringTokenizer(auxs,",");
				VarName=new String[st.countTokens()];
				for (int i=0;i<VarName.length;i++) {
					VarName[i]=st.nextToken();
				}
			} else {
				VarName=new String[0];
			}
		} else {
			VarName=new String[0];
			funcName=name;
		}
	}
*/

	public String getName() {
		return name;
	}

	public void resetId(int L) {
		String s=name+" (";
		if (type==data.alg) {
			s+=data.newName[L][data.alg];
		} else if (type==data.array) {
			s+=data.newName[L][data.array];
		} else if (type==data.func) {
			s+=data.newName[L][data.func];
		} else if (type==data.constant) {
			s+=data.newName[L][data.constant];
		} else {
			s+=data.newName[L][data.var];
		}
		s+=")";
		setId(s);
	}

	public boolean isFunction() {
		return (VarName!=null);
	}

	public String toString(String sep,int L) {
		String s="id="+name+sep;
		if (type==data.func) {
			s+=data.newName[L][data.expr]+"='"+expr+"'"+sep;
			s+=data.toString(sep,L,data.range,"'"+range+"'");
			if (hasAlg) {
				s+=data.newName[L][data.alg]+"="+data.booleanName(L,true)+sep;
				s+=data.toString(sep,L,data.ini,"'"+s_ini+"'");
				s+=data.toString(sep,L,data.doWord,"'"+s_do+"'");
				s+=data.toString(sep,L,data.whileWord,"'"+s_while+"'");
			}
		} else if (type==data.alg) {
			s+=data.newName[L][data.alg]+"="+data.booleanName(L,true)+sep;
			s+=data.toString(sep,L,data.ini,"'"+s_ini+"'");
			s+=data.toString(sep,L,data.doWord,"'"+s_do+"'");
			s+=data.toString(sep,L,data.whileWord,"'"+s_while+"'");
			if (mjaStr.hasContent(s_delay)) {
				s+=data.toString(sep,L,data.delay,"'"+s_delay+"'","'50'");
			}
			if (data.equals(name,data.p_anim)) {
				s+=data.newName[L][data.auto]+"="+data.booleanName(L,autorun)+sep;
				s+=data.newName[L][data.loop]+"="+data.booleanName(L,loop)+sep;
				s+=data.newName[L][data.controls]+"="+data.booleanName(L,controls)+sep;
			}
		} else if (type==data.array) {
			s+=data.newName[L][data.expr]+"='"+expr+"'"+sep;
			s+=data.newName[L][data.array]+"="+data.booleanName(L,true)+sep;
			s+=data.newName[L][data.size]+"='"+s_size+"'"+sep;
		} else if (type==data.constant) {
			s+=data.newName[L][data.expr]+"='"+expr+"'"+sep;
			s+=data.newName[L][data.constant]+"="+data.booleanName(L,true)+sep;
		} else if (type==data.var) {
			s+=data.newName[L][data.expr]+"='"+expr+"'"+sep;
		}
		if (type==data.alg||type==data.constant||type==data.array) {
			if (evOnce) {
				s+=data.toString(sep,L,data.evaluate,data.newName[L][data.once]);
			} else {
				s+=data.toString(sep,L,data.evaluate,data.newName[L][data.always]);
			}
		}
		return s.trim();
	}

	public editObject create(int L, String values) {
		return new auxConfig(L,values);
	}
}