/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.descartes;

/*------------------------------------------------------------*/
/*                          config                            */
/*                          (c) MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/
import java.awt.*;
import java.applet.*;
import java.util.*;
import com.jla.desc2.parser.*;
import com.jla.desc2.util.*;

public class config {

	public int language;
	public auxConfig animCfg;
	public static final int Escala0=48;

	public String name="",version0="";
	public double escala0=Escala0;
	public Color[] color;
	public boolean[] buttonVisible;
	public boolean[] isOn;
	public String x_axis,y_axis;
	public boolean numbers,x_On,y_On,applied;
	public controlConfig[] cc;
	public auxConfig[] auxiliar;
	public graphConfig[] gc;

	public config cloneConfig() {
		config auxc=new config(toAppletParams());
		auxc.applied=applied;
		auxc.escala0=escala0;
		auxc.version0=version0;
		return auxc;
	}

	public config(int L) {
		name="";
		language=L;
		buttonVisible=getButtonVisibility(L,null);
		color=getColors(L,null);
		isOn=getIsOn(L,null);
		numbers=false;
		x_axis="";
		y_axis="";
		cc=getControlConfigs(L,null);
		auxiliar=getAuxiliars(L,null);
		gc=getGraphs(L,null);
		animCfg=new auxConfig(L,data.newName[L][data.p_anim],data.alg);
		animCfg.active=false;
	}

	public config(Attribute[] aa) {
		language=data.getLanguage(data.getValue(data.nolang,aa,data.p_language));
		escala0=mjaStr.parseInteger(Attribute.getValue(aa,"escala0"),Escala0,Escala0);
		name=data.getValue(language,aa,data.name);
		version0=data.getValue(language,aa,data.p_version,"1"); // por si desea usar la versin.
		buttonVisible=getButtonVisibility(language,aa);
		color=getColors(language,aa);
		isOn=getIsOn(language,aa);
		Attribute[] saa=Attribute.parse(data.getValue(language,aa,data.p_space));
		numbers=data.isTrue(data.getValue(language,saa,data.numbers));
		x_axis=data.getValue(language,saa,data.x_axis);
		x_On=data.isNotFalse(x_axis);
		if (!x_On) { x_axis="";	}
		y_axis=data.getValue(language,saa,data.y_axis);
		y_On=data.isNotFalse(y_axis);
		if (!y_On) { y_axis="";	}
		cc=getControlConfigs(language,aa);
		auxiliar=getAuxiliars(language,aa);
		gc=getGraphs(language,aa);
		String s_anim=data.getValue(language,aa,data.p_anim);
		if (mjaStr.hasContent(s_anim)) {
			animCfg=new auxConfig(language,"id="+data.newName[language][data.p_anim]+" "+s_anim);
		} else {
			animCfg=new auxConfig(language,data.newName[language][data.p_anim],data.alg);
			animCfg.active=false;
		}
	}

	public boolean hasVisibleEquation() {
		for (int i=0;i<gc.length;i++) {
			if (gc[i].isVisible) return true;
		}
		return false;
	}

	public Attribute[] toAppletParams() {
		Vector v=new Vector();
		if (mjaStr.hasContent(name)) {
			v.addElement(new Attribute(data.newName[language][data.name],name));
		}
		v.addElement(new Attribute(data.newName[language][data.p_version],data.Version));
		v.addElement(new Attribute(data.newName[language][data.p_language],data.newName[language][data.langName]));
		String s="";
		for (int i=0;i<buttonVisible.length;i++) {
			s+=data.newName[language][data.bnameix[i]]+"="+data.booleanName(language,buttonVisible[i])+" ";
		}
		v.addElement(new Attribute(data.newName[language][data.p_buttons],s.trim()));
		s="";
		for (int i=0;i<color.length;i++) {
			if (isOn[i]) {
				s+=data.newName[language][data.BACKGROUND+i]+"="+mjaStr.getColorName(data.colorName[language],color[i])+" ";
			} else {
				s+=data.newName[language][data.BACKGROUND+i]+"="+data.newName[language][data.No]+" ";
			}
		}
		if (numbers) {
			s+=data.newName[language][data.numbers]+"="+data.newName[language][data.Yes]+" ";
		}
		if (x_On) {
			if (mjaStr.hasContent(x_axis)) {
				s+=data.newName[language][data.x_axis]+"='"+x_axis+"'"+" ";
			}
		} else {
			s+=data.newName[language][data.x_axis]+"="+data.newName[language][data.No]+" ";
		}
		if (y_On) {
			if (mjaStr.hasContent(y_axis)) {
				s+=data.newName[language][data.y_axis]+"='"+y_axis+"'"+" ";
			}
		} else {
			s+=data.newName[language][data.y_axis]+"="+data.newName[language][data.No]+" ";
		}
		v.addElement(new Attribute(data.newName[language][data.p_space],s.trim()));
		s="";
		int just=2;
		for (int i=0;i<cc.length;i++) {
			if (i>=100) {
				just=3;
			}
			v.addElement(new Attribute(data.controlPrefix+mjaStr.IntegerToString(i,just),cc[i].toString(" ",language)));
		}
		s="";
		just=2;
		for (int i=0;i<auxiliar.length;i++) {
			if (i>=100) {
				just=3;
			}
			v.addElement(new Attribute(data.auxPrefix+mjaStr.IntegerToString(i,just),auxiliar[i].toString(" ",language)));
		}
		s="";
		just=2;
		for (int i=0;i<gc.length;i++) {
			if (i>=100) {
				just=3;
			}
			v.addElement(new Attribute(data.graphPrefix+mjaStr.IntegerToString(i,just),gc[i].toString(" ",language)));
		}
		if (animCfg.active) {
			v.addElement(new Attribute(data.newName[language][data.p_anim],animCfg.toString(" ",language)));
		}

		Attribute[] aa=new Attribute[v.size()];
		for (int i=0;i<aa.length;i++) {
			aa[i]=(Attribute) v.elementAt(i);
		}
		return aa;
	}

	private static boolean[] getButtonVisibility(int L,Attribute[] aa) {
		String auxs=data.getValue(L,aa,data.p_buttons);
		Attribute[] bvaa=Attribute.parse(auxs);
		boolean[] bv=new boolean[4];
		for (int i=0;i<bv.length;i++) {
			bv[i]=data.isNotFalse(data.getValue(L,bvaa,data.bnameix[i]));
		}
		return bv;
	}

	static public final Color[] DC0={ Color.white,Color.lightGray,Color.gray,Color.gray,Color.darkGray };

	private static boolean[] getIsOn(int L,Attribute[] aa) {
		Attribute[] caa=Attribute.parse(data.getValue(L,aa,data.p_space));
		boolean[] isOn=new boolean[5];
		String net10str="";
		for (int i=0;i<isOn.length;i++) {
			isOn[i]=true;
			for (int j=0;j<caa.length;j++) {
				if (data.equals(caa[j].name,data.BACKGROUND+i)) {
					isOn[i]=data.isNotFalse(caa[j].value);
					if (i==2) {
						net10str=caa[j].value;
					}
				}
			}
		}
		if (!mjaStr.hasContent(net10str)) {
			isOn[2]=isOn[3];
		}
		return isOn;
	}

	private static Color[] getColors(int L,Attribute[] aa) {
		Attribute[] caa=Attribute.parse(data.getValue(L,aa,data.p_space));
		Color[] color=new Color[5];
		for (int i=0;i<color.length;i++) {
			color[i]=DC0[i];
			for (int j=0;j<caa.length;j++) {
				if (data.equals(caa[j].name,data.BACKGROUND+i)) {
					color[i]=data.parseColor(caa[j].value,DC0[i],DC0[i]);
				}
			}
		}
		return color;
	}

	private static controlConfig[] getControlConfigs(int L,Attribute[] aa) {
		if (aa==null) {
			return controlConfig.defaultControls(L);
		}
		String[] values=Attribute.get100Values(data.controlPrefix,aa);
		controlConfig[] ca=new controlConfig[values.length];
		for (int i=0;i<values.length;i++) {
			ca[i]=new controlConfig(L,values[i]);
		}
		return ca;
	}

	private static auxConfig[] getAuxiliars(int L,Attribute[] aa) {
		auxConfig[] ac=null;
		if (aa==null) {
			ac=new auxConfig[1];
			ac[0]=new auxConfig(L,"pi",data.constant);
			ac[0].expr="3.1416";
			return ac;
		}
		String[] values=Attribute.get100Values(data.auxPrefix,aa);
		ac=new auxConfig[values.length];
		for (int i=0;i<ac.length;i++) {
			ac[i]=new auxConfig(L,values[i]);
		}
		return ac;
	}

	private static graphConfig[] getGraphs(int L,Attribute[] aa) {
		graphConfig[] gc=null;
		if (aa==null) {
			gc=new graphConfig[1];
			gc[0]=new graphConfig(L,data.newName[L][data.t_equation],"y=x");
			return gc;
		}
		String[] values=Attribute.get100Values(data.graphPrefix,aa);
		gc=new graphConfig[values.length];
		for (int i=0;i<gc.length;i++) {
			gc[i]=new graphConfig(L,values[i]);
		}
		return gc;
	}

}