/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.descartes;

/*------------------------------------------------------------*/
/*                       controlConfig                        */
/*                         (c)  MJA                           */
/*                       Marzo de 2001                        */
/*------------------------------------------------------------*/
import java.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.util.*;

public class controlConfig extends editObject {

	public int type;
	public Param param;
	public Control ctrl;
	public int L;

	public controlConfig(int L,int type,String svalue) {
		this.L=L;
		this.type=type;
		if (type==data.c_numeric) {
			param=new Param(L,svalue);
		} else {
			ctrl=new Control(L,svalue);
		}
		resetId(L);
	}

	public controlConfig(int L,String stype,String svalue) {
		this(L,data.getIndex(data.ctrlix,L,stype,data.c_numeric),svalue);
	}

	public controlConfig(int L,String values) {
		Attribute[] aa=Attribute.parse(values);
		type=data.getIndex(data.ctrlix,L,data.getValue(L,aa,data.type),data.c_numeric);
		String id=Attribute.getValue(aa,"id");
		if (type==data.c_numeric) {
			param=new Param(L,id,values);
		} else {
			ctrl=new Control(L,id,values);
		}
	}

	public void setName(String name) {
		if (type==data.c_numeric) {
			param.id=name;
		} else if (type==data.c_graphic) {
			ctrl.controlName=name;
		}
	}

	public void resetId(int L) {
		this.L=L;
		setId(getName()+" ("+data.newName[L][type]+")");
	}

	public String getName() {
		if (type==data.c_numeric) {
			return param.id;
		} else if (type==data.c_graphic) {
			return ctrl.controlName;
		} else {
			return "";
		}
	}

	static controlConfig[] defaultControls(int L) {
		controlConfig[] ctrlc=new controlConfig[3];
		ctrlc[0]=new controlConfig(L,data.c_numeric,"escala");
		ctrlc[1]=new controlConfig(L,data.c_numeric,"Ox");
		ctrlc[2]=new controlConfig(L,data.c_numeric,"Oy");
		return ctrlc;
	}

	public String toString(String sep,int L) {
		String svalue="id="+getName()+sep;
			svalue+=data.newName[L][data.type]+"="+data.newName[L][type]+sep;
		if (type==data.c_numeric) {
			svalue+=param.toString(sep,L);
		} else if (type==data.c_graphic) {
			svalue+=ctrl.toString(sep,L);
		}
		return svalue;
	}

	public editObject create(int L, String values) {
		return new controlConfig(L,values);
	}

}