/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.descartes;

/*------------------------------------------------------------*/
/*                         mjaGraph                           */
/*                         (c)  MJA                           */
/*                       Marzo de 2001                        */
/*------------------------------------------------------------*/
import com.jla.desc2.parser.*;
import com.jla.desc2.util.*;
import com.jla.desc2.math.*;
import com.jla.desc2.gui.*;
import java.awt.*;
import java.awt.image.*;
import java.util.*;

public class mjaGraph {

	Descartes D;
	graphConfig gc;
	int size=2;
	parametrization sparz;
	TextField TF;

	private static final double dosPi=2.0*Math.PI, Pim=Math.PI/2.0,MAX_INT=32767,epsilon=0.0001;
	private static final int segment=0, equation=1,curve=2,sequence=3,line=4,conic=5,funcOfX=6,funcOfY=7;
	private int eqType;
	private int width=-1,spear=-1;
	private Node decimals,cond;
	private parametrization tparz;
	private Vector[] pstr;
	private static final String[] lineEq={"y=m*x+b","x=m*y+a","A*x+B*y=C"};
	private static final String[] conicEq={
		"e=sqrt((x-Fx)^2+(y-Fy)^2)/(d+(x-Fx)*cos(t)+(y-Fy)*sen(t))",
		"e=sqrt((x-Fx)^2+(y-Fy)^2)/(d-((x-Fx)*(Dx-Fx)+(y-Fy)*(Dy-Fy))/d)"
	};
	private Node F,fx,fy;
	private int caso,w,h,Fx,Fy,x,y,z,dx,zx,zxx,dy,zy,zyy,zxy;
	private Node x1,y1,x2,y2,r,aN,daN,Si,Sf;
	private Node[] xNa,yNa;

	private int segType;

	public mjaGraph(Descartes D,graphConfig gc) {
		this.D=D;
		this.gc=gc;
		cond=D.p.Analyse(gc.cond,"1");
		String[] sa=mjaStr.toStringArray(gc.text);
		pstr=new Vector[sa.length];
		for (int i=0;i<pstr.length;i++) {
			pstr[i]=D.p.parseString(sa[i]);
		}
		size=mjaStr.parseInteger(gc.s_size,2,2);
		width=mjaStr.parseInteger(gc.s_width,1,1);
		spear=mjaStr.parseInteger(gc.s_spear,5,spear);
		decimals=D.p.Analyse(gc.s_decimals,2);
		if (gc.isFamily) {
			sparz=new parametrization(D.p,gc.fparam,gc.f_interval,gc.f_steps);
		}
		if (mjaStr.hasContent(gc.parameter)) {
			tparz=new parametrization(D.p,gc.parameter,gc.p_interval,gc.p_steps);
		}
		if (gc.type==data.t_equation||gc.type==data.t_curve||gc.type==data.sequence) {
			analyse();
		} else if (gc.type==data.t_arc) {
			eqType=segment;
			segType=data.t_arc;
			gc.isEditable=false;
			gc.isVisible=false;
			xNa=new Node[1];
			yNa=new Node[1];
			try {
				String[] st=mjaStr.getTokens(gc.s_center);
				xNa[0]=D.p.Analyse(st[0]);
				yNa[0]=D.p.Analyse(st[1]);
			} catch (Exception exc) {
				System.out.println("bad expression "+gc.s_center);
			}
			r=D.p.Analyse(gc.s_radius);
			if (gc.s_ini.startsWith("[")||gc.s_ini.startsWith("(")) {
				try {
					String[] st=mjaStr.getTokens(gc.s_ini);
					x1=D.p.Analyse(st[0]);
					y1=D.p.Analyse(st[1]);
					st=mjaStr.getTokens(gc.s_end);
					x2=D.p.Analyse(st[0]);
					y2=D.p.Analyse(st[1]);
				} catch (Exception exc) {
					System.out.println("bad expression "+gc.s_center);
				}
			} else {
				aN=D.p.Analyse(gc.s_ini);
				daN=D.p.Analyse("("+gc.s_end+")-("+gc.s_ini+")");
			}
/*
			try {
				String[] st=mjaStr.getTokens(gc.s_ini);
				if (st.length==1) {
					aN=D.p.Analyse(gc.s_ini);
					daN=D.p.Analyse("("+gc.s_end+")-("+gc.s_ini+")");
				} else {
					x1=D.p.Analyse(st[0]);
					y1=D.p.Analyse(st[1]);
					st=mjaStr.getTokens(gc.s_end);
					x2=D.p.Analyse(st[0]);
					y2=D.p.Analyse(st[1]);
				}
			} catch (Exception exc) {
				System.out.println("bad expression "+gc.s_center);
			}
*/
		} else {
			eqType=segment;
			segType=gc.type;
			gc.isEditable=false;
			gc.isVisible=false;
			try {
				String[] st=mjaStr.getTokens(gc.formula);
				int N=st.length/2,ix=0;
				xNa=new Node[N];
				yNa=new Node[N];
				for (int i=0;i<N;i++) {
					xNa[i]=D.p.Analyse(st[ix++]);
					yNa[i]=D.p.Analyse(st[ix++]);
				}
			} catch (Exception exc) {
				System.out.println("bad expression "+gc.formula);
			}
		}
	}

	void analyse() {
		if (gc.type!=data.t_equation) {
			try {
				String[] st=mjaStr.getTokens(gc.formula);
				int ix=0;
				if (st.length>1)	{
					if (gc.type==data.sequence) {
						eqType=sequence;
						gc.isEditable=false;
						gc.isVisible=false;
						Si=D.p.Analyse("1");
						Sf=D.p.Analyse("100");
						try {
							String[] st2=mjaStr.getTokens(gc.seqRange);
							int ix2=0;
							if (st2.length>1) {
								Si=D.p.Analyse(st2[ix2++].trim());
								Sf=D.p.Analyse(st2[ix2++].trim());
							}
						} catch (Exception exc2) {
						}
					} else {
						eqType=curve;
					}
					fx=D.p.Analyse(st[ix++]);
					fy=D.p.Analyse(st[ix++]);
					return;
				}
			} catch (Exception exc) {
			}
		} else {
			for (int i=0;i<lineEq.length;i++) {
				if (gc.formula.equals(lineEq[i])) {
					eqType=line;
					return;
				}
			}
			for (int i=0;i<conicEq.length;i++) {
				if (gc.formula.equals(conicEq[i])) {
					eqType=conic;
					return;
				}
			}
//			System.out.println("CARAY: |"+gc.formula+"|");
			if (gc.formula.length()>0) {
				StringTokenizer st=new StringTokenizer(gc.formula,"=");
	//			if (st.hasMoreTokens()) {
					String initial=st.nextToken();
					if (initial.equals("y")||initial.equals("x")) {
						F=D.p.Analyse(gc.formula.substring(gc.formula.indexOf('=')+1,gc.formula.length()).trim());
						if (initial.equals("y")&&!F.contains("y")) {
							eqType=funcOfX;
							return;
						}
						if (initial.equals("x")&&!F.contains("x")) {
							eqType=funcOfY;
							return;
						}
					}
					eqType=equation;
	//			}
			} else {
				eqType=equation;
			}
		}
	}

	void draw(Image ima,Graphics[] g) {
		if (cond.Evaluate(1)>0||eqType==funcOfX||eqType==funcOfY) {
			Node X=D.p.Var("x"),Y=D.p.Var("y");
			synchronized(X) {
				synchronized(Y) {
					double vx=X.r, vy=Y.r;
					switch (eqType) {
					case segment  : drawSegment(ima,g); break;
					case curve    : drawCurve(g); break;
					case sequence : drawSequence(g); break;
					case line     : drawLine(g); break;
					case conic    : drawConic(g); break;
					case funcOfX  : drawFunctionOfx(g); break;
					case funcOfY  : drawFunctionOfy(g); break;
					case equation : drawEquation(g); break;
					}
					X.r=vx; Y.r=vy;
				}
			}
		}
	}

	static void Arc(Graphics g,int width,int x0, int y0, int r, int ai, int da) {
		if (da<0) {
			ai=ai+da;
			da=-da;
		}
		if (width==1) {
			g.drawArc(x0-r,y0-r,2*r,2*r,ai,da);
		} else if (width>1) {
			double dalfa=Math.PI/180;
			double alfa=ai*dalfa;
			int x1=x0+(int) Math.round(r*Math.cos(alfa));
			int y1=y0-(int) Math.round(r*Math.sin(alfa));
			for (int i=1;i<=da;i++) {
				int x2=x0+(int) Math.round(r*Math.cos(alfa));
				int y2=y0-(int) Math.round(r*Math.sin(alfa));
				alfa+=dalfa;
				Line(g,width,x1,y1,x2,y2);
				x1=x2; y1=y2;
			}
		}
	}

	static void Line(Graphics g,int width,int x1,int y1,int x2,int y2) {
		if (width==1) {
			g.drawLine(x1,y1,x2,y2);
		} else if (width>1) {
			R2 r=new R2(x2-x1,y2-y1);
			int N=(int) Math.round((r.norm()*3)/2);
			r.div(N);
			int sz2=width/2;
			double x=x1,y=y1;
			for (int i=0;i<=N;i++) {
				if (width==2) {
					g.fillRect((int)Math.round(x)-sz2,(int)Math.round(y)-sz2,width,width);
					x+=r.x;y+=r.y;
				} else {
					g.fillOval((int)Math.round(x)-sz2,(int)Math.round(y)-sz2,width,width);
					x+=r.x;y+=r.y;
				}
			}
		}
	}

	static void circle(Graphics g,int xc, int yc, double r) {
		g.drawLine(xc- (int) Math.round(r),yc,xc + (int) Math.round(r),yc);
		if (r>0) {
			double a=r, b=r;
			double d=1+(a+b)/16, a2=(a*a)/d, b2=(4*(b*b-b)+1)/d;
			double z=b2*(1-4*a), zxx=8*b2, zyy=32*a2, zx=4*b2*(1-2*a), zy=16*a2;
			int x=(int) Math.round(a), y=0;
			y++; z+=zy; zy+=zyy;
			boolean cambio=false;
			do {
				while (z<=0) {
					if (!cambio) {
						g.drawLine(xc-x,yc-y,xc+x,yc-y);
						g.drawLine(xc-x,yc+y,xc+x,yc+y);
					} else {
						cambio=false;
					}
					y++; z+=zy; zy+=zyy;
				}
				while (z>0 && x>0) {
					x--; z+=zx; zx+=zxx;
					g.drawLine(xc-x,yc-y,xc+x,yc-y);
					g.drawLine(xc-x,yc+y,xc+x,yc+y);
				}
				cambio=true;
			} while (x>0);
		}
	}

	static void drawPolygon(Component D,Graphics[] g,int width,Polygon P,boolean fill,Color fillColor) {
		if (fill) {
			for (int i=0;i<g.length;i++) {
				Color c=g[i].getColor();
				g[i].setColor(data.adaptColor(D,fillColor));
				g[i].fillPolygon(P);
				g[i].setColor(data.adaptColor(D,c));
			}
		}
		for (int i=0;i<g.length;i++) {
			for (int j=1;j<P.npoints;j++) {
				Line(g[i],width,P.xpoints[j-1],P.ypoints[j-1],P.xpoints[j],P.ypoints[j]);
			}
		}
	}

	/* ---------------------- segment, point, arc or text ------------------- */

	void drawSegment(Image img,Graphics[] g)	{
		if (segType==data.t_arc) {
			drawArc(g);
		} else if (xNa.length<=2) {
			R2 q=new R2(0,0);
			try {
				R2 p0=new R2(xNa[0].Evaluate(),yNa[0].Evaluate());
				R2 p1=p0;
				if (segType==data.t_segment||segType==data.arrow) {
					p1=new R2(xNa[1].Evaluate(),yNa[1].Evaluate());
				}
				if (segType!=data.t_text)	{
					p0=D.cs.projection(p0);
					p1=D.cs.projection(p1);
				}
				if (p0.ix()!=p1.ix()||p0.iy()!=p1.iy())	{
					for (int i=0;i<g.length;i++) {
						Line(g[i],width,p0.ix(),p0.iy(),p1.ix(),p1.iy());
					}
				}
				if (segType!=data.t_text&&size>0)	{
					if (gc.type==data.arrow) {
						for (int i=0;i<g.length;i++) {
							drawArrow(g[i],gc.arrowColor,gc.gcolor,p0.ix(),p0.iy(),p1.ix(),p1.iy(),width,spear);
						}
					} else {
						if (gc.type==data.fill) {
							int x0=p0.ix() , y0=p0.iy() ;
							int w=img.getWidth(D.cs);
							int h=img.getHeight(D.cs);
							if ( 0<=x0 && 0<=y0 && x0<w && y0<h ) {
								int[] pixels = mjaGui.grabPixelsFromImage(D.cs,img);
								mjaGui.fillShape(g,pixels,w,h,x0,y0);
							}
						} else {
							for (int i=0;i<g.length;i++) {
								if (D.cs.inside(p0)) {
									circle(g[i],p0.ix(),p0.iy(),size);
								}
								if ((p0.ix()!=p1.ix()||p0.iy()!=p1.iy()) && D.cs.inside(p1)) {
									circle(g[i],p1.ix(),p1.iy(),size);
								}
							}
						}
					}
				}
				q=new R2((2*p0.ix()+p1.ix())/3 + size+1,(2*p0.iy()+p1.iy())/3 - size-1);
			} catch (Exception e) {
			}
			drawText(q,g);
		} else {
			Polygon P=new Polygon();
			try {
				for (int n=0;n<xNa.length;n++)	{
					R2 p1=D.cs.projection(new R2(xNa[n].Evaluate(),yNa[n].Evaluate()));
					P.addPoint(p1.ix(),p1.iy());
				}
				drawPolygon(D,g,width,P,gc.hasFill,gc.fillColor);
			} catch (Exception e) {
			}
		}
	}

	void drawArc(Graphics[] g) {
		R2 q=new R2(0,0);
		try {
			R2 p0=D.cs.projection(new R2(xNa[0].Evaluate(),yNa[0].Evaluate()));
			int ra=(int)Math.round(D.cs.esc*r.Evaluate());
			int ai=0,da=360;
			if (aN!=null&&daN!=null)	{
				ai=(int)Math.round(aN.Evaluate());
				da=(int)Math.round(daN.Evaluate());
			} else {
				R2 P1=D.cs.projection(new R2(x1.Evaluate(),y1.Evaluate()));
				R2 P2=D.cs.projection(new R2(x2.Evaluate(),y2.Evaluate()));
				P1.sub(p0);P1.normalize();P2.sub(p0);P2.normalize();
				ai=(int)Math.round(180.0*Math.asin(-P1.y)/Math.PI);
				if (P1.x<0) { ai=180-ai; }
				while (ai<0) { ai+=360; }
				while (ai>360) { ai-=360; }
				double dA=P1.dot(P2);
				da=(int)Math.round(180.0*Math.acos(dA)/Math.PI);
				if (P1.det(P2)>0) { da=-da; }
			}
			if (Math.abs(((double)ra*da)*Math.PI/180)>=1.0 && Math.abs(ra-p0.norm())<4096) {
				if (da<0) {
					ai+=da;
					da=-da;
				}
				if (gc.hasFill) {
					for (int i=0;i<g.length;i++) {
						Color c=g[i].getColor();
						g[i].setColor(data.adaptColor(D,gc.fillColor));
						g[i].fillArc(p0.ix()-ra,p0.iy()-ra,2*ra,2*ra,ai,da);
						g[i].setColor(data.adaptColor(D,c));
					}
				}
				for (int i=0;i<g.length;i++) {
					Arc(g[i],width,p0.ix(),p0.iy(),ra,ai,da);
				}
			}
			q=p0;
		} catch (Exception e) {
		}
		drawText(q,g);
	}

	void drawText(R2 q,Graphics[] g) {
		if (D.cs.inside(q)||segType==data.t_text) {
			for (int i=0;i<g.length;i++) {
				g[i].setFont(gc.font);
				FontMetrics fm=g[i].getFontMetrics(gc.font);
				for (int n=0;n<pstr.length;n++) {
					String texto="";
					int y0=0;
					if (segType==data.t_text) {
						y0=4+fm.getAscent();
					}
					y0+=n*fm.getHeight();
					int dec=(int)Math.round(decimals.Evaluate(2));
					for (int j=0;j<pstr[n].size();j++) {
						Node auxn=(Node) pstr[n].elementAt(j);
						String auxs=auxn.toString(dec,D.language);
						texto+=auxs;
					}
					g[i].drawString(texto,q.ix()+size,y0+q.iy()-size);
				}
			}
		}
	}

	private void drawArrow(Graphics g,Color in,Color out,int x, int y, int x1, int y1,int W,int S) {
		if (W<0) {
			W=6;
		}
		W=2*((W+1)/2);
		if (S<0) {
			S=W;
		}
		S=2*((S+1)/2);
		int dx=x1-x, dy=y1-y;
		double L=Math.sqrt((double)(dx*dx+dy*dy));
		double A=0;
		if (L>0) {
			A=Math.acos(dx/L);
		}
		if (dy<0) {
			A=2*Math.PI-A;
		}
		g.setColor(data.adaptColor(D,in));
		g.fillPolygon(flecha(x,y,W,S,L,A));
		g.setColor(data.adaptColor(D,out));
		g.drawPolygon(flecha(x,y,W,S,L,A));
	}

	private static Polygon flecha(int x,int y,double W,double S,double L,double A) {
		R2[] poly0= new R2[7];
		poly0[0]=new R2(-W/2,W/2);
		poly0[1]=new R2(L-W-S,W/2);
		poly0[2]=new R2(L-2*S,S+W/2);
		poly0[3]=new R2(L,0);
		poly0[4]=new R2(L-2*S,-S-W/2);
		poly0[5]=new R2(L-W-S,-W/2);
		poly0[6]=new R2(-W/2,-W/2);
		int[] xx = new int[poly0.length];
		int[] yy = new int[poly0.length];
		for (int i=0; i<poly0.length; i++) {
			poly0[i].rot(-A);
			xx[i]=x+(int) Math.round(poly0[i].x);
			yy[i]=y-(int) Math.round(poly0[i].y);
		}
		return new Polygon(xx,yy,poly0.length);
	}

	/* ----------------------------- Curve ----------------------------- */

	protected void drawCurve(Graphics[] g) {
		if (tparz!=null) {
			R2 P0=new R2(0,0);
			boolean firstPoint=true;
			int tN=(int)Math.round(tparz.NN.Evaluate(32));
			double ti=tparz.Ni.Evaluate(0);
			double tf=tparz.Nf.Evaluate(1);
			Polygon P=new Polygon();
			try {
				Node N=D.p.Var(tparz.name);
				synchronized(N) {
					double v=N.r;
					for (int n=0;n<=tN;n++)	{
						N.r=ti+(tf-ti)*(double)n/(double)tN;
						R2 p1=D.cs.projection(new R2(fx.Evaluate(),fy.Evaluate()));
						P.addPoint(p1.ix(),p1.iy());
					}
					drawPolygon(D,g,width,P,gc.hasFill,gc.fillColor);
					N.r=v;
				}
			} catch (Exception e) {
			}
		}
	}

	/* ----------------------------- Sequence ----------------------------- */

	protected void drawSequence(Graphics[] g) {
		int N1=(int) Math.round(Si.Evaluate(1));
		int N2=(int) Math.round(Sf.Evaluate(1));
		Node N=D.p.Var("n");
		synchronized(N) {
			double vn=N.r;
			for (int n=N1;n<=N2;n++) {
				N.r=n;
				if (cond.Evaluate(1)>0) {
					try {
						R2 p=D.cs.projection(new R2(fx.Evaluate(),fy.Evaluate()));
						for (int i=0;i<g.length;i++) {
							circle(g[i],p.ix(),p.iy(),size);
						}
					} catch (Exception e) {
						System.out.println(e);
					}
				}
			}
			N.r=vn;
		}
	}

	/* -------------------------- Line --------------------------- */

	private void drawLine(Graphics[] g) {
		int x1=0,y1=0,x2=0,y2=0;
		if (gc.formula.equals(lineEq[0])) {
			double m0=D.p.value("m");
			double b0=D.cs.esc*D.p.value("b");
			x1=0;    y1=D.cs.Oy-(int)Math.round(b0+m0*(x1-D.cs.Ox));
			x2=D.cs.w; y2=D.cs.Oy-(int)Math.round(b0+m0*(x2-D.cs.Ox));
		}
		if (gc.formula.equals(lineEq[1])) {
			double m1=D.p.value("m");
			double a1=D.cs.esc*D.p.value("a");
			y1=0;    x1=D.cs.Ox+(int)Math.round(m1*(y1-D.cs.Oy)+a1);
			y2=D.cs.h; x2=D.cs.Ox+(int)Math.round(m1*(y2-D.cs.Oy)+a1);
		} else if (gc.formula.equals(lineEq[2])) {
			double A=D.p.value("A");
			double B=D.p.value("B");
			double C=D.p.value("C");
			if (Math.abs(B)>Math.abs(A)) {
				double m1=-A/B;
				double b1=(C/B)*D.cs.esc;
				x1=0;   y1=D.cs.Oy-(int)Math.round(b1+m1*(x1-D.cs.Ox));
				x2=D.cs.w; y2=D.cs.Oy-(int)Math.round(b1+m1*(x2-D.cs.Ox));
			} else if (Math.abs(A)>0.01) {
				double m1=-B/A;
				double b1=-(C/A)*D.cs.esc;
				y1=0;   x1=D.cs.Ox-(int)Math.round(b1+m1*(y1-D.cs.Oy));
				y2=D.cs.h; x2=D.cs.Ox-(int)Math.round(b1+m1*(y2-D.cs.Oy));
			} else {
				return;
			}
		}
		for (int i=0;i<g.length;i++) {
			Line(g[i],width,x1,y1,x2,y2);
		}
	}

	/* -------------------------- Conic --------------------------- */

	private Graphics[] g;

	private void drawConic(Graphics[] g) {
		this.g=g;
		boolean twoBranches=false;
		w=D.cs.w; h=D.cs.h;
		double d=1.0,e=1.0,t=0.0;
		R2 F=D.cs.projection(new R2(D.p.value("Fx"),D.p.value("Fy")));
		if (gc.formula.equals(conicEq[0]))	{
			e=D.p.value("e");
			if (e>20) {
				return;
			}
			d=D.cs.esc*D.p.value("d");
			t=D.p.value("t");
			twoBranches=false;
		} else if (gc.formula.equals(conicEq[1])) {
			R2 Q=D.cs.projection(new R2(D.p.value("Dx"),D.p.value("Dy")));
			R2 P=D.cs.projection(new R2(D.p.value("Px"),D.p.value("Py")));
			d=Q.distance(F);
			double PF=P.distance(F),PQ=P.distance(Q);
			if (PQ<0.1||PF<0.1||d<0.1) {
				return;
			}
			double sint=F.y-Q.y, cost=F.x-Q.x;
			if (cost==0) {
				if (sint>=0) {
					t=-Pim;
				} else {
					t=Pim;
				}
			} else {
				t=Math.atan(-sint/cost);
				if (cost<0) {
					t=t+Math.PI;
				}
			}
			P.sub(F); Q.sub(F);
			e=(d - (Q.dot(P)/d))/PF;
			if (e<0.05) {
				return;
			}
			e=1/e;
			twoBranches=false;
		}
		Fx=F.ix(); Fy=F.iy();
		doDrawConic(d,e,t);
		if (twoBranches&&e>1.0) {
			double e2=e*e;
			double d2=d+d; double ar=(1.E+16)/e2;
			if ((e2-1.0)/d2>1.E-16) {
				ar=e2*d2/(e2-1.0);
			}
			F.x=F.x-ar*Math.cos(t);
			F.y=F.y+ar*Math.sin(t);
			Fx=F.ix(); Fy=F.iy();
			doDrawConic(d,e,t+Math.PI);
		}
	}

	private void Plot(int x, int y) {
		for (int i=0;i<g.length;i++) {
			Line(g[i],width,x,y,x,y);
		}
	}

	private void Pon() {
		switch (caso) {
		case 0 : Plot(Fx+x,Fy+y); break;
		case 1 : Plot(Fx+y,Fy-x); break;
		case 2 : Plot(Fx-x,Fy-y); break;
		case 3 : Plot(Fx-y,Fy+x); break;
		}
	}

	private void Dx() {
		x+=dx; z+=zx; zx+=zxx; zy+=zxy;
	}

	private void Dy() {
		y+=dy; z+=zy; zy+=zyy; zx+=zxy;
	}

	private void loop()	{
		if (Math.abs(z+zy)<Math.abs(z+zx)) {
			Dy();
			if (Math.abs(z)>=Math.abs(z+zx)) {
				Dx();
			}
		} else 	{
			Dx();
			if (Math.abs(z)>=Math.abs(z+zy)) {
				Dy();
			}
		}
		Pon();
	}

	private void doDrawConic(double d, double e, double t0)	{
		boolean elip=(e<1); boolean hip=(e>1);
		double t=t0;
		while (t<0.0)    {
			t=t+dosPi;
		}
		while (t>=dosPi) {
			t=t-dosPi;
		}
		caso=0;
		while (t>=Pim) {
			t=t-Pim; caso=caso+1;
		}
		if ( t>Pim-epsilon) {
			t=0;
			caso=(caso+1)%4;
		}
		if ( t<epsilon ) {
			t=0;
		}
		int minx=0,miny=0,maxx=w,maxy=h;
		switch (caso) {
		case 0: minx=-Fx;  miny=-Fy;  maxx=w-Fx; maxy=h-Fy; break;
		case 1: minx=Fy-h; miny=-Fx;  maxx=Fy;   maxy=w-Fx; break;
		case 2: minx=Fx-w; miny=Fy-h; maxx=Fx;   maxy=Fy;   break;
		case 3: minx=-Fy;  miny=Fx-w; maxx=h-Fy; maxy=Fx;   break;
		}
		double cost= Math.cos(t),sent=-Math.sin(t);
		double p=d*e/(1.0+e), e2mint=e*e*MAX_INT;
		x=-(int)Math.round(p*cost); y=-(int)Math.round(p*sent);
		int dxx=(int)Math.round(MAX_INT-e2mint*cost*cost);
		int dyy=(int)Math.round(MAX_INT-e2mint*sent*sent);
		e2mint*=2;
		int dxy=-(int)Math.round(e2mint*cost*sent);
		e2mint*=d;
		int zxo=dxx*(x+x+1)+dxy*y-(int)Math.round(e2mint*cost);
		int zyo=dyy*(y+y+1)+dxy*x-(int)Math.round(e2mint*sent);
		zxx=2*dxx; zyy=2*dyy;
		int xo=x; int yo=y;
		Pon();
		z=0;
		dx=1;zx=zxo; dy=1;zy=zyo;zxy=dxy;
		do {
			loop();
		} while (zx<=0&&x<=maxx&&(!hip||y<=maxy));
		if (zx>0) {
			dy=-1; zy=zyy-zy; zxy=-dxy;
			do {
				loop();
			} while (x<=maxx&&(elip||y>=miny)&&(!elip||zy<=0));
		}
		x=xo; y=yo;
		dx=-1;zx=zxx-zxo; dy=-1;zy=zyy-zyo; zxy=dxy;
		z=0;
		do {
			loop();
		} while (zy<=0&&y>=miny&&(!hip||x>=minx));
		if (zy>0) {
			dx=1; zx=zxx-zx; zxy=-dxy;
			do {
				loop();
			} while (x<=maxx&&(elip||y>=miny)&&(!elip||zx<=0));
		}
		if (elip && x<maxx) {
			dx=1; dy=1;zy=zyy-zy; zxy=dxy;
			do {
				loop();
			} while (zy<=0&&x<=maxx&&y<=maxy);
		}
	}


	/* -------------------------- y=f(x) --------------------------- */

	static R2 extrapolate(Node cond,Node X,Node F,double v,double dx) {
		double saveX=X.r;
		double dxx=dx/2,Dx=0;
		double vv=v;
		while (Math.abs(dxx)>1E-12) {
			X.r+=dxx;
			boolean ok=true;
			if (cond.Evaluate(1)>0){
				try {
					double vva=vv;
					vv=F.Evaluate();
					R2 minmax=new R2(Math.min(vva,vv),Math.max(vva,vv));
					if (hasSingularity(Math.abs(dx),X,F,X.r-dxx,vva,X.r,vv,minmax)) {
						ok=false;
					}
				} catch (Exception e) {
					ok=false;
				}
			} else {
				ok=false;
			}
			if (ok) {
				Dx+=dxx;
			} else {
				X.r-=dxx;
			}
			dxx/=2;
		}
		X.r=saveX;
		return new R2(Dx/Math.abs(dx),vv);
	}

	static boolean hasSingularity(double e,Node X,Node F,double a,double va,double b,double vb,R2 minmax) {
		if ( Math.abs(b-a)<1E-12 ||
			(Math.abs(b-a)<1E-8&&Math.abs(vb-va)>Math.abs(e)) ) {
			return true;
		}
		boolean disc=false;
		double saveX=X.r;
		try {
			X.r=(a+b)/2;
			double auxv=F.Evaluate();
			if (minmax.x<=auxv && auxv<=minmax.y) {
				disc=false;
			} else {
				minmax.x=Math.min(minmax.x,auxv);
				minmax.y=Math.max(minmax.y,auxv);
				disc=hasSingularity(e,X,F,a,va,X.r,auxv,minmax)||hasSingularity(e,X,F,X.r,auxv,b,vb,minmax);
			}
		} catch (Exception exc) {
			disc=true;
		}
		X.r=saveX;
		return disc;
	}

	private void drawFunctionOfx(Graphics[] g) {
		boolean defa=false;
		R2 Or=new R2(D.cs.Ox,D.cs.Oy);
		int y0=Or.iy();
		int y=0,ya=0,x=0,xa=0;
		double dx=1/D.cs.esc;
		Node X=D.p.Var("x");
		X.r=-dx*D.cs.Ox;
		double va=0;
		while(x<D.cs.w) {
			boolean def=true;
			if (cond.Evaluate(1)>0) {
				try {
					double v=F.Evaluate();
					if (defa) {
						double min=Math.min(va,v);
						double max=Math.max(va,v);
						R2 minmax=new R2(min,max);
						if (!hasSingularity(dx,X,F,X.r-dx,va,X.r,v,minmax)) {
							if (va<=v) {
								va=minmax.x; v=minmax.y;
							} else {
								v=minmax.x; va=minmax.y;
							}
							int nya=D.cs.YY(width,va);
							y=D.cs.YY(width,v);
							for (int i=0;i<g.length;i++) {
								if (gc.hasFillminus&&y>y0) {
									g[i].setColor(data.adaptColor(D,gc.fillminusColor));
									Line(g[i],width,x,y0+1,x,y);
									g[i].setColor(data.adaptColor(D,gc.gcolor));
								}
								if (gc.hasFillplus&&y<y0) {
									g[i].setColor(data.adaptColor(D,gc.fillplusColor));
									Line(g[i],width,x,y0-1,x,y);
									g[i].setColor(data.adaptColor(D,gc.gcolor));
								}
								Line(g[i],width,xa,ya,xa,nya);
								Line(g[i],width,xa,nya,x,y);
							}
						} else {
							double saveX=X.r;
							X.r-=dx;
							R2 pn=extrapolate(cond,X,F,va,dx);
							y=D.cs.YY(width,pn.y);
							for (int i=0;i<g.length;i++) {
								Line(g[i],width,xa,ya,xa+(int)Math.round(pn.x),y);
							}
							X.r=saveX;
							R2 pa=extrapolate(cond,X,F,v,-dx);
							ya=D.cs.YY(width,pa.y);
							y=D.cs.YY(width,v);
							for (int i=0;i<g.length;i++) {
								Line(g[i],width,x+(int)Math.round(pa.x),ya,x,y);
							}
						}
					} else {
						R2 pa=extrapolate(cond,X,F,v,-dx);
						ya=D.cs.YY(width,pa.y);
						y=D.cs.YY(width,v);
						for (int i=0;i<g.length;i++) {
							Line(g[i],width,x+(int)Math.round(pa.x),ya,x,y);
						}
					}
					va=v;
				} catch (Exception e) {
					def=false;
				}
			} else {
				def=false;
			}
			if (defa&&!def) {
				double saveX=X.r;
				X.r-=dx;
				R2 pn=extrapolate(cond,X,F,va,dx);
				y=D.cs.YY(width,pn.y);
				for (int i=0;i<g.length;i++) {
					Line(g[i],width,xa,ya,xa+(int)Math.round(pn.x),y);
				}
				X.r=saveX;
			}
			defa=def; X.r+=dx; ya=y; xa=x++;
		}
	}

	/* -------------------------- x=f(y) --------------------------- */

	private void drawFunctionOfy(Graphics[] g) {
		int xmax=D.cs.getSize().width;
		boolean defa=false;
		R2 Or=new R2(D.cs.Ox,D.cs.Oy);
		int x0=Or.ix();
		int y=0,ya=0,x=0,xa=0;
		double dy=1/D.cs.esc;
		Node Y=D.p.Var("y");
		Y.r=dy*D.cs.Oy;
		double va=0;
		while(y<D.cs.h) {
			boolean def=true;
			if (cond.Evaluate(1)>0) {
				try {
					double v=F.Evaluate();
					if (defa) {
						double min=Math.min(va,v);
						double max=Math.max(va,v);
						R2 minmax=new R2(min,max);
						if (!hasSingularity(dy,Y,F,Y.r+dy,va,Y.r,v,minmax)) {
							if (va<=v) {
								va=minmax.x; v=minmax.y;
							} else {
								v=minmax.x; va=minmax.y;
							}
							int nxa=D.cs.XX(width,va);
							x=D.cs.XX(width,v);
							for (int i=0;i<g.length;i++) {
								if (gc.hasFillplus&&x>x0) {
									g[i].setColor(data.adaptColor(D,gc.fillplusColor));
									Line(g[i],width,x0+1,y,x,y);
									g[i].setColor(data.adaptColor(D,gc.gcolor));
								}
								if (gc.hasFillminus&&x<x0) {
									g[i].setColor(data.adaptColor(D,gc.fillminusColor));
									Line(g[i],width,x0-1,y,x,y);
									g[i].setColor(data.adaptColor(D,gc.gcolor));
								}
								Line(g[i],width,xa,ya,nxa,ya);
								Line(g[i],width,nxa,ya,x,y);
							}
						} else {
							double saveX=Y.r;
							Y.r+=dy;
							R2 pn=extrapolate(cond,Y,F,va,-dy);
							x=D.cs.XX(width,pn.y);
							for (int i=0;i<g.length;i++) {
								Line(g[i],width,xa,ya,x,y+(int)Math.round(pn.x));
							}
							Y.r=saveX;
							R2 pa=extrapolate(cond,Y,F,v,dy);
							xa=D.cs.XX(width,pa.y);
							x=D.cs.XX(width,v);
							for (int i=0;i<g.length;i++) {
								Line(g[i],width,xa,ya+(int)Math.round(pa.x),x,y);
							}
						}
					} else {
						R2 pa=extrapolate(cond,Y,F,v,dy);
						xa=D.cs.XX(width,pa.y);
						x=D.cs.XX(width,v);
						for (int i=0;i<g.length;i++) {
							Line(g[i],width,xa,ya+(int)Math.round(pa.x),x,y);
						}
					}
					va=v;
				} catch (Exception e ) {
					def=false;
				}
			} else {
				def=false;
			}
			if (defa&&!def) {
				double saveX=Y.r;
				Y.r+=dy;
				R2 pn=extrapolate(cond,Y,F,va,-dy);
				x=D.cs.XX(width,pn.y);
				for (int i=0;i<g.length;i++) {
					Line(g[i],width,xa,ya,x,y+(int)Math.round(pn.x));
				}
				Y.r=saveX;
			}
			defa=def; Y.r-=dy; xa=x; ya=y++;
		}
	}


	/* ------------------------- f(x,y)=0 -------------------------- */

	static final int netsz=16;

	private void drawEquation(Graphics[] g) {
		try {
			R2Newton newt=new R2Newton(D.p,gc.formula);
			int dx=D.cs.w/netsz; if (dx<3) { dx=3; }
			int dy=D.cs.h/netsz; if (dy<3) { dy=3; }
			boolean[][] b=new boolean[D.cs.w][D.cs.h];
			R2 q0=new R2(), qb=new R2(), t=new R2();
			for (int j=dy/2; j<D.cs.h; j+=dy) {
				for (int i=dx/2; i<D.cs.w; i+=dx) {
					R2 q=newt.findZero(D.cs.injection(i,j));
					R2 Q=D.cs.projection(q);
					int Qx=Q.ix(), Qy=Q.iy();
					if (Qx<0||Qx>=D.cs.w||Qy<0||Qy>=D.cs.h||b[Qx][Qy]) {
						continue; /* Zero already detected */
					}
					b[Qx][Qy]=true;
					if (newt.rangeOK()) {
						for (int ix=0;ix<g.length;ix++) {
							Line(g[ix],width,Qx,Qy,Qx,Qy);
						}
					}
					q0.x=q.x; q0.y=q.y;
					qb.x=q.x; qb.y=q.y;
					// t=t0= Unit Tangent Vector
					R2 t0=newt.getUnitNormal();
					if (t0.x==0&&t0.y==0) {
						continue; /* Zero normal vector */
					}
					t0.rotL90();
					t.x=t0.x; t.y=t0.y;
					int zeroVisited=0,side=0;
					boolean changeSide=false;
					while (side<2)	{
						if (changeSide)	{
							t.x=-t0.x; t.y=-t0.y; // Invert Unit Tangent Vector
							q.x=q0.x; q.y=q0.y;
							qb.x=q.x; qb.y=q.y;
							Q=D.cs.projection(q);
							Qx=Q.ix(); Qy=Q.iy();
							changeSide=false;
							zeroVisited=0;
						}
						q.x+=t.x/D.cs.esc; q.y+=t.y/D.cs.esc; // advance along t aprox one pixel
						q=newt.findZero(q);
						t.x=q.x-qb.x; t.y=q.y-qb.y; t.normalize(); // update Unit Tangent Vector
						if (t.x==0&&t.y==0) {
							break; /* Zero tangent vector */
						}
						qb.x=q.x; qb.y=q.y;
						Q=D.cs.projection(q);
						int Px=Q.ix(),Py=Q.iy();
						if (Px!=Qx||Py!=Qy) {
							Qx=Px; Qy=Py;
							if (0<=Qx&&Qx<D.cs.w&&0<=Qy&&Qy<D.cs.h)	{
								zeroVisited=0;
								if (b[Qx][Qy]) { /* Zero already detected */
									break;
								} else {
									b[Qx][Qy]=true;
									if (newt.rangeOK()) {
										for (int k=0;k<g.length;k++) {
											Line(g[k],width,Qx,Qy,Qx,Qy);
										}
									}
								}
							} else {
								changeSide=true; side++; /* Zero out of bounds */
							}
						} else if ( ++zeroVisited>4 ) {
							changeSide=true; side++; /* Stationary Zero */
						}

					}
				}
			}
		} catch (Exception e) {
			System.out.println(e);
		}
	}

}