/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.descartes;

/*------------------------------------------------------------*/
/*                         oldConfig                          */
/*                          (c) MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/

import java.awt.*;
import java.util.*;
import java.applet.*;
import com.jla.desc2.parser.*;
import com.jla.desc2.util.*;

public class oldConfig {

	private static final int
		idioma=0,
		colores=1,
		espacio=2,
		parametros=3,
		auxiliares=4,
		controles=5,
		funciones=6,
		ecuaciones=7,
		curvas=8,
		puntos=9,
		segmentos=10,
		arcos=11,
		textos=12,
		botones=13;

	private static final String[][] tooln = {
		{ "LANGUAGE" , "COLORS"   , "SPACE"   , "PARAMETERS" , "VARIABLES" , "CONTROLS" , "FUNCTIONS", "EQUATIONS" , "CURVES", "POINTS" , "SEGMENTS"  , "ARCS"  , "TEXTS"  , "BUTTONS" },
		{ "IDIOMA"   , "COLORES"  , "ESPACIO" , "PARAMETROS" , "AUXILIARES", "CONTROLES", "FUNCIONES", "ECUACIONES", "CURVAS", "PUNTOS" , "SEGMENTOS" , "ARCOS" , "TEXTOS" , "BOTONES" },
		{ "IDIOMA"   , "COLORS"   , "ESPAI"   , "PARMETRES" , "AUXILIARS" , "CONTROLS" , "FUNCIONS" , "EQUACIONS" , "CORBES", "PUNTS"  , "SEGMENTS"  , "ARCS"  , "TEXTOS" , "BOTONS"  },
		{ "IDIOMA"   , "CORES"    , "ESPACIO" , "PARMETROS" , "AUXILIARES", "CONTROIS" , "FUNCINS" , "ECUACINS" , "CURVAS", "PUNTOS" , "SEGMENTOS" , "ARCOS" , "TEXTOS" , "BOTNS"  },
		{ "HIZKUNTZA", "KOLOREAK" , "ESPAZIOA", "PARAMETROAK", "ALDAGAIAK" , "KONTROLAK", "FUNTZIOAK", "EKUAZIOAK" , "KURBAK", "PUNTUAK", "SEGMENTUAK", "ARKUAK", "TESTUAK", "BOTOIAK" }
	};

	static Attribute[] getNewParams(Applet A) {
		Attribute[] oa=getOldParams(A);
		int l=data.getLanguage(oa[idioma].value);
		Vector v=new Vector();
//		v.addElement(new Attribute(data.newName[l][data.p_version],data.Version));
		addParamLine(v,l,data.p_language,null,oa[idioma].value);
		addParamLine(v,l,data.p_buttons,battrix,oa[botones].value);
		addParamLine(v,l,data.p_space,cattrix,oa[colores].value);
		Attribute[] spaceaa=analyze(l,oa[espacio].value.trim());
		Attribute[] paramaa=analyze(l,oa[parametros].value.trim());
		Vector cv=new Vector();
		for (int i=0;i<spaceaa.length;i++) {
			cv.addElement(new Attribute(data.controlPrefix+mjaStr.IntegerToString(cv.size(),2),"id="+spaceaa[i].name+" "+spaceaa[i].value+" "+data.newName[l][data.region]+"="+data.newName[l][data.north]));
		}
		for (int i=0;i<paramaa.length;i++) {
			cv.addElement(new Attribute(data.controlPrefix+mjaStr.IntegerToString(cv.size(),2),"id="+paramaa[i].name+" "+paramaa[i].value+" "+data.newName[l][data.region]+"="+data.newName[l][data.south]));
		}
		Vector av=new Vector();
		addAuxiliars(av,l,"",oa[auxiliares].value);
		addAuxiliars(av,l,"(x)",oa[funciones].value);
		Vector gv=new Vector();
		addGraphics(cv,gv,l,data.t_equation,oa[ecuaciones].value);
		addGraphics(cv,gv,l,data.t_point,oa[puntos].value);
		addGraphics(cv,gv,l,data.t_point,oa[controles].value);
		addGraphics(cv,gv,l,data.t_segment,oa[segmentos].value);
		addGraphics(cv,gv,l,data.t_curve,oa[curvas].value);
		addGraphics(cv,gv,l,data.t_arc,oa[arcos].value);
		addGraphics(cv,gv,l,data.t_text,oa[textos].value);
		Enumeration e=cv.elements();
		while (e.hasMoreElements()) {
			v.addElement(e.nextElement());
		}
		e=av.elements();
		while (e.hasMoreElements()) {
			v.addElement(e.nextElement());
		}
		e=gv.elements();
		while (e.hasMoreElements()) {
			v.addElement(e.nextElement());
		}
		Attribute[] np=new Attribute[v.size()+1];
		e=v.elements();
		int i=0;
		np[i++]=new Attribute("escala0","32");
		while (e.hasMoreElements()) {
			np[i++]=(Attribute)e.nextElement();
		}
		return np;
	}

	private static Attribute[] getOldParams(Applet A) {
		Attribute[] oa=new Attribute[tooln[0].length];
		String[] p=new String[tooln[0].length];
		int l=1;
		for (int i=0; i<tooln[0].length; i++) {
			for (int L=0;L<data.numLang;L++)	{
				if (p[i]==null||p[i].length()==0) {
					p[i]=A.getParameter(tooln[L][i]);
					if (p[i]!=null) { // 2009/03/17  para corregir que el JRE 6.10 y superior transfiere a los parmetros los saltos de lnea
						p[i]=p[i].replaceAll("\n","");
						p[i]=p[i].replaceAll("\r","");
					}
				}
			}
			if (p[i]==null) {
				p[i]="";
			}
			if (i==0) {
				if (p[0].trim().length()==0) {
					p[0]=data.newName[data.esp][data.langName];
				}
				l=data.getLanguage(p[0]);
			}
			oa[i]=new Attribute(tooln[l][i],p[i]);
		}
		return oa;
	}

	private static void addParamLine(Vector v,int l, int newpar,int[] attrix,String oldvalue) {
		if (mjaStr.hasContent(oldvalue)) {
			String auxs=oldvalue.replace(';',' ');
			Attribute[] aa=Attribute.parse(auxs);
			if (aa!=null && aa.length>0 &&attrix!=null && attrix.length>0 ) {
				auxs="";
				for (int i=0;i<aa.length;i++) {
					int ix=getAttrIx(attrix,aa[i].name);
					if (ix<0) {
						auxs+=aa[i].name.toLowerCase();
					} else {
						auxs+=data.newName[l][ix];
					}
					auxs+="="+aa[i].value+" ";
				}
			}
			v.addElement(new Attribute(data.newName[l][newpar],auxs));
		}
	}

	private static void addGraphics(Vector cv,Vector gv,int l, int type, String oldValue) {
		String controlstype=data.newName[l][data.type]+"="+data.newName[l][data.c_graphic];
		String[] sa=mjaStr.getElements(oldValue.trim());
		for (int i=0;i<sa.length;i++) {
			StringTokenizer st=new StringTokenizer(sa[i],":");
			String aux=st.nextToken().trim();
			int tipo=Tipo(type,aux);
			String graphstype=data.newName[l][data.type]+"="+data.newName[l][tipo];
			String newgas="";
			if (tipo==data.t_equation) {
				newgas+=data.newName[l][data.expr]+"="+"'"+aux+"'";
			} else {
				newgas+=separateText(l,tipo,aux);
			}
			String controlName="";
			boolean iscontrol=false;
			while (st.hasMoreTokens()) {
				String token=st.nextToken().trim();
				StringTokenizer ast=new StringTokenizer(token,"=");
				if (ast.countTokens()==2) {
					String pname=ast.nextToken().trim();
					String pvalue=ast.nextToken().trim();
					int ix=getAttrIx(gattrix,pname);
					if (iscontrol && ix<0) {
						newgas+=" "+data.newName[l][data.constraint]+"='"+pname+"="+pvalue+"'";
					} else {
						if (data.equals(pname,data.control)) {
							iscontrol=data.isNotFalse(pvalue);
							if (iscontrol) {
								controlName=pvalue;
							} else {
								newgas+=" "+data.newName[l][ix]+"="+pvalue;
							}
						} else {
							newgas+=" "+data.newName[l][ix]+"="+pvalue;
						}
					}
				} else {
					if (data.parseColor(token,null,null)!=null) {
						newgas+=" "+data.newName[l][data.color]+"="+token;
					}
				}
			}
			if (iscontrol) {
				cv.addElement(new Attribute(data.controlPrefix+mjaStr.IntegerToString(cv.size(),2),"id="+controlName+" "+controlstype+" "+newgas));
			} else {
				gv.addElement(new Attribute(data.graphPrefix+mjaStr.IntegerToString(gv.size(),2),graphstype+" "+newgas));
			}
		}
	}

	private static void addAuxiliars(Vector v,int l,String fn,String oldattr) {
		String[] elements=mjaStr.getElements(oldattr);
		for (int j=0; j<elements.length; j++) {
			String str=elements[j].trim();
			StringTokenizer st2=new StringTokenizer(str,":");
			String sn=st2.nextToken().trim();
			String name="", expr="", constant="";
			int es=sn.indexOf("=");
			if (es>0) {
				name=sn.substring(0,es).trim();
				expr=sn.substring(es+1).trim();
			}
			if (st2.hasMoreTokens()) {
				String auxstr=st2.nextToken().trim().toLowerCase();
				if (auxstr.startsWith("constant")) {
					int p=auxstr.indexOf("=");
					if (p>0) {
						constant=auxstr.substring(p+1);
					}
				}
			}
			if (name.length()>0) {
				name+=fn;
				String value="id="+name+" "+data.newName[l][data.expr]+"='"+expr+"'";
				if (constant.length()>0) {
					value+=" "+data.newName[l][data.constant]+"="+constant;
				}
				v.addElement(new Attribute(data.auxPrefix+mjaStr.IntegerToString(v.size(),2),value));
			}
		}
	}

	private static String getNewText(String str) {
		String pstr="";
		String auxstr=new String(str);
		boolean esCadena=false;
		while (auxstr.length()>0){
			String test="";
			if (auxstr.startsWith("'")) {
				esCadena=true;
				auxstr=auxstr.substring(1);
			} else {
				esCadena=false;
			}
			int pos=auxstr.indexOf("'");
			if (pos>=0) {
				test=auxstr.substring(0,pos);
				if (esCadena) {
					auxstr=auxstr.substring(pos+1);
				} else {
					auxstr=auxstr.substring(pos);
				}
			} else {
				test=auxstr; auxstr="";
			}
			if (esCadena) {
				pstr+=test;
			} else {
				test=test.trim();
				if (test.startsWith("+")) {
					test=test.substring(1);
				}
				if (test.endsWith("+")) {
					test=test.substring(0,test.length()-1);
				}
				test=test.trim();
				pstr+="["+test+"]";
			}
		}
		return pstr;
	}

	private static String separateText(int l,int tipo,String s) {
		String seps="";
		int p1=s.indexOf("[");
		int p2=s.lastIndexOf("]");
		if (p1<0||p2<0||p1>=p2) {
			Toolkit.getDefaultToolkit().beep();
			seps+="ERROR";
		} else {
			String expr=s.substring(p1,p2+1);
			String text=s.substring(0,p1)+s.substring(p2+1);
			if (tipo==data.t_arc) {
				StringTokenizer st=new StringTokenizer(expr,"[,]");
				int N=st.countTokens();
				String sx=st.nextToken().trim();
				String sy=st.nextToken().trim();
				seps+=" "+data.newName[l][data.center]+"="+"'["+sx+","+sy+"]'";
				String sr=st.nextToken().trim();
				seps+=" "+data.newName[l][data.radius]+"="+"'"+sr+"'";
				if (N<7) {
					String sa1=st.nextToken().trim();
					seps+=" "+data.newName[l][data.ini]+"="+"'"+sa1+"'";
					String sa2=st.nextToken().trim();
					seps+=" "+data.newName[l][data.end]+"="+"'"+sa1+"+("+sa2+")'";
				} else {
					String sx1=st.nextToken().trim();
					String sy1=st.nextToken().trim();
					seps+=" "+data.newName[l][data.ini]+"="+"'["+sx1+","+sy1+"]'";
					String sx2=st.nextToken().trim();
					String sy2=st.nextToken().trim();
					seps+=" "+data.newName[l][data.end]+"="+"'["+sx2+","+sy2+"]'";
				}
			} else {
				seps+=" "+data.newName[l][data.expr]+"="+"'"+expr+"'";
			}
			if (text.length()>0) {
				seps+=" "+data.newName[l][data.TEXT]+"='"+getNewText(text)+"'";
			}
		}
		return seps;
	}

	private static int Tipo(int type,String str) {
		if (type==data.t_point||type==data.t_segment) {
			StringTokenizer st=new StringTokenizer(str,"[,]");
			if (st.countTokens()>=4) {
				return data.t_segment;
			} else {
				return data.t_point;
			}
		} else {
			return type;
		}
	}

	private static int getAttrIx(int[] attrix,String pname) {
		for (int i=0;i<attrix.length;i++) {
			if (data.equals(pname,attrix[i])) {
				return attrix[i];
			}
		}
		return -1;
	}

	private static int[] battrix={
		data.about,
		data.config,
		data.init,
		data.clear,
	};

	private static int[] cattrix={
		data.BACKGROUND,
		data.NET,
		data.AXES,
		data.TEXT
	};

	private static int[] gattrix={
		data.about,
		data.config,
		data.init,
		data.clear,
		data.BACKGROUND,
		data.NET,
		data.AXES,
		data.TEXT,
		data.editable,
		data.visible,
		data.trace,
		data.background,
		data.arrow,
		data.widthness,
		data.spear,
		data.control,
		data.color,
		data.fill,
		data.fillplus,
		data.fillminus,
		data.decimals,
		data.size,
		data.sequence,
		data.parameter
	};

	private static Attribute getParameter(int l,String str) {
		Attribute a=new Attribute();
		a.name=""; a.value="";
		StringTokenizer st0=new StringTokenizer(str,":,");
		StringTokenizer st1=new StringTokenizer(st0.nextToken().trim()," ='");
		a.name=st1.nextToken();
		a.value+=data.newName[l][data.value]+"="+st1.nextToken();
		String alias=a.name;
		if (data.equals(a.name,data.p_scale)) {
			a.name="escala";
			alias=data.newName[l][data.p_scale];
		} else if (a.name.equalsIgnoreCase("Ox")||(a.name.equalsIgnoreCase("O.x"))) {
			a.name="Ox";
			alias=data.newName[l][data.p_Ox];
		} else if (a.name.equalsIgnoreCase("Oy")||(a.name.equalsIgnoreCase("O.y"))) {
			a.name="Oy";
			alias=data.newName[l][data.p_Oy];
		}
		while (st0.hasMoreTokens()) {
			st1=new StringTokenizer(st0.nextToken().trim()," ='");
			String nam=st1.nextToken();
			String exp=st1.nextToken();
			if (data.equals(nam,data.decimals)||nam.startsWith("p")) {
				a.value+=" "+data.newName[l][data.decimals]+"="+exp;
			} else if (data.equals(nam,data.incr)
				||nam.startsWith("inc")
				||nam.startsWith("d")) {
				a.value+=" "+data.newName[l][data.incr]+"="+exp;
			} else if (data.equals(nam,data.inf)
				||nam.startsWith("i")) {
				a.value+=" "+data.newName[l][data.inf]+"="+exp;
			} else if (data.equals(nam,data.sup)
				||nam.startsWith("s")) {
				a.value+=" "+data.newName[l][data.sup]+"="+exp;
			} else if (data.equals(nam,data.name)
				||nam.startsWith("n")) {
				alias=exp;
			}
		}
		a.value+=" "+data.newName[l][data.name]+"='"+alias+"'";
		return a;
	}

	private static Attribute[] analyze(int l,String param) {
		if (param==null||param.trim().length()==0) {
			return new Attribute[0];
		}
		StringTokenizer st=new StringTokenizer(param,";\n\r\f");
		int N=st.countTokens();
		if (N==0) {
			return null;
		}
		Attribute[] pa=new Attribute[N];
		for (int i=0;i<N;i++) {
			pa[i]=getParameter(l,st.nextToken());
		}
		return pa;
	}

}