/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.editdesc;

/*------------------------------------------------------------*/
/*                           auxEP                            */
/*                          (c) MJA                           */
/*                      Febrero de 2001                       */
/*------------------------------------------------------------*/

import java.awt.*;
import java.awt.event.*;
import com.jla.desc2.util.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.descartes.*;

public class auxEP extends editPanel implements ItemListener {

	private int L;
	private TextField tf_name;
	private Checkbox chb_usealg,chb_once,chb_always;
	private TextArea arrayTA;
	private Label lb_eval;
	private mjaPair pr_vid,pr_length,pr_expr,pr_range;
	private Panel NP,CP,exprP,evalP,rangeP,scndP;
	private algEP Palg;
	private CardLayout CLN,CLscnd;
	private static final String paux="aux",parray="array",palg="alg",pempty="empty",peval="eval",prange="range";
	private int type;

	public auxEP() {
		setLayout(new BorderLayout());
		add("North",NP=new Panel());
		add("Center",CP=new Panel());
		tf_name=new TextField(8);
		tf_name.setFont(mjaGui.Courier);
		pr_expr=new mjaPair(32);
		exprP=mjaGui.pair(0.2,0.8,tf_name,pr_expr);
		CheckboxGroup chbg=new CheckboxGroup();
		chb_once=new Checkbox("",chbg,true);
		chb_always=new Checkbox("",chbg,false);
		lb_eval=new Label();
		lb_eval.setAlignment(Label.CENTER);
		evalP=mjaGui.flow(FlowLayout.LEFT,5,0,mjaGui.pair(0,1,lb_eval,mjaGui.pair(chb_once,chb_always)));
		Palg=new algEP();
		evalP.add(Palg.pr_id);
		chb_usealg=new Checkbox();
		chb_usealg.addItemListener(this);
		pr_range=new mjaPair(8);
		rangeP=mjaGui.pair(0.9,0.1,pr_range,chb_usealg);
		scndP=new Panel();
		scndP.setLayout(CLscnd=new CardLayout());
		scndP.add(peval,evalP);
		scndP.add(prange,rangeP);
		scndP.add(pempty,new Panel());
		pr_length=new mjaPair(0.5,0.5,8);
		arrayTA=new TextArea(3,20);
		arrayTA.setFont(mjaGui.Courier);
		Panel Parray=new Panel();
		Parray.setLayout(new BorderLayout());
		pr_vid=new mjaPair(0.5,0.5,8);
		Parray.add("North",mjaGui.pair(0.5,0.5,pr_vid,pr_length));
		Parray.add("Center",arrayTA);
		NP.setLayout(CLN=new CardLayout());
		NP.add(pempty,new Panel());
		NP.add(palg,Palg);
		NP.add(parray,Parray);
		CP.setLayout(new GridLayout(2,1));
		CP.add(exprP);
		CP.add(scndP);
	}

	public editObject newObject(String stype,String svalue) {
		return new auxConfig(L,svalue,data.getIndex(data.auxix,L,stype,data.var));
	}

	public void setInfo(int L,editObject eO) {
		this.L=L;
		evalP.setVisible(false);
		chb_usealg.setVisible(false);
		chb_usealg.setLabel(data.newName[L][data.alg]);
		chb_once.setLabel(data.newName[L][data.once]);
		chb_always.setLabel(data.newName[L][data.always]);
		lb_eval.setText(data.newName[L][data.evaluate]);
		Palg.setLabels(data.newName[L][data.ini],data.newName[L][data.doWord],data.newName[L][data.whileWord]);
		boolean isac=(eO!=null && eO instanceof auxConfig);
		auxConfig ac=null;
		if (isac) {
			ac=(auxConfig) eO;
		} else {
			ac=new auxConfig(L,"",data.var);
		}
		type=ac.type;
		if (ac.evOnce) {
			chb_once.setState(true);
		} else {
			chb_always.setState(true);
		}
		tf_name.setText(ac.name);
		pr_expr.setInfo("=",ac.expr);
		Palg.setInfo(ac.name,ac.s_ini,ac.s_do,ac.s_while);
		if (ac.type==data.alg) {
			Palg.pr_id.setVisible(true);
			exprP.setVisible(false);
			CLN.show(NP,palg);
			CLscnd.show(scndP,peval);
		} else if (ac.type==data.array) {
			Palg.pr_id.setVisible(false);
			pr_vid.setInfo("id",ac.name);
			pr_length.setInfo(data.newName[L][data.size],ac.s_size);
			exprP.setVisible(false);
			arrayTA.setText(mjaStr.replace(ac.expr,";","\n"));
			CLN.show(NP,parray);
			CLscnd.show(scndP,peval);
//			CLscnd.show(scndP,pempty);
		} else {
			Palg.pr_id.setVisible(false);
			exprP.setVisible(true);
			if (ac.type==data.constant) {
				CLN.show(NP,pempty);
				CLscnd.show(scndP,peval);
			} else if (ac.type==data.func) {
				CLscnd.show(scndP,prange);
				pr_range.setInfo(data.newName[L][data.range],ac.range);
				pr_range.setVisible(true);
				chb_usealg.setVisible(true);
				chb_usealg.setState(ac.hasAlg);
				if (ac.hasAlg) {
					CLN.show(NP,palg);
				} else {
					CLN.show(NP,pempty);
				}
			} else /* if (type==data.var)*/ {
				CLN.show(NP,pempty);
				CLscnd.show(scndP,pempty);
			}
		}
		tf_name.setEnabled(isac);
		pr_expr.setEnabled(isac);
		chb_usealg.setEnabled(isac);
		chb_once.setEnabled(isac);
		chb_always.setEnabled(isac);
		Palg.setEnabled(isac);
		paintAll(getGraphics());
	}

	public editObject getInfo() {
		auxConfig ac=new auxConfig(L,tf_name.getText().trim(),type);
		ac.expr=pr_expr.getInfo().trim();
		ac.range=pr_range.getInfo();
		ac.evOnce=chb_once.getState();
		if (type==data.alg) {
			ac.name=Palg.pr_id.getInfo();
			ac.s_ini=Palg.getIni();
			ac.s_do=Palg.getDo();
			ac.s_while=Palg.getWhile();
		} else if (type==data.func) {
			ac.hasAlg=chb_usealg.getState();
			if (ac.hasAlg) {
				ac.s_ini=Palg.getIni();
				ac.s_do=Palg.getDo();
				ac.s_while=Palg.getWhile();
			}
		} else if (type==data.array) {
			ac.s_size=pr_length.getInfo();
			String arrcode=arrayTA.getText();
			String oldvname=ac.name;
			ac.name=pr_vid.getInfo();
			if (!ac.name.equals(oldvname)) {
				arrcode=mjaStr.replace(arrcode,oldvname+"[",ac.name+"[");
			}
			ac.expr=mjaStr.replace(arrcode,"\n",";");
		}
		ac.resetId(L);
		return ac;
	}

	public void itemStateChanged(ItemEvent e) {
		if (type==data.func && e.getSource()==chb_usealg) {
			if (chb_usealg.getState()) {
				CLN.show(NP,palg);
			} else {
				CLN.show(NP,pempty);
			}
			paintAll(getGraphics());
		}
	}

}