/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.editdesc;

/*------------------------------------------------------------*/
/*                         configEdit                         */
/*                          (c) MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/

import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
//import java.awt.datatransfer.*;
import java.util.*;
import java.applet.*;
import com.jla.desc2.util.*;
import com.jla.desc2.parser.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.descartes.*;

public class configEdit extends editFrame implements ActionListener, ItemListener {

	private static final String titleBase=" Nippe.Descartes.";
	private Descartes D;
	private config cfga;
	private Panel NP, CP, SpceP,AnimP,codeP;
	private Choice chl;
	private Button b_original,b_undo,b_redo,b_new,b_applet,b_apply; //b_save;
	private Button[] b_c;
	private Label lb_bg, albl;
	private CheckboxGroup chbpg;
	private Checkbox [] b_cbx, chkbx, chbp;
	private Checkbox chb_x,chb_y;
	private TextField tf_x,tf_y;
	private TextArea TA;
	private mjaPair pr_name,pr_codebase,pr_width,pr_height;
	private Checkbox chb_numbers,chb_loop,chb_auto,chb_controls;
	private codeEdit coed;
	private controlEP epP;
	private auxEP eaP;
	private graphEP egP;
	private controlEL CtrlP;
	private auxEL AuxsP;
	private graphEL GrphP;
	private editColorDialog ecd;
	private Checkbox chb_anim;
	private Label lb_ms;
	private mjaPair pr_delay;
	private algEP eanimP;
	private Dimension dim;
	private String nombre;
	private String codebase;

	public configEdit(Descartes D) {
		super(titleBase,"","","");
		this.D=D;
		cfga=D.cfg.cloneConfig();
		setFont(mjaGui.Arial);
		chl=new Choice();
		chl.setFont(mjaGui.Courier);
		chl.addItemListener(this);
		b_original=new Button();
		b_new=new Button();
		b_undo=new Button();
		b_undo.setEnabled(false);
		b_redo=new Button();
		b_redo.setEnabled(false);
		b_applet=new Button();
		b_original.addActionListener(this);
		b_undo.addActionListener(this);
		b_redo.addActionListener(this);
		b_new.addActionListener(this);
		b_applet.addActionListener(this);
		chbpg=new CheckboxGroup();
		chbp=new Checkbox[5];
		for (int i=0;i<chbp.length;i++) {
			chbp[i]=new Checkbox("",chbpg,i==0);
			chbp[i].addItemListener(this);
		}
		chkbx=new Checkbox[4];
		for (int i=0;i<chkbx.length;i++) {
			chkbx[i]=new Checkbox("");
		}
		b_c=new Button[config.DC0.length];
		b_cbx=new Checkbox[config.DC0.length];
		for (int i=0;i<config.DC0.length;i++) {
			b_c[i]=new Button(graphEP.blankColorLabel);
			b_c[i].setBackground(config.DC0[i]);
			b_c[i].addActionListener(this);
			b_cbx[i]=new Checkbox();
			b_cbx[i].addItemListener(this);
		}
		lb_bg=new Label();
		lb_bg.setAlignment(Label.LEFT);
		chb_numbers=new Checkbox();
		chb_x=new Checkbox(); tf_x=new TextField(8);
		chb_y=new Checkbox(); tf_y=new TextField(8);
		chb_x.addItemListener(this);
		chb_y.addItemListener(this);
		add("North",NP=new Panel());
		constructNP();

		SpceP=new Panel();
		SpceP.setBackground(editList.Color_1);
		epP=new controlEP(this);
		eaP=new auxEP();
		egP=new graphEP(this);
		CtrlP=new controlEL(this,epP);
		AuxsP=new auxEL(this,eaP);
		GrphP=new graphEL(this,egP);
		CtrlP.addActionListener(this);
		AuxsP.addActionListener(this);
		GrphP.addActionListener(this);
		AnimP=new Panel();
		AnimP.setBackground(editList.Color_1);
		chb_anim=new Checkbox();
		chb_anim.addItemListener(this);
		pr_delay=new mjaPair(2);
		lb_ms=new Label("ms");
		lb_ms.setAlignment(Label.CENTER);
		eanimP=new algEP();
		chb_loop=new Checkbox();
		chb_auto=new Checkbox();
		chb_controls=new Checkbox();

		b_apply=new Button();
		b_apply.addActionListener(this);
/*
		b_save=new Button("publicar");
		b_save.addActionListener(this);
		addExtraButton(b_save);
*/
		pr_name=new mjaPair(8);
		pr_codebase=new mjaPair(8);
		pr_width=new mjaPair(4);
		pr_height=new mjaPair(4);
		dim=new Dimension(D.getSize().width,D.getSize().height);
		nombre=D.cfg.name;
		codebase=getReducedCodeBase(D);
		setControlsFromParams();
		TA=new TextArea(24,80);
		TA.setFont(mjaGui.Courier);
		albl=new Label();
		albl.setAlignment(albl.CENTER);
		albl.setBackground(Color.lightGray);
		constructCodeP();

		add("Center",CP=new Panel());
		constructCP();
	}

	private void constructNP() {
		Panel NP1=new Panel(); NP1.setLayout(new GridLayout(1,2));
		NP1.add(chl);
		NP1.add(mjaGui.pair(b_undo,b_redo));
		NP1.add(mjaGui.pair(b_original,b_new));
		NP1.add(b_applet);
		Panel NPchbp=new Panel();
		NPchbp.setLayout(new GridLayout(1,chbp.length));
		for (int i=0;i<chbp.length;i++) {
			NPchbp.add(chbp[i]);
		}
		NP.setLayout(new GridLayout(2,1));
		NP.add(NP1);NP.add(NPchbp);
	}


	private void constructSpceP() {
		SpceP.removeAll();
		SpceP.setLayout(new BorderLayout());
		Panel P=new Panel();
		SpceP.add("North",P);
		P.setLayout(new GridBagLayout());
		GridBagConstraints gbc= new GridBagConstraints();
		gbc.fill=GridBagConstraints.BOTH;
		gbc.anchor=GridBagConstraints.NORTH;
		gbc.weightx=1;
		gbc.gridy=0; gbc.gridx=0;
		P.add(mjaGui.pair(0,1,b_c[0],lb_bg),gbc);	gbc.gridx++;
		P.add(mjaGui.pair(mjaGui.pair(0,1,b_c[1],b_cbx[1]),mjaGui.pair(0,1,b_c[2],b_cbx[2])),gbc);	gbc.gridx++;
		for (int i=3;i<b_c.length;i++) {
			P.add(mjaGui.pair(0,1,b_c[i],b_cbx[i]),gbc);gbc.gridx++;
		}
		P.add(new Label()); gbc.gridx++;
		P.add(new Label()); gbc.gridx++;
		gbc.gridy=1; gbc.gridx=0;
		P.add(chb_numbers,gbc);gbc.gridx++;
		P.add(mjaGui.pair(0.2,0.8,chb_x,tf_x),gbc);gbc.gridx++;
		P.add(mjaGui.pair(0.2,0.8,chb_y,tf_y),gbc);gbc.gridx++;
		gbc.gridy=2; gbc.gridx=0;
		for (int i=0;i<chkbx.length;i++) {
			P.add(chkbx[i],gbc); gbc.gridx++;
		}
	}

	private void constructCodeP() {
		codeP=new Panel();
		codeP.setBackground(Color.lightGray);
		codeP.setLayout(new BorderLayout());
		Panel NP=new Panel();
		NP.setBackground(Color.lightGray);
		NP.setLayout(new GridLayout(1,2));
		NP.add(mjaGui.pair(pr_name,pr_codebase));
		NP.add(mjaGui.pair(5,1,mjaGui.pair(pr_width,pr_height),b_apply));
		codeP.add("North",NP);
		Panel TAP=new Panel();
		codeP.add("Center",TAP);
		TAP.setLayout(new BorderLayout());
		TAP.add("Center",TA);
		TAP.add("South",albl);
	}

	private void constructAnimP() {
		AnimP.removeAll();
		AnimP.setLayout(new BorderLayout());
		AnimP.add("Center",eanimP);
		Panel P0=new Panel();
		P0.setLayout(new BorderLayout());
		Panel P=new Panel();
		P0.add("North",P);
		P.setLayout(new GridLayout(5,1,0,2));
		P.add(chb_anim);
		P.add(mjaGui.pair(1,0,pr_delay,lb_ms));
		P.add(chb_controls);
		P.add(chb_auto);
		P.add(chb_loop);
		AnimP.add("West",P0);
	}

	private CardLayout cL;
	private String[] CPid = {"0","1","2","3","4"};

	private void constructCP() {
		CP.setLayout(cL=new CardLayout());
		constructSpceP();
		constructAnimP();
		CP.add(SpceP,CPid[0]);
		CP.add(CtrlP,CPid[1]);
		CP.add(AuxsP,CPid[2]);
		CP.add(GrphP,CPid[3]);
		CP.add(AnimP,CPid[4]);
		for (int i=0;i<chbp.length;i++) {
			if (chbp[i].getState()) {
				cL.show(CP,CPid[i]);
				break;
			}
		}
	}

	public String getAppliedCode(Descartes D) {
		return toAppletString(D,dim,D.cfg.toAppletParams());
	}

	public static String toAppletString(Descartes D) {
		return toAppletString(D,D.getSize(),D.cfg.toAppletParams());
	}

	public static String toAppletString(Applet A,Dimension d,Attribute[] aa) {
		return toAppletString(aa,getReducedCodeBase(A),
			Integer.toString(d.width),Integer.toString(d.height));
	}

	static final String noJavaDesc="<font face=\"Arial\" size=\"3\">Esta unidad interactiva requiere la m&aacute;quina virtual de Java <a href=\"http://java.com/\" target=\"_blank\">JAVA</a>.</font>";

	public static String toAppletString(Attribute[] aa,String codebase,String s_width,String s_height) {
		String s="<applet";
		String nom=data.getValue(data.nolang,aa,data.name);
		if (mjaStr.hasContent(nom)) {
			s+=" name=\""+nom+"\"";
		}
		s+=" width="+s_width+" height="+s_height+" code=\"Descartes.class\">\n";

		boolean installed=false;
		boolean in_not_installed_version=false;

		s+="code=\"Descartes.class\">\n";
		String program="Descartes2";
		s+="   <param name=\"jnlp_href\" value=\"_jnlp_path_lib/"+program+".jnlp\">\n";

		for (int j=0;j<aa.length;j++) {
			s+="   <param name=\""+aa[j].name+"\" value=\""+aa[j].value+"\">\n";
		}

		s=s+noJavaDesc+"\n";

		s=s+"</applet>\n";
		return s;
	}

	public static String getReducedCodeBase(Applet A) {
		return "./";
//		String docbase=A.getDocumentBase().toExternalForm();
//		docbase=docbase.substring(0,docbase.lastIndexOf('/')+1);
//		String codebase=A.getCodeBase().toExternalForm();
//		if (docbase.equals(codebase)) {
//			codebase="./";
//		} else if (codebase.startsWith(docbase)) {
//			codebase=codebase.substring(docbase.length());
//		} else if (docbase.startsWith(codebase)) {
//			docbase=docbase.substring(0,docbase.lastIndexOf('/'));
//			if (codebase.lastIndexOf('/')>0) {
//				codebase=codebase.substring(0,codebase.lastIndexOf('/'));
//			}
//			String cb="";
//			while (docbase.length()>codebase.length()) {
//				docbase=docbase.substring(0,docbase.lastIndexOf('/'));
//				cb+="./";
//			}
//			codebase=cb;
//		}
//		return codebase;
	}

	private void getInfo() {
		for (int i=0;i<b_c.length;i++) {
			D.cfg.color[i]=b_c[i].getBackground();
			if (i>0) {
				D.cfg.isOn[i]=b_cbx[i].getState();
			}
		}
		for (int i=0;i<D.cfg.buttonVisible.length;i++) {
			D.cfg.buttonVisible[i]=chkbx[i].getState();
		}
		D.cfg.language=data.getLanguage(chl.getSelectedItem());
		D.cfg.numbers=chb_numbers.getState();
		D.cfg.x_On=chb_x.getState();
		D.cfg.x_axis=tf_x.getText();
		D.cfg.y_On=chb_y.getState();
		D.cfg.y_axis=tf_y.getText();
		editObject[] eoa=CtrlP.getInfo();
		D.cfg.cc=new controlConfig[eoa.length];
		for (int i=0;i<eoa.length;i++) {
			D.cfg.cc[i]=(controlConfig)eoa[i];
		}
		eoa=AuxsP.getInfo();
		D.cfg.auxiliar=new auxConfig[eoa.length];
		for (int i=0;i<eoa.length;i++) {
			D.cfg.auxiliar[i]=(auxConfig)eoa[i];
		}
		eoa=GrphP.getInfo();
		D.cfg.gc=new graphConfig[eoa.length];
		for (int i=0;i<eoa.length;i++) {
			D.cfg.gc[i]=(graphConfig)eoa[i];
		}
		D.cfg.animCfg=(auxConfig) eanimP.getInfo();
		D.cfg.animCfg.active=chb_anim.getState();
		D.cfg.animCfg.s_delay=pr_delay.getInfo();
		D.cfg.animCfg.autorun=chb_auto.getState();
		D.cfg.animCfg.loop=chb_loop.getState();
		D.cfg.animCfg.controls=chb_controls.getState();
	}

	public void setInfo() {
		setTitle(titleBase+D.cfg.name);
		chbp[0].setLabel(data.newName[D.cfg.language][data.p_space]);
		chbp[1].setLabel(data.newName[D.cfg.language][data.p_controls]);
		chbp[2].setLabel(data.newName[D.cfg.language][data.p_auxiliaries]);
		chbp[3].setLabel(data.newName[D.cfg.language][data.p_graphics]);
		chbp[4].setLabel(data.newName[D.cfg.language][data.p_anim]);
		lb_bg.setText(data.newName[D.cfg.language][data.BACKGROUND]);
		for (int i=0;i<b_c.length;i++) {
			b_c[i].setBackground(D.cfg.color[i]);
			if (i>0) {
				b_cbx[i].setLabel(data.newName[D.cfg.language][data.BACKGROUND+i]);
				b_cbx[i].setState(D.cfg.isOn[i]);
			}
		}
		chkbx[0].setLabel(data.newName[D.cfg.language][data.about]);
		chkbx[0].setState(D.cfg.buttonVisible[0]);
		chkbx[1].setLabel(data.newName[D.cfg.language][data.config]);
		chkbx[1].setState(D.cfg.buttonVisible[1]);
		chkbx[2].setLabel(data.newName[D.cfg.language][data.init]);
		chkbx[2].setState(D.cfg.buttonVisible[2]);
		chkbx[3].setLabel(data.newName[D.cfg.language][data.clear]);
		chkbx[3].setState(D.cfg.buttonVisible[3]);
		setLabels(data.newName[D.cfg.language][data.accept],data.newName[D.cfg.language][data.close],data.newName[D.cfg.language][data.apply]);
		chl.removeAll();
		for (int i=0;i<data.numLang ;i++) {
			chl.addItem(data.newName[i][data.langName]);
		}
		chl.select(data.newName[D.cfg.language][data.langName]);
		b_original.setLabel(data.newName[D.cfg.language][data.original]);
		b_undo.setLabel(data.newName[D.cfg.language][data.undo]);
		b_redo.setLabel(data.newName[D.cfg.language][data.redo]);
		b_new.setLabel(data.newName[D.cfg.language][data.newcfg]);
		b_applet.setLabel(data.newName[D.cfg.language][data.appletc]);
		chb_numbers.setLabel(data.newName[D.cfg.language][data.numbers]);
		chb_numbers.setState(D.cfg.numbers);
		chb_x.setLabel(data.newName[D.cfg.language][data.x_axis]);
		chb_x.setState(D.cfg.x_On);
		tf_x.setText(D.cfg.x_axis);
		tf_x.setEnabled(chb_x.getState());
		chb_y.setLabel(data.newName[D.cfg.language][data.y_axis]);
		chb_y.setState(D.cfg.y_On);
		tf_y.setText(D.cfg.y_axis);
		tf_y.setEnabled(chb_y.getState());
		String oklbl=data.newName[D.cfg.language][data.accept];
		String calbl=data.newName[D.cfg.language][data.cancel];
		String aplbl=data.newName[D.cfg.language][data.apply];
		CtrlP.setInfo(D.cfg.language,D.cfg.cc);
		CtrlP.setLabels(oklbl,calbl,aplbl);
		AuxsP.setInfo(D.cfg.language,D.cfg.auxiliar);
		AuxsP.setLabels(oklbl,calbl,aplbl);
		GrphP.setInfo(D.cfg.language,D.cfg.gc);
		GrphP.setLabels(oklbl,calbl,aplbl);
		chb_anim.setLabel(data.newName[D.cfg.language][data.p_anim]);
		pr_delay.setInfo(data.newName[D.cfg.language][data.delay],D.cfg.animCfg.s_delay);
		eanimP.setInfo(D.cfg.language,D.cfg.animCfg);
		eanimP.setLabels(data.newName[D.cfg.language][data.ini],data.newName[D.cfg.language][data.doWord],data.newName[D.cfg.language][data.whileWord]);
		chb_anim.setState(D.cfg.animCfg.active);
		chb_auto.setLabel(data.newName[D.cfg.language][data.auto]);
		chb_auto.setState(D.cfg.animCfg.autorun);
		chb_loop.setLabel(data.newName[D.cfg.language][data.loop]);
		chb_loop.setState(D.cfg.animCfg.loop);
		chb_controls.setLabel(data.newName[D.cfg.language][data.controls]);
		chb_controls.setState(D.cfg.animCfg.controls);
		editAnimEnable(chb_anim.getState());
		pr_name.setInfo(data.newName[D.cfg.language][data.name],nombre);
		pr_codebase.setInfo("codebase",codebase);

//		dim=new Dimension(D.getSize().width,D.getSize().height);
//		resetDimControls();

		b_apply.setLabel(data.newName[D.cfg.language][data.apply]);
		albl.setText(data.newName[D.cfg.language][data.textapplet]);
		TA.setText(toAppletString(D));
		if (coed!=null) {
			coed.setTitle(D.cfg.name);
		}
//		repaint();
	}

	private void editAnimEnable(boolean v) {
		eanimP.setEnabled(v);
		pr_delay.setEnabled(v);
		chb_auto.setEnabled(v);
		chb_loop.setEnabled(v);
		chb_controls.setEnabled(v);
	}

	void setControlsFromParams() {
		pr_width.setInfo("width",String.valueOf(dim.width));
		pr_height.setInfo("height",String.valueOf(dim.height));
		pr_name.setInfo(data.newName[D.cfg.language][data.name],nombre);
		pr_codebase.setInfo("codebase",codebase);
	}

	private void setParamsFromControls() {
		try {
			dim.width=Integer.parseInt(pr_width.getInfo().trim());
			dim.height=Integer.parseInt(pr_height.getInfo().trim());
			nombre=pr_name.getInfo();
			codebase=pr_codebase.getInfo();
		} catch (NumberFormatException nfe) {
		}
	}

	public Dimension getProposedDimension() {
		return dim;
	}

	private void selectAll() {
/*
		try {
			StringSelection ss=new StringSelection(TA.getText());
			getToolkit().getSystemClipboard().setContents(ss,ss);
//			Transferable t=getToolkit().getSystemClipboard().getContents(this);
//			System.out.println((String)t.getTransferData(DataFlavor.stringFlavor));
		} catch (Exception ex) {
			System.out.println(ex);
		}
*/
		TA.setSelectionStart(0);
		TA.setSelectionEnd(TA.getText().length());
		TA.requestFocus();
	}

	private void showAppletText() {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		TA.setText(toAppletString(D));
		if (coed==null) {
			coed=new codeEdit(this);
			coed.add("Center",codeP);
			coed.pack();
		} else {
			coed.setVisible(false);
		}
		coed.setTitle(D.cfg.name);
		coed.setVisible(true);
		coed.toFront();
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		selectAll();
	}

	private Vector undo=new Vector();
	private volatile int undo_ix=0;

	private void pushConfig(boolean apply) {
		config pcfg=D.cfg.cloneConfig();
		if (undo.size()==0) {
			pcfg.applied=true;
			undo.addElement(pcfg);
		}
		getInfo();
		if (!toAppletString(D,dim,pcfg.toAppletParams()).equals(toAppletString(D,dim,D.cfg.toAppletParams()))) {
			undo.addElement(D.cfg.cloneConfig());
			b_redo.setEnabled(false);
			b_undo.setEnabled(true);
			undo_ix=undo.size()-1;
		}
		if (apply) {
			((config) undo.elementAt(undo_ix)).applied=true;
		}
	}

	public void closingAction(boolean close,boolean apply) {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		if (apply) {
			cfga=D.cfg.cloneConfig();
			dim=getProposedDimension();
		} else {
			pr_width.setInfo("width",String.valueOf(dim.width));
			pr_height.setInfo("height",String.valueOf(dim.height));
		}
		if (close) {
//			pushConfig(true);  cambiado a apply en 2005-05-26  ver 2.458
			pushConfig(apply);
			if (apply) {
				D.configApplied();
			}
		} else if (apply) {
			pushConfig(false);
		}
		if (apply) {
			D.reset(close,true);
		}
		setCursor(null);
	}



/*
    public static String getEncoding(String value){

		StringBuffer sb=new StringBuffer();
		for (int i=0; i<value.length(); i++) {
			char ch = value.charAt(i);
			switch (ch) {
			case '\u00A1' : sb.append("&iexcl;"); break;
			case '\u00A2' : sb.append("&cent;"); break;
			case '\u00A3' : sb.append("&pound;"); break;
			case '\u00A4' : sb.append("&curren;"); break;
			case '\u00A5' : sb.append("&yen;"); break;
			case '\u00A6' : sb.append("&brvbar;"); break;
			case '\u00A7' : sb.append("&sect;"); break;
			case '\u00A8' : sb.append("&uml;"); break;
			case '\u00A9' : sb.append("&copy;"); break;
			case '\u00AA' : sb.append("&ordf;"); break;
			case '\u00AB' : sb.append("&laquo;"); break;
			case '\u00AC' : sb.append("&not;"); break;
			case '\u00AD' : sb.append("&shy;"); break;
			case '\u00AE' : sb.append("&reg;"); break;
			case '\u00AF' : sb.append("&macr;"); break;
			case '\u00B0' : sb.append("&deg;"); break;
			case '\u00B1' : sb.append("&plusmn;"); break;
			case '\u00B2' : sb.append("&sup2;"); break;
			case '\u00B3' : sb.append("&sup3;"); break;
			case '\u00B4' : sb.append("&acute;"); break;
			case '\u00B5' : sb.append("&micro;"); break;
			case '\u00B6' : sb.append("&para;"); break;
			case '\u00B7' : sb.append("&middot;"); break;
			case '\u00B8' : sb.append("&cedil;"); break;
			case '\u00B9' : sb.append("&sup1;"); break;
			case '\u00BA' : sb.append("&ordm;"); break;
			case '\u00BB' : sb.append("&raquo;"); break;
			case '\u00BC' : sb.append("&frac14;"); break;
			case '\u00BD' : sb.append("&frac12;"); break;
			case '\u00BE' : sb.append("&frac34;"); break;
			case '\u00BF' : sb.append("&iquest;"); break;
			case '\u00C0' : sb.append("&Agrave;"); break;
			case '\u00C1' : sb.append("&Aacute;"); break;
			case '\u00C2' : sb.append("&Acirc;"); break;
			case '\u00C3' : sb.append("&Atilde;"); break;
			case '\u00C4' : sb.append("&Auml;"); break;
			case '\u00C5' : sb.append("&Aring;"); break;
			case '\u00C6' : sb.append("&AElig;"); break;
			case '\u00C7' : sb.append("&Ccedil;"); break;
			case '\u00C8' : sb.append("&Egrave;"); break;
			case '\u00C9' : sb.append("&Eacute;"); break;
			case '\u00CA' : sb.append("&Ecirc;"); break;
			case '\u00CB' : sb.append("&Euml;"); break;
			case '\u00CC' : sb.append("&Igrave;"); break;
			case '\u00CD' : sb.append("&Iacute;"); break;
			case '\u00CE' : sb.append("&Icirc;"); break;
			case '\u00CF' : sb.append("&Iuml;"); break;
			case '\u00D0' : sb.append("&ETH;"); break;
			case '\u00D1' : sb.append("&Ntilde;"); break;
			case '\u00D2' : sb.append("&Ograve;"); break;
			case '\u00D3' : sb.append("&Oacute;"); break;
			case '\u00D4' : sb.append("&Ocirc;"); break;
			case '\u00D5' : sb.append("&Otilde;"); break;
			case '\u00D6' : sb.append("&Ouml;"); break;
			case '\u00D7' : sb.append("&times;"); break;
			case '\u00D8' : sb.append("&Oslash;"); break;
			case '\u00D9' : sb.append("&Ugrave;"); break;
			case '\u00DA' : sb.append("&Uacute;"); break;
			case '\u00DB' : sb.append("&Ucirc;"); break;
			case '\u00DC' : sb.append("&Uuml;"); break;
			case '\u00DD' : sb.append("&Yacute;"); break;
			case '\u00DE' : sb.append("&THORN;"); break;
			case '\u00DF' : sb.append("&szlig;"); break;
			case '\u00E0' : sb.append("&agrave;"); break;
			case '\u00E1' : sb.append("&aacute;"); break;
			case '\u00E2' : sb.append("&acirc;"); break;
			case '\u00E3' : sb.append("&atilde;"); break;
			case '\u00E4' : sb.append("&auml;"); break;
			case '\u00E5' : sb.append("&aring;"); break;
			case '\u00E6' : sb.append("&aelig;"); break;
			case '\u00E7' : sb.append("&ccedil;"); break;
			case '\u00E8' : sb.append("&egrave;"); break;
			case '\u00E9' : sb.append("&eacute;"); break;
			case '\u00EA' : sb.append("&ecirc;"); break;
			case '\u00EB' : sb.append("&euml;"); break;
			case '\u00EC' : sb.append("&igrave;"); break;
			case '\u00ED' : sb.append("&iacute;"); break;
			case '\u00EE' : sb.append("&icirc;"); break;
			case '\u00EF' : sb.append("&iuml;"); break;
			case '\u00F0' : sb.append("&eth;"); break;
			case '\u00F1' : sb.append("&ntilde;"); break;
			case '\u00F2' : sb.append("&ograve;"); break;
			case '\u00F3' : sb.append("&oacute;"); break;
			case '\u00F4' : sb.append("&ocirc;"); break;
			case '\u00F5' : sb.append("&otilde;"); break;
			case '\u00F6' : sb.append("&ouml;"); break;
			case '\u00F7' : sb.append("&divide;"); break;
			case '\u00F8' : sb.append("&oslash;"); break;
			case '\u00F9' : sb.append("&ugrave;"); break;
			case '\u00FA' : sb.append("&uacute;"); break;
			case '\u00FB' : sb.append("&ucirc;"); break;
			case '\u00FC' : sb.append("&uuml;"); break;
			case '\u00FD' : sb.append("&yacute;"); break;
			case '\u00FE' : sb.append("&thorn;"); break;
			case '\u00FF' : sb.append("&yuml;"); break;
//			case '"'      :
//			case '<'      :
//			case '>'      : sb.append("&#"+Integer.toHexString(ch)+";"); break;
//			case '\n'     : sb.append("&#x000a;"); break;
			default       : sb.append(ch);
			}
		}
        return new String(sb);
    }

     */
/*
	private static final int default_port=6789;

	private void publish() {
		String base="BancoDeEscenas/";
		String fname=pr_name.getInfo().trim();
		if (fname.length()>0) {
			fname+=".html";
			String HTMLheader="<html>\n<head>\n<title>+fname+</title></head>\n";
			HTMLheader+="<body BGCOLOR=\"#d0d0d0\" onload=\"parent.frames['left'].location.reload(true);\">";
			HTMLheader+="\n<p align=\"center\">\n";
			String info=HTMLheader+
			toAppletString(D.cfg.toAppletParams(),
			pr_codebase.getInfo().trim(),
			pr_width.getInfo().trim(),pr_height.getInfo().trim())+"\n</p>\n</body>\n</html>";
			int port=default_port;
			String login="";
			try {
				Socket s=new Socket(D.getCodeBase().getHost(),port);
//				BufferedReader sin = new BufferedReader(new InputStreamReader(s.getInputStream()));
				PrintStream sout= new PrintStream(s.getOutputStream());
//System.out.println(login+" conectado a: "+s.getInetAddress().getHostName()+":"+s.getPort());
				sout.println(base+" "+fname);
				sout.println("Autores: Jos&eacute; Luis Abreu y Marta Oliver&oacute;");
				sout.println(getEncoding(info));
				sout.println(".");
				sout.flush();
				sout.close();
				// para asegurar que se haya completado la creacin del archivo.
				try {
					readWebPage(D.getCodeBase().getHost(),"abreu/DESCARTES/BancoDeEscenas/"+fname,"center");
					readWebPage(D.getCodeBase().getHost(),"abreu/DESCARTES/BancoDeEscenas/index.html","left");
				} catch (UnknownHostException uhe) {
					System.out.println(uhe);
				} catch (MalformedURLException mue) {
					System.out.println(mue);
				} catch (IOException ioe) {
					System.out.println(ioe);
				} catch (Exception e) {
					System.out.println(e);
				}

				String time=Long.toString(System.currentTimeMillis());
				D.getAppletContext().showDocument(new URL(D.getCodeBase(),base+"index.html?time"),"left");
				D.getAppletContext().showDocument(new URL(D.getCodeBase(),base+fname+"?time="+time),"center");
			} catch (MalformedURLException mue) {
				System.err.println(mue);
			} catch (IOException e) {
				System.err.println(e);
			}
		}
	}
	*/

//	private static void readWebPage(String host,String path,String wname) throws Exception {
  // los navegadores muestran las pginas del cache en lugar de las nuevas.
//		Socket s=new Socket(host,8080);
//		PrintStream sout= new PrintStream(s.getOutputStream());
//		BufferedReader sin = new BufferedReader(new InputStreamReader(s.getInputStream()));
//		sout.println("GET "+path+" HTTP/1.1");
//		sout.println("Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/vnd.ms-excel, application/msword, application/vnd.ms-powerpoint, */*");
//		sout.println("Accept-Language: es-es");
//		sout.println("Accept-Encoding: gzip, deflate");
//		sout.println("User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows 98)");
//		sout.println("Host: localhost:8080");
//		sout.println("Connection: Keep-Alive");
//		sout.println("Cache-Control: no-cache");
//		sout.println("");
//		String line="";
//		do {
//			line=sin.readLine();
//		} while (line.indexOf("</html>")<0);
//		sin.close();
//		sout.close();
//	}

	private void applyInfo(){
		D.cfg.name=pr_name.getInfo().trim();
		setParamsFromControls();
		TA.setText(toAppletString(D.cfg.toAppletParams(),
			pr_codebase.getInfo().trim(),
			pr_width.getInfo().trim(),pr_height.getInfo().trim()));
		if (coed!=null) {
			coed.setTitle(D.cfg.name);
		}
		pushConfig(false);
		selectAll();
	}

	public void actionPerformed(ActionEvent e) {
		pushConfig(false);
		if (e.getSource() instanceof editList) {
			return;
		}
		if (e.getSource()==b_original) {
			D.cfg=D.cfg0.cloneConfig();
			setInfo();
			pushConfig(false);
		} else if (e.getSource()==b_redo) {
			if (undo_ix+1<undo.size()) {
				undo_ix++;
			}
			D.cfg=((config) undo.elementAt(undo_ix)).cloneConfig();
			setInfo();
			if (D.cfg.applied) {
				D.reset(false,true);
			}
			b_undo.setEnabled(true);
			if (undo_ix+1>=undo.size()) {
				b_redo.setEnabled(false);
			}
		} else if (e.getSource()==b_undo) {
			if (undo_ix>0) {
				undo_ix--;
			}
			config auxc0=((config) undo.elementAt(undo_ix)).cloneConfig();
			config auxc=auxc0;
			int i=undo_ix;
			while (!auxc.applied) {
				auxc=((config) undo.elementAt(--i));
			}
			D.cfg=auxc;
			D.reset(false,true);
			D.cfg=auxc0;
			setInfo();
			b_redo.setEnabled(true);
			if (undo_ix==0) {
				b_undo.setEnabled(false);
			}
		} else if (e.getSource()==b_new) {
			D.cfg=new config(data.getLanguage(chl.getSelectedItem()));
			setInfo();
			pushConfig(false);
		} else if (e.getSource()==b_applet) {
			showAppletText();
		} else if (e.getSource()==b_apply) {
			applyInfo();
//		} else if (e.getSource()==b_save) {
//			publish();
		} else {
			for (int i=0;i<b_c.length;i++) {
				if (e.getSource()==b_c[i]) {
					if (ecd==null) {
						ecd=new editColorDialog(this,"",true,"","");
					}
					ecd.setTitle(b_c[i].getLabel());
					int L=data.getLanguage(chl.getSelectedItem());
					ecd.setLabels(data.newName[L][data.accept],data.newName[L][data.cancel]);
					ecd.setCopyLabels(data.newName[L][data.copy],data.newName[L][data.paste]);
					ecd.setColorNames(data.colorName[L]);
					ecd.setColor(b_c[i].getBackground());
					ecd.display();
					if (ecd.ok) {
						b_c[i].setBackground(ecd.getColor());
						b_c[i].setForeground(mjaGui.bestContrast(ecd.getColor()));
						pushConfig(false);
					}
					break;
				}
			}
		}
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource()==chl && e.getStateChange()==e.SELECTED) {
			pushConfig(false);
			setVisible(false);
			setInfo();
			setVisible(true);
		} else if (e.getSource()==chb_anim) {
			pushConfig(false);
			editAnimEnable(chb_anim.getState());
		} else if (e.getSource()==chb_x) {
			pushConfig(false);
			tf_x.setEnabled(chb_x.getState());
		} else if (e.getSource()==chb_y) {
			pushConfig(false);
			tf_y.setEnabled(chb_y.getState());
		} else {
			for (int i=0;i<chbp.length;i++) {
				if (chbp[i].getState()) {
					pushConfig(false);
					cL.show(CP,CPid[i]);
					break;
				}
			}
		}
	}

}

class codeEdit extends Frame {

	private configEdit ce;
	codeEdit(configEdit ce) {
		this.ce=ce;
		setBackground(Color.lightGray);
		setLayout(new BorderLayout());
	}

	public void setTitle(String t) {
		super.setTitle("Applet Descartes "+t);
	}

	public boolean handleEvent(Event e) {
		if (e.id==e.WINDOW_DESTROY) {
			ce.setControlsFromParams();
			setVisible(false);
			return true;
		}
		return false;
	}

}