/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.editdesc;

/*------------------------------------------------------------*/
/*                          editList                          */
/*                          (c) MJA                           */
/*                       Febrero de 2001                      */
/*------------------------------------------------------------*/

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.*;
import java.applet.*;
import com.jla.desc2.util.*;
import com.jla.desc2.parser.*;
import com.jla.desc2.gui.*;
import com.jla.desc2.descartes.*;

public class editList extends Panel implements ActionListener, ItemListener, MouseListener, MouseMotionListener, KeyListener, Runnable  {

	public static final Color Color_1=new Color(0xb0b0b0);
	public static final Color Color_2=new Color(0xa0a0a0);

	protected int L;
	protected editTextField eTF;
	private Vector pV;
	private Label tlbl;
	private java.awt.List pl;
	private Button B_add,B_delete,B_duplicate;
	private spinnerControl sc;
	private editPanel eP;
	private int ix,idw;
	private Frame parent;
	private editFrame ef;
	private TextArea TA;

	public editList(Frame parent,int lh,int idw,editPanel eP,editTextField eTF) {
		this.parent=parent;
		this.idw=idw;
		this.eP=eP;
		this.eTF=eTF;
		setLayout(new BorderLayout());
		tlbl=new Label();
		tlbl.setFont(mjaGui.Arial);
		tlbl.setAlignment(Label.CENTER);
		tlbl.setBackground(new Color(0x000088));
		tlbl.setForeground(Color.white);
		Panel WP=new Panel();
		WP.setBackground(Color_2);
		add("West",WP);
		WP=mjaGui.embedPanel(WP,5);
		WP.setLayout(new BorderLayout());
		WP.setFont(mjaGui.Courier);
		WP.add("Center",pl=new java.awt.List());
		Panel BP=new Panel();
		BP.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		BP.add(B_add=new Button("+"));
		BP.add(B_duplicate=new Button("*"));
		BP.add(sc=new spinnerControl());
		BP.add(B_delete=new Button("-"));
		WP.add("North",mjaGui.pair(BP,tlbl));
		eP.setBackground(Color_1);
		add("Center",eP);
		ef=new editFrame("title","ok","cancel","apply");
		ef.setSize(600,400);
		ef.add("Center",TA=new TextArea(20,80));
		TA.setFont(mjaGui.Courier);
		ef.addActionListener(this);

		B_add.addActionListener(this);
		B_duplicate.addActionListener(this);
		B_delete.addActionListener(this);
		sc.addMouseListener(this);
		sc.addMouseMotionListener(this);
		tlbl.addMouseListener(this);
		pl.addKeyListener(this);
		pl.addItemListener(this);
	}

	public void setTitle(String t) {
		tlbl.setText(t);
		ef.setTitle(t);
	}
	public void setLabels(String okLabel, String cancelLabel,String applyLabel) {
		ef.setLabels(okLabel,cancelLabel,applyLabel);
	}

	private String prepareItem(editObject eO) {
		return mjaStr.justify(eO.getId(),idw,' ');
	}

	public void addElement(editObject eo) {
		eo.resetId(L);
		pV.addElement(eo);
		pl.removeItemListener(this);
		pl.add(prepareItem(eo));
		pl.addItemListener(this);
	}

	public void setInfo(String s) {
	}

	public void setInfo(int L,editObject[] pca) {
		this.L=L;
		pl.removeItemListener(this);
		pl.removeAll();
		pl.addItemListener(this);
		pV=new Vector();
		if (pca!=null) {
			for (int i=0;i<pca.length;i++) {
				addElement(pca[i]);
			}
		}
		pl.removeItemListener(this);
		pl.select(0);
		pl.addItemListener(this);
		ix=pl.getSelectedIndex();
		eP.setInfo(L,pV(ix));
		eP.paintAll(eP.getGraphics());
	}

	public editObject[] getInfo() {
		updateList(ix,ix);
		editObject[] pca=new editObject[pV.size()];
		for (int i=0;i<pV.size();i++) {
			pca[i]=pV(i);
		}
		return pca;
	}

	editObject pV(int i) {
		if (i>=0 && i<pV.size()) {
			return (editObject) pV.elementAt(i);
		} else {
			return null;
		}
	}

	boolean validNewName(boolean creating,String s) {
		if (mjaStr.hasContent(s)) {
			for (int i=0;i<pV.size();i++) {
				if ((creating||i!=ix) && s.equals(pV(i).getId())) {
					return false;
				}
			}
			return true;
		} else {
			return false;
		}
	}

	protected editObject addnew(boolean duplicate) {
		editObject pc=null;
		eTF.setDefaultValue(pl.getItemCount()+1);
		boolean copy=duplicate&&pl.getItemCount()>0;
		if (copy) {
			eTF.showTypes(false);
			pc=eP.getInfo();
			eTF.setValue(pc.getName());
		} else {
			eTF.showTypes(true);
		}
		boolean ok=true;
		if (!copy||eTF.showsValue()) {
			eTF.display();
			ok=eTF.ok;
		}
		if (ok) {
			if (validNewName(true,eTF.getValue())) {
				if (ix>=0 && ix<pV.size()) {
					pV.setElementAt(eP.getInfo(),ix);
				}
				if (copy) {
					pc.setName(eTF.getValue().trim());
					pc.resetId(L);
				} else {
					pc=eP.newObject(eTF.getTextFieldType(),eTF.getValue().trim());
				}
				pV.addElement(pc);
				ix=pV.size()-1;
				eP.setInfo(L,pV(ix));
				eP.paintAll(eP.getGraphics());
				pl.removeItemListener(this);
				pl.add(prepareItem(pV(ix)),ix);
				pl.select(ix);
				pl.addItemListener(this);
			}
		}
		return pc;
	}

	private void delete() {
		if (ix>=0) {
			if (mjaGui.ask(parent,"Descartes"," Eliminar: "+ pl.getSelectedItem().trim() +" ?","si","no")) {
				pV.removeElementAt(ix);
				pl.removeItemListener(this);
				pl.remove(ix);
				pl.addItemListener(this);
				if (ix>=pV.size()) {
					ix--;
				}
				if (ix>=0) {
					pl.removeItemListener(this);
					pl.select(ix);
					pl.addItemListener(this);
					eP.setInfo(L,pV(ix));
					eP.paintAll(eP.getGraphics());
				} else {
					setInfo(L,null);
				}
			}
		}
	}

	private Vector listeners=new Vector();

	private void callListeners(String arg) {
		for (int i=0;i<listeners.size();i++) {
			ActionListener al=(ActionListener)listeners.elementAt(i);
			al.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,arg));
		}
	}

	public void addActionListener(ActionListener al) {
		listeners.addElement(al);
	}

	public void removeActionListener(ActionListener al) {
		listeners.removeElement(al);
	}

/* ------------------ ActionListener ------------------- */

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==B_add) {
			addnew(false);
		} else if (e.getSource()==B_duplicate) {
			addnew(true);
		} else if (e.getSource()==B_delete) {
			delete();
		} else if (e.getSource()==ef) {
			String ac=e.getActionCommand();
			boolean apply=(ac.charAt(1)=='T');
			if (apply) {
				setInfo(TA.getText().trim());
			}
		}
		callListeners("");
	}

	private void updateList(int ix,int ixnew) {
		if (ix>=0 && ix<pV.size()) {
			pV.setElementAt(eP.getInfo(),ix);
			if (!prepareItem(pV(ix)).equals(pl.getItem(ix))) {
				pl.removeItemListener(this);
				pl.replaceItem(prepareItem(pV(ix)),ix);
				pl.select(ixnew);
				pl.addItemListener(this);
			}
		}
	}

/* ------------------ ItemListener ------------------- */

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource()==pl && e.getStateChange()==e.SELECTED) {
			int ixnew=pl.getSelectedIndex();
			updateList(ix,ixnew);
			ix=ixnew;
			eP.setInfo(L,pV(ix));
			callListeners("");
		}
	}

/* ------------------ MouseListener ------------------- */

	public void mousePressed(MouseEvent e) {
		e.consume();
		if (thr!=null) {
			thr.stop();
			thr=null;
		}
		if (e.getSource()==sc) {
			if (e.getY()<sc.getSize().height/2) {
				sc.up=true;
			} else {
				sc.down=true;
			}
			sc.repaint();
			thr=new Thread(this);
			stopRequested=false;
			thr.start();
		} else if (e.getSource()==tlbl) {
			editObject[] eoa=getInfo();
			String s="";
			for (int i=0;i<eoa.length;i++) {
				s+=eoa[i].toString(" ",L)+"\n";
			}
			TA.setText(s+" ");
			ef.display(true);
		}
	}

	public void mouseReleased(MouseEvent e) {
		e.consume();
		stopRequested=true;
	}

	/* -------------- Runnable ------------- */

	private Thread thr;
	private volatile boolean stopRequested;
	private boolean stop() {
		return stopRequested;
	}

	public synchronized void run() {
		long T=System.currentTimeMillis()+350;
		spinStep();
		while (!stop()) {
			while  (!stop() && System.currentTimeMillis()<T) {
				try {
					thr.sleep(20);
				}  catch (InterruptedException ie) {
					stopRequested=true;
				}
			}
			if (stop()) {
				break;
			}
			spinStep();
			try {
				thr.sleep(20);
			}  catch (InterruptedException ie) {
				stopRequested=true;
			}
			T=System.currentTimeMillis()+40;
		}
		sc.up=false;
		sc.down=false;
		sc.repaint();
		callListeners("");
		thr=null;
	}

	private synchronized void spinStep() {
		if (ix>=0) {
			pl.removeItemListener(this);
			if (sc.up) {
				if (ix>0) {
					editObject pc=pV(ix);
					pV.setElementAt(pV(ix-1),ix);
					pV.setElementAt(pc,ix-1);
					pl.replaceItem(prepareItem(pV(ix-1)),ix-1);
					pl.replaceItem(prepareItem(pV(ix)),ix);
					ix--;
				}
			} else if (sc.down) {
				if (ix<pV.size()-1) {
					editObject pc=pV(ix);
					pV.setElementAt(pV(ix+1),ix);
					pV.setElementAt(pc,ix+1);
					pl.replaceItem(prepareItem(pV(ix)),ix);
					pl.replaceItem(prepareItem(pV(ix+1)),ix+1);
					ix++;
				}
			}
			pl.select(ix);
			pl.addItemListener(this);
		}
		paintAll(getGraphics());
	}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {
		stopRequested=true;
	}
	public void mouseExited(MouseEvent e) {
		stopRequested=true;
	}
	public void mouseMoved(MouseEvent e) {
		stopRequested=true;
	}
	public void mouseDragged(MouseEvent e) {
//		stopRequested=true;
	}

	/* ------------------ KeyListener --------------- */

	public void keyTyped(KeyEvent e) {}
	public void keyPressed(KeyEvent e) {
		if (e.getKeyCode()==e.VK_ADD || e.getKeyCode()==e.VK_INSERT) {
			addnew(false);
			callListeners("");
		} else if (e.getKeyCode()==e.VK_MULTIPLY) {
			addnew(true);
			callListeners("");
		} else if (e.getKeyCode()==e.VK_DELETE || e.getKeyCode()==e.VK_SUBTRACT) {
			delete();
			callListeners("");
		}
	}
	public void keyReleased(KeyEvent e) {}

}