/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.gui;

import java.awt.*;
import java.awt.event.*;
import com.jla.desc2.util.*;

public class editDialog extends Dialog implements mjaWindow,WindowListener {

	public boolean ok=false;
	private editWindowButtons ewb;

	public editDialog(Frame parent,String title,boolean modal,String okLabel,String cancelLabel) {
		super(parent,title,modal);
		setBackground(Color.lightGray);
		addWindowListener(this);
		setLayout(new BorderLayout());
		add("South",ewb=new editWindowButtons(this,okLabel,cancelLabel,null));
	}

	public void addExtraButton(Button b) {
		ewb.addExtraButton(b);
	}

	public void display(boolean center) {
		pack();
		if (center) {
			Dimension dd=getSize();
			Dimension pd=Toolkit.getDefaultToolkit().getScreenSize();
			if (getParent()!=null&&getParent().isVisible()) {
				pd=getParent().getSize();
			}
			if (pd.width==0 || pd.height==0) {
				pd=Toolkit.getDefaultToolkit().getScreenSize();
			}
			Point pl=new Point(0,0);
			if (getParent()!=null&&getParent().isVisible()) {
				pl=getParent().getLocation();
			}
System.out.println(pd);
System.out.println(pl);
			setLocation(Math.max(0,pl.x+(pd.width-dd.width)/2),Math.max(0,pl.y+(pd.height-dd.height)/2));
		}
		ok=false;
		show();
	}

	public void display() {
		ok=false;
		display(true);
	}

	public void closingAction(boolean close,boolean apply) {
		ok=apply;
	}

	public void setLabels(String okLabel, String cancelLabel) {
		ewb.setLabels(okLabel,cancelLabel,"");
	}

	public void windowClosing(WindowEvent e){
		setVisible(false);
	}
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}

}