/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.gui;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.jla.desc2.util.*;

public class editFrame extends Frame implements mjaWindow, WindowListener {

	private editWindowButtons ewb;
	private Vector listeners=new Vector();
	public boolean pack;

	public editFrame(String title,String okLabel,String cancelLabel,String applyLabel) {
		super(title);
		setBackground(Color.lightGray);
		addWindowListener(this);
		setLayout(new BorderLayout());
		add("South",ewb=new editWindowButtons(this,okLabel,cancelLabel,applyLabel));
	}

	public void setLabels(String okLabel, String cancelLabel,String applyLabel) {
		ewb.setLabels(okLabel,cancelLabel,applyLabel);
	}

	private int dx=0,dy=0;

	public void addExtraButton(Button b) {
		ewb.addExtraButton(b);
	}

	public void setSize(int dx,int dy) {
		super.setSize(dx,dy);
		this.dx=dx;
		this.dy=dy;
	}

	public void display(boolean center) {
		if (center) {
			display("center");
		} else {
			display("fixed");
		}
	}

	public void display() {
		display(true);
	}

	public void display(String s) {
		if (pack) {
			pack();
		} else {
			super.setSize(dx,dy);
		}
		Dimension pd=Toolkit.getDefaultToolkit().getScreenSize();
		Dimension dd=getSize();
		Point pl=new Point(0,0);
		int xc=Math.max(0,pl.x+(pd.width-dd.width)/2);
		int yc=Math.max(0,pl.y+(pd.height-dd.height)/2);
		if (mjaStr.hasContent(s)) {
			if (s.equalsIgnoreCase("fixed")) {

			} else if (s.equalsIgnoreCase("up")) {
				setLocation(xc,0);
			} else if (s.equalsIgnoreCase("center")) {
				setLocation(xc,yc);
			} else {
				setLocation(xc,yc);
			}
		}
		show();
	}

	public void setInfo() {
	}

	private void callListeners(String arg) {
		for (int i=0;i<listeners.size();i++) {
			ActionListener al=(ActionListener)listeners.elementAt(i);
			al.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,arg));
		}
	}

	public void addActionListener(ActionListener al) {
		listeners.addElement(al);
	}

	public void removeActionListener(ActionListener al) {
		listeners.removeElement(al);
	}

	public void closingAction(boolean close, boolean apply) {
		String args="";
		if (close) {
			args+="T";
		} else {
			args+="F";
		}
		if (apply) {
			args+="T";
		} else {
			args+="F";
		}
		callListeners(args);
	}

	public void windowClosing(WindowEvent e){
		setVisible(false);
		closingAction(true,false);
	}
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}

}