/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.gui;

import java.util.*;
import java.awt.*;
import java.awt.image.*;

public class mjaGui {

	public static final Font Arial=new Font("Helvetica",Font.PLAIN,12);
	public static final Font Arial_11=new Font("Helvetica",Font.PLAIN,11);
	public static final Font Arial_10=new Font("Helvetica",Font.PLAIN,10);
	public static final Font Times=new Font("TimesRoman",Font.PLAIN,12);
	public static final Font Courier=new Font("Courier",Font.PLAIN,12);
	public static final Font Courier_11=new Font("Courier",Font.PLAIN,11);
//	public static final Font Courier_10=new Font("Courier",Font.PLAIN,10);

	public static Panel flow(int hgap,int vgap,Component c) {
		return flow(FlowLayout.CENTER,hgap,vgap,c);
	}

	public static Panel embedPanel(Container C,int gap) {
		GridBagLayout gbl=new GridBagLayout();
		C.setLayout(gbl);
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.insets=new Insets(gap,gap,gap,gap);
		gbc.fill=GridBagConstraints.BOTH;
		gbc.weightx=1; gbc.weighty=1;
		Panel p=new Panel();
		p.setLayout(new BorderLayout());
		C.add(p,gbc);
		return p;
	}

	public static boolean ask (Frame parent,String title,String msg,String yesLbl,String noLbl) {
		Frame F=parent;
		if (F==null) {
			F=new Frame();
		}
		editDialog ed=new editDialog(F,title,true,yesLbl,noLbl);
		Panel P=new Panel();
		P.setLayout(new FlowLayout());
		TextArea TA=new TextArea(3,40);
		TA.setText(msg);
		TA.setFont(Courier);
		TA.setEditable(false);
		P.add(TA);
		ed.add("Center",P);
		ed.display();
		boolean ok=ed.ok;
		ed.dispose();
		if (parent==null) {
			F.dispose();
		}
		return ok;
	}

	public static Panel flow(int align,int hgap,int vgap,Component c) {
		Panel P=new Panel();
		P.setLayout(new FlowLayout(align,hgap,vgap));
		P.add(c);
		return P;
	}

	public static Panel pair(Component c1,Component c2) {
		Panel P=new Panel();
		P.setLayout(new GridLayout(1,2));
		P.add(c1);
		P.add(c2);
		return P;
	}

	public static Panel pair(double w1,double w2,Component c1,Component c2) {
		return pair(1,1,w1,w2,c1,c2);
	}

	public static Panel pair(int n1,int n2,double w1,double w2,Component c1,Component c2) {
		Panel P=new Panel();
		P.setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		c.fill=GridBagConstraints.BOTH;
		c.gridx=0; c.gridwidth=n1; c.weightx=w1; P.add(c1,c);
		c.gridx=n1; c.gridwidth=n2;c.weightx=w2; P.add(c2,c);
		return P;
	}

	public static Color bestContrast(Color c) {
		int I=c.getBlue()+c.getRed()+c.getGreen();
		if (I<380) {
			return Color.white;
		} else {
			return Color.black;
		}
	}

	public static int[] grabPixelsFromImage(Component comp,Image img) {
		int w=img.getWidth(comp);
		int h=img.getHeight(comp);
		int[] pixels=new int[w*h];
		PixelGrabber pg = new PixelGrabber(img, 0, 0, w, h, pixels, 0, w);
		try {
			pg.grabPixels();
		} catch (InterruptedException e) {
		}
		return pixels;
	}

	public static  Image getImageFromPixels(Component comp,int[] pixels,int w, int h) {
		Image ima=comp.createImage(new MemoryImageSource(w,h,pixels,0,w));
		MediaTracker mt=new MediaTracker(comp);
		mt.addImage(ima,0);
		try {
			mt.waitForID(0);
		} catch (InterruptedException e) {
		}
		return ima;
	}

	public static void fillShape(Component comp,Image img, Color col,int x0, int y0) {
		if (img!=null) {
			int w=img.getWidth(comp), h=img.getHeight(comp);
			if ( 0<=x0 && 0<=y0 && x0<w && y0<h ) {
				int[] pixels = grabPixelsFromImage(comp,img);
				Graphics[] g=new Graphics[1];
				g[0]=img.getGraphics();
				g[0].setColor(col);
				fillShape(g,pixels,w,h,x0,y0);
				Image ima=getImageFromPixels(comp,pixels,w,h);
				img.getGraphics().drawImage(ima,0,0,comp);
			}
		}
	}

	public static void fillShape(Graphics[] g,int[] pixels,int w, int h,int x0, int y0) {
		if ( 0<=x0 && 0<=y0 && x0<w && y0<h ) {
			int c0=pixels[x0+y0*w];
			int c=c0^0x00ffffff;
			Stack S=new Stack();
			S.push(new Point(x0,y0));
			while (!S.empty()) {
				Point P=(Point) S.pop();
				int x=P.x, y=P.y, p=x+y*w;
				while (x>0 && pixels[p]==c0) {
					x--; pixels[p--]=c;
				}
				int mi=x+1;
				x=P.x+1; p=x+y*w;
				while (x<w && pixels[p]==c0) {
					x++; pixels[p++]=c;
				}
				int mf=x-1;
				for (int i=0;i<g.length;i++) {
					g[i].drawLine(mi,y,mf,y);
				}
				for (int caso=0;caso<2;caso++) {
					if (caso==0) {
						y++;
					} else {
						y--; y--;
					}
					if (0<=y && y<h) {
						x=mi;
						p=x+y*w;
						while (x<=mf) {
							boolean pflag=false;
							while (x<mf && pixels[p]==c0) {
								pflag=true; x++; p++;
							}
							if (pflag) {
								if (x==mf && pixels[p]==c0) {
									S.push(new Point(x,y));
								} else {
									S.push(new Point(x-1,y));
								}
								pflag=false;
							}
							int aux=x;
							while (x+1<mf && pixels[p]!=c0) {
								x++;p++;
							}
							if (x==aux) {
								x++;p++;
							}
						}
					}
				}
			}
		}
	}

}