/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.desc2.math;
/*------------------------------------------------------------*/
/*                            R2                              */
/*                         (c) MJA                            */
/*                     Septiembre de 1998                     */
/*------------------------------------------------------------*/
import com.jla.desc2.parser.*;

public class R2 {

	public double x,y;

	public R2() {
		x=0;y=0;
	}

	public R2(double x,double y) {
		this.x=x; this.y=y;
	}

	public R2 copy() {
		return new R2(x,y);
	}

	public int ix() {
		return (int)Math.round(Math.max(Math.min(x,32000),-32000));
	}

	public int iy() {
		return (int)Math.round(Math.max(Math.min(y,32000),-32000));
	}

	public boolean equals(R2 p) {
		return ((x==p.x)&&(y==p.y));
	}

	public double norm2() {
		return x*x+y*y;
	}

	public double norm() {
		return Math.sqrt(norm2());
	}

	public double distance(R2 p) {
		R2 q=copy();
		q.sub(p);
		return q.norm();
	}

	public double dot(R2 p) {
		return x*p.x+y*p.y;
	}

	public double det(R2 p) {
		return x*p.y-y*p.x;
	}

	public void mul(double m) {
		x*=m; y*=m;
	}

	public void div(double d) {
		x/=d; y/=d;
	}

	public void add(R2 p) {
		x+=p.x; y+=p.y;
	}

	public void sub(R2 p) {
		x-=p.x; y-=p.y;
	}

	public void normalize() {
		double abs=norm();
		if (abs!=0.0) {
			div(abs);
		}
	}

	public void rotR90() {
		double aux=x; x=y; y=-aux;
	}

	public void rotL90() {
		double aux=x; x=-y; y=aux;
	}

	public void rot(double t) {
		R2 p=copy();
		double cost=Math.cos(t);
		double sint=Math.sin(t);
		x = p.x*cost - p.y*sint;
		y = p.x*sint + p.y*cost;
	}

	public void rot(int g) {
		rot((double)g*Math.PI/180.0);
	}

}