/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.edit;

import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AudioClip;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FileDialog;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Label;
import java.awt.MediaTracker;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.Panel;
import java.awt.Point;
import java.awt.ScrollPane;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowEvent;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Random;
import java.util.Vector;

import javax.swing.ImageIcon;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import org.xml.sax.SAXException;

import com.jla.nippe.AbstractNippe;
import com.jla.nippe.Nippe;
import com.mja.descartes.DescartesJS;
import com.mja.file.mjaFile;
import com.mja.file.mjaFont;
import com.mja.file.mjaHtml;
import com.mja.gui.editFrame;
import com.mja.gui.mjaText;
import com.mja.util.BasicStr;
import com.jla.versionManager.DescartesVersionManager;

import edu.mec.descartesserver.DescartesServerConector;
import edu.mec.descartesserver.beans.EsceneBean;
import edu.ite.items.beans.Item;
import edu.ite.items.services.ArquimedesItemsServices;


public class NippeEditor extends editFrame implements AppletContext, ActionListener, Runnable, KeyListener, FocusListener, FilenameFilter {
	
	public static final String nippeEditorVer="5."+com.jla.nippe.AbstractNippe.sub_ver;
	public static final String[] descartesMainHosts = {
		"recursostic.educacion.es/descartes/web",
		"arquimedes.matem.unam.mx"
	};
	String server=descartesMainHosts[0]+"/";
	String user="";
	String pwd="";
	String project="";
	String filename="";
	String uri="http://"+server+"servidor/repositorio/"+user+"/"+project+"/"+filename;
	
	public static boolean inItems=true;
	
//	http://www.experinnova.org/evaluador/items/PHP/

	public static String nippeEditorTitle="Editor de Nippes v. "+nippeEditorVer;
	
	protected static String[] nippes=Nippe.nippes;
	private String user_home="";
	private Item item;
	private static NippeEditor NE;
	private static boolean runningApplet=false;
	private static int FW=1080,FH=750;

	public static final String empty_html=
	"<html>\n<head>\n<title>TITULO</title>\n</head>\n"+
	"<body BGCOLOR=\"e0e4e8\">\n\n"+
	"<p align=\"center\">\n</p>\n\n"+
	"</body>\n</html>\n";
	
	private MenuBar MB;
	private MenuItem mi_newHtml, mi_openHtml, mi_openItem, 
					mi_downloadFromServer, mi_openURL, mi_closeHtml, 
					mi_reload, mi_save, mi_saveas, 
					mi_uploadHtml, 
					mi_uploadNewItem, mi_uploadItem, 
					mi_exportToPNG, mi_exportToJPEG, mi_exportToTeX,
					mi_exit;
	private MenuItem mi_undo, mi_redo,
					mi_cutScene, mi_copyScene, mi_pasteScene, mi_deleteScene;
	private MenuItem mi_changeCodebase;
	private Menu mArchivo, mConfig, mServer, mItem, mEdit, mInsert, mInsertScene, mAddScene, mInsertSceneInP, mView;
	private MenuItem	mi_addCopiedScene,mi_addSceneFromDisk,
						mi_insertCopiedScene,mi_insertSceneFromDisk,
						mi_insertCopiedSceneInP, mi_insertSceneFromDiskInP,
						mi_insertParagraph;
	

	private Menu  m_libraryPortable, m_libraryOfProject, m_libraryInInternet; 
	private MenuItem mi_savePortableJava, mi_savePortableJS,
						mi_saveProjectJava, mi_saveProjectJS,
						mi_saveInternetJava, mi_saveInternetJS;

	private MenuItem[] mi_addNippe=new MenuItem[nippes.length],
						mi_insertNippe=new MenuItem[nippes.length],
						mi_insertNippeInP=new MenuItem[nippes.length];

	private MenuItem mi_HTML_YES,mi_HTML_NO;
	private FileDialog FDL, FDS, FDSL;
	public String html_fileName="";
	private String html_String_0="";
	private Vector<block> V_block=new Vector<block>();
	private Vector<Applet> V_applet=new Vector<Applet>();
	private Panel MP;
	private ScrollPane SP;
	private Label lb_status;
	private String home;
	private boolean showHTML=false;

	private String copiedAppletCode;
	
	private static boolean justForJavaScript=true;
	
	private static boolean runningApplication=false;
	
	public static void Start(String title,boolean for_JS) {
		justForJavaScript=for_JS;
		if (title!=null) {
			nippeEditorTitle=title+" v. "+nippeEditorVer;
		}
		System.out.println("Java Runtime "+System.getProperty("java.version"));
		if (!runningApplication) {
			try {
				Class cl=Class.forName("descinst.Descartes");
				System.out.println("Hay un DescartesLib.jar instalado. Es necesario eliminarlo.");
			} catch (Exception ex1) {
//				System.out.println("No hay DescartesLib.jar instalado.");
			}
			System.out.println(title);
			try {
				DescartesVersionManager versionManager = new DescartesVersionManager();
				versionManager.checkUpdates();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		NE=new NippeEditor(nippeEditorTitle,null,"cerrar","aplicar");
		NE.makeNew();
		File F=new File("./"); 
		NE.FDL.setDirectory(F.getAbsolutePath());
		NE.repaint();
	}

	public static void StartAndRunApplet(String title,String fileName,int w,int h,int pad,int col) {
		runningApplication=true;
		FW=w+2+2*pad;
		FH=h+51+2*pad;
		block.margin=pad;
		block.borderColor=new Color(col);
		runningApplet=true;
		Start(title,true);
		NE.setMenuBar(null);
// Necesario para que pueda leer las imgenes. Por qu?
		File F=new File(fileName); 
		NE.html_fileName=F.getAbsolutePath();
		String dir=NE.html_fileName.substring(0,NE.html_fileName.lastIndexOf(File.separator)+1);
		NE.FDL.setDirectory(dir);
// -----------------------------------------------------
//System.out.println("Abriendo "+fileName);
		NE.loadHtml(NE.html_fileName,fromFile);
		for (int i=0; i<NE.V_block.size();i++) {
			block b=(block) NE.V_block.elementAt(i);
			b.hideButtons();
		}
		NE.refreshEnablings();
		NE.refreshIfResized();
		NE.setResizable(false);
		NE.repaint();
	}

	public NippeEditor(String title,String okLabel,String cancelLabel,String applyLabel) {
		super(title,okLabel,cancelLabel,applyLabel);
		Hashtable properties=System.getProperties();
		user_home=(String) properties.get("user.home");
		home=new File("").getAbsolutePath();
		setSize(FW,FH);

		MB=new MenuBar();

		mArchivo=new Menu("Archivo");
		mArchivo.add(mi_newHtml=new MenuItem("Nuevo"));
		mi_newHtml.addActionListener(this);
		mArchivo.add(mi_openHtml=new MenuItem("Abrir"));
		mi_openHtml.addActionListener(this);
		mArchivo.add(mi_closeHtml=new MenuItem("Cerrar"));
		mi_closeHtml.addActionListener(this);
		mArchivo.add(mi_reload=new MenuItem("Actualizar"));
		mi_reload.addActionListener(this);
		mArchivo.add(mi_save=new MenuItem("Guardar"));
		mi_save.addActionListener(this);
		mArchivo.add(mi_saveas=new MenuItem("Guardar como"));
		mi_saveas.addActionListener(this);
		mArchivo.add(mi_exportToPNG=new MenuItem("Exportar a png"));
		mi_exportToPNG.addActionListener(this);
		mArchivo.add(mi_exportToJPEG=new MenuItem("Exportar a jpeg"));
		mi_exportToJPEG.addActionListener(this);
		mArchivo.add(mi_exportToTeX=new MenuItem("Exportar a LaTeX"));
		mi_exportToTeX.addActionListener(this);
		mArchivo.add(mi_exit=new MenuItem("Salir"));
		mi_exit.addActionListener(this);
		MB.add(mArchivo);

		mConfig=new Menu("Opciones");
		mConfig.add(m_libraryInInternet=new Menu("Librera en Internet "));
		mConfig.add(m_libraryPortable=new Menu("Librera portable "));
		mConfig.add(m_libraryOfProject=new Menu("Librera de proyecto "));
		m_libraryPortable.add(mi_savePortableJava=new MenuItem("para Java y JS"));
		m_libraryPortable.add(mi_savePortableJS=new MenuItem("slo para JS"));
		m_libraryOfProject.add(mi_saveProjectJava=new MenuItem("para Java y JS"));
		m_libraryOfProject.add(mi_saveProjectJS=new MenuItem("slo para JS"));
		m_libraryInInternet.add(mi_saveInternetJava=new MenuItem("para Java y JS"));
		m_libraryInInternet.add(mi_saveInternetJS=new MenuItem("slo para JS"));
		mi_savePortableJava.addActionListener(this);
		mi_savePortableJS.addActionListener(this);
		mi_saveProjectJava.addActionListener(this);
		mi_saveProjectJS.addActionListener(this);
		mi_saveInternetJava.addActionListener(this);
		mi_saveInternetJS.addActionListener(this);
		MB.add(mConfig);

		mServer=new Menu("Servidores");
		mServer.add(mi_downloadFromServer=new MenuItem("Descargar Escena de un servidor"));
		mi_downloadFromServer.addActionListener(this);
		mServer.add(mi_uploadHtml=new MenuItem("Publicar Escena en un servidor"));
		mi_uploadHtml.addActionListener(this);
		mServer.add(mi_openURL=new MenuItem("Abrir URL"));
		mi_openURL.addActionListener(this);
		MB.add(mServer);

		mItem=new Menu("Items");
		mItem.add(mi_openItem=new MenuItem("Descargar Item de un servidor"));
		mi_openItem.addActionListener(this);
		mItem.add(mi_uploadItem=new MenuItem("Publicar Item en un servidor"));
		mi_uploadItem.addActionListener(this);
		mItem.add(mi_uploadNewItem=new MenuItem("Publicar nuevo Item en un servidor"));
		mi_uploadNewItem.addActionListener(this);
		MB.add(mItem);


		mEdit=new Menu("Editar");
		mi_undo=new MenuItem("Deshacer");
		mi_undo.addActionListener(this);
		mi_undo.setEnabled(false);
		mEdit.add(mi_undo);
		mi_redo=new MenuItem("Rehacer");
		mi_redo.addActionListener(this);
		mi_redo.setEnabled(false);
		mEdit.add(mi_redo);
		mi_cutScene=new MenuItem("Cortar escena");
		mi_cutScene.addActionListener(this);
		mi_cutScene.setEnabled(false);
		mEdit.add(mi_cutScene);
		mi_copyScene=new MenuItem("Copiar escena");
		mi_copyScene.addActionListener(this);
		mi_copyScene.setEnabled(false);
		mEdit.add(mi_copyScene);
		mi_pasteScene=new MenuItem("Pegar escena");
		mi_pasteScene.addActionListener(this);
		mi_pasteScene.setEnabled(false);
		mEdit.add(mi_pasteScene);
		mi_deleteScene=new MenuItem("Eliminar escena");
		mi_deleteScene.addActionListener(this);
		mi_deleteScene.setEnabled(false);
		mEdit.add(mi_deleteScene);

		MB.add(mEdit);

		mInsert=new Menu("Insertar");

		mAddScene=new Menu("Agregar escena");
		for (int i=0;i<nippes.length;i++) {
			mAddScene.add(mi_addNippe[i]=new MenuItem(Nippe.nippeName[i]));
			mi_addNippe[i].addActionListener(this);
		}
		mAddScene.add(mi_addSceneFromDisk=new MenuItem("del sistema"));
		mi_addSceneFromDisk.addActionListener(this);
		mAddScene.add(mi_addCopiedScene=new MenuItem("del portapapeles"));
		mi_addCopiedScene.addActionListener(this);
		mi_addCopiedScene.setEnabled(false);
		mInsert.add(mAddScene);

		mInsertScene=new Menu("Insertar escena");
		for (int i=0;i<nippes.length;i++) {
			mInsertScene.add(mi_insertNippe[i]=new MenuItem(Nippe.nippeName[i]));
			mi_insertNippe[i].addActionListener(this);
		}
		mInsertScene.add(mi_insertSceneFromDisk=new MenuItem("del sistema"));
		mi_insertSceneFromDisk.addActionListener(this);
		mInsertScene.add(mi_insertCopiedScene=new MenuItem("del portapapeles"));
		mi_insertCopiedScene.addActionListener(this);
		mi_insertCopiedScene.setEnabled(false);
		mInsert.add(mInsertScene);

		mi_insertParagraph=new MenuItem("Insertar prrafo");
		mi_insertParagraph.addActionListener(this);
		mInsert.add(mi_insertParagraph);

		mInsertSceneInP=new Menu("Insertar prrafo con escena");
		for (int i=0;i<nippes.length;i++) {
			mInsertSceneInP.add(mi_insertNippeInP[i]=new MenuItem(nippes[i]));
			mi_insertNippeInP[i].addActionListener(this);
		}
		mInsertSceneInP.add(mi_insertSceneFromDiskInP=new MenuItem("del sistema"));
		mi_insertSceneFromDiskInP.addActionListener(this);
		mInsertSceneInP.add(mi_insertCopiedSceneInP=new MenuItem("del portapapeles"));
		mi_insertCopiedSceneInP.addActionListener(this);
		mi_insertCopiedSceneInP.setEnabled(false);
		mInsert.add(mInsertSceneInP);

		MB.add(mInsert);

		mView=new Menu("Html");
		mView.add(mi_HTML_YES=new MenuItem("Mostrar HTML"));
		mi_HTML_YES.addActionListener(this);
		mView.add(mi_HTML_NO=new MenuItem("Ocultar HTML"));
		mi_HTML_NO.addActionListener(this);

//		mView.add(mi_viewCode=new MenuItem("Ver cdigo"));
//		mi_viewCode.addActionListener(this);

		MB.add(mView);

		setMenuBar(MB);

		lb_status=new Label();
/* ---- agregar o quitar para mostrar uso de memoria --- */
		add("South",lb_status);
/* ----------------------------------------------------- */
		SP=new ScrollPane();
		SP.setBackground(block.borderColor);
		MP=new Panel();
		MP.setBackground(block.borderColor);
		if (runningApplication) {
			add("Center",MP);
		} else {
			SP.add(MP);
			add("Center",SP);
		}
		FDL=new FileDialog(this,"Abrir html",FileDialog.LOAD);
		FDS=new FileDialog(this,"Guardar html",FileDialog.SAVE);
		FDSL=new FileDialog(this,"Importar escena .applet",FileDialog.LOAD);
		File tf=new File("");
		if (!tf.exists()) {
			tf.mkdir();
		}
		if (tf.exists()) {
			FDL.setDirectory("");
			FDS.setDirectory("");
			FDSL.setDirectory("escenas");
		} else {
			FDL.setDirectory(".");
			FDS.setDirectory(".");
			FDSL.setDirectory("."+File.separator+"escenas");
		}
		display(true);		
		Thread thr=new Thread(this);
		thr.start();
	}

/* ----------------- Action Listener ------------------- */

	public void makeNew() {
		setEditEnabled(false);
		V_block=new Vector<block>();
		destroyApplets();
		block b=new block(this,this,this,this,block.HTML,empty_html);
		V_block.add(b);

		if (!runningApplet) {
			insertScene(Nippe.DESCARTES5,false,false,true);
			html_String_0=toHtml();
			html_fileName="";
		}
		setEditEnabled(true);
	}

	String dump="";

	public synchronized void actionPerformed(ActionEvent e) {
//System.out.println(e.getActionCommand());
		addToUndo(toHtml());
		if (e.getSource()==mi_undo) {
			Object O=undo();
			if (O!=null) {
				loadHTML((String) O);
				refresh();
			}
		} else if (e.getSource()==mi_redo) {
			Object O=redo();
			if (O!=null) {
				loadHTML((String) O);
				refresh();
			}
		} else {
			boolean changed=true;
			if (e.getSource()==mi_newHtml) {
				if ( htmlModified() && mjaText.ask("Nuevo html",3,20,"\n   Desea guardar los cambios?","si","no",mjaFont.AWTSansSerif.deriveFont(Font.PLAIN,18)))  {
					save();
				}
				makeNew();
			} else if (e.getSource()==mi_openItem) {
				Item tmpRes = this.buscarItemEnServicios();
				
				if(tmpRes != null)
					item = tmpRes;
			} else if (e.getSource() == mi_openHtml) {
				FDL.show();
				if (FDL.getFile()!=null && FDL.getDirectory()!=null) {
					changed=false;
					if ( htmlModified() && mjaText.ask("Abrir html",3,20,"\n   Desea guardar los cambios?","si","no",mjaFont.AWTSansSerif.deriveFont(Font.PLAIN,18)))  {
						save();
					}
					String str=FDL.getDirectory()+FDL.getFile();
					if (BasicStr.hasContent(str)) {
						html_fileName=str;
						loadHtml(html_fileName,fromFile);
					}
				}
			} else if (e.getSource()==mi_openURL) {
				uri=mjaText.getInfo("URL","URL:","Aceptar","Cancelar",false,uri);
				if (uri!=null) {
					try {
						if ( htmlModified() && mjaText.ask("Abrir html",3,20,"\n   Desea guardar los cambios?","si","no",mjaFont.AWTSansSerif.deriveFont(Font.PLAIN,18)))  {
							save();
						}
						closeHtml();
						changed=false;
						openUri(uri);
					} catch (Exception ex) {
						ex.printStackTrace();
					}
				}
			} else if (e.getSource()==mi_downloadFromServer) {
				downloadScene();
			} else if (e.getSource()==mi_uploadHtml) {
				uploadScene();
			} else if (e.getSource()==mi_uploadNewItem) {
				if (item!=null) {
					item.setId("");
				}
				Item tmpRes = this.uploadItemToServices();
				if(tmpRes != null){
					item = tmpRes;
					if((html_fileName != null) && !("".equals(html_fileName.trim()))){
						File info = new File(html_fileName);
						info = info.getParentFile();
						info = new File(info,"info.xml");
//						mjaFile.save(info.getAbsolutePath(), item.printtoXmlString());
						mjaHtml.writeInUTF8File(item.printtoXmlString(),info.getAbsolutePath());
						save();
					}
				}
			} else if (e.getSource()==mi_uploadItem) {
				Item tmpRes = this.uploadItemToServices();
				if(tmpRes != null){
					item = tmpRes;
					if((html_fileName != null) && !("".equals(html_fileName.trim()))){
						File info = new File(html_fileName);
						info = info.getParentFile();
						info = new File(info,"info.xml");
//						mjaFile.save(info.getAbsolutePath(), item.printtoXmlString());
						mjaHtml.writeInUTF8File(item.printtoXmlString(),info.getAbsolutePath());
						save();
					}
				}
			} else if (e.getSource()==mi_closeHtml) {
				closeHtml();
				changed=false;
			} else if (e.getSource()==mi_reload) {
				boolean doit=true;
				if ( htmlModified() && !mjaText.ask("Actualizar",4,23,"\n   Si contina se perdern los cambios.\n   Desea continuar?","si","no",mjaFont.AWTSansSerif.deriveFont(Font.PLAIN,18)))  {
					doit=false;
				}
				if (doit) {
					V_block=new Vector<block>();
					destroyApplets();
					loadHtml(fromFile);
					startUndo();
					refresh();
					html_String_0=toHtml();
				}
			} else if (e.getSource()==mi_save) {
				if (from==fromUri) {
					uploadScene();
				} else {
					save();
				}
			} else if (e.getSource()==mi_savePortableJava) {
				justForJavaScript=false;
				saveStyle=PORTABLE;
			} else if (e.getSource()==mi_saveProjectJava) {
				justForJavaScript=false;
				saveStyle=FORPROJECT;
			} else if (e.getSource()==mi_saveInternetJava) {
				justForJavaScript=false;
				saveStyle=FORBLOG;
			} else if (e.getSource()==mi_savePortableJS) {
				justForJavaScript=true;
				saveStyle=PORTABLE;
			} else if (e.getSource()==mi_saveProjectJS) {
				justForJavaScript=true;
				saveStyle=FORPROJECT;
			} else if (e.getSource()==mi_saveInternetJS) {
				justForJavaScript=true;
				saveStyle=FORBLOG;
			} else if (e.getSource()==mi_saveas) {
				from=fromRAM;
				trySaveAs();
			} else if (e.getSource()==mi_exportToPNG) {
				tryExportToImage("png");
			} else if (e.getSource()==mi_exportToJPEG) {
				tryExportToImage("jpeg");
			} else if (e.getSource()==mi_exportToTeX) {
				tryExportToTeX();
			} else if (e.getSource()==mi_exit) {
				tryClosing();
			} else if (e.getSource()==mi_insertParagraph) {
				insertParagraph();
			} else if (e.getSource()==mi_insertCopiedScene) {
				insertScene(Nippe.DESCARTES5,false,true,false);
			} else if (e.getSource()==mi_insertCopiedSceneInP) {
				insertScene(Nippe.DESCARTES5,true,true,false);
			} else if (e.getSource()==mi_insertSceneFromDisk) {
				int active=getActiveIndex();
				block b=null;
				int caretPos=0;
				if (active>=0) {
					b=V_block.elementAt(active);
					caretPos=b.getCaretPos();
				}
				String importedBlock=importBlock();
				if (importedBlock!=null) {
					insertScene(active,caretPos,Nippe.DESCARTES5,false,false,false,importedBlock);
				}
			} else if (e.getSource()==mi_insertSceneFromDiskInP) {
				int active=getActiveIndex();
				block b=null;
				int caretPos=0;
				if (active>=0) {
					b=V_block.elementAt(active);
					caretPos=b.getCaretPos();
				}
				String importedBlock=importBlock();
				if (importedBlock!=null) {
					insertScene(active,caretPos,Nippe.DESCARTES5,true,false,false,importedBlock);
				}
			} else if (e.getSource()==mi_addCopiedScene) {
				insertScene(Nippe.DESCARTES5,false,true,true);
			} else if (e.getSource()==mi_addSceneFromDisk) {
				String importedBlock=importBlock();
				if (importedBlock!=null) {
					insertScene(Nippe.DESCARTES5,false,false,true,importedBlock);
				}
			} else if (e.getSource()==mi_cutScene) {
				block b=selectedScene();
				int i=sceneSelected();
				if (b!=null && i>=0) {
					copyAppletCode(b);
					deleteAppletAt(i);
				}
			} else if (e.getSource()==mi_copyScene) {
				block b=selectedScene();
				if (b!=null) {
					copyAppletCode(b);
				}
			} else if (e.getSource()==mi_pasteScene) {
				block b=selectedScene();
				if (b!=null) {
					pasteAppletCode(b);
					refresh();
				} else if (getActiveIndex()>=0) {
					insertScene(Nippe.DESCARTES5,false,true,false);
				}
			} else if (e.getSource()==mi_deleteScene) {
				int i=sceneSelected();
				if (i>=0) {
					deleteAppletAt(i);
				}
			} else if (e.getSource()==mi_HTML_YES && !showHTML) {
				showHTML=true;
				loadHtml(fromRAM);
				refresh();
			} else if (e.getSource()==mi_HTML_NO && showHTML) {
				showHTML=false;
				loadHtml(fromRAM);
				refresh();
//			} else if (e.getSource()==mi_viewPage) {
//				TestWith("winOpen");
//			} else if (e.getSource()==mi_viewCode) {
//				mjaText.openShowPlainTextFrame("Cdigo HTML","Cerrar",toDiskHtml(),25,100,800,600,false);
			} else {
				boolean done=false;				
				for (int i=0;i<nippes.length;i++) {
					if (e.getSource()==mi_addNippe[i]) {
						insertScene(Nippe.Type(nippes[i]),false,false,true);
						done=true;
						break;
					}
				}
				if (!done) {
					for (int i=0;i<nippes.length;i++) {
						if (e.getSource()==mi_insertNippe[i]) {
							insertScene(Nippe.Type(nippes[i]),false,false,false);
							done=true;
							break;
						}
					}
				}
				if (!done) {
					for (int i=0;i<nippes.length;i++) {
						if (e.getSource()==mi_insertNippeInP[i]) {
							insertScene(Nippe.Type(nippes[i]),true,false,false);
							done=true;
							break;
						}
					}
				}
				if (!done) {
					for (int i=0;i<V_block.size();i++) {
						block b=V_block.elementAt(i);
						if (b.getType()==block.APPLET) {
							int n=b.getAction(e.getSource());
							if (n==block.SELECT) {
								b.requestFocus();
								break;
							} else if (n==block.EDIT) {
								Object O=b.getObject();
								if (O instanceof com.mja.descartes.Descartes) {
									((com.mja.descartes.Descartes) O).edit(this);
								} else if (O instanceof com.jla.desc2.descartes.Descartes) {
									((com.jla.desc2.descartes.Descartes) O).edit();
								}
							}
						}
					}
				}
			}
		}
		addToUndo(toHtml());
		refreshEnablings();
		refreshIfResized();
	}
	

	String JavaOrJS() {
		if (justForJavaScript) {
			return "slo para JS";
		} else {
			return "para Java y JS";
		}
	}

	String Guardando() {
		switch (saveStyle) {
			case FORPROJECT	: return "Librera de un PROYECTO";
			case PORTABLE	: return "Librera PORTABLE";
			case FORBLOG	:  return "Librera en INTERNET";
			default 		: return "Librera PORTABLE";
		}
	}
	
	private Vector V;
	
	void getAllHosts() {
		if (descartesHosts==null) {
			V=new Vector();
			String userHome=System.getProperty("user.home");
			String myHostsStr=mjaFile.readFile(userHome+File.separator+"servidor"+File.separator+"otrosServidores");
			if (BasicStr.hasContent(myHostsStr)) {
				String[] myHosts=BasicStr.toStringArray(myHostsStr);
				for (int j=0;j<myHosts.length;j++) {
					myHosts[j]=BasicStr.trim(myHosts[j],'/');
					if (!V.contains(myHosts[j])) {
						V.addElement(myHosts[j]);
					}
				}
			}
			for (int i=0;i<descartesMainHosts.length;i++) {
				V.addElement(descartesMainHosts[i]);
				String extraHostsStr=mjaFile.readURL("http://"+descartesMainHosts[i]+"/servidor/otrosServidores");
				if (BasicStr.hasContent(extraHostsStr)) {
					String[] extraHosts=BasicStr.toStringArray(extraHostsStr);
					for (int j=0;j<extraHosts.length;j++) {
						extraHosts[j]=BasicStr.trim(extraHosts[j],'/');
						if (!V.contains(extraHosts[j])) {
							V.addElement(extraHosts[j]);
						}
					}
				}
			}
			descartesHosts=new String[V.size()];
			for (int i=0;i<V.size();i++) {
				descartesHosts[i]=(String) V.elementAt(i);
				if (!descartesHosts[i].endsWith("/")) {
					descartesHosts[i]+="/";
				}
			}
		}
	}
	
	String[] descartesHosts=null;
	
	boolean selectServerData(boolean askpwd) {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		if (descartesHosts==null) {
			getAllHosts();
		}
		String aux=mjaText.getInfo("http://<Servidor>","Servidor:","Aceptar","Cancelar",descartesHosts,server,true);
		if (aux!=null && aux.length()>0) {
			if (!aux.endsWith("/")) {
				aux+="/";
			}
			String uri="http://"+aux+"servidor/sistema/descartesServer.php?service=status";
			String aux2=mjaFile.readURL(uri);
			aux2=BasicStr.trim(aux2,'\n');
			aux2=BasicStr.trim(aux2,'\r');
			if ("ok".equals(aux2)) {
				if (!V.contains(BasicStr.trim(aux,'/'))) {
					String userHome=System.getProperty("user.home");
					String myHostsStr=mjaFile.readFile(userHome+File.separator+"servidor"+File.separator+"otrosServidores");
					if (myHostsStr==null) {
						myHostsStr="";
					}
					String dirstr=userHome+File.separator+"servidor";
					File dirs=new File(dirstr);
					dirs.mkdirs();
					myHostsStr=BasicStr.trim(aux,'/')+"\r\n"+myHostsStr;
//					mjaFile.save(dirstr+File.separator+"otrosServidores",myHostsStr);
					mjaHtml.writeInUTF8File(myHostsStr,dirstr+File.separator+"otrosServidores");
				}
				server=aux;
				uri="http://"+server+"servidor/sistema/descartesServer.php?service=listUsers";
				String users_str=mjaFile.readURL(uri);
				String[] usuarios=BasicStr.toStringArray(users_str);
				if (BasicStr.arrayContains(usuarios,user)) {
					aux=user;
				} else {
					aux="";
				}
				aux=mjaText.getInfo("http://"+server+"servidor/sistema/<Usuario>","Usuario:","Aceptar","Cancelar",usuarios,aux,false);
				if (aux!=null && aux.length()>0) {
					String old_user=user;
					if (!aux.equals(user)) {
						project="";
						filename="";
					}
					user=aux;
					if (askpwd) {
						if (user.equals(old_user)) {
							aux=pwd;
						} else {
							aux="";
						}
						aux=mjaText.getInfo("http://"+server+"servidor/sistema/"+user,"Contrasea:","Aceptar","Cancelar",true,aux);
						if (aux!=null && aux.length()>0) {
							uri="http://"+server+"servidor/sistema/descartesServer.php?service=checkLogin&user="+user+"&password="+aux;
							String result=mjaFile.readURL(uri);
							result=BasicStr.trim(result,'\n');
							result=BasicStr.trim(result,'\r');
							if ("ok".equals(result)) {
								pwd=aux;
							} else {
								pwd="";
								mjaText.msg(this,"Error","La contrasea no es vlida\n\n");
								setCursor(null);
								return false;
							}
						} else {
							setCursor(null);
							return false;
						}
					}
					uri="http://"+server+"servidor/sistema/descartesServer.php?service=listProjects&user="+user;
					String projects_str=mjaFile.readURL(uri);
					String[] proyectos=BasicStr.toStringArray(projects_str);
					aux=mjaText.getInfo("http://"+server+"servidor/sistema/"+user+"/<Proyecto>","Proyecto:","Aceptar","Cancelar",proyectos,project,askpwd);
					if (aux!=null && aux.length()>0) {
						if (!aux.equals(project)) {
							filename="";
						}
						project=aux;
						if (!BasicStr.arrayContains(proyectos,project)) {
							if (project.indexOf(" ")>=0) {
								mjaText.msg(this,"Error","El nombre de proyecto es invlido:\n\n"+project);
								setCursor(null);
								return false;
							}
							uri="http://"+server+"servidor/sistema/descartesServer.php?service=createProject&user="+user+"&password="+pwd+"&project="+project;
							aux=mjaFile.readURL(uri);
							if (aux!=null) {
								aux=BasicStr.trim(aux,'\n');
								aux=BasicStr.trim(aux,'\r');
								if (!"ok".equals(aux)) {
									mjaText.msg(this,"Error","No se pudo crear el proyecto\n\n"+project);
									setCursor(null);
									return false;
								}
							} else {
								setCursor(null);
								return false;
							}
						}
						uri="http://"+server+"servidor/sistema/descartesServer.php?service=listFiles&user="+user+"&project="+project;
						String files_str=mjaFile.readURL(uri);
						String[] files=BasicStr.toStringArray(files_str);
						aux=mjaText.getInfo("http://"+server+"servidor/sistema/"+user+"/"+project+"/<Archivo>","Archivo:","Aceptar","Cancelar",files,filename,askpwd);
						if (aux!=null && aux.length()>0) {
							filename=aux;
							if (filename.indexOf(" ")>=0) {
								mjaText.msg(this,"Error","El nombre del archivo es invlido:\n\n"+filename);
								setCursor(null);
								return false;
							}
							setCursor(null);
							this.uri=Uri();
							return true;
						}
					}
				}
			} else {
				mjaText.msg(this,"Error","El servidor\n"+aux+"\nno est disponible\n\n");
				setCursor(null);
				return false;
			}
		}
		setCursor(null);
		return false;
	}

	void openUri(String uri) {
		try {
			URL url=new URL(uri);
			String uri_server=url.getHost();
			String path=uri;
			int N=path.lastIndexOf("/");
			if (N>=uri_server.length()) {
				filename=path.substring(N+1);
				path=path.substring(0,N);
				int N1=path.lastIndexOf("/");
				if (N1>=uri_server.length()) {
					project=path.substring(N1+1);
					path=path.substring(0,N1);
					int N2=path.lastIndexOf("/");
					if (N2>=uri_server.length()) {
						user=path.substring(N2+1);
						path=path.substring(0,N2);
					}
				}
			}
//			this.uri=uri;
			html_fileName=uri;
			if (loadHtml(fromUri)) {
				startUndo();
				refresh();
				html_String_0=toHtml();
			} else {
				mjaText.msg(this,"Error","No se pudo leer\n\n"+uri);
				
			}
		} catch (Exception ex) {
			mjaText.msg(this,"Error",ex.getMessage());
		}
	}

	private String Uri() {
		if (BasicStr.hasContent(server)&&BasicStr.hasContent(user)&&BasicStr.hasContent(filename)) {
			if (server.endsWith("/")) {
				uri="http://"+server+"servidor/repositorio/"+user+"/"+project+"/"+filename+"/";
			} else {
				uri="http://"+server+"/servidor/repositorio/"+user+"/"+project+"/"+filename+"/";
			}
		}
		return uri;
	}
	
	
	
	private void downloadScene(){
		try {
			if (selectServerData(false)) {
				File current = new File(FDL.getDirectory());
				JFileChooser fileChooser = new JFileChooser(current.getParent());  
				fileChooser.setDialogType(JFileChooser.SAVE_DIALOG);
				fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
				fileChooser.setDialogTitle("Selecciona una carpeta para guardar la escena");
				
				File tmpFile = null;
				do{
					int returnVal = fileChooser.showOpenDialog(null);
					if (returnVal != JFileChooser.APPROVE_OPTION) {
						return;
					}
					File docbasedir = fileChooser.getSelectedFile();
					if (!docbasedir.isDirectory()) {
						JOptionPane.showMessageDialog(fileChooser,
								"No existe el directorio '"
										+ docbasedir.getCanonicalPath() + "'",
								"Error al escribir en directotio.",
								JOptionPane.ERROR_MESSAGE);
						tmpFile = null;
						continue;
					}
					String dirTmp = filename;
					tmpFile = new File(docbasedir, dirTmp);
					if (tmpFile.isDirectory()) {
						int res2 = JOptionPane
								.showConfirmDialog(
										fileChooser,
										"La carpeta "
												+ dirTmp
												+ " ya existe.\nDesea sobrescribir?",
										" Sobrescribir Escena ?",
										JOptionPane.YES_NO_CANCEL_OPTION);
						if (res2 == JOptionPane.NO_OPTION) {
							tmpFile = null;
							continue;
						}
						if (res2 == JOptionPane.CANCEL_OPTION) {
							return;
						}
					}
				} while(tmpFile == null); 
				
				DescartesServerConector conector = new DescartesServerConector(server+"servidor/sistema/",user,pwd);
				EsceneBean tmpBean = conector.downloadEscena(user,project,filename,tmpFile);
				if(tmpBean == null){
					mjaText.msg(this,"Error al descargar","No se pudo descargar la escena");
					return;
				}
								
			
				
				String directoryName = tmpBean.getLocalPath();
				FDL.setDirectory(directoryName+File.separator);
				FDL.setFile("index.html");
				String str = FDL.getDirectory()+FDL.getFile();
//				System.out.println("Leido desde "+str);
				html_fileName=str;
				loadHtml(html_fileName,fromFile);
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	
	private void uploadScene() {
		String prev_server=server;
		String prev_user=user;
		String prev_pwd=pwd;
		String prev_project=project;
		String prev_filename=filename;
		if (selectServerData(true)) {
			try {
				DescartesServerConector conector = new DescartesServerConector(server+"servidor/sistema/",user,pwd);
				
				EsceneBean esceneBean =  new EsceneBean();
				esceneBean.setFiles(getFilePaths());
				esceneBean.setHtmlCode(toHtml());
				
				File baseDir = new File(html_fileName);
				esceneBean.setLocalPath(baseDir.getParent());
				
				esceneBean.setName(filename);
			
				String result = conector.uploadEscene(project, filename, esceneBean);
				if ("ok".equals(result)) {
					String uri=Uri();
					setTitle(nippeEditorTitle+": "+uri);
					mjaText.msg(this,"Publicacin","El archivo se public correctamente");
					html_String_0=esceneBean.getHtmlCode();
				} else {
					server=prev_server;
	//System.out.println("upload1 "+server);
					user=prev_user;
					pwd=prev_pwd;
					project=prev_project;
					filename=prev_filename;
					String uri=Uri();
					setTitle(nippeEditorTitle+": "+uri);
					mjaText.msg(this,"Publicacin","Error en la publicacin del archivo\r\n"+result);
				}
			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else {
			server=prev_server;
//System.out.println("upload2 "+server);
			user=prev_user;
			pwd=prev_pwd;
			project=prev_project;
			filename=prev_filename;
			String uri=Uri();
			setTitle(nippeEditorTitle+": "+uri);
		}
	}
	

	String importBlock() {
		FDSL.show();
		if (FDSL.getFile()!=null && FDSL.getDirectory()!=null) {
			String filename=FDSL.getDirectory()+FDSL.getFile();
			if (BasicStr.hasContent(filename)) {
				String str=mjaFile.readFile(filename);
				str=str.replace("<ajs ","<applet ");
				str=str.replace("</ajs>","</applet>");
				Point[] AppletLimits=mjaHtml.getAppletCodeLimits(str);
				if (AppletLimits!=null && AppletLimits.length>0) {
					str=str.substring(AppletLimits[0].x,AppletLimits[0].y);
					return str;
				}
			}
		}
		return null;
	}

	public void refreshEnablings() {

//		Save, Close and View
		boolean nonEmptyHtml=BasicStr.hasContent(html_String_0);
		mEdit.setEnabled(nonEmptyHtml);
		mInsert.setEnabled(nonEmptyHtml);
		mi_closeHtml.setEnabled(nonEmptyHtml);
		mi_reload.setEnabled(nonEmptyHtml);
		mi_save.setEnabled(nonEmptyHtml);
		mi_saveas.setEnabled(nonEmptyHtml);
		mAddScene.setEnabled(nonEmptyHtml);

//		Insert in HTML (getActiveIndex()>=0);
		boolean insertionPossible=(getActiveIndex()>=0)||(sceneSelected()>=1)||(V_block!=null&&V_block.size()==1);
		mi_insertParagraph.setEnabled(insertionPossible&&showHTML);
		mInsertScene.setEnabled(insertionPossible);
		mInsertSceneInP.setEnabled(insertionPossible&&showHTML);

//		Cut, Copy, Paste and Delete
		boolean sceneSelected=sceneSelected()>=0;
		mi_cutScene.setEnabled(sceneSelected);
		mi_copyScene.setEnabled(sceneSelected);
		mi_deleteScene.setEnabled(sceneSelected);
		boolean canCopy=BasicStr.hasContent(copiedAppletCode);
		mi_pasteScene.setEnabled(canCopy &&insertionPossible);
		mi_addCopiedScene.setEnabled(canCopy);
		mi_insertCopiedScene.setEnabled(canCopy);
		mi_insertCopiedSceneInP.setEnabled(canCopy&&showHTML);

//		Undo - Redo
		mi_undo.setEnabled(canUndo());
		mi_redo.setEnabled(canRedo());
		if (this instanceof ItemEditor) {
			mEdit.setEnabled(false);
			mInsert.setEnabled(false);
		}
	}
	
	private boolean isEditEnabled=true;
	
	boolean isEditEnabled() {
		return isEditEnabled;
	}

	void setEditEnabled(boolean b) {
		isEditEnabled=b;
		mArchivo.setEnabled(b); 
		mServer.setEnabled(b); 
		mItem.setEnabled(b); 
		mEdit.setEnabled(b); 
		mInsert.setEnabled(b);
		mInsertScene.setEnabled(b);
		mAddScene.setEnabled(b);
		mInsertSceneInP.setEnabled(b);
		mView.setEnabled(b);
		if (b) {
			refreshEnablings();
		}
	}

	private void setCopyAndDeleteEnabled(boolean sceneSelected) {
	}

	void setInsertEnabled(boolean b) {
	}

/* ---------------- Undo - Redo system ------------- */

	private boolean objectsEqual(Object o1,Object o2) {
		String s1=(String) o1;
		String s2=(String) o2;
		if (s1!=null && s2!=null) {
			return s1.equals(s2);
		}
		return true;
	}

	private Vector<Object> v_undo=new Vector<Object>();
	private int showing=-1;

	private boolean canUndo() {
		return showing>0;
	}

	private boolean canRedo() {
		return showing+1<v_undo.size();
	}

	private synchronized void startUndo() {
		v_undo=new Vector<Object>();
		showing=-1;
	}

	private synchronized void addToUndo(Object O) {
		if (showing>=0 && showing<v_undo.size()) {
			if (!objectsEqual(O,v_undo.elementAt(showing)) ) {
				while (showing<v_undo.size()-1) {
					v_undo.remove(v_undo.size()-1);
				}
				v_undo.add(O);
				showing++;
			}
		} else {
			v_undo.add(O);
			showing++;
		}
	}

	private synchronized Object undo() {
		if (showing>0) {
			return v_undo.elementAt(--showing);
		} else {
			return null;
		}
	}

	private synchronized Object redo() {
		if (showing+1<v_undo.size()) {
			return v_undo.elementAt(++showing);
		} else {
			return null;
		}
	}

/* ---------------- End: Undo - Redo system ------------- */

	void closeHtml() {
		if ( htmlModified() && mjaText.ask("Cerrar html",3,20,"\n   Desea guardar los cambios?","si","no",mjaFont.AWTSansSerif.deriveFont(Font.PLAIN,18)))  {
			save();
		}
		html_String_0="";
		html_fileName="";
		startUndo();
		V_block=new Vector<block>();
		destroyApplets();
		refresh();
	}

	static final String jslibPORTABLE="src=\'lib/descartes-min.js\'";
	static final String jslibFORPROJECT="src=\'../lib/descartes-min.js\'";
	static final String jslibFORBLOG="src=\'http://arquimedes.matem.unam.mx/Descartes5/lib/descartes-min.js\'";
	static final String jslibOLDBLOG="src=\'http://arquimedes.matem.unam.mx/DescartesJS/descartes-min.js\'";

	static String jslib() {
		String str=jslibPORTABLE;
		switch (saveStyle) {
			case PORTABLE: 		str=jslibPORTABLE;
								break;
			case FORPROJECT: 	str=jslibFORPROJECT;
								break;
			case FORBLOG: 		str=jslibFORBLOG;
								break;
			default : 		str=jslibPORTABLE;
		}
		return str;
	}

//	static final String codebase_path="_codebase_path_";

	static String CodeBase_Path() {
		String str="http://arquimedes.matem.unam.mx/Descartes5/";
		switch (saveStyle) {
			case PORTABLE: 		str="./";
								break;
			case FORPROJECT: 	str="../";
								break;
			case FORBLOG: 		str="http://arquimedes.matem.unam.mx/Descartes5/";
								break;
			default : 		str="./";
		}
		return str;
	}

	static final String noJava="<font face=\"Arial\" size=\"3\">Esta unidad interactiva requiere la m&aacute;quina virtual de Java <a href=\"http://java.com/\" target=\"_blank\">JAVA</a>.</font>\r\n";

	String getAppletCode(block b) {
		String code="";
		Object O=b.getObject();
		AbstractNippe AN=(AbstractNippe) O;
		code=AN.getAppliedCode();
		code=code.replace(jslibPORTABLE,jslib());
		code=code.replace(jslibFORPROJECT,jslib());
		code=code.replace(jslibFORBLOG,jslib());
		code=code.replace(jslibOLDBLOG,jslib());
		code=code.replace("_jnlp_path_",CodeBase_Path());
		return code;
	}

	String[] getFilePaths(block b) {
		String code="";
		Object O=b.getObject();
		AbstractNippe AN=(AbstractNippe) O;
		String[] files=AN.getFilePaths();
//System.out.println(code);
//new Exception().printStackTrace();
		return files;
	}

	String[] getFilePaths() {
		Vector V=new Vector();
		for (int i=0;i<V_block.size();i++) {
			block b=V_block.elementAt(i);
			if (b.getType()==block.APPLET) {
				V.addElement(getFilePaths(b));
			}
		}
		int N=0;
		for (int i=0;i<V.size();i++) {
			N+=((String[]) V.elementAt(i)).length;
		}
		String[] files=new String[N];
		int k=0;
		for (int i=0;i<V.size();i++) {
			String[] filesi=(String[]) V.elementAt(i);
			for (int j=0;j<filesi.length;j++) {
				files[k++]=filesi[j];
			}
		}
		return files;
	}
	
	String toHtml() {
		String s="";
		boolean conJSHTML5 =justForJavaScript;
		for (int i=0;i<V_block.size();i++) {
			block b=V_block.elementAt(i);
			if (b.getType()==block.HTML) {
				s+=(String) b.getObject();
			} else if (b.getType()==block.APPLET) {
				/*
				 * Agregamos estas lineas para la carga 
				 * descartes-min.js si aun no la tiene y existen applets de DescartesJS 
				 */
				AbstractNippe AN=(AbstractNippe) b.getObject();
				conJSHTML5 |= (AN instanceof DescartesJS);
				if(conJSHTML5 && (s.indexOf("descartes-min.js") < 0) ){
					String jsCode = "\t"+jsline+"\n</head>";
					s = s.replaceFirst("</head>", jsCode);
				}
				
				s+=getAppletCode(b);
			}
		}
		if(conJSHTML5){
			int idxDoctype = s.indexOf("<!DOCTYPE");	
			if(idxDoctype >= 0){
				int idxSalto = s.indexOf(">",idxDoctype+6);
				String before = s.substring(0, idxDoctype);
				String after = s.substring(idxSalto+1);
				s = before+"<!DOCTYPE html>"+after;
			} else {
				s="<!DOCTYPE html>\n"+s;
			}
		} else {
			// Removing JS lines");
			while (s.indexOf(jsline)>=0) {
				int ix=s.indexOf(jsline);
				s=s.substring(0,ix)+s.substring(ix+jsline.length());
			}
		}
		return s;
	}
	
	static final String jsline = "<script type='text/javascript' src='lib/descartes-min.js'></script>";

//	private static String getJavaScriptIncludeTags() {
//		String tagsInclude = 
//				"\n\t"+jsline+"\n";
//		return tagsInclude;
//	}

	public void refreshIfResized() {
		for (int i=0;i<V_block.size();i++) {
			block b=V_block.elementAt(i);
			if (b.getType()==block.APPLET) {
				Object O= b.getObject();
				AbstractNippe AN=(AbstractNippe) O;
				Dimension d0=AN.getRealSize();
				Dimension d=AN.proposedDimension();
				if (d0.width!=d.width || d0.height!=d.height) {
					loadHtml(fromRAM);
					refresh();
					break;
				}
			}
		}
	}

	static String canonicNewLines(String s) {
		StringBuffer sb=new StringBuffer();
		char charant=' ';
		for (int i=0; i<s.length(); i++) {
			char ch = s.charAt(i);
			if ((ch=='\n') && (i==s.length() || (int)charant!=0x0D)) {
				sb.append((char)0x0D);
			}
			sb.append(ch);
			charant=ch;
		}
		return new String(sb);
	}

	private boolean htmlModified() {
		String s0=html_String_0;
		String s1=toHtml();
		return !s1.equals(s0);
	}

	private void destroyApplets() {
		for (int i=0;i<V_applet.size();i++) {
			Applet A=V_applet.elementAt(i);
			A.stop();
			A.destroy();
		}
		MP.removeAll();
		V_applet=new Vector<Applet>();
	}

	static final int fromRAM=0,fromFile=1,fromUri=2;
	static final int PORTABLE=0, FORPROJECT=1, FORBLOG=2;
	int from;
	static int saveStyle=PORTABLE;

	public boolean loadHtmlFromFile(String html_filename) {
		return loadHtml(html_filename,fromFile);
	}
	
	public boolean loadHtmlFromUri(String uri) {
		return loadHtml(uri,fromUri);
	}
	
	public boolean loadHtml(String html_filename,int from) {
//System.out.println("Loading "+html_filename);
		FDS.setFile(html_fileName);
		boolean loaded=loadHtml(from);
		if (loaded) {
			startUndo();
			refresh();
			html_String_0=toHtml();
			return true;
		}
		return false;
	}

	boolean loadHtml(int from) {
		String html_String="";
		switch (from) {
			case fromRAM : html_String=canonicNewLines(mjaHtml.decodeHTMLEncoding(toHtml())); 
							break;
			case fromFile : this.from=from; 
							html_String=mjaFile.readFile(html_fileName);
							if ((html_String.indexOf("charset=UTF-8")>=0)
								|((html_String.charAt(0)==0xEF)
									&(html_String.charAt(1)==0xBB)
									&(html_String.charAt(2)==0xBF))
								|(html_String.charAt(0)==0xFEFF)
								) {
								html_String=mjaHtml.readUTF8(html_fileName);
							}
							html_String=html_String.replace("<ajs ","<applet ");
							html_String=html_String.replace("</ajs>","</applet>");
							break;
			case fromUri : 	
							showStatus("reading: "+html_fileName);
							SP.setCursor(new Cursor(Cursor.WAIT_CURSOR));
							this.from=from; 
							html_String=mjaFile.readURL(html_fileName); 
							html_String=html_String.replace("<ajs ","<applet ");
							html_String=html_String.replace("</ajs>","</applet>");
							SP.setCursor(null);
							break;
			default: 
		}

		String searchforProject="../lib/descartes-min.js";
		String searchforJSInternet="http://arquimedes.matem.unam.mx/Descartes5/lib/descartes-min.js";
		String searchforJavaInternet="http://arquimedes.matem.unam.mx/Descartes5/lib/Descartes5.jnlp";

		if (html_String.indexOf(searchforProject)>0) {
			saveStyle=FORPROJECT;
		} else if (html_String.indexOf(searchforJSInternet)>0) {
			saveStyle=FORBLOG;
		} else if (html_String.indexOf(searchforJavaInternet)>0) {
			saveStyle=FORBLOG;
		} else {
			saveStyle=PORTABLE;
		}

		if (html_String.indexOf("lib/descartes-min.js'></script>")>0) {
			justForJavaScript=true;
			while (html_String.indexOf("lib/descartes-min.js'></script>")>0) {
				int ixr=html_String.indexOf("lib/descartes-min.js'></script>");
				int ixf=html_String.toLowerCase().indexOf("</script>",ixr)+9;
				int ixi=html_String.toLowerCase().indexOf("<script");
				int ixia=ixi;
				while ((ixi>=0)&&(ixi<ixr)) {
					ixia=ixi;
					ixi=html_String.toLowerCase().indexOf("<script",ixi+6);
				}
				ixi=ixia;
				if (ixi>0 && ixf>0 &&ixi<ixf) {
					html_String=html_String.substring(0,ixi).trim()+
								html_String.substring(ixf);
				}
			}
		} else {
			if (from==fromRAM) {
				justForJavaScript=true;
			}
			justForJavaScript=false;
		}
		if (html_String==null) {
			html_String="";
		}
		loadHTML(html_String);
		return (html_String.length()>0);
	}

	void loadHTML(String html_String) {
		if (html_String.indexOf("charset=UTF-8")<0) {
			html_String = mjaHtml.decodeHTMLEncoding(html_String);
		}
		destroyApplets();
		V_block=loadHTML(html_String,false);
	}
	
	Vector<block> loadHTML(String html_String,boolean justOne) {

/* ---- Si se quiere usar en NippeEditor el color de fondo de la pgina -----
		String bcs=mjaHtml.getAttribute(html_String,"BODY","BGCOLOR").toLowerCase();
		if (bcs.startsWith("#")) {
			bcs=bcs.toLowerCase().substring(1);
		}
		mjaColor mjabc=mjaColor.parseColor(bcs,null,null);
		if (mjabc!=null) {
			block.borderColor=mjabc.getAdaptedColor();
		} else {
			block.borderColor=block.borderColor0;
		}
-------------------------------------------------------------------------- */
		SP.setCursor(new Cursor(Cursor.WAIT_CURSOR));
		Vector<block> V_b=new Vector<block>();
		Point[] AppletLimits=mjaHtml.getAppletCodeLimits(html_String);
		block b;
		int firstHtmlChar=0;
		for (int n=0;n<AppletLimits.length;n++) {
			String appletCode=html_String.substring(AppletLimits[n].x,AppletLimits[n].y);
			String appletType=mjaHtml.getAppletAttribute(appletCode,"code");
			String appletArchive=mjaHtml.getAppletAttribute(appletCode,"archive");
			if (appletType.endsWith(".class")) {
				appletType=appletType.substring(0,appletType.length()-6);
			}
			String default_codebase=getMainCodeBase(Nippe.Type(appletCode,appletType,appletArchive));
			if (default_codebase==null || from==fromUri) {
				default_codebase=mjaHtml.getAppletAttribute(appletCode,"codebase");
			}
			if (runningApplet) {
				default_codebase="./";
			}
			if (Nippe.isNippe(appletCode,appletType,appletArchive)) {
				int firstNippeChar=AppletLimits[n].x;

				String str=html_String.substring(firstHtmlChar,firstNippeChar);
				b=new block(this,this,this,this,block.HTML,str);
				V_b.add(b);
				Nippe N=new Nippe(this,this,appletType,appletArchive,appletCode,FDL.getDirectory());
				N.suggestCodebase(default_codebase);
				Applet A=N.getApplet(this);
				if (runningApplet && (A instanceof AbstractNippe)) {
					((AbstractNippe) A).setToRun(true);
				}
				b=new block(this,this,this,this,block.APPLET,A);
				V_b.add(b);
				firstHtmlChar=AppletLimits[n].y;
			}
			if (justOne) {
				break;
			}
		}
		b=new block(this,this,this,this,block.HTML,html_String.substring(firstHtmlChar));
		V_b.add(b);
		b.invalidate();
		paintAll(getGraphics());
		SP.setCursor(null);
		return V_b;
	}

	public void refresh() {
		SP.setCursor(new Cursor(Cursor.WAIT_CURSOR));
		MP.removeAll();
		MP.setLayout(new GridBagLayout());
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.ipadx=0;
		gbc.ipady=0;
		gbc.insets=new Insets(0,0,0,0);
		gbc.gridy=0;
		V_applet=new Vector<Applet>();
		for (int i=0;i<V_block.size();i++) {
			block b=V_block.elementAt(i);
			if (b.getType()==block.HTML && showHTML) {
				MP.add(b,gbc); gbc.gridy++;
			} else if (b.getType()==block.APPLET) {
				MP.add(b,gbc); gbc.gridy++;
				Applet A=(Applet) b.getObject();
				V_applet.add(A);
				A.start();
			}
		}
		setTitle(nippeEditorTitle+": "+html_fileName);
		SP.setCursor(null);
		invalidate();
		paintComponents(getGraphics());
		paintAll(getGraphics());
	}

	private void save() {
		if (html_fileName.equals("")) {
			from=fromRAM;
			trySaveAs();
		} else {
			saveAs(html_fileName);
			html_String_0=toHtml();
		}
//		startUndo();   Eliminado por peticin de Juan Madrigal 2005-05-25.
	}

	private String toDiskHtml() {
		return canonicNewLines(toHtml());
	}

	private void saveAs(String fileNameOrUri) {
		com.mja.descedit.configEdit.forJava=false;
		String whatToSaveForJS=toDiskHtml();
		com.mja.descedit.configEdit.forJava=true;
		String whatToSaveForJava=toDiskHtml();
		whatToSaveForJava=whatToSaveForJava.replace("_no_Java_",noJava);
		int ix = fileNameOrUri.lastIndexOf(File.separator);
		if (saveStyle!=FORBLOG) {
			String path = "";
			if (ix>0) {
				path = fileNameOrUri.substring(0,ix+1);
			}
			path+=CodeBase_Path()+"lib/";
			path=path.replace("/",File.separator);

			updateForUser(path,"descartes-min.js");
			if (!justForJavaScript) {
				updateForUser(path,"icon.jpg");
				tryUpdate(path,"Arquimedes.jar",whatToSaveForJava);
				tryUpdate(path,"Arquimedes.jnlp",whatToSaveForJava);			
				tryUpdate(path,"Descartes2.jar",whatToSaveForJava);			
				tryUpdate(path,"Descartes2.jnlp",whatToSaveForJava);			
				tryUpdate(path,"Descartes5.jar",whatToSaveForJava);			
				tryUpdate(path,"Descartes5.jnlp",whatToSaveForJava);			
//				tryUpdate(path,"Descartes5_NoEdit.jar",whatToSaveForJava);			
//				tryUpdate(path,"Descartes5_Algebra.jar",whatToSaveForJava);			
//				tryUpdate(path,"Descartes5_Registro.jar",whatToSaveForJava);			
//				tryUpdate(path,"Descartes5_Sonido.jar",whatToSaveForJava);			
			}			
		}
		String str=adaptToJS(whatToSaveForJS);
		if (justForJavaScript) {
//			mjaFile.save(fileNameOrUri,str);
			mjaHtml.writeInUTF8File(mjaHtml.decodeHTMLEncoding(str),fileNameOrUri);
		} else {
//			mjaFile.save(fileNameOrUri,whatToSaveForJava);
			mjaHtml.writeInUTF8File(mjaHtml.decodeHTMLEncoding(whatToSaveForJava),fileNameOrUri);
			if (fileNameOrUri.toLowerCase().indexOf("_js.htm")<0) {
				ix = fileNameOrUri.toLowerCase().lastIndexOf(".htm");
				String JSfile=fileNameOrUri.substring(0,ix)+"_JS"+fileNameOrUri.substring(ix);
//				mjaFile.save(JSfile,str);
				mjaHtml.writeInUTF8File(mjaHtml.decodeHTMLEncoding(str),JSfile);
			}
		} 
//		ix=fileNameOrUri.indexOf(".html");
//		String filename=fileNameOrUri.substring(0,ix)+"_x"+fileNameOrUri.substring(ix);
//		mjaHtml.writeInUTF8File(mjaHtml.decodeHTMLEncoding(str),filename);
	}
	
	private void tryUpdate(String path,String filename,String whatToSave) {
		int ix=filename.indexOf(".");
		String jnlpname=filename.substring(0,ix)+".jnlp";
		if (whatToSave.indexOf("lib/"+jnlpname)>=0) {
			updateForUser(path,filename);			
		}			
	} 
	
	private void updateForUser(String path,String filename) {
		String pathToJS = "/resources/"+filename;
		try{
			try {
				DescartesVersionManager vM = new DescartesVersionManager();
				File f= new File(path);
				f.mkdirs();
				com.jla.versionManager.LibraryVersionManager lvm=vM.getVersionManagerId(filename);
				File s=vM.writeLibrary(lvm,f);
			} catch (Exception e) {
				e.printStackTrace();
				mjaFile.updateFromURL(this.getClass().getResource(pathToJS),path+filename,false);
			}
		} catch (Exception e) {
			System.out.println("Can't write ["+filename+"]");
			e.printStackTrace();
		}
	}
	
	private boolean trySaveAs() {
		FDS.setFile(""); // para que no ponga como dir parte del nombre del archivo anterior
		FDS.show();
		if (FDS.getDirectory()!=null && FDS.getFile()!=null) {
			String dir=FDS.getDirectory();
			String fil=FDS.getFile();
			String filename=dir+fil;
			if (BasicStr.hasContent(filename)) {
				if (!filename.endsWith(".html")) {
					filename+=".html";
				}
				html_fileName=filename;
				save();
				FDL.setDirectory(FDS.getDirectory());
				setTitle(nippeEditorTitle+": "+html_fileName);

// agregado post ver 1.0 el 19 de julio de 2005, para actualizar el codebase de todas las escenas.
				V_block=new Vector<block>();
				destroyApplets();
				loadHtml(fromFile);
				refresh();
				save();
				return true;
			}
		}
		return false;
	}
	
	private void saveAsImage(String filename,String format) {
		if (V_block.size()>1) {
			block b=V_block.elementAt(1);
			b.exportToImage(filename,format);
		}
	}

	private boolean tryExportToTeX() {
		if (V_block.size()>1) {
			block b=V_block.elementAt(1);
			b.exportToTeX();
		}
		return true;
	}
	
	private boolean tryExportToImage(String format) {
		String filename=FDS.getFile();
		String abrevFormat=format;
		if (filename!=null) {
			if (filename.toLowerCase().endsWith(".html")
				||filename.toLowerCase().endsWith(".htm")
				||filename.toLowerCase().endsWith(".png")
				||filename.toLowerCase().endsWith(".jpg")
				||filename.toLowerCase().endsWith(".jpeg")
				) {
				filename=filename.substring(0,filename.lastIndexOf("."));
			}
			if (format.equals("jpeg")) {
				abrevFormat="jpg";
			}
			filename=filename+"."+abrevFormat;
		}
		FDS.setFile(filename);
		FDS.show();
		if (FDS.getDirectory()!=null && FDS.getFile()!=null) {
			filename=FDS.getDirectory()+FDS.getFile();
			if (BasicStr.hasContent(filename)) {
				if (filename.indexOf(".")<0) {
					filename+="."+abrevFormat;
				}
				saveAsImage(filename,format);
				FDL.setDirectory(FDS.getDirectory());
				return true;
			}
		}
		return false;
	}


	private boolean confirmClose() {
		if ((!runningApplet)&&htmlModified()) {
			if (mjaText.ask("Guardar",3,20,"\n   Desea guardar los cambios?","si","no",mjaFont.AWTSansSerif.deriveFont(Font.PLAIN,18))) {
				save();
				return true;
			} else if (mjaText.ask("Salir",3,23,"\n   Desea cerrar el Editor Descartes?","si","no",mjaFont.AWTSansSerif.deriveFont(Font.PLAIN,18)) ) {
				return true;
			} else {
				return false;
			}
		} else {
			return true;
		}
	}

	private void tryClosing() {
		if (confirmClose()) {
			setVisible(false);
			destroyApplets();
			dispose();
			System.exit(0);
		}
	}

	private void deleteAppletAt(int n) {
		block b1=V_block.elementAt(n-1);
		block b=V_block.elementAt(n);
		block b2=V_block.elementAt(n+1);
		String T1=(String) b1.getObject();
		String T2=(String) b2.getObject();
		b1.setObject(T1+T2);
		V_block.remove(n+1);
		V_block.remove(n);
		destroyApplets();
		loadHtml(fromRAM);
		refresh();
		Applet A=(Applet)b.getObject();
		A.destroy();
	}

	private void TestWith(String program) {
		try {
			String cmd=program+" "+html_fileName;
			Runtime.getRuntime().exec(program+" "+html_fileName);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	private void insertTextAtCaretPos(String s) {
		int active=getActiveIndex();
		if (active>=0 && active<V_block.size()) {
			block b=V_block.elementAt(active);
			int caretPos=b.getCaretPos();
			if (caretPos>=0) {
				String T=(String) b.getObject();
				String T1=T.substring(0,caretPos);
				String T2=T.substring(caretPos);
				b.setObject(T1+s+T2);
			}
		}
	}

	private void insertParagraph() {
		insertTextAtCaretPos("<p align=\"left\">\n</p>\n\n");
	}

	private String getMainCodeBase(int type) {
		File docdir=new File(FDL.getDirectory());
		String proposedCB="./";
//		proposedCB=Nippe.getRelativeCodeBase(type,home,docdir.getAbsolutePath());
		return proposedCB;
	}

	private void insertScene(int type,boolean in_paragraph,boolean paste,boolean add) {
		insertScene(type,in_paragraph,paste,add,null);
	}

	private void insertScene(int type,boolean in_paragraph,boolean paste,boolean add,String importedBlock) {
		int active=getActiveIndex();
		block b=null;
		int caretPos=0;
		if (active>=0) {
			b= V_block.elementAt(active);
			caretPos=b.getCaretPos();
		}
		insertScene(active,caretPos,type,in_paragraph,paste,add,importedBlock);
	}

	void copyAppletCode(block b) {
		copiedAppletCode=getAppletCode(b);
	}

	void pasteAppletCode(block b1) {
		pasteAppletCode(b1,copiedAppletCode);
	}

	void pasteAppletCode(block b1,String appletCode) {
		if (BasicStr.hasContent(appletCode) && b1.getType()==block.APPLET) {
			String s="";
			for (int i=0;i<V_block.size();i++) {
				block b=V_block.elementAt(i);
				if (b.getType()==block.HTML) {
					s+=(String) b.getObject();
				} else if (b.getType()==block.APPLET) {
					if (b==b1) {
						s+=appletCode;
					} else {
						s+=getAppletCode(b);
					}
				}
			}
//			s=mjaHtml.getHTMLEncoding(s);
			loadHTML(s);
		}
	}
	private void insertScene(int active,int caretPos,int type,boolean in_paragraph,
		boolean paste,boolean add,String importedBlock) {
		String proposedCB=getMainCodeBase(type);
		boolean mustRefresh=false;
		block b1=null;
		if (proposedCB!=null) {
			if (add) {
				int pos=V_block.size()-1;
				block b=V_block.elementAt(pos);
				String T=(String) b.getObject();
				caretPos=T.toLowerCase().lastIndexOf("</p");
				if (caretPos<0) {
					caretPos=T.toLowerCase().lastIndexOf("</body");
				}
				if (caretPos<0) {
					caretPos=T.length();
				}
				String T1=T.substring(0,caretPos);
				String T2=T.substring(caretPos);
				b.setObject(T1);
				V_block.addElement(new block(this,this,this,this,block.HTML,T2));
				Nippe N=null;
				String appletcode=Nippe.getEmptyAppletCode(type,proposedCB);
				N=new Nippe(this,this,Nippe.code(type),Nippe.archive(type),appletcode,FDL.getDirectory());
				N.suggestCodebase(proposedCB);
				Applet A=N.getApplet(this);
				b1=new block(this,this,this,this,block.APPLET,A);
				V_block.insertElementAt(b1,pos+1);
				mustRefresh=true;
			} else if (active>=0 && active<V_block.size()) {
				if (caretPos>=0) {
					block b=V_block.elementAt(active);
					String T=(String) b.getObject();
					String T1=T.substring(0,caretPos);
					String T2=T.substring(caretPos);
					if (in_paragraph) {
						T1=T1+="\n<p align=\"center\">\n";
						T2="</p>\n\n"+T2;
					}
					b.setObject(T1);
					V_block.insertElementAt(new block(this,this,this,this,block.HTML,T2),++active);
					String appletcode=Nippe.getEmptyAppletCode(type,proposedCB);
					Nippe N=new Nippe(this,this,Nippe.code(type),Nippe.archive(type),appletcode,FDL.getDirectory());
					N.suggestCodebase(proposedCB);
					Applet A=N.getApplet(this);
					b1=new block(this,this,this,this,block.APPLET,A);
					V_block.insertElementAt(b1,active);
					mustRefresh=true;
				}
			} else if (lastSceneSelected>=1) {
				int pos=lastSceneSelected;
				block b=V_block.elementAt(pos-1);
				String T2="";
				V_block.insertElementAt(new block(this,this,this,this,block.HTML,T2),pos);
				String appletcode=Nippe.getEmptyAppletCode(type,proposedCB);
				Nippe N=new Nippe(this,this,Nippe.code(type),Nippe.archive(type),appletcode,FDL.getDirectory());
				N.suggestCodebase(proposedCB);
				Applet A=N.getApplet(this);
				b1=new block(this,this,this,this,block.APPLET,A);
				V_block.insertElementAt(b1,pos);
				mustRefresh=true;
			} else if (V_block!=null && V_block.size()==1) {
				block b=V_block.elementAt(0);
				String T=(String) b.getObject();
				caretPos=T.toLowerCase().lastIndexOf("</p");
				if (caretPos<0) {
					caretPos=T.toLowerCase().lastIndexOf("</body");
				}
				if (caretPos<0) {
					caretPos=T.length();
				}
				String T1=T.substring(0,caretPos);
				String T2=T.substring(caretPos);
				b.setObject(T1);
				V_block.addElement(new block(this,this,this,this,block.HTML,T2));
				String appletcode=Nippe.getEmptyAppletCode(type,proposedCB);
				Nippe N=new Nippe(this,this,Nippe.code(type),Nippe.archive(type),appletcode,FDL.getDirectory());
				N.suggestCodebase(proposedCB);
				Applet A=N.getApplet(this);
				b1=new block(this,this,this,this,block.APPLET,A);
				V_block.insertElementAt(b1,1);
				mustRefresh=true;
			}
		}
		if (mustRefresh) {
			if (paste) {
				pasteAppletCode(b1);
			} else if (importedBlock!=null) {
				pasteAppletCode(b1,importedBlock);
			}
//			loadHtml(fromRAM);
			refresh();
		}
	}

	int getActiveIndex() {
		for (int i=0;i<V_block.size();i++) {
			block b=V_block.elementAt(i);
			if (b.isActive()) {
				return i;
			}
		}
		return -1;
	}

	/* ----------- AppletContext Interface ---------- */

	public Applet getApplet(String name) {
		return null;
	}

	public AudioClip getAudioClip(URL url) {
		return null;
	}

	public Image getImage(URL url) {
		return Toolkit.getDefaultToolkit().getImage(url.getFile());
	}

	public Enumeration<Applet> getApplets() {
		return V_applet.elements();
	}

	public void showDocument(URL url) {
		try {
			String cmd="showLib"+File.separator+"winOpen"+" "+url.toExternalForm();
			Runtime.getRuntime().exec(cmd);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public void showDocument(URL url,String target) {
		showDocument(url);
	}

	public void showStatus(String status) {
		if (runningApplet) {
			lb_status.setText("");
		} else {
			lb_status.setText(status);
		}
	}

	private int lastSceneSelected;

	private int sceneSelected() {
		for (int j=0;j<V_block.size();j++) {
			block b=V_block.elementAt(j);
			if (b.isSelected()) {
				lastSceneSelected=j;
				return lastSceneSelected;
			}
		}
		return -1;
	}

	private block selectedScene() {
		for (int j=0;j<V_block.size();j++) {
			block b=V_block.elementAt(j);
			if (b.isSelected()) {
				return b;
			}
		}
		return null;
	}

/* -------------- FilenameFilter Listener ------------- */
	
	public boolean accept(File dir,String name) {	// No funciona en Windows
		return name!=null && (
				name.toLowerCase().endsWith(".html") ||
				name.toLowerCase().endsWith(".htm") ||
				name.toLowerCase().endsWith(".applet") 
				);
	}


/* -----------------Runnable ------------------ */

	public void run() {
		try {
			while (true) {
				Runtime.getRuntime().runFinalization();
				Runtime.getRuntime().gc();
				long totmem=Runtime.getRuntime().totalMemory()/1024;
				long freemem=Runtime.getRuntime().freeMemory()/1024;
				showStatus(Guardando()+" "+JavaOrJS()+". "+
						"Memoria usada: "+(totmem-freemem)+" de "+totmem+" kb. "+
						"Hay "+Thread.activeCount()+" hilos funcionando. "); //+
//						"Se est mostrando la pgina "+(showing+1)+" de "+v_undo.size()+" que hay en el la pila.");
				Thread.sleep(1000);
			}
		} catch (InterruptedException e) {
		}
	}

/* -----------------Window Listener ------------------ */

	public void windowClosing(WindowEvent e){
		tryClosing();
	}

/* -----------------Key Listener ------------------ */

	public void keyPressed(KeyEvent e){
		addToUndo(toHtml());
		boolean ShiftOn=e.isShiftDown();
		boolean CtrlOn =e.isControlDown();
		boolean AltOn  =e.isAltDown();
		for (int j=0;j<V_block.size();j++) {
			block b=V_block.elementAt(j);
			if (e.getSource()==b) {
				switch (e.getKeyCode()) {
					case KeyEvent.VK_DELETE:
					case KeyEvent.VK_BACK_SPACE:
							deleteAppletAt(j);
							break;
					case KeyEvent.VK_C:
							if (CtrlOn) {
								copyAppletCode(b);
							}
							break;
					case KeyEvent.VK_X:
							if (CtrlOn) {
								copyAppletCode(b);
								deleteAppletAt(j);
							}
							break;
					case KeyEvent.VK_V:
							if (CtrlOn) {
								pasteAppletCode(b);
								loadHtml(fromRAM);
								refresh();
							}
							break;
					case KeyEvent.VK_N:
							if (CtrlOn&&AltOn) {
								TestWith("winOpen");
							}
							break;
					case KeyEvent.VK_T:
							if (CtrlOn&&AltOn) {
								mjaText.showPlainTextFrame("Cdigo HTML","Cerrar",toDiskHtml(),25,100,false);
							}
							break;
				}
			}
		}
		addToUndo(toHtml());
		refreshEnablings();
	}

	public void keyReleased(KeyEvent e){
	}

	public void keyTyped(KeyEvent e){
	}

	/* -------------- Focus Listener ------------- */

	public void focusGained(FocusEvent fe) {
		addToUndo(toHtml());
		refreshEnablings();
	}

	public void focusLost(FocusEvent fe) {
		addToUndo(toHtml());
		refreshEnablings();
	}

	/* -------------- -------------- ------------- */

	public InputStream getStream(String key) {
		// TODO Auto-generated method stub
		return null;
	}

	public Iterator getStreamKeys() {
		// TODO Auto-generated method stub
		return null;
	}

	public void setStream(String key, InputStream stream) throws IOException {
		// TODO Auto-generated method stub
		
	}
	
	private Item buscarItemEnServicios(){
				
		Item item2 = ArquimedesItemsServices.searchAndGetItem(null);
		
		if (item2!=null) {
			String directoryName = item2.getLocalPath(); 
			FDS.setDirectory(directoryName);
			FDL.setDirectory(directoryName);
			FDSL.setDirectory(directoryName);
			html_fileName = FDL.getDirectory()+"index.html";
			
			setTitle(nippeEditorTitle+": "+html_fileName);
			V_block = new Vector<block>();
			destroyApplets();
			loadHTML(item2.getHtmlCode());
			refresh();
			save();
		}
		
		return item2;
	}
	
	/**
	 * Presenta el cuadro de dialogo para seleccionar un directorio. Muestra el dialogo
	 * para llenar le valor de los metadatos y manda el item al servidor. 
	 * @return el item ya guardado
	 */

	private Item uploadItemToServices(){
		if (item == null){ 
			if((html_fileName != null) && !("".equals(html_fileName.trim()))){
				File info = new File(html_fileName);
				info = info.getParentFile();
				info = new File(info,"info.xml");
				if(info.isFile()){
					String infoCont = mjaFile.readFile(info.getAbsolutePath());
					Item[] items = null;
					try {
						items = Item.getItemFromXmlStr(infoCont, Item.FILL_LEVEL_METADATOS);
					} catch (SAXException e) {
						e.printStackTrace();
					}
					if((items != null)&&(items.length>0)){
						item = items[0];
					}
				}
			} 
			if(item == null)
				item = new Item(null,"",null,new String[0]);
		}
		
		
		item.setHtmlCode(toHtml());
		item.setFiles(getFilePaths());
		File codeBase = null;
		if((html_fileName == null) || ("".equals(html_fileName.trim()))){
			// No hay Archivo. Creamos una carpeta temporal para trabajar.
			String baseTempPath = System.getProperty("java.io.tmpdir");

		    Random rand = new Random();
		    int randomInt = 1 + rand.nextInt();

		    File tempDir = new File(baseTempPath + File.separator + "tempDir_" + randomInt);
		    if (tempDir.exists() == false) {
		        tempDir.mkdir();
		    }
		    tempDir.deleteOnExit();
		    codeBase = tempDir;
		} else {
		    codeBase = new File(html_fileName);
			codeBase = codeBase.getParentFile();
		}
		
		
		String thumbsFileName = "Thumbs.png";
		String pathToThums = codeBase.getAbsolutePath()+File.separatorChar+thumbsFileName;
		createThumbsItem(pathToThums,120,80);
		String[] filesTmp = item.getFiles();
		String[] newFilesTmp = new String[filesTmp.length+1];
		
		newFilesTmp[0] = thumbsFileName;
		System.arraycopy(filesTmp, 0, newFilesTmp, 1, filesTmp.length);
		item.setFiles(newFilesTmp);
		
		Item a = ArquimedesItemsServices.uploadItem(item, codeBase);
		return a;
	}
	
	private void createThumbsItem(String pathToSaveThumbs,int width,int height) {
        try{
            this.saveAsImage(pathToSaveThumbs, "png");
            pathToSaveThumbs = pathToSaveThumbs.replaceAll("\\\\", "/");
            ImageIcon icon = new ImageIcon(pathToSaveThumbs);
            Image imgT = icon.getImage();
            
            BufferedImage a = new BufferedImage(width,height,BufferedImage.TYPE_INT_ARGB);
    
            double diffW = imgT.getWidth(this)/width; 
            double diffH = imgT.getHeight(this)/height; 
            
            boolean conW = (diffW<=diffH); 
            width    = (conW)?width:-1;
            height    = (!conW)?height:-1;
            
            Image escalado = imgT.getScaledInstance(width, height, Image.SCALE_SMOOTH);
            MediaTracker mediaTracker = new MediaTracker(this);
            
            mediaTracker.addImage(escalado, 0);
            mediaTracker.addImage(escalado, 0);
            mediaTracker.waitForAll();
            int posX = (a.getWidth()-escalado.getWidth(this))/2;
            int posY = (a.getHeight(this)-escalado.getHeight(this))/2;
            
            Graphics2D g2d = (Graphics2D) a.createGraphics();
            g2d.drawImage(escalado,    posX, posY, this);
        
            mjaFile.save(pathToSaveThumbs,a,"png");
        } catch (Exception e) {
            e.printStackTrace();
        }
	}
	
/* --- funcin para adaptar escenas de Arqumedes y DescartesWeb2_0 a JavaScript para HTML5 --- */

	static String adaptToJS(String s0) {
		String height_key="KEY_replace_for_rtf_height+110";
		String s=s0;
		while (s.indexOf(jsline)>=0) {
			int ix=s.indexOf(jsline);
			s=s.substring(0,ix)+s.substring(ix+jsline.length());
		}
		int ix=s.toLowerCase().indexOf("</head>");
		if (ix>=0) {
				s=s.substring(0,ix).trim()+"\n\t"+jsline+"\n"+s.substring(ix);
		}

/*
		String[] sa=BasicStr.toStringArray(s0);
		String s="";
		for (int i=0;i<sa.length;i++) {

			if (sa[i].toLowerCase().indexOf("</head>")>=0) {
			// Removing JS lines");
				String str=sa[i];
				while (str.indexOf(jsline)>=0) {
					int ix=str.indexOf(jsline);
					str=str.substring(0,ix)+str.substring(ix+jsline.length());
				}

				int ix=str.toLowerCase().indexOf("</head>");
				s+=str.substring(0,ix)+
						getJavaScriptIncludeTags()+
						str.substring(ix)+"\n";
			} else {
				s+=sa[i]+"\n";
			}
		}
*/
		s=s.replace(jslibPORTABLE,jslib());
		s=s.replace(jslibFORPROJECT,jslib());
		s=s.replace(jslibFORBLOG,jslib());
		s=s.replace(jslibOLDBLOG,jslib());
		s=s.replace("_no_Java_","");
		s=s.replace("<applet ","<ajs ");
		s=s.replace("</applet>","</ajs>");
		return canonicNewLines(s);
	}

}