/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.edit;

import com.jla.nippe.Nippe;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import com.mja.descartes.Descartes;
import com.mja.descartes.Arquimedes;
import com.mja.textedit.EditorButtons;
import com.mja.textedit.EditorCanvas;

public class block extends Panel implements FocusListener, MouseListener, ActionListener, ComponentListener, Runnable {

	public static final int HTML=0,APPLET=1;
	public static final int SELECT=1,EDIT=2;
	public static Font AWTMono=new Font("Monospaced",Font.PLAIN,15);
	public static Color borderColor=EditorButtons.borderColor;
	public static int margin=8;
	public static Color selectedColor=new Color(0xc01020);
	private int type;

  	private JEditorPane pane;

	private TextArea TA;
	private Applet A;
	private Button b_select,b_edit,b_text;
	private boolean selected;
	private Panel MP, EP, bP;
	private Canvas C;
	private ActionListener al;
	private CardLayout CL;
	private NippeEditor NE;
	private int dH=0;
	
	public void hideButtons() {
		remove(C);
		remove(EP);
	}
	
	public Dimension getAppletSize() {
		return A.getSize();
	}

	public block(NippeEditor NE,ActionListener al,KeyListener kl,FocusListener fl,int type,Object o) {
		this.NE=NE;
		this.al=al;
		setBackground(borderColor);
		this.type=type;
		setLayout(new BorderLayout());
		MP=new Panel();
		MP.setBackground(borderColor);
		if (type==HTML) {
			add("Center",MP);
			TA=new TextArea(18,90);
			TA.setFont(AWTMono);
			TA.setText((String)o);
			TA.addFocusListener(this);
			TA.addFocusListener(fl);
			TA.addMouseListener(this);
			CL=new CardLayout(margin,margin);
			MP.setLayout(CL);
			MP.add(TA,"text/plain");
			pane = new JEditorPane("text/html",(String) o);
			pane.setEditable(false);
			pane.setPreferredSize(new Dimension(600,300));
			MP.add(new JScrollPane(pane),"text/html");
			EP=new Panel();
			EP.setLayout(new FlowLayout(FlowLayout.CENTER,0,8));
			b_text=new Button("T");
			b_text.setFont(new Font("SansSerif",Font.PLAIN,15));
			b_text.setBackground(Color.black);
			b_text.setForeground(Color.white);
			b_text.addActionListener(this);
			EP.add(b_text);
			add("East",EP);
			C=new Canvas();
			C.setBackground(borderColor);
			C.setSize(25,25);
			add("West",C);
		} else if (type==APPLET) {
			Panel auxp=new Panel();
			A=(Applet) o;
			Dimension d=A.getSize();
			dH=Math.max((790-d.width)/4,-10);
			if (A instanceof com.mja.descartes.Descartes) {
				d=((com.mja.descartes.Descartes) A).getRealSize();
			}

			int hEB=0;
			add("Center",MP);
			MP.setLayout(null);
			hEB=addEditorButtons();
			MP.setSize(d.width+8,d.height+8);
			A.setLocation(4,4);
			MP.add(A);
			EP=new Panel();
			EP.setLayout(new FlowLayout(FlowLayout.CENTER,8+dH,4));
			bP=new Panel();
			bP.setLayout(new GridLayout(2,1,8,4));
			EP.add(bP);
			b_select=new Button("S");
			b_select.setFont(new Font("SansSerif",Font.PLAIN,15));
			b_select.setBackground(new Color(0xc01020));
			b_select.setForeground(Color.white);
			b_select.addActionListener(al);
			bP.add(b_select);
			b_edit=new Button("E");
			b_edit.setFont(new Font("SansSerif",Font.PLAIN,15));
			b_edit.setBackground(new Color(0x405060));
			b_edit.setForeground(Color.white);
			b_edit.addActionListener(al);
			bP.add(b_edit);
			add("East",EP);
			C=new Canvas();
			C.setBackground(borderColor);
			C.setSize(20+2*dH,1);
			add("West",C);

			addKeyListener(kl);
			MP.addMouseListener(this);
		}
		addFocusListener(this);
		addComponentListener(this);
	}
	
	public void exportToTeX() {
		if (A instanceof Descartes) { 
			((Descartes) A).scene.toTeX();
		}
	}
	
	public void exportToImage(String filename,String format) {
		if (A instanceof Descartes) { 
			if (A instanceof Arquimedes) {
				EditorCanvas EC=(EditorCanvas) ((Arquimedes)A).getEC();
				if (EC!=null) {
					EC.setEditing(false);
				}
			}
			((Descartes) A).scene.saveScene(filename,format);
			if (A instanceof Arquimedes) {
				EditorCanvas EC=(EditorCanvas) ((Arquimedes)A).getEC();
				if (EC!=null) {
					EC.setEditing(true);
					EC.updateScreen();
				}
			}
		}
	}
	
	private EditorButtons EB;
	
	protected int addEditorButtons() {
		int hEB=0;
		if (A instanceof Arquimedes) {
			EditorCanvas EC=(EditorCanvas) ((Arquimedes) A).getEC();
			if (EC!=null) {
				hEB=50;
				if (EB==null) {
					EB=new EditorButtons(A,NE,((Arquimedes) A).Tr,true,false,true,false);
					EB.setBackground(borderColor);
					EB.setAttributes(EditorButtons.ArquimedesAttributes);
					EB.setEditorCanvas(EC,false);
				}
				EC.addActionListener(EB);
				EB.setEditing(true);
				add("North",EB);
			} else {
				new Exception("Text Editor not created").printStackTrace();
			}
		}
		return hEB;
	}

	public boolean isActive() {
		if (type==HTML && TAhasFocus) {
			return true;
		}
		return false;
	}

	public int getCaretPos() {
		if (isActive()) {
			return TA.getCaretPosition();
		}
		return -1;
	}

	public int getType() {
		return type;
	}

	public Object getObject() {
		if (type==HTML) {
			return TA.getText();
		} else if (type==APPLET) {
			return A;
		} else {
			return null;
		}
	}

	public void setObject(Object o) {
		if (type==HTML && o instanceof String) {
			TA.setText((String) o);
			pane.setText(TA.getText());
		} else if (type==APPLET && o instanceof Applet) {
			A=(Applet) o;
		}
	}

	public int getAction(Object source) {
		if (source==b_select) {
			setSelected(!selected);
			return SELECT;
		} else if (source==b_edit) {
			return EDIT;
		} else {
			return -1;
		}
	}

	public boolean isSelected() {
		return selected;
	}

	private void setSelected(boolean b) {
		selected=b;
		if (selected) {
			MP.setBackground(selectedColor);
		} else {
			MP.setBackground(borderColor);
		}
	}

	/* -------------- Action Listener ------------- */
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b_text) {
			pane.setText(TA.getText());
			CL.next(MP);
		}
	}

	/* -------------- Focus Listener ------------- */

	boolean TAhasFocus=false;

	public void focusGained(FocusEvent fe) {
		if (fe.getSource()==TA) {
			TAhasFocus=true;
		} else if (fe.getSource()==this) {
//			setSelected(true);
		}
		al.actionPerformed(new ActionEvent(this,0,"Focus Gained"));
	}

	public void focusLost(FocusEvent fe) {
		if (fe.getSource()==TA) {
			TAhasFocus=false;
		} else if (fe.getSource()==this) {
			setSelected(false);
		}
		al.actionPerformed(new ActionEvent(this,0,"Focus Gained"));
	}

	/* -------------- Mouse Listener ------------- */

	public void mousePressed(MouseEvent e) {
		if (e.getSource()==MP) {
			requestFocus();
		}
	}

	public void mouseReleased(MouseEvent e) {
	}
	public void mouseClicked(MouseEvent e) {
	}
	public void mouseEntered(MouseEvent e) {
	}
	public void mouseExited(MouseEvent e) {
		if (e.getSource()==TA) {
			al.actionPerformed(new ActionEvent(this,0,"Mouse exits TextArea"));
		}
	}

	/* -------------- Runnable ------------- */

	public static boolean ready;
	
	public synchronized void run() {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		NE.setCursor(new Cursor(Cursor.WAIT_CURSOR));
		while (!NE.isEditEnabled()) {
			try {
				Thread.sleep(20);
			} catch (InterruptedException ie) {
			}
		}
		NE.setEditEnabled(false);
		try {
			Thread.sleep(50);
			EB.selectChars(EditorButtons.Latin);
			Thread.sleep(50);
			EB.selectChars(EditorButtons.Symbols);
			Thread.sleep(50);
		} catch (InterruptedException e) {
		}
		NE.setEditEnabled(true);
		NE.setCursor(null);
		NE.invalidate();
		NE.repaint();
		setCursor(null);
	}

	/* ------------ Component Listener ----------- */

	public void componentResized(ComponentEvent e) {
		if (EB!=null) {
			new Thread(this).start();
		}
	}

	public void componentMoved(ComponentEvent e) {
	}
	public void componentShown(ComponentEvent e) {
	}
	public void componentHidden(ComponentEvent e) {
	}

}