/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.nippe;
/* ------------ Nippe ---------- */

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

import com.jla.desc2.descartes.Descartes2;
import com.mja.parser.Parser;
import com.mja.descartes.Descartes3;
import com.mja.descartes.Descartes5;
import com.mja.descartes.Arquimedes;
import com.mja.descartes.DescartesJS;
import com.mja.descartes.Item;
//import com.mja.algebra.DescartesA;
import com.mja.file.mjaHtml;
import com.mja.util.BasicStr;


public class Nippe {

	public static final int 
	DESCARTES2 	= 0, 
	DESCARTES5 	= 1,
	ARQUIMEDES 	= 2, 
	ITEM 		= 3, 
	DESCARTESA 	= 4, 
	TABLAS 		= 5, 
	PROMETEO 	= 6;

	
	public static String[] nippeName={
		"Descartes 2",
		"Descartes 5",
		"Discurso",
		"Item",
//		"Descartes JS",
//		"DescartesA",
//		"Tabla",
//		"Prometeo",
	};

	public static final String[] nippes= {
		"Descartes2",
		"Descartes5",
		"Discurso",
		"Item",
//		"DescartesA",
//		"Tablas",
//		"Prometeo",
//		"DescartesJS",
	};
	
	public String docdir;
	public String type;
	public String archive;
	public String name;
	private String applet_code;
	public Dimension d;
	public URL docbase,codebase;
	protected ActionListener al;
	private Object aE;
	
	
	
	public static String archive(int type) {
		switch (type) {
			case DESCARTES2 : return "Descartes2.jar";
			case DESCARTES5 : return "Descartes5.jar";
			case ARQUIMEDES : return "Arquimedes.jar";
			case ITEM 			: return "Descartes5.jar";
//			case DESCARTESA : return "DescartesA.jar";
//			case TABLAS     : return "tablas.jar";
//			case PROMETEO   : return "Prometeo.jar";
			default : return "";
		}
	}

	public static String code(int type) {
		switch (type) {
			case DESCARTES2 	: return "Descartes";
			case DESCARTES5 	: return "Descartes";
			case ARQUIMEDES 	: return "Discurso";
			case ITEM 			: return "Item";
//			case DESCARTESA 	: return "DescartesA";
//			case TABLAS     	: return "com.mos.tablas.tabla";
//			case PROMETEO   	: return "com.jla.nippe.Prometeo";
			default : return "";
		}
	}
	
	public String getAppletCode() {
		return applet_code;
	}

/*
	public static String getRelativeCodeBase(int type,String abscodedir,String absdocdir) {
		if (absdocdir.toUpperCase().startsWith(abscodedir.toUpperCase())) {
			String subdir=absdocdir.substring(abscodedir.length());
			String s="";
			while (subdir.indexOf(File.separator)>=0) {
				subdir=subdir.substring(subdir.indexOf(File.separator)+1);
				s+="./";
			}
			return s;
		} else {
			String subdir=absdocdir;
			String s="";
			while (true) {
				String testpath=subdir+File.separator+archive(type);
				File testfile=new File(testpath);
				if (testfile.exists()) {
					if (s.equals("")) {
						s="../";
					}
					return s;
				}
				int ix=subdir.lastIndexOf(File.separator);
				if (ix>=0) {
					if (ix==0) {
						subdir="";
					} else {
						subdir=subdir.substring(0,ix);
					}
					s+="./";
				} else {
					break;
				}
			}
		}
		return abscodedir;
	}
*/

	protected Frame parentFrame;
	
//	public Panel getEB() {
//		return aE;
//	}

	public Object getEC() {
		return aE;
	}

	public Nippe(Frame pf,String appletType,String appletArchive,String appletCode,URL codebase, URL docbase) {
		parentFrame=pf;
//		this.al=al;
		type=appletType;
		archive=appletArchive;
		applet_code=appletCode;
		this.docdir=docdir;
		name=mjaHtml.getAppletAttribute(applet_code,"name");
		this.codebase=codebase;
		this.docbase=docbase;
		d=new Dimension(640,480);
		try {
			d=mjaHtml.getAppletSize(applet_code);
		} catch (Exception ex) {
		}
	}

	public Nippe(Frame pf,ActionListener al,String appletType,String appletArchive,String appletCode,String docdir) {
		parentFrame=pf;
		this.al=al;
		type=appletType;
		archive=appletArchive;
		this.docdir=docdir;
		applet_code=appletCode;
		name=mjaHtml.getAppletAttribute(applet_code,"name");
		String str_cb=mjaHtml.getAppletAttribute(applet_code,"codebase");
		codebase=getURL(str_cb);
		docbase=getURL("");
		d=new Dimension(640,480);
		try {
			d=mjaHtml.getAppletSize(applet_code);
		} catch (Exception ex) {
		}
	}

	public void suggestCodebase(String s) {
		if (!codebase.toExternalForm().toLowerCase().startsWith("http://")) {
			codebase=getURL(s);
		}
	}
	
	public URL getURL(String str_codebase) {
		String uri="";
		if (str_codebase.toLowerCase().startsWith("http://")) {	// cambiado el 100808 ver 4.104
			uri=str_codebase;
		} else if (str_codebase.toLowerCase().startsWith("file:")) {
			uri=str_codebase;
		} else {
			uri="file://"+docdir+str_codebase;
			uri=BasicStr.convertToFilePath(uri);
			uri=BasicStr.reducePath(uri);
		}
		try {
			return new URL(uri);
		} catch (Exception ex) {
			ex.printStackTrace();
			return null;
		}
	}

	public static boolean isNippe(String appletCode,String type,String archive) {
		return Type(appletCode,type,archive)>=0;
	}
	
	public static int Type(String stype) {
		for (int i=0;i<nippes.length;i++) {
			if (nippes[i].equalsIgnoreCase(stype)) {
				return i;
			}
		}
		return -1;
	}

	public static int Type(String appletCode,String code,String archive) {
		if (code!=null) {
			if ((code.indexOf("DescartesJS")>=0) || (code.indexOf("DescartesBasico")>=0)) {
				return DESCARTES5;
			}
			if (code.endsWith(".class")) {
				code=code.substring(0,code.length()-6);
			}
			if (code.equals("Discurso")) {
				return ARQUIMEDES;
			} else if (code.equals("Arquimedes")) {
				return ARQUIMEDES;
			} else if (code.equals("descinst.DescartesWeb2_0")) {
				return ARQUIMEDES;
			} else if (code.equals("Item") || code.equals("ArquimedesItem")) {
				return ITEM;
			} else if (code.equals("Descartes")) {
				if (archive.indexOf("Descartes5.jar")>=0) {
					return DESCARTES5;
				} else if (archive.indexOf("Descartes5_NoEdit.jar")>=0) {
					return DESCARTES5;
				} else if (archive.indexOf("Descartes4.jar")>=0) {
					return DESCARTES5;
				} else if (archive.indexOf("Descartes3.jar")>=0) {
					return DESCARTES5;
				} else if (archive.indexOf("Descartes2.jar")>=0) {
					return DESCARTES2;
				} else if (archive.indexOf("Descartes.jar")>=0) {
					return DESCARTES2;
				} else {
					AbstractNippe A=new Descartes5();
					if (A!=null) {
						try {
							Hashtable ht=mjaHtml.getAppletParams(appletCode);
							A.setAppletParams(ht);
							String cfgVer=((Descartes5) A).getConfigVersion();
							if (cfgVer!=null && (cfgVer.startsWith("1")||cfgVer.startsWith("2") ) ) {
								return DESCARTES2;
							}
						} catch (Exception e) {
							e.printStackTrace();
							return DESCARTES5;
						}
					}
					return DESCARTES5;
				}
			}
		}
		return -1;
	}

	public Applet getApplet(AppletContext ac) {
		Applet A=getApplet(ac,false);
		A.init();
		return A;
	}

	public Applet getUninitedApplet(AppletContext ac) {
		Applet A=getApplet(ac,false);
		return A;
	}

	public AbstractNippe getApplet(AppletContext ac,boolean inWeb) {
		AbstractNippe A=null;
		int tipus=Type(applet_code,type,archive);
		if (tipus==DESCARTES2) {
			A=new Descartes2();
		} else if (tipus==DESCARTES5) {
			A=new Descartes5();
		} else if (tipus==ARQUIMEDES) {
			A=new Arquimedes(parentFrame);
		} else if (tipus==ITEM) {
			A=new Item(parentFrame);
//		} else if (tipus==DESCARTESA) {
//			A=new DescartesA();
//		} else if (tipus==TABLAS) {
//			A=new com.mos.tablas.tabla();
//		} else if (tipus==PROMETEO) {
//			A=new com.jla.nippe.Prometeo();
		} else {
			A=new Descartes5();
		}
		if (A!=null) {
			A.applet_codebase=mjaHtml.getAppletAttribute(applet_code,"codebase");
			try {
				Hashtable ht=mjaHtml.getAppletParams(applet_code);
				A.setAppletContext(ac);
				A.setAppletParams(ht);
				A.setCodeBase(codebase);
				A.setDocBase(docbase);
				A.setInWeb(inWeb);
				A.setInNippeEditor(!inWeb);
				A.addActionListener(al);
				A.setSize(d);
				A.setBounds(0,0,d.width,d.height);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		if (tipus==ARQUIMEDES||tipus==ITEM) {
			aE=((Arquimedes) A).getEC();
			if (tipus==ITEM) {
				((Item) A).setDescartesWeb2_0(false);
			} else {
				((Arquimedes) A).setDescartesWeb2_0(false);
			}
		}
		return A;
	}
	
	URL getCodeBase() {
		return codebase;
	}

	URL getDocumentBase() {
		return docbase;
	}

	public static String getEmptyAppletCode(int type,String codebase) {
		if (type==DESCARTES2) {
			return Descartes2.getDefaultConfig(codebase);
		} else if (type==DESCARTES5) {
			return Descartes5.getDefaultConfig(codebase);
		} else if (type==ARQUIMEDES) {
			return Arquimedes.getDefaultConfig(codebase);
		} else if (type==ITEM) {
			return Item.getDefaultConfig(codebase);
		}
		return "";
	}

}