/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.nippe;

import java.net.*;
import java.util.*;

import com.mja.parser.Parser;

public class doLMS {


	private static volatile org.cnice.lms.client.learner.LearnerClient lms;
	private static volatile org.cnice.rad.client.learner.LearnerClient rad;
	private static String[] alumnos;

	public static Object getLearnerClient() {
		if (rad!=null) {
			return rad;
		} else if (lms!=null) {
			return lms;
		}
		return null;
	}

/* ---------------------------- RAD --------------------------- */

	public static boolean initRAD(String equipment_name,String host) {
		String RAD_host=host;
		try {
			InetAddress ina=InetAddress.getByName(RAD_host);
			if (RAD_host==null||RAD_host.length()==0) {
				RAD_host="127.0.0.1";
			}
			org.cnice.rad.client.learner.LearnerClient.initRAD(equipment_name,RAD_host);
			rad=org.cnice.rad.client.learner.LearnerClient.client();
			if (rad!=null) {
				alumnos=rad.getAlumnos();
				return true;
			}
		} catch (Exception e) {
			System.out.println("getByName("+RAD_host+") failed");
			e.printStackTrace();
		}
		return false;
	}
	
	public static String clientName() {
		if (rad!=null) {
			return rad.getNombreEquipo();
		}
		return "localhost";
	}
	
	public static String[] Alumnos() {
		return alumnos;
	}

	public static Object RADInitialize(String codebase,String filepath,String name,String appletcode,String infoind,String infoest) {
		if (rad!=null) {
			return rad.RADInitialize(codebase,filepath,name,appletcode,infoind,infoest);
		}
		return null;
	}

	public static void RADFinish(Object raddb_activity,Parser parser,int nota,int aciertos,int errores) {
		if (rad!=null) {
			if (raddb_activity!=null) {
				rad.RADFinish((org.cnice.rad.client.learner.Actividad)raddb_activity,parser,nota,aciertos,errores);
			}
		}
	}

	public static void RADAddAction(Object raddb_activity,String tipo,String name,String[][] s) {
		if (rad!=null) {
			rad.RADAddAction((org.cnice.rad.client.learner.Actividad)raddb_activity,tipo,name,s);
		}
	}

	public static void RADProgramFinish() {
		if (rad!=null) {
			rad.ProgramFinish();
		}
	}

/* ---------------------------- LMS --------------------------- */

	public static void initLMS(String host) {
		String LMS_host=host;
		try {
			InetAddress ina=InetAddress.getByName(LMS_host);
			if (LMS_host==null||LMS_host.length()==0) {
				LMS_host="127.0.0.1";
			}
			System.out.println(LMS_host+"="+ina.toString());
		} catch (Exception e) {
		}
		org.cnice.lms.client.learner.LearnerClient.initLMS(LMS_host);
		lms=org.cnice.lms.client.learner.LearnerClient.client();
	}

	public static Object LMSInitialize(String LearningProgram,
		String course,String unit,String exercise,String location) {
		if (lms!=null) {
			return lms.LMSInitialize(LearningProgram,course,unit,exercise,location);
		}
		return null;
	}

	public static void LMSAddAction(Object lmsdb_activity,String name,String s) {
		if (lms!=null) {
			if (name.length()>0||s.length()>0) {
				lms.LMSAddAction((org.cnice.lms.client.learner.Activity)lmsdb_activity,name,s);
			}
		}
	}

	public static void LMSFinish(Object lmsdb_activity) {
		if (lms!=null) {
			if (lmsdb_activity!=null) {
				lms.LMSFinish((org.cnice.lms.client.learner.Activity)lmsdb_activity);
			}
		}
	}

	public static void LMSProgramFinish() {
		if (lms!=null) {
			lms.ProgramFinish();
		}
	}

//	public static String LMSGetTutorEMail(Object lmsdb_activity,String def) {
//		if (lms!=null&&lmsdb_activity!=null) {
//			return ((org.cnice.lms.client.learner.Activity)lmsdb_activity).getTutorEMail();
//		}
//		return def;
//	}

}