/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.jla.prometeo;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;

import com.jla.nippe.*;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.gui.*;
import org.unam.matem.Attribute;
import org.unam.matem.Communicator;

public class Prometeo extends NotSoAbstractNippe implements AppletContext, Runnable {
	
/* ------------- Communicator implementation --------------- */

	public Attribute[] getState() {
		return new Attribute[0];
	}
	
	public void changed(Communicator cc) {
	}
	
/* --------------------------------------------------------- */
	
	boolean standAlone=false;
	
	public static void main(String[] args) {
		if (args!=null && args.length>0 && BasicStr.hasContent(args[0])) {
			String str=mjaFile.readFile(args[0]);
			Point[] P=mjaHtml.getAppletCodeLimits(str);
			if (P.length>0) {
				String appletCode=str.substring(P[0].x,P[0].y);
				try {
					Hashtable ap=mjaHtml.getAppletParams(appletCode);
					Prometeo Pr=new Prometeo();
					Pr.standAlone=true;
					File f=new File(".");
					Pr.setAppletParams(ap);
					Dimension dim=mjaHtml.getAppletSize(appletCode);
					Pr.setSize(dim);
					Pr.init();
					editFrame EF=new editFrame("Prometeo","ok","cancel","");
					EF.standAlone=true;
					EF.setSize(800,600);
					EF.add("Center",Pr);
					EF.pack();
					EF.display();
					Pr.start();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}
	}
	
/* ----------------- AbstractNippe implementation ----------------- */

	public String getInfo(String type,String param) {
		String varName=type;
		StringTokenizer st=new StringTokenizer(param,"_");
		if (st.hasMoreTokens()) {
			int i=BasicStr.parseInteger(st.nextToken(),0,0);
			if (st.hasMoreTokens()) {
				int j=BasicStr.parseInteger(st.nextToken(),0,0);
				String var=varName+"_"+i+"_"+j;
				if (p.isVar(var)) {
					if (p.svalue(var)!=null) {
						return p.svalue(var);
					} else {
						return BasicStr.DoubleToString(p.rvalue(var),6,false);
					}
				} else {
					System.out.println("class_Id() = "+class_Id());
					System.out.println("object_id = "+object_id);
					System.out.println("Error en "+class_Id()+": la variable "+var+" no est definida");
					return "Error";
				}
			}
		}
		return "";
	}

	public void doAction(String actionName,String param) {
		if ("close".equalsIgnoreCase(actionName)) {
			Applet A=getAppletByName(param);
			if (A!=null) {
				A.stop();
				A.setVisible(false);
				A.destroy();
			}
		} else if ("add".equalsIgnoreCase(actionName)) {
		} else if ("refresh".equalsIgnoreCase(actionName)) {
		}
	}

	public String getAppliedCode() {
		return "";
	}
	
	public Dimension getRealSize() {
		return getSize();
	}
	
	public void updateProposedDimension() {}
	
	public String class_Id() {
		return "Prometeo";
	}
	
	public String[] getFilePaths() {
		return new String[0];
//		String[] files=new String[imagesHT.size()];
//		Enumeration E=imagesHT.keys();
//		for (int i=0;i<files.length;i++) {
//			files[i]=(String) E.nextElement();
//		}
//		return files;
	}

	Vector ANA=new Vector();
	private static boolean versionShown=false;
	
	public void init() {
		if (!versionShown) { /* a new web page with a Prometeo applet writes its version in the Java console. */
			System.out.println(class_Id()+" ver. 0.9 (beta)");
			versionShown=true;
		}
		if (reloj==null) {
			reloj=getImage(getClass().getResource("/resources/images/reloj.png"));
		}
		setBackground(Color.black);
		try {
			int N=Integer.parseInt(getParameter("BGCOLOR"),16);
			Color bgColor=new Color(N);
			setBackground(bgColor);	// ste color se ve en el fondo
		} catch (NumberFormatException e) {
		}
		setLayout(null);
		String nombre=getParameter("name");
		if (!BasicStr.hasContent(nombre)) {
			nombre=getParameter("nombre");
		}
		setName(nombre);
		PromApplet PA0=new PromApplet(nombre,0,0);
		PA0.applet=this;
		ANA.addElement(PA0);
		for (int i=0;i<10;i++) {
			String value=getParameter("E_0"+i);
			if (BasicStr.hasContent(value)) {
				Attribute[] aa=Attribute.parse(value);
				String name=Attribute.getValue(aa,"name");
				if (!BasicStr.hasContent(name)) {
					name=Attribute.getValue(aa,"nombre");
				}
				String location=Attribute.getValue(aa,"pos");
				String type=Attribute.getValue(aa,"tipo");
				String source=Attribute.getValue(aa,"source");
				String[] strLoc=BasicStr.getElements(location,",");
				int x0=0,y0=0,w0=320,h0=200,dx0=-1,dy0=-1;
				if (strLoc.length>=2) {
					x0=BasicStr.parseInteger(strLoc[0],x0,x0);
					y0=BasicStr.parseInteger(strLoc[1],y0,y0);
				}
				PromApplet PA=new PromApplet(name,x0,y0);
				readApplet(PA,source);
				if (PA.applet!=null) {
					ANA.addElement(PA);
				}
			}
		}
		for (int i=ANA.size()-1;i>=1;i--) {
			Applet A=((PromApplet) ANA.elementAt(i)).applet;
			add(A);
		}
	}

	private void readApplet(PromApplet PA,String source) {
		try {
			String html_String="";
			String rsrc="";

			if (!BasicStr.hasContent(html_String)) {
				if (standAlone) {
					html_String=mjaFile.readFile(source);
				} else {
					try {
						URL url=new URL(getDocumentBase(),source);
						html_String=mjaFile.readURL(url);
						if (!BasicStr.hasContent(html_String)) {
							System.out.println(url.toExternalForm()+"/"+source+" not found or is empty");
						}
					} catch (Exception e) {
						System.out.println(e.getMessage());
					}
				}
			}

			if (!BasicStr.hasContent(html_String)) {
				try {
					rsrc="/"+getDocumentBase().getHost()+getDocumentBase().getPath()+"/"+source;
					URL url=getClass().getResource(rsrc);
					url.openConnection();
					html_String=mjaFile.readURL(url);
				} catch (Exception e2) {
				}
			}

			if (!BasicStr.hasContent(html_String)) {
				try {
					rsrc="/"+source;
					InputStream is=getClass().getResourceAsStream(rsrc);
					html_String=mjaFile.readInputStream(is);
				} catch (Exception e1) {
				}
			}

			if (BasicStr.hasContent(html_String)) {
				Point[] P=mjaHtml.getAppletCodeLimits(html_String);
				if (P.length>0) {
					String appletString=html_String.substring(P[0].x,P[0].y);
					appletString=mjaHtml.decodeHTMLEncoding(appletString);
					String s_w=mjaHtml.getAppletAttribute(appletString,"width");
					PA.w0=BasicStr.parseInteger(s_w,320,320);
					String s_h=mjaHtml.getAppletAttribute(appletString,"height");
					PA.h0=BasicStr.parseInteger(s_h,200,200);
					String code=mjaHtml.getAppletAttribute(appletString,"code");
					if (code.endsWith(".class")) {
						code=code.substring(0,code.length()-6);
					}
					String archive=mjaHtml.getAppletAttribute(appletString,"archive");
					int TYPE=Prometeo_Nippe.Type(code,archive);
//System.out.println ("TYPE="+TYPE);
					Applet A=null;
					if (TYPE>=0) {
						Prometeo_Nippe N=new Prometeo_Nippe(parentFrame,Prometeo_Nippe.code(TYPE),Prometeo_Nippe.archive(TYPE),appletString,getCodeBase(),getDocumentBase());
						AbstractNippe AN=N.getApplet(this,true);
						AN.Promete= ((com.jla.nippe.Prometeo) this);
//System.out.println ("Promete="+AN.Promete);
						A=AN;
					} else {
						Class C=Class.forName(code);
						if (C!=null) {
							A=(Applet) C.newInstance();
							A.setStub(new PappletStub(this,mjaHtml.getAppletParams(appletString)));
						}
					}
					if (A!=null) {
						A.setName(mjaHtml.getAppletAttribute(appletString,"name"));
						A.setBounds(PA.getX(),PA.getY(),PA.w0,PA.h0);
					}
					PA.applet=A;
				} else {
					throw new Exception("applet not found in: "+source);
				}
			} else {
				throw new Exception("file not found: "+source);
			}
		} catch (Exception E) {
			E.printStackTrace();
			PA.applet.setBounds(-10-PA.w0,-10-PA.h0,PA.w0,PA.h0);
		}
	}

	private byte[] loadClassData(URL docbase,String name) {
		try {
			URL url=new URL(docbase,name);
			URLConnection c=url.openConnection();
			int N=c.getContentLength();
			byte[] b=new byte[N];
			InputStream is=c.getInputStream();
			is.read(b);
			return b;
			
		} catch (MalformedURLException e) {
			return null;
		} catch (IOException e) {
			return null;
		}
    }

	public void start() {
		if (Promete==null) {
			Promete=(com.jla.nippe.Prometeo) this;
		}
		for (int i=1;i<ANA.size();i++) {
			PromApplet PA=((PromApplet) ANA.elementAt(i));
			Applet A=PA.applet;
			A.setBounds(PA.getX(),PA.getY(),PA.getW(),PA.getH());
			A.init();
		}
		paintAll(getGraphics());
		for (int i=1;i<ANA.size();i++) {
			Applet A=((PromApplet) ANA.elementAt(i)).applet;
			if ( !(A instanceof com.mos.tablas.tabla) )  {
				A.start();
			}
		}
		for (int i=1;i<ANA.size();i++) {
			Applet A=((PromApplet) ANA.elementAt(i)).applet;
			if ((A instanceof com.mos.tablas.tabla)) {
				A.start();
			}
		}
		cleanMem(true);
	}
	
	public void stop() {
		for (int i=ANA.size()-1;i>0;i--) {
			Applet A=((PromApplet) ANA.elementAt(i)).applet;
			A.stop();
		}
		super.stop();
	}
	
	public void destroy() {
		for (int i=ANA.size()-1;i>0;i--) {
			Applet A=((PromApplet) ANA.elementAt(i)).applet;
			A.destroy();
		}
		super.destroy();
	}
	
	public void update(Graphics g) {
		paint(g);
	}

	public void paint(Graphics g) {
		if (backIm!=null) {
			g.drawImage(backIm,0,0,this);
		} else {
			super.paint(g);
		}
	}

	
	public void replace(Applet A,String filename) {
		for (int i=1;i<ANA.size();i++) {
			PromApplet PA=(PromApplet) ANA.elementAt(i);
			if (A==PA.applet) {
				Thread thr=new Thread(this);
				thr.start();
				int ix=0;
				for (ix=0;ix<countComponents();ix++) {
					if (getComponent(ix)==A) {
						break;
					}
				}
				if (ix==countComponents()) {
					System.out.println("applet not found in Prometeo");
					return;
				}
				setCursor(new Cursor(Cursor.WAIT_CURSOR));
				A.stop();
				A.setVisible(false);
				paint(getGraphics());
				remove(A);
				Applet Ad=A;
				readApplet(PA,filename);
				Applet Ac=PA.applet;
				Ac.init();

				setProgress(progress);

				Runtime.getRuntime().runFinalization();
				Runtime.getRuntime().gc();

				Ac.setVisible(false);
				add(Ac,ix);
				Ac.start();
				Ac.setVisible(true);
				Ac.paintAll(Ac.getGraphics());
				Ad.destroy();
				Ad=null;
				backIm=null;

				Runtime.getRuntime().runFinalization();
				Runtime.getRuntime().gc();
				setCursor(null);

				break;
			}
			if (i>=ANA.size()-1 && Promete!=this) {
				Prometeo P=(Prometeo) Promete;
				Image BI=P.createImage(P.getSize().width,P.getSize().height);
				Graphics g=BI.getGraphics();
				P.paintAll(g);
				P.backIm=BI;
				P.getGraphics().drawImage(P.backIm,0,0,P);
				P.replace(A,filename);
			}
		}
	}
	
	public Applet getAppletByName(String name) {
		for (int i=0;i<ANA.size();i++) {
			PromApplet PA=(PromApplet) ANA.elementAt(i);
			if (name.equals(PA.getName())) {
				return PA.applet;
			}
		}
		if (Promete !=this) {
			Prometeo P=(Prometeo) Promete;
			Applet A=P.getAppletByName(name);
			if (A != null) {
				return A;
			}
		}
		return null;
	}
	
	public URL getDocumentBase() {
		if (standAlone) {
			try {
				return new URL("file://");
			} catch (Exception e) {
				return null;
			}
		} else {
			return super.getDocumentBase();
		}
	}
	
	public URL getCodeBase() {
		if (standAlone) {
			try {
				return new URL("file://");
			} catch (Exception e) {
				return null;
			}
		} else {
			return super.getCodeBase();
		}
	}
	
	/*----------------------- AppletContext interface -----------------*/
	
	public Applet getApplet(String name) {
		return getAppletByName(name);
	}

	public Enumeration getApplets() {
		Vector VA=new Vector();
		for (int i=0;i<ANA.size();i++) {
			VA.addElement(((PromApplet) ANA.elementAt(i)).applet);
		}
		return VA.elements();
	}
	
	public void showDocument(URL url) {
		getAppletContext().showDocument(url);
	}

	public void showDocument(URL url,String s) {
		getAppletContext().showDocument(url,s);
	}

	public InputStream getStream(String key) {
		// TODO Auto-generated method stub
		return null;
	}

	public Iterator getStreamKeys() {
		// TODO Auto-generated method stub
		return null;
	}

	public void setStream(String key, InputStream stream) throws IOException {
		// TODO Auto-generated method stub
		
	}
	
}

class PappletStub implements AppletStub {
	
	
	private Hashtable ht;
	private Applet A;
	
	PappletStub(Applet A, Hashtable ht) {
		this.A=A;
		this.ht=ht;
	}
	
	public void appletResize(int dx,int dy) {
	}
	
	public String getParameter(String name) {
		return (String) ht.get(name);
	}
	
	public boolean isActive() {
		return A.isActive();
	}
	
	public URL getCodeBase() {
		return A.getCodeBase();
	}

	public URL getDocumentBase() {
		return A.getDocumentBase();
	}
	
	public AppletContext getAppletContext() {
		return A.getAppletContext();
	}
	
}

class PromApplet {
	
	PromApplet(String name,int x0,int y0) {
		this.name=name;
		this.x0=x0;
		this.y0=y0;
	}
	
	private String name;
	private int x0,y0;
	Applet applet;
	int w0,h0;
	
	String getName() {
		return name;
	}
	
	int getX() {
		return x0;
	}
	
	int getY() {
		return y0;
	}

	int getW() {
		return w0;
	}
	
	int getH() {
		return h0;
	}

}

/*
class PromLoader extends ClassLoader {
	
	URL docbase;
	
	PromLoader(ClassLoader parent,URL docbase) {
		super(parent);
		this.docbase=docbase;
	}
	
	public Class findClass(String name) {
		byte[] b=loadClassData(name);
		if (b!=null) {
			return defineClass(name, b, 0, b.length);
		} else {
			return null;
		}
	}
	
	private byte[] loadClassData(String name) {
		try {
			URL url=new URL(docbase,name);
			URLConnection c=url.openConnection();
			int N=c.getContentLength();
			byte[] b=new byte[N];
			InputStream is=c.getInputStream();
			is.read(b);
			return b;
			
		} catch (MalformedURLException e) {
			return null;
		} catch (IOException e) {
			return null;
		}
    }
	
}
*/