package com.jla.versionManager.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.LayoutManager2;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.Arrays;
import java.util.Vector;

import javax.swing.Box;
import javax.swing.BoxLayout; 
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.border.EmptyBorder;
import javax.swing.table.DefaultTableModel;

public class UpdateLibraryQuestion extends JDialog {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	private JTable table;
	protected int selectedClosebtn = JOptionPane.CLOSED_OPTION;
	private JPanel detailsContainer;
	private int initHeight = 200;
	private int initWidth = 420;
	private int maxHeight = 250;
	private Icon iconExpanded;	
	private Icon iconClosed;
	private Icon iconInfo;	
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					UpdateLibraryQuestion frame = new UpdateLibraryQuestion();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	public UpdateLibraryQuestion() {
		iconExpanded = UIManager.getIcon("Tree.expandedIcon");
		iconClosed = UIManager.getIcon("Tree.collapsedIcon");
		iconInfo = UIManager.getIcon("OptionPane.informationIcon");
		
		/*TODO Falta agregar las traducciones */
		String strWindowsTitle = "Actualizar bibliotecas"; 
		String strUpdateMsg = "Hay actualizaciones disponibles. Desea instalarlas?";
		final String strBtnDetailsLabel = "Detalles";
		final String strBtnHideLabel = "Ocultar";
		String strBtnOk = "Aceptar";
		String strBtnCancel = "Cancelar";
		
		
		setPreferredSize(new Dimension(initWidth, initHeight));
		setMaximumSize(new Dimension(initWidth, 50000));
		setResizable(false);
		addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosed(WindowEvent e) {
				UpdateLibraryQuestion.this.selectedClosebtn = JOptionPane.CLOSED_OPTION;
			}
		});
		setTitle(strWindowsTitle);

		setModal(true);
//		setModalExclusionType(ModalExclusionType.APPLICATION_EXCLUDE);
//		setModalityType(ModalityType.APPLICATION_MODAL);
		
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(15, 15, 15,15));
		contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.Y_AXIS));
		setContentPane(contentPane);
		
		JPanel panel = new JPanel();
		panel.setBorder(new EmptyBorder(0, 0, 5, 0));
		contentPane.add(panel);
		panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
		
		JLabel lblGtatsatas = new JLabel("<html>"+strUpdateMsg+"</html>");
		lblGtatsatas.setIcon(iconInfo);
		lblGtatsatas.setIconTextGap(10);
		panel.add(lblGtatsatas);
		
		detailsContainer = new JPanel();
		detailsContainer.setBackground(Color.RED);
		detailsContainer.setBorder(new EmptyBorder(0, 0, 0, 0));
		contentPane.add(detailsContainer);
		LayoutManager2 tmpBLy = new BorderLayout(0, 5);
		tmpBLy = new BoxLayout(detailsContainer,BoxLayout.Y_AXIS);
		detailsContainer.setLayout(tmpBLy);
		
		JPanel panel_3 = new JPanel();
		panel_3.setBorder(new EmptyBorder(0, 0, 5, 0));
		detailsContainer.add(panel_3, BorderLayout.NORTH);
		panel_3.setLayout(new BoxLayout(panel_3, BoxLayout.X_AXIS));
		
		final JButton btnDetalles = new JButton(strBtnDetailsLabel);
		btnDetalles.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
		btnDetalles.setMargin(new Insets(0, 0, 0, 0));
//		btnDetalles.setHideActionText(true);
		btnDetalles.setFocusable(false);
		btnDetalles.setFocusPainted(false);
		btnDetalles.setAlignmentY(Component.TOP_ALIGNMENT);
		btnDetalles.setOpaque(false);
		btnDetalles.setContentAreaFilled(false);
		btnDetalles.setBorderPainted(false);
		
		btnDetalles.setIcon(iconClosed);
			
		btnDetalles.setHorizontalAlignment(SwingConstants.LEFT);
		panel_3.add(btnDetalles);
		
		Component horizontalGlue = Box.createHorizontalGlue();
		panel_3.add(horizontalGlue);
		
		
		final JPanel detallesDataContainer = new JPanel();
		detailsContainer.add(detallesDataContainer, BorderLayout.CENTER); //No lo agegamos de inicio
		detallesDataContainer.setLayout(new GridLayout(0, 1, 0, 0));
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setPreferredSize(new Dimension(initWidth, initHeight));
		scrollPane.setMaximumSize(new Dimension(initWidth, initHeight));
		detallesDataContainer.add(scrollPane);
		
		table = new JTable();
		table.setRowSelectionAllowed(false);
		table.setCellSelectionEnabled(false);
		table.setModel(new SelectionTableModel());
//		table.setFillsViewportHeight(true);
		scrollPane.setViewportView(table);
		
		Component verticalGlue = Box.createVerticalGlue();
		contentPane.add(verticalGlue);
		
		JPanel panel_1 = new JPanel();
		contentPane.add(panel_1);
		panel_1.setLayout(new BoxLayout(panel_1, BoxLayout.X_AXIS));
		
		Component horizontalGlue_1 = Box.createHorizontalGlue();
		panel_1.add(horizontalGlue_1);
		
		JButton btnAceptar = new JButton(strBtnOk);
		
		panel_1.add(btnAceptar);
		
		Box horizontalBox = Box.createHorizontalBox();
		horizontalBox.setPreferredSize(new Dimension(5, 0));
		horizontalBox.setAlignmentY(Component.CENTER_ALIGNMENT);
		panel_1.add(horizontalBox);
		
		JButton btnCancelar = new JButton(strBtnCancel);
		
		
		panel_1.add(btnCancelar);

		
		
		
		
		
		btnDetalles.addActionListener(new ActionListener() {
			boolean open = false;
			
			public void actionPerformed(ActionEvent e) {
				open = !open;
				Dimension tmpD = UpdateLibraryQuestion.this.getSize();
				if(open){
					btnDetalles.setIcon(iconExpanded);
					btnDetalles.setText(strBtnHideLabel);
					detailsContainer.add(detallesDataContainer,BorderLayout.CENTER);
					tmpD.setSize(tmpD.getWidth(), maxHeight );
				} else {
					btnDetalles.setIcon(iconClosed);
					btnDetalles.setText(strBtnDetailsLabel);
					detailsContainer.remove(detallesDataContainer);
					detallesDataContainer.invalidate();
					tmpD.setSize(tmpD.getWidth(), initHeight);
				}
				UpdateLibraryQuestion.this.setPreferredSize(tmpD);
				UpdateLibraryQuestion.this.setSize(tmpD);
				
				UpdateLibraryQuestion.this.setPreferredSize(tmpD);
				UpdateLibraryQuestion.this.pack();
				UpdateLibraryQuestion.this.repaint();
			}
		});
		btnAceptar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				UpdateLibraryQuestion.this.setVisible(false);
//				UpdateLibraryQuestion.this.dispose();
				UpdateLibraryQuestion.this.selectedClosebtn = JOptionPane.OK_OPTION;
			}
		});
		btnCancelar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				UpdateLibraryQuestion.this.setVisible(false);
//				UpdateLibraryQuestion.this.dispose();
				UpdateLibraryQuestion.this.selectedClosebtn = JOptionPane.CANCEL_OPTION;
			}
		});
		
		detailsContainer.remove(detallesDataContainer);
		this.pack();

		this.initHeight = this.getHeight();
		setLocationRelativeTo(null);
	}
	
	
	
	
	public void setLibraryData(String[] tableHead,Object [][] tableData, boolean defaultSelected){
		String titleHeadSel = "Update"; 
		SelectionTableModel tModel = (SelectionTableModel)this.table.getModel(); 
		
		
		String[] tableHead2 = new String[tableHead.length+1];
		tableHead2[0] = titleHeadSel;
		System.arraycopy(tableHead, 0, tableHead2, 1, tableHead.length);
		tModel.setColumnIdentifiers(tableHead2);
		for (int i = 0; i < tableData.length; i++) {
			
			Object[] tableRow = tableData[i];
			Object[] tableRow2 = new Object[tableRow.length +1];
			System.arraycopy(tableRow, 0, tableRow2, 1, tableRow.length);
			tableRow2[0] = new Boolean(defaultSelected);
			
			//We need get the next index for this row, and then add it to the table
			int rowCount = tModel.getRowCount();
			
			tModel.addRow(tableRow2);
			tModel.setCellEditable(rowCount, 0, true);
			for (int j = 1; j < tableRow.length; j++) {
				tModel.setCellEditable(rowCount, j, false);	
			}
		}
		int firstColumWidth = 50;
		this.table.getColumnModel().getColumn(0).setPreferredWidth(firstColumWidth);
		this.table.getColumnModel().getColumn(0).setMaxWidth(firstColumWidth);
	}
	
	
	/**
	 * Return the row index of selected items.
	 * @return
	 */
	public int[] getSelected(){
		SelectionTableModel tableM = (SelectionTableModel)this.table.getModel();
		Vector<Integer> res = new Vector<Integer>();
		
		for (int i = 0; i < tableM.getRowCount(); i++) {
			if((Boolean) tableM.getValueAt(i, 0)){
				res.add(i); 
			}
		}
		
		int [] arrayRes = new int[res.size()]; 
		for (int i = 0; i < res.size(); i++) {
			arrayRes[i] = res.get(i);
					
		}
		return arrayRes;
	}
	
	public int getSelectedCloseBtn(){
		return this.selectedClosebtn;
	}
	
	@SuppressWarnings("serial")
	private class SelectionTableModel extends DefaultTableModel {
		private boolean[][] cfgCellEditable = {{true}}; 
		
		@SuppressWarnings({ "unchecked", "rawtypes" })
		public Class getColumnClass(int c) {
			return getValueAt(0, c).getClass();
		}

		public boolean isCellEditable(int row, int column) {
			int nCols = this.getColumnCount();
			int nRows = this.getRowCount();
			if(cfgCellEditable.length != nRows || cfgCellEditable[0].length != nCols){
				rebuildArrayCfgEditable();
			}
			return cfgCellEditable[row][column];
		}
		
		public void setCellEditable(int row, int column, boolean isEditable){
			int nCols = this.getColumnCount();
			int nRows = this.getRowCount();
			if(cfgCellEditable.length < nRows || cfgCellEditable[0].length < nCols){
				rebuildArrayCfgEditable();
			}
			
			cfgCellEditable[row][column] = isEditable;
		}
		
		
		private void rebuildArrayCfgEditable() {
			int nCols = this.getColumnCount();
			int nRows = this.getRowCount();
			boolean[][] cfgCellEditableAnt = cfgCellEditable;
			
			nRows = Math.max(1,nRows);
			nCols = Math.max(1,nCols);
			
			cfgCellEditable = new boolean[nRows][nCols];
			for (int i = 0; i < cfgCellEditableAnt.length; i++) {
				Arrays.fill(cfgCellEditable[i], true);
			}
			
			int minNRows = Math.min(cfgCellEditableAnt.length, cfgCellEditable.length);
			int minNCols = Math.min(cfgCellEditableAnt[0].length, cfgCellEditable[0].length);
			
			for (int i = 0; i < minNRows ; i++) {
				for (int j = 0; j < minNCols; j++) {
					cfgCellEditable[i][j] = cfgCellEditableAnt[i][j]; 
				}
			}
		}
	}
}


