/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import com.mja.algebra.*;
import java.util.*;

public class ANode_AA extends ANode {

	public ANode_AA(ANode AN) {
		super(AN.N,AN.an_cfg);
	}

	public void perform_AA_0(Vector V) {
		ANode AN=null;
		String msg="";
		String cond="";
		if (L.equals(R)) {
			msg="A "+symbol+" A";
			if (isSum()) {
				AN=Mul(Num(2),L);
				msg="A + A = 2 A";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isSub()) {
				AN=Num(0);
				msg="A - A = 0";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isMul()) {
				AN=Exp(R,Num(2));
				msg="A * A = A ^ 2";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isDiv()) {
				AN=Num(1);
				msg="A / A = 1";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isExp()) {		// a ^ a
				if (R.equals(Num(2))) {
					AN=Mul(L,L);
					msg="A ^ 2 = A * A";
					addResultado(V,new Resultado(AN,msg,cond));
				}
			} else if (isRoot()) {		// a \ a
			} else if (isComp()) {		// a = a
				AN=Num(1);
				msg="(A = A) => 1";
				addResultado(V,new Resultado(AN,msg,cond));
			}
		} else {
			if (isSum()) {
			} else if (isSub()) {
			} else if (isMul()) {
			} else if (isDiv()) {
			} else if (isExp()) {		// a ^ b
			} else if (isRoot()) {		// a \ b
			} else if (isComp()) {		// a =? b
//				if (isEqual()) {    // cambiado a perform_AA_1 el 8 de abril de 2006
//					AN=Equal(R,L);
//					msg="A = B == B = A";
//					addResultado(V,new Resultado(AN,msg,cond));
//				}
			}
		}
	}

	public void perform_AA_1(Vector V) {
		ANode AN=null;
		String msg="";
		String cond="";
		if (L.equals(R)) {
			msg="A "+symbol+" A";
			if (isSum()) {
				AN=Mul(Num(2),R);
				msg="A + A = 2*A";
				addResultado(V,new Resultado(AN,msg,cond));
			} else if (isSub()) {
			} else if (isMul()) {
			} else if (isDiv()) {
			} else if (isExp()) {		// a ^ a
			} else if (isRoot()) {		// a \ a
			} else if (isComp()) {		// a = a
			}
		}
		if (isSum()) {
			AN=Sum(R,L);
			msg="A + B = B + A";
			addResultado(V,new Resultado(AN,msg,cond));
		} else if (isSub()) {
			AN=Sum(Minus(R),L);
			msg="A - B = -B + A";
			addResultado(V,new Resultado(AN,msg,cond));
		} else if (isMul()) {
			if ((!L.isNumber())|R.isNumber()) {
				AN=Mul(R,L);
				msg="A * B = B * A";
				addResultado(V,new Resultado(AN,msg,cond));
			}
		} else if (isDiv()) {
			AN=(Mul(L,Exp(R,Minus(Num(1)))));
			msg="A / B = A * (B ^(-1))";
			addResultado(V,new Resultado(AN,msg,cond));
		} else if (isExp()) {		// a ^ b
			AN=Root(Div(Num(1),R),L);
			msg="A ^ B = (1/B) \\ A";
			addResultado(V,new Resultado(AN,msg,cond));
		} else if (isRoot()) {		// a \ b
			AN=Exp(R,Div(Num(1),L));
			msg="A \\ B = B ^ (1/A)";
			addResultado(V,new Resultado(AN,msg,cond));
		} else if (isComp()) {		// a =? b
			if (isEqual()) {
				AN=Equal(R,L);
				msg="A = B == B = A";
				addResultado(V,new Resultado(AN,msg,cond));
				AN=Equal(Sub(L,R),Num(0));
				msg="A = B == A - B = 0";
				addResultado(V,new Resultado(AN,msg,cond));
				AN=Equal(Div(L,R),Num(1));
				msg="A = B == A / B = 1";
				addResultado(V,new Resultado(AN,msg,cond));
			}
		}
	}

}