/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.algebra;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.applet.*;
import com.mja.file.*;
import com.mja.util.*;
import com.mja.parser.*;

public class ExerciseEditor extends Dialog implements ActionListener, WindowListener {
	
	private static Frame Father=new Frame();
	
	private DescartesA M;
	private boolean accepted;
	private Button b_accept, b_cancel;
	private ExercisePanel EP;
	private ExerciseConfig ecfg;
	
	public ExerciseEditor(DescartesA MM) {
		super(Father,"Editar ejercicio",true);
		M=MM;
		setLayout(new BorderLayout());
		EP=new ExercisePanel(MM);
		add("Center",EP);
		Panel SP=new Panel();
		SP.setLayout(new FlowLayout());
		b_accept=new Button("aceptar");
		b_accept.addActionListener(this);
		SP.add(b_accept);
		b_cancel=new Button("cancelar");
		b_cancel.addActionListener(this);
		SP.add(b_cancel);
		add("South",SP);
		addWindowListener(this);
	}

	public void edit(ExerciseConfig ecfg) {
		this.ecfg=ecfg;
		EP.edit(ecfg);
		Dimension SCsz=Toolkit.getDefaultToolkit().getScreenSize();
		setSize(M.getSize().width+8,M.getSize().height);
		Dimension d=getSize();
		setLocation((SCsz.width-d.width)/2,(SCsz.height-d.height)/2);
		setVisible(true);
	}
	
	public boolean accepted() {
		return accepted;
	}

/* --------------------- Action Listener  --------------------- */

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b_accept) {
			accepted=true;
			EP.apply(ecfg);
			setVisible(false);
		} else if (e.getSource()==b_cancel) {
			accepted=false;
			setVisible(false);
		}
	}


/* --------------------- Window Listener  --------------------- */

	public void windowOpened(WindowEvent e) {
	}
	public void windowClosed(WindowEvent e) {
	}
	public void windowClosing(WindowEvent e) {
		accepted=false;
		setVisible(false);
	}
	public void windowActivated(WindowEvent e) {
	}
	public void windowDeactivated(WindowEvent e) {
	}
	public void windowIconified(WindowEvent e) {
	}
	public void windowDeiconified(WindowEvent e) {
	}

}

class ExercisePanel extends Panel {

	private DescartesA M;
	private TextField TF_instr;
	private TextArea TAExpr=new TextArea("",10,24);
	private TextArea TAExpl=new TextArea("",10,48);

	ExercisePanel(DescartesA MM) {
		this.M=MM;
		setLayout(new BorderLayout());
		Panel NP=new Panel();
		NP.setLayout(new BorderLayout());
		Label lb=new Label("Instrucciones");
		lb.setAlignment(Label.CENTER);
		lb.setFont(mjaFont.AWTSansSerif);
		TF_instr=new TextField();
		TF_instr.setFont(mjaFont.AWTMono);
		TAExpr.setFont(mjaFont.AWTMono);
		TAExpl.setFont(mjaFont.AWTSansSerif);
		NP.add("West",lb);
		NP.add("Center",TF_instr);
		add("North",NP);
		add("West",TAExpr);
		add("Center",TAExpl);
	}
	
	void edit(ExerciseConfig ecfg) {
		TF_instr.setText(ecfg.getInstruction());
		TAExpr.setText(ecfg.getOExpressions());
		TAExpl.setText(ecfg.getAllExplanations());
	}
	
	void apply(ExerciseConfig ecfg) {
		if (ecfg!=null) {
			ecfg.setValues(TF_instr.getText(),TAExpr.getText(),TAExpl.getText());
		} else {
			TF_instr.setText("");
			TAExpr.setText("");
			TAExpl.setText("");
		}
	}
	
}