/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

/*------------------------------------------------------------*/
/*                         Curve		                           */
/*                         (c)  MJA     	                      */
/*                       Mayo de 2016                        */
/*------------------------------------------------------------*/

import javax.swing.*;

import java.awt.*;
import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.util.*;
import java.net.*;
import javax.swing.JTextField;
import com.mja.parser.*;
import com.mja.util.*;
import com.mja.math.*;
import com.mja.file.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.lang.*;
import com.mja.poly.*;
import com.mja.text.*;

public class Curve {
	
		boolean draw=false;
		Color bc=Color.white,fc=Color.black;
		boolean fill=false;
		boolean isCircle=false;
		double radius=1;
		double ai=0;
		double da=360;
		int sz=1;
		double[] X=new double[sz];
		double[] Y=new double[sz];
		int WIDTH=1;
		int SIZE=2;
		Node decimals;
		boolean fixed=true;
		boolean hasBorder=false;
		Color borderColor;
		int xt=20, dyt=0;
		MathText mt=null;
		
		public Curve() {
		}

	public String toTeX(Component C,int H,boolean grayscale) {
		Color BC=bc;
		Color FC=fc;
		String bcn="bc";
		String fcn="fc";
		double width=((double) WIDTH)/2.0;
		String str="";
		boolean extraline=false;
		if ((sz==0)|!draw) {
		} else if (sz==1) {
			if (isCircle) {
				str=str+BasicStr.DefineColor(grayscale,fcn,FC);
				if (da==360) {
					if (fill) {
						str=str+BasicStr.DefineColor(grayscale,bcn,BC);
						str=str+"\\pscircle[linecolor="+fcn+",linewidth="+width+"pt,fillstyle=solid,fillcolor="+bcn+"]("+BasicStr.DblStr(X[0])+","+BasicStr.DblStr(H-Y[0])+"){"+BasicStr.DblStr(radius)+"}\r\n";
					} else {
						str=str+"\\pscircle[linecolor="+fcn+",linewidth="+width+"pt,fillstyle=none]("+BasicStr.DblStr(X[0])+","+BasicStr.DblStr(H-Y[0])+"){"+BasicStr.DblStr(radius)+"}\r\n";
					}
					str=str+"\r\n";
				} else {
					if (fill) {
						str=str+BasicStr.DefineColor(grayscale,bcn,BC)+"\r\n";
						str=str+"\\pswedge[linewidth="+width+"pt,linecolor="+bcn+",fillcolor="+bcn+",fillstyle=solid]("+BasicStr.DblStr(X[0])+","+BasicStr.DblStr(H-Y[0])+"){"+BasicStr.DblStr(radius)+"}{"+BasicStr.DblStr(ai)+"}{"+BasicStr.DblStr(ai+da)+"}\r\n";
					}
					str=str+BasicStr.DefineColor(grayscale,fcn,FC)+"\r\n";
					str=str+"\\psarc[linewidth="+width+"pt,linecolor="+fcn+",fillstyle=none]("+BasicStr.DblStr(X[0])+","+BasicStr.DblStr(H-Y[0])+"){"+BasicStr.DblStr(radius)+"}{"+BasicStr.DblStr(ai)+"}{"+BasicStr.DblStr(ai+da)+"}\r\n";
				}
				str=str+"\r\n";
			}
		} else if (sz==2) {
			str=str+BasicStr.DefineColor(grayscale,fcn,FC)+"\r\n";
			if ((X.length>1)&&(X[0]==X[1])&&(Y[0]==Y[1])) { // es un punto
				if (width>0) {
					str=str+"\\pscircle[linewidth=0.1pt,fillstyle=solid,fillcolor="+fcn+",linecolor="+fcn+"]("+BasicStr.DblStr(X[0])+","+BasicStr.DblStr(H-Y[0])+"){"+BasicStr.DblStr(SIZE)+"}\r\n";
					extraline=true;
				}
			} else {
				str=str+"\\psline[showpoints=false,linewidth="+BasicStr.DblStr(width)+"pt,linecolor="+fcn+"]";
				str=str+"("+BasicStr.DblStr(X[0])+","+BasicStr.DblStr(H-Y[0])+")";
				if ((X.length>1)&&(Y.length>1)) {
					str=str+"("+BasicStr.DblStr(X[1])+","+BasicStr.DblStr(H-Y[1])+")\r\n";
				}
				extraline=true;
			}
			if (mt!=null) {
				str=str+mt.getTeXColors(grayscale);
				if (hasBorder) {
					str=str+BasicStr.DefineColor(grayscale,fcn,borderColor)+"\r\n";
				}
				int yt=mt.getTextY(C)+dyt;
				if (hasBorder) {
					str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt+1)+","+BasicStr.DblStr(H-yt-0)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(borderColor,false)+"}}\r\n";
					str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt+1)+","+BasicStr.DblStr(H-yt-1)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(borderColor,false)+"}}\r\n";
					str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt+0)+","+BasicStr.DblStr(H-yt-1)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(borderColor,false)+"}}\r\n";
					str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt-1)+","+BasicStr.DblStr(H-yt-1)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(borderColor,false)+"}}\r\n";
					str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt-1)+","+BasicStr.DblStr(H-yt-0)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(borderColor,false)+"}}\r\n";
					str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt-1)+","+BasicStr.DblStr(H-yt+1)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(borderColor,false)+"}}\r\n";
					str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt-0)+","+BasicStr.DblStr(H-yt+1)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(borderColor,false)+"}}\r\n";
					str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt+1)+","+BasicStr.DblStr(H-yt+1)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(borderColor,false)+"}}\r\n";
				}
				if (hasBorder) {
					str=str+BasicStr.DefineColor(grayscale,fcn,FC)+"\r\n";
				}
				str=str+"\\uput{1pt}[30]("+BasicStr.DblStr(xt)+","+BasicStr.DblStr(H-yt)+"){\\shortstack[l]{\\color{fc} "+mt.toTeX(FC,true)+"}}\r\n";
				extraline=true;
			}
		} else {
			str=str+BasicStr.DefineColor(grayscale,fcn,FC);
			str=str+BasicStr.DefineColor(grayscale,bcn,BC);
			if (fill) {
				str=str+"\\pspolygon[linewidth=0.01pt,linecolor="+bcn+",fillcolor="+bcn+",fillstyle=solid]";
				for (int j=0;j<sz;j++) {
					str=str+"("+BasicStr.DblStr(X[j])+","+BasicStr.DblStr(H-Y[j])+")";
				}
				extraline=true;
			}
			if ((width>0)&(FC.getAlpha()>0)) {
				str=str+"\\psline[showpoints=false,linewidth="+width+"pt,linecolor="+fcn+"]";
				for (int j=0;j<sz;j++) {
					str=str+"("+BasicStr.DblStr(X[j])+","+BasicStr.DblStr(H-Y[j])+")";
				}
				extraline=true;
			}
			str=str+"\r\n\r\n";
		}
		return str;
	}

}