/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;
/*------------------------------------------------------------*/
/*                         Descartes                          */
/*                          (c) MJA                           */
/*                        Enero de 2001                       */
/*------------------------------------------------------------*/


import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.UIManager;
import com.jla.nippe.*;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.lang.*;
import com.mja.gui.*;
import com.mja.cmp.*;
import com.mja.parser.*;
import com.mja.descgui.*;
import org.unam.matem.Attribute;
import org.unam.matem.Communicator;

public class Descartes extends com.jla.nippe.LMSApplet 
		implements ActionListener, MouseListener, KeyListener {
			
	public static final Color appletGB=new Color(0xe0e4e8);
	public static final Color basicBlue=new Color(0xdbdddf);

	public volatile config cfg;
	public translator Tr;
	public boolean undo_active=true, usarSonido=false, usarAlgebra=false;
	public boolean inArquimedes=false;
	
	protected Attribute Space,Buttons,Animation;
	protected Vector Params, Spaces, Graphs, Graphs3D, Aux, Controls;
	private edu.cr.descartes.copyright aboutFrame;

	public Scene scene;
	Vector eventActions;
	Descartes father;
	Panel mainP;

	private static boolean versionShown=false;
	boolean pop=false;
	private Panel north,center,south,east,west;
	private static final int ixhelp=0, ixcfg=1, ixini=2, ixclear=3;
	private mjaButton[] b,be;
	private mjaButton banim,binianim,banime,binianime,b_verif, b_solution, b_answer;
	private Label lb_nota,lb_puntos,lb_buenos,lb_malos;
	private Panel panim;
	private NumericControl[] numctrls;
	private Panel nsp,ssp, esp,ecp;
	private editFrame extSpinFrame;
	private editFrame editConfigFrame;
	private Button mainB;
	private DescartesFrame mainF;
	private Object LMS_activity;
	private boolean modified=false;
	private doed dd;
	Hashtable imagesHT;
	Vector macroFiles;
	Vector fileNames;
	
	public boolean disableControls=false;
	
	public NumericControl[] getNumCtrls() {
		return numctrls;
	}

	public String class_Id() {
		return "Descartes 4";
	}

	protected static String getVersion() {
		return data.Version;
	}
	
	private boolean isDescartesWeb2_0=true;
	
	protected void setDescartesWeb2_0(boolean b) {
		isDescartesWeb2_0=b;
	}

	public boolean isDescartesWeb2_0() {
		return isDescartesWeb2_0;
	}
	
	public static String getDefaultConfig(String codebase) {
		try {
			Object O=new Object();
			URL url=O.getClass().getResource("/resources/modelos/Descartes5.html");
			String descartes_html=mjaFile.readURL(url);
			descartes_html=mjaHtml.decodeHTMLEncoding(descartes_html);
			String str_applet=descartes_html.substring(descartes_html.toLowerCase().indexOf("<applet"),descartes_html.toLowerCase().indexOf("</applet>")+9);
			return str_applet+"\n";
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		}
	}

	private static boolean busy,inEval;
	
	private static boolean isBusy() {
		return busy;
	}
	
	public boolean inEvaluation() {
		return inEval;
	}

	public boolean isArquimedesItem() {
		return (this instanceof Item);
	}

/* ---------------- Communicator Interface --------------- */

	public Attribute[] getState() {
		return p.getState();
	}
	
	public void changed(Communicator cc) {
		Attribute[] aa=cc.getState();
		boolean changed=p.adoptValues(aa);
		if (changed) {
			refresh(true);
		}
	}
	
	private Image D_logo=null;
	
/* ------------------------------------------------------- */

	public void init() {
		setBackground(basicBlue);
		while (isBusy()) {
			try {
				Thread.sleep(50);
			} catch (InterruptedException e) {
			}
		}
		busy=true;
		if (! (this instanceof Arquimedes)) {
			setDescartesWeb2_0(false);
		}
		try {
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Exception e) {
		}
		if (!versionShown) { /* a new web page with a Descartes applet writes its version in the Java console. */
			System.out.println(BasicStr.getOs());
			System.out.println(class_Id()+" ver. "+data.Version);
			versionShown=true;
			mjaFont.prepareFonts(this); /* preparing special fonts */
			mjaColor.cm=getColorModel();
		}
		super.init();
		if (!inWeb()&&!toRun()) {
			doInit();
		}
		busy=false;
	}
	
	private boolean initComplete=false;

	public void start() {
//		int n=0;
//System.out.println("start "+n); n++;
		if (!initComplete) {
			doInit();
		}
//System.out.println("start "+n); n++;
		updateProposedDimension();
		cleanMem(false);
		rebuild(getSize());
		removeAll();
//System.out.println("start "+n); n++;
		mainP.setLayout(new BorderLayout());
		mainP.add("North",north);
		mainP.add("Center",center);
		mainP.add("South",south);
		mainP.add("East",east);
		mainP.add("West",west);
		if (!pop) {
			try {
				Thread.sleep(100);
			} catch (InterruptedException ie) {
			}
//System.out.println("start "+n); n++;
			startScene(true);
		}
//System.out.println("start "+n); n++;
		ready=true;
	}
	
	private void doInit() {
//System.out.println("Descartes.doInit() 1");
		imagesHT=new Hashtable();
		if (inWeb()) {
			try {
				if (this instanceof Arquimedes) {
					D_logo=Toolkit.getDefaultToolkit().getImage(getClass().getResource("/resources/A_loader.png"));
		
				} else {
					D_logo=Toolkit.getDefaultToolkit().getImage(getClass().getResource("/resources/D_loader.png"));
				}
			} catch (Exception e) {
			}
		}
		paint(getGraphics());
		Tr=new translator(this);
		disableControls=(BasicStr.hasContent(getParameter("enabled")) && ("false".equals(getParameter("enabled"))));
		BasicStr.antialias=BasicStr.antialias||Tr.isTrue(getParameter("antialias"));
		getToolsFromApplet(this);
		Attribute popa=Tr.getParam(this,data.pop);
		pop=popa!=null && BasicStr.hasContent(popa.value);
		Attribute[] AA=getAttributesFromTools();
		macroFiles=new Vector();
		fileNames=new Vector();
		cfg=new config(this,AA);
		UseRAD=cfg.useRAD;
		if (pop) {
			setLayout(new GridLayout(1,1));
			if (BasicStr.hasContent(cfg.name)) {
				mainB=new Button(cfg.name);
			} else {
				mainB=new Button("Descartes");
			}
			mainB.setFont(mjaFont.AWTMono);
			mainB.addActionListener(this);
			mainB.addMouseListener(this);
			mainB.addKeyListener(this);
			add(mainB);
			Attribute[] popaa=Attribute.parse(popa.value);
			popWidth0=BasicStr.parseInteger(Attribute.getValue(popaa,"width"),480,480);
			popHeight0=BasicStr.parseInteger(Attribute.getValue(popaa,"height"),360,360);
			mainP=new Panel();
		} else {
			mainP=this;
			popWidth0=100;
			popHeight0=25;
		}
		mainP.setBackground(basicBlue);
		construct(mainP);
		inEval=(getDocumentBase().toExternalForm().indexOf("verify=true")>=0);
		initComplete=true;
//System.out.println("Descartes.doInit() "+n); n++;
	}

	public Hashtable getImagesHashtable() {
		return imagesHT;
	}

	public void addMacroFilename(String filename) {
		for (int i=0;i<macroFiles.size();i++) {
			String fn=(String) macroFiles.elementAt(i);
			if (fn.equals(filename)) {
				return;
			}
		}
		macroFiles.addElement(filename);
	}

	public void addFilename(String filename) {
		for (int i=0;i<fileNames.size();i++) {
			String fn=(String) fileNames.elementAt(i);
			if (fn.equals(filename)) {
				return;
			}
		}
		fileNames.addElement(filename);
	}

	public String[] getFilePaths() {
		Vector dataFiles=p.getDataFilePaths();
		String[] fn=p.guessFilenames();
		for (int i=0;i<fn.length;i++) {
			addFilename(fn[i]);
		}
		String[] files=new String[dataFiles.size()+imagesHT.size()+macroFiles.size()+fileNames.size()];
		int k=0;
		Enumeration E=dataFiles.elements();
		for (int i=0;i<dataFiles.size();i++) {
			files[k++]=(String) E.nextElement();
		}
		E=imagesHT.keys();
		for (int i=0;i<imagesHT.size();i++) {
			files[k++]=(String) E.nextElement();
		}
		E=macroFiles.elements();
		for (int i=0;i<macroFiles.size();i++) {
			files[k++]=(String) E.nextElement();
		}
		E=fileNames.elements();
		for (int i=0;i<fileNames.size();i++) {
			files[k++]=(String) E.nextElement();
		}
		return files;
	}

	protected String getInfoInd() {
		return cfg.txt_infoind;
	}

	protected String getInfoEst() {
		return cfg.txt_infoest;
	}

	private Applet AP;

	public void getAppletParamsFrom(Applet AP) {
		this.AP=AP;
	}

	public void updateProposedDimension() {
		if (dd!=null && editConfigFrame!=null) {
			proposedDimension=dd.proposedDimension();
		} else {
			proposedDimension=getRealSize();
		}
	}

	public Dimension getRealSize() {
		return super.getSize();
	}

	public Dimension getSize() {
		if (pop) {
			return new Dimension(popWidth0,popHeight0);
		} else {
			return super.getSize();
		}
	}

	public boolean isPop() {
		return pop;
	}
	
	public void closeScene() {
		if (getParent() instanceof DescartesDialog) {
			DescartesDialog DD=(DescartesDialog) getParent();
			DD.setVisible(false);
			if (father!=null) {
				father.paintAll(father.getGraphics());
			}
			stop();
			DD.dispose();
		} else if (getParent() instanceof DescartesFrame) {
			DescartesFrame DF=(DescartesFrame) getParent();
			DF.setVisible(false);
			if (father!=null) {
				father.paintAll(father.getGraphics());
			}
			stop();
			DF.dispose();
		}
	}
	
	private void prepareBackImage() {
		backIm=createImage(getSize().width,getSize().height);
		Graphics g=backIm.getGraphics();
		paintAll(g);
	}

	public void runScene(String filename,String target) throws Exception {
		prepareBackImage();
		paint(getGraphics());
		setProgress(10);
		super.runScene(filename,target);
		backIm=null;
		Runtime.getRuntime().runFinalization();
		Runtime.getRuntime().gc();
	}

	public void showScene(String parameter) {
//System.out.println("showScene 1");
		prepareBackImage();
		paint(getGraphics());
		setProgress(10);
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		boolean modal=false;
		boolean inWindow=false;
		String filename=parameter;
//System.out.println("showScene 2");
		if (parameter.endsWith(" modal")) {
			filename=parameter.substring(0,parameter.length()-" modal".length());
			modal=true;
		} else if (parameter.endsWith(" window")) {
			filename=parameter.substring(0,parameter.length()-" window".length());
			inWindow=true;
		}
		boolean self=false;
		String target="_self";
		if (filename.endsWith(" target=_self")) {
			self=true;
			filename=filename.substring(0,filename.length()-" target=_self".length());
		}
//System.out.println("showScene 2");
		try {
			Descartes D=this;
			boolean inW=inWeb();
			URL docbase=getDocumentBase();
			boolean inNE=inNippeEditor();
			if (self) {
				stop();
				destroy();
				removeAll();
				paint(getGraphics());
			} else if (!self) {
				if (D instanceof Arquimedes) {
					D=new Arquimedes(null);
				} else {
					D=new Descartes();
				}
			}
//System.out.println("showScene 3");
			cleanMem(false);
			D.father=this;
			D.setInWeb(inW);
			D.setDocBase(docbase);
			D.setInNippeEditor(inNE);
			String str="";
			try {
				InputStream is=getClass().getResourceAsStream("/"+filename);
				str=mjaFile.readInputStream(is);
			} catch (Exception e1) {
			}
//System.out.println("showScene 4");
			URL url=url=new URL (getDocumentBase(),filename);
			if (!BasicStr.hasContent(str)||!(str.toLowerCase().indexOf("<applet")>=0)) {
				if (inWeb()) {
//System.out.println("showScene 5");
					str=mjaFile.readURL(url);
				} else {
					String db=getDocumentBase().toExternalForm();
					String cb=getCodeBase().toExternalForm();
					if (db.startsWith(cb)) {
						String rdb=db.substring(cb.length());
						if (rdb.length()>0 && !rdb.endsWith(File.separator)) {
							rdb+=File.separator;
						}
						str=mjaFile.readFile(BasicStr.replace(rdb+filename,"/",File.separator));;
					}
					if (!BasicStr.hasContent(str)||!(str.toLowerCase().indexOf("<applet")>=0)) {
						String uri=getDocumentBase().toExternalForm();
						if (!uri.endsWith("/")) {
							uri+="/";
						}
						uri+=filename;
						if (uri.startsWith("file://")) {
							uri=uri.substring(7);
						}
						str=mjaFile.readFile(uri);
					}
				}
				if (!BasicStr.hasContent(str)||!(str.toLowerCase().indexOf("<applet")>=0)) {
					if (inWeb()) {
						url=new URL (getCodeBase(),filename);
						str=mjaFile.readURL(url);
					} else {
						str=mjaFile.readFile(BasicStr.replace(filename,"/",File.separator));;
						if (!BasicStr.hasContent(str)||!(str.toLowerCase().indexOf("<applet")>=0)) {
							String uri=url.toExternalForm();
							if (uri.startsWith("file://")) {
								uri=uri.substring(7);
							}
							str=mjaFile.readFile(uri);
						}
					}
				}
			}
//System.out.println("showScene 6");
			str=mjaHtml.decodeHTMLEncoding(str);
			Dimension dim=new Dimension(480,360);
			if (BasicStr.hasContent(str)&&str.toLowerCase().indexOf("<applet")>=0) {
				String s_url=url.toExternalForm();
				int L=url.getFile().length();
				Point[] P=mjaHtml.getAppletCodeLimits(str);
				if (P.length>0) {
					String appletCode=str.substring(P[0].x,P[0].y);
					Hashtable ap=mjaHtml.getAppletParams(appletCode);
					D.setAppletParams(ap);
					if (!self) {
						dim=mjaHtml.getAppletSize(appletCode);
						D.setSize(dim);
					}
				}
				D.init();
				D.doInit();
			} else {
				D.Tr=Tr;
				D.cfg=new config(D);
				String onlyfn=(new File(filename)).getName();
				if (onlyfn.indexOf(".")>0) {
					int N=onlyfn.lastIndexOf(".");
					onlyfn=onlyfn.substring(0,N);
				}
				D.cfg.name=onlyfn;
				D.mainP=D;
				D.construct(D.mainP);
				if (!self) {
					D.setSize(480,360);
				}
			}
//System.out.println("showScene 7");
			if (modal) {
				new DescartesDialog(D,"Descartes: "+filename,dim);
			} else if (inWindow) {
				new DescartesWindow(D,dim);
				D.restart(true);
			} else {
				if (self) {
					D.restart(true);
				} else {
					new DescartesFrame(D,"Descartes: "+filename,dim);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
//System.out.println("showScene 8");
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
		backIm=null;
		cleanMem(false);
	}


	boolean canEdit() {
		if (this instanceof Arquimedes) {
			return !inWeb();
		}
		if (cfg.isEditable || !inWeb()) {
			return true;
		} else {
			return false;
		}
	}

//	public Dimension popRealSize=new Dimension(100,25);
	
	int west_w=0,east_w=0;

	public int SceneWidth() {
		int sceneWidth=getSize().width;
		sceneWidth-=west_w;
		sceneWidth-=east_w;
		return sceneWidth;
	}

	public int SceneHeight() {
		int dH=((int)Math.round(cfg.rows_height));
		int sceneHeight=mainP.getSize().height;
		int rn=cfg.rows_north;
		if (rn==0 && (np.countSpinners()>0 || b[ixhelp].isVisible() || b[ixcfg].isVisible())) {
			rn=1;
		}
		sceneHeight=sceneHeight-dH*rn;
		int rs=cfg.rows_south;
		if (rs==0 && (sp.countSpinners()>0 || b[ixini].isVisible() || b[ixclear].isVisible())) {
			rs=1;
		}
		sceneHeight=sceneHeight-dH*rs;
		if (scene.hasEquationsPanel()) {
			sceneHeight=sceneHeight-dH;
		}
		return sceneHeight;
	}
	
	int SceneLeft() {
		return west.getSize().width;
	}

	int SceneTop() {
		return north.getSize().height;
	}

	public Dimension getSceneSize() {
		return new Dimension(SceneWidth(),SceneHeight());
	}

	void startPopLMS() {
		initLMS("Descartes");
	}
	
	public void restart(boolean run) {
		restart(run,true);
	}

	synchronized void restart(boolean run,boolean inform) {
		boolean popActive=pop && (mainF!=null);
		stop();
		if (popActive) {
			mainF.setVisible(false);
			mainF.dispose();
			mainF=null;
		}
		center.removeAll();
		imagesHT=new Hashtable();
		cleanMem(false);
		if (inform&&run) {
			informLMS("clic",Tr.getTr(data.init));
		}
		getToolsFromConfig();
		rebuild(getSize());
		if (pop) {
			if (popActive) {
				mainF=new DescartesFrame(this,mainB.getLabel(),getSize());
			}
		} else {
			startScene(run);
			mainP.doLayout();
			mainP.paintAll(mainP.getGraphics());
		}
	}
	
	public void resize(Dimension d) {
		super.resize(d);
	}

	public void resize(int w,int h) {
		super.resize(w,h);
// Esta fincin es la que llama Firefox cuando el usuario cambia el tamao.
// hay que acomodar el applet 
//		scene.updateScene(true);
	}

	private boolean ready=false;
	
	public boolean isReady() {
		if (!ready) {
			System.out.println("READY=FALSE "+this.getName());
		}
		return ready;
	}

	synchronized void startScene(boolean run) {
//int n=0;
//System.out.println("startScene "+n); n++;
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		scene.setPreferredSize(new Dimension(SceneWidth(),SceneHeight()));
		scene.preSizeSpaces();
		scene.addGraphs(); // para que el eqPanel sepa lo que tiene.
		ecp=scene.getVisibleEquationsPanel();
//System.out.println("startScene "+n); n++;
		int dH=0;
		if (ecp!=null) {
			dH=(int)Math.round(cfg.rows_height);
			ecp.setBackground(NumericControl.labelColor);
			ecp.setPreferredSize(new Dimension(SceneWidth(),dH));
			center.add("South",ecp);
		}
//System.out.println("startScene "+n); n++;
		center.setPreferredSize(new Dimension(SceneWidth(),SceneHeight()+dH));
//System.out.println("startScene "+n); n++;
 		center.add("Center",scene);
//System.out.println("startScene "+n); n++;
		scene.defineNumericControls(numctrls);
//System.out.println("startScene "+n); n++;
		scene.start(run);
//System.out.println("startScene "+n); n++;
		if (cfg.useRAD) {
			initLMS("Descartes");
			super.start();
		}
		if (mainF!=null) {
			mainF.setVisible(true);	// no se porqu hace falta esto, pero hace falta.
			mainF.toFront();
			mainF.requestFocus();
		} else {
			if (dd!=null) {
				dd.getFocus();
			} else {
				requestFocus();
			}
//System.out.println("startScene "+n); n++;
		}
		setCursor(null);
		cleanMem(true);
	}
	
	public void stop() {
		Action.stopPlaying();
		_aciertos_=(int) Math.round(p.Var("_ACIERTOS_").getDouble());
		_errores_=(int) Math.round(p.Var("_ERRORES_").getDouble());
		if (p.isVar("_NOTA_")) {
			_nota_=(int) Math.round(p.Var("_NOTA_").getDouble());
		} else {
			_nota_=(int) Math.round((double)(_aciertos_*100)/(double) Math.max(_aciertos_+_errores_,1));
		}
		if (cfg.useRAD) {
			stopLMS();
		}
		scene.stop();
		
//System.out.println(dump());
		
		for (int i=0;i<numctrls.length;i++) {
			if (numctrls[i]!=null) {
				numctrls[i].removeActionListener(this);
			}
		}
		if (cfg.useSound && BasicStr.classExists("com.jla.sound.SoundPlayer")) {
			com.jla.sound.SoundPlayer.stopAll();
		}
		Enumeration e=imagesHT.elements();
		while (e.hasMoreElements()) {
			Object O=e.nextElement();
			if (O instanceof Image) {
				Image im=(Image) O;
				im.flush();
			}
		}
		imagesHT.clear();
		cleanMem(false);
	}
	

	public void destroy() {
		if (aboutFrame!=null) {
			aboutFrame.dispose();
		}
		if (extSpinFrame!=null) {
			extSpinFrame.setVisible(false);
			extSpinFrame.dispose();
			extSpinFrame=null;
		}
		if (editConfigFrame!=null) {
			editConfigFrame.setVisible(false);
			editConfigFrame.destroy();
			editConfigFrame.dispose();
			editConfigFrame=null;
		}
		if (mainF!=null) {
			mainF.dispose();
			mainF=null;
		}
		mjaText.destroy();
		super.destroy(cfg.useRAD);
	}

	public void about() {
		about(true);
	}

	void about(boolean inform) {
		if (inform) {
			informLMS("clic",Tr.getTr(data.about));
		}
		if (aboutFrame==null) {
			aboutFrame=new edu.cr.descartes.copyright(this,"Descartes",cfg.useCC);
		}
		aboutFrame.display();
	}

	public void edit(Object O) {
		edit(O,true);
	}

	void updateEditConfigInfo() {
		if (editConfigFrame==null) {
			editConfigFrame=dd.getEditor();
			editConfigFrame.setSize(850,540);
			editConfigFrame.setInfo();
		} else {
			editConfigFrame.setInfo();
		}
	}

	void edit(Object O, boolean inform) {
//new Exception().printStackTrace();
		if (inform) {
			informLMS("clic",Tr.getTr(data.config));
		}
		if (!LMS_inUse()) {
			scene.stopAnimations(); // cambiado a stop el 21 de noviembre de 2009 para evitar colgadas cuando un espacio R3 est girando
			if (editConfigFrame==null) {
//				if (!canEdit()) {
//					try {
//						System.out.println("trying to load Descartes_E.jar");
//						System.loadLibrary("Descartes_E.jar");
//					} catch (Exception e) {
//						e.printStackTrace();
//					}
//				}
				if (canEdit()) {
					setCursor(new Cursor(Cursor.WAIT_CURSOR));
					if (dd==null) {
						dd=new doed(this,O);
					}
					updateEditConfigInfo();
					setCursor(null);
					editConfigFrame.display("up");
				} else {
					mjaText.ask("Descartes",Tr.getTr(data.noedit),Tr.getTr(data.accept),null);
				}
			} else {
				if (mustRenew) {
					editConfigFrame.setInfo();
					mustRenew=false;
				}
//				editConfigFrame.show(O);
			}
			if (dd!=null) {
				dd.show(O);
			}
		}
	}
	
	private boolean mustRenew;
	
	public void renewEditorConfig() {
		mustRenew=true;
	}
	
	public editFrame getEditor() {
		return editConfigFrame;
	}

	public void clear() {
		clear(true);
	}

	void clear(boolean inform) {
		if (inform) {
			informLMS("clic",Tr.getTr(data.clear));
		}
		scene.updateScene(true);
	}

	public void refresh(boolean updateFromControls) {
		scene.refreshScene(updateFromControls);
	}

	public void toggleAnimation() {
		toggleAnimation(true);
	}

	void toggleAnimation(boolean inform) {
		if (inform) {
			informLMS("clic",Tr.getTr(data.anim)+"/"+Tr.getTr(data.pause));
		}
		scene.toggleAnimation();
	}

	public void initAnimation() {
		initAnimation(true);
	}

	void initAnimation(boolean inform) {
		if (inform) {
			informLMS("clic",Tr.getTr(data.initAnim));
		}
		scene.initAnimation();
		scene.refreshScene(true);
	}
	
	public String toAppletString() {
		return getAppliedCode();
	}

	public String getAppliedCode() {
		return getAppliedCode(true);
	}

	public String getAppliedCode(boolean HTML_encoded) {
		if (dd==null) {
			dd=new doed(this,null);
			updateEditConfigInfo();
		}
		return dd.getAppliedCode(HTML_encoded);
	}

/* ---------------- Overwritten to make showScene work --------------- */

	public AppletContext getAppletContext() {
		if (externalAppletContext!=null) {
			return externalAppletContext;
		} else if (father!=null) {
			return father.getAppletContext();
		} else {
			return super.getAppletContext();
		}
	}

	public URL getCodeBase() {
		if (externalCodeBase!=null) {
			return externalCodeBase;
		} else if (father!=null) {
			return father.getCodeBase();
		} else {
			return super.getCodeBase();
		}
	}

	public URL getDocumentBase() {
		if (externalDocBase!=null) {
			return externalDocBase;
		} else {
			return super.getDocumentBase();
		}
	}


/* ---------------------- Communications ---------------------- */


/* ----------------- AbstractNippe implementation ----------------- */

/*
	public String getInfo(String type,String param) {
		String varName=type;
		StringTokenizer st=new StringTokenizer(param,"_");
		if (st.hasMoreTokens()) {
			int i=BasicStr.parseInteger(st.nextToken(),0,0);
			if (st.hasMoreTokens()) {
				int j=BasicStr.parseInteger(st.nextToken(),0,0);
				String var=varName+"_"+i+"_"+j;
				if (p.Var(var).s!=null)  {
					return p.Var(var).s;
				} else if (p.isVar(var)) {
					if (p.svalue(var)!=null) {
						return p.svalue(var);
					} else {
						return BasicStr.DoubleToString(p.rvalue(var),6,false);
					}
				} else {
					System.out.println("class_Id() = "+class_Id());
					System.out.println("object_id = "+object_id);
					System.out.println("Error en Descartes.getInfo: la variable "+var+" no est definida");
					return "Error";
				}
			}
		}
		return "";
	}
*/
/*
	public void doAction(String actionName,String actionParam) {
		if ("restart".equalsIgnoreCase(actionName)) {
			restart(true);
		} else if ("refresh".equalsIgnoreCase(actionName)) {
			refresh(true);
		} else if ("clear".equalsIgnoreCase(actionName)) {
			clear();
		}
	}
*/

    public void doAction(String actionName, String actionParam) {
        if("restart".equalsIgnoreCase(actionName)) {
            restart(true);
            return;
        }
        if("refresh".equalsIgnoreCase(actionName)) {
            refresh(true);
            return;
        }
        if("clear".equalsIgnoreCase(actionName)) {
            clear();
            return;
        }
        if("processExpression".equalsIgnoreCase(actionName)) {
            processExpression(actionName,actionParam);
        }
    }


	public String getInfo(String type, String param) {
        String varName = type;
//        System.out.println("Se pide la informacion de ["+type+","+param+"]");
        String var = type;
        if(BasicStr.hasContent(p.Var(var).getStr()))
            return p.Var(var).getStr();
        if(p.isVar(var))
        {
        	if (p.Var(var).getStr()!=null) {
        		return p.Var(var).getStr();
        	} else {
	            return BasicStr.DoubleToString(p.Var(var).getDouble(), 6, false);
        	}
        } else {
            System.out.println("class_Id() = "+class_Id());
            System.out.println("object_id = "+object_id);
            System.out.println("Error en Descartes.getInfo: la variable "+var+" no est\341 definida");
            return "Error";
        }
    }



    private void processExpression(String actionName,String actionParam) {
        try	
        {
            actionParam = actionParam.substring(0, actionParam.length() - 1);
            Algorithm a = new Algorithm(actionName,p, true, actionParam, "", "");
            a.perform();
            refresh(true);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

/* ---------------------------------------------------------------- */

	public String getParameter(String s) {
		String  res=filterParameter(s);
		if (res!=null) {
			return res;
		}
		if (AP!=null && father==null) {
			String p=AP.getParameter(s);
			if (BasicStr.hasContent(p)) {
				p=p.replaceAll("\n","");
				p=p.replaceAll("\r","");
			}
			return p;
		} else if (father!=null||appletParams()!=null) {
			if (BasicStr.hasContent(s)) {
				String p=(String) appletParams().get(s);
				if (BasicStr.hasContent(p)) {
					// 2009/03/17  para corregir que el JRE 6.10 y superior transfiere a los parmetros los saltos de lnea
					p=p.replaceAll("\n","");
					p=p.replaceAll("\r","");
//System.out.println(s+" --> "+p);
					return p;
				}
			}
			return "";
		} else {
			String p=super.getParameter(s);
			if (BasicStr.hasContent(p)) {
				p=p.replaceAll("\n","");
				p=p.replaceAll("\r","");
			}
			return p;
		}
	}

/* ------------------- Tools, Attributes and Config --------------- */

	private void initializeTools() {
		Params=new Vector();
		Buttons=new Attribute(Tr.getTr(data.p_buttons),"");
		Space=new Attribute(Tr.getTr(data.p_space),"");
		Spaces=new Vector();
		Controls=new Vector();
		Aux=new Vector();
		Graphs=new Vector();
		Graphs3D=new Vector();
		Animation=new Attribute(Tr.getTr(data.p_anim),"");
	}
	
	public String getConfigVersion() {
		if (Tr==null) {
			Tr=new translator(this);
		}
		return Tr.getParam(this,data.p_version).value;
	}

	private void getToolsFromApplet(Applet A) {
		Tr.setActiveLanguage(Tr.getLanguage(Tr.getParam(this,data.p_language).value));
		String ver=Tr.getParam(A,data.p_version).value;
		initializeTools();
		if (BasicStr.hasContent(ver) && !ver.startsWith("1")) {
			Params.addElement(Tr.getParam(A,data.isEditable));
			Params.addElement(Tr.getParam(A,data.useSound));
			Params.addElement(Tr.getParam(A,data.useAlgebra));
			Params.addElement(Tr.getParam(A,data.useRAD));
//			Params.addElement(Tr.getParam(A,data.editable));
			Params.addElement(Tr.getParam(A,data.course));
			Params.addElement(Tr.getParam(A,data.unit));
			Params.addElement(Tr.getParam(A,data.name));
			Params.addElement(Tr.getParam(A,data.p_version));
			Params.addElement(Tr.getParam(A,data.p_language));
			Params.addElement(Tr.getParam(A,data.infoind));
			Params.addElement(Tr.getParam(A,data.infoest));
			Buttons=Tr.getParam(A,data.p_buttons);
			Space=Tr.getParam(A,data.p_space);
			addParamAttributes(A,Spaces,data.spacePrefix);
			addParamAttributes(A,Controls,data.controlPrefix);
			addParamAttributes(A,Aux,data.auxPrefix);
			addParamAttributes(A,Graphs,data.graphPrefix);
			addParamAttributes(A,Graphs3D,data.graph3Prefix);
			Animation=Tr.getParam(A,data.p_anim);
			undo_active=!Tr.isFalse(Tr.getParam(A,data.undo).value);
		}
	}

	protected void getToolsFromConfig() {
		Attribute[] aa=cfg.toAppletParams(Tr);
		initializeTools();
		Params.addElement(Tr.getAttribute(aa,data.isEditable));
		Params.addElement(Tr.getAttribute(aa,data.useSound));
		Params.addElement(Tr.getAttribute(aa,data.useAlgebra));
		Params.addElement(Tr.getAttribute(aa,data.useRAD));
//		Params.addElement(Tr.getAttribute(aa,data.editable));
		Params.addElement(Tr.getAttribute(aa,data.course));
		Params.addElement(Tr.getAttribute(aa,data.unit));
		Params.addElement(Tr.getAttribute(aa,data.name));
		Params.addElement(Tr.getAttribute(aa,data.p_version));
		Params.addElement(Tr.getAttribute(aa,data.p_language));
		Params.addElement(Tr.getAttribute(aa,data.infoind));
		Params.addElement(Tr.getAttribute(aa,data.infoest));
		Buttons=Tr.getAttribute(aa,data.p_buttons);
		Space=Tr.getAttribute(aa,data.p_space);
		addAttributes(aa,Spaces,data.spacePrefix);
		addAttributes(aa,Graphs,data.graphPrefix);
		addAttributes(aa,Graphs3D,data.graph3Prefix);
		addAttributes(aa,Aux,data.auxPrefix);
		addAttributes(aa,Controls,data.controlPrefix);
		Animation=Tr.getAttribute(aa,data.p_anim);
	}

	protected Attribute[] getAttributesFromTools() {
		Attribute[] aa=new Attribute[Params.size()+3+Spaces.size()+Graphs.size()+Graphs3D.size()+Aux.size()+Controls.size()];
		int j=0;
		for (int i=0;i<Params.size();i++) {
			aa[j++]=(Attribute) Params.elementAt(i);
		}
		aa[j++]=Buttons;
		aa[j++]=Space;
		for (int i=0;i<Spaces.size();i++) {
			aa[j++]=(Attribute) Spaces.elementAt(i);
		}
		for (int i=0;i<Graphs.size();i++) {
			aa[j++]=(Attribute) Graphs.elementAt(i);
		}
		for (int i=0;i<Graphs3D.size();i++) {
			aa[j++]=(Attribute) Graphs3D.elementAt(i);
		}
		for (int i=0;i<Aux.size();i++) {
			aa[j++]=(Attribute) Aux.elementAt(i);
		}
		for (int i=0;i<Controls.size();i++) {
			aa[j++]=(Attribute) Controls.elementAt(i);
		}
		aa[j++]=Animation;
		return aa;
	}
	
/* ---------------------- Action Listener --------------------- */

	public void actionPerformed(ActionEvent ev) {
		Component c=(Component) ev.getSource();
		if (c==mainB) {
//			if (mainF==null) {
//				mainF=new DescartesFrame(this,mainB.getLabel(),getSize());
//			}
//			mainF.show();
		} else if (c==b[ixhelp]||c==be[ixhelp]||c==b[ixcfg]||c==be[ixcfg]
				||c==b[ixini]||c==be[ixini]||c==b[ixclear]||c==be[ixclear]
				||c==banim||c==banime||c==binianim||c==binianime) {
		} else if (c==b_verif) {
			disableControls=true;
			if (numctrls!=null) {
				for (int i=0;i<numctrls.length;i++) {
					if (numctrls[i]!=null) {
						numctrls[i].setEnabled(false);
					}
				}
			}
			showingAnswer=true;
			String str=getEvaluation();
			lb_nota.setText("nota:  "+BasicStr.DoubleToString(nota,1,false)+"%");
			lb_puntos.setText(""+puntos+"  puntos");
			lb_buenos.setText(""+buenos+"  buenos");
			lb_malos.setText(""+malos+"  malos");
//			mjaText.msg("Evaluacin",);
			b_verif.setEnabled(false);
			b_solution.setEnabled(true);
			b_answer.setEnabled(false);
		} else if (c==b_solution) {
			if (numctrls!=null) {
				for (int i=0;i<numctrls.length;i++) {
					if (numctrls[i]!=null) {
						numctrls[i].setEnabled(false);
					}
				}
			}
			b_verif.setEnabled(false);
			b_solution.setEnabled(false);
			b_answer.setEnabled(true);
			showSolution();
		} else if (c==b_answer) {
			if (numctrls!=null) {
				for (int i=0;i<numctrls.length;i++) {
					if (numctrls[i]!=null) {
						numctrls[i].setEnabled(true);
					}
				}
			}
			b_verif.setEnabled(true);
			b_solution.setEnabled(true);
			b_answer.setEnabled(false);
			showAnswer();
		} else {
			refresh(true);
		}
	}

/* ---------------------- Mouse Listener ----------------------- */

	public void mousePressed(MouseEvent ev) {}

	public void mouseReleased(MouseEvent ev) {
		Component c=(Component) ev.getSource();
		if (ev.getModifiers()==MouseEvent.BUTTON1_MASK) {
			if (c==b[ixhelp]||c==be[ixhelp]) {
				about();
			} else if (c==b[ixcfg]||c==be[ixcfg]) {
				c.setCursor(new Cursor(Cursor.WAIT_CURSOR));
				setCursor(new Cursor(Cursor.WAIT_CURSOR));
				edit(null);
				setCursor(null);
				c.setCursor(null);
			} else if (c==b[ixini]||c==be[ixini]) {
				restart(true);
			} else if (c==b[ixclear]||c==be[ixclear]) {
				clear();
			} else if (c==banim||c==banime) {
				toggleAnimation();
			} else if (c==binianim||c==binianime) {
				initAnimation();
			} else if (c==mainB) {
				if (mainF==null) {
					mainF=new DescartesFrame(this,mainB.getLabel(),getSize());
				} else {
					mainF.setVisible(true);
				}
			}
		} else if (ev.getModifiers()==MouseEvent.BUTTON3_MASK) {
			String label="";
			int n=-1;
			if (c==b[ixhelp]||c==be[ixhelp]) {
				n=0; label=Tr.getTr(data.about);
			} else if (c==b[ixcfg]||c==be[ixcfg]) {
				n=1; label=Tr.getTr(data.config);
			} else if (c==b[ixini]||c==be[ixini]) {
				n=2; label=Tr.getTr(data.ini);
			} else if (c==b[ixclear]||c==be[ixclear]) {
				n=3; label=Tr.getTr(data.clear);
			} else if (c==banim||c==banime) {
				n=4; label=Tr.getTr(data.anim);
			} else if (c==binianim||c==binianime) {
				n=5; label=Tr.getTr(data.initAnim);
			}
			if (n>=0) {
				String explanation=Expl.get(Expl.ButtonsDefault[n],Tr.getActiveLanguage());
				informLMS("expl",label);
				mjaText.msg(c,label,explanation,mjaFont.AWTMono);
			}
		}
	}
	public void mouseClicked(MouseEvent ev) {
		if (((ev.getClickCount()==2)||(ev.getClickCount()==1 && BasicStr.CtrlOn)) && inNippeEditor() && !(ev.getSource() instanceof spinnerControl)) {
			edit(ev.getSource());
		} else if (ev.getModifiers()==ev.BUTTON3_MASK || (BasicStr.ShiftOn && BasicStr.CtrlOn))  {
			if (ev.getClickCount()==1 && !ev.isConsumed()) {
				showExternalSpinners();
			}
		}
	}
	public void mouseEntered(MouseEvent ev) { }
	public void mouseExited(MouseEvent ev) { }
	
/* ----------------------- Key Listener --------------------- */


	public void keyPressed(KeyEvent e) {
		BasicStr.CtrlOn=e.isControlDown();
		BasicStr.ShiftOn=e.isShiftDown();
		if ( (e.getKeyCode()==KeyEvent.VK_TAB && !e.isShiftDown()) ||
				((e.getKeyCode()==KeyEvent.VK_RIGHT) && e.isControlDown()) ||
				((e.getKeyCode()==KeyEvent.VK_DOWN) && e.isControlDown()) ) {
			for (int i=0;i<FC.length;i++) {
				if (e.getSource()==FC[i]) {
					for (int j=1;j<FC.length;j++) {
						Component C=FC[(i+j) % FC.length];
						if (C.isVisible() && C.isEnabled()) {
							C.requestFocus();
							break;
						}
					}
				}
			}
		} else if ( (e.getKeyCode()==KeyEvent.VK_TAB && e.isShiftDown()) ||
				((e.getKeyCode()==KeyEvent.VK_LEFT) && e.isControlDown()) ||
				((e.getKeyCode()==KeyEvent.VK_UP) && e.isControlDown()) ) {
			for (int i=0;i<FC.length;i++) {
				if (e.getSource()==FC[i]) {
					for (int j=1;j<FC.length;j++) {
						Component C=FC[(FC.length+i-j) % FC.length];
						if (C.isVisible() && C.isEnabled()) {
							C.requestFocus();
							break;
						}
					}
				}
			}
		}
	}

	public void keyTyped(KeyEvent e) {
	}

	public void keyReleased(KeyEvent e) {
		BasicStr.CtrlOn=false;
		BasicStr.ShiftOn=false;
	}

/* ---------------------- package methods --------------------- */

	public void updateNodesFromControls() {
		scene.updateNodesFromTexts();
		for (int i=0;i<numctrls.length;i++) {
			if (numctrls[i]!=null) {
				numctrls[i].updateFromText();
			}
		}
	}

	public synchronized void updateTextFieldsFromNodes() {
		updateTextFieldsFromNodes(true);
	}
	
	synchronized void updateTextFieldsFromNodes(boolean force) {
		scene.updateTextsFromNodes(force);
		for (int i=0;i<numctrls.length;i++) {
			if (numctrls[i]!=null && (force || !numctrls[i].isBeingEdited())) {
				numctrls[i].updateFromNode();
			}
		}
	}

	void updateAnimationButtons() {
		if (scene.animationIsRunning()) {
			b[ixini].setEnabled(false);
			be[ixini].setEnabled(false);
			banim.type=mjaButton.pause;
			banime.type=mjaButton.pause;
		} else {
			b[ixini].setEnabled(true);
			be[ixini].setEnabled(true);
			banim.type=mjaButton.play;
			banime.type=mjaButton.play;
		}
		b[ixini].paintAll(b[ixini].getGraphics());
		be[ixini].paintAll(be[ixini].getGraphics());
		banim.paintAll(banim.getGraphics());
		banime.paintAll(banime.getGraphics());
	}

	void showExternalSpinners() {
		if ( !(this instanceof Arquimedes) || canEdit()  ) {
			extSpinFrame.setVisible(false);
			extSpinFrame.display(false);
		}
		BasicStr.ShiftOn=false;
		BasicStr.CtrlOn=false;
	}

/* ------------------------ private methods -------------------------- */

	private void construct(Panel mainP) {
		setFont(mjaFont.AWTMono);
		b=new mjaButton[data.bnameix.length];
		be=new mjaButton[data.bnameix.length];
		for (int i=0;i<data.bnameix.length;i++) {
			b[i]=new mjaButton();
			b[i].addActionListener(this);
			b[i].addMouseListener(this);
			be[i]=new mjaButton();
			be[i].addActionListener(this);
			be[i].addMouseListener(this);
		}
		banim=new mjaButton(mjaButton.play);
		banim.addActionListener(this);
		banim.addMouseListener(this);
		binianim=new mjaButton(mjaButton.rewind);
		binianim.addActionListener(this);
		binianim.addMouseListener(this);
		banime=new mjaButton(mjaButton.play);
		banime.addActionListener(this);
		banime.addMouseListener(this);
		banime.setVisible(false);
		binianime=new mjaButton(mjaButton.rewind);
		binianime.addActionListener(this);
		binianime.addMouseListener(this);
		binianime.setVisible(false);

		north=new Panel();
		center=new Panel();
		center.setLayout(new BorderLayout());
//		center.setBackground(BGColor); // ste color se ve en el fondo; debe heredarlo del mainP y ste del AbstractNippe;
		south=new Panel();
		south.setVisible(false);
		east=new Panel(); east.setLayout(new GridLayout(1,1));
		east.setVisible(false);
		west=new Panel(); west.setLayout(new GridLayout(1,1));
		west.setVisible(false);
		GridBagLayout gbln=new GridBagLayout();
		north.setLayout(gbln);
		north.setVisible(false);
		GridBagConstraints c=new GridBagConstraints();
		c.insets=new Insets(0,0,0,0);
		c.anchor=GridBagConstraints.CENTER;
		c.fill  =GridBagConstraints.BOTH;

		c.gridwidth=1; c.gridheight=1; c.weighty=1; c.gridy=0;
		c.weightx=0.05;
		c.gridx=0; gbln.setConstraints(b[ixhelp],c);
		north.add(b[ixhelp]);
		c.weightx=0.9;
		c.gridx=1; gbln.setConstraints(nsp=new Panel(),c);
		nsp.setLayout(new GridLayout(1,1));
		north.add(nsp);
		c.weightx=0.05;
		c.gridx=2; gbln.setConstraints(b[ixcfg],c);
		north.add(b[ixcfg]);

		GridBagLayout gbls=new GridBagLayout();
		south.setLayout(gbls);

		c.gridwidth=1; c.gridheight=1; c.weighty=1; c.gridy=0;
		c.weightx=0.05;
		c.gridx=0; gbls.setConstraints(b[ixini],c);
		south.add(b[ixini]);
		c.weightx=0.9;
		c.gridx=1; gbls.setConstraints(ssp=new Panel(),c);
		ssp.setLayout(new BorderLayout());
		south.add(ssp);
		c.weightx=0.05;
		c.gridx=2; gbls.setConstraints(b[ixclear],c);
		south.add(b[ixclear]);
		panim=mjaLayout.pair(binianim,banim);
		c.gridx=3; gbls.setConstraints(panim,c);
		south.add(panim);
		esp=new Panel();
		esp.setLayout(new GridLayout(1,1));
		
		extSpinFrame=new editFrame("Descartes","",null,null);
		extSpinFrame.setLocation(40,40);
		extSpinFrame.setResizable(false);
		extSpinFrame.pack=true;
		Panel extp=new Panel();
		extSpinFrame.add("Center",extp);
		extp.setLayout(new BorderLayout());
		extp.add("Center",esp);
		Panel exnbp=new Panel();
		Panel exsbp=new Panel();
		extp.add("North",exnbp);
		extp.add("South",exsbp);
		exnbp.setLayout(new GridLayout(1,2));
		exnbp.add(be[0]);
		exnbp.add(be[1]);
		exsbp.setLayout(new GridLayout(1,3));
		exsbp.add(be[2]);
		exsbp.add(be[3]);
		exsbp.add(mjaLayout.pair(binianime,banime));
//		mainP.setLayout(new BorderLayout());
//		mainP.add("North",north);
//		mainP.add("Center",center);
//		mainP.add("South",south);
//		mainP.add("East",east);
//		mainP.add("West",west);
		mainP.addMouseListener(this);
		mainP.addKeyListener(this);
		if (!inWeb() && canEdit()) {
			dd=new doed(this,null);
		}
		scene=new Scene(this,dd);
	}
	
	private synchronized void rebuild(Dimension sz) {
		p.renew();
		p.defineVar(_EQUIPO_,nombre_equipo);
		p.defineVar(_SERVIDOR_RAD_,RAD_host);
		p.Var(_CONECTADO_AL_RAD_).setDouble((connectedToRAD)?1:0);
		eventActions=new Vector();
		rebuildButtons();
		defineMath(cfg.aux_macro,ini);	/* initial values of the numctrls may be changed... */
		rebuildControls(sz);			/* scales and origin locations may be overwritten */
		scene.addSpaces();
		if(scene.isVisible())
			scene.preSizeSpaces();	// eliminado y recuperado para la 4.04, el 22 de marzo de 2009; eliminado otra vez en octubre 25 de 2009 para ver 4.06
		defineMath(cfg.auxiliar,todo);	/* initial values of the numctrls may be changed... */
		defineMath(cfg.aux_macro,fin);	/* incluir algoritmos que se evalan siempre */
		scene.doAlgorithms(true);
		recalculateNumericAndGraphicControls(cfg.cc);
		updateExternalControlFrame();
		nombre_equipo=p.Var(_EQUIPO_).getStr();
		RAD_host=p.Var(_SERVIDOR_RAD_).getStr();
	}

	private void rebuildButtons() {
		banim.setSize(26,cfg.rows_height);
		binianim.setSize(26,cfg.rows_height);
		if (cfg.animC.active && !inArquimedes) {
			panim.setVisible(true);
			banime.setVisible(true);
			binianime.setVisible(true);
		} else {
			panim.setVisible(false);
			banime.setVisible(false);
			binianime.setVisible(false);
		}
		for (int n=0;n<cfg.buttonVisible.length;n++) {
			b[n].setLabel(Tr.getTr(data.bnameix[n]));
			be[n].setLabel(Tr.getTr(data.bnameix[n]));
			if (cfg.buttonVisible[n]) {
				b[n].setVisible(true);
			} else {
				b[n].setVisible(false);
			}
		}
	}

	private static final int ini=0,fin=1,todo=2;

	private void defineMath(auxConfig[] auxiliar,int caso) {
		for (int i=0;i<auxiliar.length;i++) {
			if (auxiliar[i].type==data.func||auxiliar[i].type==data.sequence) {
				if (caso==ini||caso==todo) {
					if (auxiliar[i].hasAlg) {
						p.defineFunc(
							auxiliar[i].funcName,
							auxiliar[i].VarName,
							auxiliar[i].s_value[auxConfig.ixexpr],
							auxiliar[i].s_value[auxConfig.ixrange],
							auxiliar[i].s_value[auxConfig.ixlocalvars],
							auxiliar[i].s_value[auxConfig.ixdo],
							auxiliar[i].s_value[auxConfig.ixini],
							auxiliar[i].s_value[auxConfig.ixwhile],
							auxiliar[i].type==data.sequence);
					} else {
						p.defineFunc(auxiliar[i].funcName,auxiliar[i].VarName,
							auxiliar[i].s_value[auxConfig.ixexpr],auxiliar[i].s_value[auxConfig.ixrange],
							auxiliar[i].type==data.sequence);
					}
				}
			} else if (auxiliar[i].type==data.constant) {
				if (auxiliar[i].evOnce) {
					if (caso==ini||caso==todo) {
						Algorithm alg=p.defineConstant(auxiliar[i].getName(),true,auxiliar[i].getName()+"="+auxiliar[i].s_value[auxConfig.ixexpr],"","");
					}
				} else {
					if (caso==todo||caso==fin) { // se quit para que las constantes se evalen antes y despus.
						Algorithm alg=p.defineConstant(auxiliar[i].getName(),false,auxiliar[i].getName()+"="+auxiliar[i].s_value[auxConfig.ixexpr],"","");
					}
				}
			} else if (auxiliar[i].type==data.alg) {
				if (caso==todo||(auxiliar[i].evOnce&&caso==ini)||(!auxiliar[i].evOnce&&caso==fin))  {
					Algorithm alg=p.defineAlgorithm(auxiliar[i].getName(),auxiliar[i].evOnce,auxiliar[i].s_value[auxConfig.ixdo],
						auxiliar[i].s_value[auxConfig.ixini],auxiliar[i].s_value[auxConfig.ixwhile]);
				}
			} else if (auxiliar[i].type==data.array) {
				if (caso==ini || caso==todo) {
					p.defineArray(auxiliar[i].getSize(),
								  auxiliar[i].getName(),
								  auxiliar[i].getExpr(),
								  auxiliar[i].getFileName(),
								  auxiliar[i].evOnce);
					p.evaluateArray(auxiliar[i].getName(),true);
				}
			} else if (auxiliar[i].type==data.matrix) {
				if (caso==ini || caso==todo) {
					p.defineMatrix(auxiliar[i].getColumns(),
								  auxiliar[i].getRows(),
								  auxiliar[i].getName(),
								  auxiliar[i].getFileName(),
								  auxiliar[i].getExpr(),
								  auxiliar[i].evOnce);
					p.evaluateMatrix(auxiliar[i].getName(),true);
				}
			} else if (auxiliar[i].type==data.event) {
				if (caso==ini||caso==todo) {
					eventActions.addElement(new Action(this,auxiliar[i].getName(),auxiliar[i].mode,auxiliar[i].getCondition(),auxiliar[i].getAction(),auxiliar[i].getParameter(),auxiliar[i].param_font,auxiliar[i].msgloc));
				}
			} else { // auxiliar[i].type==data.var
				if (caso==ini||caso==todo) {
					p.defineExpr(auxiliar[i].getName(),auxiliar[i].s_value[auxConfig.ixexpr]);
				}
			}
		}
	}

	private int popWidth0,popHeight0;
	private statePanel sp, np, wp, ep;
	private Component[] FC=new Component[0];


	void resetFocusTraversalOrder() {
		Vector VFC=new Vector();
		for (int i=0;i<numctrls.length;i++) {
			if (numctrls[i]!=null) {
				numctrls[i].disableFocusTraversalKeys();
				Component[] ca=numctrls[i].getFocusableComponents();
				for (int k=0;k<ca.length;k++) {
					ca[k].addKeyListener(this);
					VFC.addElement(ca[k]);
				}
			}
		}
		FC=new Component[VFC.size()];
		for (int i=0;i<FC.length;i++) {
			FC[i]=(Component) VFC.elementAt(i);
		}
	}
	
	private void rebuildControls(Dimension sz) {
		nsp.removeAll(); ssp.removeAll(); east.removeAll(); west.removeAll(); esp.removeAll();

		numctrls=getNumericAndInitGraphicControls(cfg.cc);
		if (numctrls!=null) {
			for (int i=0;i<numctrls.length;i++) {
				if (numctrls[i]!=null) {
					numctrls[i].addMouseListener(this);
					numctrls[i].addKeyListener(this);
				}
			}
			resetFocusTraversalOrder();
		}
		int dH=cfg.rows_height;
		sp=new statePanel(cfg.cc,numctrls,data.south,sz.width,dH,basicBlue,Math.max(cfg.rows_south,1));
		np=new statePanel(cfg.cc,numctrls,data.north,sz.width,dH,basicBlue,Math.max(cfg.rows_north,1));
		wp=new statePanel(cfg.cc,numctrls,data.west,sz.width,dH,basicBlue,cfg.width_west);
		ep=new statePanel(cfg.cc,numctrls,data.east,sz.width,dH,basicBlue,cfg.width_east);
		statePanel es=new statePanel(cfg.cc,numctrls,data.external,sz.width,dH,basicBlue);
		west_w=wp.getAncho();
		east_w=ep.getAncho();
		sp.addMouseListener(this);
		np.addMouseListener(this);
		wp.addMouseListener(this);
		ep.addMouseListener(this);
		nsp.add(np);
		ssp.add("Center",sp);
		if (inEval) {
			Panel P=new Panel();
			P.setLayout(new GridLayout(1,3));
			P.add(b_verif=new mjaButton("Verificar"));
			b_verif.addActionListener(this);
			P.add(lb_nota=new Label("nota"));
			lb_nota.setAlignment(Label.CENTER);
			P.add(lb_puntos=new Label("puntos"));
			lb_puntos.setAlignment(Label.CENTER);
			P.add(lb_buenos=new Label("buenos"));
			lb_buenos.setAlignment(Label.CENTER);
			P.add(lb_malos=new Label("malos"));
			lb_malos.setAlignment(Label.CENTER);
			P.add(b_solution=new mjaButton("Ver solucin"));
			b_solution.setEnabled(false);
			b_solution.addActionListener(this);
			P.add(b_answer=new mjaButton("Ver respuesta"));
			b_answer.setEnabled(false);
			b_answer.addActionListener(this);
			ssp.add("South",P);
		}
		west.add(wp);
		east.add(ep);
		int rn=cfg.rows_north;
		if (rn==0 && (np.countSpinners()>0 || b[ixhelp].isVisible() || b[ixcfg].isVisible())) {
			rn=1;
		}
		
		int Hn=dH*rn;
		if (Hn<=1) {
			Hn=0;
		}
		north.setPreferredSize(new Dimension(sz.width,Hn));
		north.setVisible(Hn!=0);

		int rs=cfg.rows_south;
		if (rs==0 && (sp.countSpinners()>0 || b[ixini].isVisible() || b[ixclear].isVisible())) {
			rs=1;
		}
//		if (rs==0) {
//			ssp.remove(sp);
//		}
		int Hs=dH*rs+((inEval)?23:0);
		if (Hs<=1) {
			Hs=0;
		}
		int scH=SceneHeight();
		int extrH=0;
		if (scene.hasEquationsPanel()) {
			extrH=dH;
		}
		
		south.setPreferredSize(new Dimension(sz.width,Hs));
		south.setVisible(Hs!=0);

		west.setPreferredSize(new Dimension(west_w,scH));
		west.setVisible(west_w>0);

		east.setPreferredSize(new Dimension(east_w,scH));
		east.setVisible(east_w>0);

		esp.add(es);
	}



	private void updateExternalControlFrame() {
		if (extSpinFrame!=null) {
			boolean extvis=extSpinFrame.isVisible();
			extSpinFrame.setVisible(false);
			extSpinFrame.setLabels(Tr.getTr(data.close),"","");
			if (extvis) {
				extSpinFrame.display(false);
			}
		}
	}

	private static void addAttributes(Attribute[] aa,Vector v,String prefix) {
		for (int i=0;i<aa.length;i++) {
			if (aa[i].name.startsWith(prefix)) {
				v.addElement(aa[i]);
			}
		}
	}

	private static void addParamAttributes(Applet ap,Vector v,String prefix) {
		for (int i=0;i<100;i++) {
			String auxs=ap.getParameter(prefix+BasicStr.IntegerToString(i,2));
			if (BasicStr.hasContent(auxs)) {
				v.addElement(new Attribute(prefix+BasicStr.IntegerToString(i,2),auxs));
			}
		}
		for (int i=100;i<1000;i++) {
			String auxs=ap.getParameter(prefix+BasicStr.IntegerToString(i,3));
			if (BasicStr.hasContent(auxs)) {
				v.addElement(new Attribute(prefix+BasicStr.IntegerToString(i,3),auxs));
			}
		}
	}

	private NumericControl[] getNumericAndInitGraphicControls(controlConfig[] a) {
		NumericControl[] spina=new NumericControl[a.length];
		for (int i=0;i<a.length;i++) {
			if (a[i].type==data.c_numeric) {
				spina[i]=a[i].makeNumericControl(this);
			} else if (a[i].type==data.c_graphic) {
				spina[i]=null;
				a[i].initializeGraphicControl(this);
			} else if (a[i].type==data.c_audio) {
				a[i].initializeMediaControl(this);
			} else if (a[i].type==data.c_video) {
				a[i].initializeMediaControl(this);
			} else if (a[i].type==data.c_string) {
				spina[i]=null;
				a[i].initializeTextControl(this);
			}
		}
		return spina;
	}

	private void recalculateNumericAndGraphicControls(controlConfig[] a) {
		for (int i=0;i<a.length;i++) {
			if (a[i].type==data.c_numeric) {
				numctrls[i].reinitialize();
			} else if (a[i].type==data.c_graphic) {
				a[i].initializeGraphicControl(this);
			} else if (a[i].type==data.c_string) {
				a[i].initializeTextControl(this);
			} else if (a[i].type==data.c_audio) {
			} else if (a[i].type==data.c_video) {
			}
		}
	}

	public void update(Graphics g) {
		paint(g);
	}

	private int progress=0;
		
	public void paint(Graphics g) {
		if (g!=null) {
			g.setColor(appletGB);
			g.fillRect(0,0,getSize().width,getSize().height);
			if (D_logo!=null) {
				int w1=Math.min(D_logo.getWidth(this),getSize().width);
				int h1=Math.min(D_logo.getHeight(this),getSize().height);
				w1=D_logo.getWidth(this)*h1/D_logo.getHeight(this);
				g.drawImage(D_logo,(getSize().width-w1)/2,(getSize().height-h1)/2,w1,h1,this);
			}
		}
	}
	
	public String dump() {
		scene.registerTextsInParser();
		return p.dump();
	}

	public void undump(String dump) {
		scene.stopAnimations();
		p.undump(dump);
		scene.updateTextsFromNodes();
		updateTextFieldsFromNodes(true);
		clear();
	}
	
	private boolean showingAnswer=true;
	private String dump0;
	
	public void showSolution() { 
		if (disableControls && showingAnswer) {
			dump0=dump();
			scene.showTextSolutions();
			String ds=BasicStr.decimal_symbol;
			BasicStr.decimal_symbol=".";
			scene.showSolutions();
			for (int i=0;i<numctrls.length;i++) {
				if (numctrls[i]!=null && numctrls[i].ccfg.isEval()) {
					if (numctrls[i].answer==null) {
						numctrls[i].answer=numctrls[i].getStringValue();
					}
					String pattern=numctrls[i].ccfg.getAnswerPattern().trim();
					String solution=p.getSolution(pattern);
					numctrls[i].defineValue(solution);
				}
			}
			BasicStr.decimal_symbol=ds;
			showingAnswer=false;
			refresh(true);
		}
	}

	public void showAnswer() { 
		if (disableControls && !showingAnswer) {
			undump(dump0);
			scene.showUserTexts();
			scene.updateTextsFromNodes();
			if (numctrls!=null && numctrls.length>0) {
				String ds=BasicStr.decimal_symbol;
				BasicStr.decimal_symbol=".";
				for (int i=0;i<numctrls.length;i++) {
					if (numctrls[i]!=null && numctrls[i].answer!=null) {
						numctrls[i].defineValue(numctrls[i].answer);
					}
				}
				BasicStr.decimal_symbol=ds;
				showingAnswer=true;
				refresh(true);
			}
		}
	}

	private double nota;
	private int puntos,buenos,malos;

	public synchronized String getEvaluation() {
		String ds=BasicStr.decimal_symbol;
		BasicStr.decimal_symbol=".";
		String str="";
		int numquestions=0;
		int correct=0;
		int wrong=0;
		int unanswered=0;
		puntos=0;buenos=0;malos=0;
		for (int i=0;i<numctrls.length;i++) {
			if (numctrls[i]!=null && numctrls[i].ccfg.isEval()) {
				numquestions++;
				puntos=puntos+numctrls[i].peso();
				String pattern=numctrls[i].ccfg.getAnswerPattern().trim();
				String answer=numctrls[i].getStringValue().trim();
				str+=numctrls[i].getName()+"="+answer+"|";
				if (BasicStr.hasContent(answer)) {
System.out.println("Descartes.getEvaluation");
					if (p.isCorrect(pattern,answer)) {
						str+="1";
						correct++;
						buenos=buenos+numctrls[i].peso();
					} else {
						str+="0";
						wrong++;
						malos=malos+numctrls[i].peso();
					}
				} else {
					unanswered++;
				}
				str+="\n";
			}
		}
//		double average=(100.0*correct)/((double) numquestions);
//		str="questions="+numquestions+"\n"
//			+"correct="+correct+"\n"
//			+"wrong="+wrong+"\n"
//			+str;
		nota=(100.0*buenos)/((double) puntos);
		str="questions="+puntos+"\n"
			+"correct="+buenos+"\n"
			+"wrong="+malos+"\n"
			+str;
		BasicStr.decimal_symbol=ds;
		return str;
	}

	public String Evaluate(String expression) throws Exception {
		Node N=p.Analyse(expression);
		N.Evaluate(0);
		return N.getStringValue();
	}

}


/*  -------------------- OTRAS CLASES ---------------------- */

class DescartesWindow extends Window implements WindowListener {

	private static Frame father=new Frame();
	private Descartes D;
	private Dimension dim,ScrSz;
	private Point p;

	DescartesWindow(Descartes D,Dimension dim) {
		super(father);
		this.D=D;
		this.dim=dim;
		setBackground(Descartes.basicBlue);
		addWindowListener(this);
		setLayout(new GridLayout(1,1));
		add(D.mainP);
		pack();
		ScrSz=Toolkit.getDefaultToolkit().getScreenSize();
		p=new Point((ScrSz.width-dim.width)/2,(ScrSz.height-dim.height)/2);
		p.x=(p.x<0)?0:p.x;
		p.y=(p.y<0)?0:p.y;
		setBounds(p.x,p.y,dim.width,dim.height);
		D.setSize(dim);
		D.mainP.setSize(dim);
		if (D instanceof Arquimedes) {
			setLocation((ScrSz.width-dim.width)/2,(ScrSz.height-Math.min(565,dim.height))/2);
		}
		show();
	}

	public void windowClosing(WindowEvent e){
		setVisible(false);
		D.closeScene();
		D.destroy();
	}
    public void windowOpened(WindowEvent e){
		paintAll(getGraphics());
    	int dx=D.mainP.getSize().width-dim.width;
    	int dy=D.mainP.getSize().height-dim.height;
    	if (dx!=0 || dy!=0) { 
			setSize(getSize().width-dx,getSize().height-dy);
    	}
		D.setSize(dim);
		D.mainP.setSize(dim);
		D.start();
    }

    public void windowActivated(WindowEvent e){
    }
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){
	}
    public void windowDeiconified(WindowEvent e){
	}
    public void windowClosed(WindowEvent e){}

}

class DescartesDialog extends Dialog implements WindowListener {

	private static Frame father=new Frame();
	private Descartes D;
	private Dimension dim,ScrSz,WD;
	private Point p;

	DescartesDialog(Descartes D,String name,Dimension dim) {
		super(father,name,true);
		this.D=D;
		this.dim=dim;

		setTitle(name);
		setBackground(Descartes.basicBlue);
		addWindowListener(this);
		setLayout(new GridLayout(1,1));
		add(D.mainP);
		pack();
		ScrSz=Toolkit.getDefaultToolkit().getScreenSize();
		WD=new Dimension(dim.width+8,dim.height+34);
		p=new Point((ScrSz.width-WD.width)/2,(ScrSz.height-WD.height)/2);
		p.x=(p.x<0)?0:p.x;
		p.y=(p.y<0)?0:p.y;
		setResizable(false);
		setBounds(p.x,p.y,WD.width,WD.height);
		D.setSize(dim);
		D.mainP.setSize(dim);
		if (D instanceof Arquimedes) {
			setLocation((ScrSz.width-dim.width)/2,(ScrSz.height-Math.min(565+34,dim.height))/2);
		}
		show();
	}

	public void windowClosing(WindowEvent e){
		setVisible(false);
		D.closeScene();
		D.destroy();
	}
    public void windowOpened(WindowEvent e){
		paintAll(getGraphics());
    	int dx=D.mainP.getSize().width-dim.width;
    	int dy=D.mainP.getSize().height-dim.height;
    	if (dx!=0 || dy!=0) { 
			setSize(getSize().width-dx,getSize().height-dy);
			WD=getSize();
    	}
		D.setSize(dim);
		D.mainP.setSize(dim);
		D.start();
		setSize(WD);
    }

    public void windowActivated(WindowEvent e){
    }
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){
	}
    public void windowDeiconified(WindowEvent e){
	}
    public void windowClosed(WindowEvent e){}

}

class DescartesFrame extends Frame implements WindowListener {

	private Descartes D;
	private Dimension dim,ScrSz,WD;
	private Point p;

	DescartesFrame(Descartes D,String name,Dimension dim) {
		this.D=D;
		this.dim=dim;
		setTitle(name);
		setBackground(Descartes.basicBlue);
		addWindowListener(this);
		setLayout(new GridLayout(1,1));
		add(D.mainP);
		pack();
		ScrSz=Toolkit.getDefaultToolkit().getScreenSize();
		WD=new Dimension(dim.width+8,dim.height+34);
		p=new Point((ScrSz.width-WD.width)/2,(ScrSz.height-WD.height)/2);
		p.x=(p.x<0)?0:p.x;
		p.y=(p.y<0)?0:p.y;
		setResizable(false);
		setBounds(p.x,p.y,WD.width,WD.height);
		D.mainP.setSize(dim);
		if (D instanceof Arquimedes) {
			setLocation((ScrSz.width-dim.width)/2,(ScrSz.height-Math.min(565+34,dim.height))/2);
		}
		setVisible(true);
	}
	
	public void windowClosing(WindowEvent e){
		setVisible(false);
		if (!D.pop) {
			D.closeScene();
			D.destroy();
		}
	}
    public void windowOpened(WindowEvent e){
		paintAll(getGraphics());
    	int dx=D.mainP.getSize().width-dim.width;
    	int dy=D.mainP.getSize().height-dim.height;
    	if (dx!=0 || dy!=0) { 
			setSize(getSize().width-dx,getSize().height-dy);
			WD=getSize();
    	}
		D.mainP.setSize(dim);
		if (D.pop) {
			D.startPopLMS();
			D.startScene(true);
		} else {
			D.start();
		}
		setSize(WD);
    }
    public void windowActivated(WindowEvent e){
    }
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){
	}
    public void windowDeiconified(WindowEvent e){
	}
    public void windowClosed(WindowEvent e){}
    
}

