/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.net.*;
import com.mja.util.*;
import com.mja.math.*;
import com.mja.math3D.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.parser.*;
import com.mja.poly.*;
import com.mja.lang.*;
import com.mja.text.*;
import com.mja.algebra.*;
import com.mja.descartes.*;

public class SpaceTA extends Space {
	
	public SpaceTA(Descartes D,spaceConfig sc) {
		super(D,sc);
		DA=new DescartesA();
		DA.inD3=true;
		DA.setAppletContext(D.getAppletContext());
		DA.setStub(new DAStub(D,new Hashtable()));
		DA.setName(spcfg.getName());
		DA.init();
		String[] paramContent=new String[DescartesAConfig.paramName.length];
		for (int i=0;i<paramContent.length;i++) {
			paramContent[i]=spcfg.s_value[spaceConfig.controls+i];
		}
		DA.setConfig(paramContent);
		String prefix="";
		if (BasicStr.hasContent(spcfg.getName())) {
			prefix=spcfg.getName()+".";
		}
		chngN=D.p.Var(prefix+"_reiniciar_");
		strEq=spcfg.s_value[spcfg.equation];
		eqStr=D.p.Var(prefix+"_ecuacin_");
		eqStr.setOnlyStr(strEq);
		createSeries();
		DA.build();
		setLayout(new GridLayout(1,1));
		add(DA);
		DA.addMouseListener(this);
	}

	DescartesA DA;
	Node eqStr=null, chngN=null;
	String strEq="";

	public String toTeX(boolean grayscale) {
		return "";
	} 

	public void start() {
		super.start();
		DA.start();	
	}

	public void stop() {
		removeAll();
		DA.stop();
		DA.destroy();
		super.stop();
	}

	void createSeries() {
		SeriesConfig[] sc=new SeriesConfig[1];
		if (BasicStr.hasContent(eqStr.getStr())) {
			String str="";
			str+="guiado='"+spcfg.s_value[spcfg.guided]+"' ";
			str+="modos='"+spcfg.s_value[spcfg.mode]+"' ";
			str+="ecuacin='"+eqStr.getStr()+"' ";
			sc=new SeriesConfig[1];
			sc[0]=new SeriesConfig(D,D.Tr,D.p,str,2,true);
			DA.setControls("no");
		} else {
			StringTokenizer st=new StringTokenizer(spcfg.s_value[spcfg.exercises],",");
			sc=new SeriesConfig[st.countTokens()];
			int i=0;
			while (i<sc.length) {
				sc[i++]=new SeriesConfig(D,D.Tr,D.p,"ejercicios='"+st.nextToken()+"' ",2,true);
			}
			DA.setControls("arriba");
		}
		DA.setSeriesConfig(sc);
	}

/* ------------------ Implementation of Space --------------------*/

	protected R2 projection(R2 p) {
		return new R2(0,0);
	}

	protected R2 injection(double x,double y) {
		return new R2(0,0);
	}

	synchronized protected void doCalc() {	// synchronized para que no interfieran el run y el mouseDragged
	}
	
	boolean eqChanged() {
		if (!strEq.equals(eqStr.getStr())) {
			return true;
		}
		return false;
	}
	
	boolean reinit() {
		if (chngN.getDouble()>0) {
			chngN.setDouble(0);
			return true;
		}
		return false;
	}

	void doBack(boolean clear) {
//		super.doBack(clear);
		setVisible(visibilityN.Evaluate(1)>0);
		if (isVisible() && (eqChanged() || reinit())) {
			chngN.setDouble(0);
			strEq=eqStr.getStr();
			createSeries();
			DA.start();
		}
	}

	protected void doFront(boolean calc) {
//		if (isVisible()) {
//			gmain.drawImage(back,0,0,this);
////			drawAlgebraicThings();
//			super.doFront(calc);
//		}
	}
	
//	void drawAlgebraicThings() {
//	}

	protected void writeCoordinates(Graphics g,int x, int y) {
	}

	protected boolean onDrag(boolean right,int dx,int dy) {
		if (right) {
		} else {
		}
		return false;
	}

	protected void stopMoving() {
	}

	protected boolean isMoving() {
		return false;
	}

	protected void flushImages() {
	}
}

class DAStub implements AppletStub {
	
	
	private Hashtable ht;
	private Applet A;
	
	DAStub(Applet A, Hashtable ht) {
		this.A=A;
		this.ht=ht;
	}
	
	public void appletResize(int dx,int dy) {
	}
	
	public String getParameter(String name) {
		return A.getParameter(name);
	}
	
	public boolean isActive() {
		return A.isActive();
	}
	
	public URL getCodeBase() {
		return A.getCodeBase();
	}

	public URL getDocumentBase() {
		return A.getDocumentBase();
	}
	
	public AppletContext getAppletContext() {
		return A.getAppletContext();
	}
}