/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

/*------------------------------------------------------------*/
/*                          config                            */
/*                          (c) MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.net.*;
import java.io.*;

import com.mja.parser.*;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.lang.*;
import org.unam.matem.Attribute;

public class config {

	public String s_applet="";
	public animConfig animC;
	public static final int Escala0=48;

	public String name="",version0="";
	public String course,unit,image_loader,expand;
	public boolean useLMS, useRAD, useAlgebra, useSound, useCC;
	public boolean isEditable=true; //,modular;
	public double escala0=Escala0;
	public int language=1;
	public boolean[] buttonVisible;
	public int rows_north=0,rows_south=0,width_west=0,width_east=0,rows_height=BasicStr.lineVSize();
	public String txt_infoind="",txt_infoest="";
	public boolean applied;
	public spaceConfig[] sc=new spaceConfig[0];
	public controlConfig[] cc=new controlConfig[0];
	public auxConfig[] auxiliar=new auxConfig[0],aux_macro=new auxConfig[0];
	private Vector vaux;
	public graphR2Config[] gR2c=new graphR2Config[0];
	public graphR2Config[] allgR2c=new graphR2Config[0];
	public graphR3Config[] gR3c=new graphR3Config[0];
	public graphR3Config[] allgR3c=new graphR3Config[0];
	private Hashtable macro2D,macro3D;
	private String s_cfgsz;

	private Descartes D;

	public config cloneConfig() {
		this.D=D;
		config auxc=new config(D,toAppletParams(D.Tr));
		auxc.txt_infoind=txt_infoind;
		auxc.txt_infoest=txt_infoest;
		auxc.language=language;
		auxc.s_applet=s_applet;
		auxc.applied=applied;
		auxc.escala0=escala0;
		auxc.version0=version0;
		auxc.macro2D=macro2D;
		auxc.macro3D=macro3D;
		auxc.aux_macro=aux_macro;
		auxc.allgR2c=allgR2c;
		auxc.allgR3c=allgR3c;
//		auxc.modular=modular;
		auxc.isEditable=isEditable;
		auxc.useSound=useSound;
		auxc.useAlgebra=useAlgebra;
		auxc.useRAD=useRAD;
		auxc.useLMS=useLMS;
		auxc.useCC=useCC;
		auxc.image_loader=image_loader;
		auxc.expand=expand;
		auxc.s_cfgsz=s_cfgsz;
		return auxc;
	}
	
	public boolean isInstalled() {
		return false;
	}
	
	public config(Descartes D) {
		this.D=D;
		vaux=new Vector();
		macro2D=new Hashtable();
		macro3D=new Hashtable();
		name="";
		unit="";
		course="";
		useLMS=false;
		isEditable=true;
		useRAD=false;
		useSound=isInstalled();
		useAlgebra=isInstalled();
		useCC=!"no".equals(D.getParameter("CreativeCommonsLicense"));
		image_loader=D.getParameter("image_loader");
		expand=D.getParameter("expand");
		txt_infoind=D.getParameter("infoind");
		txt_infoest=D.getParameter("infoest");
		readButtonsAndRows(D.Tr,null);
		sc=getSpaceConfigs(D.Tr,null);
		cc=getControlConfigs(D.Tr,null);
		auxiliar=getAuxiliars(D.Tr,null);
		aux_macro=new auxConfig[0];
		gR2c=getR2Graphs(D.Tr,null);
		allgR2c=getR2Graphs(D.Tr,null);
		gR3c=getR3Graphs(D.Tr,null);
		allgR3c=getR3Graphs(D.Tr,null);
		animC=new animConfig(D.Tr,null);
		animC.active=false;
		Attribute a=D.Tr.getParam(D,data.size);
		if (a!=null) {
			s_cfgsz=a.value;
//System.out.println("1 "+s_cfgsz);
		}
	}

	public config(Descartes D,Attribute[] aa) {
		this.D=D;
		vaux=new Vector();
		macro2D=new Hashtable();
		macro3D=new Hashtable();
		language=D.Tr.getLanguage(D.Tr.getValue(aa,data.p_language));
		D.Tr.setActiveLanguage(language);

		isEditable=translator.isNotFalse(D.Tr.getValue(aa,data.isEditable));

		Expl.init(D,!D.inWeb());

		escala0=BasicStr.parseInteger(Attribute.getValue(aa,"escala0"),Escala0,Escala0);
		name=D.Tr.getValue(aa,data.name);
		unit=D.Tr.getValue(aa,data.unit);
		course=D.Tr.getValue(aa,data.course);
		spaceConfig.types=spaceConfig.allTypes;
		useLMS=BasicStr.hasContent(course);
//		modular=true;
//		modular=translator.isTrue(D.Tr.getValue(aa,data.modular));

		useSound=translator.isTrue(D.Tr.getValue(aa,data.useSound))||isInstalled();
		if (useSound) {
			Action.actions=Action.actionsS;
		}
		useAlgebra=translator.isTrue(D.Tr.getValue(aa,data.useAlgebra))||isInstalled();;
		if (useAlgebra) {
			spaceConfig.types=spaceConfig.allTypes;
		} else {
			spaceConfig.types=spaceConfig.typesR2R3;
		} 
		useRAD=translator.isTrue(D.Tr.getValue(aa,data.useRAD));
		image_loader=D.getParameter("image_loader");
		expand=D.getParameter("expand");
		useCC=!"no".equals(D.getParameter("CreativeCommonsLicense"));
		version0=D.Tr.getValue(aa,data.p_version,"1"); // por si desea usar la versin.
		txt_infoind=D.Tr.getValue(aa,data.infoind);
		txt_infoest=D.Tr.getValue(aa,data.infoest);
		readButtonsAndRows(D.Tr,aa);
		sc=getSpaceConfigs(D.Tr,aa);
		cc=getControlConfigs(D.Tr,aa);
		auxiliar=getAuxiliars(D.Tr,aa);
		gR2c=getR2Graphs(D.Tr,aa);
		gR3c=getR3Graphs(D.Tr,aa);
		String s_anim=D.Tr.getValue(aa,data.p_anim);
		if (BasicStr.hasContent(s_anim)) {
			animC=new animConfig(D.Tr,s_anim);
			animC.active=true;
		} else {
			animC=new animConfig(D.Tr,null);
			animC.active=false;
		}
		applyMacros();
//		s_cfgsz=D.Tr.getValue(aa,data.size); // esta no funciona porqu?
		s_cfgsz=D.getParameter(D.Tr.getTr(data.size));
	}
	
	private Dimension cfgdim;
	
	public Dimension getCfgSize() {
		if (cfgdim==null && BasicStr.hasContent(s_cfgsz)) {
			StringTokenizer st=new StringTokenizer(s_cfgsz,"x");
			if (st.countTokens()==2) {
				String s_w=st.nextToken();
				String s_h=st.nextToken();
				try {
					int w=Integer.parseInt(s_w);
					int h=Integer.parseInt(s_h);
					cfgdim = new Dimension(w,h);
				} catch (NumberFormatException e) {
				}
			}
		}
//System.out.println("3 "+cfgdim);
		return cfgdim;
	}
	
	public boolean has3D() {
		for (int i=0;i<sc.length;i++) {
			if (sc[i].type==spaceConfig.tresD) {
				return true;
			}
		}
		return false;
	}

/*
	public boolean hasCalc() {
		return true;
	}

	public boolean hasSound() {
		return true;
	}

	public boolean hasAlgebra() {
		return false;
	}

	public boolean useRAD() {
		return useLMS;
	}
*/

	public void addSpace(spaceConfig spcfg) {
		for (int i=0;i<sc.length;i++) {
			if (spcfg==sc[i]) {
				D.renewEditorConfig();
				return;
			}
		}
		spaceConfig[] sca=new spaceConfig[sc.length+1];
		for (int i=0;i<sc.length;i++) {
			sca[i]=sc[i];
		}
		sca[sc.length]=spcfg;
		sc=sca;
		D.renewEditorConfig();
	}

	public void removeSpace(spaceConfig spcfg) {
		for (int i=0;i<sc.length;i++) {
			if (spcfg==sc[i]) {
				spaceConfig[] sca=new spaceConfig[sc.length-1];
				int n=0;
				for (int j=0;j<sc.length;j++) {
					if (j!=i) {
						sca[n++]=sc[j];
					}
				}
				sc=sca;
				D.renewEditorConfig();
			}
		}
	}

	public void addControl(controlConfig ccfg) {
		for (int i=0;i<cc.length;i++) {
			if (ccfg==cc[i]) {
				return;
			}
		}
		controlConfig[] cca=new controlConfig[cc.length+1];
		for (int i=0;i<cc.length;i++) {
			cca[i]=cc[i];
		}
		cca[cc.length]=ccfg;
		cc=cca;
		D.renewEditorConfig();
	}

	public void removeControl(controlConfig ccfg) {
		for (int i=0;i<cc.length;i++) {
			if (ccfg==cc[i]) {
				controlConfig[] cca=new controlConfig[cc.length-1];
				int n=0;
				for (int j=0;j<cc.length;j++) {
					if (j!=i) {
						cca[n++]=cc[j];
					}
				}
				cc=cca;
				D.renewEditorConfig();
			}
		}
	}

	public spaceConfig getSpace(String name) {
		if (name!=null) {
			for (int i=0;i<sc.length;i++) {
				if (name.equals(sc[i].getName())) {
					return sc[i];
				}
			}
		}
		return null;
	}

	public boolean hasMacros() {
		return (!macro2D.isEmpty()) || (!macro3D.isEmpty());
	}

	public boolean hasR2() {
		for (int i=0;i<sc.length;i++) {
			if (sc[i].isR2()) {
				return true;
			}
		}
		return false;
	}

	public boolean hasR3() {
		for (int i=0;i<sc.length;i++) {
			if (sc[i].isR3()) {
				return true;
			}
		}
		return false;
	}

	private int ngR2=0,ngR3=0;


	public void applyMacros() {
//long T=System.currentTimeMillis();
		ngR2=0;
		ngR3=0;
		applyMacros(gR2c,gR3c,"");
		allgR2c=new graphR2Config[ngR2];
		int n=0;
		for (int i=0;i<gR2c.length;i++) {
			graphR2Config g=gR2c[i];
			if (data.gtix[g.getTypeIndex(D.Tr)]==data.t_macro) {
				Vector v=(Vector) macro2D.get(g.getName());
				if (v!=null) {
					for (int k=0;k<v.size();k++) {
						allgR2c[n++]=(graphR2Config) v.elementAt(k);
					}
				}
			} else {
				allgR2c[n++]=g;
			}
		}
		allgR3c=new graphR3Config[ngR3];
		n=0;
		for (int i=0;i<gR3c.length;i++) {
			graphR3Config gc=gR3c[i];
			if (data.gtR3ix[gc.getTypeIndex(D.Tr)]==data.t_macro) {
				Vector v=(Vector) macro3D.get(gc.getName());
				if (v!=null) {
					for (int k=0;k<v.size();k++) {
						allgR3c[n++]=(graphR3Config) v.elementAt(k);
					}
				}
			} else {
				allgR3c[n++]=gc;
			}
		}

		aux_macro=new auxConfig[vaux.size()];
		for (int i=0;i<aux_macro.length;i++) {
			aux_macro[i]=(auxConfig) vaux.elementAt(i);
		}
//System.out.println("applyMacros: "+(System.currentTimeMillis()-T)+" ms");
	}


	private void applyMacros(graphR2Config[] gR2c,graphR3Config[] gR3c,String prfx) {
		D.setProgress(20);
		int NG=1;
		if (gR2c!=null) {
			NG+=gR2c.length;
		}
		if (gR3c!=null) {
			NG+=gR3c.length;
		}

		if (gR2c!=null && gR2c.length>0) {
			for (int i=0;i<gR2c.length;i++) {
				graphR2Config g=gR2c[i];
				if (data.gtix[g.getTypeIndex(D.Tr)]==data.t_macro) {
					Vector v=readMacro(D.Tr,false,g.getSpace(),g.getName(),g.getCondition(),g.getExpr(),g.getLocation(),g.getRotation(),g.getCondition(),g.absCoor);
					for (int j=0;j<v.size();j++) {
						graphR2Config vG=(graphR2Config)v.elementAt(j);
						if (D.Tr.isTrue(g.s_value[g.ixbackground])) {
							vG.s_value[g.ixbackground]=g.s_value[g.ixbackground];
							vG.isInBack=D.Tr.isTrue(g.s_value[g.ixbackground]);
						}
						if (g.isFamily) {
							vG.isFamily=g.isFamily;
							vG.fparam=g.fparam;
							vG.f_interval=g.f_interval;
							vG.f_steps=g.f_steps;
						}
					}
					g.setName(prfx+g.getName());
					macro2D.put(g.getName(),v);
					if (v!=null) {
						ngR2=ngR2+v.size();
					}
				} else {
					ngR2++;
				}
				D.setProgress(20+(80*i)/NG);
			}
		}
		if (gR3c!=null && gR3c.length>0) {
			for (int i=0;i<gR3c.length;i++) {
				graphR3Config gc=gR3c[i];
				if (data.gtR3ix[gc.getTypeIndex(D.Tr)]==data.t_macro) {
					Vector v=readMacro(D.Tr,true,gc.getSpace(),gc.getName(),gc.getCondition(),gc.getExpr(),gc.getLocation(),gc.getRotation(),gc.getCondition(),false);
					if (D.Tr.isTrue(gc.s_value[gc.ixbackground])) {
						for (int j=0;j<v.size();j++) {
							((graphR3Config)v.elementAt(j)).s_value[gc.ixbackground]=gc.s_value[gc.ixbackground];
//							((graphR3Config)v.elementAt(j)).isInBack=true;
						}
					}
					gc.setName(prfx+gc.getName());
					macro3D.put(gc.getName(),v);
					if (v!=null) {
						ngR3=ngR3+v.size();
					}
				} else {
					ngR3++;
				}
				D.setProgress(20+(80*(gR2c.length+i))/NG);
			}
		}
		D.setProgress(100);
	}


	public Attribute[] toAppletParams(translator Tr) {
		Vector v=new Vector();
		if (BasicStr.hasContent(course)) {
			v.addElement(new Attribute(Tr.getTr(data.course),course));
		}
		if (BasicStr.hasContent(unit)) {
			v.addElement(new Attribute(Tr.getTr(data.unit),unit));
		}
		if (BasicStr.hasContent(name)) {
			v.addElement(new Attribute(Tr.getTr(data.name),name));
		}
		v.addElement(new Attribute(Tr.getTr(data.p_version),data.Version));
		v.addElement(new Attribute(Tr.getTr(data.p_language),Tr.getTr(data.langName)));
		String s="";
		for (int i=0;i<buttonVisible.length;i++) {
			s+=Tr.getTr(data.bnameix[i])+"="+Tr.booleanName(buttonVisible[i])+" ";
		}
		if (BasicStr.hasContent(txt_infoind)) {
			s+="infoind="+txt_infoind+" ";
		}
		if (BasicStr.hasContent(txt_infoest)) {
			s+="infoest="+txt_infoest+" ";
		}
		if (rows_north!=0) {
			s+=Tr.getTr(data.rows_north)+"="+rows_north+" ";
		}
		if (rows_south!=0) {
			s+=Tr.getTr(data.rows_south)+"="+rows_south+" ";
		}
		if (width_east!=0) {
			s+=Tr.getTr(data.width_east)+"="+width_east+" ";
		}
		if (width_west!=0) {
			s+=Tr.getTr(data.width_west)+"="+width_west+" ";
		}
		if (rows_height!=23) {
			s+=Tr.getTr(data.alto)+"="+rows_height+" ";
		}
		v.addElement(new Attribute(Tr.getTr(data.p_buttons),s.trim()));
		int just=2;
		for (int i=0;i<sc.length;i++) {
			if (i>=100) {
				just=3;
			}
			v.addElement(new Attribute(data.spacePrefix+BasicStr.IntegerToString(i+1,just),sc[i].toString(" ",Tr)));
		}
		just=2;
		for (int i=0;i<cc.length;i++) {
			if (i>=100) {
				just=3;
			}
			v.addElement(new Attribute(data.controlPrefix+BasicStr.IntegerToString(i+1,just),cc[i].toString(" ",Tr)));
		}
		just=2;
		for (int i=0;i<auxiliar.length;i++) {
			if (i>=100) {
				just=3;
			}
			v.addElement(new Attribute(data.auxPrefix+BasicStr.IntegerToString(i+1,just),auxiliar[i].toString(" ",Tr)));
		}
		just=2;
		for (int i=0;i<gR2c.length;i++) {
			if (i>=100) {
				just=3;
			}
			v.addElement(new Attribute(data.graphPrefix+BasicStr.IntegerToString(i+1,just),gR2c[i].toString(" ",Tr)));
		}
		just=2;
		for (int i=0;i<gR3c.length;i++) {
			if (i>=100) {
				just=3;
			}
			v.addElement(new Attribute(data.graph3Prefix+BasicStr.IntegerToString(i+1,just),gR3c[i].toString(" ",Tr)));
		}
		if (animC.active) {
			v.addElement(new Attribute(Tr.getTr(data.p_anim),animC.toString(" ",Tr)));
		}

		Attribute[] aa=new Attribute[v.size()];
		Enumeration e=v.elements();
		for (int i=0;i<aa.length;i++) {
			aa[i]=(Attribute) e.nextElement();
		}
		return aa;
	}

	private void readButtonsAndRows(translator Tr,Attribute[] aa) {
		String auxs=Tr.getValue(aa,data.p_buttons);
		Attribute[] bvaa=Attribute.parse(auxs);
		buttonVisible=new boolean[4];
		for (int i=0;i<buttonVisible.length;i++) {
			buttonVisible[i]=Tr.isNotFalse(Tr.getValue(bvaa,data.bnameix[i]));
		}
		rows_north=BasicStr.parseInteger(Tr.getValue(bvaa,data.rows_north),0,0);
		rows_south=BasicStr.parseInteger(Tr.getValue(bvaa,data.rows_south),0,0);
		width_east=BasicStr.parseInteger(Tr.getValue(bvaa,data.width_east),0,0);
		width_west=BasicStr.parseInteger(Tr.getValue(bvaa,data.width_west),0,0);
		rows_height=BasicStr.parseInteger(Tr.getValue(bvaa,data.alto),23,23);
	}

	private static spaceConfig[] getSpaceConfigs(translator Tr,Attribute[] aa) {
		if (aa==null) {
			spaceConfig[] sa=new spaceConfig[1];
			sa[0]= new spaceConfig(Tr,"R2","");
			return sa;
		} else {
			Vector vspa=new Vector();
			String spstr=Attribute.getValue(aa,Tr.getTr(data.p_space));
			if (BasicStr.hasContent(spstr)) {
				vspa.addElement(spstr);
			} else {
				String[] values=Attribute.get100Values(data.spacePrefix,aa);
				for (int i=0;i<values.length;i++) {
					vspa.addElement(values[i]);
				}
			}
			spaceConfig[] sa=new spaceConfig[vspa.size()];
			Enumeration e=vspa.elements();
			for (int i=0;i<sa.length;i++) {
				sa[i]=new spaceConfig(Tr,(String)e.nextElement());
			}
			return sa;
		}
	}

	private static controlConfig[] getControlConfigs(translator Tr,Attribute[] aa) {
		if (aa==null) {
			return controlConfig.defaultControls(Tr);
		}
		String[] values=Attribute.get100Values(data.controlPrefix,aa);
		controlConfig[] ca=new controlConfig[values.length];
		for (int i=0;i<values.length;i++) {
			ca[i]=new controlConfig(Tr,values[i]);
		}
		return ca;
	}

	public controlConfig addNumCtrlCfg(String data) {
		controlConfig ncc=new controlConfig(D.Tr,data);
		controlConfig[] cca=cc;
		cc=new controlConfig[cca.length+1];
		for (int i=0;i<cca.length;i++) {
			cc[i]=cca[i];
		}
		cc[cca.length]=ncc;
		return ncc;
	}

	public void addSpace(String data) {
		spaceConfig nsc=new spaceConfig(D.Tr,data);
		spaceConfig[] sca=sc;
		sc=new spaceConfig[sca.length+1];
		for (int i=0;i<sca.length;i++) {
			sc[i]=sca[i];
//			if (!BasicStr.hasContent(sc[i].getSpaceID())) {
//				sc[i].setSpaceID("SPACE_"+Integer.toString(i));
//			}
		}
		sc[sca.length]=nsc;
	}

	private static auxConfig[] getAuxiliars(translator Tr,Attribute[] aa) {
		auxConfig[] ac=null;
		if (aa==null) {
			ac=new auxConfig[1];
			ac[0]=new auxConfig(Tr,"pi",data.constant);
			ac[0].s_value[auxConfig.ixexpr]="3.1416";
		} else {
			String[] values=Attribute.get100Values(data.auxPrefix,aa);
			ac=new auxConfig[values.length];
			for (int i=0;i<ac.length;i++) {
//System.out.println(values[i]);
				ac[i]=new auxConfig(Tr,Attribute.parse(values[i]));
			}
		}
		return ac;
	}

	private graphR2Config[] getR2Graphs(translator Tr,Attribute[] aa) {
		graphR2Config[] gR2c=null;
//System.out.println("getR2Graphs IN");
		if (aa==null) {
			gR2c=new graphR2Config[1];
			gR2c[0]=new graphR2Config(Tr,Tr.getTr(data.t_equation),"y=x",version0);
		} else {
			String[] values=Attribute.get100Values(data.graphPrefix,aa);
//System.out.println("getR2Graph 100 values");
			gR2c=new graphR2Config[values.length];
			for (int i=0;i<values.length;i++) {
//System.out.println("getR2Graph "+i);
				gR2c[i]=new graphR2Config(Tr,Attribute.parse(values[i]),version0);
			}
		}
//System.out.println("getR2Graphs OUT");
		return gR2c;
	}

	private graphR3Config[] getR3Graphs(translator Tr,Attribute[] aa) {
		graphR3Config[] gR3c=new graphR3Config[0];
		if (aa!=null) {
			String[] surfastr=Attribute.get100Values(data.graph3Prefix,aa);
			gR3c=new graphR3Config[surfastr.length];
			for (int i=0;i<surfastr.length;i++) {
				gR3c[i]=new graphR3Config(Tr,Attribute.parse(surfastr[i]));
			}
		}
		return gR3c;
	}

	private Vector readMacro(translator Tr,boolean isR3,String space,String name,String dibujarsi,String fileName,String location,String rotation,String cond,boolean absCoor) {
		Vector auxv=new Vector();
		String macro_path="";
		String filename=fileName;
		filename=fileName;
		if (fileName.startsWith("./")) {
			filename=fileName.substring(2);
		}
		try {
			macro_path=filename;
			auxv=doReadMacro(macro_path,filename,Tr,space,isR3,name,dibujarsi,location,rotation,cond,absCoor);
//System.out.println(filename+" FOUND in direct path: "+macro_path);
			return auxv;
		} catch(Exception e) {
		}
		String sptype="g2d";
		if (isR3) {
			sptype="g3d";
		}

		macro_path="macros/"+sptype+"/"+filename;
		try {
			auxv=doReadMacro(macro_path,filename,Tr,space,isR3,name,dibujarsi,location,rotation,cond,absCoor);
//System.out.println(filename+" FOUND in external macros folder");
			return auxv;
		} catch(Exception e) {
		}

		macro_path="/resources/macros/"+sptype+"/"+filename;
		try {
			auxv=doReadMacro(macro_path,filename,Tr,space,isR3,name,dibujarsi,location,rotation,cond,absCoor);
//System.out.println(filename+" FOUND in resources/macros");
			return auxv;
		} catch(Exception e) {
		}
System.out.println("MACRO "+filename+" NOT FOUND");
		return auxv;
	}
	
	private static Hashtable macrosAAA=new Hashtable();

	private Vector doReadMacro(String filepath,String filename,translator Tr,String space,boolean isR3,String mname,String dibujarsi,
							String location,String rotation,String cond,boolean absCoor)
							throws Exception {
		Vector auxv=new Vector();
		String[] stra=new String[0];
		Attribute[][] aaa=null;
		int ix=0;
		int IX=0;
		boolean isSaved=false;
		if (macrosAAA.containsKey(filepath)) {
//System.out.println("MACRO "+filepath+" found in cache");
			aaa=(Attribute[][]) macrosAAA.get(filepath);
			isSaved=true;
		} else {
			String str="";
			if (filepath.startsWith("/resources")) {
				InputStream is=D.getClass().getResourceAsStream(filepath);
				try {
					str=mjaFile.readInputStream(is);
				} catch(Exception e) {
				}
			} else {
				str=mjaFile.readFile(D,D.inWeb(),filepath,false);
			}
			if (!BasicStr.hasContent(str)||str.startsWith("404")) {
				throw (new Exception("file not found"));
			}

			D.addMacroFilename(filename);

			str=mjaHtml.decodeHTMLEncoding(str);
			stra=BasicStr.toStringArray(str);
			aaa=new Attribute[stra.length][];
			aaa[ix]=Attribute.parse(stra[ix]);
		}

		IX=aaa.length;
		try {
			Vector TempVaux=new Vector();
			int AL=Tr.getActiveLanguage();
			Attribute[] aa=Attribute.copy(aaa[ix]);
			if (aa!=null&&aa.length>0) {
				if (Tr.equals(aa[0].name,data.macrotype)) {
					if (aa[0].value.equals("R3")) {
						isR3=true;
					}
					// read auxiliaries
					int OL=Tr.guessOriginalLanguageFromName(data.macrotype,aa[0].name);
					Tr.setActiveLanguage(OL);
					Vector replv=new Vector();
					while (true) {
						ix++;
						if (ix>=IX) {
							break;
						}
						boolean isAux=false;
						if (!isSaved) {
							aaa[ix]=Attribute.parse(stra[ix]);
						}
						aa=aaa[ix];
						if (aa.length>0 && Tr.equals(aa[0].name,data.p_language)) {
							OL=Tr.getLanguage(aa[0].value);
							Tr.setActiveLanguage(OL);
							ix++;
							if (ix>=IX) {
								break;
							}
							if (!isSaved) {
								aaa[ix]=Attribute.parse(stra[ix]);
							}
							aa=aaa[ix];
						}

						auxConfig ac=null;
						for (int k=0;k<aa.length;k++) {
							if (D.Tr.equals(aa[k].name,data.id)) {
								isAux=true;
								ac=new auxConfig(Tr,aa);
								if (!replv.contains(ac.getEditName())) {
									replv.addElement(ac.getEditName());
								}
								ac.addVariables(aa,replv);
								break;
							}
						}
						if (ac!=null) {
							for (int k=0;k<aa.length;k++) {
								if (D.Tr.equals(aa[k].name,data.id)) {
									ac.macroUpdate(mname,aa,replv);
									TempVaux.addElement(ac);
									break;
								}
							}
						}

						if (!isAux) {
							break;
						}
					}
					while (ix<IX) {
						if (!isSaved) {
							String s=stra[ix];
							s=Tr.getTr(data.space)+"='"+space+"' "+s+" ";
							s+=Tr.getTr(data.location)+"='' ";
							s+=Tr.getTr(data.rotation)+"='' ";
							s+=Tr.getTr(data.cond)+"='' ";
							aaa[ix]=Attribute.parse(s);
						}
						aa=Attribute.copy(aaa[ix]);
						Attribute.setValue(aa,Tr.getTr(data.space),space);
						if (!BasicStr.hasContent(Attribute.getValue(aa,Tr.getTr(data.location)))) {
							Attribute.setValue(aa,Tr.getTr(data.location),location);
						}
						if (!BasicStr.hasContent(Attribute.getValue(aa,Tr.getTr(data.rotation)))) {
							Attribute.setValue(aa,Tr.getTr(data.rotation),rotation);
						}
						if (!BasicStr.hasContent(Attribute.getValue(aa,Tr.getTr(data.cond)))) {
							Attribute.setValue(aa,Tr.getTr(data.cond),cond);
						}
						graphR2Config g2=null;
						graphR3Config g3=null;
						boolean isMacro=false;
						if (isR3) {
							auxConfig.updateValues(Tr,aa,mname,dibujarsi,replv,graphR3Config.noreplix,graphR3Config.colorix);
							g3=new graphR3Config(Tr,aa);
							isMacro=(data.gtR3ix[g3.getTypeIndex(D.Tr)]==data.t_macro);
							if (!isMacro) {
								auxv.addElement(g3);
							}
						} else {
							auxConfig.updateValues(Tr,aa,mname,dibujarsi,replv,graphR2Config.noreplix,graphR2Config.colorix);
							g2=new graphR2Config(Tr,aa,version0);
							isMacro=(data.gtix[g2.getTypeIndex(D.Tr)]==data.t_macro);
							if (!isMacro) {
								g2.absCoor=g2.absCoor||absCoor;
								auxv.addElement(g2);
							}
						}
						if (isMacro) { // OJO: esto es para incorporar los grficos de un sub-macro; habra que hacer esto recursivo.
							String prfx=mname+".";
							if (isR3) {
								Vector v=readMacro(D.Tr,true,g3.getSpace(),prfx+g3.getName(),g3.getCondition(),g3.getExpr(),g3.getLocation(),g3.getRotation(),g3.getCondition(),false);
								if (D.Tr.isTrue(g3.s_value[g3.ixbackground])) {
									for (int j=0;j<v.size();j++) {
										((graphR3Config)v.elementAt(j)).s_value[g3.ixbackground]=g3.s_value[g3.ixbackground];
									}
								}
								g3.setName(prfx+g3.getName());
								for (int j=0;j<v.size();j++) {
									auxv.addElement(v.elementAt(j));
								}
							} else {
								String[] st=BasicStr.getTokens(g2.s_location);
								String s0=null,s1=null;
								if (st.length==2) {
									s0=st[0];
									s1=st[1];
								}
								st=BasicStr.getTokens(g2.s_rotation);
								String sR=null;
								if (st.length==1) {
									sR=st[0];
								}
	//							iniRot=D.p.Analyse(gc.s_rotation);
								Vector v=readMacro(D.Tr,false,g2.getSpace(),prfx+g2.getName(),g2.getCondition(),g2.getExpr(),g2.getLocation(),g2.getRotation(),g2.getCondition(),g2.absCoor);
								for (int j=0;j<v.size();j++) {
									graphR2Config vG=(graphR2Config)v.elementAt(j);
									if (D.Tr.isTrue(g2.s_value[g2.ixbackground])) {
										vG.s_value[g2.ixbackground]=g2.s_value[g2.ixbackground];
										vG.isInBack=D.Tr.isTrue(g2.s_value[g2.ixbackground]);
									}
									if (g2.isFamily) {
										vG.isFamily=g2.isFamily;
										vG.fparam=g2.fparam;
										vG.f_interval=g2.f_interval;
										vG.f_steps=g2.f_steps;
									}
								}
								g2.setName(prfx+g2.getName());
								for (int j=0;j<v.size();j++) {
									graphR2Config gc=(graphR2Config)v.elementAt(j);
									if (s0!=null && s1!=null) {
										st=BasicStr.getTokens(gc.s_location);
										if (st.length==2) {
											gc.s_location="[("+s0+")+("+st[0]+"),("+s1+")+("+st[1]+")]";
										}
									}
									if (sR!=null) {
										st=BasicStr.getTokens(gc.s_rotation);
										if (st.length==1) {
											gc.s_rotation="("+sR+")+("+st[0]+")";
										}
									}
									auxv.addElement(gc);
								}
							}
						}
						ix++;
						if (ix>=IX) {
							break;
						}
					}
					// Por si es un macro, se agregan DESPUS de haber ledo los del macro
					for (int j=0;j<TempVaux.size();j++) { 
						auxConfig ac=(auxConfig) TempVaux.elementAt(j);
						vaux.addElement(ac);
					}
				}
			}
			Tr.setActiveLanguage(AL);
			if (!isSaved) {
				macrosAAA.put(filename,aaa);
			}
		} catch (Exception eee) {
			eee.printStackTrace();
		}
		return auxv;
	}

}