/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

/*------------------------------------------------------------*/
/*                       controlConfig                        */
/*                         (c)  MJA                           */
/*                       Marzo de 2001                        */
/*------------------------------------------------------------*/
import java.util.*;
import java.awt.*;
import java.awt.event.*;

import com.mja.util.*;
import com.mja.gui.*;
import com.mja.lang.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import com.mja.parser.*;
import com.mja.math.*;
import com.mja.text.*;
import com.mja.file.*;
import com.mja.krypto.*;

import com.mja.descgui.edit.editObject;
import org.unam.matem.Attribute;

public class controlConfig extends editObject {
	
	public static String bcol="blue", icol="red"; // for Descartes
//	public static String bcol="406080", icol="cc0022"; // for Arquimedes

	public static String bgcol="f0f8ff", fgcol="222222"; 

	public int type;
	public translator Tr;
	public String label="", explanation="", tooltip="", parameter="";

	protected static final int[] regions={data.south,data.north,data.east,data.west,data.external,data.interior,data.scenario};

	private static final int[] guis={data.spinner,data.textfield,data.choice,data.scrollbar,data.button};

	private static final int[] fonts={data.Monospaced,data.SansSerif,data.Serif};

	public int region=data.south;

	public int msgloc=0;
	
	private boolean onlyText=false;

	private static int ix=0;
	public static final int 
		ixid=ix++,
		ixtype=ix++,
		ixgui=ix++,
		ixonlytext=ix++,
		ixregion=ix++,
		ixspace=ix++,
		ixcolor=ix++,
		ixicolor=ix++,
		ixsize=ix++,
		ixname=ix++,
		ixexpr=ix++,
		ixvalue=ix++,
		ixconstraint=ix++,
		ixtext=ix++,
		ixbuttons=ix++,
		ixsolution=ix++,
		ixincr=ix++,
		ixinf=ix++,
		ixsup=ix++,
		ixdiscrete=ix++,
		ixdecimals=ix++,
		ixfixed=ix++,
		ixnotexp=ix++,
		ixvisible=ix++,
		ixtrace=ix++,
/* deben quedar en este orden */
		ixfgcol=ix++,
		ixbgcol=ix++,
		ixbold=ix++,
		ixitalic=ix++,
		ixunderline=ix++,
//		ixfont=ix++,
		ixfontsize=ix++,
		ixdrawbg=ix++,
		iximage=ix++,
		ixoptions=ix++,
/* -------------------------- */
		ixaction=ix++,
		ixparam=ix++,
		ixcondvis=ix++,
		ixcondactiv=ix++,
		ixeval=ix++,
		ixanswer=ix++,
		ixweight=ix++,
		ixtooltip=ix++,
		ixexpl=ix++,
		ixmsgloc=ix++,
		ixfile=ix++,
		ixcontrolID=ix++,
		numFields=ix++;

	public Font tooltip_font,expl_font,param_font;

	public static final editField[] controlfield=new editField[numFields];
	
	public void defineFields() {
		int n=0;
		controlfield[n++]=new editField(data.id        ,""       ,""       ,editObject.string      ,10);
		controlfield[n++]=new editField(data.type      ,""       ,""       ,editObject.string      , 8,-1,true,-1,-1,-1,data.empty,null);
		controlfield[n++]=new editField(data.gui       ,"spinner","spinner",editObject.choice      , 1,-1,true,-1,-1,-1,data.empty,guis);
		controlfield[n++]=new editField(data.onlytext  ,"no"     ,"no"     ,editObject.select      , 1);
		controlfield[n++]=new editField(data.region    ,"south"  ,"south"  ,editObject.choice      , 1,-1,true,-1,-1,-1,data.empty,regions);
		controlfield[n++]=new editField(data.space     ,""       ,""       ,editObject.choice      , 1,-1,true,-1,-1,-1,data.space,null);
		controlfield[n++]=new editField(data.color     ,bcol     ,bcol     ,editObject.color_button, 1);
		controlfield[n++]=new editField(data.icolor    ,icol     ,icol     ,editObject.color_button, 1);
		controlfield[n++]=new editField(data.size      ,"4"      ,"4"      ,editObject.string      , 7);
		controlfield[n++]=new editField(data.name      ,""       ,""       ,editObject.string      ,15);
		controlfield[n++]=new editField(data.expr      ,"(0,0)"  ,"(0,0)"  ,editObject.string      ,34,-1,true,-1,-1,-1,data.initialPos,null);
		controlfield[n++]=new editField(data.value     ,"0"      ,"0"      ,editObject.string      ,10);
		controlfield[n++]=new editField(data.constraint,""       ,""       ,editObject.string      ,55);
		controlfield[n++]=new editField(data.t_text    ,""        ,""      ,editObject.text        ,35,-1,true ,-1,data.font,-1,data.t_text ,null,false,ixcolor);
		controlfield[n++]=new editField(data.p_buttons   ,"no"     ,"no"   ,editObject.select      , 1);
		controlfield[n]=new editField(data.answer    ,""        ,""      ,editObject.text        ,35,-1,true ,-1,data.font,-1,data.answer ,null,false,ixcolor);
		controlfield[n++].encoded=true;
		controlfield[n++]=new editField(data.incr      ,"0.1"    ,"0.1"    ,editObject.string      , 7);
		controlfield[n++]=new editField(data.inf       ,""       ,""       ,editObject.string      , 7);
		controlfield[n++]=new editField(data.sup       ,""       ,""       ,editObject.string      , 7);
		controlfield[n++]=new editField(data.discrete  ,"no"     ,"no"     ,editObject.select      , 1);
		controlfield[n++]=new editField(data.decimals  ,"2"      ,"2"      ,editObject.string      ,10);
		controlfield[n++]=new editField(data.fixed     ,"si"     ,"si"     ,editObject.select      , 1);
		controlfield[n++]=new editField(data.notexp    ,""       ,""       ,editObject.string      ,22);
		controlfield[n++]=new editField(data.visible   ,"yes"    ,"yes"    ,editObject.select      , 1);
		controlfield[n++]=new editField(data.trace     ,"gray"   ,"no"     ,editObject.color_select, 1);
		controlfield[n++]=new editField(data.color     ,fgcol    ,fgcol    ,editObject.color_button, 1,-1 ,true ,-1       ,-1     ,-1,-1           ,null);
		controlfield[n++]=new editField(data.icolor    ,bgcol    ,bgcol    ,editObject.color_button, 1,-1 ,true ,-1       ,-1     ,-1,-1           ,null);
		controlfield[n++]=new editField(data.bold	   ,"no"     ,"no"     ,editObject.select		,1);
		controlfield[n++]=new editField(data.italics   ,"no"     ,"no"     ,editObject.select		,1);
		controlfield[n++]=new editField(data.underlined,"no"     ,"no"     ,editObject.select		,1);
//		controlfield[n++]=new editField(data.font	 ,"SansSerif","SansSerif",editObject.choice  	,1,-1 ,true ,-1       ,-1     ,-1,-1           ,fonts);
		controlfield[n++]=new editField(data.fontsz    ,"12"     ,"12"     ,editObject.string	    ,2); //,-1 ,true ,-1       ,-1     ,-1,-1           ,null);
		controlfield[n++]=new editField(data.background,"no"     ,"no"     ,editObject.select       ,1);
		controlfield[n++]=new editField(data.image     ,""       ,""       ,editObject.string      ,57);
		controlfield[n++]=new editField(data.options   ,""       ,""       ,editObject.string      ,56);
		controlfield[n++]=new editField(data.action    ,""       ,""       ,editObject.choice      , 1,-1,true,-1,-1,-1,data.action,Action.actions);
		controlfield[n++]=new editField(data.parameter ,""       ,""       ,editObject.text        ,40,-1,true,-1,data.font,data.parameter,data.parameter ,null);//ixparam
		controlfield[n++]=new editField(data.cond      ,""       ,""       ,editObject.string      ,19);
		controlfield[n++]=new editField(data.condActiv ,""       ,""       ,editObject.string      ,19);
		controlfield[n++]=new editField(data.evaluation,"no"	 ,"no"		,editObject.select      , 1);
		controlfield[n]=new editField(data.answer		,""       ,""       ,editObject.string      ,42);
		controlfield[n++].encoded=true;
		controlfield[n++]=new editField(data.weight    ,"1"		 ,"1" 	   ,editObject.string      , 1);
		controlfield[n++]=new editField(data.tooltip   ,""       ,""       ,editObject.text        ,18,-1,true ,-1,data.font,data.tooltip,data.tooltip,null);//ixtooltip
		controlfield[n++]=new editField(data.expl      ,""       ,""       ,editObject.text        ,18,-1,true ,-1,data.font,data.expl,data.expl,null); //ixexpl
		controlfield[n++]=new editField(data.msgloc    ,"center" ,"center" ,editObject.choice      , 1,-1,true,-1,-1,-1,data.msgloc,data.msglocs);
		controlfield[n++]=new editField(data.file      ,""      ,""        ,editObject.string      ,30);
		controlfield[n++]=new editField(data.cID	   ,""		 ,""	   ,editObject.string		,12);
	}

	private static editObjectType[] controlEOT;

/* -------------------------- extends editObject --------------------- */

	public void updateInfo(translator Tr) {
		type=Tr.getIndex(data.ctrlix,s_value[ixtype],data.c_numeric);
		tooltip=BasicStr.replace(s_value[ixtooltip],"\\n","\n");
		tooltip_font=BasicStr.parseGeneralFont(h_value[ixtooltip],mjaFont.AWTMono);
		explanation=BasicStr.replace(s_value[ixexpl],"\\n","\n");
		expl_font=BasicStr.parseGeneralFont(h_value[ixexpl],mjaFont.AWTMono);
		parameter=BasicStr.replace(s_value[ixparam],"\\n","\n");
		param_font=BasicStr.parseFont(h_value[ixparam],mjaFont.AWTMono);
		/* -- Correccin hecha el 28 de Enero de 2004
			para que los controles nuevos del origen funcionen -- */
		if ("O.x".equals(s_value[ixid])) {
			if (!BasicStr.hasContent(s_value[ixname])) {
				s_value[ixname]=s_value[ixid];
			}
			s_value[ixid]="Ox";
		} else if ("O.y".equals(s_value[ixid])) {
			if (!BasicStr.hasContent(s_value[ixname])) {
				s_value[ixname]=s_value[ixid];
			}
			s_value[ixid]="Oy";
		} else if (s_value[ixid].endsWith(".O.x")) {
			if (!BasicStr.hasContent(s_value[ixname])) {
				s_value[ixname]=s_value[ixid];
			}
			s_value[ixid]=s_value[ixid].substring(0,s_value[ixid].length()-3)+"Ox";
		} else if (s_value[ixid].endsWith(".O.y")) {
			if (!BasicStr.hasContent(s_value[ixname])) {
				s_value[ixname]=s_value[ixid];
			}
			s_value[ixid]=s_value[ixid].substring(0,s_value[ixid].length()-3)+"Oy";
		}
		/* ----------------------------------------------- */
		s_value[ixgui]=s_value[ixgui].trim();
		if (type==data.c_numeric) {
			label=s_value[ixname];
			if (Tr.equals(s_value[ixgui],data.spinner)||Tr.equals(s_value[ixgui],data.scrollbar)) {
				if (Tr.equals(s_value[ixgui],data.spinner)) {
					if (!BasicStr.hasContent(s_value[ixname]) ) {
						s_value[ixname]=s_value[ixid];
					}
				}
				if (Tr.equals(s_value[ixgui],data.scrollbar)) {
					if (!BasicStr.hasContent(s_value[ixinf]) && !BasicStr.hasContent(s_value[ixsup])) {
						s_value[ixinf]="0";
						s_value[ixsup]="100";
					}
				}
			} else {
				if (!Tr.equals(s_value[ixgui],data.textfield)) {
					s_value[ixincr]="";
					s_value[ixinf]="";
					s_value[ixsup]="";
				}
			}
		} else if (type==data.c_graphic) {
			label=s_value[ixid];
			ccolor=Tr.parseColor(s_value[ixcolor],ccolor,ccolor);
			icolor=Tr.parseColor(s_value[ixicolor],icolor,icolor);
			font=BasicStr.parseFont(h_value[ixtext],mjaFont.AWTMono);
			mjaColor auxc=Tr.parseColor(s_value[ixtrace],tcolor,null);
			hasTrace=(auxc!=null);
			if (hasTrace) {
				tcolor=auxc;
			}
		} else if (type==data.c_audio) {
			fileName=s_value[ixfile];
			mediaType="audio";
		} else if (type==data.c_video) {
			fileName=s_value[ixfile];
			mediaType="video";
		} else if (type==data.c_string) {
			ccolor=Tr.parseColor(s_value[ixcolor],ccolor,ccolor);
			icolor=Tr.parseColor(s_value[ixicolor],icolor,icolor);
			font=BasicStr.parseFont(h_value[ixtext],mjaFont.AWTMono);
		}
		setId(getName()+" ("+Tr.getTr(type)+")");
		if (type==data.c_numeric) {
			region=Tr.getIndex(regions,s_value[ixregion],region);
		}
		msgloc=Tr.parseLocation(s_value[ixmsgloc]);
	}

	public void setEditName(String nom) {
		setName(nom);
	}

	public String getEditName() {
		return getName();
	}

	public String controlID() {
		return s_value[ixcontrolID];
	}
	
	public boolean isEval() {
		return Tr.isTrue(s_value[ixeval]);
	}
	
	public String getAnswerPattern() {
		return s_value[ixanswer];
	}

	public void setControlID(String str) {
		s_value[ixcontrolID]=str;
	}

	private static final String[] defaultExpresion = {
		"n?","g?","t?","a?","v?"
	};

	public int getNumTypes() {
		return defaultExpresion.length;
	}
	public String getType(translator Tr,int i) {
		return Tr.getTr(data.ctrlix[i]);
	}
	public String getDefaultExpresion(translator Tr,int i) {
		return defaultExpresion[i];
	}
	public String getListTitle(translator Tr) {
		return Tr.getTr(data.p_controls);
	}
	public String getTypesInfo(translator Tr) {
		return Tr.getTr(data.control);
	}

	public int getTypeIndex(translator Tr) {
		for (int i=0;i<data.ctrlix.length;i++) {
			if (type==data.ctrlix[i]) {
				return i;
			}
		}
		return 0;
	}

/* ------------------------------------------------------------------- */

	private void fixFields() {
		controlfield[ixtype].isFixed=true;
		controlfield[ixcontrolID].isFixed=true;
	}

	public controlConfig(translator Tr,int type,String svalue) {
		this(Tr,Tr.getTr(type),svalue);
	}

	public controlConfig(translator Tr,String stype,String svalue) {
		this(Tr,Tr.getTr(data.type)+"="+stype+" "+Tr.getTr(data.id)+"="+svalue);
	}
	
	public controlConfig cloneControlConfig() {
		return new controlConfig(Tr,toString(" ",Tr));
	}

	public controlConfig(translator Tr,String values) {
		defineFields();
		fixFields();
		expl=Expl.Control;
		this.Tr=Tr;
		if (controlEOT==null) {
			createControlEOT();
		}
		Attribute[] aa=Attribute.parse(values);
		type=Tr.getIndex(data.ctrlix,Tr.getValue(aa,data.type),data.c_numeric);
		String[] nullv=new String[numFields];
		for (int i=0;i<nullv.length;i++) {
			nullv[i]=controlfield[i].null_val;
		}
		nullv[ixgui]=Tr.getTr(data.spinner);
		nullv[ixregion]=Tr.getTr(data.south);
		if (type==data.c_numeric) {
			String s_id=Attribute.getValue(aa,"id");
			if (Tr.equals(s_id,data.p_scale)) {
				nullv[ixid]="E00.escala";
				nullv[ixname]=Tr.getTr(data.zoom);
				nullv[ixregion]=Tr.getTr(data.north);
				nullv[ixvalue]="48";
				nullv[ixdecimals]="(escala<0.01)+(escala<0.1)+(escala<1)+(escala<10)+(escala<100)+(escala<1000)+(escala<10000)+(escala<100000)";
				nullv[ixincr]="0.1*escala";
				nullv[ixinf]="0.000001";
				nullv[ixsup]="1000000";
				nullv[ixvisible]="no";
			}
			if (s_id.equalsIgnoreCase("Ox")||s_id.equalsIgnoreCase("O.x")||Tr.equals(s_id,data.p_Ox)) {
				nullv[ixid]="E00.Ox";
				nullv[ixname]="O.x";
				nullv[ixregion]=Tr.getTr(data.north);
				nullv[ixvalue]="0";
				nullv[ixdecimals]="0";
				nullv[ixincr]="100";
				nullv[ixvisible]="no";
			}
			if (s_id.equalsIgnoreCase("Oy")||s_id.equalsIgnoreCase("O.y")||Tr.equals(s_id,data.p_Oy)) {
				nullv[ixid]="E00.Oy";
				nullv[ixname]="O.y";
				nullv[ixregion]=Tr.getTr(data.north);
				nullv[ixvalue]="0";
				nullv[ixdecimals]="0";
				nullv[ixincr]="100";
				nullv[ixvisible]="no";
			}
		}
		initialize(Tr,controlfield,controlEOT,Attribute.parse(values),nullv);
	}

	private static void createControlEOT() {
		BitSet numattr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			numattr.clear(i);
		}
		numattr.set(ixid);
		numattr.clear(ixtype);
		numattr.set(ixgui);
		numattr.set(ixonlytext);
		numattr.set(ixregion);
		numattr.set(ixspace);
		numattr.set(ixvalue);
		numattr.set(ixexpr);
		numattr.set(ixname);
		numattr.set(ixdecimals);
		numattr.set(ixfixed);
		numattr.set(ixincr);
		numattr.set(ixinf);
		numattr.set(ixsup);
		numattr.set(ixdiscrete);
		numattr.set(ixnotexp);
		numattr.set(ixvisible);
		numattr.set(ixcondvis);
		numattr.set(ixcondactiv);
		numattr.set(ixfgcol);
		numattr.set(ixbgcol);
		numattr.set(ixbold);
		numattr.set(ixitalic);
		numattr.set(ixunderline);
		numattr.set(ixfontsize);
//		numattr.set(ixfont);
		numattr.set(ixdrawbg);
		numattr.set(iximage);
//		numattr.set(ixexpl);
//		numattr.set(ixtooltip);
		numattr.set(ixoptions);
		numattr.set(ixaction);
		numattr.set(ixeval);
		numattr.set(ixanswer);
		numattr.set(ixweight);
		numattr.set(ixparam);
		numattr.set(ixmsgloc);
		numattr.set(ixcontrolID);

		BitSet graphattr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			graphattr.clear(i);
		}
		graphattr.set(ixid);
		graphattr.clear(ixtype);
		graphattr.set(ixspace);
		graphattr.set(ixexpr);
		graphattr.set(ixcolor);
		graphattr.set(ixicolor);
		graphattr.set(ixsize);
		graphattr.set(ixconstraint);
		graphattr.set(ixtext);
		graphattr.set(ixdecimals);
		graphattr.set(ixfixed);
		graphattr.set(ixtrace);
		graphattr.set(ixcondvis);
		graphattr.set(ixcondactiv);
		graphattr.set(iximage);
//		graphattr.set(ixexpl);
//		graphattr.set(ixtooltip);

		BitSet textattr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			textattr.clear(i);
		}
		textattr.set(ixid);
		textattr.clear(ixtype);
		textattr.set(ixspace);
		textattr.set(ixexpr);
		textattr.set(ixtext);
		textattr.set(ixbuttons);
		textattr.set(ixsolution);
		textattr.set(ixcondvis);
		textattr.set(ixcondactiv);
//		textattr.set(ixexpl);
//		textattr.set(ixtooltip);

		BitSet mediaattr=new BitSet(numFields);
		for (int i=0;i<numFields;i++) {
			mediaattr.clear(i);
		}
		mediaattr.set(ixid);
		mediaattr.set(ixtype);
		mediaattr.set(ixregion);
		mediaattr.set(ixspace);
		mediaattr.set(ixexpr);
		mediaattr.set(ixfile);
		mediaattr.set(ixcondvis);

		controlEOT=new editObjectType[5];
		controlEOT[0]=new editObjectType("",numattr);
		controlEOT[1]=new editObjectType("",graphattr);
		controlEOT[2]=new editObjectType("",textattr);
		controlEOT[3]=new editObjectType("",mediaattr);
		controlEOT[4]=new editObjectType("",mediaattr);
	}

	private void setName(String nom) {
		s_value[ixid]=nom;
	}

	public String getName() {
		return s_value[ixid];
	}

	static controlConfig[] defaultControls(translator Tr) {
		controlConfig[] ctrlc=new controlConfig[3];
		ctrlc[0]=new controlConfig(Tr,data.c_numeric,Tr.getTr(data.p_scale));
		ctrlc[1]=new controlConfig(Tr,data.c_numeric,Tr.getTr(data.p_Ox));
		ctrlc[2]=new controlConfig(Tr,data.c_numeric,Tr.getTr(data.p_Oy));
		return ctrlc;
	}

	/* ------------------------ numeric control ------------------------ */

	public NumericControl makeNumericControl(Descartes D) {
		String xExpr="0";
		String yExpr="0";
		String wExpr="100";
		String hExpr="23";
		int w=100,h=23;
//		int w=100,h=BasicStr.lineVSize();
//		String hExpr=String.valueOf(h);
		try {
			String[] sa=BasicStr.getTokens(s_value[ixexpr]);
			if (sa.length>=2) { // hacerlo tambin con porcentajes?
				xExpr=sa[0];
				yExpr=sa[1];
			}
			if (sa.length>=4) {
				wExpr=sa[2];
				hExpr=sa[3];
			}
		} catch(Exception e ) {
		}
// La responsabilidad de distinguir la coma decimal 
// de la coma entre variables de una funcin
// se transfiere al Parser:  15 de mayo de 2008. ver 3.920 beta 4
//		xExpr=BasicStr.replace(xExpr,",",".");
//		yExpr=BasicStr.replace(yExpr,",",".");
//		wExpr=BasicStr.replace(wExpr,",",".");
//		hExpr=BasicStr.replace(hExpr,",",".");
//		s_value[ixvalue]=BasicStr.replace(s_value[ixvalue],",",".");
		Node xN=D.p.Analyse(xExpr,0);
		Node yN=D.p.Analyse(yExpr,0);
		Node wN=D.p.Analyse(wExpr,w);
		Node hN=D.p.Analyse(hExpr,h);
		w=(int) Math.round(wN.Evaluate(w));
		h=(int) Math.round(hN.Evaluate(h));
		NumericControl nc = null;
		if (Tr.equals(s_value[ixgui],data.button)) {
			nc = new ButtonControl(
				D,
				this,
				s_value[ixname],
				s_value[ixid],
				s_value[ixvalue],
				s_value[ixinf],
				s_value[ixsup],
				s_value[ixcondvis],
				s_value[ixcondactiv],
				s_value[ixfgcol],
				s_value[ixbgcol],
				s_value[ixbold],
				s_value[ixitalic],
				s_value[ixunderline],
				s_value[ixfontsize],
//				s_value[ixfont],
				s_value[iximage],
				s_value[ixdrawbg]
				);
		} else if (Tr.equals(s_value[ixgui],data.scrollbar)) {
				nc = new ScrollBarControl(
				D,
				this,
				s_value[ixname],
				s_value[ixid],
				s_value[ixdecimals],
				D.Tr.isNotFalse(s_value[ixfixed]),
				s_value[ixvalue],
				s_value[ixincr],
				s_value[ixinf],
				s_value[ixsup],
				D.Tr.isNotFalse(s_value[ixvisible]),
				s_value[ixnotexp],
				Tr.equals(s_value[ixregion],data.interior)&&(w<=h),
				s_value[ixcondvis],
				s_value[ixcondactiv]
				);
		} else if (Tr.equals(s_value[ixgui],data.choice)) {
			nc = new ChoiceControl(
				D,
				this,
				s_value[ixname],
				s_value[ixid],
				s_value[ixdecimals],
				D.Tr.isNotFalse(s_value[ixfixed]),
				s_value[ixvalue],
				D.Tr.isNotFalse(s_value[ixvisible]),
				s_value[ixnotexp],
				s_value[ixoptions],
				s_value[ixcondvis],
				s_value[ixcondactiv]
				);
		} else if (Tr.equals(s_value[ixgui],data.textfield)) {
			String s_v=s_value[ixvalue];
			if (D.Tr.isTrue(s_value[ixonlytext])) {
				onlyText=true;
			} else {
				if ("|_TexT_|".equals(s_value[ixvalue])||"'_TexT_'".equals(s_value[ixvalue])) {
					onlyText=true;
					s_value[ixvalue]="";
					s_v="";
				} else if ((s_value[ixvalue].trim().startsWith("'") && s_value[ixvalue].trim().endsWith("'")) ||
							(s_value[ixvalue].trim().startsWith("|") && s_value[ixvalue].trim().endsWith("|"))) {
					if (s_value[ixvalue].trim().length()>2) {
						onlyText=true;
					}
				}
				if (onlyText) {
					s_value[ixonlytext]=D.Tr.getTr(data.Yes);
				}
			}
			nc = new textControl(
				D,
				this,
				s_value[ixname],
				s_value[ixid],
				s_value[ixdecimals],
				D.Tr.isNotFalse(s_value[ixfixed]),
				s_v,
				s_value[ixincr],
				s_value[ixinf],
				s_value[ixsup],
				D.Tr.isNotFalse(s_value[ixvisible]),
				s_value[ixnotexp],
				s_value[ixcondvis],
				s_value[ixcondactiv]
				);
			((textControl) nc).setOnlyText(onlyText);
		} else {
			nc = new Spinner(
				D,
				this,
				s_value[ixname],
				s_value[ixid],
				s_value[ixdecimals],
				D.Tr.isNotFalse(s_value[ixfixed]),
				s_value[ixvalue],
				s_value[ixincr],
				s_value[ixinf],
				s_value[ixsup],
				D.Tr.isNotFalse(s_value[ixvisible]),
				s_value[ixnotexp],
				s_value[ixcondvis],
				s_value[ixcondactiv]
				);
		}
		nc.setTypeName(s_value[ixgui]);
		nc.setAction(s_value[ixaction],parameter,param_font,msgloc);
		nc.setInterior(Tr.equals(s_value[ixregion],data.interior));
		nc.setInScenario(Tr.equals(s_value[ixregion],data.scenario));
		nc.setSpace(s_value[ixspace]);
		nc.setTooltip(tooltip,Tr.getTr(data.rightClick),tooltip_font);
		nc.setExplanation(explanation,expl_font);
		nc.setDiscrete(Tr.isTrue(s_value[ixdiscrete]));
		nc.setControlID(s_value[ixcontrolID]);
		if (nc.isInterior() || nc.inScenario()) {
			nc.setNodeBounds(xN,yN,wN,hN);
//			nc.locate();	Eliminado el 13 de mayo de 2009
			// La siguiente lnea se agreg el 29 de abril de 2008 para la versin 3.915
			int ww=(int) (wN.Evaluate(23));
			int hh=(int) (hN.Evaluate(23));
			if ((Tr.equals(s_value[ixgui],data.scrollbar))&&(ww<hh)) {
				nc.setFont(23);
			} else {
				nc.setFont(hh);
			}
		}
		if (D.disableControls) {
			nc.setEnabled(false);
		}
		this.nc=nc;
		return nc;
	}
	
	private NumericControl nc;

	public void setRegion(int region) {
		this.region=region;
		s_value[ixregion]=Tr.getTr(region);
	}

	/* ------------------------ graphic control ------------------------ */

	public R2 cpos;
	public int size_x,size_y;
	public Font font=mjaFont.Monospaced;
	public mjaColor ccolor=new mjaColor(Color.blue),icolor=new mjaColor(Color.red),tcolor=new mjaColor(Color.gray);
	public boolean hasTrace;
	public static final String _x=".x",_y=".y";
	public Node xN, yN, wN, hN, condVis, condActiv;

	private Descartes D;
	private Space cs;
	private MathText mthtxt;
	private Node constraint, decimals, funcOfX, funcOfY;
	private R2Newton newt;
	private Image image, over, down;
	private String fileName="";
	private String mediaType="";
	
	public String getFileName() {
		return fileName;
	}

	public String getMediaType() {
		return mediaType;
	}

	boolean hasImage () {
		return image!=null;
	}

	void setSpace(Space cs) {
		this.cs=cs;
	}

	void initializeGraphicControl(Descartes D) {
		this.D=D;
		ccolor.analyse(D.p);
		icolor.analyse(D.p);
		tcolor.analyse(D.p);
		decimals=D.p.Analyse(s_value[ixdecimals],2);
		mthtxt=new MathText(D.p,D.Tr,s_value[ixtext],decimals,D.Tr.isNotFalse(s_value[ixfixed]),font,ccolor.getAdaptedColor());
		int size=BasicStr.parseInteger(s_value[ixsize],2,2);
		size_x=size;
		size_y=size;
		if (BasicStr.hasContent(s_value[ixconstraint])) {
			constraint=D.p.Analyse(s_value[ixconstraint]);
			if (constraint.getSymbol().equals("=")
				||constraint.getSymbol().equals("<")
				||constraint.getSymbol().equals("<=")
				||constraint.getSymbol().equals(">=")
				||constraint.getSymbol().equals(">")
				) {
				Node left=(Node) constraint.getLeft();
				Node right=(Node) constraint.getRight()[0];
				if (left.getSymbol().equals("y")&&!right.contains("y")) {
					funcOfX=right;
				} else if (left.getSymbol().equals("x")&&!right.contains("x")) {
					funcOfY=right;
				}
				try {
					newt=new R2Newton(D.p,constraint);
				} catch (Exception e) {
					e.printStackTrace();
				}
			} else {
				constraint=null;
			}
		}
		image=mjaFile.loadImage(D.imagesHT,D,s_value[iximage]);
		if (image!=null) {
			String s=s_value[iximage];
			int n=s.lastIndexOf(".");
			if (n>0) {
				String s_ext=s.substring(n);
				String s_name=s.substring(0,n);
				String s_file_over=s_name+"_over"+s_ext;
				String s_file_down=s_name+"_down"+s_ext;
				over=mjaFile.loadImage(D.imagesHT,D,s_file_over);
				down=mjaFile.loadImage(D.imagesHT,D,s_file_down);
			}
			size_x=image.getWidth(D)/2;
			size_y=image.getHeight(D)/2;
		}
		condVis=D.p.Analyse(s_value[ixcondvis],"1");
		condActiv=D.p.Analyse(s_value[ixcondactiv],"1");
		cpos=new R2(0,0);
		try {
			String[] sa=BasicStr.getTokens(s_value[ixexpr]);
			if (sa.length>=2) {
				Node xN=D.p.Analyse(sa[0]);
				Node yN=D.p.Analyse(sa[1]);
				cpos=new R2(xN.Evaluate(0),yN.Evaluate(0));
			} else {
				System.out.println("wrong expression: "+s_value[ixexpr]);
			}
		} catch (Exception exc) {
			System.out.println(exc);
		}
		D.p.Var(s_value[ixid]+_x).setDouble(cpos.x);
		D.p.Var(s_value[ixid]+_y).setDouble(cpos.y);
	}
	
	public int getTextX() {
		return (int) Math.round(xN.Evaluate(0));
	}
	public int getTextY() {
		return (int) Math.round(yN.Evaluate(0));
	}
	public int getTextW() {
		return (int) Math.round(wN.Evaluate(300));
	}
	public int getTextH() {
		return (int) Math.round(hN.Evaluate(200));
	}

	void initializeMediaControl(Descartes D) {
		this.D=D;
		String xExpr="0";
		String yExpr="0";
		String wExpr="300";
		String hExpr="200";
		try {
			String[] sa=BasicStr.getTokens(s_value[ixexpr]);
			if (sa.length>=2) { // hacerlo tambin con porcentajes?
				xExpr=sa[0];
				yExpr=sa[1];
			}
			if (sa.length>=4) {
				wExpr=sa[2];
				hExpr=sa[3];
			}
		} catch(Exception e ) {
		}
		xN=D.p.Analyse(xExpr,0);
		yN=D.p.Analyse(yExpr,0);
		wN=D.p.Analyse(wExpr,300);
		hN=D.p.Analyse(hExpr,200);
		condVis=D.p.Analyse(s_value[ixcondvis],"1");
//		condActiv=D.p.Analyse(s_value[ixcondactiv],"1");
	}

	void initializeTextControl(Descartes D) {
		this.D=D;
		decimals=D.p.Analyse(s_value[ixdecimals],2);
		mthtxt=new MathText(D.p,D.Tr,s_value[ixtext],decimals,D.Tr.isNotFalse(s_value[ixfixed]),font,ccolor.getAdaptedColor());
		String xExpr="0";
		String yExpr="0";
		String wExpr="300";
		String hExpr="200";
		try {
			String[] sa=BasicStr.getTokens(s_value[ixexpr]);
			if (sa.length>=2) { // hacerlo tambin con porcentajes?
				xExpr=sa[0];
				yExpr=sa[1];
			}
			if (sa.length>=4) {
				wExpr=sa[2];
				hExpr=sa[3];
			}
		} catch(Exception e ) {
		}
		xN=D.p.Analyse(xExpr,0);
		yN=D.p.Analyse(yExpr,0);
		wN=D.p.Analyse(wExpr,300);
		hN=D.p.Analyse(hExpr,200);
		condVis=D.p.Analyse(s_value[ixcondvis],"1");
		condActiv=D.p.Analyse(s_value[ixcondactiv],"1");
	}


	void setControlPos(double x,double y) {
		cpos=cs.injection(x,y);
		if (constraint!=null) {
			try {
//				cpos=R2.Newton(D.p,constraint,cpos);
				cpos=newt.findZero(cpos,1/cs.Nesc.getDouble());
			} catch (Exception e) {
			}
		}
		D.p.Var(s_value[ixid]+_x).setDouble(cpos.x);
		D.p.Var(s_value[ixid]+_y).setDouble(cpos.y);
		D.updateTextFieldsFromNodes();
		if (D.LMS_inUse()) {
			String[][] stra=new String[2][2];
			stra[0][0]=s_value[ixid]+_x; stra[0][1]=Double.toString(D.p.Var(s_value[ixid]+_x).getDouble());
			stra[1][0]=s_value[ixid]+_y; stra[1][1]=Double.toString(D.p.Var(s_value[ixid]+_y).getDouble());
			D.informLMS("ctrl_G",getName(),"",stra);
		}
	}

	R2 getControlPos() {
		return cs.projection(cpos);
	}

	boolean isSelected;

	void adjust() {
		double xa=cpos.x;
		double ya=cpos.y;
		cpos.x=D.p.rvalue(s_value[ixid]+_x);
		cpos.y=D.p.rvalue(s_value[ixid]+_y);
		Node X=D.p.Var("x");
		Node Y=D.p.Var("y");
		synchronized (X) {
			synchronized (Y) {
				double savex=X.getDouble();
				double savey=Y.getDouble();
				X.setDouble(cpos.x);
				Y.setDouble(cpos.y);
				if (constraint!=null) {
					try {
						if (funcOfX!=null&&cpos.x!=xa) {
							cpos.y=funcOfX.Evaluate();
						} else if (funcOfY!=null&&cpos.y!=ya) {
							cpos.x=funcOfY.Evaluate();
						} else {
							cpos=newt.findZero(cpos,1/cs.Nesc.getDouble());
//							cpos=R2.Newton(D.p,constraint,cpos);
						}
					} catch (Exception e) {
							cpos.x=xa; cpos.y=xa;
//							e.printStackTrace();
					}
				}
				X.setDouble(savex);
				Y.setDouble(savey);
			}
		}
		D.p.Var(s_value[ixid]+_x).setDouble(cpos.x);
		D.p.Var(s_value[ixid]+_y).setDouble(cpos.y);
	}
	
	boolean isOver,isPressed;
	
	public boolean isVisible() {
		return (condVis.Evaluate(1)>0);
	}

	public boolean isActive() {
		return (condActiv.Evaluate(1)>0);
	}

	void drawControl(boolean trace,Graphics[] g)	{
		Node X=D.p.Var("x");
		Node Y=D.p.Var("y");
		synchronized (X){
			synchronized (Y) {
				double savex=X.getDouble();
				double savey=Y.getDouble();
				X.setDouble(cpos.x);
				Y.setDouble(cpos.y);
				if (isVisible()) {
					R2 q=cs.projection(cpos);
					for (int i=0;i<g.length;i++) {
						if (trace) {
							g[i].setColor(tcolor.getAdaptedColor());
							g[i].drawOval(q.ix()-size_x,q.iy()-size_y,2*size_x,2*size_y);
						} else {
							if (image!=null) {
								if (isPressed&&(down!=null)) {
									g[i].drawImage(down,q.ix()-size_x,q.iy()-size_y,D);
								} else if (isOver&&(over!=null)) {
									g[i].drawImage(over,q.ix()-size_x,q.iy()-size_y,D);
								} else {
									g[i].drawImage(image,q.ix()-size_x,q.iy()-size_y,D);
								}
							} else {
								g[i].setColor(icolor.getAdaptedColor());
								mjaGraph.circle(g[i],q.ix(),q.iy(),size_x);
								if (isSelected) {
									g[i].setColor(mjaColor.bestContrast(icolor.getAdaptedColor()));
									g[i].drawOval(q.ix()-size_x+2,q.iy()-size_y+2,2*size_x-4,2*size_y-4);
								}
								g[i].setColor(ccolor.getAdaptedColor());
								g[i].drawOval(q.ix()-size_x,q.iy()-size_y,2*size_x,2*size_y);
							}
						}
					}
					if (!trace) {
						int fa=new TFont(font).getAscent();
						R2 qq=new R2(q.ix()+size_x,q.iy()-size_y-fa);
						mthtxt.draw(cs,qq.ix(),qq.iy(),g);
					}
				}
				X.setDouble(savex);
				Y.setDouble(savey);
			}
		}
	}

	public String toString(String sep,translator Tr) {
		if ((region==data.scenario) && (nc!=null)) {
			Point p=nc.getLocation();
			Dimension d=nc.getSize();
			s_value[ixexpr]="("+p.x+","+p.y+","+d.width+","+d.height+")";
		}
		return super.toString(sep,Tr);
	}

}