/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;
/*------------------------------------------------------------*/
/*                       spaceConfig                          */
/*                         (c)  MJA                           */
/*                      Julio de 2001                         */
/*------------------------------------------------------------*/

import java.util.*;
import java.awt.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import com.mja.util.*;
import com.mja.lang.*;

import com.mja.descgui.edit.editObject;
import org.unam.matem.Attribute;

public class spaceConfig extends editObject {

	public static String bcol="ffffff", netcol="c0c0c0",net10col="",axescol="808080",textcol="ffafaf"; // Descartes
//	public static String bcol="f0f8fa", netcol="b8c4c8",net10col="889498",axescol="405860",textcol="405860"; // Arquimedes

	public static final int dosD=0,tresD=1,alg=2,appl=3,htmliframe=4;

	static final String[] allTypes={"R2","R3","TA","AP","HTMLIFrame"};
	static String[] types=allTypes;
	static final String[] typesR2R3={"R2","R3","AP","HTMLIFrame"};

	private static int[] typeID={
		dosD,
		tresD,
		alg,
		appl,
		htmliframe
//		desc3
	};

	private static String[] defaultExpresion={
		"E?",  // R2
		"E?",  // R3
		"E?",  // TA
		"E?",  // AP
		"E?",  // HTMLIFrame
//		"E?",  // D3
	};



	public static final int topleft=0, stretch=1, patch=2, center=3;
	public int type=dosD, bgdisplay=topleft;
	public String top,left,width,height;
	public String s_Ox, s_Oy;
	public String s_visicond;
/* --- 2-D --- */
	public String x_axis="",y_axis="";
	public String bgimage="";
	public boolean numbers=false,x_On,y_On;
	static public final mjaColor[] DC0={ new mjaColor(Color.white),new mjaColor(Color.lightGray),new mjaColor(Color.gray),new mjaColor(Color.darkGray),new mjaColor(Color.pink) };
	public mjaColor[] DC;
	public boolean[] isOn;
	public boolean mouseMotionActive=true;
	public boolean split=false, fixed=false;
/* --- 3-D --- */

	public static final int 
		SpTyp=0,id=1,l=2,t=3,w=4,h=5,visible=6,ixfix=7, 	// generales
		scale=8,Ox=9,Oy=10,bgima=11, bgdisp=12, 												// R2 y R3
		bg=13,net=14,net10=15,ax=16,text=17,numb=18,x_ax=19,y_ax=20,	// R2
		render=21,ixsplit=22,ixmousem=23,									// R3
		controls=24, tree=25, sensible=26, paso=27, fonttype=28, fontsz=29, mult=30, par=31, dec=32, // TA
		guided=33, mode=34, equation=35, exercises=36,
		file=37, // AP, HLTMLFrame
//		advance=36, showresult=37, showrule=38, asoconclicks=39, simp0_1=40, usemcm=41, simpnum=42, simpden=42,
		spaceID=38, numFields=39;
	private static final int[] bgdispTypes={data.bgtopleft,data.bgstretch,data.bgpatch,data.bgcenter};
	private static final int[] sortTypes={data.sort,data.painter,data.raytrace};
	private static final int[] spaceTypes={data.TX_type,data.R2_type,data.R3_type,data.TA_type,data.GL_type,data.HF_type,data.D3_type};
	private static final int[] controlsTypes={data.No,data.Up,data.Down};
	private static final int[] fontTypes={data.SansSerif,data.Serif,data.Monospaced};
//	private static final int[] modes={data.automatic,data.clickanddrag,data.clickandwrite,data.write};
	private static final int[] modes={data.clickanddrag,data.write};
	private static final int[] multOptions={data.dot,data.cross};

	private static editObjectType[] spaceEOT;
	
	private static final editField[] spacefield = new editField[numFields];
	
	public void defineFields() {
		int n=0;
		spacefield[n++]=new editField(data.spaceType ,"TX"    ,"TX"    ,editObject.choice      , 0,-1,true,-1,-1,-1,data.spaceType,spaceTypes);
		spacefield[n++]=new editField(data.id        ,""      ,""      ,editObject.string      , 5);
		spacefield[n++]=new editField(data.left      ,""      ,""      ,editObject.string      , 8);
		spacefield[n++]=new editField(data.top       ,""      ,""      ,editObject.string      , 8);
		spacefield[n++]=new editField(data.widthness ,""      ,""      ,editObject.string      , 8);
		spacefield[n++]=new editField(data.heightness,""      ,""      ,editObject.string      , 8);
		spacefield[n++]=new editField(data.cond      ,""       ,""     ,editObject.string      ,45);
		spacefield[n++]=new editField(data.fixed     ,"no"    ,"no"    ,editObject.select      , 1);
		spacefield[n++]=new editField(data.p_scale   ,""      ,""      ,editObject.string      ,15);
		spacefield[n++]=new editField(data.p_Ox      ,"0"     ,"0"     ,editObject.string      ,15);
		spacefield[n++]=new editField(data.p_Oy      ,"0"     ,"0"     ,editObject.string      ,15);
		spacefield[n++]=new editField(data.bgimage   ,""      ,""      ,editObject.string      ,36);
		spacefield[n++]=new editField(data.bgdisplay ,""      ,""      ,editObject.choice      , 1,-1,true,-1,-1,-1,data.bgdisplay,bgdispTypes);
		spacefield[n++]=new editField(data.BACKGROUND,bcol    ,bcol    ,editObject.color_button, 1);
		spacefield[n++]=new editField(data.NET       ,netcol  ,"yes"   ,editObject.color_select, 1);
		spacefield[n++]=new editField(data.NET10     ,net10col,""      ,editObject.color_select, 1);
		spacefield[n++]=new editField(data.AXES      ,axescol ,"yes"   ,editObject.color_select, 1);
		spacefield[n++]=new editField(data.TEXT      ,textcol ,"yes"   ,editObject.color_select, 1);
		spacefield[n++]=new editField(data.numbers   ,"no"    ,"no"    ,editObject.select      , 1);
		spacefield[n++]=new editField(data.x_axis    ,""      ,""      ,editObject.string      ,15);
		spacefield[n++]=new editField(data.y_axis    ,""      ,""      ,editObject.string      ,15);

		spacefield[n++]=new editField(data.render    ,"sort"  ,"sort"  ,editObject.choice      , 1,-1,true,-1,-1,-1,data.render,sortTypes);
		spacefield[n++]=new editField(data.split    ,"no"     ,"no"    ,editObject.select      , 1);
		spacefield[n++]=new editField(data.mousem   ,"no"     ,"no"    ,editObject.select      , 1);

		spacefield[n++]=new editField(data.controls ,"no" 	 ,"no"  	,editObject.choice      , 1,-1,true,-1,-1,-1,data.controls,controlsTypes);
		spacefield[n++]=new editField(data.tree		,"no" 	 ,"no"  	,editObject.select      , 1);
		spacefield[n++]=new editField(data.sensible	,"no" 	 ,"no"  	,editObject.select      , 1);
		spacefield[n++]=new editField(data.step		,"1" 	 ,"1" 	 	,editObject.string      , 6);
		spacefield[n++]=new editField(data.fonttype ,"SansSerif","SansSerif",editObject.choice  , 1,-1,true,-1,-1,-1,data.fonttype,fontTypes);
		spacefield[n++]=new editField(data.fontsz	,"20",		"20"	,editObject.string  	,6);
		spacefield[n++]=new editField(data.mult		,"punto,no siempre"	,"punto,no siempre",editObject.choice, 1,-1,true,-1,-1,-1,data.mult,multOptions);
		spacefield[n++]=new editField(data.par		,"no" 	 ,"no" 	 	,editObject.select      , 1);
		spacefield[n++]=new editField(data.decimals	,"2" 	 ,"2" 	 	,editObject.string      , 5);
		spacefield[n++]=new editField(data.guided	,"no" 	 ,"no" 	 	,editObject.select      , 1);
		spacefield[n++]=new editField(data.mode		,"clic y arrastre" 	 ,"clic y arrastre" ,editObject.choice , 1,-1,true,-1,-1,-1,data.mode,modes);
		spacefield[n++]=new editField(data.equation ,"" 	,""			,editObject.string		,33);
		spacefield[n++]=new editField(data.exercises,"" 	,""			,editObject.string		,54);
		spacefield[n++]=new editField(data.file     ,""      ,""        ,editObject.string      ,30);
		spacefield[n++]=new editField(data.cID  	,"" 	,""			,editObject.string		,12);
	};

	private translator Tr;

/* -------------------------- extends editObject --------------------- */

	public void updateInfo(translator Tr) {
		if (Tr.equals(s_value[SpTyp],data.R3_type)) {
			type=tresD;
		} else if (Tr.equals(s_value[SpTyp],data.R2_type)) {
			type=dosD;
		} else if (Tr.equals(s_value[SpTyp],data.TA_type)) {
			type=alg;
		} else if (Tr.equals(s_value[SpTyp],data.GL_type)) {
			type=appl;
		} else if (Tr.equals(s_value[SpTyp],data.HF_type)) {
			type=htmliframe;
//		} else if (Tr.equals(s_value[SpTyp],data.D3_type)) {
//			type=desc3;
		} else {
			System.out.println("Space Type "+s_value[SpTyp]+" Unrecognized");
			System.out.println("SpaceConfig.updateInfo; Unrecognized space type: "+s_value[SpTyp]);
			type=htmliframe;
		}
		fixed=Tr.isTrue(s_value[ixfix]);
		DC=getColors();
		isOn=getIsOn();

		left=s_value[l];
		top=s_value[t];
		width=s_value[w];
		height=s_value[h];

//		s_scale=s_value[scale];
		s_Ox=s_value[Ox];
		s_Oy=s_value[Oy];

		x_axis=s_value[x_ax];
		y_axis=s_value[y_ax];
		numbers=Tr.isTrue(s_value[numb]);
		bgimage=s_value[bgima];
		bgdisplay=getBGDisplay(Tr);
		s_visicond=s_value[visible];
		if (!BasicStr.hasContent(s_visicond)) {
			s_visicond="1";
		}
		x_On=Tr.isNotFalse(x_axis);
		y_On=Tr.isNotFalse(y_axis);;
		if (!x_On) { x_axis="";	}
		if (!y_On) { y_axis="";	}
		split=Tr.isTrue(s_value[ixsplit]);
		mouseMotionActive=Tr.isTrue(s_value[ixmousem]);

		String s=getName()+" (";
		switch (type) {
			case dosD	: s+="2-D"; break;
			case tresD 	: s+="3-D"; break;
			case alg   	: s+="Alg"; break;
			case appl  	: s+="App"; break;
			case htmliframe	: s+="HTMLIFrame"; break;
			default		: System.out.println("SpaceConfig.getName(); unknown space type: "+type);
							s+="2-D";
		}
		s+=")";
		setId(s);
	}
	
	public String getScale() {
		return s_value[scale];
	}

	public boolean isR2() {
		return type==dosD;
	}

	public boolean isR3() {
		return type==tresD;
	}

	public void setEditName(String name) {
		setName(name);
	}

	public String getEditName() {
		return getName();
	}

	public String getSpaceID() {
		return s_value[spaceID];
	}
	
	public void setSpaceID(String str) {
		s_value[spaceID]=str;
	}

/* -------------------------------------------------------------------- */

	private void fixFields() {
		spacefield[SpTyp].isFixed=true;
		spacefield[spaceID].isFixed=true;
	}

	public spaceConfig(translator Tr,String s_type,String s_id) {
		this(Tr,Tr.getTr(data.type)+"="+s_type+" "+Tr.getTr(data.id)+"="+s_id);
	}
	
	public spaceConfig cloneSpaceConfig() {
		return new spaceConfig(Tr,toString(" ",Tr));
	}

	public spaceConfig(translator Tr,String values) {
		defineFields();
		fixFields();
		expl=Expl.Space;
		this.Tr=Tr;
		if (spaceEOT==null) {
			createSpaceEOT();
		}
		String values1=values;
		Attribute[] aa=Attribute.parse(values);
		String sptype=Attribute.getValue(aa,Tr.getTr(data.spaceType));
		if (!BasicStr.hasContent(sptype)) {
			String oldR3=Attribute.getValue(aa,Tr.getTr(data.R3));
			if (BasicStr.hasContent(oldR3) && Tr.isTrue(oldR3) ) {
				values1=Tr.getTr(data.spaceType)+"='R3' "+values;
			} else {
				values1=Tr.getTr(data.spaceType)+"='R2' "+values;
			}
		}
		/* ---------------------------------------- */
		String[] nullv=new String[numFields];
		for (int i=0;i<nullv.length;i++) {
			nullv[i]=spacefield[i].null_val;
		}
		nullv[render]=Tr.getTr(data.sort);
		initialize(Tr,spacefield,spaceEOT,Attribute.parse(values1),nullv);
	}

	private static void createSpaceEOT() {
		BitSet R2attr=new BitSet(numFields);
		R2attr.set(id);
		R2attr.clear(SpTyp);
		R2attr.set(ixfix);
		R2attr.set(l);
		R2attr.set(t);
		R2attr.set(w);
		R2attr.set(h);
		R2attr.set(scale);
		R2attr.set(Ox);
		R2attr.set(Oy);
		R2attr.set(bg);
		R2attr.set(net);
		R2attr.set(net10);
		R2attr.set(ax);
		R2attr.set(text);
		R2attr.set(x_ax);
		R2attr.set(y_ax);
		R2attr.set(numb);
		R2attr.set(bgima);
		R2attr.set(bgdisp);
		R2attr.clear(render);
		R2attr.clear(ixsplit);
		R2attr.set(ixmousem);
		R2attr.set(visible);
		R2attr.clear(file);
		R2attr.set(spaceID);

		BitSet R3attr=new BitSet(numFields);
		R3attr.set(id);
		R3attr.clear(SpTyp);
		R3attr.set(ixfix);
		R3attr.set(l);
		R3attr.set(t);
		R3attr.set(w);
		R3attr.set(h);
		R3attr.set(scale);
		R3attr.set(Ox);
		R3attr.set(Oy);
		R3attr.set(bg);
		R3attr.clear(net);
		R3attr.clear(net10);
		R3attr.clear(ax);
		R3attr.clear(text);
		R3attr.clear(x_ax);
		R3attr.clear(y_ax);
		R3attr.clear(numb);
		R3attr.set(bgima);
		R3attr.set(bgdisp);
		R3attr.set(render);
		R3attr.set(ixsplit);
		R3attr.set(ixmousem);
		R3attr.set(visible);
		R3attr.clear(file);
		R3attr.set(spaceID);

		BitSet TAattr=new BitSet(numFields);
		TAattr.set(id);
		TAattr.clear(SpTyp);
		TAattr.set(l);
		TAattr.set(t);
		TAattr.set(w);
		TAattr.set(h);
		TAattr.clear(bg);
		TAattr.clear(bgima);
		TAattr.clear(bgdisp);
		TAattr.set(visible);
		TAattr.clear(controls);
		TAattr.set(tree);
		TAattr.set(sensible);
		TAattr.set(paso);
		TAattr.set(fonttype);
		TAattr.set(fontsz);
		TAattr.set(mult);
		TAattr.set(par);
		TAattr.set(dec);
		TAattr.clear(guided);
		TAattr.set(mode);
		TAattr.set(equation);
		TAattr.set(exercises);
		TAattr.clear(file);
		TAattr.set(spaceID);

		BitSet GLattr=new BitSet(numFields);
		GLattr.set(id);
		GLattr.clear(SpTyp);
		GLattr.set(l);
		GLattr.set(t);
		GLattr.set(w);
		GLattr.set(h);
		GLattr.set(bg);
		GLattr.set(bgima);
		GLattr.set(bgdisp);
		GLattr.set(visible);
		GLattr.clear(controls);
		GLattr.clear(tree);
		GLattr.clear(sensible);
		GLattr.clear(paso);
		GLattr.clear(fonttype);
		GLattr.clear(fontsz);
		GLattr.clear(mult);
		GLattr.clear(par);
		GLattr.clear(dec);
		GLattr.clear(guided);
		GLattr.clear(mode);
		GLattr.clear(equation);
		GLattr.clear(exercises);
		GLattr.set(file);
		GLattr.set(spaceID);

		BitSet HFattr=GLattr;


		BitSet D3attr=new BitSet(numFields);
		D3attr.set(id);
		D3attr.clear(SpTyp);
		D3attr.set(l);
		D3attr.set(t);
		D3attr.set(w);
		D3attr.set(h);
		D3attr.set(bg);
		D3attr.set(bgima);
		D3attr.set(bgdisp);
		D3attr.set(visible);


		spaceEOT=new editObjectType[6];
		spaceEOT[0]=new editObjectType("",R2attr);
		spaceEOT[1]=new editObjectType("",R3attr);
		spaceEOT[2]=new editObjectType("",TAattr);
		spaceEOT[3]=new editObjectType("",GLattr);
		spaceEOT[4]=new editObjectType("",HFattr);
		spaceEOT[5]=new editObjectType("",D3attr);
	}

	public void setName(String name) {
		s_value[id]=name;
	}

	public String getName() {
		return s_value[id];
	}
	
	public String getFileName() {
		return s_value[spaceConfig.file];
	}

	public int getNumTypes() {
		return types.length;
	}
	public String getType(translator Tr,int i) {
		return types[i];
	}
	public String getDefaultExpresion(translator Tr,int i) {
		return defaultExpresion[i];
	}
	public String getListTitle(translator Tr) {
		return Tr.getTr(data.p_space);
	}
	public String getTypesInfo(translator Tr) {
		return Tr.getTr(data.space);
	}

	public int getTypeIndex(translator Tr) {
//		if (Tr.equals(s_value[SpTyp],data.D3_type)) {
//			return desc3;
		if (Tr.equals(s_value[SpTyp],data.TA_type)) {
			return alg;
		} else if (Tr.equals(s_value[SpTyp],data.R3_type)) {
			return tresD;
		} else if (Tr.equals(s_value[SpTyp],data.R2_type)) {
			return dosD;
		} else if ("AP".equals(s_value[SpTyp])) {
			return appl;
		} else if ("HTMLIFrame".equals(s_value[SpTyp])) {
			return htmliframe;
		} else if ("HF".equals(s_value[SpTyp])) {
			return htmliframe;
		} else {
			System.out.println("SapceConfig.getTypeIndex(); unknown type string: "+s_value[SpTyp]);
			return dosD;
		}
	}

	public String prefix() {
		if (BasicStr.hasContent(getName())) {
			return getName()+".";
		} else {
			return "";
		}
	}

	public int getBGDisplay(translator Tr) {
		if (Tr.equals(s_value[bgdisp],data.bgstretch)) {
			return stretch;
		} else if (Tr.equals(s_value[bgdisp],data.bgpatch)) {
			return patch;
		} else if (Tr.equals(s_value[bgdisp],data.bgcenter)) {
			return center;
		} else {
			return topleft;
		}
	}

	private boolean[] getIsOn() {
		boolean[] isOn=new boolean[5];
		for (int i=0;i<isOn.length;i++) {
			isOn[i]=Tr.isNotFalse(s_value[bg+i]);
		}
		if (!BasicStr.hasContent(s_value[bg+2])) {
			isOn[net10-bg]=isOn[net-bg]&&isOn[ax-bg];
			if (isOn[net10-bg]) {
				s_value[bg+2]=s_value[bg+3];
			} else {
				s_value[bg+2]="false";
			}
		}
		return isOn;
	}

	private mjaColor[] getColors() {
		mjaColor[] color=new mjaColor[DC0.length];
		for (int i=0;i<color.length;i++) {
			color[i]=Tr.parseColor(s_value[bg+i],DC0[i],DC0[i]);
		}
		return color;
	}
	
	public Space makeSpace(Descartes D) {
		Space sp=null;
		if (type==spaceConfig.tresD) {
			sp=new SpaceR3(D,this);
		} else if (type==spaceConfig.alg) {
			try {
				sp=new SpaceTA(D,this);
			} catch (Exception e) {
				System.out.println("Descartes_A.jar not loaded?");
				e.printStackTrace();
			}
		} else if (type==spaceConfig.appl) {
			sp=new SpaceAP(D,this);
		} else if (type==spaceConfig.htmliframe) {
			sp=new SpaceHTMLIFrame(D,this);
		} else if (type==spaceConfig.dosD) {
			sp=new SpaceR2(D,this);
		} else {
			System.out.println("SpaceConfig.makeSpace; Wrong space type: "+type);
			sp=new SpaceR2(D,this);
		}
		this.sp=sp;
		return sp;
	}

	private Space sp;
	
	public String toString(String sep,translator Tr) {
		if ((BasicStr.hasContent(s_value[spaceID])) && (sp!=null)) {
			Point p=sp.getLocation();
			s_value[l]=""+p.x;
			s_value[t]=""+p.y;
		}
		String s=super.toString(sep,Tr);
		if ("R3".equals(Tr.getValue(Attribute.parse(s),data.spaceType))) {
			s=s+" R3='"+Tr.getTr(data.Yes)+"'";
		}
		if (!BasicStr.hasContent(Tr.getValue(Attribute.parse(s),data.spaceType))) {
			s=Tr.getTr(data.spaceType)+"='"+Tr.getTr(data.R2_type)+"' "+s;
		}
		return s;
	}
	

}