/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descartes;

//import com.mja.util.*;
/*------------------------------------------------------------*/
/*                        statePanel                          */
/*                         (c)  MJA                           */
/*                      Enero de 2001                         */
/*------------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.lang.*;
import com.mja.util.*;
import com.mja.cmp.*;

public class statePanel extends Panel {


	private int nsp;
	private controlConfig[] cca;
	private NumericControl[] numctrl;
	private int region;
	private int ancho;

	public statePanel(controlConfig[] cca,NumericControl[] numctrl,int region,int scene_width,int height,Color bg) {
		this(cca,numctrl,region,scene_width,height,bg,1);
	}

	public statePanel(controlConfig[] cca,NumericControl[] numctrl,int region,int scene_width,int height,Color bg, int rowsorwidth) {
		this.cca=cca;
		this.numctrl=numctrl;
		this.region=region;
		setBackground(bg);
		nsp=0;
		if (cca==null) {
			return;
		}
		for (int i=0;i<cca.length;i++) {
			if (cca[i].type==data.c_numeric&&cca[i].region==region) {
				numctrl[i].setBackground(getBackground());
				nsp++;
			}
		}
		if (region==data.north||region==data.south) {
			int cols=(nsp+(rowsorwidth-1))/rowsorwidth;
			setLayout(new GridLayout(rowsorwidth,cols));
		} else if (region==data.east || region==data.west) {
			ancho=0;
			if (nsp>0) {
				ancho=125;
				if (rowsorwidth!=0) {
					ancho=rowsorwidth;
				}
			}
			setLayout(null);
			for (int i=0,j=0;i<cca.length;i++) {
				if (cca[i].type==data.c_numeric&&cca[i].region==region) {
					numctrl[i].setBounds(3,3+(height+3)*j,ancho-6,height);
					j++;
				}
			}
		} else {
			setLayout(new GridLayout(nsp,1));
		}
		for (int i=0;i<cca.length;i++) {
			if (cca[i].type==data.c_numeric&&cca[i].region==region) {
				add(numctrl[i]);
			}
		}
	}
	
	public int getAncho() {
		return ancho;
	}

	int countSpinners() {
		return nsp;
	}

	private boolean fontUpdated=false;
	
	public void paint(Graphics g) {
		if (g!=null) {
			for (int i=0;i<cca.length;i++) {
				if (cca[i].type==data.c_numeric&&cca[i].region==region) {
					numctrl[i].updateFont();
				}
			}
			fontUpdated=true;
		}
		super.paint(g);
	}

}