/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descedit;

/*------------------------------------------------------------*/
/*                         configEdit                         */
/*                          (c) MJA                           */
/*                       Enero de 2001                        */
/*------------------------------------------------------------*/

import java.util.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
//import java.awt.datatransfer.*;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.lang.*;
import com.mja.parser.*;
import com.mja.gui.*;
import com.mja.file.mjaFont;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import com.mja.descartes.*;
import com.mja.textedit.*;
import com.mja.cmp.*;
import javax.swing.*;
import org.unam.matem.Attribute;
import com.mja.descedit.descartesJS.ControlsEditorPane;
import com.mja.descedit.descartesJS.ControlEditorList;
import com.mja.descedit.descartesJS.DefinitionEditorPane;
import com.mja.descedit.descartesJS.DefinitionEditorList;
import com.mja.descedit.descartesJS.ProgramEditorPane;
import com.mja.descedit.descartesJS.ProgramEditorList;
import com.mja.descedit.descartesJS.Graph2DEditorPane.Graph2DEditObject;

public class configEdit extends editFrame implements ActionListener, ItemListener, Explainer {

	public static boolean forJava=true;

	com.mja.gui.MouseCursorHandler mch;
	
	protected int BUTTON_P=0,SPACE_P=1,CONTROL_P=2,DEF_P=3,PRG_P=4,GR2D_P=5,GR3D_P=6,ANIM_P=7;

	protected static String titleBase=" Descartes config ";
	protected Descartes D;
	protected Panel MP, NP, CP, ButtP,AnimP;
	protected Choice chl;
	protected static final int ix_original=0,ix_undo=1,ix_redo=2,ix_new=3,ix_applet=4,ix_macro=5,ix_help=6;
	private static final int[] b_ix={ data.original,data.undo,data.redo,data.newcfg,data.appletc,data.macro,data.help };
	protected Button[] b_;
	private Button b_apply;
	private Label albl,mlbl;
	protected CheckboxGroup chbpg;
	protected int[] chbp_ix={
		data.p_buttons,data.p_space,data.p_controls,data.p_auxiliaries,data.p_auxiliaries,
		data.p_graphics,data.p_graphR3,data.p_anim
		};
	private static final int[] chkbx_ix={ data.about,data.config,data.init,data.clear };
	protected Checkbox [] chkbx, chbp;
	protected Checkbox chb_undo, chb_anim, chPop;
	private mjaPair chkbxE, chkbxS, chkbxA, chkbxR; //, chkbxm, chkbx3;
	private TextArea TA,TA_m;
	private static final int ix_n=0,ix_cb=1, ix_w=2, ix_h=3, ix_co=4, ix_pop=5, ix_bw=6, ix_bh=7;
	private mjaPair[] pr_Code;
	private mjaPair pr_lms,pr_course,pr_unit;
	protected mjaPair rowsNorth,rowsSouth,widthEast,widthWest,rowsHeight,p_infoind,p_infoest,p_decsymb,p_antialias;
	private codeEdit coed,coed_m;
	protected controlEP epP;
	protected auxEP eaP;
	protected spaceEP esP;
	protected graphEP egP;
	protected graphR3EP egR3P;
	protected animEP eanimP;
	protected controlEL CtrlEL;
	protected auxEL AuxsEL;
	protected spaceEL SpceEL;
	protected graphEL GrR2EL;
	protected graphR3EL GrR3EL;
	protected CardLayout cL;
	protected String[] CPid = {"0","1","2","3","4","5","6","7"};
	private Vector undo=new Vector();
	private volatile int undo_ix=0;
	private DefinitionEditorPane DefEP;
	private DefinitionEditorList DefEL;


	protected editPanel[] EP=new editPanel[CPid.length];

	protected codeParams copa=new codeParams();
	
	private Object caller=null;

	public configEdit(Descartes D,Object O) {
		super(titleBase,"","","");
//System.out.println("ctrlCfg IN");
		try {
			UIManager.setLookAndFeel(UIManager.getCrossPlatformLookAndFeelClassName());
		} catch (Exception e) {
		}
		this.D=D;
		caller=O;
//		cfga=D.cfg.cloneConfig();
		MP=new Panel();
		mch=new com.mja.gui.MouseCursorHandler(MP,this);
		add("Center",MP);
		MP.setLayout(new BorderLayout());
		setFont(mjaFont.AWTSansSerif);
		chl=new Choice();
		chl.setFont(mjaFont.AWTSansSerif);
		chb_undo=new Checkbox();
		chb_undo.setState(false);
//		chb_undo.setState(D.undo_active);
//		chb_undo.addItemListener(this);
		b_=new Button[b_ix.length];
		for (int i=0;i<b_.length;i++) {
			b_[i]=new Button();
			b_[i].addActionListener(this);
			b_[i].addMouseListener(mch);
		}
		b_[ix_undo].setEnabled(false);
		b_[ix_redo].setEnabled(false);

		b_[ix_original].setEnabled(false); // porque requiere de tiempo para crear copias del original

//		chb_undo.addMouseListener(mch);

		chbpg=new CheckboxGroup();
		chbp=new Checkbox[CPid.length];
		for (int i=0;i<chbp.length;i++) {
			chbp[i]=new Checkbox("",chbpg,i==0);
			chbp[i].setForeground(mjaPair.mostlyWhite);
			chbp[i].addItemListener(this);
			chbp[i].addMouseListener(mch);
		}
		chkbx=new Checkbox[chkbx_ix.length];
		for (int i=0;i<chkbx.length;i++) {
			chkbx[i]=new Checkbox("");
			chkbx[i].addMouseListener(mch);
			chkbx[i].addItemListener(this);
		}

		// construct NP
		MP.add("North",NP=new Panel());
		Panel NP1=new Panel(); NP1.setLayout(new GridLayout(1,4));
		NP1.add(chl);
		chl.addMouseListener(mch);
		chl.addItemListener(this);
//		NP1.add( mjaLayout.triplet(1,0,1,b_[ix_undo],chb_undo,b_[ix_redo]));
		NP1.add(new Label(" ",Label.RIGHT));
		NP1.add(new Label(" ",Label.LEFT));
//		NP1.add(mjaLayout.pair(b_[ix_original],b_[ix_new]));
		NP1.add(mjaLayout.pair(b_[ix_applet],mjaLayout.pair(0.9,0.1,b_[ix_macro],b_[ix_help])));
		Panel NPchbp=new Panel();
		NPchbp.setBackground(new Color(0x7070a0));
		NPchbp.setLayout(new GridLayout(1,chbp.length));
		for (int i=0;i<chbp.length;i++) {
			NPchbp.add(chbp[i]);
		}
		NP.setLayout(new GridLayout(2,1));
		NP.add(NP1);NP.add(NPchbp);
//System.out.println("ctrlCfg 1");

		// construct ButtP
		ButtP=new Panel();
		ButtP.setLayout(new BorderLayout());
		Panel auxNP=new Panel();
		ButtP.add("North",auxNP);
		ButtP.add("Center",new Label());
		auxNP.setLayout(new GridLayout(5,1,16,4));
		auxNP.setBackground(editList.Color_1);
		Panel auxP1=new Panel();
		auxP1.setLayout(new GridLayout(1,chkbx.length));
		for (int i=0;i<chkbx.length;i++) {
			auxP1.add(chkbx[i]);
		}
		Panel auxP2=new Panel();
		auxP2.setLayout(new FlowLayout(FlowLayout.CENTER,8,4));
		auxP2.add(rowsNorth=new mjaPair(MP,0.9,0.1,2));
		auxP2.add(rowsSouth=new mjaPair(MP,0.9,0.1,2));
		auxP2.add(widthWest=new mjaPair(MP,0.9,0.1,2));
		auxP2.add(widthEast=new mjaPair(MP,0.9,0.1,2));
		auxP2.add(rowsHeight=new mjaPair(MP,0.9,0.1,2));

		Panel auxP3=new Panel();
		auxP3.setLayout(new FlowLayout(FlowLayout.CENTER,36,4));

		chkbxE=new mjaPair(MP,editObject.select,0,null,0);
		chkbxE.setState(true);
		chkbxE.setLabel("editor");
		chkbxE.addMouseListener(mch);
		auxP3.add(chkbxE);
		
		chkbxS=new mjaPair(MP,editObject.select,0,null,0);
		chkbxS.setLabel("audio");
		chkbxS.addMouseListener(mch);
		auxP3.add(chkbxS);

		chkbxA=new mjaPair(MP,editObject.select,0,null,0);
		chkbxA.setLabel("algebra");
		chkbxA.addMouseListener(mch);
		auxP3.add(chkbxA);

		chkbxR=new mjaPair(MP,editObject.select,0,null,0);
		chkbxR.setLabel("RAD");
		chkbxR.addMouseListener(mch);
		auxP3.add(chkbxR);

		Panel auxP4=new Panel();
		auxP4.setLayout(new FlowLayout(FlowLayout.CENTER,16,4));
		auxP4.add(p_infoind=new mjaPair(MP,editObject.text,25,null,0));
		auxP4.add(p_infoest=new mjaPair(MP,editObject.text,25,null,0));
		p_infoind.addActionListener(this);
		p_infoest.addActionListener(this);
//System.out.println("ctrlCfg 2");
		
		Panel auxP5=new Panel();
		auxP5.setLayout(new FlowLayout(FlowLayout.CENTER,16,4));
		auxP5.add(p_decsymb=new mjaPair(MP,editObject.choice,15,null,0));
		Vector V=new Vector();
		V.addElement(",");
		V.addElement(".");
		p_decsymb.setOptions(V);
		p_decsymb.addActionListener(this);
		auxP5.add(p_antialias=new mjaPair(MP,editObject.select,0,null,0));
		p_antialias.setLabel("antialias");
		p_antialias.addActionListener(this);

		auxNP.add(auxP1);
		auxNP.add(auxP2);
		auxNP.add(auxP3);
		auxNP.add(auxP4);
		auxNP.add(auxP5);

		// construct AnimP
		AnimP=new Panel();
		AnimP.setBackground(editList.Color_1);
		AnimP.setLayout(new BorderLayout());

		esP=new spaceEP(D,this,MP);
		SpceEL=new spaceEL(this,MP,esP);
		esP.eL=SpceEL;
		SpceEL.addActionListener(this);

		epP = new ControlsEditorPane(D,this,MP);
		CtrlEL = new ControlEditorList(this,MP,epP,SpceEL);
//		epP=new controlEP(D,this,MP);
//		CtrlEL=new controlEL(this,MP,epP);
		epP.eL=CtrlEL;
		CtrlEL.addActionListener(this);
		SpceEL.addListaDependiente(CtrlEL);
//System.out.println("ctrlCfg 3");

		DefEP = new DefinitionEditorPane(D,this,MP);
		DefEL = new DefinitionEditorList(this,MP,DefEP);
		DefEP.eL=DefEL;
		DefEL.addActionListener(this);
		DefEL.setInfo(this.D.Tr, null);

//		eaP=new auxEP(D,this,MP);
//		AuxsEL=new auxEL(this,MP,eaP);
		eaP = new ProgramEditorPane(D, this, MP);
		AuxsEL = new ProgramEditorList(this,MP,(ProgramEditorPane)eaP);
		eaP.eL=AuxsEL;
		AuxsEL.addActionListener(this);

//System.out.println("ctrlCfg 3.1");

		egP=new graphEP(D,this,MP);
//System.out.println("ctrlCfg 3.1.2");
		GrR2EL=new graphEL(this,MP,egP,SpceEL);
//System.out.println("ctrlCfg 3.1.3");
		egP.eL=GrR2EL;
		GrR2EL.addActionListener(this);
		SpceEL.addListaDependiente(GrR2EL);

//System.out.println("ctrlCfg 3.2");

		egR3P=new graphR3EP(D,this,MP);
		GrR3EL=new graphR3EL(this,MP,egR3P,SpceEL);
		egR3P.eL=GrR3EL;
		GrR3EL.addActionListener(this);
		SpceEL.addListaDependiente(GrR3EL);

//System.out.println("ctrlCfg 3.3");

		chb_anim=new Checkbox();
		chb_anim.addItemListener(this);
		chb_anim.addMouseListener(mch);
		eanimP=new animEP(D,this,MP);

		b_apply=new Button();
		b_apply.addActionListener(this);
		b_apply.addMouseListener(mch);

//System.out.println("ctrlCfg 3.4");

		pr_lms=new mjaPair(MP,editObject.select,1,null,-1);
		pr_course=new mjaPair(MP,30);
		pr_unit=new mjaPair(MP,30);
//		if (D.LMS_inUse()) {
//			pr_lms.setEnabled(false);
//			pr_course.setEnabled(false);
//			pr_unit.setEnabled(false);
//		}
//System.out.println("ctrlCfg 4");

		pr_Code=new mjaPair[8];
		pr_Code[ix_n]=new mjaPair(MP,8);
		pr_Code[ix_cb]=new mjaPair(MP,8);
		pr_Code[ix_w]=new mjaPair(MP,4);
		pr_Code[ix_h]=new mjaPair(MP,4);
		pr_Code[ix_co]=new mjaPair(MP,editObject.select,1,null,-1);
		pr_Code[ix_pop]=new mjaPair(MP,editObject.select,1,null,-1);
		pr_Code[ix_bw]=new mjaPair(MP,4);
		pr_Code[ix_bh]=new mjaPair(MP,4);
		chPop=(Checkbox)pr_Code[ix_pop].getInfoComponents()[0];
		chPop.addItemListener(this);

		TA=new TextArea(24,120);
		TA.setFont(mjaFont.AWTSansSerif);
		TA_m=new TextArea(24,120);
		TA_m.setFont(mjaFont.AWTSansSerif);
		TA_m.setEditable(false);
		TA_m.setBackground(Color.white);
		albl=new Label();
		albl.setAlignment(Label.CENTER);
		albl.setBackground(Color.lightGray);
		mlbl=new Label();
		mlbl.setAlignment(Label.CENTER);
		mlbl.setBackground(Color.lightGray);

		// construct CP
		CP=new Panel();
		CP.setLayout(cL=new CardLayout());
		EP[SPACE_P]=esP;
		EP[CONTROL_P]=epP;
		EP[DEF_P]=DefEP;
		EP[PRG_P]=eaP;
		EP[GR2D_P]=egP;
		EP[GR3D_P]=egR3P;
		
		rebuildAnimP();
		CP.add(ButtP,CPid[0]);
		CP.add(SpceEL,CPid[1]); 
		CP.add(CtrlEL,CPid[2]); 
		CP.add(DefEL,CPid[3]); 
		CP.add(AuxsEL,CPid[4]); 
		CP.add(GrR2EL,CPid[5]); 
		CP.add(GrR3EL,CPid[6]); 
		CP.add(AnimP,CPid[7]);
		chbp[1].setState(true);
		for (int i=0;i<chbp.length;i++) {
			if (chbp[i].getState()) {
				if (EP[i]!=null) {
					EP[i].reset();
				}
				cL.show(CP,CPid[i]);
				break;
			}
		}
//System.out.println("ctrlCfg 5");
		MP.add("Center",CP);
		pr_lms.setInfo("LMS","false");
		copa.tolms=false;
		if (BasicStr.hasContent(D.cfg.course)) {
			copa.tolms=true;
			copa.course=D.cfg.course;
			copa.unit=D.cfg.unit;
			pr_lms.setInfo("true");
			pr_course.setInfo(D.Tr.getTr(data.course),D.cfg.course);
			pr_unit.setInfo(D.Tr.getTr(data.unit),D.cfg.unit);
		} else {
			copa.tolms=false;
			copa.course="";
			copa.unit="";
			pr_lms.setInfo("false");
			pr_course.setInfo(D.Tr.getTr(data.course),"");
			pr_unit.setInfo(D.Tr.getTr(data.unit),"");
		}
		copa.name=D.cfg.name;
		copa.codebase=BasicStr.getReducedCodeBase(D);
		copa.dim=new Dimension(D.getSize().width,D.getSize().height);
		copa.dimb=new Dimension(D.getRealSize().width,D.getRealSize().height);
		copa.popUp=D.isPop();
		setCodeControlsFromParams();
//System.out.println("ctrlCfg OUT");
	}
	
	private void setAllExplanations() {
		pr_lms.setExplanation(Expl.get(Expl.LMS,D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		pr_course.setExplanation(Expl.get(Expl.Course,D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		pr_unit.setExplanation(Expl.get(Expl.Unit,D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		for (int i=0;i<pr_Code.length;i++) {
			if (Expl.Code!=null && Expl.Code[i]!=null) {
				pr_Code[i].setExplanation(Expl.get(Expl.Code[i],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
			} else {
				pr_Code[i].setExplanation("",D.Tr.getTr(data.rightClick));
			}
		}

		rowsNorth.setExplanation(Expl.get(Expl.Buttons[4],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		rowsSouth.setExplanation(Expl.get(Expl.Buttons[5],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		widthEast.setExplanation(Expl.get(Expl.Buttons[6],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		widthWest.setExplanation(Expl.get(Expl.Buttons[7],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		rowsHeight.setExplanation(Expl.get(Expl.Buttons[8],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		chkbxE.setExplanation(Expl.get(Expl.Buttons[9],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		chkbxS.setExplanation(Expl.get(Expl.Buttons[10],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		chkbxA.setExplanation(Expl.get(Expl.Buttons[11],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		chkbxR.setExplanation(Expl.get(Expl.Buttons[12],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		p_infoind.setExplanation(Expl.get(Expl.Buttons[13],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		p_infoest.setExplanation(Expl.get(Expl.Buttons[14],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		p_decsymb.setExplanation(Expl.get(Expl.Buttons[15],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		p_antialias.setExplanation(Expl.get(Expl.Buttons[16],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));

		pr_course.setExplanation(Expl.get(Expl.Course,D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		pr_unit.setExplanation(Expl.get(Expl.Unit,D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		for (int i=0;i<pr_Code.length;i++) {
			pr_Code[i].setExplanation(Expl.get(Expl.Code[i],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		}

		epP.setAllExplanations();
		eaP.setAllExplanations();
		esP.setAllExplanations();
		egP.setAllExplanations();
		egR3P.setAllExplanations();
		eanimP.setAllExplanations();
	}

	public void show(Object O) {
		caller=O;
		show();
	}

	public void show() {
		if (caller == null ) {
		} else if ( caller instanceof SpaceR2) {
			GrR2EL.setSelector(((SpaceR2)caller).spcfg.s_value[spaceConfig.id]);
			selectPanel(SPACE_P);
			SpceEL.selectItem(((SpaceR2)caller).spcfg);
		} else if ( caller instanceof SpaceR3) {
			GrR3EL.setSelector(((SpaceR3)caller).spcfg.s_value[spaceConfig.id]);
			selectPanel(SPACE_P);
			SpceEL.selectItem(((SpaceR3)caller).spcfg);
		} else if ( caller instanceof EditorCanvas) {
			selectPanel(BUTTON_P);
		} else if ( caller instanceof Component ) {
			Component c = (Component) caller;
			Container C=c.getParent();
			if (C instanceof NumericControl) {
				NumericControl NC=(NumericControl) C;
				selectPanel(CONTROL_P);
				CtrlEL.selectItem(NC.ccfg);
			}
		} else {
			System.out.println("Unknown caller "+caller );
		}
//		b_[ix_macro].setEnabled(D.cfg.sc.length==1 /* && !D.cfg.hasMacros() */); // eliminado el 28 de Junio de 2006 ver 3.8805
		b_[ix_macro].setEnabled(true); // agregado el 12 de Julio de 2014 ver 5.315 para que se puedan general macros desde un Discurso
		super.show();
		D.cleanMem(false);
		BasicStr.ShiftOn=false;
		BasicStr.CtrlOn=false;
	}

	public void destroy() {
		if (coed!=null) {
			coed.dispose();
			D.cleanMem(false);
		}
		super.destroy();
	}

	config getConfig() {
		return D.cfg;
	}

	private void rebuildAnimP() {
		AnimP.removeAll();
		Panel NP=new Panel();
		NP.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		NP.add(chb_anim);
		AnimP.add("North",NP);
		AnimP.add("Center",eanimP);
	}

/* --------------------------- public interface ----------------------- */

/* ----------------------------- applet Text ------------------------- */

	private String getAppliedCode(Descartes D) {
		return getAppliedCode(D,D.Tr.isTrue(pr_Code[ix_co].getInfo(D.Tr)));
	}

	public String getAppliedCode(Descartes D,boolean codify) {
		String appletHTMLStr = 
		toAppletString(
			D,
			D.scene.getPleca(),
			D.scene.getText(),
			D.scene.getTextHeight(),
			copa.course,
			copa.unit,
			copa.name,
			D.Tr,
			p_infoind.getInfo(D.Tr),
			p_infoest.getInfo(D.Tr),
//			cfga.toAppletParams(D.Tr),
			D.cfg.toAppletParams(D.Tr),
			copa.codebase,
			Integer.toString(copa.dim.width),
			Integer.toString(copa.dim.height),
			codify,
			copa.popUp,
			Integer.toString(copa.dimb.width),
			Integer.toString(copa.dimb.height),
			D.undo_active,
			D.cfg.isEditable,
			D.cfg.useSound,
			D.cfg.useAlgebra,
			D.cfg.useRAD
//			chkbxE.isSelected(),
//			chkbxS.isSelected(),
//			chkbxA.isSelected(),
//			chkbxR.isSelected()
		);

		appletHTMLStr = agregaIgnorados((Descartes5) D,appletHTMLStr);
		return appletHTMLStr;

	}

	private String agregaIgnorados(Descartes5 D5, String appletHTMLStr) {
		String codeToInsert = ""; 
		String formatParam = "   <param name=\"%1$s\" value=\"%2$s\">\n";
		Formatter f = new Formatter();
		Hashtable<String, String> ignored = D5.getIgnoredCtrCfgs();
		int numCtrs = D5.cfg.cc.length;
		Enumeration<String> mediaCtrsCfg = ignored.elements();
		int numDig = (numCtrs>=100)?3:2;
		while (mediaCtrsCfg.hasMoreElements()) {
			String cfgAct = mediaCtrsCfg.nextElement();
			String cfgId = data.controlPrefix+BasicStr.IntegerToString(numCtrs++, numDig);
			String formattedStr = f.format(formatParam, cfgId, cfgAct).toString();
			codeToInsert+=formattedStr;
		}
		
		
		appletHTMLStr = appletHTMLStr.replaceFirst("(?i)(</applet>)",codeToInsert+"</applet>");
		return appletHTMLStr;
	}
	
	public String getModifiedCode(Descartes D) {
		return getModifiedCode(D,D.Tr.isTrue(pr_Code[ix_co].getInfo(D.Tr)));
	}

	public String getModifiedCode(Descartes D,boolean codify) {
		getInfo();
		return toAppletString(
			D,
			D.scene.getPleca(),
			D.scene.getText(),
			D.scene.getTextHeight(),
			copa.course,
			copa.unit,
			copa.name,
			D.Tr,
			p_infoind.getInfo(D.Tr),
			p_infoest.getInfo(D.Tr),
			D.cfg.toAppletParams(D.Tr),
			copa.codebase,
			Integer.toString(copa.dim.width),
			Integer.toString(copa.dim.height),
			codify,
			copa.popUp,
			Integer.toString(copa.dimb.width),
			Integer.toString(copa.dimb.height),
			D.undo_active,
			D.cfg.isEditable,
			D.cfg.useSound,
			D.cfg.useAlgebra,
			D.cfg.useRAD
		);
	}

	protected static String toAppletString(
		Descartes D,
		String scene_pleca,
		String scene_rtf,
		int rtf_height,
		String course,String unit,String nom,
		translator Tr,String txt_infoind,String txt_infoest,
		Attribute[] aa,String codebase,
		String s_width,String s_height,boolean codify,
		boolean pop,String s_awidth,String s_aheight,
		boolean undo_active,
		boolean editable,
		boolean hasSound,
		boolean hasAlgebra,
		boolean useRAD
		) {
		if (!BasicStr.hasContent(nom)) {
			if (D instanceof Arquimedes) {
				nom="Arquimedes";
			} else {
				nom="Descartes";
			}
		}
		String s="<applet";
		if (BasicStr.hasContent(nom)) {
			s+=" name=\""+nom+"\"";
		}
		if (pop) {
			s+=" width="+s_awidth+" height="+s_aheight+" align=\"center\"  ";
		} else {
			s+=" width="+s_width+" height="+s_height+" ";
		}
		String program="Descartes5";
		if (D instanceof Item) {
			s+="code=\"ArquimedesItem\">\n";
			program="Arquimedes";
		} else if (D instanceof Arquimedes) {
			program="Arquimedes";
			s+="code=\"Arquimedes\">\n";
		} else {
			program="Descartes5";
			s+="code=\"Descartes\">\n";
		}
		if (forJava) {
			s+=" <script>\n";
			s+="    document.write('<param name=\"docBase\" value=\"'+window.location.href+'\">');\n";
			s+=" </script>\n";
			s+="   <param name=\"jnlp_href\" value=\"_jnlp_path_lib/"+program+".jnlp\">\n";
		}
		s+="   <param name=\""+Tr.getTr(data.size)+"\" value=\""+s_width+"x"+s_height+"\">\n";
		if (BasicStr.hasContent(scene_pleca)) {
			s+="   <param name=\"pleca\" value=\""+scene_pleca+"\">\n";
		}
		if (D instanceof Arquimedes) {
			s+="   <param name=\"rtf\" value=\""+scene_rtf+"\">\n";
			s+="   <param name=\"rtf_height\" value=\""+rtf_height+"\">\n";
		}

		s+="   <param name=\"image_loader\" value=\""+D.cfg.image_loader+"\">\n";
		s+="   <param name=\"expand\" value=\""+D.cfg.expand+"\">\n";

		if (!D.cfg.useCC) {
			s+="   <param name=\"CreativeCommonsLicense\" value=\"no\">\n";
		}

		if (!editable) {
			s+="   <param name=\""+Tr.getTr(data.isEditable)+"\" value=\"no\">\n";
		}
		if (hasSound) {
			s+="   <param name=\""+Tr.getTr(data.useSound)+"\" value=\""+Tr.getTr(data.Yes)+"\">\n";
		}
		if (hasAlgebra) {
			s+="   <param name=\""+Tr.getTr(data.useAlgebra)+"\" value=\""+Tr.getTr(data.Yes)+"\">\n";
		}
		if (useRAD) {
			s+="   <param name=\""+Tr.getTr(data.useRAD)+"\" value=\""+Tr.getTr(data.Yes)+"\">\n";
		}
		s+="   <param name=\"decimal_symbol\" value=\""+BasicStr.decimal_symbol+"\">\n";
		if (BasicStr.antialias) {
			s+="   <param name=\"antialias\" value=\""+Tr.getTr(data.Yes)+"\">\n";
		} else {
			s+="   <param name=\"antialias\" value=\""+Tr.getTr(data.No)+"\">\n";
		}
		if (!undo_active) {
			s+="   <param name=\""+Tr.getTr(data.undo)+"\" value=\"no\">\n";
		}
		if (BasicStr.hasContent(nom)) {
			s+="   <param name=\""+Tr.getTr(data.name)+"\" value=\""+nom+"\">\n";
		}
		if (pop) {
			s+="   <param name=\""+Tr.getTr(data.pop)+"\" value=\"width="+s_width+" height="+s_height+"\">\n";
		}
		if (BasicStr.hasContent(course)) {
			s+="   <param name=\""+Tr.getTr(data.course)+"\" value=\""+course+"\">\n";
			s+="   <param name=\""+Tr.getTr(data.unit)+"\" value=\""+unit+"\">\n";
		}
		if (BasicStr.hasContent(txt_infoind)) {
			s+="   <param name=\"infoind\" value=\""+txt_infoind+"\">\n";
		}
		if (BasicStr.hasContent(txt_infoest)) {
			s+="   <param name=\"infoest\" value=\""+txt_infoest+"\">\n";
		}
		for (int j=0;j<aa.length;j++) {
			if (j>0 || !Tr.equals(aa[j].name,data.name)) {
				s+="   <param name=\""+aa[j].name+"\" value=\""+aa[j].value+"\">\n";
			}
		}

		s+="_no_Java_";

		s=s+"</applet>";
//		if (codify) {
//			return mjaHtml.getHTMLEncoding(s);
//		} else {
			return s;
//		}
	}

	private void showAppletText() {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		if (coed==null) {
			coed=new codeEdit(this,TA);
			// construct codeP
			Panel codeP=new Panel();
			codeP.setBackground(Color.lightGray);
			codeP.setLayout(new BorderLayout());
			Panel NP=new Panel();
			NP.setBackground(Color.lightGray);
			NP.setLayout(new GridLayout(2,1));
			NP.add(mjaLayout.pair(mjaLayout.pair(pr_Code[ix_n],pr_Code[ix_cb]),mjaLayout.pair(pr_Code[ix_w],pr_Code[ix_h])));
			NP.add(mjaLayout.pair(9,1,mjaLayout.pair(mjaLayout.pair(pr_Code[ix_co],pr_Code[ix_pop]),mjaLayout.pair(pr_Code[ix_bw],pr_Code[ix_bh])),b_apply));
			codeP.add("North",NP);
			Panel SP=mjaLayout.pair(0.1,0.9,pr_lms,mjaLayout.pair(pr_course,pr_unit));
			codeP.add("South",SP);

			Panel TAP=new Panel();
			codeP.add("Center",TAP);
			TAP.setLayout(new BorderLayout());
			TAP.add("Center",TA);
			TAP.add("South",albl);
			coed.add("Center",codeP);
			coed.pack();
			coed.center();
			coed.setTitle(pr_Code[ix_n].getInfo(D.Tr).trim());
		} else {
			coed.setVisible(false);
		}
		coed.setVisible(true);
		coed.toFront();
		coed.selectAll();
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	}


/* ----------------------------- macro Text --------------------------- */

	private static String toMacroString(Descartes D) {
		return toMacroString(D.Tr,D,D.cfg.toAppletParams(D.Tr));
	}
	private static String toMacroString(translator Tr,Applet A,Attribute[] aa) {
		return toMacroString(Tr,aa,BasicStr.getReducedCodeBase(A),
			Integer.toString(A.getSize().width),Integer.toString(A.getSize().height));
	}

	private static String toMacroString(translator Tr,Attribute[] aa,String codebase,String s_width,String s_height) {
		// falta mejorar la forma de decidir el tipo de macro: R2 o R3
		String s=Tr.getTr(data.macrotype)+"=";
		boolean isR3=macroIsR3(Tr,aa);
		if (isR3) {
			s+="R3\n";
		} else {
			s+="R2\n";
		}
		s+=Tr.getTr(data.p_language)+"="+Tr.getTr(data.langName)+"\n";
		for (int j=0;j<aa.length;j++) {
			if (aa[j].name.startsWith("A")) {
				s+=aa[j].value+"\n";
			} else if (((!isR3) && aa[j].name.startsWith("G"))||(isR3 && aa[j].name.startsWith("S"))) {
				Attribute[] bb=Attribute.parse(aa[j].value);
				for (int k=0;k<bb.length;k++) {
					if (!Tr.equals(bb[k].name,data.space)) {
						s+=bb[k].name+"='"+bb[k].value+"' ";
					}
				}
				s+="\n";
			}
		}
		return s;
//		return mjaHtml.getHTMLEncoding(s);
	}
	private boolean macroIsR3() {
		return macroIsR3(D.Tr,D.cfg.toAppletParams(D.Tr));
	}
	private static boolean macroIsR3(translator Tr,Attribute[] aa) {
		boolean isR3=false;
		for (int j=0;j<aa.length;j++) {
			if (aa[j].name.startsWith("E")) {
				Attribute[] bb=Attribute.parse(aa[j].value);
				for (int k=0;k<bb.length;k++) {
					if (bb[k].name.equals("R3")) {
						isR3=Tr.isTrue(bb[k].value);
						break;
					}
				}
				break;
			}
		}
		return isR3;
	}

	private void showMacroText() {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		TA_m.setText(toMacroString(D));
		if (coed_m==null) {
			coed_m=new codeEdit(this,TA_m);
			coed_m.add("North",new Label("Macro"));
			coed_m.add("Center",TA_m);
			coed_m.add("South",mlbl);
			coed_m.pack();
			coed_m.center();
		} else {
			coed_m.setVisible(false);
		}
		String s=mlbl.getText();
		if (macroIsR3()) {
			s=BasicStr.replace(s,"g2d","g3d");
		} else {
			s=BasicStr.replace(s,"g3d","g2d");
		}
		mlbl.setText(s);
		coed_m.setTitle(pr_Code[ix_n].getInfo(D.Tr).trim());
		coed_m.setVisible(true);
		coed_m.toFront();
		coed_m.selectAll();
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	}

/* ------------------------------------------------------------------- */

	protected void getInfo() {
		for (int i=0;i<D.cfg.buttonVisible.length;i++) {
			D.cfg.buttonVisible[i]=chkbx[i].getState();
		}
		D.cfg.txt_infoind=p_infoind.getInfo(D.Tr);
		D.cfg.txt_infoest=p_infoest.getInfo(D.Tr);
		BasicStr.decimal_symbol=p_decsymb.getInfo(D.Tr);
		BasicStr.antialias=p_antialias.isSelected();
		D.cfg.rows_north=BasicStr.parseInteger(rowsNorth.getInfo(D.Tr),0,0);
		D.cfg.rows_south=BasicStr.parseInteger(rowsSouth.getInfo(D.Tr),0,0);
		D.cfg.width_east=BasicStr.parseInteger(widthEast.getInfo(D.Tr),0,0);
		D.cfg.width_west=BasicStr.parseInteger(widthWest.getInfo(D.Tr),0,0);
		D.cfg.rows_height=BasicStr.parseInteger(rowsHeight.getInfo(D.Tr),23,23);
		D.cfg.language=D.Tr.getActiveLanguage();
		D.cfg.isEditable=chkbxE.isSelected();
		D.cfg.useSound=chkbxS.isSelected();
		D.cfg.useAlgebra=chkbxA.isSelected();
		D.cfg.useRAD=chkbxR.isSelected();
		
		editObject[] eoa=CtrlEL.getInfo();
		D.cfg.cc=new controlConfig[eoa.length];
		for (int i=0;i<eoa.length;i++) {
			D.cfg.cc[i]=(controlConfig)eoa[i];
		}
		
		
//		eoa=AuxsEL.getInfo();
//		D.cfg.auxiliar=new auxConfig[eoa.length];
//		for (int i=0;i<eoa.length;i++) {
//			D.cfg.auxiliar[i]=(auxConfig)eoa[i];
//		}
		
		editObject[] eoa2 = AuxsEL.getInfo();
		editObject[] eoa1 = DefEL.getInfo();
		D.cfg.auxiliar = new auxConfig[eoa1.length+eoa2.length];
		Vector<editObject> tmpList = new Vector<editObject>();
		for (int i=0;i<eoa1.length;i++) {
			tmpList.add(eoa1[i]);
		}
		for (int i=0;i<eoa2.length;i++) {
			tmpList.add(eoa2[i]);
		}
		D.cfg.auxiliar = tmpList.toArray(D.cfg.auxiliar);
		
		for (int i = 0; i < D.cfg.gR2c.length; i++) {
			graphR2Config tmp = D.cfg.gR2c[i];
			if(!(tmp instanceof Graph2DEditObject))
				D.cfg.gR2c[i] = (graphR2Config) this.egP.newObject(D.Tr, tmp.toString(" ", D.Tr));
		}

		
		eoa=SpceEL.getInfo();
		D.cfg.sc=new spaceConfig[eoa.length];
		for (int i=0;i<eoa.length;i++) {
			D.cfg.sc[i]=(spaceConfig)eoa[i];
		}
		eoa=GrR2EL.getInfo();
		D.cfg.gR2c=new graphR2Config[eoa.length];
		for (int i=0;i<eoa.length;i++) {
			D.cfg.gR2c[i]=(graphR2Config)eoa[i];
		}
		eoa=GrR3EL.getInfo();
		D.cfg.gR3c=new graphR3Config[eoa.length];
		for (int i=0;i<eoa.length;i++) {
			D.cfg.gR3c[i]=(graphR3Config)eoa[i];
		}
		D.cfg.animC=(animConfig) eanimP.getInfo();
		D.cfg.animC.active=chb_anim.getState();
		D.cfg.applyMacros();
		D.cfg.useLMS=D.Tr.isTrue(pr_lms.getInfo(D.Tr));
		D.cfg.course="";
		if (D.cfg.useLMS) {
			D.cfg.course=pr_course.getInfo(D.Tr).trim();
		}
		D.cfg.unit=pr_unit.getInfo(D.Tr).trim();
		updateVisibility();
	}

	private void updateAppletStrings(boolean cfgstr) {
		TA_m.setText(toMacroString(D));
		String htmlcode=getModifiedCode(D,false);
		TA.setText(htmlcode);
		if (cfgstr) {
			D.cfg.s_applet=htmlcode;
		}
	}

	protected void setLabels() {
		setTitle(titleBase+pr_Code[ix_n].getInfo(D.Tr).trim());

		pr_Code[ix_co].setLabel(D.Tr.getTr(data.HTMLencoding));
		pr_Code[ix_pop].setLabel(D.Tr.getTr(data.pop));

		for (int i=0;i<chbp_ix.length;i++) {
			chbp[i].setLabel(D.Tr.getTr(chbp_ix[i]));
		}
		chbp[3].setLabel("Definiciones"); // Ojo: Poner en data y en resources/idiomas/*.txt
		chbp[4].setLabel("Programa");
		for (int i=0;i<chkbx_ix.length;i++) {
			chkbx[i].setLabel(D.Tr.getTr(chkbx_ix[i]));
		}
/*		
		rowsNorth.setExplanation(Expl.get(Expl.Buttons[4],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		rowsSouth.setExplanation(Expl.get(Expl.Buttons[5],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		widthEast.setExplanation(Expl.get(Expl.Buttons[6],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		widthWest.setExplanation(Expl.get(Expl.Buttons[7],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		rowsHeight.setExplanation(Expl.get(Expl.Buttons[8],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		chkbxE.setExplanation(Expl.get(Expl.Buttons[9],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		chkbxS.setExplanation(Expl.get(Expl.Buttons[10],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		chkbxA.setExplanation(Expl.get(Expl.Buttons[11],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		chkbxR.setExplanation(Expl.get(Expl.Buttons[12],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		p_infoind.setExplanation(Expl.get(Expl.Buttons[13],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		p_infoest.setExplanation(Expl.get(Expl.Buttons[14],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		p_decsymb.setExplanation(Expl.get(Expl.Buttons[15],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
		p_antialias.setExplanation(Expl.get(Expl.Buttons[16],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
*/
		p_infoind.setLabel(D.Tr.getTr(data.infoind));
		p_infoest.setLabel(D.Tr.getTr(data.infoest));
		p_decsymb.setLabel(D.Tr.getTr(data.decsymb));
		setLabels(D.Tr.getTr(data.accept),D.Tr.getTr(data.close),D.Tr.getTr(data.apply));
		chl.removeItemListener(this);
		chl.removeAll();
		for (int i=0;i<data.numLang ;i++) {
			chl.addItem(D.Tr.getLanguageName(i));
		}
		chl.select(D.Tr.getTr(data.langName));
		chl.addItemListener(this);
		for (int i=0;i<b_.length;i++) {
			b_[i].setLabel(D.Tr.getTr(b_ix[i]));
		}
		String oklbl=D.Tr.getTr(data.accept);
		String calbl=D.Tr.getTr(data.cancel);
		String aplbl=D.Tr.getTr(data.apply);
		
		for (int i = 0; i < EP.length; i++) {
			if(EP[i]!= null && EP[i].eL != null)
				EP[i].eL.setLabels(oklbl,calbl,aplbl);
		}
		
		chb_anim.setLabel(D.Tr.getTr(data.p_anim));
		b_apply.setLabel(D.Tr.getTr(data.apply));

		pr_lms.setLabel("LMS");
		pr_course.setLabel(D.Tr.getTr(data.course));
		pr_unit.setLabel(D.Tr.getTr(data.unit));
		pr_Code[ix_n].setLabel(D.Tr.getTr(data.name));
		pr_Code[ix_co].setLabel(D.Tr.getTr(data.HTMLencoding));
		pr_Code[ix_pop].setLabel(D.Tr.getTr(data.pop));
//		pr_course.setExplanation(Expl.get(Expl.Course,D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
//		pr_unit.setExplanation(Expl.get(Expl.Unit,D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
//		for (int i=0;i<pr_Code.length;i++) {
//			pr_Code[i].setExplanation(Expl.get(Expl.Code[i],D.Tr.getActiveLanguage()),D.Tr.getTr(data.rightClick));
//		}
	}
	
	void updateVisibility() {
		if (D.cfg.hasR2()) {
			chbp[GR2D_P].setVisible(true);
		} else {
			chbp[GR2D_P].setVisible(false);
		}
		if (D.cfg.hasR3()) {
			chbp[GR3D_P].setVisible(true);
		} else {
			chbp[GR3D_P].setVisible(false);
		}
	}
	
	protected void setOnlyInfo() {
		chl.select(D.cfg.language);
		chkbx[0].setState(D.cfg.buttonVisible[0]);
		chkbx[1].setState(D.cfg.buttonVisible[1]);
		chkbx[2].setState(D.cfg.buttonVisible[2]);
		chkbx[3].setState(D.cfg.buttonVisible[3]);
		chkbxE.setState(D.cfg.isEditable);
		chkbxS.setState(D.cfg.useSound);
		chkbxA.setState(D.cfg.useAlgebra);
		chkbxR.setState(D.cfg.useRAD);
		p_infoind.setInfo(D.cfg.txt_infoind);
		p_infoest.setInfo(D.cfg.txt_infoest);
		p_decsymb.setInfo(BasicStr.decimal_symbol);
		p_antialias.setState(BasicStr.antialias);
		rowsNorth.setInfo(D.Tr.getTr(data.rows_north),Integer.toString(D.cfg.rows_north));
		rowsSouth.setInfo(D.Tr.getTr(data.rows_south),Integer.toString(D.cfg.rows_south));
		widthEast.setInfo(D.Tr.getTr(data.width_east),Integer.toString(D.cfg.width_east));
		widthWest.setInfo(D.Tr.getTr(data.width_west),Integer.toString(D.cfg.width_west));
		rowsHeight.setInfo(D.Tr.getTr(data.alto),Integer.toString(D.cfg.rows_height));
		

		Vector<auxConfig> definiciones = new Vector<auxConfig>();
		Vector<auxConfig> programa = new Vector<auxConfig>();
		for (int i = 0; i < D.cfg.auxiliar.length; i++) {
			auxConfig cfg = D.cfg.auxiliar[i];
			
			switch (cfg.type) {
			case data.var:
			case data.func:
			case data.sequence:
			case data.matrix:
			case data.array:
				definiciones.add(cfg);
				break;

			case data.constant:
			case data.alg:
			case data.event:
				programa.add(cfg);
				break;

			default:
				definiciones.add(cfg);
				System.out.println("Tipo de auxiliar no identificado "+cfg.type);
//				System.out.println("Tipo de auxiliar no identificado "+cfg.getType(this.D.Tr, cfg.type));
			}
		}


		
		SpceEL.setInfo(D.Tr,D.cfg.sc);
		CtrlEL.setInfo(D.Tr,D.cfg.cc);
		DefEL.setInfo(D.Tr,definiciones.toArray(new auxConfig[definiciones.size()]));
		AuxsEL.setInfo(D.Tr,programa.toArray(new auxConfig[programa.size()])); //Sobre escribimos lo que hay en auxiliares que ahora es programa
//		AuxsEL.setInfo(D.Tr,D.cfg.auxiliar);
		GrR2EL.setInfo(D.Tr,D.cfg.gR2c);
		GrR3EL.setInfo(D.Tr,D.cfg.gR3c);
		eanimP.setInfo(D.Tr,D.cfg.animC);
		
		chb_anim.setState(D.cfg.animC.active);
		editAnimEnable(chb_anim.getState());
		albl.setText(D.Tr.getTr(data.textapplet));
		mlbl.setText(D.Tr.getTr(data.textmacro));
		if (coed!=null) {
			String title=pr_Code[ix_n].getInfo(D.Tr).trim();
			if (D.Tr.isTrue(pr_lms.getInfo(D.Tr))) {
				if (BasicStr.hasContent(pr_unit.getInfo(D.Tr).trim())) {
					title=pr_unit.getInfo(D.Tr).trim()+"/"+title;
				}
				if (BasicStr.hasContent(pr_course.getInfo(D.Tr).trim())) {
					title=pr_course.getInfo(D.Tr).trim()+"/"+title;
				}
			}
			coed.setTitle(title);
		}
		if (undo.size()==0) {
			updateAppletStrings(true);
			if (chb_undo.getState()) {
				getInfo();
				config pcfg=D.cfg.cloneConfig();
				pcfg.applied=true;
				undo.addElement(pcfg);
				undo_ix=0;
			}
		}
		if (D.Tr.isTrue(pr_Code[ix_pop].getInfo(D.Tr))) {
			pr_Code[ix_bw].setEnabled(true);
			pr_Code[ix_bh].setEnabled(true);
		} else {
			pr_Code[ix_bw].setEnabled(false);
			pr_Code[ix_bh].setEnabled(false);
		}
	}

	public void setInfo() {
		setLabels();
		setOnlyInfo();
	}

	private void editAnimEnable(boolean v) {
		eanimP.setEnabled(v);
	}

	private void pushConfig(boolean apply) {
		if (apply || chb_undo.getState()) {
			D.cfg=new config(D);
			getInfo();
			updateAppletStrings(true);
			D.cfg.applied=apply;
			if (chb_undo.getState()) {
				config pcfg=(config) undo.elementAt(undo_ix);
				if (!pcfg.s_applet.equals(D.cfg.s_applet)) {
					if (undo.size()>undo_ix+1) {
						undo.setSize(undo_ix+1);
					}
					undo.addElement(D.cfg);
					undo_ix=undo.size()-1;
					b_[ix_undo].setEnabled(undo_ix>0);
					b_[ix_redo].setEnabled(undo_ix+1<undo.size());
				} else if (apply) {
					pcfg.applied=apply;
				}
			}
		}
	}

	private void popConfig() {
		b_[ix_undo].setEnabled(undo_ix>0);
		b_[ix_redo].setEnabled(undo_ix+1<undo.size());
		if (0<=undo_ix && undo_ix<undo.size()) {
			D.cfg=((config) undo.elementAt(undo_ix)).cloneConfig();
			if (D.Tr.getActiveLanguage()!=D.cfg.language) {
				D.Tr.setActiveLanguage(D.cfg.language);
				setLabels();
			}
			setOnlyInfo();
			updateAppletStrings(false);
			if (D.cfg.applied) {
				D.restart(false);
			}
		}
	}

	void setCodeControlsFromParams() {
		pr_Code[ix_n].setInfo(D.Tr.getTr(data.name),copa.name);
		pr_Code[ix_cb].setInfo("codebase",copa.codebase);
		if (copa.codified) {
			pr_Code[ix_co].setInfo(D.Tr.getTr(data.HTMLencoding),"true");
		} else {
			pr_Code[ix_co].setInfo(D.Tr.getTr(data.HTMLencoding),"false");
		}
		pr_Code[ix_w].setInfo("width",String.valueOf(copa.dim.width));
		pr_Code[ix_h].setInfo("height",String.valueOf(copa.dim.height));
		pr_Code[ix_bw].setInfo("b_width",String.valueOf(copa.dimb.width));
		pr_Code[ix_bh].setInfo("b_height",String.valueOf(copa.dimb.height));
		chPop.setState(copa.popUp);
		if (copa.tolms) {
			pr_lms.setInfo("LMS","true");
			pr_course.setInfo(copa.course);
			pr_unit.setInfo(copa.unit);
		} else {
			pr_lms.setInfo("LMS","false");
			pr_course.setInfo("");
			pr_unit.setInfo("");
		}
	}
	
	private void getCodeParamsFromControls() {
		try {
			copa.name=pr_Code[ix_n].getInfo(D.Tr);
			copa.codebase=pr_Code[ix_cb].getInfo(D.Tr);
			copa.codified=D.Tr.isTrue(pr_Code[ix_co].getInfo(D.Tr));
			copa.popUp=chPop.getState();
			copa.tolms=D.Tr.isTrue(pr_lms.getInfo(D.Tr));
			copa.course="";
			if (copa.tolms) {
				copa.course=pr_course.getInfo(D.Tr).trim();
			}
			copa.unit=pr_unit.getInfo(D.Tr).trim();
			copa.dim.width=Integer.parseInt(pr_Code[ix_w].getInfo(D.Tr).trim());
			copa.dim.height=Integer.parseInt(pr_Code[ix_h].getInfo(D.Tr).trim());
			copa.dimb.width=Integer.parseInt(pr_Code[ix_bw].getInfo(D.Tr).trim());
			copa.dimb.height=Integer.parseInt(pr_Code[ix_bh].getInfo(D.Tr).trim());
		} catch (NumberFormatException nfe) {
		}
	}

	public Dimension getProposedDimension() {
		if (copa.popUp) {
			return copa.dimb;
		} else {
			return copa.dim;
		}
	}

	public Dimension getProposedSceneSize() {
		return copa.dim;
	}

	public String getProposedName() {
		return copa.name;
	}
/* ------------------- interface implementation ------------------ */

	public void closingAction(boolean close,boolean apply) {
		setCursor(new Cursor(Cursor.WAIT_CURSOR));
		pushConfig(apply);
		if (apply) {
			Dimension d0=D.getRealSize();
			Dimension d=D.proposedDimension();
			if ( D.inWeb() || (d0.width==d.width && d0.height==d.height)) {
				D.restart(close);
			}
			if (close) {
				D.configApplied();
			}
		}
		setCursor(null);
	}

/* ------------------- Action Listener ------------------ */

	public void actionPerformed(ActionEvent e) {
		if (!mch.isHand()) {
//			mch.setWait();
			pushConfig(false);
			if (e.getSource() instanceof editList) {
				// break;
			} else if (e.getSource()==b_[ix_original]) {
				undo_ix=0;
				popConfig();
			} else if (e.getSource()==b_[ix_redo]) {
				undo_ix++;
				popConfig();
			} else if (e.getSource()==b_[ix_undo]) {
				undo_ix--;
				popConfig();
			} else if (e.getSource()==b_[ix_new]) {
				D.cfg=new config(D);
				setInfo();
				pushConfig(false);
			} else if (e.getSource()==b_[ix_applet]) {
				showAppletText();
			} else if (e.getSource()==b_[ix_macro]) {
				showMacroText();
			} else if (e.getSource()==b_[ix_help]) {
//				b_[ix_help].setCursor(new Cursor(Cursor.WAIT_CURSOR));
//				setCursor(new Cursor(Cursor.WAIT_CURSOR));
//				D.setCursor(new Cursor(Cursor.WAIT_CURSOR));
//				Expl.init(D,true);
//				setAllExplanations();
//				D.setCursor(null);
//				setCursor(null);
//				b_[ix_help].setCursor(null);
//				mch.setHand();
				mjaText.msg((Component) b_[ix_help],"smbolo especial",Expl.get(Expl.Help,D.Tr.getActiveLanguage()),mjaFont.AWTMonoB);
				return;
			} else if (e.getSource()==b_apply) {
				getCodeParamsFromControls();
				D.setCodeBase(copa.codebase);
				updateAppletStrings(false);
				coed.selectAll();
/*
				try {
					Clipboard c=getToolkit().getSystemClipboard();
					StringSelection ss=new StringSelection(TA.getText());
					c.setContents(ss,ss);
					Transferable t=c.getContents(this);
					System.out.println((String)t.getTransferData(DataFlavor.stringFlavor));
				} catch (Exception ex) {
					System.out.println(ex);
				}
*/
			} else if (e.getSource()==p_infoind) {
				editRTF(p_infoind);
			} else if (e.getSource()==p_infoest) {
				editRTF(p_infoest);
			} else if (e.getSource()==p_decsymb) {
				editRTF(p_decsymb);
			} else if (e.getSource()==p_antialias) {
				editRTF(p_antialias);
			}
			mch.setNull();
		}
	}
	
	private void editRTF(mjaPair p_info) {
		editRTFDialog ertfd=new editRTFDialog(this,D,true,"","");
		ertfd.setTitle("inoind");
		ertfd.setLabels(D.Tr.getTr(data.accept),D.Tr.getTr(data.cancel));
		ertfd.setSelectedFont(mjaFont.makeFont("SansSerif",Font.PLAIN,16));
		ertfd.setSelectedColor(new mjaColor(Color.black));
		String parentSpace=null;
		ertfd.setExprDefaults(2,false,D.Tr.getActiveLanguage());
		ertfd.setText(p_info.getInfo(D.Tr));
		ertfd.display();
		if (ertfd.ok) {
			p_info.setInfo(ertfd.getText());
		}
		ertfd.dispose();
		ertfd=null;
		D.cleanMem(false);
	}
	
/* ------------------- Item Listener ------------------ */

	public void itemStateChanged(ItemEvent e) {
		if (mch.isHand() && e.getSource() instanceof Checkbox) {
			Checkbox chb=(Checkbox) e.getSource();
			chb.setState(!chb.getState());
		}
		if (!mch.isHand()) {
			mch.setWait();
			if (e.getSource()==chl && e.getStateChange()==e.SELECTED) {
				pushConfig(false);
				setVisible(false);
				D.cfg.language=chl.getSelectedIndex();
				D.Tr.setActiveLanguage(D.cfg.language);
				setInfo();
				setVisible(true);
				pushConfig(false);
			} else if (e.getSource()==chb_undo) {
				pushConfig(false);
				b_[ix_undo].setEnabled(chb_undo.getState()&&undo_ix>0);
				b_[ix_redo].setEnabled(chb_undo.getState()&&undo_ix+1<undo.size());
				D.undo_active=chb_undo.getState();
				updateAppletStrings(false);
			} else if (e.getSource()==chb_anim) {
				pushConfig(false);
				editAnimEnable(chb_anim.getState());
			} else if (e.getSource()==chPop) {
				if (chPop.getState()) {
					pr_Code[ix_bw].setEnabled(true);
					pr_Code[ix_bh].setEnabled(true);
				} else {
					pr_Code[ix_bw].setEnabled(false);
					pr_Code[ix_bh].setEnabled(false);
				}
			} else {
				for (int i=0;i<chbp.length;i++) {
					if (chbp[i].getState()) {
						pushConfig(false);
						if (EP[i]!=null) {
							EP[i].reset();
						}
						cL.show(CP,CPid[i]);
						break;
					}
				}
			}
			mch.setNull();
		}
	}

	protected void selectPanel(int i) {
		chbp[i].setState(true);
		pushConfig(false);
		if (EP[i]!=null) {
			EP[i].reset();
		}
		cL.show(CP,CPid[i]);
	}

/* ---------------- Explainer ------------- */

	public String getExplLabel(MouseEvent e) {
		String label="";
		Component c=(Component) e.getSource();
		if (c instanceof Button) {
			Button b=(Button) c;
			label=b.getLabel();
		} else if (c instanceof Checkbox) {
			if (c==chb_undo) {
				label="undo-activate";
			} else if (c==chb_anim) {
				label=D.Tr.getTr(data.anim);
			} else {
				for (int i=0;i<chkbx.length;i++) {
					if (c==chkbx[i]) {
						label=chkbx[i].getLabel();
						break;
					}
				}
				for (int i=0;i<chbp.length;i++) {
					if (c==chbp[i]) {
						label=chbp[i].getLabel();
						break;
					}
				}
			}
		} else if (c==chl) {
			label="language-select";
		}
		return label;
	}

	public String getExplanation(MouseEvent e) {
		Expl.init(D,true);
		setAllExplanations();
		String[] sa=null;
		Component c=(Component) e.getSource();
		if (c instanceof JButton || c instanceof Button ) {
			Button b=(Button) c;
			if (b==b_apply) {
				sa=Expl.Code[8];
			} else {
				for (int i=0;i<b_.length;i++) {
					if (b==b_[i]) {
						sa=Expl.Edit[2+i];
						break;
					}
				}
			}
		} else if (c instanceof Checkbox) {
			if (c==chb_undo) {
				sa=Expl.Edit[1];
			} else if (c==chb_anim) {
				sa=Expl.Animation;
			} else {
				for (int i=0;i<chkbx.length;i++) {
					if (c==chkbx[i]) {
						sa=Expl.Buttons[i];
						break;
					}
				}
				for (int i=0;i<chbp.length;i++) {
					if (c==chbp[i]) {
						sa=Expl.Panels[i];
						break;
					}
				}
			}
		} else if (c==chl) {
			sa=Expl.Edit[0];
		}
		return Expl.get(sa,D.Tr.getActiveLanguage());
	}

}

class codeEdit extends Frame implements WindowListener {

	private TextArea TA;
	private configEdit ce;
	codeEdit(configEdit ce,TextArea TA) {
		this.ce=ce;
		this.TA=TA;
		setBackground(Color.lightGray);
		setLayout(new BorderLayout());
	}

	public void setTitle(String t) {
		super.setTitle("Applet Descartes "+t);
		addWindowListener(this);
	}

	void selectAll() {
		TA.setSelectionStart(0);
		TA.setSelectionEnd(TA.getText().length());
		TA.requestFocus();
	}

	void center() {
		Toolkit tk=Toolkit.getDefaultToolkit();
		int W=tk.getScreenSize().width;
		int H=tk.getScreenSize().height;
		int w=getSize().width;
		int h=getSize().height;
		setLocation((W-w)/2,(H-h)/2);
	}

	public void windowClosing(WindowEvent e){
		ce.setCodeControlsFromParams();
		setVisible(false);
	}
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){
    	selectAll();
    }
    public void windowDeactivated(WindowEvent e){
    }
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){
    	selectAll();
    }
    public void windowClosed(WindowEvent e){}

}

class codeParams {

	String name,codebase,course,unit;
	Dimension dim,dimb;
	boolean codified=true,popUp,tolms;

}