package com.mja.descedit.descartesJS;

import java.awt.Component;
import java.util.BitSet;

import org.unam.matem.Attribute;

import com.mja.descartes.Descartes;
import com.mja.descartes.auxConfig;
import com.mja.descedit.auxEP;
import com.mja.descedit.configEdit;
import com.mja.descedit.editPanel;
import com.mja.descgui.edit.editField;
import com.mja.descgui.edit.editObject;
import com.mja.descgui.edit.editObjectType;
import com.mja.lang.data;
import com.mja.lang.translator;
//import com.sun.xml.internal.bind.v2.runtime.unmarshaller.IntArrayData;

public class DefinitionEditorPane extends auxEP {
	private static final long serialVersionUID = -3546562749599195186L;

	public DefinitionEditorPane(Descartes D, configEdit parent, Component C) {
		super(D, parent, C);
	}

	public editObject newObject(String stype, String svalue) {
		return new DefinitionEditObject(this.D.Tr, stype, svalue);
	}

	
	public editObject newObject(translator Tr, String svalue) {
		return new DefinitionEditObject(Tr,Attribute.parse(svalue));
	}
	
	class DefinitionEditObject extends auxConfig {
		//private final int[] auxix = {data.var,data.array,data.matrix,data.func,data.sequence};
		//private String[] defaultExpresion = {"v?","V?","M?","f?","s?"};
		private final int[] auxix = {data.var,data.func,data.array,data.matrix};
		private String[] defaultExpresion = {"v?","f?","V?","M?"};
		
		public DefinitionEditObject(translator Tr, String stype, String svalue) {
			super(Tr, stype, svalue);
			overwriteCfg();
		}

		public DefinitionEditObject(translator tr, Attribute[] parse) {
			super(tr, parse);
			overwriteCfg();
		}

		
		@Override
		public void updateInfo(translator Tr) {
			super.updateInfo(Tr);
			
		}

		private void overwriteCfg(){
			editField tmpF = field[ixeval];
			tmpF.chvalues = new int[]{data.once};
			tmpF.def_val = "once";
			tmpF.null_val = "once";

			editObjectType[] tmpEOT = this.eot;
			this.eot = new editObjectType[auxix.length];
			//{data.var,data.constant,data.array,data.matrix,data.func,data.sequence,data.alg,data.event};
			int idx = 0;//variables
			int idxNew = 0;
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,(BitSet) tmpEOT[idx].attributes.clone()); 
			this.eot[idxNew].attributes.clear(auxConfig.ixeditable);

			idx = 4;  //funciones
			idxNew = 1;
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,(BitSet) tmpEOT[idx].attributes.clone());
//			this.eot[idxNew].attributes.clear(auxConfig.ixrange);
			
			idx = 2; //Arreglos
			idxNew = 2;
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,(BitSet) tmpEOT[idx].attributes.clone());
			
			idx = 3; //Matrices
			idxNew = 3;
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,(BitSet) tmpEOT[idx].attributes.clone());
//			this.eot[idxNew].attributes.clear(auxConfig.ixfile);
			
			/* No las tenemos aun en descartes bsico 
			idx = 5;  //sucesiones
			this.eot[4] = new editObjectType(tmpEOT[idx].defaultExpresion,(BitSet) tmpEOT[idx].attributes.clone());
			this.eot[4].attributes.clear(auxConfig.ixrange);
			*/
		}
		
		public int getNumTypes() {
			return defaultExpresion.length;
		}

		
		public String getType(translator Tr, int i) {
			return Tr.getTr(auxix[i]);
		}

		public String getDefaultExpresion(translator Tr, int i) {
			// TODO Auto-generated method stub
			return defaultExpresion[i];
		}
		
		public String getListTitle(translator Tr) {
			return "Definiciones";
		}

		
		public String getTypesInfo(translator Tr) {
			String res = Tr.getTr(data.auxiliary);
			return res;
		}
		
		public int getTypeIndex(translator Tr) {
			for (int i=0;i<auxix.length;i++) {
				if (type==auxix[i]) {
					return i;
				}
			}
			return 0;
		}

	}
}
