package com.mja.descedit.descartesJS;

import java.awt.Component;
import java.util.BitSet;

import org.unam.matem.Attribute;

import com.mja.descartes.Action;
import com.mja.descartes.Descartes;
import com.mja.descartes.auxConfig;
import com.mja.descedit.auxEP;
import com.mja.descedit.configEdit;
import com.mja.descedit.descartesJS.ControlsEditorPane.ControlEditObject;
import com.mja.descgui.edit.editField;
import com.mja.descgui.edit.editObject;
import com.mja.descgui.edit.editObjectType;
import com.mja.lang.data;
import com.mja.lang.translator;

public class ProgramEditorPane extends auxEP {
	private static final long serialVersionUID = -3546562749599195186L;

	public ProgramEditorPane(Descartes D, configEdit parent, Component C) {
		super(D, parent, C);
	}

	public void setInfo(translator Tr, editObject neO) {
		if(neO != null && !(neO instanceof ProgramEditObject))
			neO = newObject(Tr,neO.toString(" ", Tr)); 
		super.setInfo(Tr, neO);
	}
	
	public editObject newObject(String stype, String svalue) {
		return new ProgramEditObject(this.D.Tr, stype, svalue);
	}

	
	public editObject newObject(translator Tr, String svalue) {
		return new ProgramEditObject(Tr,Attribute.parse(svalue));
	}

	class ProgramEditObject extends auxConfig {
		private final int[] auxix = {data.constant,data.alg,data.event};
		private String[] defaultExpresion = {
				"c?","a?","e?"
		};
		public ProgramEditObject(translator Tr, String stype, String svalue) {
			super(Tr, stype, svalue);
			overwriteCFG();
		}

		public ProgramEditObject(translator tr, Attribute[] parse) {
			super(tr, parse);
			overwriteCFG();
		}

		private void overwriteCFG(){
			editObjectType[] tmpEOT = this.eot;
			
			
			
			field[this.ixaction].chvalues = new int[]{ data.empty, data.calculate, data.openURL, data.openScene, data.ini, data.clear,data.anim,data.initAnim,data.play};
			this.eot = new editObjectType[auxix.length];
			//{data.var,data.constant,data.array,data.matrix,data.func,data.sequence,data.alg,data.event};
			int idx = 1;//constantes
			this.eot[0] = new editObjectType(tmpEOT[idx].defaultExpresion,(BitSet) tmpEOT[idx].attributes.clone()); 
			
			idx = 6;  //algoritmos
			this.eot[1] = new editObjectType(tmpEOT[idx].defaultExpresion,(BitSet) tmpEOT[idx].attributes.clone());

			idx = 7;  //eventos
			this.eot[2] = new editObjectType(tmpEOT[idx].defaultExpresion,(BitSet) tmpEOT[idx].attributes.clone());
		}
		
		public int getNumTypes() {
			return defaultExpresion.length;
		}

		
		public String getType(translator Tr, int i) {
			return Tr.getTr(auxix[i]);
		}

		
		public String getDefaultExpresion(translator Tr, int i) {
			// TODO Auto-generated method stub
			return defaultExpresion[i];
		}

		
		public String getListTitle(translator Tr) {
			return "Programa";
		}

		
		public String getTypesInfo(translator Tr) {
			return Tr.getTr(data.event);
		}

		
		public int getTypeIndex(translator Tr) {
			for (int i=0;i<auxix.length;i++) {
				if (type==auxix[i]) {
					return i;
				}
			}
			return 0;
		}

	}
}
