package com.mja.descedit.descartesJS;

import java.awt.Component;
import java.util.BitSet;

import com.mja.descartes.Descartes;
import com.mja.descartes.spaceConfig;
import com.mja.descedit.configEdit;
import com.mja.descedit.spaceEP;
import com.mja.descgui.edit.editObject;
import com.mja.descgui.edit.editObjectType;
import com.mja.lang.data;
import com.mja.lang.translator;

public class SpaceEditorPane extends spaceEP {

	public SpaceEditorPane(Descartes D, configEdit parent, Component mch_c) {
		super(D, parent, mch_c);
	}
	public editObject newObject(String stype,String svalue) {
		return new Space2DEditObject(this.D.Tr,stype,svalue);
	}
	public editObject newObject(translator Tr,String svalue) {
		return new Space2DEditObject(Tr,svalue);
	}
	
	class Space2DEditObject extends spaceConfig {
		
		final String[] types={"R2","AP","HTMLIFrame"};
		private String[] defaultExpresion={
			"E?",  // R2
			"AP?",  // AP
			"HF?",  // HTMLIFrame
		};
		
		
		public Space2DEditObject(translator Tr, String stype, String svalue) {
			super(Tr, stype, svalue);
			overwriteCfg();
		}

		public Space2DEditObject(translator Tr,String svalue) {
			super(Tr, svalue);
			overwriteCfg();
		}

		private void overwriteCfg(){
			// R2->0 , R3->1, TA->2, GL->3, D3->4
			editObjectType[] tmpEOT = this.eot;
			this.eot = new editObjectType[types.length];
			
			int idx = 0;
			int idxNew = 0;
			BitSet tmpBitSet;

			idx = 0;
			idxNew = 0;
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			this.eot[idxNew].attributes.clear(Space2DEditObject.spaceID);
			this.eot[idxNew].attributes.clear(Space2DEditObject.ixmousem);
			this.eot[idxNew].attributes.clear(Space2DEditObject.x_ax);
			this.eot[idxNew].attributes.clear(Space2DEditObject.y_ax);

			idx = 3;
			idxNew = 1;
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
			this.eot[idxNew].attributes.clear(Space2DEditObject.spaceID);
			this.eot[idxNew].attributes.clear(Space2DEditObject.bgdisp);
			this.eot[idxNew].attributes.clear(Space2DEditObject.ixmousem);
			this.eot[idxNew].attributes.clear(Space2DEditObject.bgima);
			this.eot[idxNew].attributes.clear(Space2DEditObject.x_ax);
			this.eot[idxNew].attributes.clear(Space2DEditObject.y_ax);
			this.eot[idxNew].attributes.clear(Space2DEditObject.SpTyp);

			idx = 4;
			idxNew = 2;
			tmpBitSet = new BitSet(numFields);
			tmpBitSet.or(tmpEOT[idx].attributes);
			this.eot[idxNew] = new editObjectType(tmpEOT[idx].defaultExpresion,tmpBitSet);
//			this.eot[idxNew].attributes.clear(Space2DEditObject.spaceID);
//			this.eot[idxNew].attributes.clear(Space2DEditObject.bgdisp);
			this.eot[idxNew].attributes.clear(Space2DEditObject.ixmousem);
//			this.eot[idxNew].attributes.clear(Space2DEditObject.bgima);
			this.eot[idxNew].attributes.clear(Space2DEditObject.x_ax);
			this.eot[idxNew].attributes.clear(Space2DEditObject.y_ax);
			this.eot[idxNew].attributes.clear(Space2DEditObject.SpTyp);

		}
		
		public int getNumTypes() {
			return types.length;
		}
		public String getType(translator Tr,int i) {
			return types[i];
		}
		public String getDefaultExpresion(translator Tr,int i) {
			return defaultExpresion[i];
		}
		public int getTypeIndex(translator Tr) {
			String strType = s_value[SpTyp]; 
			if ("HTMLIFrame".equals(strType)) {
				return 2;
			} else if ("AP".equals(strType)) {
				return 1;
			} if ("R2".equals(strType)){
				return 0;
			} else {
				System.out.println("SpaceEditorPane.getTypeIndex WARNING : Unknow type: "+strType);
				return 0;
			}
		}
	}

}
