/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descedit;

/*------------------------------------------------------------*/
/*                          editList                          */
/*                          (c) MJA                           */
/*                       Febrero de 2001                      */
/*------------------------------------------------------------*/

import java.awt.*;
import java.awt.event.*;
import java.awt.datatransfer.*;
import java.util.Vector;
import java.util.Enumeration;
import java.applet.*;
import javax.swing.JComboBox;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.lang.*;
import com.mja.parser.*;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;

public class editList extends Panel implements ActionListener, ItemListener, MouseListener, Explainer, MouseMotionListener, KeyListener, Runnable  {

	public static final Color Color_1=new Color(0xc0c0c8);
	public static final Color Color_2=new Color(0x8888a0);

	translator Tr;
	protected editTextField eTF;

	protected Vector pV; 
//	private Vector selectionItems;
//	private Vector selectedItems;
	private editList SEL;
	protected Label tlbl;
	protected List pl;
	protected Button B_add,B_delete,B_duplicate;
	protected spinnerControl sc;
	protected editPanel eP;
	private int ix,idw;
	private editFrame ef;
	private TextArea TA;
	private com.mja.gui.MouseCursorHandler mch;
	private int selectionIndex=-1;
	private JComboBox jcbx;

	public editList(Component mch_c,int lh,int idw,editPanel eP,editTextField eTF) {
		this(mch_c,lh,idw,eP,eTF,-1);
	}

	public editList(Component mch_c,int lh,int idw,editPanel eP,editTextField eTF, int sIx) {
		mch=new com.mja.gui.MouseCursorHandler(mch_c,this);
		this.idw=idw;
		this.eP=eP;
		this.eTF=eTF;
		selectionIndex=sIx;
		setLayout(new BorderLayout());
		tlbl=new Label();
		tlbl.setFont(mjaFont.AWTSansSerif);
		tlbl.setAlignment(Label.CENTER);
		tlbl.setBackground(mjaColor.DeepBlue);
		tlbl.setForeground(Color.white);
		Panel WP=new Panel();
		WP.setBackground(Color_2);
		add("West",WP);
		WP=mjaGui.embedPanel(WP,5);
		WP.setLayout(new BorderLayout());
		WP.setFont(mjaFont.AWTSansSerif);
		WP.add("Center",pl=new List());
		pl.setBackground(mjaPair.mostlyWhite);
		Panel BP=new Panel();
		BP.setFont(mjaFont.AWTMono);
		BP.setLayout(new FlowLayout(FlowLayout.LEFT,0,0));
		BP.add(B_add=new Button("+"));
		BP.add(B_duplicate=new Button("*"));
		BP.add(sc=new spinnerControl(false));
		BP.add(B_delete=new Button("-"));
		jcbx = new JComboBox();
		jcbx.setFont(mjaFont.AWTSansSerif);
		if (selectionIndex>=0) {
			Panel NP=new Panel();
			NP.setLayout(new GridLayout(2,1));
			WP.add("North",NP);
			NP.add(jcbx);
			jcbx.addItemListener(this);
			NP.add(mjaLayout.pair(BP,tlbl));
		} else {
			WP.add("North",mjaLayout.pair(BP,tlbl));
		}
		eP.setBackground(Color_1);
		add("Center",eP);
		ef=new editFrame("title","ok","cancel","apply");
		ef.setSize(600,400);
		ef.add("Center",TA=new TextArea(20,120));
		TA.setFont(mjaFont.AWTMono);
		ef.addActionListener(this);

		B_add.addActionListener(this);
		B_duplicate.addActionListener(this);
		B_delete.addActionListener(this);
		B_add.addMouseListener(this);
		B_add.addMouseListener(mch);
		B_duplicate.addMouseListener(this);
		B_duplicate.addMouseListener(mch);
		B_delete.addMouseListener(this);
		B_delete.addMouseListener(mch);
		sc.addMouseListener(this);
		sc.addMouseListener(mch);
		sc.addMouseMotionListener(this);
		tlbl.addMouseListener(this);
		tlbl.addMouseListener(mch);
		pl.setFont(mjaFont.AWTMono);
		pl.addKeyListener(this);
		pl.addMouseListener(this);
		pl.addMouseListener(mch);
	}
	
	public void setSelectorEL(editList SEL) {
		this.SEL=SEL;
	}

	void editItem(int index) {}

	public void setTitle(String t) {
		tlbl.setText(t);
		ef.setTitle(t);
	}
	public void setLabels(String okLabel, String cancelLabel,String applyLabel) {
		ef.setLabels(okLabel,cancelLabel,applyLabel);
	}

	private String prepareItem(editObject eO) {
		return BasicStr.justify(eO.getId(),idw,' ');
	}

	public void addElement(editObject eo) {
		eo.updateInfo(Tr);
		pV.addElement(eo);
	}

	private void setInfo(String s) {
		String[] sa=BasicStr.toStringArray(s.trim());
		editObject[] eoa=new editObject[sa.length];
		for (int i=0;i<eoa.length;i++) {
			eoa[i]=eP.newObject(Tr,sa[i]);
		}
		setInfo(Tr,eoa);
	}

	public void setInfo(translator Tr,editObject[] pca) {
		this.Tr=Tr;
		eTF.removeTypes();
		editObject pc=eP.newObject(Tr,"");
		for (int i=0;i<pc.getNumTypes(); i++) {
			eTF.addType(pc.getType(Tr,i),pc.getDefaultExpresion(Tr,i));
		}
		setTitle(pc.getListTitle(Tr));
		eTF.setTitle(pc.getTypesTitle(Tr));
		eTF.setLabels(pc.getAcceptLabel(Tr),pc.getCancelLabel(Tr));
		eTF.setInfo(pc.getTypesInfo(Tr));

		pV=new Vector();
		if (pca!=null) {
			for (int i=0;i<pca.length;i++) {
				pca[i].translateValues(Tr);
				pca[i].updateInfo(Tr);
				pV.addElement(pca[i]);
			}
		}
		updateSelectorMenu();
		updateList();
		renewListSelection();
		eP.setVisible(pl.countItems()>0);
		eP.repaint();
	}
	
	private String SF;
	protected void setSelectorFilter(String SF) {
		this.SF=SF;
	}
	
	private int[] ixl;
	
	public void selectItem(editObject O) {
		setSelector("");
		for (int i=0;i<pV.size();i++) {
// corregir editObjects ... ??
			if (prepareItem(O).equals(prepareItem((editObject)pV.elementAt(i)))) {
				if (ix>=0) {
					updateList(ix,ix);
				}
				ix=i;
				pl.select(i);
				eP.setInfo(Tr,pV(i));
				break;
			}
		}
	}

	void updateSelectorMenu() {
		Object item=jcbx.getSelectedItem();
		jcbx.removeItemListener(this);
		jcbx.removeAllItems();
		jcbx.addItem("*");
		if (selectionIndex>=0) {
			Vector sV=SEL.pV;
			for (int i=0;i<sV.size();i++) {
				String strID=((editObject) sV.elementAt(i)).getId();
				if (strID.indexOf(SF)>=0) {
					String strName=((editObject) sV.elementAt(i)).getEditName();
					jcbx.addItem(strName);
				}
			}
		}
		if (item!=null) {
			jcbx.setSelectedItem(item);
		}
		jcbx.addItemListener(this);
		updateList();
	}
	
	void replaceSelected(editObject eO) {
		pV.setElementAt(eO,ixl[ix]);
		renewListSelection();
	}

	void updateList() {
		String selectedItem=(String) jcbx.getSelectedItem();
		pl.removeAll();
		for (int i=0;i<pV.size();i++) {
			editObject eo=(editObject) pV.elementAt(i);
		 	if (jcbx.getSelectedIndex()==0 || (selectionIndex>=0 && selectedItem.equals(eo.s_value[selectionIndex])) ) {
				pl.addItem(prepareItem(eo));
			}
		}
		int K=pl.countItems();
		if (ix>=K) {
			ix=K-1;
		}
		if (ix<0 && K>0) {
			ix=0;
		}
		if (ix>=0 && ix<K) {
			pl.select(ix);
		}
		ixl=new int[K];
		int k=0;
		for (int i=0;i<pV.size();i++) {
			editObject eo=(editObject) pV.elementAt(i);
		 	if (jcbx.getSelectedIndex()==0 || (selectionIndex>=0 && selectedItem.equals(eo.s_value[selectionIndex])) ) {
		 		ixl[k++]=i;
		 	}
		}
	}
	
	public void renewListSelection() {
		String selectedItem = (String) jcbx.getSelectedItem();
		updateList();
		if (pl.countItems()>0) {
			ix=pl.getSelectedIndex();
			eP.setInfo(Tr,pV(ixl[ix]));
		} else {
			eP.setInfo(Tr,null);
			ix=-1;
		}
		eP.setVisible(pl.countItems()>0);
		repaint();
	}

	public editObject[] getInfo() {
		updateList(ix,ix);
		editObject[] pca=new editObject[pV.size()];
		for (int i=0;i<pV.size();i++) {
			pca[i]=(editObject) pV.elementAt(i);
		}
		return pca;
	}

	private void updateList(int ix,int ixnew) {
		if (ix>=0 && ix<pl.countItems()) {
			editObject eo=eP.getInfo();
			pV.setElementAt(eo,ixl[ix]);
			if (!prepareItem(pV(ixl[ix])).equals(pl.getItem(ix))) {
				pl.replaceItem(prepareItem(pV(ixl[ix])),ix);
				pl.select(ixnew);
			}
		}
	}
	
	public Vector editObjects() {
		return pV;
	}

	private editObject pV(int i) {
		if (i>=0 && i<pV.size()) {
			return (editObject) pV.elementAt(i);
		} else {
			return null;
		}
	}

	boolean validNewName(boolean creating,String s) {
		if (BasicStr.hasContent(s)) {
			return true;
		} else {
			return false;
		}
	}

	protected editObject addnew(boolean duplicate) {
		editObject pc=null;
		eTF.setDefaultValue(pV.size()+1);
		boolean copy=duplicate&&(pV.size()>0);
		if (copy) {
			eTF.showTypes(false);
			pc=eP.getInfo();
			eTF.setValue(pc.getEditName());
		} else {
			eTF.showTypes(true);
		}
		boolean ok=true;
		if (!copy||eTF.showsValue()) {
			eTF.display();
			ok=eTF.ok;
		}
		if (ok) {
			if (!eTF.showsValue() || validNewName(true,eTF.getValue())) {
				if (ix>=0 && ix<pl.countItems()) {
					pV.setElementAt(eP.getInfo(),ixl[ix]);
				}
				if (copy) {
					pc.setEditName(eTF.getValue().trim());
					pc.updateInfo(Tr);
				} else {
					pc=eP.newObject(eTF.getTextFieldType(),eTF.getValue().trim());
					if (selectionIndex>=0) {
						pc.s_value[selectionIndex]=(String) jcbx.getSelectedItem();
					}
				}
				pV.addElement(pc);
				redoList();
			}
		}

		eP.setVisible(pl.countItems()>0);
		paintAll(getGraphics());
		return pc;
	}
	
	protected void redoList() {
		updateList();
		renewListSelection();
		select(pl.countItems()-1);
//		ix=pl.countItems()-1;
//		pl.select(ix);
//		eP.setInfo(Tr,pV(ixl[ix]));
//		eP.setVisible(pl.countItems()>0);
//		eP.repaint();
	}
	
	protected int countItems() {
		return pl.countItems();
	}
	
	protected void select(int IX) {
		ix=IX;
		pl.select(ix);
		eP.setInfo(Tr,pV(ixl[ix]));
		eP.setVisible(pl.countItems()>0);
		eP.repaint();
	}

	private void delete() {
		if (ix>=0) {
			if (mjaText.ask("Descartes"," Eliminar: "+ pl.getSelectedItem().trim() +" ?","si","no")) {
				String selectedItem = (String) jcbx.getSelectedItem();
				int tix=ix;
				pV.removeElementAt(ixl[ix]);
				ix=tix;
				if (ix>=pl.countItems()) {
					ix--;
				}
				renewListSelection();
				if (ix>=0) {
					pl.select(ix);
					eP.setInfo(Tr,pV(ixl[ix]));
					eP.setVisible(pl.countItems()>0);
					eP.repaint();
				}
			}
		}
	}

	private Vector listeners=new Vector();

	private void callListeners(String arg) {
		Enumeration e=listeners.elements();
		while (e.hasMoreElements()) {
			ActionListener al=(ActionListener)e.nextElement();
			al.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,arg));
		}
	}

	public void addActionListener(ActionListener al) {
		listeners.addElement(al);
	}

	public void removeActionListener(ActionListener al) {
		listeners.removeElement(al);
	}
	
	public void setSelector(String selectorName) {
		jcbx.setSelectedItem(selectorName);
//		updateList(ix,ix);
		renewListSelection();
	}

/* ------------------ ItemListener ------------------- */

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource()==jcbx) {
			updateList(ix,ix);
			renewListSelection();
		}
	}

/* ------------------ ActionListener ------------------- */

	public void actionPerformed(ActionEvent e) {
		if (!mch.isHand()) {
			mch.setWait();
			if (e.getSource()==B_add) {
				addnew(false);
			} else if (e.getSource()==B_duplicate) {
				addnew(true);
			} else if (e.getSource()==B_delete) {
				delete();
			} else if (e.getSource()==ef) {
				String ac=e.getActionCommand();
				boolean apply=(ac.charAt(1)=='T');
				if (apply) {
					setInfo(mjaHtml.decodeHTMLEncoding(TA.getText()));
				}
			}
			callListeners("");
			mch.setNull();
		}
	}

/* ------------------ MouseListener ------------------- */

	public void mousePressed(MouseEvent e) {
		stop();
		if (!mch.isHand() && e.getModifiers()==MouseEvent.BUTTON1_MASK) {
			if (e.getSource()==sc) {
				if (e.getY()<sc.getSize().height/2) {
					sc.up=true;
				} else {
					sc.down=true;
				}
				sc.repaint();
				thr=new Thread(this);
				stopRequested=false;
				thr.start();
			} else if (e.getSource()==tlbl) {
				editObject[] eoa=getInfo();
				String s="";
				for (int i=0;i<eoa.length;i++) {
					s+=eoa[i].toString(" ",Tr)+"\n";
				}
				TA.setText(s+" ");
				ef.display(true);
			}
		}
	}

	public void mouseReleased(MouseEvent e) {
		stopRequested=true;
		if (!mch.isHand() && e.getSource()==pl) {
			if (e.getModifiers()==MouseEvent.BUTTON3_MASK) {
				editItem(pl.getSelectedIndex());
			} else {
				int ixnew=pl.getSelectedIndex();
				if (ix!=ixnew) {
					updateList(ix,ixnew);
					ix=ixnew;
					eP.setInfo(Tr,pV(ixl[ix]));
					eP.setVisible(pl.countItems()>0);
					eP.repaint();
					callListeners("");
				}
			}
		}
	}

	public void mouseClicked(MouseEvent e) {
//		if (mch.isHand()) {
//			e.consume();
//		}
	}

//	private long T=0;
	public void mouseEntered(MouseEvent e) {
		stopRequested=true;
//		String tooltip=getExplanation(e);
//		if (BasicStr.hasContent(tooltip) && T<System.currentTimeMillis()-6000) {
//			mjaGui.showTooltip((Component)e.getSource(),tooltip,Tr.getTranslation(data.rightClick),mjaGui.Courier);
//			T=System.currentTimeMillis();
//		}
	}
	public void mouseExited(MouseEvent e) {
		stopRequested=true;
//		T=0;
	}
	public void mouseMoved(MouseEvent e) {
		stopRequested=true;
	}
	public void mouseDragged(MouseEvent e) {}

/* ------------------ Explainer ----------------- */

	public String getExplanation(MouseEvent e) {
		Component c=(Component) e.getSource();
		if (c!=pl) {
			int n=0;
			if (c==B_add) {
				n=0;
			} else if (c==B_duplicate) {
				n=1;
			} else if (c==B_delete) {
				n=2;
			} else if (c==tlbl) {
				n=3;
			} else if (c==sc) {
				n=4;
			}
			return Expl.get(Expl.List[n],Tr.getActiveLanguage());
		} else {
			return null;
		}
	}

	public String getExplLabel(MouseEvent e) {
		String label="";
		Component c=(Component) e.getSource();
		if (c==B_add) {
			label=B_add.getLabel();
		} else if (c==B_duplicate) {
			label=B_duplicate.getLabel();
		} else if (c==B_delete) {
			label=B_delete.getLabel();
		} else if (c==tlbl) {
			label=tlbl.getText();
		} else if (c==sc) {
			label="up-down";
		}
		return label;
	}

	/* -------------- Runnable ------------- */

	private Thread thr;
	private volatile boolean stopRequested;
	private boolean stop() {
		return stopRequested;
	}

	public synchronized void run() {
		long T=System.currentTimeMillis()+350;
		spinStep();
		while (!stop()) {
			while  (!stop() && System.currentTimeMillis()<T) {
				try {
					thr.sleep(20);
				}  catch (InterruptedException ie) {
					stopRequested=true;
				}
			}
			if (stop()) {
				break;
			}
			spinStep();
			try {
				thr.sleep(20);
			}  catch (InterruptedException ie) {
				stopRequested=true;
			}
			T=System.currentTimeMillis()+40;
		}
		sc.up=false;
		sc.down=false;
		sc.repaint();
		callListeners("");
		thr=null;
	}

	protected synchronized void spinStep() {
		if (ix>=0) {
			if (sc.up) {
				if (ix>0) {
					editObject pc=pV(ixl[ix]);
					pV.setElementAt(pV(ixl[ix-1]),ixl[ix]);
					pV.setElementAt(pc,ixl[ix-1]);
					pl.replaceItem(prepareItem(pV(ixl[ix-1])),ix-1);
					pl.replaceItem(prepareItem(pV(ixl[ix])),ix);
					ix--;
				}
			} else if (sc.down) {
				if (ix<pl.countItems()-1) {
					editObject pc=pV(ixl[ix]);
					pV.setElementAt(pV(ixl[ix+1]),ixl[ix]);
					pV.setElementAt(pc,ixl[ix+1]);
					pl.replaceItem(prepareItem(pV(ixl[ix])),ix);
					pl.replaceItem(prepareItem(pV(ixl[ix+1])),ix+1);
					ix++;
				}
			}
			pl.select(ix);
		}
		paintAll(getGraphics());
	}

	/* ------------------ KeyListener --------------- */

	public void keyTyped(KeyEvent e) {}

	public void keyPressed(KeyEvent e) {
		if (e.getKeyCode()==e.VK_ADD || e.getKeyCode()==e.VK_INSERT) {
			addnew(false);
			callListeners("");
		} else if (e.getKeyCode()==e.VK_MULTIPLY) {
			addnew(true);
			callListeners("");
		} else if (e.getKeyCode()==e.VK_DELETE || e.getKeyCode()==e.VK_SUBTRACT) {
			delete();
			callListeners("");
		}
	}
	public void keyReleased(KeyEvent e) {
		if (e.getSource()==pl) {
			int ixnew=pl.getSelectedIndex();
			if (ix!=ixnew) {
				updateList(ix,ixnew);
				ix=ixnew;
				eP.setInfo(Tr,pV(ixl[ix]));
				callListeners("");
			}
		}
	}

}