/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descedit;

/*------------------------------------------------------------*/
/*                          editPanel                         */
/*                          (c) MJA                           */
/*                       Febrero de 2001                      */
/*------------------------------------------------------------*/

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import javax.swing.JOptionPane;

import com.mja.gui.*;
import com.mja.guiedit.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import com.mja.util.*;
import com.mja.lang.*;
import com.mja.descartes.*;
import com.mja.parser.*;
import com.mja.file.mjaFont;

abstract public class editPanel extends Panel implements ActionListener, ItemListener  {

	static final String blankColorLabel="  ";

	configEdit parent;
	public editList eL;
	protected translator Tr;
	protected Descartes D;

	protected mjaPair[] mp;
	editColorDialog ecd;
	protected editObject eO;

	abstract public editObject newObject(String stype,String svalue);
	abstract public editObject newObject(translator Tr,String svalue);
	
	private Component mch_c;

	public editPanel(Descartes D,configEdit parent,Component C) {
		this.D=D;
		this.Tr=D.Tr;
		this.parent=parent;
		this.mch_c=C;
		setBackground(editList.Color_1);
		rebuild();
	}
	

	private Panel AuxP=null;

	protected void rebuild() {
		removeAll();
		setLayout(new FlowLayout(FlowLayout.LEFT,2,2));
		AuxP=null;
		Canvas C=new Canvas();
		C.setSize(2000,3);
		add(C);
		editObject eo=newObject(Tr,"");
		if (eo!=null&&eo.field!=null) {
			mp = new mjaPair[eo.field.length];
			Panel col1=null, col2=null;
			int NP=0,ix=0;
			for (int i=0;i<eo.field.length;i++) {
				mp[i]=new mjaPair(mch_c,eo.field[i].eType,eo.field[i].sz,eo.field[i].chvalues,eo.field[i].xinfoix);
				if (mp[i].show) {
					if (eo.field[i].inColumn) {
						if (AuxP==null) {
							col1=new Panel();
							col1.setBackground(editList.Color_1);
							col1.setLayout(new BorderLayout());
							col2=new Panel();
							col2.setBackground(editList.Color_1);
							col2.setLayout(new BorderLayout());
							AuxP=new Panel();
							NP++;
							AuxP.setName("panel_"+NP);
							AuxP.setBackground(editList.Color_1);
							add(AuxP);
							AuxP.setLayout(new GridBagLayout());
							GridBagConstraints c=mjaGui.newGBC();
							c.weightx=0.0; c.gridx=0;
							AuxP.add(col1,c);
							c.weightx=0.0; c.gridx=1;
							AuxP.add(col2,c);
							ix=0;
						}
						if (col1!=null && col2!=null) {
							if (eo.field[i].eType==editObject.textArea) {
								col1.add("Center",mp[i].getLabelComponent());
							} else if (ix<2) {
								col1.add("North",mp[i].getLabelComponent());
							} else {
								col1.add("South",mp[i].getLabelComponent());
							}
							Component[] ca=mp[i].getInfoComponents();
							for (int k=0;k<ca.length;k++) {
								ca[k].setVisible(true);
								if (eo.field[i].eType==editObject.textArea) {
									col2.add("Center",ca[k]);
								} else if (ix<2) {
									col2.add("North",ca[k]);
								} else {
									col2.add("South",ca[k]);
								}
							}
							ix++;
						}
					} else {
						if (eo.field[i].eType==editObject.textArea) {
//							cP.add(mp[i].getLabelComponent());
							Component[] ca=mp[i].getInfoComponents();
							for (int k=0;k<ca.length;k++) {
								add(ca[k]);
							}
						} else {
							add(mp[i]);
						}
					}
					mp[i].addActionListener(this);
					mp[i].addItemListener(this);
				}
			}
		} else {
			mp=new mjaPair[0];
		}
	}

	void reset() {
		for (int i=0;i<mp.length;i++) {
			if (mp[i].getType()==editObject.choice&&mp[i].chvalues!=null) {
				String s_info=mp[i].getInfo(Tr);
				Vector v=new Vector();
				for (int j=0;j<mp[i].chvalues.length;j++) {
					v.addElement(Tr.getTr(mp[i].chvalues[j]));
				}
				mp[i].setOptions(v);
				if (s_info!=null) {
					mp[i].setInfo(s_info);
				}
			}
		}
	}

	public void setInfo(translator Tr,editObject neO) {
		this.Tr=Tr;
		if (neO!=null) {
			eO=neO;
		} else {
			eO=newObject(Tr,"");
		}
		reset();
		setOnlyInfo(eO);
	}
	
	public void setAllExplanations() {
		for (int i=0;i<eO.field.length;i++) {
			if (eO.expl!=null && i<eO.expl.length && eO.expl[i]!=null) {
				mp[i].setExplanation(Expl.get(eO.expl[i],Tr.getActiveLanguage()),Tr.getTr(data.rightClick));
			} else {
				mp[i].setExplanation("",Tr.getTr(data.rightClick));
			}
		}
	}

	private void setOnlyInfo(editObject eO) {
		for (int i=0;i<eO.field.length;i++) {
			String label="";
			if (eO.field[i].uattrix>=0) {
				label=Tr.getTr(eO.field[i].uattrix);
			}
			mp[i].setInfo(label,eO.s_value[i],eO.field[i].def_val);
			if (eO.expl!=null && i<eO.expl.length && eO.expl[i]!=null) {
				mp[i].setExplanation(Expl.get(eO.expl[i],Tr.getActiveLanguage()),Tr.getTr(data.rightClick));
			} else {
				mp[i].setExplanation("",Tr.getTr(data.rightClick));
			}
			if (mp[i].getType()==editObject.text) {
				mp[i].msgFont=BasicStr.parseGeneralFont(eO.h_value[i],mjaFont.AWTMono);
			}
		}
		if (eO!=null && eO instanceof auxConfig) {
			auxConfig ac=(auxConfig) eO;
			if (AuxP!=null) {
				AuxP.setVisible(ac.type==data.alg||(ac.type==data.func) || ac.hasAlg);
				boolean enableCondition=ac.type==data.alg||(ac.type==data.func && ac.hasAlg) || (ac.type!=data.func&&ac.hasAlg);
				setEnabling(AuxP,enableCondition);
				setEnabling(mp[auxConfig.ixlocalvars],enableCondition);
			}
		}

		if (!inResetEnabling) {
			resetEnabling();
		} else {
			try {
				Thread.sleep(100);
			} catch(InterruptedException e) {
			}
			paintAll(getGraphics());
		}
	}

	public editObject getInfo() {
		editObject eOa=eO;
		eO=newObject(Tr,"");
		int ix=eOa.getTypeIndex(Tr);
		for (int i=0;i<eO.field.length;i++) {
			if (eOa.eot[ix].attributes.get(i)||eO.field[i].isFixed) {
				eO.s_value[i]=mp[i].getInfo(Tr);
				if (mp[i].getType()==editObject.text) {
					if (!mp[i].msgFont.equals(mjaFont.AWTMono)) {
						eO.h_value[i]=BasicStr.FontToString(mp[i].msgFont);
					} else {
						eO.h_value[i]="";
					}
				}
			}
		}
		eO.updateInfo(Tr);
		return eO;
	}
	
	boolean inResetEnabling=false;
	
	protected String s_type_ant="";
	
	protected void resetEnabling() {
		inResetEnabling=true;
		int ix=eO.getTypeIndex(Tr);
		if (eO instanceof controlConfig) {
			controlConfig cc=(controlConfig) eO;
			String s_type=BasicStr.trim(cc.s_value[controlConfig.ixtype],' ');
			if (BasicStr.hasContent(s_type)) {
				if (!s_type.equals(s_type_ant)) {
					for (int i=0;i<mp.length;i++) {
						mp[i].setVisible(eO.eot[ix].attributes.get(i));
						mp[i].setEnabled(eO.eot[ix].attributes.get(i));
					}
				}
				mp[controlConfig.ixtype].setEnabled(false);
				if (Tr.equals(s_type,data.c_numeric)) {
					if (!s_type.equals(s_type_ant)) {
						mp[controlConfig.ixid].setEnabled(true);
						mp[controlConfig.ixgui].setEnabled(true);
						mp[controlConfig.ixonlytext].setEnabled(false);
						mp[controlConfig.ixregion].setEnabled(true);
						mp[controlConfig.ixspace].setEnabled(false);
		
						mp[controlConfig.ixexpr].setEnabled(false);
						mp[controlConfig.ixvalue].setEnabled(true);
		
						mp[controlConfig.ixdecimals].setEnabled(true);
						mp[controlConfig.ixfixed].setEnabled(true);
						mp[controlConfig.ixname].setEnabled(true);
						mp[controlConfig.ixincr].setEnabled(true);
						mp[controlConfig.ixinf].setEnabled(true);
						mp[controlConfig.ixsup].setEnabled(true);
						mp[controlConfig.ixdiscrete].setEnabled(true);
						mp[controlConfig.ixvisible].setEnabled(true);
		
						mp[controlConfig.ixcondvis].setEnabled(true);
						mp[controlConfig.ixcondactiv].setEnabled(true);
		
						mp[controlConfig.ixaction].setEnabled(true);
						mp[controlConfig.ixparam].setEnabled(true);
						mp[controlConfig.ixmsgloc].setEnabled(true);
		//				mp[controlConfig.ixtooltip].setEnabled(true);
		//				mp[controlConfig.ixexpl].setEnabled(true);
//						mp[controlConfig.ixcontrolID].setEnabled(false);
					}	
					mp[controlConfig.ixcontrolID].setVisible(D.inArquimedes);
					mp[controlConfig.ixcontrolID].setEnabled(false);
					if (Tr.equals(cc.s_value[controlConfig.ixgui],data.spinner)) {
					} 
					if (Tr.equals(cc.s_value[controlConfig.ixgui],data.scrollbar)) {
					}
					setEnabling(mp[controlConfig.ixinf],true);
					setEnabling(mp[controlConfig.ixsup],true);
					setEnabling(mp[controlConfig.ixincr],true);
					setEnabling(mp[controlConfig.ixdiscrete],true);
					setEnabling(mp[controlConfig.ixnotexp],true);
					setEnabling(mp[controlConfig.ixdecimals],true);
					setEnabling(mp[controlConfig.ixnotexp],Tr.isTrue(cc.s_value[controlConfig.ixvisible]));
					if (Tr.equals(cc.s_value[controlConfig.ixgui],data.textfield)) {
						setEnabling(mp[controlConfig.ixonlytext],true);
						if (Tr.isTrue(cc.s_value[controlConfig.ixonlytext])) {
							setEnabling(mp[controlConfig.ixinf],false);
							setEnabling(mp[controlConfig.ixsup],false);
							setEnabling(mp[controlConfig.ixincr],false);
							setEnabling(mp[controlConfig.ixdiscrete],false);
							setEnabling(mp[controlConfig.ixnotexp],false);
							setEnabling(mp[controlConfig.ixdecimals],false);
						}
					} else {
						cc.s_value[controlConfig.ixonlytext]="no";
					}
					if (Tr.equals(cc.s_value[controlConfig.ixgui],data.choice)) {
						mp[controlConfig.ixoptions].setVisible(true);
						setEnabling(mp[controlConfig.ixinf],false);
						setEnabling(mp[controlConfig.ixsup],false);
						setEnabling(mp[controlConfig.ixincr],false);
						setEnabling(mp[controlConfig.ixdiscrete],false);
					} else {
						mp[controlConfig.ixoptions].setVisible(false);
					}
					if (Tr.equals(cc.s_value[controlConfig.ixgui],data.button)) {
						setEnabling(mp[controlConfig.ixnotexp],false);
						setEnabling(mp[controlConfig.ixdecimals],false);
						setEnabling(mp[controlConfig.ixinf],false);
						setEnabling(mp[controlConfig.ixsup],false);
						setEnabling(mp[controlConfig.ixincr],false);
						setEnabling(mp[controlConfig.ixdiscrete],false);
						mp[controlConfig.ixfgcol].setVisible(true);
						mp[controlConfig.ixbgcol].setVisible(true);
						mp[controlConfig.ixbold].setVisible(true);
						mp[controlConfig.ixitalic].setVisible(true);
						mp[controlConfig.ixunderline].setVisible(true);
						mp[controlConfig.ixfontsize].setVisible(true);
						mp[controlConfig.iximage].setVisible(true);
					} else {
						mp[controlConfig.ixfgcol].setVisible(false);
						mp[controlConfig.ixbgcol].setVisible(false);
						mp[controlConfig.ixbold].setVisible(false);
						mp[controlConfig.ixitalic].setVisible(false);
						mp[controlConfig.ixunderline].setVisible(false);
						mp[controlConfig.ixfontsize].setVisible(false);
						mp[controlConfig.ixdrawbg].setVisible(false);
						mp[controlConfig.iximage].setVisible(false);
					}
					setEnabling(mp[controlConfig.ixanswer],Tr.isTrue(cc.s_value[controlConfig.ixeval]));
					setEnabling(mp[controlConfig.ixweight],Tr.isTrue(cc.s_value[controlConfig.ixeval]));

					boolean inScenario=BasicStr.hasContent(cc.s_value[controlConfig.ixcontrolID]);
					setEnabling(mp[controlConfig.ixregion],!inScenario);
					boolean isInterior=Tr.equals(cc.s_value[controlConfig.ixregion],data.interior);
					setEnabling(mp[controlConfig.ixspace],isInterior);

				} else if (Tr.equals(s_type,data.c_graphic)) {
					setEnabling(mp[controlConfig.ixspace],true);
				} else if (Tr.equals(s_type,data.c_string)) {
					setEnabling(mp[controlConfig.ixspace],true);
				} else if (Tr.equals(s_type,data.c_audio)) {
					setEnabling(mp[controlConfig.ixspace],true);
				} else if (Tr.equals(s_type,data.c_video)) {
					setEnabling(mp[controlConfig.ixspace],true);
				} else {
					System.out.println("Error in control type='"+cc.s_value[controlConfig.ixtype]+"'");
				}
			}
			if (!s_type.equals(s_type_ant)) {
				setInfo(D.Tr,eO);
			} else {
				setOnlyInfo(eO);
			}
			s_type_ant=s_type;
		} else {
			for (int i=0;i<mp.length;i++) {
				mp[i].setVisible(eO.eot[ix].attributes.get(i));
			}
			setInfo(D.Tr,eO);
			s_type_ant="";
			if (eO instanceof spaceConfig) {
				spaceConfig sc=(spaceConfig) eO;
				mp[spaceConfig.spaceID].setVisible(D.inArquimedes);
				setEnabling(mp[spaceConfig.spaceID],false);
			}
		}
		paintAll(getGraphics());
		inResetEnabling=false;
	}
	
	void setEnabling(Container P,boolean b) {
		if (P!=null) {
			P.setEnabled(b);
			Component[] comps=P.getComponents();
			for (int i=0;i<comps.length;i++) {
				comps[i].setEnabled(b);
				if (comps[i] instanceof TextField || comps[i] instanceof TextArea) {
					if (b) {
						comps[i].setBackground(mjaPair.mostlyWhite);
					} else {
						comps[i].setBackground(mjaPair.disabledText);
					}
				} else if (comps[i] instanceof Container) {
					setEnabling((Container) comps[i],b);
				}
			}
		}
	}

	public void itemStateChanged(ItemEvent e) {
		eO=getInfo();
		resetEnabling();
		if (eO instanceof auxConfig) {
			if (e.getItem() instanceof mjaPair) {
				if (e.getStateChange()==ItemEvent.SELECTED) {
//					rebuild();
//					setInfo(D.Tr,eO);
					setEnabling(AuxP,true);
				} else {
					setEnabling(AuxP,false);
				}
			}
		} else if (eL!=null) {
			eL.replaceSelected(eO);
		}
	}

	public void actionPerformed(ActionEvent e) {
		mjaPair mp=(mjaPair) e.getSource();
		if (e.getActionCommand().equals("text")) {
			eO=getInfo();
			eO.updateInfo(D.Tr);
			boolean rtfFormat = false;
			if (eO instanceof controlConfig) {
				controlConfig cc=(controlConfig) eO;
				rtfFormat |= (mp==this.mp[controlConfig.ixtext]);
				rtfFormat |= (mp==this.mp[controlConfig.ixsolution]);
			}
			boolean askForRTF = (eO instanceof graphR2Config) || (eO instanceof graphR3Config);
			if( askForRTF ){
				int respuesta = JOptionPane.showOptionDialog(
						this,
						"Qu formato de texto desea usar?", 
						"Formato de texto", JOptionPane.YES_NO_OPTION, 
						JOptionPane.QUESTION_MESSAGE, 
						null, 
						new String []{"Texto con formato","Texto simple"},
						"Texto con formato");
				rtfFormat = (respuesta == JOptionPane.YES_OPTION);
			}
			
			if (rtfFormat&&mp.xinfoix>=0) {
Runtime.getRuntime().runFinalization();
Runtime.getRuntime().gc();
//System.out.println("editPanel1, memoria usada: "+
//		(Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory())/1024+
//		" Threads: "+Thread.activeCount());
				editRTFDialog ertfd=new editRTFDialog(parent,D,true,"","");
				ertfd.setTitle(mp.getLabel());
				ertfd.setLabels(Tr.getTr(data.accept),Tr.getTr(data.cancel));
				ertfd.setSelectedFont(mp.msgFont);
				String c_s=this.mp[mp.xinfoix].getInfo(Tr);
				ertfd.setSelectedColor(Tr.parseColor(c_s,new mjaColor(Color.black),new mjaColor(Color.black)));
				String parentSpace=null;
				if (eO instanceof graphR2Config) {
					graphR2Config gc=(graphR2Config) eO;
					parentSpace=gc.getSpace();
					Node decimals=D.p.Analyse(gc.s_decimals,2);
					int dec=(int)Math.round(decimals.Evaluate(2));
					ertfd.setExprDefaults(dec,gc.fixed,D.Tr.getActiveLanguage());
				} else if (eO instanceof graphR3Config) {
					graphR3Config gc=(graphR3Config) eO;
					parentSpace=gc.s_value[graphR3Config.space];
					Node decimals=D.p.Analyse(gc.s_value[graphR3Config.dec],2);
					int dec=(int)Math.round(decimals.Evaluate(2));
					ertfd.setExprDefaults(dec,D.Tr.isNotFalse(gc.s_value[graphR3Config.fixed]),D.Tr.getActiveLanguage());
				} else if (eO instanceof controlConfig) {
					controlConfig cc=(controlConfig) eO;
					parentSpace=cc.s_value[controlConfig.ixspace];
					Node decimals=D.p.Analyse(cc.s_value[controlConfig.ixdecimals],2);
					int dec=(int)Math.round(decimals.Evaluate(2));
					ertfd.setExprDefaults(dec,D.Tr.isNotFalse(cc.s_value[controlConfig.ixfixed]),D.Tr.getActiveLanguage());
				}
				if (parentSpace!=null) {
					spaceConfig sc=D.cfg.getSpace(parentSpace);
					ertfd.setBGColor(sc.DC[0].getAdaptedColor());
				}
				ertfd.setText(mp.getInfo(Tr));
				ertfd.display();
				if (ertfd.ok) {
					mp.msgFont=ertfd.getSelectedMjaFont().getAwtFont();
					mp.setInfo(ertfd.getText());
				}
				ertfd.dispose();
				ertfd=null;
Runtime.getRuntime().runFinalization();
Runtime.getRuntime().gc();
//System.out.println("editPanel2, memoria usada: "+
//		(Runtime.getRuntime().totalMemory()-Runtime.getRuntime().freeMemory())/1024+
//		" Threads: "+Thread.activeCount());
			} else {
				editTextDialog etd=new editTextDialog(parent,"",true,"","");
				etd.setTitle(mp.getLabel());
				etd.setLabels(Tr.getTr(data.accept),Tr.getTr(data.cancel));
				etd.setSelectedFont(mp.msgFont);
				etd.setText(BasicStr.replace(mp.getInfo(Tr),"\\n","\n"));
				etd.display();
				if (etd.ok) {
					mp.msgFont=etd.getSelectedFont();
					mp.setInfo(BasicStr.replace(etd.getText(),"\n","\\n"));
				}
			}
		} else if (e.getActionCommand().equals("color")) {
			if (ecd==null) {
				ecd=new editColorDialog(parent,"",true,"","");
			}
			ecd.setTitle(mp.getLabel());
			ecd.setLabels(Tr.getTr(data.accept),Tr.getTr(data.cancel));
			ecd.setCopyLabels(Tr.getTr(data.copy),Tr.getTr(data.paste));
			ecd.setColorNames(Tr);
			ecd.setMjaColor(mp.cb.getMjaBackColor());
			ecd.display();
			if (ecd.ok) {
				mp.cb.setBackColor(ecd.getMjaColor());
			}
		}
		if (eL!=null) {
			eO=getInfo();
			eL.replaceSelected(eO);
		}

	}

}