/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descedit;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;
import java.io.*;
import javax.swing.JComboBox;
import com.mja.descartes.*;
import com.mja.descedit.*;
import com.mja.lang.*;
import com.mja.util.*;
import com.mja.file.*;
import com.mja.gui.*;
import com.mja.guiedit.*;
import com.mja.descgui.*;
import com.mja.descgui.edit.*;
import org.unam.matem.Attribute;

public class mjaPair extends Panel implements ActionListener, Explainer, KeyListener, FocusListener, ItemListener {


	public static final Color mostlyWhite=new Color(0xfdfeff);
	public static final Color disabledText=new Color(0xd8e0e8);
	private static final int 
		select=editObject.select,
		string=editObject.string,
		color_button=editObject.color_button,
		color_select=editObject.color_select,
		text=editObject.text,
		choice=editObject.choice,
		textArea=editObject.textArea,
		macro=editObject.macro;

	public ColorButton cb;
	public int[] chvalues;
	public int xinfoix;
	public Font msgFont=new Font("Monospaced",Font.PLAIN,15);
	private static final Font textFont=new Font("Monospaced",Font.PLAIN,15);
	public static final Font labelFont=new Font("SansSerif",Font.PLAIN,15);
	public boolean show;
	private int type;
	private Label lb,lb0;
	private TextField tf;
	private Choice ch,ch2;
	private Button b1,b2;
	private ColorButton text_b;
	private Checkbox chb;
	private TextArea TA;
//	private JScrollPane jsp;
	private String defval;
	private String explanation,tooltip,more,path;
	private com.mja.gui.MouseCursorHandler mch;
	private int tfsz;
	private static final int mintfsz=3;

	private Descartes D;

	public void setExplanation(String expl,String more) {
		explanation=expl;
		tooltip=explanation;
		this.more=more;
	}
	
	public mjaPair(Component parent,int tfsz) {
		this(parent,0.1,0.9,tfsz);
	}

	public mjaPair(Component parent,double w1,double w2,int tfsz) {
		setBackground(editList.Color_1);
		mch=new com.mja.gui.MouseCursorHandler(parent,this);
		tfsz=Math.max(tfsz,mintfsz);
		this.tfsz=tfsz;
		show=tfsz>0;
		type=string;
		lb=new Label();
		lb.addMouseListener(mch);
		lb.setAlignment(Label.CENTER);
		tf=new TextField(tfsz);
		tf.setBackground(Color.white);
		tf.addMouseListener(mch);
		tf.addKeyListener(this);
		tf.addActionListener(this);
		tf.addFocusListener(this);
		tf.setFont(textFont);
		setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		c.fill=GridBagConstraints.BOTH;
		c.gridx=0; c.weightx=w1; add(lb,c);
		c.gridx=1; c.weightx=w2; add(tf,c);
	}

	private Panel pch,pch2;

	public mjaPair(Component parent,int type,int tfsz,int[] chvalues,int xinfoix) {
		setBackground(editList.Color_1);
		mch=new com.mja.gui.MouseCursorHandler(parent,this);
		tfsz=Math.max(tfsz,mintfsz);
		this.tfsz=tfsz;
		show=tfsz>0;
		this.type=type;
		this.chvalues=chvalues;
		this.xinfoix=xinfoix;
		setLayout(new GridBagLayout());
		GridBagConstraints c=new GridBagConstraints();
		c.fill=GridBagConstraints.BOTH;
		c.gridx=0; c.weightx=0.1;
		lb=new Label();
		lb.addMouseListener(mch);
		lb.setAlignment(Label.CENTER);
		lb.setFont(labelFont);
		if (type==string||type==choice||type==textArea||type==macro) {
			add(lb,c); c.gridx++;
		}
		c.weightx=0.9;
		switch (type) {
		case select :
			add(chb=new Checkbox()); c.gridx++;
			chb.addMouseListener(mch);
			chb.addItemListener(this);
			break;
		case string :
			tf=new TextField(tfsz);
			tf.setBackground(mostlyWhite);
			tf.setForeground(Color.black);
			tf.setFont(textFont);
			add(tf,c); c.gridx++;
			break;
		case text :
			text_b=new ColorButton("   ");
			text_b.setFont(labelFont);
			c.weightx=0.0;  add(text_b,c); c.gridx++;
			tf=new TextField(tfsz);
			tf.setBackground(mostlyWhite);
			tf.setForeground(Color.black);
			tf.setFont(textFont);
			c.weightx=1.0; add(tf,c); c.gridx++;
			break;
		case color_button :
			cb=new ColorButton("   ");
			cb.setFont(labelFont);
			c.weightx=0.0;  add(cb,c); c.gridx++;
			c.weightx=1.0;	add(lb); c.gridx++;
			lb.setAlignment(Label.LEFT);
			break;
		case color_select :
			cb=new ColorButton("   ");
			cb.setFont(labelFont);
			c.weightx=0.0;  add(cb,c); c.gridx++;
			c.weightx=1.0;	chb=new Checkbox(); chb.setFont(labelFont); add(chb); c.gridx++;
			chb.addMouseListener(mch);
			chb.addItemListener(this);
			break;
		case choice :
			ch=new Choice();
			ch.addMouseListener(mch);
			ch.addItemListener(this);
			ch.setFont(labelFont);
			pch=new Panel();
			pch.setLayout(new GridLayout(1,1,0,0));
			pch.add(ch);
			add(pch,c); c.gridx++;
			if (tfsz==0) {
				pch.setVisible(false);
			}
			break;
		case textArea :
			TA=new TextArea(15,tfsz+4);
			TA.setBackground(mostlyWhite);
			TA.setForeground(Color.black);
			TA.addMouseListener(mch);
			TA.setFont(textFont);
			break;
		case macro :
			tf=new TextField(tfsz);
			tf.setBackground(mostlyWhite);
			tf.setFont(textFont);
			c.weightx=0.0; add(tf,c); c.gridx++;
			c.weightx=0.4;
			ch=new Choice();
			ch.addMouseListener(mch);
			ch.setFont(labelFont);
			pch=new Panel();
			pch.setLayout(new GridLayout(1,1,0,0));
			pch.add(ch);
			add(pch,c); c.gridx++;
			ch.addItemListener(this);
			ch2=new Choice();
			ch2.addMouseListener(mch);
			ch2.addItemListener(this);
			ch2.setFont(labelFont);
			pch2=new Panel();
			pch2.setLayout(new GridLayout(1,1,0,0));
			pch2.add(ch2);
			add(pch2,c); c.gridx++;
			b1=new Button();
			b1.setFont(labelFont);
			b1.addActionListener(this);
			b1.addMouseListener(mch);
			c.weightx=0.0;  add(b1,c); c.gridx++;
			b2=new Button();
			b2.setFont(labelFont);
			b2.addActionListener(this);
			b2.addMouseListener(mch);
			c.weightx=0.0;  add(b2,c); c.gridx++;
			break;

		}
		if (tf!=null) {
			tf.addMouseListener(mch);
			tf.addKeyListener(this);
			tf.addActionListener(this);
			tf.addFocusListener(this);
		}
		if (cb!=null) {
			cb.addActionListener(this);
			cb.addMouseListener(mch);
		}
		if (text_b!=null) {
			text_b.addActionListener(this);
			text_b.addMouseListener(mch);
		}
	}
	
	public void setPath(String path) {
		this.path=path;
	}

	public void setDescartes(Descartes D) { // slo se llama para macros
		this.D=D;
		if (type==macro) {
			b1.setLabel(D.Tr.getTr(data.aux));
			b2.setLabel(D.Tr.getTr(data.doc));
		}
	}

	public void setOptions(Vector v) {
		setOptions(ch,v,false);
	}

	private void setOptions(Choice ch,Vector v,boolean addInitialBlank) {
		if (ch!=null) {
			ch.removeItemListener(this);
			ch.removeAll();
			boolean first=true;
			if (addInitialBlank) {
				String s=" ";
				while (s.length()<tfsz) {
					s+=" ";
				}
				ch.addItem(s);
				first=false;
			}
			Enumeration e=v.elements();
			while (e.hasMoreElements()) {
				String s=(String) e.nextElement();
				if (first) {
					while (s.length()<tfsz) {
						s+=" ";
					}
					first=false;
				}
				ch.addItem(s);
			}
			ch.addItemListener(this);
		}
	}

/* se crea un nuevo ch para que haga caso al cambiar la seleccin */
	Choice renewChoiceInPanel(Choice ch,Panel pch) {
		String[] option=new String[ch.getItemCount()];
		for (int i=0;i<ch.getItemCount();i++) {
			option[i]=(String) ch.getItem(i);
		}
		pch.remove(ch);
		ch=new Choice();
		for (int i=0;i<option.length;i++) {
			ch.addItem(option[i]);
		}
		ch.addMouseListener(mch);
		ch.addItemListener(this);
		ch.setFont(labelFont);
		pch.add(ch);
		return ch;
	}

	public void setInfo(String info) {
		mjaColor c=null;
		switch (type) {
		case select :
			chb.setState(translator.isNotFalse(info));
			break;
		case string :
			tf.setText(info);
//			tf.moveCaretPosition(0);
			break;
		case color_button :
			c=mjaColor.parseColor(info,null,null);
			if (c!=null) {
				cb.setBackColor(c);
			}
			break;
		case color_select :
			mjaColor defcol=mjaColor.parseColor(defval,null,null);
			c=mjaColor.parseColor(info,defcol,null);
			if (c!=null) {
				cb.setBackColor(c);
			} else {
				cb.setBackColor(defcol);
			}
			chb.setState((translator.isTrue(info)|| (BasicStr.hasContent(info)&&translator.isNotFalse(info)) ));
			break;
		case text :
			tf.setText(info);
//			tf.moveCaretPosition(0);
			break ;
		case choice :
			ch=renewChoiceInPanel(ch,pch);
			boolean infoFound=false;
			for (int i=0;i<ch.getItemCount();i++) {
				if (info!=null && info.equals((String) ch.getItem(i))) {
					infoFound=true;
					ch.select(i);
					break;
				}
			}
			if (!infoFound && ch.getItemCount()>0) {
				ch.select(0);
			}
			break;
		case textArea :
			TA.setText(BasicStr.replace(info,";","\n"));
//			TA.moveCaretPosition(0);
			break;
		case macro :
			tf.setText(info);
//			tf.moveCaretPosition(0);
			ch=renewChoiceInPanel(ch,pch);
			ch.select(info);
			if (!info.equals(ch.getSelectedItem())) {
				StringTokenizer st=new StringTokenizer(info,"/");
				if (st.countTokens()==1) {
					ch=renewChoiceInPanel(ch,pch);
					ch.select(".");
					updateMacros();
					ch2=renewChoiceInPanel(ch2,pch2);
					ch2.select(st.nextToken());
				} else if (st.countTokens()==2) {
					ch=renewChoiceInPanel(ch,pch);
					ch.select(st.nextToken());
					updateMacros();
					ch2=renewChoiceInPanel(ch2,pch2);
					ch2.select(st.nextToken());
				} else {
					if (ch.getItemCount()>0) {
						ch=renewChoiceInPanel(ch,pch);
						ch.select(0);
						updateMacros();
						if (ch2.getItemCount()>0) {
							ch2=renewChoiceInPanel(ch2,pch2);
							ch2.select(0);
						}
					}
				}
			}
			break;
		}
	}

	private void updateMacros() {
		Vector macros=new Vector();
		if (ch.getSelectedItem()!=null) {
			String s="";
			String searchfor=path+((String) ch.getSelectedItem()).trim()+"/index.txt";
			searchfor=searchfor.replace("/./","/");
			try {
				URL url=D.getClass().getResource(searchfor);
				s=mjaFile.readURL(url);
			} catch (Exception e) {
				System.out.println(searchfor);
				System.out.println(e.getMessage());
			}
			BasicStr.addToStringVector(macros,s);
		}
		setOptions(ch2,macros,true);
	}

	public void setInfo(String label,String info,String defval) {
		setLabel(label);
		this.defval=defval;
		setInfo(info);
	}

	public void setInfo(String label,String info) {
		setInfo(label,info,null);
	}

	public Component getLabelComponent() {
		return lb;
	}

	public void setLabel(String label) {
		switch (type) {
		case select : chb.setLabel(label); break;
		case string : lb.setText(label); break;
		case color_button : lb.setText(label); break;
		case color_select : chb.setLabel(label); break;
		case text : text_b.setLabel(label); break;
		case choice : lb.setText(label); break;
		case textArea : lb.setText(label); break;
		case macro : lb.setText(label); break;
		}
	}

	public String getLabel() {
		switch (type) {
		case select : 		return chb.getLabel();
		case string : 		return lb.getText();
		case color_button : return lb.getText();
		case color_select : return chb.getLabel();
		case text : 		return text_b.getLabel();
		case choice : 		return lb.getText();
		case textArea :		return lb.getText();
		case macro : 		return lb.getText();
		}
		return "";
	}

	public int getType() {
		return type;
	}

	public Component[] getInfoComponents() {
		Component[] ca;
		if (type==select||type==text) {
			ca=new Component[2];
		} else if (type==macro) {
			ca=new Component[2];
		} else {
			ca=new Component[1];
		}
		switch (type) {
		case select : ca[0]=chb; break;
		case string : ca[0]=tf;  break;
		case color_button : ca[0]=cb;  break;
		case color_select : ca[0]=cb; ca[1]=chb; break;
//		case text : ca[0]=cb; ca[1]=tf;  break;
		case text : ca[0]=text_b; ca[1]=tf;  break;
		case choice : ca[0]=ch;  break;
//		case textArea : ca[0]=jsp;  break;
		case textArea : ca[0]=TA;  break;
		case macro : ca[0]=ch; ca[1]=ch2;
		}
		return ca;
	}
	
	public boolean isSelected() {
		if (type==select) {
			if (chb.getState()) {
				return true;
			} else {
				return false;
			}
		}
		return false;
	}

	public void setState(boolean b) {
		if (type==select) {
			chb.setState(b);
		}
	}

	public String getInfo(translator Tr) {
		switch (type) {
		case select : 		if (chb.getState()) {
								return Tr.getTr(data.Yes);
							} else {
								return Tr.getTr(data.No);
							}
		case string : 		return tf.getText();
		case color_button : return mjaColor.getColorName(Tr,cb.getMjaBackColor());
		case color_select : if (chb.getState()) {
								return mjaColor.getColorName(Tr,cb.getMjaBackColor());
							} else {
								return Tr.getTr(data.No);
							}
		case text :			return tf.getText();
		case choice : 		if (ch.getSelectedItem()!=null) {
								return ch.getSelectedItem().trim();
							} else {
								return null;
							}
		case textArea :		return BasicStr.replace(TA.getText(),"\n",";");
		case macro :        return tf.getText();
		}
		return "";
	}

	private String getMacro() {
		String first="",second="";
		if (ch.getSelectedIndex()>0) {
			first=((String) ch.getSelectedItem()).trim();
		}
		if (ch2.getSelectedIndex()>0) {
			second=((String) ch2.getSelectedItem()).trim();
		} else {
			return first;
		} 
		if (ch.getSelectedIndex()==0) {
			return second;
		} else {
			return first+"/"+second;
		}
	}

	public void setEnabled(boolean e) {
		lb.setEnabled(e);
		if (tf!=null) {
			tf.setEditable(e);
			tf.setEnabled(e);
			if (e) {
				tf.setBackground(mostlyWhite);
			} else {
				tf.setBackground(disabledText);
			}
		}
		switch (type) {
		case select :
			chb.setEnabled(e);
			break;
		case string :
			break;
		case color_button :
			cb.setEnabled(e);
			break;
		case color_select :
			cb.setEnabled(e);
			chb.setEnabled(e);
			break;
		case text :
//			cb.setEnabled(e);
			text_b.setEnabled(e);
			break ;
		case choice :
			ch.setEnabled(e);
			break;
		case textArea :
			TA.setEditable(e);
			TA.setEnabled(e);
			if (e) {
				TA.setBackground(mostlyWhite);
			} else {
				TA.setBackground(disabledText);
			}
			break;
		case macro :
			ch.setEnabled(e);
			ch2.setEnabled(e);
			b1.setEnabled(e);
			b2.setEnabled(e&&(D.inWeb()));
			break;
		}
	}

	public void setVisible(boolean e) {
		lb.setVisible(e);
		switch (type) {
		case select :
			chb.setVisible(e);
			break;
		case string :
			tf.setVisible(e);
			break;
		case color_button :
			cb.setVisible(e);
			break;
		case color_select :
			cb.setVisible(e);
			chb.setVisible(e);
			break;
		case text :
//			cb.setVisible(e);
			text_b.setVisible(e);
			tf.setVisible(e);
			break ;
		case choice :
			pch.setVisible(e);
			break;
		case textArea :
//			jsp.setVisible(e);
			TA.setVisible(e);
			break;
		case macro :
			tf.setVisible(e);
			pch.setVisible(e);
			pch2.setVisible(e);
			b1.setVisible(e);
			b2.setVisible(e);
			break;
		}
		super.setVisible(e);
	}

	private Vector listeners=new Vector();

	public void addActionListener(ActionListener c) {
		listeners.addElement(c);
	}

	public void removeActionListener(ActionListener c) {
		listeners.removeElement(c);
	}

	private void callListeners(String arg) {
		Enumeration e=listeners.elements();
		while (e.hasMoreElements()) {
			ActionListener al=(ActionListener) e.nextElement();
			al.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,arg));
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (!mch.isHand()) {
			if (e.getSource()==cb) {
				if (type==color_button||type==color_select) {
					callListeners("color");
//				} else if (type==text) {
//					callListeners("text");
				}
			} else if (e.getSource()==text_b) {
				callListeners("text");
			} else if (e.getSource()==tf) {
				callListeners(tf.getText());
			} else if (e.getSource()==b1) {
				String macro_path=path+getInfo(null);
				if (!macro_path.startsWith("/")) {
					macro_path="/"+macro_path;
				}
				URL url=D.getClass().getResource(macro_path);
				String str=mjaFile.readURL(url);
				boolean found=BasicStr.hasContent(str);
				if (found) {
					Vector v=mjaFile.readStrArrResource(getClass(),macro_path);
					String msg="";
					for (int i=0;i<v.size();i++) {
						String auxs=(String) v.elementAt(i);
						Attribute[] aa=Attribute.parse(auxs);
						String id=Attribute.getValue(aa,"id");
						if (BasicStr.hasContent(id)) {
							auxConfig ac=new auxConfig(D.Tr,aa);
							String lnmsg="";
							lnmsg+=id;
							if (ac.hasAlg) {
								lnmsg+=" ("+D.Tr.getTr(data.alg)+")";
							} else {
								lnmsg+="="+ac.s_value[auxConfig.ixexpr];
							}
							int sz=40;
							if (lnmsg.length()<sz) {
								lnmsg=BasicStr.justify(lnmsg,sz,' ');
							}
							if (ac.type==data.constant||ac.type==data.alg) {
								if (ac.evOnce) {
									lnmsg+=" ("+D.Tr.getTr(data.once)+")";
								} else {
									lnmsg+=" ("+D.Tr.getTr(data.always)+")";
								}
							} else if (ac.type==data.var) {
								lnmsg+=" ("+D.Tr.getTr(data.var)+")";
							} else if (ac.type==data.array) {
								lnmsg+=" ("+D.Tr.getTr(data.array)+")";
							} else if (ac.type==data.matrix) {
								lnmsg+=" ("+D.Tr.getTr(data.matrix)+")";
							} else if (ac.type==data.event) {
								lnmsg+=" ("+D.Tr.getTr(data.event)+")";
							} else if (ac.type==data.sequence) {
								lnmsg+=" ("+D.Tr.getTr(data.sequence)+")";
							}
							msg+=lnmsg+"\n";
						}
					}
					mjaText.msg(b1,"macro: "+getInfo(null),20,60,false,msg,"ok",textFont,mjaText.center);
				} else {
					mjaText.msg(b1,"macro: "+getInfo(null),20,60,false,D.Tr.getTr(data.NotFound),"ok",textFont,mjaText.center);
				}
			} else if (e.getSource()==b2 && (D.inWeb())) {
				String macro_path=path+getInfo(null);
				if (!macro_path.startsWith("/")) {
					macro_path="/"+macro_path;
				}
				String uri="http://arquimedes.matem.unam.mx/Descartes5"+macro_path+".html";
				try {
					URL url=new URL(uri);
//					System.out.println(uri);
					D.getAppletContext().showDocument(url,"_blank");
				} catch (Exception eee) {
				}
/*
				URL url=getClass().getResource("/"+path+getInfo(null)+".html");
				boolean found=url!=null&&mjaFile.fileExists(url);
				if (!found) {
					url=getClass().getResource(mjaHtml.getRelativeDocPath(D)+getInfo(null)+".html");
					found=url!=null&&mjaFile.fileExists(url);
					if (!found) {
						url=getClass().getResource("/"+path+getInfo(null)+".htm");
						found=url!=null&&mjaFile.fileExists(url);
						if (!found) {
							url=getClass().getResource(mjaHtml.getRelativeDocPath(D)+getInfo(null)+".htm");
							found=url!=null&&mjaFile.fileExists(url);
						}
					}
				}
				if (found) {
					D.getAppletContext().showDocument(url,"_blank");
				} else {
					mjaText.msg(b2,D.Tr.getTr(data.NotFound),getInfo(null)+".html",textFont);
				}
*/
			}
		}
	}

	public void focusGained(FocusEvent e) {
		if (e.getSource()==tf) {
			mjaGui.setEditor(tf);
		}
	}

	public void focusLost(FocusEvent e) { }

	/* -------------- Mouse Listener ------------- */
	public String getExplLabel(MouseEvent e) {
		if (e.getSource()==b1) {
			return b1.getLabel();
		} else if (e.getSource()==b2) {
			return b2.getLabel();
		} else {
			return getLabel();
		}
	}


	public String getExplanation(MouseEvent e) {
		if (e.getSource()==b1) {
			return Expl.MacroPair[0][D.Tr.getActiveLanguage()];
		} else if (e.getSource()==b2) {
			return Expl.MacroPair[1][D.Tr.getActiveLanguage()];
		} else {
			return explanation;
		}
	}

	/* -------------- Key Listener ------------- */

	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}

	/* -------------- Item Listener ------------- */


	private Vector item_listeners=new Vector();

	public void addItemListener(ItemListener c) {
		item_listeners.addElement(c);
	}

	public void removeItemListener(ItemListener c) {
		item_listeners.removeElement(c);
	}

	private void callItemListeners(ItemEvent ie) {
		Enumeration e=item_listeners.elements();
		while (e.hasMoreElements()) {
			ItemListener al=(ItemListener) e.nextElement();
			al.itemStateChanged(ie);
		}
	}


	public void itemStateChanged(ItemEvent e) {
		if (mch.isHand() && e.getSource() instanceof Checkbox) {
			Checkbox chbx=(Checkbox) e.getSource();
			chbx.setState(!chbx.getState());
		}
		if (type==macro && e.getStateChange()==ItemEvent.SELECTED ) {
			if (e.getSource()==ch) {
				updateMacros();
			}
			tf.setText(getMacro());
//			tf.moveCaretPosition(0);
		}
		ItemEvent ne=new ItemEvent(e.getItemSelectable(),e.getID(),this,e.getStateChange());
		callItemListeners(ne);
	}

}