/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;
/*------------------------------------------------------------*/
/*                       ChoiceControl                        */
/*                         (c)  MJA                           */
/*                     Septiembre de 2002                     */
/*------------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import com.mja.util.*;
import com.mja.gui.*;
import com.mja.descartes.*;
import com.mja.parser.*;
import com.mja.file.mjaFile;
import javax.swing.JComboBox;

public class ChoiceControl extends NumericControl implements ItemListener {

	private JComboBox ch;
	private String options;
	private Hashtable opht;
	private int NumOptions;
	private String[] strValue;

	public ChoiceControl(Descartes D,controlConfig ccfg,String ne,String nv,String s_p,boolean fixed,String s_v,boolean visible,String s_notexp,String options,String vc,String ac) {
		super();
		ch=new JComboBox();
		this.options=options;
		init(D,ccfg,ne, nv, s_p, fixed, s_v, "0", "", "", visible, s_notexp,vc,ac);
		GridBagLayout gbl=new GridBagLayout();
		setLayout(gbl);
		GridBagConstraints c=new GridBagConstraints();
		c.insets=new Insets(0,4,0,4);
		c.fill=GridBagConstraints.BOTH;
		c.anchor=GridBagConstraints.NORTHWEST;
		c.gridwidth=1; c.gridheight=1;	c.gridy=0; c.weighty=1.0;
		int x=0;
		if (BasicStr.hasContent(getTitle())) {
			c.gridx=0; c.weightx=0.0; gbl.setConstraints(lb,c); add(lb);
			x++;
		}
		c.insets=new Insets(0,0,0,0);
		c.gridx=x; c.weightx=0.3; gbl.setConstraints(ch,c); add(ch);
		x=x+1;
		c.gridx=x; c.weightx=0.7; gbl.setConstraints(TF,c); add(TF);
		ch.addMouseListener(this);
	}

	public Component[] getFocusableComponents() {
		Component[] ca=new Component[2];
		ca[0]=TF;
		ca[1]=ch;
		return ca;
	}

	public void setOptions(String s) {
		opht=new Hashtable();
		if (BasicStr.hasContent(s)) {
			StringTokenizer st=new StringTokenizer(s,",");
			NumOptions=st.countTokens();
			strValue=new String[NumOptions];
			int n=0;
			while (st.hasMoreTokens()) {
				String token=st.nextToken();
				StringTokenizer st2=new StringTokenizer(token,"[]");
				String key=st2.nextToken();
				if (key.startsWith("'") && key.endsWith("'")) {
					key=BasicStr.trim(key,'\'');
				} else if (st2.countTokens()<2 && token.indexOf("=")>0) {
					st2=new StringTokenizer(token,"[=]");
					key=st2.nextToken();
				}
				ch.addItem(key);
				String value="";
				if (st2.hasMoreTokens()) {
					value=st2.nextToken();
				}
				Node N=D.p.Analyse(value,n);
				opht.put(key,N);
				strValue[n]=getStringValue(N.Evaluate(n));
				n++;
			}
		}
	}

	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x,y,w,h);
		setLayout(null);
		Graphics g=D.getGraphics();
		FontMetrics fm=g.getFontMetrics(ch.getFont());
		int minchw=0;
		minTFw=0;
		for (int i=0;i<NumOptions;i++) {
			minchw=Math.max(minchw,fm.stringWidth((String) ch.getItemAt(i)));
			minTFw=Math.max(minTFw,fm.stringWidth(strValue[i]));
		}
		minchw=minchw+25;
		minTFw=minTFw+7;
		int lbw=minlbw;
		int TFw=minTFw;
		if (!BasicStr.hasContent(getTitle())) {
			lbw=0;
		}
		if (!TF.isVisible()) {
			TFw=0;
		}
		int chw=w-TFw-lbw;
		while (chw<minchw && lbw>0)	{
			lbw--;
			chw++;
		}
		while (chw<minchw && TFw>0)	{
			TFw--;
			chw++;
		}
		while (lbw+chw+TFw+1<w) {
			chw++;TFw++;
		}
		int chx=lbw;
		int TFx=chx+chw;
		TFw=w-TFx;

		lb.setBounds(0,0,lbw,h);
		ch.setBounds(chx,0,chw,h);
		TF.setBounds(TFx,0,TFw,h);
	}

	public void setFont(int fh) {
		super.setFont(fh);
		ch.setFont(getFont());
	}

	public boolean isActive() {
		boolean active=activityN.Evaluate(1)>0;
		ch.setEnabled(active);
		return super.isActive();
	}

	public void stop() {
	}
	
	public void reinitialize() {
		super.reinitialize();
		Node N=D.p.Analyse(s_v,0);
		defineValue(N.Evaluate(getDoubleValue()));
	}

	public String getStringValue() {
		if (var.getStr()!=null) {
			return var.getStr();
		} else {
			return getStringValue(var.getDouble());
		}
	}

	protected void defineTextValue(String s0) {
	}

	public void updateVisualComponent() {
		if (TF!=null && (!getStringValue().equals(TF.getText()))) {
			TF.setText(getStringValue());
			double d=getDoubleValue();
			defineValue(d);
		}
	}

	public void itemStateChanged(ItemEvent e) {
		if (isActive() && e.getSource()==ch) {
			if (e.getStateChange()==ItemEvent.SELECTED) {
				String selected=ch.getSelectedItem().toString();
				D.updateNodesFromControls();
				userIsSelecting=false;
				Node N=(Node) opht.get(selected);
				if (N.getStr()!=null) {
					var.setStrAndAnalyse(N.getStr());
					if (TF!=null) {
						TF.setText(var.getStr());
					}
				} else {
					defineValue(N.Evaluate(getDoubleValue()));
				}
				D.updateTextFieldsFromNodes();
				executeAction();
				callListeners("");
			}
		}
	}

	private boolean userIsSelecting=false;

	public void mouseClicked (MouseEvent e) {
		if (isActive()) {
			if (e.getSource()==ch) {
				userIsSelecting=true;
			}
			super.mouseClicked(e);
		}
	}

	public void defineValue(double d) {
		if (ch.getItemCount()==0) {
			setOptions(options);
			ch.addItemListener(this);
		}
		double max=Double.MAX_VALUE;
		String key="";
		Enumeration e=opht.keys();
		double value=d;
		while (e.hasMoreElements()) {
			String tkey=(String) e.nextElement();
			Node N=(Node) opht.get(tkey);
			double x=N.Evaluate(getMin());
			double dif=Math.abs(x-d);
			if (max>dif) {
				max=dif;
				key=tkey;
				value=x;
			}
		}
		if (!userIsSelecting && key!=ch.getSelectedItem()) {
			ch.removeItemListener(this);
			ch.setSelectedItem(key);
			ch.addItemListener(this);
		}
		if (!getStringValue().equals(TF.getText())) {
			TF.setText(getStringValue());
		}
		setValue(value);
	}


}