/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;
/*------------------------------------------------------------*/
/*                      MediaControl                        */
/*                      (c)  JLAbreu                          */
/*                    Julio 20 de 2012                         */
/*------------------------------------------------------------*/
import java.awt.*;
import javax.swing.JLabel;
import com.mja.descartes.*;
import com.mja.gui.mjaColor;

public class MediaControl extends Panel {

	private Descartes D;
	private String name,mediaType,fileName;
	private controlConfig mediactrl;

	public MediaControl(Descartes D,controlConfig mediactrl) {
		this.D=D;
		this.mediactrl=mediactrl;
		name=mediactrl.getName();
		setBounds(mediactrl.getTextX(),mediactrl.getTextY(),mediactrl.getTextW(),mediactrl.getTextH());
		setLayout(new FlowLayout(0,0,FlowLayout.LEFT));
		mediaType=mediactrl.getMediaType();
		fileName=mediactrl.getFileName();
		if (mediaType.equals("audio")) {
			setBackground(Color.darkGray);
			setForeground(Color.yellow);
		} else { // video
			setBackground(Color.black);
			setForeground(Color.white);
		}
	}
	
	public void registerTextInParser() {
	}
	
	private boolean showingSol=false;
	
	public void updateVisualComponent() {
	}
	
	public void showSolution() {
	}
	
	public void showUserText() {
	}
	
	protected void defineTextValue(String s0) {
	}

	public void start() {
	}

	public void locate() {
		setVisible(mediactrl.condVis.Evaluate(1)>0);
//		setEnabled(mediactrl.condActiv.Evaluate(1)>0);
	}
	
	public void stop() {
	}
	
	public void paint(Graphics g) {
		g.setColor(mjaColor.bestContrast(getBackground()));
		g.setFont(new Font("SansSerif",Font.PLAIN,15));
		g.drawString(mediaType.toUpperCase()+": "+fileName,5,20);
	}

}