/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;
/*------------------------------------------------------------*/
/*                      NumericControl                        */
/*                         (c)  MJA                           */
/*                    September de 2002                       */
/*------------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
import javax.swing.JTextField;
import javax.swing.JLabel;
//import com.jla.calc.*;
import com.mja.util.*;
import com.mja.parser.*;
import com.mja.descartes.*;
import com.mja.gui.*;
import com.mja.cmp.*;
import com.mja.file.*;

public abstract class NumericControl extends Panel implements MouseListener, KeyListener, FocusListener, ComponentListener, LiveOrDie {

	public static final Color labelColor=new Color(0xe0e4e8);

	public controlConfig ccfg;
	public String answer;
	JLabel lb;
	public JTextField TF=new JTextField(10);
	private boolean TFhasFocus=false;
	public static final double minDouble=-(Double.MAX_VALUE-1);
	public static final double maxDouble=Double.MAX_VALUE;
	protected Node xN,yN,wN,hN;
	protected Node visibilityN,activityN;
	protected boolean onlyText=false;

	Descartes D;

	protected double v0;
	protected Node var, dvN;

	private Node pvN,minN,maxN;

	private int p0;
	private Node notexp;
	private boolean fixed;
	protected boolean discrete;
	protected boolean interior;
	private String title,explanation,tooltip,more,space;
	private Vector listeners=new Vector();
	private Action a;
	private String cID="";
//	private double dv=0.1;

	String s_p,s_v,s_vincr,s_vmin,s_vmax,s_notexp,s_visicond,s_activcond;
	boolean vertical=false;
	String pattern="";

	public abstract void updateVisualComponent();
	public abstract void stop();
	protected abstract void defineTextValue(String s0);
	
	void init(Descartes D,controlConfig ccfg,String ne,String nv,String s_p,boolean fixed,String s_v,String s_vincr,String s_vmin,String s_vmax,boolean visible,String s_notexp,String visicond,String activcond) {
		this.D=D;
		this.ccfg=ccfg;
		this.s_p=s_p;
		this.fixed=fixed;
		this.s_v=s_v;
		this.s_vincr=s_vincr;
		this.s_vmin=s_vmin;
		this.s_vmax=s_vmax;
		this.s_notexp=s_notexp;
		this.s_visicond=visicond;
		this.s_activcond=activcond;
		setBackground(labelColor); // ste color se ve en el fondo de los controles, es el que se ve antes de que se dibujen
		title=ne;
		if ("_._".equals(title) || "_nada_".equals(title) || "_void_".equals(title)) {
			title="";
		}
		lb=new JLabel(title);
		lb.setHorizontalAlignment(JLabel.CENTER);
		lb.setBackground(labelColor);
		lb.setForeground(Color.black);
		lb.setOpaque(true);
		lb.addMouseListener(this);
		lb.addKeyListener(this);
		TF.setHorizontalAlignment(JTextField.LEFT);
		TF.setBackground(Color.white);
		TF.setForeground(Color.black);
		TF.setDisabledTextColor(new Color(0x204080));
		TF.addKeyListener(this);
		TF.addMouseListener(this);
		TF.addFocusListener(this);
		TF.setEditable(true);
		if (!visible) {
			TF.setVisible(false);
		}
		setName(nv);
		var=D.p.Var(getName());
		reinitialize();
		addMouseListener(this);
		addKeyListener(this);
		addActionListener(D);
		addMouseListener(D.scene);
		addKeyListener(D.scene);
		pattern=ccfg.getAnswerPattern().trim();
		String solution=D.p.getSolution(pattern);
		disableFocusTraversalKeys();
		D.p.Var(getName()+".sol").setOnlyStr(solution);
		addComponentListener(this);
	}
	
	public void disableFocusTraversalKeys() {
		Component[] ca=getFocusableComponents();
		for (int k=0;k<ca.length;k++) {
			ca[k].setFocusTraversalKeysEnabled(false);
		}
	}
	
/* --------- LiveOrDie --------- */

	public Component[] getFocusableComponents() {
		Component[] ca=new Component[1];
		ca[0]=TF;
		return ca;
	}

	private boolean isUsed=false;
	
	public void setIsUsed(boolean b) {
		isUsed=b;
		if (isUsed) {
			D.cfg.addControl(ccfg);
		} else {
			if (getParent() !=null) {
				getParent().remove(this);
			}
			D.cfg.removeControl(ccfg);
		}
	}
	
	public boolean isUsed() {
		return isUsed;
	}

	public Component cloneComponent(String cid) {
		controlConfig ncc=ccfg.cloneControlConfig();
		NumericControl nnc=ncc.makeNumericControl(D);
		nnc.setSize(getSize().width,getSize().height);
		D.scene.addEditObjectToText(ncc,cid);
		return nnc;
	}

	public void start() {
		try {
			locate();
		} catch (Exception e) {
		}
		updateFont();
	}

/* -------- END LiveOrDie ------- */

	public void setControlID(String cid) {
		cID=cid;
	}
	
	public String getControlID() {
		return cID;
	}
	
	private String typeName="";
	public void setTypeName(String tname) {
		typeName=tname;
	}
	public String getTypeName() {
		return typeName;
	}

	public void addMouseListener(MouseListener ml) {
		super.addMouseListener(ml);
		Component[] ca=getComponents();
		for (int i=0;i<ca.length;i++) {
			ca[i].addMouseListener(ml);
		}
	}
	
	public void reinitialize() {
		pvN=D.p.Analyse(s_p,2);
		notexp=D.p.Analyse(s_notexp,0);
		p0=Math.max(0,(int) Math.round(pvN.Evaluate(2)));
		if (pvN.isANumber()) {
			pvN=null;
		}
		// Agregado el 17 de Enero de 2009 para redondear SIEMPRE
		if (var.getStr()==null) {
			var.setDouble(BasicStr.round(var.getDouble(),p0));
		}
		/* ------------ */
		dvN=D.p.Analyse(s_vincr,0.1);
		minN=D.p.Analyse(s_vmin,minDouble);
		maxN=D.p.Analyse(s_vmax,maxDouble);
		defineValue(s_v);
		v0=var.getDouble();
		visibilityN=D.p.Analyse(s_visicond,"1");
		activityN=D.p.Analyse(s_activcond,"1");
		informRAD();
		checkCorrect();
	}

	int minlbw=0,minTFw=0;

	private void updateFontAndSize() {
		if (!vertical) {
			updateFont();
			Graphics g=D.getGraphics();
			FontMetrics fm=g.getFontMetrics(lb.getFont());
			minlbw=fm.stringWidth(getTitle())+10;
			minTFw=fm.stringWidth(TF.getText()+"0");
			double auxr=var.getDouble();
			String auxs=var.getStr();
			if (BasicStr.hasContent(s_vmin)) {
				var.setDouble(minN.Evaluate(0));
				minTFw=Math.max(minTFw,fm.stringWidth(getStringValue()));
			}
			if (BasicStr.hasContent(s_vmax)) {
				var.setDouble(maxN.Evaluate(0));
				minTFw=Math.max(minTFw,fm.stringWidth(getStringValue()));
			}
			if (auxs!=null) {
				var.setOnlyStr(auxs);
			} else {
				var.setDouble(auxr);
			}
			minTFw=minTFw+7;
		}
	}

	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x,y,w,h);
		updateFontAndSize();
	}

/* ------------------------ public interface ------------------------ */

	public void setDescartes(Descartes D) {
		this.D=D;
	}

	public void setAction(String action,String param,Font font,int msgloc) {
		if (BasicStr.hasContent(action)) {
			this.a=new Action(D,getName(),action,param,font,msgloc);
		} else {
			this.a=null;
		}
	}
	
	void informRAD() {
		if (D.cfg.useRAD) {
			String[][] stra=new String[1][2];
			stra[0][0]=getName(); 
			stra[0][1]=Double.toString(var.getDouble()); 
//			D.informLMS(mjaHtml.getHTMLEncoding(getTypeName()),getTitle(),"",stra);
			D.informLMS(getTypeName(),getTitle(),"",stra);
		}
	}

	public void executeAction() {
		informRAD();
		if (a!=null) {
			a.execute();
		}
	}

	public Action getAction() {
		return a;
	}

	public void setInterior(boolean b) {
		interior=b;
	}

	private boolean inScenario;

	public void setInScenario(boolean b) {
		inScenario=b;
	}
	
	public boolean inScenario() {
		return inScenario;
	}

	public void setNodeBounds(Node xN,Node yN,Node wN,Node hN) {
		this.xN=xN;
		this.yN=yN;
		this.wN=wN;
		this.hN=hN;
	}
	
	public void checkActive() {
		boolean isA=isActive();
	}
	
	public boolean isActive() {
		if (activityN==null) {
			return true;
		} else {
			boolean active=activityN.Evaluate(1)>0;
			TF.setEnabled(active);
			if (active) {
				TF.setBackground(Color.white);
			} else {
				TF.setBackground(new Color(0xf8f8f8));
			}
			return active;
		}
	}
	
	int numloc=0;
	
	public void locate() throws Exception {
		Component parent=getParent();
		if (parent==null) {
			throw new Exception("Attempt to locate fatherless numeric control ");
		}
		if ((parent!=null) && parent.isVisible()) {
			if (getGraphics()!=null) {
				boolean isVisible=(visibilityN.Evaluate(1)>0);
				setVisible(isVisible);
				if (isVisible && (isInterior() || inScenario()) &&(xN!=null)&&(yN!=null)&&(wN!=null)&&(hN!=null)) {
					Dimension d=getSize();
					double w=wN.Evaluate(100);
					double h=hN.Evaluate(23);
					int w1=(int)Math.floor(w+0.5);
					int h1=(int)Math.floor(h+0.5);
					if (inScenario()) {
						if (d.width!=w1||d.height!=h1) {
							setSize(w1,h1);
						}
					} else {
						int x1=(int)Math.floor(xN.Evaluate(0)+0.5);
						int y1=(int)Math.floor(yN.Evaluate(0)+0.5);
						Point loc=getLocation();
						if (loc.x!=x1||loc.y!=y1||d.width!=w1||d.height!=h1) {
							setBounds(x1,y1,w1,h1);
							updateFont();
						}
					}
				}
			}
		}
	}
	
	public void setForeground(Color fgc) {
		super.setForeground(fgc);
		lb.setForeground(fgc);
		TF.setForeground(fgc);
	}

	public void setBackground(Color bgc) {
		if (bgc!=null) {
			super.setBackground(bgc);
			if (lb!=null) {
				lb.setBackground(bgc);
//				lb.setBackground(labelColor);
			}
			if (TF!=null) {
				TF.setBackground(bgc);
			}
		} else {
			if (lb!=null) {
				lb.setBackground(labelColor);
			}
			if (TF!=null) {
				TF.setBackground(Color.white);
			}
		}
	}

	public void setFont(Font f) {
		super.setFont(f);
		if (lb!=null) {
			lb.setFont(f);
		}
		if (TF!=null) {
			TF.setFont(f);
		}
	}
	
	public void setFont(int hh) {
		String fname="SansSerif";
		int fstyle=Font.PLAIN;
		Font f=mjaFont.makeFont(fname,fstyle,BasicStr.fontSizeForHeight(hh));
		setFont(f);
	}

	public void updateFont() {
		if (!( (this instanceof ScrollBarControl) && ((ScrollBarControl) this).isVertical() )) {
			setFont(getSize().height);
		}
	}

	public void setSpace(String s) {
		space=s;
	}

	public boolean isInterior() {
		return interior;
	}

	public String getSpace() {
		return space;
	}

	public void setTitle(String tit) {
		title=tit;
		lb.setText(tit);
	}

	public String getTitle() {
		return title;
	}

	public void setDiscrete(boolean b) {
		discrete=b;
	}

	private Font expl_f,tooltip_f;

	public void setExplanation(String s,Font font) {
		explanation=s;
		expl_f=font;
	}

	public void setTooltip(String s,String more,Font font) {
		tooltip=s;
		tooltip_f=font;
		this.more=more;
		if (!BasicStr.hasContent(explanation)) {
			explanation=s;
		}
	}

	boolean TFhasFocus() {
		return TFhasFocus;
	}

	public final void updateFromNode() {
		if (var.getDouble()!=Double.NaN && var.getStr()==null) {
			setValue(var.getDouble());
		}
		updateVisualComponent();
		checkCorrect();
		checkActive();
	}

	public final void updateFromText() {
		defineValue(TF.getText());
	}
	
	public boolean isBeingEdited() {
		return TFhasFocus();
	}
	
	public String getStringValue(double d) {
		int p=precision();
		d=BasicStr.round(d,p);
		/* --------------- */
		String s="";
		if (notexp.Evaluate(0)>0) {
			s=BasicStr.notExp(d,p,fixed);
		} else {
			s= BasicStr.DoubleToString(d,p,fixed);
		}
		return s;
	}
	
	public int peso() {
		try {
			return BasicStr.parseInteger(ccfg.s_value[controlConfig.ixweight],1,1);
		} catch (Exception e) {
			return 1;
		}
	}
	
	private String aa;
	private boolean ba;
	
	private void checkCorrect() {
		String solution=D.p.getSolution(pattern);
		D.p.Var(getName()+".sol").setOnlyStr(solution);
		String answer=getStringValue().trim();
		if (!answer.equals(aa)) {
			if (BasicStr.hasContent(answer)) {
				ba=D.p.isCorrect(getName(),pattern,answer);
			} else {
				ba=false;
			}
			aa=answer;
		}
//		if (ba) {
//			D.p.Var(getName()+".ok").setDouble(1);
//		} else {
//			D.p.Var(getName()+".ok").setDouble(0);
//		}
	}

	public String getStringValue() {
		return getStringValue(var.getDouble());
	}

	public double getDoubleValue() {
		return var.getDouble();
	}

	public void defineValue(double d) {
		defineValue(Double.toString(d));
	}
	
	private boolean firstTime=true;
	
	public void defineValue(String s0) {
		boolean changed=false;
		if ((this instanceof textControl) && onlyText) {
			changed=!TF.getText().equals(s0);
			defineTextValue(s0);
		} else {
			String s=s0;
			if (s.equals("''")||s.equals("||")) {
				defineTextValue(s);
			} else {
				double d=var.getDouble();
				try {
					s=s.replace(',','.');
					Node N=D.p.Analyse("NumericControl "+getName(),s,true,true);
					double d0=d;
					d=N.Evaluate();
					if (N.getStr()==null && d!=Double.NaN) {
						setValue(d);
						changed=(d0!=d);
					}
				} catch (Exception exc) {
					if (this instanceof textControl) {
						if (firstTime) {
							onlyText=true;
						}
						changed=!TF.getText().equals(s0);
						defineTextValue(s0);
					} else {
	//					Comentado el 6 de mayo de 2009
	//					System.out.println("Error de sintaxis en: \""+s0+"\"");
	//					new Exception().printStackTrace();
					}
				}
			}
		}
		firstTime=false;
//		if (changed) {
			updateVisualComponent();
//		}
	}
	
	
	public void step(boolean up) {
		if (isActive()) {
//			double inc=dvN.Evaluate(0.01);
			int p=precision();
			double inc=Math.max(BasicStr.minIncr(p),dvN.Evaluate(0.01)); // para que siempre se pueda incrementar;
			double d=var.getDouble();
			double id=minN.Evaluate(minDouble);
			double sd=maxN.Evaluate(maxDouble);
			if (up) {
				d+=inc;
				if (d>sd) {
					Toolkit.getDefaultToolkit().beep();
					d=sd;
				}
			} else {
				d-=inc;
				if (d<id) {
					Toolkit.getDefaultToolkit().beep();
					d=id;
				}
			}
			setValue(d);
			if (Math.abs(var.getDouble())<Math.pow(10,-BasicStr.real_precision)) {
				var.setDouble(0);
			}
			updateFromNode();
		}
	}

	public double getMin() {
		return minN.Evaluate(minDouble);
	}

	public double getMax() {
		return maxN.Evaluate(maxDouble);
	}

	public double getIncr() {
		return dvN.Evaluate(0.01);
	}
	
/* ------------- private operation ------------- */

	protected int precision() {
		int p=p0;
		if (pvN!=null) {
			p=(int) Math.round(pvN.Evaluate(2));
		}
		return p;
	}

	protected void setValue(double d0) {
		double dd=d0;
		double id=minN.Evaluate(minDouble);
		double sd=maxN.Evaluate(maxDouble);
		if (dd<id) {
			dd=id;
		}
		if (dd>sd) {
			dd=sd;
		}
		int p=precision();
		if (discrete) {
			try {
				double dv0=dvN.Evaluate(0.1);
//				dd=v0+dv0*Math.round((dd-v0)/dv0);
				double V0=BasicStr.round(v0,p);
				double dV0=BasicStr.round(dv0,p);
				if (dV0!=0) {
					dd=V0+dV0*Math.round((dd-V0)/dV0);
				}
			} catch (Exception ex) {
			}
		}
		dd=BasicStr.round(dd,p);
		String s=getStringValue(dd);
		s=s.replace(',','.');
		try {
			dd=Double.parseDouble(s);
			var.setDouble(dd);
		} catch (Exception e) {
		}
		if (activityN!=null) {
			boolean aux=isActive();
		}
		checkCorrect();
	}
	
	/* -------------- Listeners ------------- */

	private void addActionListener(ActionListener al) {
		listeners.addElement(al);
	}

	public void removeActionListener(ActionListener al) {
		listeners.removeElement(al);
	}

	void callListeners(String arg) {
		Enumeration e=listeners.elements();
		while (e.hasMoreElements()) {
			ActionListener al=(ActionListener) e.nextElement();
			al.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,arg));
		}
	}
	
	/* ------------- Key Listener ------------ */

	public void keyTyped(KeyEvent e) {
	}
	public void keyPressed(KeyEvent e) {
		BasicStr.ShiftOn=e.isShiftDown();		
		BasicStr.CtrlOn=e.isControlDown();		
		if (isActive() && (e.getKeyCode()==e.VK_ENTER||e.getKeyCode()==e.VK_TAB)) {
			D.updateNodesFromControls();
			defineValue(TF.getText());
			D.updateTextFieldsFromNodes();
			executeAction();
			callListeners("");
			TF.setText(getStringValue());
			TF.repaint();
		}
	}
	public void keyReleased(KeyEvent e) {
		BasicStr.ShiftOn=false;
		BasicStr.CtrlOn=false;
	}

	/* -------------- Mouse Listener ------------- */

	private long T=0;

	public void mousePressed(MouseEvent e) {
		if (e.getSource()==lb) {
//			invalidate();
//			paintAll(getGraphics());
		}
		if (e.getSource()==TF) {
			TF.requestFocus();
		}
	}
	public void mouseReleased(MouseEvent e) {}
	public void mouseEntered (MouseEvent e) {
		if (e.getSource()==lb) {
			invalidate();
			paintAll(getGraphics());
		}
		if (isActive()) {
			if ((e.getSource()==lb || e.getSource() instanceof Button || e.getSource() instanceof mjaButton) && BasicStr.hasContent(tooltip) && T+3000<System.currentTimeMillis()) {
				T=System.currentTimeMillis();
				mjaGui.showTooltip(D.scene,(Component)e.getSource(),tooltip,more,tooltip_f);
			}
		}
	}
	public void mouseExited (MouseEvent e) {
		T=0;
	}
	
	private boolean inEC() {
		return getParent() instanceof com.mja.textedit.EditorCanvas;
	}
	
	public void mouseClicked (MouseEvent e) {
		if (isActive()) {
			if (e.getSource()==TF && e.getClickCount()==2) {
				Class cl=null;
				try {
					cl=Class.forName("com.mja.textedit.EditorCanvas");
				} catch (Exception ex) {
					cl=null;
				}
				if (cl==null || !inEC()) {
					useCalc(this);
				}
			} else if ( e.getModifiers()==MouseEvent.BUTTON3_MASK && BasicStr.hasContent(explanation) ) {
				e.consume();
				mjaText.msg((Component) e.getSource(),getTitle(),explanation,expl_f);
			}
		}
	}
	
	static void useCalc(NumericControl NC) {
		com.jla.calc.calcWin cw=new com.jla.calc.calcWin(true,(NC instanceof textControl));
		Point P=NC.TF.getLocationOnScreen();
		cw.setLocation(P.x-(cw.getSize().width-NC.TF.getSize().width)/2,Math.max(0,P.y-cw.getSize().height));
		cw.show();
		if (cw.getValue()!=null) {
			NC.var.setStrAndAnalyse(cw.getValue());
			NC.defineValue(cw.getValue());
			NC.updateFromNode();
		}
		cw.dispose();
	}

	public void focusLost(FocusEvent fe) {
		if (fe.getSource()==TF) {
			TFhasFocus=false;
		}
	}
	public void focusGained(FocusEvent fe) {
		if (fe.getSource()==TF) {
			TFhasFocus=true;
			TF.setSelectionStart(0);
			TF.setSelectionEnd(TF.getText().length());
		}
	}
	
	public void componentShown(ComponentEvent ce) {
		disableFocusTraversalKeys();
	}
	
	public void componentHidden(ComponentEvent ce) {
	}
	
	public void componentMoved(ComponentEvent ce) {
		disableFocusTraversalKeys();
	}
	
	public void componentResized(ComponentEvent ce) {
		updateFontAndSize();
		disableFocusTraversalKeys();
	}
	
}