/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.descgui;
/*------------------------------------------------------------*/
/*                        textControl                         */
/*                         (c)  MJA                           */
/*                     Septiembre de 2002                     */
/*------------------------------------------------------------*/
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import com.mja.util.*;
import com.mja.descartes.*;
import com.mja.gui.*;
import com.mja.parser.*;

public class textControl extends NumericControl implements FocusListener {

	public textControl(Descartes D,controlConfig ccfg,String ne,String nv,String s_p,boolean fixed,String s_v,String s_incr,String s_vmin,String s_vmax,boolean visible,String s_notexp,String vc,String ac) {
		super();
		init(D,ccfg,ne, nv, s_p, fixed, s_v, s_incr, s_vmin, s_vmax, visible, s_notexp,vc,ac);
		GridBagLayout gbl=new GridBagLayout();
		setLayout(gbl);
		GridBagConstraints c=new GridBagConstraints();
		c.insets=new Insets(0,0,0,0);
		c.fill=GridBagConstraints.BOTH;
		c.anchor=GridBagConstraints.NORTHWEST;
		c.gridwidth=1; c.gridheight=1;
		c.gridy=0; c.weighty=1.0;
		c.gridx=0; c.weightx=0.5;
		String tit=getTitle();
		if (BasicStr.hasContent(tit)) {
			add(lb,c); c.gridx++;
		}
		defineTextValue(s_v);
		add(TF,c);
	}
	
	public void setBounds(int x, int y, int w, int h) {
		super.setBounds(x,y,w,h);
		setLayout(null);
		int lbw=w/2;
		if (!TF.isVisible()) {
			lbw=w;
		}
		if (lbw<minlbw) {
			lbw=minlbw;
		}
		if (!BasicStr.hasContent(getTitle())) {
			lbw=0;
		}
		if (w-lbw<minTFw) {
			lbw=w-minTFw;
		}
		if (lbw<0) {
			lbw=0;
		}
		int TFx=lbw;
		int TFw=w-TFx;

		lb.setBounds(0,0,lbw,h);
		TF.setBounds(TFx,0,TFw,h);
	}

	public void setOnlyText(boolean onlyText) {
		this.onlyText=onlyText;
	}

	public void updateVisualComponent() {
		if ( TF!=null && (!getStringValue().equals(TF.getText())) ) {
			TF.setText(getStringValue());
			TF.repaint();
		}
	}

	public void defineTextValue(String s0) {
/* added in ver. 5.306 */
		if (Node.isVarName(s0)) {
//			System.out.println("defining "+s0+"="+var.getSymbol()+".value");
			D.p.defineExpr(s0,var.getSymbol()+".value");
		}

		var.setOnlyStr(s0);
		if (!"".equals(s0)) {
			if (var.getStr().startsWith("|") && var.getStr().endsWith("|")) {
				var.setStrAndAnalyse(BasicStr.trim(var.getStr(),'|'));
			} else if (var.getStr().startsWith("'") && var.getStr().endsWith("'")) {
				var.setStrAndAnalyse(BasicStr.trim(var.getStr(),'\''));
			} else if (onlyText) {
				var.setStrAndAnalyse(s0);
			} else if (!onlyText) {
				try {
					var.ns=D.p.Analyse(var.getStr());
					double d=var.ns.Evaluate();
					if (d!=Double.NaN && var.ns.getStr()==null) {
						var.setDouble(d);
					} else {
						var.setOnlyStr(var.ns.getStr());
					}
				} catch (Exception e) {
					var.setDouble(0);
				}
				setValue(var.getDouble());
			}
		}
		TF.setText(getStringValue());
	}
	
	protected void setValue(double d) {
		if (!onlyText) {
			super.setValue(d);
		} else {	// agregado el 100808, ver 4.104
			defineTextValue(Double.toString(d));
		}
	}

	public String getStringValue() {
		if (var.getStr()!=null) {
			return var.getStr();
		} else {
			return getStringValue(var.getDouble());
		}
	}

	/* -------------- Focus Listener ------------- */

	public void focusLost(FocusEvent fe) {
		super.focusLost(fe);
		if (fe.getSource()==TF) {
			if (var.getStr()!=null && BasicStr.hasContent(TF.getText())) {
				var.setOnlyStr(null);
				defineValue(TF.getText());
				updateVisualComponent();
			}
		}
	}
	
	public void stop() {
	}

	public void keyPressed(KeyEvent e) {
		if (isActive()) {
			if (e.getKeyCode()==e.VK_ENTER||e.getKeyCode()==e.VK_TAB) {
				if (var.getStr()!=null) {
					var.setOnlyStr(null);
				}
				super.keyPressed(e);
			}
		}
	}
}