/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.file;

import java.applet.Applet;
import java.awt.Point;
import java.awt.Dimension;
import java.util.*;
import java.io.*;

import com.mja.util.*;
import org.unam.matem.Attribute;

public final class mjaHtml {

/* -------------------- HTML Ecoding-Decoding ---------------- */

	/** Get the ascii representation of UNICODE string.
     *  @param value The string to convert.
     *  @return The string converted.
     */
 /*
    public static String getHTMLEncoding(String value){
		StringBuffer sb=new StringBuffer();
		for (int i=0; i<value.length(); i++) {
			char ch = value.charAt(i);
			int k=(int)ch-0xA1;
			if (k>=0 && k<HTMLcode.length) {
				sb.append(HTMLcode[k]);
			} else if (ch<255) {
				sb.append(ch);
			} else {
				sb.append("&#x"+Integer.toHexString(ch)+";");
			}
//			case '"'      :
//			case '<'      :
//			case '>'      : sb.append("&#"+Integer.toHexString(ch)+";"); break;
//			case '\n'     : sb.append("&#x000a;"); break;
		}
        return new String(sb);
    }
*/
    public static String decodeHTMLEncoding(String value) {
        if (!BasicStr.hasContent(value)) {
        	return value;
        }
		StringBuffer sb=new StringBuffer();
		int i=0;
		while (i<value.length()) {
			char ch = value.charAt(i++);
			if (ch=='&') {
				int j=value.indexOf(";",i);
				if (j>=0) {
					String test=value.substring(i-1,j+1);
					if (value.charAt(i)=='#') {
						if (j>i+1) {
							int k=-1;
							if (j>(i+2) && value.charAt(i+1)=='x') {
								try {
									k=Integer.valueOf(value.substring(i+2,j),16).intValue();
								} catch (NumberFormatException e) {
								}
							} else {
								String tst=value.substring(i+1,j);
								try {
									k=Integer.valueOf(tst,10).intValue();
								} catch (NumberFormatException e) {
									try {
										k=Integer.valueOf(tst,16).intValue();
									} catch (NumberFormatException nfe) {
									}
								}
							}
							if (k>=0&&k<65536) {
								ch=(char)k;
								i=j+1;
							}
						}
					} else {
						if (test.equals("&amp;")) {
							ch='&';	i=j+1;
						} else if (test.equals("&gt;")){
							ch='>';	i=j+1;
						} else if (test.equals("&lt;")){
							ch='<';	i=j+1;
						} else if (test.equals("&quot;")){
							ch='"';	i=j+1;
						} else {
							for (int k=0;k<HTMLcode.length;k++) {
								if (test.equals(HTMLcode[k])) {
									ch=(char) (0x00A1+k);
									i=j+1;
									break;
								}
							}
						}
					}
				}
			}
			sb.append(ch);
		}
		return sb.toString();
	}

	private static final String[] HTMLcode = {
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&curren;",
		"&yen;",
		"&brvbar;",
		"&sect;",
		"&uml;",
		"&copy;",
		"&ordf;",
		"&laquo;",
		"&not;",
		"&shy;",
		"&reg;",
		"&macr;",
		"&deg;",
		"&plusmn;",
		"&sup2;",
		"&sup3;",
		"&acute;",
		"&micro;",
		"&para;",
		"&middot;",
		"&cedil;",
		"&sup1;",
		"&ordm;",
		"&raquo;",
		"&frac14;",
		"&frac12;",
		"&frac34;",
		"&iquest;",
		"&Agrave;",
		"&Aacute;",
		"&Acirc;",
		"&Atilde;",
		"&Auml;",
		"&Aring;",
		"&AElig;",
		"&Ccedil;",
		"&Egrave;",
		"&Eacute;",
		"&Ecirc;",
		"&Euml;",
		"&Igrave;",
		"&Iacute;",
		"&Icirc;",
		"&Iuml;",
		"&ETH;",
		"&Ntilde;",
		"&Ograve;",
		"&Oacute;",
		"&Ocirc;",
		"&Otilde;",
		"&Ouml;",
		"&times;",
		"&Oslash;",
		"&Ugrave;",
		"&Uacute;",
		"&Ucirc;",
		"&Uuml;",
		"&Yacute;",
		"&THORN;",
		"&szlig;",
		"&agrave;",
		"&aacute;",
		"&acirc;",
		"&atilde;",
		"&auml;",
		"&aring;",
		"&aelig;",
		"&ccedil;",
		"&egrave;",
		"&eacute;",
		"&ecirc;",
		"&euml;",
		"&igrave;",
		"&iacute;",
		"&icirc;",
		"&iuml;",
		"&eth;",
		"&ntilde;",
		"&ograve;",
		"&oacute;",
		"&ocirc;",
		"&otilde;",
		"&ouml;",
		"&divide;",
		"&oslash;",
		"&ugrave;",
		"&uacute;",
		"&ucirc;",
		"&uuml;",
		"&yacute;",
		"&thorn;",
		"&yuml;",
    };
	
	public static String readUTF8(String filename) {
		return readUTF8(new File(filename));
	}
	
	public static String readUTF8(File f) {
//System.out.println("readUTF8: "+f.getName());
		try {
			FileInputStream fins=	new FileInputStream(f);
			InputStreamReader insr=new InputStreamReader(fins, "UTF-8");
			BufferedReader BR= new BufferedReader(insr);
			Vector V=new Vector();
			do {
				String str=BR.readLine();
//System.out.println(str);
				if (str==null) {
					break;
				}
				V.addElement(str);
			} while (true);
			BR.close();
			String content="";
			for (int i=0;i<V.size();i++) {
				if (i>0) {
					content+="\r\n";
				}
				content+=(String) V.elementAt(i);
			}
			return content;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}
	
	public static void writeInUTF8File(String content,String newfilestr) {
		try {
			newfilestr=newfilestr.replace("/",File.separator);
			newfilestr=newfilestr.replace("\\",File.separator);
			File newfile=new File(newfilestr);
			newfile.mkdirs();
			if (newfile.exists()) {
				newfile.delete();
			}

			String codeutf8="<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">";
			if ((content.toLowerCase().indexOf(codeutf8.toLowerCase())<0)
				&&  (!newfilestr.toLowerCase().endsWith("tex")) ) {
				int ix=content.toLowerCase().indexOf("<html>");
				if (ix>=0) {
					content=content.substring(0,ix+6)+"\r\n"+codeutf8+content.substring(ix+6);
				} else {
					content=codeutf8+"\r\n"+content;
				}
			}

// to write the BOM
//				char i1=0xEF;
//				char i2=0xBB;
//				char i3=0xBF;
//				String utf8Start="";
//				utf8Start+=i1;
//				utf8Start+=i2;
//				utf8Start+=i3;
//				content=(content.indexOf(utf8Start)!=0)?utf8Start+content:content;

			FileOutputStream fouts=	new FileOutputStream(newfilestr);
			OutputStreamWriter outsw=new OutputStreamWriter(fouts, "UTF-8");
			BufferedWriter out = new BufferedWriter(outsw);
			out.write(content);
			out.flush();
			out.close();

//			FileWriter fw=new FileWriter(newfile);
//			BufferedWriter BW=new BufferedWriter(fw);
//			BW.write(content,0,content.length());
//			BW.flush();
//			BW.close();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}	


/* -------- conservar para tener la tabla ----------------

    public static String getHTMLEncoding(String value){

		StringBuffer sb=new StringBuffer();
		for (int i=0; i<value.length(); i++) {
			char ch = value.charAt(i);
			switch (ch) {
			case '\u00A1' : sb.append("&iexcl;"); break;
			case '\u00A2' : sb.append("&cent;"); break;
			case '\u00A3' : sb.append("&pound;"); break;
			case '\u00A4' : sb.append("&curren;"); break;
			case '\u00A5' : sb.append("&yen;"); break;
			case '\u00A6' : sb.append("&brvbar;"); break;
			case '\u00A7' : sb.append("&sect;"); break;
			case '\u00A8' : sb.append("&uml;"); break;
			case '\u00A9' : sb.append("&copy;"); break;
			case '\u00AA' : sb.append("&ordf;"); break;
			case '\u00AB' : sb.append("&laquo;"); break;
			case '\u00AC' : sb.append("&not;"); break;
			case '\u00AD' : sb.append("&shy;"); break;
			case '\u00AE' : sb.append("&reg;"); break;
			case '\u00AF' : sb.append("&macr;"); break;
			case '\u00B0' : sb.append("&deg;"); break;
			case '\u00B1' : sb.append("&plusmn;"); break;
			case '\u00B2' : sb.append("&sup2;"); break;
			case '\u00B3' : sb.append("&sup3;"); break;
			case '\u00B4' : sb.append("&acute;"); break;
			case '\u00B5' : sb.append("&micro;"); break;
			case '\u00B6' : sb.append("&para;"); break;
			case '\u00B7' : sb.append("&middot;"); break;
			case '\u00B8' : sb.append("&cedil;"); break;
			case '\u00B9' : sb.append("&sup1;"); break;
			case '\u00BA' : sb.append("&ordm;"); break;
			case '\u00BB' : sb.append("&raquo;"); break;
			case '\u00BC' : sb.append("&frac14;"); break;
			case '\u00BD' : sb.append("&frac12;"); break;
			case '\u00BE' : sb.append("&frac34;"); break;
			case '\u00BF' : sb.append("&iquest;"); break;
			case '\u00C0' : sb.append("&Agrave;"); break;
			case '\u00C1' : sb.append("&Aacute;"); break;
			case '\u00C2' : sb.append("&Acirc;"); break;
			case '\u00C3' : sb.append("&Atilde;"); break;
			case '\u00C4' : sb.append("&Auml;"); break;
			case '\u00C5' : sb.append("&Aring;"); break;
			case '\u00C6' : sb.append("&AElig;"); break;
			case '\u00C7' : sb.append("&Ccedil;"); break;
			case '\u00C8' : sb.append("&Egrave;"); break;
			case '\u00C9' : sb.append("&Eacute;"); break;
			case '\u00CA' : sb.append("&Ecirc;"); break;
			case '\u00CB' : sb.append("&Euml;"); break;
			case '\u00CC' : sb.append("&Igrave;"); break;
			case '\u00CD' : sb.append("&Iacute;"); break;
			case '\u00CE' : sb.append("&Icirc;"); break;
			case '\u00CF' : sb.append("&Iuml;"); break;
			case '\u00D0' : sb.append("&ETH;"); break;
			case '\u00D1' : sb.append("&Ntilde;"); break;
			case '\u00D2' : sb.append("&Ograve;"); break;
			case '\u00D3' : sb.append("&Oacute;"); break;
			case '\u00D4' : sb.append("&Ocirc;"); break;
			case '\u00D5' : sb.append("&Otilde;"); break;
			case '\u00D6' : sb.append("&Ouml;"); break;
			case '\u00D7' : sb.append("&times;"); break;
			case '\u00D8' : sb.append("&Oslash;"); break;
			case '\u00D9' : sb.append("&Ugrave;"); break;
			case '\u00DA' : sb.append("&Uacute;"); break;
			case '\u00DB' : sb.append("&Ucirc;"); break;
			case '\u00DC' : sb.append("&Uuml;"); break;
			case '\u00DD' : sb.append("&Yacute;"); break;
			case '\u00DE' : sb.append("&THORN;"); break;
			case '\u00DF' : sb.append("&szlig;"); break;
			case '\u00E0' : sb.append("&agrave;"); break;
			case '\u00E1' : sb.append("&aacute;"); break;
			case '\u00E2' : sb.append("&acirc;"); break;
			case '\u00E3' : sb.append("&atilde;"); break;
			case '\u00E4' : sb.append("&auml;"); break;
			case '\u00E5' : sb.append("&aring;"); break;
			case '\u00E6' : sb.append("&aelig;"); break;
			case '\u00E7' : sb.append("&ccedil;"); break;
			case '\u00E8' : sb.append("&egrave;"); break;
			case '\u00E9' : sb.append("&eacute;"); break;
			case '\u00EA' : sb.append("&ecirc;"); break;
			case '\u00EB' : sb.append("&euml;"); break;
			case '\u00EC' : sb.append("&igrave;"); break;
			case '\u00ED' : sb.append("&iacute;"); break;
			case '\u00EE' : sb.append("&icirc;"); break;
			case '\u00EF' : sb.append("&iuml;"); break;
			case '\u00F0' : sb.append("&eth;"); break;
			case '\u00F1' : sb.append("&ntilde;"); break;
			case '\u00F2' : sb.append("&ograve;"); break;
			case '\u00F3' : sb.append("&oacute;"); break;
			case '\u00F4' : sb.append("&ocirc;"); break;
			case '\u00F5' : sb.append("&otilde;"); break;
			case '\u00F6' : sb.append("&ouml;"); break;
			case '\u00F7' : sb.append("&divide;"); break;
			case '\u00F8' : sb.append("&oslash;"); break;
			case '\u00F9' : sb.append("&ugrave;"); break;
			case '\u00FA' : sb.append("&uacute;"); break;
			case '\u00FB' : sb.append("&ucirc;"); break;
			case '\u00FC' : sb.append("&uuml;"); break;
			case '\u00FD' : sb.append("&yacute;"); break;
			case '\u00FE' : sb.append("&thorn;"); break;
			case '\u00FF' : sb.append("&yuml;"); break;
//			case '"'      :
//			case '<'      :
//			case '>'      : sb.append("&#"+Integer.toHexString(ch)+";"); break;
//			case '\n'     : sb.append("&#x000a;"); break;
			default       : sb.append(ch);
			}
		}
        return new String(sb);
    }
*/

/* ------------------- Applet HTML Code Parsing ------------------- */

	public static String getRelativeDocPath(Applet A) {
		String relDocPath="";
		if (A.getDocumentBase()!=null && A.getCodeBase()!=null) {
			String docbase=A.getDocumentBase().toExternalForm();
			String codebase=A.getCodeBase().toExternalForm();
//System.out.println("docbase="+docbase);
//System.out.println("docpath="+A.getDocumentBase().getPath());
//System.out.println("codebase="+codebase);
//System.out.println("codepath="+A.getCodeBase().getPath());
			if (docbase.startsWith(codebase)) {
				relDocPath=docbase.substring(codebase.length());
				int N=relDocPath.lastIndexOf("/");
				if (N>=0) {
					relDocPath="/"+relDocPath.substring(0,N)+"/";
				} else {
					relDocPath="/";
				}
			} else {
				relDocPath="/";
			}
		}
//System.out.println("relDocPath="+relDocPath);
		return relDocPath;
	}

/* ----- Label limits and attributes ------ */

	private static Point getLabelLimits(String label,String s) {
		String aux=s.toLowerCase();
		int N0=aux.indexOf("<"+label.toLowerCase());
		if (N0>=0) {
			int N1=aux.indexOf(">",N0);
			if (N1<0) {
				N1=aux.length();
			}
			return new Point(N0,N1);
		}
		return null;
	}

	public static String getAttribute(String s,String label,String attrname) {
		String attr="";
		Point P=getLabelLimits(label,s);
		if (P!=null) {
			String auxs=s.toLowerCase().substring(P.x+label.length()+1,P.y);
			attr=Attribute.getValueIgnoreCase(auxs,attrname.toLowerCase(),false);
			if (attr.startsWith("\"")) {
				attr=attr.substring(1,attr.length()-1);
			}
		}
		return attr;
	}

/* --------------- Applet information --------------- */

	public static Point[] getAppletCodeLimits(String s0) {
		String s=new String(s0);
		String aux=s.toLowerCase();
		Vector V=new Vector();
		int N0=0;
		while (true) {
			N0=aux.indexOf("<applet",N0);
			if (N0>=0) {
				int N1=aux.indexOf("</applet>",N0);
				if (N1<0) {
					N1=s.length();
				}
				N1+="</applet>".length();
				V.addElement(new Point(N0,N1));
				N0=N1; //+"</applet>".length();
			} else {
				break;
			}
		}
		Point[] P=new Point[V.size()];
		for (int i=0;i<P.length;i++) {
			P[i]=(Point) V.elementAt(i);
		}
		return P;
	}

	public static String getAppletAttribute(String s0,String attrname) {
		return getAppletAttribute(s0,attrname,false);
	}

	public static String getAppletAttribute(String s0,String attrname,boolean trimvalue) {
		String s=s0;
		int ix=s0.toUpperCase().indexOf("MAYSCRIPT");
		if (ix>0) {
			s=s0.substring(0,ix)+s0.substring(ix+"MAYSCRIPT".length());
		}
		int first="<applet ".length();
		int last=s.indexOf(">");
		String auxs=s.substring(first,last);
		String attr=Attribute.getValueIgnoreCase(auxs,attrname,trimvalue);
		if (attr.startsWith("\"")) {
			attr=attr.substring(1,attr.length()-1);
		}
		return attr;
	}

	public static Dimension getAppletSize(String s) throws Exception {
		Point p=getAttributeLimits(s,"width",0);
		String sw=s.substring(p.x,p.y);
		p=getAttributeLimits(s,"height",0);
		String sh=s.substring(p.x,p.y);
		int width=BasicStr.parseInteger(sw,640,640);
		int height=BasicStr.parseInteger(sh,480,480);
		return new Dimension(width,height);
	}

	public static Hashtable getAppletParams(String s) throws Exception {
		Hashtable ht=new Hashtable();
		String aux=s.toLowerCase();
		int n=0;
		while (true) {
			n=aux.indexOf("<param",n);
			if (0<=n) {
				n+="<param".length();
				String ps=null;
				int nn=aux.indexOf("<param",n);
				if (nn>=0) {
					int nnn=nn;
					int[] kk=new int[4];
					for (int k=0;k<4;k++) {
						nnn=aux.indexOf("\"",nnn+1);
						kk[k]=nnn;
					}
					if (nnn>=0 && nnn<nn && nnn<s.length()) {
						String name=s.substring(kk[0]+1,kk[1]);
						String value=s.substring(kk[2]+1,kk[3]);
						if ( (!ht.containsKey(name)) || (!"java_arguments".equals(name)) ) {
							ht.put(name,value);
						}
						continue;
					}
					nn=Math.max(nn,nnn);
					if (nn>aux.length()) {
						throw new Exception("invalid applet code");
					} else {
						ps=s.substring(n,nn); /* este corte reduce por mucho el tiempo de parseo */
					}
				} else {
					ps=s.substring(n);
				}
				Point p=getAttributeLimits(ps,"name",0);
				String name=ps.substring(p.x,p.y);
				p=getAttributeLimits(ps,"value",p.y);
				String value=ps.substring(p.x,p.y);
				if ( (!ht.containsKey(name)) || (!"java_arguments".equals(name)) ) {
					ht.put(name,value);
				}
				n+=p.y;
			} else {
				break;
			}
		}
		return ht;
	}

	private static Point getAttributeLimits(String s,String attr_name,int pos) throws Exception {
		String aux=s.toLowerCase();
		int n=aux.indexOf(attr_name.toLowerCase(),pos);
		if (0<=n) {
			n+=attr_name.length();
			n=s.indexOf("=",n);
			if (0<=n) {
				n++;
				while (n<s.length() && Character.isWhitespace(s.charAt(n))) {
					n++;
				}
				if (n<s.length()) {
					int k=n;
					if (s.charAt(n)=='"') {
						n++;
						k=s.indexOf("\"",n);
						if (0<=k) {
						} else {
							throw new Exception ("invalid applet code: \" missing.");
						}
					} else {
						while (k<s.length() && ! (Character.isWhitespace(s.charAt(k))||s.charAt(k)=='>') ) {
							k++;
						}
						if (k<s.length()) {
						} else {
							throw new Exception ("invalid applet code: invalid param name");
						}
					}
					return new Point(n,k);

				} else {
					throw new Exception ("invalid attribute code: info missing after "+attr_name);
				}

			} else {
				throw new Exception("invalid applet code: '=' missing after "+attr_name);
			}
		} else {
			throw new Exception("invalid applet code: "+attr_name+" missing ");
		}
	}

}