/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.gui;

import java.awt.*;
import java.awt.image.*;
import java.util.*;
import com.mja.lang.*;
import com.mja.parser.*;
import com.mja.util.BasicStr;

public class mjaColor {

	public static final Color DeepBlue=new Color(0x111166);

	public boolean var_r,var_g,var_b,var_t;
	public String s_r,s_g,s_b,s_t;
	public Node Nr,Ng,Nb,Nt;
	private Color fullColor,adaptedColor;
	private int transp=0;
	public static ColorModel cm;

	public mjaColor(Color c) {
		this(c,0);
	}

	public mjaColor(Color c,int transp) {
		this.transp=transp;
		fullColor=c;
		if (c!=null&&cm!=null&&cm.getPixelSize()==16) {
			int r=8*(c.getRed()/8);
			int g=8*(c.getGreen()/8);
			int b=8*(c.getBlue()/8);
			adaptedColor=new Color(r,g,b);
		} else {
			adaptedColor=c;
		}
		if (c!=null && BasicStr.isJava2() && transp>0) {
			int a=255-transp;
			adaptedColor=new Color(adaptedColor.getRed(),adaptedColor.getGreen(),adaptedColor.getBlue(),a);
			fullColor=new Color(fullColor.getRed(),fullColor.getGreen(),fullColor.getBlue(),a);
		}
		var_t=false;
		var_r=false;
		var_g=false;
		var_b=false;
	}

	public mjaColor(float fr,float fg,float fb,float transp) {
		this(new Color(bound(fr),bound(fg),bound(fb)),(int) (255*bound(transp)));
	}
	public mjaColor(int r,int g,int b,int a) {
		this(new Color(bound(r),bound(g),bound(b)),bound(a));
	}

	private mjaColor(String sr,String sg,String sb,String sa) {
		this(Color.black,0);
		s_r=sr;
		s_g=sg;
		s_b=sb;
		s_t=sa;
		try {
			Integer.parseInt(s_t,16);
			var_t=false;
		} catch (NumberFormatException nfe) {
			var_t=true;
		}
		try {
			Integer.parseInt(s_r,16);
			var_r=false;
		} catch (NumberFormatException nfe) {
			var_r=true;
		}
		try {
			Integer.parseInt(s_g,16);
			var_g=false;
		} catch (NumberFormatException nfe) {
			var_g=true;
		}
		try {
			Integer.parseInt(s_b,16);
			var_b=false;
		} catch (NumberFormatException nfe) {
			var_b=true;
		}
	}

	public static Color bestContrast(Color c) {
		if (c!=null) {
			int I=c.getBlue()+c.getRed()+c.getGreen();
			if (I<380) {
				return Color.white;
			} else {
				return Color.black;
			}
		} else {
			return Color.black;
		}
	}

	public int getTransp() {
		return transp;
	}

	public static Color scaleColor(float I,Color C) {
		if (BasicStr.isJava2()) {
			return mjaColor2.scaleColor(I,C);
		} else {
			return new Color(I*C.getRed(),I*C.getGreen(),I*C.getBlue());
		}
	}


	public static mjaColor make(String sr,String sg,String sb,String sa) {
		try {
			int r=0,g=0,b=0,a=0;
			r=Integer.parseInt(sr,16);
			g=Integer.parseInt(sg,16);
			b=Integer.parseInt(sb,16);
			a=Integer.parseInt(sa,16);
			return new mjaColor(r,g,b,a);
		} catch (NumberFormatException nfe) {
			return new mjaColor(sr,sg,sb,sa);
		}
	}

	public void analyse(Parser p) {
		int r=0,g=0,b=0,t=0;
		if (variable()) {
			try {
				t=Integer.parseInt(s_t,16);
				Nt=new Node(p,(double)t/(double)255);
			} catch (NumberFormatException nfe) {
				Nt=p.Analyse(s_t,0.0);
			}
			try {
				r=Integer.parseInt(s_r,16);
				Nr=new Node(p,(double)r/(double)255);
			} catch (NumberFormatException nfe) {
				Nr=p.Analyse(s_r,0.0);
			}
			try {
				g=Integer.parseInt(s_g,16);
				Ng=new Node(p,(double)g/(double)255);
			} catch (NumberFormatException nfe) {
				Ng=p.Analyse(s_g,0.0);
			}
			try {
				b=Integer.parseInt(s_b,16);
				Nb=new Node(p,(double)b/(double)255);
			} catch (NumberFormatException nfe) {
				Nb=p.Analyse(s_b,0.0);
			}
		}
	}
	
	public boolean variable() {
		return (var_t || var_r || var_g || var_b);
	}

	public Color getFullColor() {
		return fullColor;
	}
	public Color getAdaptedColor() {
		if (!variable()) {
			return adaptedColor;
		} else if (Nr!=null && Ng!=null && Nb!=null) {
			if (BasicStr.isJava2() && Nt!=null) {
				return mjaColor2.makeColor(bound((float)Nr.Evaluate(0)),
								 bound((float)Ng.Evaluate(0)),
								 bound((float)Nb.Evaluate(0)),
								 bound((float)Nt.Evaluate(0)));
			} else {
				return new Color(bound((float)Nr.Evaluate(0)),
								 bound((float)Ng.Evaluate(0)),
								 bound((float)Nb.Evaluate(0)) );
			}
		} else {
			return Color.black;
		}
	}

	static int bound(int i) {
		return Math.min(255,Math.max(0,i));
	}

	static float bound(float f) {
		return Math.min((float)1,Math.max(0,f));
	}

/* ----------------------- Color ---------------------- */

	public static final Color[] namedColor={
		Color.black,
		Color.magenta,  Color.blue,  Color.cyan,  Color.green,
		Color.yellow, Color.orange,  Color.red,   Color.pink,
		Color.darkGray, Color.gray,  Color.lightGray, Color.white
	};

	public static String rgbHex(int n) {
		String s=Integer.toString(n,16);
		while (s.length()<2) {
			s="0"+s;
		}
		return s;
	}

	public static String getOnlyNamedColor(translator Tr,mjaColor c) {
		if (c==null) {
			return "";
		}
		if (c.variable()) {
			return "";
		}
		if (c.getFullColor()!=null) {
			for (int i=0;i<namedColor.length;i++) {
				if (c.getFullColor().equals(namedColor[i])) {
					return Tr.getColorName(i);
				}
			}
		}
		return "";
	}
	
	public boolean isEqualTo(Color c) {
		return ( (fullColor.getRed()==c.getRed()) && (fullColor.getGreen()==c.getGreen()) &&(fullColor.getBlue()==c.getBlue()) );
	}

	public static String getColorName(translator Tr,mjaColor c) {
		if (c==null) {
			return "";
		}
		if (c.variable()) {
			return "("+c.s_r+","+c.s_g+","+c.s_b+","+c.s_t+")";
		} else {
			if (c.getFullColor()!=null) {
				for (int i=0;i<namedColor.length;i++) {
					if (c.getFullColor().equals(namedColor[i])) {
						return Tr.getColorName(i);
					}
				}
				Color C=c.getFullColor();
				String s=rgbHex(C.getRed())+rgbHex(C.getGreen()) +rgbHex(C.getBlue());
				if (c.transp>0) {
					s=rgbHex(c.transp)+s;
				}
				return s;
			} else {
				return "";
			}
		}
	}

	public static mjaColor parseColor(String s,mjaColor defcol,mjaColor nullcol)	{
		return parseColor(-1,s,defcol,nullcol);
	}

	public static mjaColor parseColor(int language,String s,mjaColor defcol,mjaColor nullcol)	{
		if (BasicStr.hasContent(s)) {
			if (language>=0) {
				for (int i=0;i<translator.colorName[language].length;i++) {
					if (s.equalsIgnoreCase(translator.colorName[language][i])) {
						return new mjaColor(namedColor[i],0);
					}
				}
			}
			for (int L=0;L<data.numLang;L++) {
				for (int i=0;i<translator.colorName[L].length;i++) {
					if (s.equalsIgnoreCase(translator.colorName[L][i])) {
						return new mjaColor(namedColor[i],0);
					}
				}
			}
			try {
				long c=Long.parseLong(s,16);
				int transp=(int)(c/(65536*256));
				c=c%(65536*256);
				return new mjaColor(new Color((int)c),transp);
			}
			catch (NumberFormatException nfe) {
				try {
					String[] cols=BasicStr.getTokens(s);
					if (cols.length==4) {
						return new mjaColor(cols[0],cols[1],cols[2],cols[3]);
					} else if (cols.length==3) {
						return new mjaColor(cols[0],cols[1],cols[2],"0.0");
					}
				} catch (Exception e) {
				}
			}
			return defcol;
		}
		return nullcol;
	}

}