/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.guiedit;

import java.awt.*;
import java.awt.event.*;
import com.mja.util.BasicStr;
import com.mja.gui.*;
import com.mja.descgui.*;
import com.mja.lang.*;
import com.mja.util.*;
import com.mja.file.mjaFont;

public class editColorDialog extends editDialog implements AdjustmentListener, ItemListener,
	KeyListener, ActionListener, Explainer {

	private MouseCursorHandler mch;

	public mjaColor color;

	private Canvas can;
	private Scrollbar sb_r,sb_g,sb_b,sb_t;
	private TextField tf_r,tf_g,tf_b,tf_t;
	private Choice ch_c;
	private translator Tr;
	private Button bc,bp,bhelp;
	private static mjaColor lastCopied=new mjaColor(0,0,0,0);
	private Label lr,lg,lb,lt;
	private Panel NP;

	public editColorDialog(Frame parent,String title,boolean modal,String okLabel,String cancelLabel) {
		super(parent,title,modal,okLabel,cancelLabel);
		mch=new MouseCursorHandler(this,this);
		NP=new Panel();
		NP.setBackground(Color.lightGray);
		add("North",NP);
		NP.add(bc=new Button("copy"));
		NP.add(ch_c=new Choice());
		NP.add(bp=new Button("paste"));
		NP.add(bhelp=new Button("?"));
		bc.addActionListener(this);
		bp.addActionListener(this);
		bhelp.addActionListener(this);
		ch_c.addItem("");
		ch_c.addItemListener(this);
		Panel cp=new Panel();
		cp.setBackground(Color.white);
		cp.setFont(mjaFont.AWTMono);
		cp.setLayout(new GridLayout(4,2));
		add("Center",cp);
		sb_t = new Scrollbar(Scrollbar.HORIZONTAL,255,1,0,256);
		sb_r = new Scrollbar(Scrollbar.HORIZONTAL,255,1,0,256);
		sb_g = new Scrollbar(Scrollbar.HORIZONTAL,255,1,0,256);
		sb_b = new Scrollbar(Scrollbar.HORIZONTAL,255,1,0,256);
		sb_t.setForeground(Color.lightGray);
		sb_r.setForeground(Color.red);
		sb_g.setForeground(Color.green);
		sb_b.setForeground(Color.blue);
		cp.add(tf_t=new TextField(16));
		cp.add(sb_t);
		cp.add(tf_r=new TextField(16));
		cp.add(sb_r);
		cp.add(tf_g=new TextField(16));
		cp.add(sb_g);
		cp.add(tf_b=new TextField(16));
		cp.add(sb_b);
		tf_t.addMouseListener(mch);
		tf_r.addMouseListener(mch);
		tf_g.addMouseListener(mch);
		tf_b.addMouseListener(mch);
		sb_t.addMouseListener(mch);
		sb_r.addMouseListener(mch);
		sb_g.addMouseListener(mch);
		sb_b.addMouseListener(mch);
		ch_c.addMouseListener(mch);
		bc.addMouseListener(mch);
		bp.addMouseListener(mch);
		bhelp.addMouseListener(mch);
		Panel wp=new Panel();
		add("West",wp);
		wp.setFont(mjaFont.AWTMono);
		wp.setLayout(new GridLayout(4,1));
		lt=new Label("transp"); lt.setBackground(Color.lightGray); wp.add(lt); lt.addMouseListener(mch);
		lr=new Label("     "); lr.setBackground(Color.red);	wp.add(lr); lr.addMouseListener(mch);
		lg=new Label("     "); lg.setBackground(Color.green); wp.add(lg); lg.addMouseListener(mch);
		lb=new Label("     "); lb.setBackground(Color.blue); wp.add(lb); lb.addMouseListener(mch);
		add("East",can=new Canvas());
		can.addMouseListener(mch);
		can.setSize(80,92);
		enableListener(true);
		tf_t.addKeyListener(this);
		tf_r.addKeyListener(this);
		tf_g.addKeyListener(this);
		tf_b.addKeyListener(this);
		color=new mjaColor(0,0,0,0);
	}

	private void enableListener(boolean b) {
		if (b) {
			ch_c.addItemListener(this);
			sb_t.addAdjustmentListener(this);
			sb_r.addAdjustmentListener(this);
			sb_g.addAdjustmentListener(this);
			sb_b.addAdjustmentListener(this);
		} else {
			ch_c.removeItemListener(this);
			sb_t.removeAdjustmentListener(this);
			sb_r.removeAdjustmentListener(this);
			sb_g.removeAdjustmentListener(this);
			sb_b.removeAdjustmentListener(this);
		}
	}

	public void setColorNames(translator Tr) {
		this.Tr=Tr;
		NP.remove(bhelp);
		NP.remove(bp);
		NP.remove(ch_c);
		ch_c=new Choice();
		ch_c.addItem("");
		for (int i=0;i<translator.numColors;i++) {
			ch_c.addItem(Tr.getColorName(i));
		}
		ch_c.addItemListener(this);
		ch_c.addMouseListener(mch);
		NP.add(ch_c);
		NP.add(bp);
		NP.add(bhelp);
		NP.repaint();
	}

	public void setCopyLabels(String copy,String paste) {
		bc.setLabel(copy);
		bp.setLabel(paste);
	}

	public mjaColor getMjaColor() {
		color=mjaColor.make(tf_r.getText(),tf_g.getText(),tf_b.getText(),tf_t.getText());
		return color;
	}

	public void setMjaColor(mjaColor col) {
		color=col;
		updateAll();
	}

	private boolean updating=false;

	private boolean isUpdating() {
		return updating;
	}

	private void updateAll() {
		if (!isUpdating()) {
			updating=true;
			enableListener(false);
			if (color.variable()) {
				tf_t.setText(color.s_t);
				tf_r.setText(color.s_r);
				tf_g.setText(color.s_g);
				tf_b.setText(color.s_b);
				try {
					sb_t.setValue(Integer.parseInt(color.s_t,16));
				} catch (NumberFormatException e) {
					sb_t.setValue(0);
				}
				try {
					sb_r.setValue(Integer.parseInt(color.s_r,16));
				} catch (NumberFormatException e) {
					sb_r.setValue(0);
				}
				try {
					sb_g.setValue(Integer.parseInt(color.s_g,16));
				} catch (NumberFormatException e) {
					sb_g.setValue(0);
				}
				try {
					sb_b.setValue(Integer.parseInt(color.s_b,16));
				} catch (NumberFormatException e) {
					sb_b.setValue(0);
				}
			} else {
				String cn=mjaColor.getOnlyNamedColor(Tr,color);
				if (BasicStr.hasContent(cn)) {
					ch_c.select(cn);
				} else {
					ch_c.select(0);
				}
				Color fullc=color.getFullColor();				
				int transp=color.getTransp();
				if (fullc==null) {
					fullc=Color.gray;
					transp=0;
				}
				sb_t.setValue(transp);
				sb_r.setValue(fullc.getRed());
				sb_g.setValue(fullc.getGreen());
				sb_b.setValue(fullc.getBlue());

				tf_r.setText(mjaColor.rgbHex(fullc.getRed()));
				tf_g.setText(mjaColor.rgbHex(fullc.getGreen()));
				tf_b.setText(mjaColor.rgbHex(fullc.getBlue()));
				tf_t.setText(mjaColor.rgbHex(transp));
				can.setBackground(fullc);
				can.repaint();
			}
			enableListener(true);
			updating=false;
		}
	}

	private long ta=0;
	public void adjustmentValueChanged(AdjustmentEvent e) {
		long TA=System.currentTimeMillis();
		if (TA-ta>100) {
			ta=TA;
			if (!isUpdating()) {
				if ((e.getSource()==sb_r)||(e.getSource()==sb_g)||
					(e.getSource()==sb_b)||(e.getSource()==sb_t)) {
					if (e.getSource()==sb_r) {
						int r=sb_r.getValue();
						if (r>0xff) r=0xff;
						tf_r.setText(mjaColor.rgbHex(r));
					} else if (e.getSource()==sb_g) {
						int g=sb_g.getValue();
						if (g>0xff) g=0xff;
						tf_g.setText(mjaColor.rgbHex(g));
					} else if (e.getSource()==sb_b) {
						int b=sb_b.getValue();
						if (b>0xff) b=0xff;
						tf_b.setText(mjaColor.rgbHex(b));
					} else if (e.getSource()==sb_t) {
						int a=sb_t.getValue();
						if (a>0xff) a=0xff;
						tf_t.setText(mjaColor.rgbHex(a));
					}
					color=mjaColor.make(tf_r.getText(),tf_g.getText(),tf_b.getText(),tf_t.getText());
					updateAll();
				}
			}
		}
	}

	private long ti=0;
	public void itemStateChanged(ItemEvent e) {
		long TI=System.currentTimeMillis();
		if (TI-ti>100 ) {
			ti=TI;
			if (!isUpdating()) {
				if (e.getStateChange()==ItemEvent.SELECTED) {
					if (e.getSource()==ch_c) {
						color=Tr.parseColor(ch_c.getSelectedItem(),color,color);
						updateAll();
					}
				}
			}
		}
	}

	public void actionPerformed(ActionEvent e) {
		if (!isUpdating()) {
			if (!mch.isHand()) {
				if (e.getSource()==bc) {
					lastCopied=getMjaColor();
				} else if (e.getSource()==bp) {
					color=lastCopied;
					updateAll();
				} else if (e.getSource()==bhelp) {
					mch.setHand();
				}
			}
		}
	}

	public void keyPressed(KeyEvent e) {
		if (!isUpdating()) {
			if ((e.getSource() instanceof TextField) && (e.getKeyCode()==KeyEvent.VK_ENTER)) {
				color=mjaColor.make(tf_r.getText(),tf_g.getText(),tf_b.getText(),tf_t.getText());
				updateAll();
			}
		}
	}
	public void keyReleased(KeyEvent e) {}
	public void keyTyped(KeyEvent e) {}

/* ---------------- Explainer ------------- */

	public String getExplLabel(MouseEvent e) {
		Component c=(Component) e.getSource();
		if (c instanceof Label) {
			Label l=(Label) c;
			return "Componente del color";
		} else if (c instanceof TextField) {
			TextField tf=(TextField) c;
			return "Componente del color";
		} else if (c instanceof Scrollbar) {
			Scrollbar sb=(Scrollbar) c;
			return "Componente del color";
		} else if (c instanceof Button) {
			Button b=(Button) c;
			return b.getLabel();
		} else if (c instanceof Choice) {
			return "Selector de color por nombre";
		} else if (c instanceof Canvas) {
			return "Color actual";
		}
		return "";
	}

	public String getExplanation(MouseEvent e) {
		String[] sa=null;
		Component c=(Component) e.getSource();
		if (c instanceof Label) {
			Label l=(Label) c;
			if (l==lt) {
				sa=Expl.EditColor[0]; // transp
			} else if (l==lr) {
				sa=Expl.EditColor[1]; // red
			} else if (l==lg) {
				sa=Expl.EditColor[2]; // green
			} else if (l==lb) {
				sa=Expl.EditColor[3]; // blue
			}
		} else if (c instanceof TextField) {
			TextField tf=(TextField) c;
			if (tf==tf_t) {
				sa=Expl.EditColor[0]; // transp
			} else if (tf==tf_r) {
				sa=Expl.EditColor[1]; // red
			} else if (tf==tf_g) {
				sa=Expl.EditColor[2]; // green
			} else if (tf==tf_b) {
				sa=Expl.EditColor[3]; // blue
			}
		} else if (c instanceof Scrollbar) {
			Scrollbar sb=(Scrollbar) c;
			if (sb==sb_t) {
				sa=Expl.EditColor[0]; // transp
			} else if (sb==sb_r) {
				sa=Expl.EditColor[1]; // red
			} else if (sb==sb_g) {
				sa=Expl.EditColor[2]; // green
			} else if (sb==sb_b) {
				sa=Expl.EditColor[3]; // blue
			}
		} else if (c instanceof Button) {
			Button b=(Button) c;
			if (b==bc) {
				sa=Expl.EditColor[4]; // copy
			} else if (b==bp) {
				sa=Expl.EditColor[5]; // paste
			} else if (b==bhelp) {
				sa=Expl.EditColor[6]; // help
			}
		} else if (c instanceof Choice) {
			Choice ch=(Choice) c;
			if (ch==ch_c) {
				sa=Expl.EditColor[7]; // choose color by name
			}
		} else if (c instanceof Canvas) {
			Canvas ca=(Canvas) c;
			if (ca==can) {
				sa=Expl.EditColor[8]; // color actual
			}
		}
		return com.mja.lang.Expl.get(sa,Tr.getActiveLanguage());
	}

}