/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.img;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.applet.*;

public class imageCanvas extends Canvas implements MouseListener {

	private Image ima,back;
	private Applet A;
	private String uri;
	private URL url;

	public imageCanvas(Image ima,Component C) {
		this.ima=ima;
	}

	public imageCanvas() {
		this.ima=null;
	}

	public void setImage(Image ima) {
		this.ima=ima;
	}

	public Image getImage() {
		return ima;
	}
	
	public void setHyperlink(Applet A,String uri) {
		try {
			this.A=A;
			this.uri=uri;
			url=new URL(uri);
			addMouseListener(this);
			setCursor(new Cursor(Cursor.HAND_CURSOR));
		} catch (MalformedURLException e) {
		}
	}

	public void paint(Graphics g) {
		int w=getSize().width;
		int h=getSize().height;
		if (ima!=null&&g!=null) {
			if (back==null||back.getWidth(this)!=w||back.getHeight(this)!=h) {
				back=createImage(Math.max(w,1),Math.max(h,1));
			}
			int wima=ima.getWidth(this);
			int hima=ima.getHeight(this);
			if (wima<=w && hima<=h) {
			} else {
				int nhima=h;
				int nwima=(int)((double)nhima*((double)wima/(double)hima));
				if (nwima>w || nhima>h) {
					nwima=w;
					nhima=(int)((double)nwima*((double)hima/(double)wima));
				}
				wima=nwima;
				hima=nhima;
				if (wima>w || hima>h) {
					System.out.println("!!!!!");
				}
			}
			int x=(w-wima)/2;
			int y=(h-hima)/2;
			Graphics bg=back.getGraphics();
//			((Graphics2D)bg).setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			bg.setColor(getBackground());
			bg.fillRect(0,0,w,h);
			bg.drawImage(ima,x,y,wima,hima,this);
			g.drawImage(back,0,0,this);
		}
	}
	
	public void mouseExited(MouseEvent e) {
		A.getAppletContext().showStatus("");
	}

	public void mouseEntered(MouseEvent e) {
		A.getAppletContext().showStatus(uri);
	}

	public void mouseClicked(MouseEvent e) {
	}

	public void mousePressed(MouseEvent e) {
	}

	public void mouseReleased(MouseEvent e) {
		A.getAppletContext().showDocument(url,"_blank");
	}


}