/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.lang;

/*------------------------------------------------------------*/
/*                        translator                          */
/*                          (c) MJA                           */
/*------------------------------------------------------------*/

import java.util.*;
import java.awt.*;
import java.applet.Applet;
import java.net.URL;
import com.mja.parser.*;
import org.unam.matem.Attribute;
import com.mja.util.BasicStr;
import com.mja.gui.mjaColor;
import com.mja.gui.mjaText;
import com.mja.file.mjaFont;
import com.mja.file.mjaFile;
import com.jla.nippe.NotSoAbstractNippe;

public class translator {


	private static boolean initialized=false;
	private static String idiomasPath="resources/idiomas/",
							indexPath=idiomasPath+"Tr__index.txt";

	public translator(Applet A) {
		if (!initialized) {
			initialized=initialize(A);
		}
	}
	
	private static String[][] newName;
	private int language;

	synchronized private static boolean initialize(Applet A) {
		try {
			String filenames="";
			try {
				filenames=mjaFile.getResource(A,indexPath);
			} catch (Exception e0) {
				System.out.println("No languages for translator");
			}
			String[] filename = BasicStr.toStringArray(filenames);
			data.numLang=0;
			Expl.langs=new String[filename.length];
			for (int j=0;j<filename.length;j++) {
				Expl.langs[j]=filename[j].substring(3,filename[j].length()-4);
				if (BasicStr.hasContent(filename[j].trim())) {
//					try {
//						String datos=mjaFile.getResource(A,idiomasPath+filename[j]);
//						if (BasicStr.hasContent(datos)) {
//						}
//					} catch (Exception ex1) {
//					}
					data.numLang++;
				}
			}
			newName = new String[data.numLang][data.NN];
			int ND=data.NN;
			int L=0;
			for (int j=0;j<filename.length;j++) {
				if (BasicStr.hasContent(filename[j].trim())) {
					int i = 0;
					try {
						String datos=mjaFile.getResource(A,idiomasPath+filename[j]);
						if (BasicStr.hasContent(datos)) {
							String[] data = BasicStr.toStringArray(datos);
							for (i = 0;i<ND;i++) {
								newName[L][i]="";
								if (i<data.length) {
									int ix = data[i].indexOf(":");
									if (
											ix > 0 // No se encontraron el separador ":"  
											&& (ix+2) <= data[i].length() // Hay un acadena vacia en las traducciones
										) {
										String auxs = data[i].substring(ix+2);
										newName[L][i]=BasicStr.replace(auxs,"\\n","\n");
									}
								}
							}
						} else {
							for (i = 0;i<ND;i++) {
								newName[L][i]=(L>0)?newName[0][i]:"?";
							}
						}
					} catch (Exception ex2) {
						for (i = 0;i<ND;i++) {
							newName[L][i]=(L>0)?newName[0][i]:"?";
						}
					}
					L++;
				}
			}
			if (colorName==null) {
				colorName=new String[data.numLang][numColors];
				for (int j=0;j<data.numLang;j++) {
					for (int i=0;i<numColors;i++) {
						colorName[j][i]=newName[j][data.black+i];
					}
				}
			}
			return true;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return false;
	}

	static public final int numColors=1+data.white-data.black;

	public static String[][] colorName;

	public void setActiveLanguage(int L) {
		language=L;
	}

	public int getActiveLanguage() {
		return language;
	}

	public String getTr(int num) { 
		String translation = newName[language][num]; 
		return translation;
	}

	public String getTr(int num,int L) {
		String translation = newName[Math.min(L,data.numLang-1)][num];; 
		return translation;
	}
	
	public int guessOriginalLanguageFromName(int ix,String name) {
		for (int i=0;i<newName.length;i++) {
			if (newName[i][ix].equals(name)) {
				return i;
			}
		}
		return language;
	}

	public String getLanguageName(int L) {
		return newName[L][data.langName];
	}

	public String getColorName(int num) {
		return colorName[language][num];
	}
	

	public Attribute getParam(Applet A,int pix) {
		String s=A.getParameter(newName[language][pix]);
		if (!BasicStr.hasContent(s)) {
			s="";
			for (int l=0;l<data.numLang;l++) {
				String auxs=A.getParameter(newName[l][pix]);
				if (BasicStr.hasContent(auxs)) {
					s=auxs;
					break;
				}
			}
		}
		return new Attribute(newName[language][pix],s);
	}

	public int getLanguage(String lang) {
		if (BasicStr.hasContent(lang)) {
			for (int j=0;j<data.numLang;j++) {
				String lanAct = newName[j][data.langName];
				if (BasicStr.equalsIgnoreAccents(lanAct,lang)) {
					return j;
				}
			}
		}
		return data.defLang;
	}


	public String booleanName(boolean b) {
		if (b) {
			return newName[language][data.Yes];
		} else {
			return newName[language][data.No];
		}
	}

/* ------------------------------------------------------------------- */

	private static boolean equals(String s,String prefix,int n) {
		for (int L=0;L<data.numLang;L++) {
			boolean b=BasicStr.equalsIgnoreAccents(s,prefix+newName[L][n]);
			if (b) {
				return true;
			}
		}
		return false;
	}

	public static boolean equals(String s,int n) {
		return equals(s,"",n);
	}

	private static boolean equalsIgnoreCase(String s,String prefix,int n) {
		for (int L=0;L<data.numLang;L++) {
			boolean b=BasicStr.equalsIgnoreAccents(s.toLowerCase(),prefix.toLowerCase()+newName[L][n].toLowerCase());
			if (b) {
				return true;
			}
		}
		return false;
	}

	public static boolean equalsIgnoreCase(String s,int n) {
		return equalsIgnoreCase(s,"",n);
	}

/* Ojo en Descartes isTrue se cambi el 26 de Octubre de 2005. */

//	public static boolean isTrue(String p) {
//		if (BasicStr.hasContent(p)) {
//			return equals(p,data.True)||equals(p,data.Yes);
//		} else {
//			return false;
//		}
//	}

/* Ojo en Descartes isTrue,isFalse & isNotFalse se cambi el 12 de Febrero de 2007. */

	public static boolean isTrue(String p) {
		return isTrue(p,false);
	}

	public static boolean isTrue(String p,boolean nullvalue) {
		if (BasicStr.hasContent(p)) {
			return equals(p,data.True)||equals(p,data.Yes)||p.equalsIgnoreCase("y")||p.equalsIgnoreCase("s")||p.equalsIgnoreCase("t");
		}
		return nullvalue;
	}

	public static boolean isFalse(String p) {
		if (BasicStr.hasContent(p)) {
			return equals(p,data.False)||equals(p,data.No)||p.equalsIgnoreCase("n")||p.equalsIgnoreCase("f");
		}
		return false;
	}

	public static boolean isNotFalse(String p) {
		if (BasicStr.hasContent(p)) {
			return !(equals(p,data.False)||equals(p,data.No)||p.equalsIgnoreCase("n")||p.equalsIgnoreCase("f"));
		}
		return true;
	}

/* ------------------- getValue methods -------------------- */

	public Attribute getAttribute(Attribute[] aa,int attrix) {
		return new Attribute(getTr(attrix),getValue(aa,attrix));
	}

	public String getValue(Attribute[] aa,int attrix) {
		return getValue(aa,attrix,"");
	}

	public String getValue(Attribute[] aa,int attrix,String def) {
		return getValue(aa,"",attrix,def);
	}

	public String getValue(Attribute[] aa,String prefix,int attrix,String def) {
		if (aa!=null) {
			for (int i=0;i<aa.length;i++) {
				if (BasicStr.equalsIgnoreAccents(aa[i].name,prefix+newName[language][attrix])) {
					return aa[i].value;
				}
			}
			for (int i=0;i<aa.length;i++) {
				if (equals(aa[i].name,prefix,attrix)) {
					return aa[i].value;
				}
			}
		}
		return def;
	}

/* ---------------- parse local types -------------- */

	public int getIndex(int[] ixa,String s,int defval) {
		for (int i=0;i<ixa.length;i++) {
			if (BasicStr.equalsIgnoreAccents(s,newName[language][ixa[i]])) {
				return ixa[i];
			}
		}
		for (int i=0;i<ixa.length;i++) {
			if (equals(s,ixa[i])) {
				return ixa[i];
			}
		}
		return defval;
	}

	public mjaColor parseColor(String s,mjaColor defcol,mjaColor nullcol) {
		if (isTrue(s)) {
			return defcol;
		} else if (BasicStr.hasContent(s)&&isNotFalse(s)) {
			mjaColor c=mjaColor.parseColor(language,s,null,null);
			if (c!=null && c.getAdaptedColor()!=null) {
				return c;
			}
			return defcol;
		} else {
			return nullcol;
		}
	}

	public static final Color[] namedColor={
		Color.black,
		Color.magenta,  Color.blue,  Color.cyan,  Color.green,
		Color.yellow, Color.orange,  Color.red,   Color.pink,
		Color.darkGray, Color.gray,  Color.lightGray, Color.white
	};

	public Color ParseColor(String s,Color defcol,Color nullcol) {
		if (isTrue(s)) {
			return defcol;
		} else if (BasicStr.hasContent(s)&&isNotFalse(s)) {
			return ParseColor(language,s,defcol,nullcol);
		} else {
			return nullcol;
		}
	}

	public static Color ParseColor(int language,String s,Color defcol,Color nullcol)	{
		if (BasicStr.hasContent(s)) {
			if (language>=0) {
				for (int i=0;i<colorName[language].length;i++) {
					if (s.equalsIgnoreCase(colorName[language][i])) {
						return namedColor[i];
					}
				}
			}
			for (int L=0;L<data.numLang;L++) {
				for (int i=0;i<colorName[L].length;i++) {
					if (s.equalsIgnoreCase(colorName[L][i])) {
						return namedColor[i];
					}
				}
			}
			try {
				long c=Long.parseLong(s,16);
				int transp=(int)(c/(65536*256));
				c=c%(65536*256);
				return new Color((int)c);
			} catch (NumberFormatException nfe) {
				try {
					int r=0,g=0,b=0,a=0;
					String[] cols=BasicStr.getTokens(s);
					r=Integer.parseInt(cols[0],16);
					g=Integer.parseInt(cols[1],16);
					b=Integer.parseInt(cols[2],16);
					return new Color(r,g,b);
				} catch (Exception e) {
				}
			}
			return defcol;
		}
		return nullcol;
	}

	public static int parseLocation(String s) {
		if (BasicStr.hasContent(s)) {
			if (equals(s,data.center)) {
				return mjaText.center;
			} else if (equals(s,data.top_left)) {
				return mjaText.top_left;
			} else if (equals(s,data.top_center)) {
				return mjaText.top;
			} else if (equals(s,data.top_right)) {
				return mjaText.top_right;
			} else if (equals(s,data.center_left)) {
				return mjaText.left;
			} else if (equals(s,data.right)) {
				return mjaText.right;
			} else if (equals(s,data.bottom_left)) {
				return mjaText.bottom_left;
			} else if (equals(s,data.bottom)) {
				return mjaText.bottom;
			} else if (equals(s,data.bottom_right)) {
				return mjaText.bottom_right;
			}
		}
		return mjaText.center;
	}

	public static int parseAlign(String s,int nullval)	{
		if (BasicStr.hasContent(s)) {
			if (s.equalsIgnoreCase("izquierda")) {
				return data.a_left;
			} else if (s.equalsIgnoreCase("centro")) {
				return data.a_center;
			} else if (s.equalsIgnoreCase("derecha")) {
				return data.a_right;
			}
		}
		return nullval;
	}

	public static int parseAdjust(String s,int nullval)	{
		if (BasicStr.hasContent(s)) {
			if (!(equals(s,data.False)||equals(s,data.No)||s.equalsIgnoreCase("n"))) {
				return data.wrap;
			} else {
				return data.scroll;
			}
		} else {
			return nullval;
		}
	}

/* --------------------- to String Methods ------------------------ */

	public String toString(String sep,int ix,String s,String defvalue) {
		return toString(sep,newName[language][ix],s,defvalue);
	}

	public String toString(String sep,String attrname,String s,String defvalue) {
		if (BasicStr.hasContent(s) && !s.equals("''")
			&& !s.equals(defvalue) && !s.equals("'"+defvalue+"'")
			) {
			return attrname+"="+s+sep;
		} else {
			return "";
		}
	}
	
/* --------------------- Escribir todas las traducciones ------------------- */
	
//	public static void main(String[] args) {
//		String languages="";
//		for (int L=0;L<data.numLang;L++) {
//			String s="";
//			for (int n=0;n<data.NN;n++) {
//				s+=Integer.toString(n)+": "+BasicStr.replace(newName[L][n],"\n","\\n")+"\r\n";
//			}
//			String filename="Tr_"+newName[L][0]+".txt";
//			mjaFile.save(filename,s);
//			languages+=filename+"\r\n";
//		}
//		mjaFile.save("Tr__index.txt",languages);
//	}

}