/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.parser;
/*------------------------------------------------------------*/
/*                         Algorithm                          */
/*                         (c)  MJA                           */
/*                       Marzo de 2001                        */
/*------------------------------------------------------------*/
import java.util.*;

import com.mja.util.BasicStr;

public class Algorithm {

	boolean evOnce;
	boolean isNull;

	Parser parser;
	String name="";

	private Node[] inivar,ininode,iniixnode,iniarrN,iniixnode_col,iniixnode_row,inimatrixN;
	private Node[] var,node,ixnode,arrN,ixnode_col,ixnode_row,matrixN;
	private Node whileNode;
	private int N;
//	private int maxRepeat=134217728;
	private int maxRepeat=100000001;
	private String type="";
	private String s_do,s_ini,s_while;

	public void assign(Algorithm a) {
		name=a.name;
		parser=a.parser;
		isNull=a.isNull;
		s_do=a.s_do;
		s_ini=a.s_ini;
		s_while=a.s_while;
		evOnce=a.evOnce;
		inivar=a.inivar;
		ininode=a.ininode;
		ixnode=a.ixnode;
		iniarrN=a.iniarrN;
		iniixnode=a.iniixnode;
		iniixnode_col=a.iniixnode_col;
		iniixnode_row=a.iniixnode_row;
		inimatrixN=a.inimatrixN;
		node=a.node;
		arrN=a.arrN;
		ixnode_col=a.ixnode_col;
		ixnode_row=a.ixnode_row;
		matrixN=a.matrixN;
		var=a.var;
		whileNode=a.whileNode;
		N=a.N;
		maxRepeat=a.maxRepeat;
		type=a.type;
	}

	public Algorithm (String name) {
//System.out.println("Create VOID Algorithm "+name);
		this.name=name;
		isNull=true;
		this.s_do="";
		this.s_ini="";
		this.s_while="";
	}
		
	public Algorithm (String name,Parser p,boolean evOnce,String s_do,String s_ini,String s_while) {
		this(name,p,evOnce,"Algorithm",s_do,s_ini,s_while);
	}
	
	Algorithm (String name,Parser p,boolean evOnce,String type,String s_do,String s_ini,String s_while) {
//System.out.println("Create Algorithm "+name);
		this.name=name;
		parser=p;
		isNull=false;
		this.type=type;
		this.s_do=s_do;
		this.s_ini=s_ini;
		this.s_while=s_while;
		this.evOnce=evOnce;
		String[] sa=BasicStr.getElements(s_ini);
		String[] inivarname=new String[sa.length];
		ininode=new Node[sa.length];
		inivar=new Node[sa.length];
		iniixnode=new Node[sa.length];
		iniarrN=new Node[sa.length];
		iniixnode_col=new Node[sa.length];
		iniixnode_row=new Node[sa.length];
		inimatrixN=new Node[sa.length];
		fillInfo("init",p,sa,inivarname,inivar,ininode,iniixnode,iniarrN,iniixnode_col,iniixnode_row,inimatrixN);
		sa=BasicStr.getElements(s_do);
		String[] varname=new String[sa.length];
		node=new Node[sa.length];
		ixnode=new Node[sa.length];
		arrN=new Node[sa.length];
		ixnode_col=new Node[sa.length];
		ixnode_row=new Node[sa.length];
		matrixN=new Node[sa.length];
		var=new Node[sa.length];
		fillInfo("do",p,sa,varname,var,node,ixnode,arrN,ixnode_col,ixnode_row,matrixN);
		if (BasicStr.hasContent(s_while.trim())) {
			try {
				whileNode=p.Analyse(type+" "+name+".while",s_while.trim(),true,true);
			} catch (Exception e) {
				whileNode=new Node(p,"0");
			}
		} else {
			whileNode=new Node(p,"0");
		}
	}

	private void fillInfo(String algpart,Parser p,String[] sa,String[] varname,Node[] var,Node[] node,Node[] ixnode,Node[] arrN,Node[] ixnode_col,Node[] ixnode_row,Node[] matrixN) {
		parser=p;
		int i=0;
		for (int k=0;k<sa.length;k++) {
			if (BasicStr.hasContent(sa[k].trim())) {
				int pos=sa[k].indexOf("=");
				if (pos>0) {
					varname[i]=sa[k].substring(0,pos).trim();
					int ixlb=varname[i].indexOf("[");
					if (ixlb>0) {
						String vname=varname[i].substring(0,ixlb).trim();
						if (p.isArray(vname)) {
							int ixrb=varname[i].lastIndexOf("]");
							if (ixrb>ixlb) {
								String auxs=varname[i].substring(ixlb+1,ixrb).trim();
								ixnode[i]=p.Analyse(auxs,3);
							} else {
								ixnode[i]=new Node(p,3.0);
							}
							arrN[i]=p.Array(vname);
						} else if (p.isMatrix(vname)) {
							int ixrb=varname[i].lastIndexOf("]");
							if (ixrb>ixlb) {
								String auxs=varname[i].substring(ixlb+1,ixrb).trim();
								int poscoma=auxs.indexOf(",");
								String s_col=auxs.substring(0,poscoma);
								String s_row=auxs.substring(poscoma+1);
								ixnode_col[i]=p.Analyse(s_col,3);
								ixnode_row[i]=p.Analyse(s_row,3);
	//System.out.println(name+" s_col="+s_col+" s_row="+s_row);
							} else {
								ixnode_col[i]=new Node(p,3);
								ixnode_row[i]=new Node(p,3);
	//System.out.println(name+" s_col="+s_col+" s_row="+s_row);
							}
							matrixN[i]=p.Matrix(vname);
						} else {
							new Exception("[ expected in "+varname[i]).printStackTrace();
						}
					} else {
						if (p.isMatrix(varname[i])) {
							var[i]=p.Matrix(varname[i]);
						} else {
							var[i]=p.Var(varname[i]);
						}
					}
				} else {
					varname[i]="";
					arrN[i]=null;
					var[i]=null;
				}
				String auxs2=sa[k].substring(pos+1).trim();
				String extra="";
				if (type.equals("Algorithm") || type.equals("Function")) {
					extra="."+algpart;
				}
				try {
					node[i]=p.Analyse(varname[i]+"="+auxs2+"\n"+type+" "+name+extra,auxs2,true,true); 
					if (node[i]==null) {
						node[i]=new Node(p,0.0);
						throw new Exception("null assignment at "+varname[i]+" = ");
					}
				} catch (Exception e) {
					reportError(e.getMessage()+"\n"+varname[i]+"="+auxs2+"\n"+type+" "+name+extra);
					node[i]=new Node(p,e.getMessage());
				}
				i++;
			} else {
//				System.out.println("Empty line "+k+" in "+this.name);
			}
		}
	}

	public void backstep() throws Exception {
		if (!isNull) {
			int pn=N-1;
			initialize();
			while(N<pn) {
				step();
				if (N>maxRepeat) {
					System.out.println("Loop limit exceeded in "+type+" "+name);
					throw new Exception("Loop limit exceeded.");
				}
			}
		}
	}

	public void initialize() {
		if (!isNull) {
			for (int i=0;i<inivar.length;i++) {
				try {
					if (iniarrN[i]!=null) {
						int n=(int) Math.round(iniixnode[i].Evaluate());
						if (n>=0 && n<iniarrN[i].rarray.length) {
							iniarrN[i].rarray[n]=ininode[i].Evaluate();
							iniarrN[i].sarray[n]=ininode[i].getStr();
						}
					} else if (/*inimatrixN!=null &&*/ inimatrixN[i]!=null) {
						if (iniixnode_col!=null && iniixnode_row!=null) {
							int col=(int) Math.round(iniixnode_col[i].Evaluate());
							int row=(int) Math.round(iniixnode_row[i].Evaluate());
							if (col>=0 && col<inimatrixN[i].rmatrix.length && row>=0 && row<inimatrixN[i].rmatrix[col].length) {
								inimatrixN[i].rmatrix[col][row]=ininode[i].Evaluate();
								inimatrixN[i].smatrix[col][row]=ininode[i].getStr();
							}
						}
					} else if (inivar[i]!=null) {
						double d=0;
						d=ininode[i].Evaluate();
						if (inivar[i].symb==Node.MATRIX && ininode[i].rmatrix!=null) {
							inivar[i].rmatrix=ininode[i].rmatrix;
						} else if (ininode[i].getStr()!=null) {
							inivar[i].setStrAndAnalyse(ininode[i].getStr());
						} else {
							inivar[i].setDouble(d);
						}
					} else {
						ininode[i].Evaluate(0);
					}
				} catch (Exception e) {
					if (inivar[i]!=null) {
						StringTokenizer st=new StringTokenizer(e.getMessage(),"\n");
						inivar[i].setOnlyStr(st.nextToken());
					}
					reportError(e.getMessage()+"\n"+type+" "+name+".init");
				}
			}
			N=0;
		}
	}

	public void toEnd() throws Exception {
		if (!isNull) {
			boolean go_on=false;
			do {
				try {
					step();
				} catch (Exception e) {
					reportError(e.getMessage()+"\n"+type+" "+name+".do");
					e.printStackTrace();
				}
				if (N>maxRepeat) {
					System.out.println("Loop limit exceeded in "+type+" "+name);
					System.out.println(whileNode.toExpression());
					throw new Exception("Loop limit exceeded.");
				}
				go_on=false;
				try {
					go_on=repeat();
				} catch (Exception e) {
				}
			} while (go_on);
		}
	}

	public void step() {
		if (!isNull) {
			for (int i=0;i<var.length;i++) {
				try {
					if (arrN[i]!=null) {
						int n=(int) Math.round(ixnode[i].Evaluate());
						if (n>=0 && n<arrN[i].rarray.length) {
							arrN[i].rarray[n]=node[i].Evaluate();
							arrN[i].sarray[n]=node[i].getStr();
						}
					} else if (/*matrixN!=null &&*/ matrixN[i]!=null) {
						if ( ixnode_col[i]!=null && ixnode_row[i]!=null ) {
							int col=(int) Math.round(ixnode_col[i].Evaluate());
							int row=(int) Math.round(ixnode_row[i].Evaluate());
							if (col>=0 && col<matrixN[i].rmatrix.length && row>=0 && row<matrixN[i].rmatrix[col].length) {
								matrixN[i].rmatrix[col][row]=node[i].Evaluate();
								matrixN[i].smatrix[col][row]=node[i].getStr();
//System.out.println("MATRIX "+matrixN[i].rmatrix[col][row]+" | "+matrixN[i].smatrix[col][row]);
							}
						}
					} else if (var[i]!=null) {
						double d=0;
						d=node[i].Evaluate();
						if (var[i].symb==Node.MATRIX && node[i].rmatrix!=null) {
							var[i].rmatrix=node[i].rmatrix;
						} else if (node[i]!=null && node[i].getStr()!=null) {
							var[i].setStrAndAnalyse(node[i].getStr());
						} else {
							var[i].setDouble(d);
						}
					} else if (node[i]!=null) {
						node[i].Evaluate(0);
					}
				} catch (Exception e) {
					e.printStackTrace();
					if (var[i]!=null) {
						if (e.getMessage()!=null) {
							StringTokenizer st=new StringTokenizer(e.getMessage(),"\n");
							var[i].setOnlyStr(st.nextToken());
						} else {
							var[i].setOnlyStr(e.getMessage());
						}
					}
//					if (BasicStr.hasContent(e.getMessage())) {
						reportError(e.getMessage()+"\n"+type+" "+name+".do");
//					}
				}
			}
			N++;
		}
	}


	public boolean repeat() {
		if (isNull) {
			return false;
		} else {
			try {
				return (whileNode.Evaluate(0)>0);
			} catch (Exception e) {
				System.out.println(type+" "+name+".while ");
				return false;
			}
		}
	}

	public void perform() throws Exception {
		String s_errors="";
		if (!isNull) {
			try {
				initialize();
				toEnd();
			} catch (Exception e) {
				throw e;
			}
		}
	}

	public String toExpression() {
		return s_ini+"\n\n"+s_do+"\n\n"+s_while+"\n\n";
	}

	private boolean firstError=true;

	private void reportError(String errmsg) {
		if (BasicStr.hasContent(errmsg)) {
			System.out.println("\n"+errmsg);
//			if (parser.inNippeEditor()&&firstError&&(parser.nsa_nippe!=null)) {
//				com.mja.gui.mjaText.msg(parser.nsa_nippe,"Error",errmsg);
//			} else {
				System.out.println("Error: "+errmsg);
//			}
		}
		firstError=false;
	}

}