/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.parser;

import java.util.Vector;

public class Node_R {
	
	public static Node replaceRandomVariables(Parser p,Node N0,Vector v_random,int num_dec,boolean isolated) {
		Node N=N0.cloneNode();
		N.symbstr=replaceRandomVariables(N.symbstr,v_random,isolated);
		try {
			N.setDouble(Double.valueOf(N.getSymbol()).doubleValue());
		} catch(NumberFormatException nfe) {
		}
		switch(N0.type) {
		case Node.Vi:double val=0.0;
				if (N.left!=null) {
					N.left=replaceRandomVariables(p,(Node) N0.left,v_random,num_dec,isolated);
				}

				break;
		case Node.Za: break;
		case Node.Us:
		case Node.Ua:
			for (int i=0;i<N0.right.length;i++) {
				N.right[i]=replaceRandomVariables(p,(Node) N0.right[i],v_random,num_dec,isolated);
			}
			break;
		case Node.B0:
		case Node.B1:
		case Node.B2:
		case Node.B3:
		case Node.As:
		case Node.If :
			N.left=replaceRandomVariables(p,(Node) N.left,v_random,num_dec,isolated);
			for (int i=0;i<N0.right.length;i++) {
				N.right[i]=replaceRandomVariables(p,(Node) N.right[i],v_random,num_dec,isolated);
			}
			break;
		default:;
		}
		if (N0.symb==Node.EXPR) {
			try {
				double x=N.Evaluate();
				return new Node(p,x,num_dec);
			} catch (Exception ex) {
			}
		}
		return N;
	}

	public static String replaceRandomVariables(String str,Vector v_random,boolean isolated) {
		String s=new String(str);
		for (int i=0;i<v_random.size();i++) {
			com.mja.algebra.RandomNumber rn=(com.mja.algebra.RandomNumber)v_random.elementAt(i);
			if (s.equals(rn.getName())) {
				s=rn.getStrValue();
				if (!isolated && s.startsWith("-")) {
					s="("+s+")";
				}
				break;
			}
		}
		return s;
	}

/*
	public static  Node randomlyCommute(Node N0) {
		Node N=(Node) N0.cloneNode();
		if (Math.random()<0.5) {
			N=Node_A.associateOnTheRight(N,true);
		} else if (Math.random()<0.5) {
			N=Node_A.associateOnTheLeft(N,true);
		}
		switch(N0.type) {
			case Node.Vi:
			case Node.Za: break;
			case Node.Us:
				break;
			case Node.Ua:
				break;
			case Node.B0:
			case Node.B1:
			case Node.B2:
			case Node.B3:
					if ((N0.symb==Node.MAS&&N0.type==Node.B1) || N0.symb==Node.POR) {
						if (Math.random()<0.5) {
							Node aux=N.right[0];
							N.right[0]=N.left;
							N.left=aux;
						}
					} else if (N0.type==Node.B1 && N0.symb==Node.MENOS) {
						if (Math.random()<0.5) {
							Node aux=N;
							N=new Node(N0.parser,Node.Us,Node.MENOS,"-");
							N.right=new Node[1];
							N.right[0]=new Node(N0.parser,Node.B1,Node.MENOS,"-");
							N.right[0].left=aux.right[0];
							N.right[0].right=new Node[1];
							N.right[0].right[0]=aux.left;
						}
					}
					break;
		}
		boolean doit=Math.random()<0.25;
		if (doit) {
			Node aux=N;
			N=new Node(N0.parser,Node.Us,Node.MENOS,"-");
			N.right=new Node[1];
			N.right[0]=new Node(N0.parser,Node.Us,Node.MENOS,"-");
			N.right[0].right=new Node[1];
			N.right[0].right[0]=aux;
		}
		return N;
	}

	public Node commuteAll(Node N0) {
		Node N=(Node) N0.cloneNode();
		switch(N0.type) {
			case Node.Vi:
			case Node.Za:
			case Node.Us:
			case Node.Ua:
					break;
			case Node.B0:
			case Node.B1:
			case Node.B2:
			case Node.B3:
					if (N0.symb==Node.MAS || N0.symb==Node.POR) {
						Node aux=N.right[0];
						N.right[0]=N.left;
						N.left=aux;
					}
					break;
		}
		return (Node) N;
	}

	public synchronized static Node randomAlgebraicNode(Parser p,int diff,int lng) {
		diff=Math.max(diff,1);
		diff=Math.max(diff,2);
		lng=Math.max(lng,2);
		return randomNode(p,diff,lng,true);
	}

	private synchronized static Node randomNode(Parser p,int diff,int n,boolean force) {
		int r=1+(int) Math.floor((diff)*Math.random());
		if (force||Math.random()<0.25) {
			r=diff;
		}
		force=false;
		if ((Math.random()<0.5)&&(diff>0)) {
			diff--;
		}
		n--;
		if (n==0) {
			r=0;
		}
		Node N=null;
		switch(r) {
			case 1 :N=new Node(p,Node.B1,Node.MAS,"+");
					N.left=randomNode(p,diff,n,force);
					N.right=new Node[1];
					N.right[0]=randomNode(p,diff,n,force);
					break;
			case 2 :N=new Node(p,Node.B1,Node.MENOS,"-");
					N.left=randomNode(p,diff,n,force);
					N.right=new Node[1];
					N.right[0]=randomNode(p,diff,n,force);
					break;
			case 3 :N=new Node(p,Node.B2,Node.POR,"*");
					N.left=randomNode(p,2,n,force);
					N.right=new Node[1];
					N.right[0]=randomNode(p,diff,n,force);
					break;
			case 4 :N=new Node(p,Node.B2,Node.DIV,"/");
					N.left=randomNode(p,3,n,force);
					N.right=new Node[1];
					N.right[0]=randomNode(p,3,n,force);
					break;
			case 5 :N=new Node(p,Node.B3,Node.EXPON,"^");
					N.left=randomNode(p,4,n,force);
					N.right=new Node[1];
					N.right[0]=new Node(p,null,2.0);
					break;
			case 6 :N=new Node(p,Node.B3,Node.EXPON,"^");
					N.left=randomNode(p,5,n,force);
					N.right=new Node[1];
					N.right[0]=randomNode(p,5,n,force);
					break;
			case 7 :N=new Node(p,Node.Ua,Node.SQRT,"sqrt");
					N.right=new Node[1];
					N.right[0]=randomNode(p,6,n,force);
					break;
			case 8 :N=new Node(p,Node.B3,Node.ROOT,"\\");
					N.left=randomNode(p,5,n,force);
					N.right=new Node[1];
					N.right[0]=randomNode(p,5,n,force);
					break;
			case 0:
			default:
					double aux=Math.floor(Math.random()*(diff+1)*10);
					int rn=(int) aux;
					N=new Node(p,(double)rn);
					if (diff>=2 && Math.random()<0.5) {
						int letra=(int)Math.floor(Math.random()*3);
						if (letra>=3) {
							N.symbstr="d";
						} else if (letra>=2) {
							N.symbstr="c";
						} else if (letra>=1) {
							N.symbstr="b";
						} else  {
							N.symbstr="a";
						}
						if (Math.random()<0.25) {
							N.symbstr=N.symbstr.toUpperCase();
						}
					} else if (diff>=2 && Math.random()<0.5) {
							N.symbstr="x";
					}
		}
		if (Math.random()<0.5) {
			N=Node_A.associateOnTheRight(N,true);
		} else if (Math.random()<0.5) {
			N=Node_A.associateOnTheLeft(N,true);
		}
		return N;
	}

*/

}