/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mja.textedit;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.swing.JScrollBar;

import com.mja.lang.*;
import com.mja.gui.*;
import com.mja.cmp.*;
import com.mja.file.mjaFont;

public class UnicodeSelector extends editDialog implements ActionListener, 
															ItemListener, 
															AdjustmentListener, 
															ComponentListener,
															Runnable,
															Explainer  {

	private static UnicodeSelector us;

	public static String getUnicodeChar(Frame pf,translator Tr) {
		if (us==null) {
			us=new UnicodeSelector(pf,Tr);
			us.pack();
			us.setSize(640,360);
		}
		us.display(false,true);
		String ch=us.charSelected;
//		us.hide();
		return ch;
	} 

	private java.awt.List l_base1;
	private Choice ch_base2;
	private Label lb;
	private mjaButton[] b;
	private int base;
//	private Button b_help;
	private JScrollBar sb;
	private Vector listeners;
	private translator Tr;
	private MouseCursorHandler mch;
	private static final int limsup=0x2600;
	private String charSelected="";

	static UnicodePair[] up=null;
	
	private mjaFont mf;

	public UnicodeSelector(Frame parent,translator Tr) {
		super(parent,Tr.getTr(data.Alphabets),false,Tr.getTr(data.close),null);
		mjaFont.finishLoadingMathFont();
		setModal(true);
		this.Tr=Tr;
		if (up==null) {
			up=new UnicodePair[16];
			up[0] =new UnicodePair(Tr.getTr(data.Alpha0020),0x0020,0x007E);
			up[1] =new UnicodePair(Tr.getTr(data.Alpha00A0),0x00A0,0x00FF);
			up[2] =new UnicodePair(Tr.getTr(data.Alpha0100),0x0100,0x017F);
			up[3] =new UnicodePair(Tr.getTr(data.Alpha0180),0x0180,0x024F);
			up[4] =new UnicodePair(Tr.getTr(data.Alpha0370),0x0370,0x03CF);
			up[5] =new UnicodePair(Tr.getTr(data.Alpha0400),0x0400,0x04FF);
			up[6] =new UnicodePair(Tr.getTr(data.Alpha05D0),0x05D0,0x05EA);
			up[7] =new UnicodePair(Tr.getTr(data.Alpha0600),0x0600,0x06FF);
			up[8] =new UnicodePair(Tr.getTr(data.Alpha2000),0x2000,0x206F);
			up[9] =new UnicodePair(Tr.getTr(data.Alpha20A0),0x20A0,0x20CF);
			up[10]=new UnicodePair(Tr.getTr(data.Alpha2100),0x2100,0x214F);
			up[11]=new UnicodePair(Tr.getTr(data.Alpha2150),0x2150,0x218F);
			up[12]=new UnicodePair(Tr.getTr(data.Alpha2200),0x2200,0x22FF);
			up[13]=new UnicodePair(Tr.getTr(data.Alpha2500),0x2500,0x257F);
			up[14]=new UnicodePair(Tr.getTr(data.Alpha2580),0x2580,0x25FF);
			up[15]=new UnicodePair(Tr.getTr(data.Alpha2600),0x2600,0x26FF);
		}
		mch=new MouseCursorHandler(this,this);	
		mch.handEnabled=false;
		listeners=new Vector();
		Panel P=new Panel();
		add("Center",P);
		Panel P1=new Panel();
		P1.setLayout(new BorderLayout(5,1));
		lb=new Label("UNICODE");
		lb.setAlignment(Label.CENTER);
		lb.addMouseListener(mch);
//		b_help=new Button("?");
//		b_help.addActionListener(this);
//		b_help.addMouseListener(mch);
//		P1.add("North",mjaLayout.pair(1,0,lb,b_help));
		P1.add("North",lb);
		P1.add("Center",l_base1=new java.awt.List());
		for (int i=0;i<up.length;i++) {
			l_base1.add(up[i].description);
		}
		l_base1.addMouseListener(mch);
		Panel auxP=new Panel();
		auxP.setLayout(new GridLayout(2,1));
		P1.add("South",auxP);
		auxP.add(ch_base2=new Choice());
		for (int i=0;i<=limsup;i+=0x10) {
			ch_base2.addItem(Integer.toString(i,16));
		}
		ch_base2.addMouseListener(mch);


		l_base1.select(0);
		ch_base2.select(Integer.toString(up[l_base1.getSelectedIndex()].start,16));
		
		Panel P2=new Panel();
		P2.setLayout(new GridLayout(8,16));
		b=new mjaButton[8*16];
//		mf=new mjaFont(mjaFont.makeFont("SansSerif",Font.PLAIN,16));
		mf=new mjaFont("SansSerif",Font.PLAIN,16);
		setFont(mf.getAwtFont());
		for (int i=0;i<b.length;i++) {
			P2.add(b[i]=new mjaButton());
			b[i].setFont(mf.getAwtFont());
			b[i].setBackground(new Color(0xeef8ff));
			b[i].addActionListener(this);
			b[i].addMouseListener(mch);
		}
		P.setLayout(new BorderLayout());
		P.add("West",P1);
		P.add("Center",P2);
		P.add("East",sb=new JScrollBar(JScrollBar.VERTICAL,0x002,0x010,0x000,(limsup/0x10)+0x10));
		addComponentListener(this);
	}
	
	int indexOf(int n) {
		for (int i=0;i<up.length-1;i++) {
			if (n*0x10<up[i+1].start) {
				return i;
			}
		}
		return up.length-1;
	}
	
	void updateButtons() {
		try {
			base=Integer.parseInt(ch_base2.getSelectedItem(),16);
		} catch (NumberFormatException e) {
			base=0x0000;
		}
		for (int i=0;i<b.length;i++) {
			int ch=base+i;
			if (0x2135<=ch && ch<0x228f) {
				b[i].setFont(mf.getMathFont());
			} else {
				b[i].setFont(mf.getAwtFont());
			}
			String chstr=new Character((char) ch).toString();
			b[i].setLabel(chstr,false);
			b[i].invalidate();
			b[i].repaint();
		}
	}

    public void actionPerformed(ActionEvent e) {
		for (int i=0;i<b.length;i++) {
			if (e.getSource()==b[i]) {
				charSelected=b[i].getLabel();
				setVisible(false);
//			} else if (e.getSource()==b_help) {
//				mch.setHand();
			}
		}
    }
    
    public void itemStateChanged(ItemEvent e) {
		if (!mch.isHand()) {
	    	if (e.getSource()==l_base1) {
				ch_base2.select(Integer.toString(up[l_base1.getSelectedIndex()].start,16));
				sb.setValue(ch_base2.getSelectedIndex());
				updateButtons();
	    	} else if (e.getSource()==ch_base2) {
				sb.setValue(ch_base2.getSelectedIndex());
				l_base1.select(indexOf(ch_base2.getSelectedIndex()));
				updateButtons();
	    	}
	    }
    } 
    
    public void adjustmentValueChanged(AdjustmentEvent e) {
		if (!mch.isHand()) {
	    	if (e.getSource()==sb) {
	    		ch_base2.select(sb.getValue());
				l_base1.select(indexOf(ch_base2.getSelectedIndex()));
	    		updateButtons();
	    	}
	    }
    }
    

	public String getExplLabel(MouseEvent e) {
		Component c=(Component) e.getSource();
		if (c instanceof Label) {
			Label l=(Label) c;
			return l.getText();
		} else if (c instanceof Button) {
			Button b=(Button) c;
			return b.getLabel();
		} else if (c instanceof java.awt.List) {
			java.awt.List l=(java.awt.List) c;
			if (l==l_base1) {
				return Tr.getTr(data.Alphabets);
			}
		} else if (c instanceof Choice) {
			Choice ch=(Choice) c;
			if (ch==ch_base2) {
				return Tr.getTr(data.UnicodeBase);
			}
		}
		return "";
	}

	public String getExplanation(MouseEvent e) {
		String[] sa=null;
		Component c=(Component) e.getSource();
		if (c instanceof Label) {
			Label l=(Label) c;
			if (l==lb) {
				sa=Expl.SymbolsTable[0];
			}
		} else if (c instanceof Button) {
			Button b=(Button) c;
//			if (b==b_help) {
//				sa=Expl.SymbolsTable[1];
//			} else {
				sa=Expl.SymbolsTable[2]; // todos los caracteres.
//			}
		} else if (c instanceof java.awt.List) {
			java.awt.List l=(java.awt.List) c;
			if (l==l_base1) {
				sa=Expl.SymbolsTable[3];
			}
		} else if (c instanceof Choice) {
			Choice ch=(Choice) c;
			if (ch==ch_base2) {
				sa=Expl.SymbolsTable[4];
			}
		}
		return Expl.get(sa,Tr.getActiveLanguage());
	}


/* -------------- Runnable -------------- */

	public void run() {
		try {
			Thread.sleep(500);
			updateButtons();
		} catch (InterruptedException e) {
		}
	}

/* -------------- Component Listener -------------- */

	public void componentResized(ComponentEvent e) {
		Thread thr=new Thread(this);
		thr.start();
	}

	public void componentMoved(ComponentEvent e) {
	}

	private boolean firsttime=true;
	public void componentShown(ComponentEvent e) {
		if (firsttime) {
			sb.addAdjustmentListener(this);
			l_base1.addItemListener(this);
			ch_base2.addItemListener(this);
			firsttime=false;
		}
		Thread thr=new Thread(this);
		thr.start();
	}

	public void componentHidden(ComponentEvent e) {
	}
	
}

class UnicodePair {
	
	String description;
	int start;
	int size;
	
	UnicodePair(String d,int start,int end) {
		description = d;
		this.start = start;
		size = end+1-start;
	}
	
}