/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mos.tablas;
/*
 * @(#)Celda.java    1.0   2005/06/21
 *
 * This software is property of MJA
 *
 */
import java.awt.*;
import java.util.*;

import com.mja.parser.Parser;
import com.mja.textedit.TextParser;

import com.mja.util.BasicStr;
import com.mja.parser.*;

public class Celda {
	
	public Font SansSerif_16=new Font("SansSerif",Font.PLAIN,16);
	public static final int calc_no=0, calc_num=1, calc_alfa=2;

	public TextBox tb;
	public String varName="";
	public String str_user="",str_initial="";
	public boolean isFormula=false;
	public boolean editable=false,may_imp=false;
	public int decimales=-1;
	public boolean fijo=true;
	public Color fgcolor,bgcolor;
	public Font font;
	public double ancho,alto;
	public int rancho,ralto;
	public String pancho,palto;
	public int align,adjust;
	public int celdas_ancho=1,celdas_alto;
	public boolean evaluated=false;
	public int calcalfanum=1;
	public String str_DrawIf="1";

	private Solution[] solution;

	public Component getVisualComponent() {
		return tb.getVisualComponent();
	}

	private double redondeo(double d) {
		if (decimales>=0) {
			double auxd=1.0;
			for (int n=0;n<decimales;n++) {
				auxd*=10.0;
			}
			return Math.round(d*auxd)/auxd;
		} else {
			return d;
		}

	}

	public void setNumSolutions(int N) {
		solution=new Solution[N];
	}

	public void setSolution(Parser parser,String s,int nsol) {
////System.out.println("setSolution "+s);
		StringTokenizer st=new StringTokenizer(s,"|");
		int n=st.countTokens();
		solution=new Solution[1];
		solution[nsol]=new Solution();
		solution[nsol].str_solution=new String[n];
		if (n==0) {
			solution[nsol].str_solution=new String[1];
			solution[nsol].str_solution[0]="";
		} else {
			int i=0;
			while (st.hasMoreTokens()) {
				solution[nsol].str_solution[i]=st.nextToken().trim(); // Se agreg el trim() el 30 de marzo de 2007
				if (isFormula) {
					solution[nsol].str_solution[i]=TextParser.canonize(parser,solution[nsol].str_solution[i],false);
				} else {
					try {
						double d=BasicStr.parseDouble(solution[nsol].str_solution[i]);
						solution[nsol].str_solution[i]=BasicStr.DoubleToString(d,decimales, fijo,".");
					} catch (NumberFormatException nfe) {
					}
				}
				i++;
			}
		}
		solution[nsol].sol_type=new int[solution[nsol].str_solution.length];
		solution[nsol].lim_inf=new double[solution[nsol].str_solution.length];
		solution[nsol].lim_sup=new double[solution[nsol].str_solution.length];
		solution[nsol].lim_inf_s=new String[solution[nsol].str_solution.length];
		solution[nsol].lim_sup_s=new String[solution[nsol].str_solution.length];
		for (int i=0;i<solution[nsol].str_solution.length;i++) {
			if (solution[nsol].str_solution[i].startsWith("[")&&solution[nsol].
				str_solution[i].endsWith("]")&&
				solution[nsol].str_solution[i].indexOf(",")>0) {
				int p=solution[nsol].str_solution[i].indexOf(",");
				solution[nsol].lim_inf_s[i]=solution[nsol].str_solution[i].substring(1,p);
				solution[nsol].lim_sup_s[i]=solution[nsol].str_solution[i].substring(p+1,solution[nsol].str_solution[i].length()-1);
				try {
					solution[nsol].lim_inf[i]=redondeo(Double.valueOf(solution[nsol].lim_inf_s[i]).doubleValue());
					solution[nsol].lim_sup[i]=redondeo(Double.valueOf(solution[nsol].lim_sup_s[i]).doubleValue());
					solution[nsol].sol_type[i]=Solution.num_interval;
				} catch (NumberFormatException nfe) {
					solution[nsol].sol_type[i]=Solution.char_interval;
				}
			} else {
				solution[nsol].sol_type[i]=Solution.onevalue;
			}
		}
	}
	
	
	private boolean isNumeric=false;
	
	public boolean solutionIsNumeric() {
		return isNumeric;
	}

	public boolean isSolution(int nsol) {
		String s=str_user.replace('_',' ').trim();
		while (s.indexOf("  ")>=0) {
			String s2=BasicStr.replace(s,"  "," ");
			s=s2;
		}
		isNumeric=false;
		for (int i=0;i<solution[nsol].str_solution.length;i++) {
			switch (solution[nsol].sol_type[i]) {
			case Solution.onevalue:
				if ((may_imp&&s.equals(solution[nsol].str_solution[i]))||
					(!may_imp&&s.equalsIgnoreCase(solution[nsol].str_solution[i]))) {
					return true;
				}
				try {
					double d1=BasicStr.parseDouble(s);
					double d2=BasicStr.parseDouble(solution[nsol].str_solution[i]);
					if (d1==d2) {
						isNumeric=true;
						return true;
					}
				} catch (NumberFormatException e) {
				}
				break;
			case Solution.char_interval:
				if ((may_imp&&s.compareTo(solution[nsol].lim_inf_s[i])>=0&&
					s.compareTo(solution[nsol].lim_sup_s[i])<=0) ||
					(!may_imp&&s.compareToIgnoreCase(solution[nsol].lim_inf_s[i])>=0&&
					s.compareToIgnoreCase(solution[nsol].lim_sup_s[i])<=0)) {
					return true;
				}
				break;
			case Solution.num_interval:
				try {
					double d=redondeo(Double.valueOf(s).doubleValue());
					if (solution[nsol].lim_inf[i]<=d&&d<=solution[nsol].lim_sup[i]) {
						return true;
					}
				} catch (NumberFormatException nfe) {
				}
				break;
			}
		}
		return false;
	}

	public String getFirstSolution(int nsol) {
		switch (solution[nsol].sol_type[0]) {
		case Solution.onevalue:
			return solution[nsol].str_solution[0];
		case Solution.char_interval:
			return solution[nsol].lim_inf_s[0];
		case Solution.num_interval:
			return solution[nsol].lim_inf_s[0];
		}
		return "";
	}
}

class Solution {
	public static final int onevalue=0,num_interval=1,char_interval=2;

	public String[] str_solution;
	public int[] sol_type;
	public double[] lim_inf,lim_sup;
	public String[] lim_inf_s,lim_sup_s;

}