/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package com.mos.tablas;
/*
 * @(#)TextBox.java    1.0   2005/06/21
 *
 * This software is property of MJA
 *
 */
import java.applet.*;
import java.awt.*;
import java.awt.event.*;

import com.mja.util.TFont;
import com.mja.cmpedit.mjaLineEditor;
import com.mja.text.*;
import com.mja.parser.*;
import com.mja.lang.*;
import com.mja.gui.*;
import com.mja.textedit.EditorCanvas;
import com.mja.textedit.TextParser;

public class TextBox {

	static boolean onlyFormula=false;
	static final Font txtFont=new Font("Monospaced",Font.PLAIN,15);
	static final Font bFont=new Font("SansSerif",Font.PLAIN,13);
	static final Color eqFC=Color.black;
	static Frame EF;
	static translator Tr;
	static MouseCursorHandler mch;
	private Parser parser;

	boolean editable;
	mjaLineEditor mja_le;
	EditorCanvas EC;
	Node drawIf;


	public Component getVisualComponent() {
		if (EC!=null) {
			return EC;
		} else {
			return mja_le;
		}
	}

	public TextBox(Applet A,translator Tr,Parser parser,int width,int height,int points,boolean editable,int decimales,boolean fijo,int calcalfanum,boolean formula,String str_DrawIf) {
		this.Tr=Tr;
		this.editable=editable;
		this.parser=parser;
		drawIf=parser.Analyse(str_DrawIf);
		if (formula) {
			Formula.drawBox=false;
			if (EF==null) {
				EF=new Frame();
//				parser=new Parser();
//				Tr=new translator();
				mch=new MouseCursorHandler(EF,null);
			}
			EC=new EditorCanvas(A,EF,Tr,mch,parser,new TFont(txtFont),eqFC,false,true,onlyFormula);
			EC.setMinimumHeight(height-2);
//			EC.addActionListener(this);
			EC.addMouseListener(mch);
			EC.setLayout(null);
			EC.setEnabled(editable);
		} else {
			mja_le=new mjaLineEditor(width,height,points,editable,decimales,fijo,calcalfanum);
		}
	}

	public void updateSize() {
		if (EC!=null) {
			EC.updateSize();
		}
	}

	public void start() {
		if (EC!=null) {
			EC.setEditing(editable);
			EC.start();
			EC.updateSize();
			EC.updateScreen();
		}
	}

	public void stop() {
		if (EC!=null) {
			EC.setEditing(false);
			EC.stop();
		}
	}

	public void setFont(Font font) {
		if (EC!=null) {
			EC.setFont(font);
		} else {
			mja_le.setFont(font);
		}
	}

	public void addActionListener(ActionListener c) {
		if (EC!=null) {
			EC.addActionListener(c);
		} else {
			mja_le.addActionListener(c);
		}
	}

	public void removeActionListener(ActionListener c) {
		if (EC!=null) {
//			EC.removeActionListener(c);
		} else {
			mja_le.removeActionListener(c);
		}
	}

	public String getText() {
		if (EC!=null) {
			String s=EC.getText().toExpression(true);
			return TextParser.canonize(parser,s,false);
//			return TextParser.canonizeAsFormula(parser,s,false);
		} else {
			return mja_le.getText();
		}
	}

	public void setText(String s0) {
		String s=s0;
		try {
			Node n=parser.Analyse("TextBox",s0,true,false);
			if (n!=null) {
				parser.Var("valor").setDouble(n.Evaluate(0));
				if (drawIf.Evaluate(1)==0.0) {
					s="";
				}
			}
		} catch (Exception e) {
		}
		if (EC!=null) {
			EC.setText(TextParser.parseString(parser,s));
//			EC.setMainFormula(TextParser.parseStringToFormula(parser,s));
			EC.updateScreen();
		} else {
			mja_le.setText(s);
		}
	}

	public void setEditable(boolean toEdit) {
		if (EC!=null) {
			EC.setEditing(toEdit);
		} else {
			mja_le.setEditable(toEdit);
		}
	}


	public void setAlignment(int align) {
		if (EC!=null) {
		} else {
			mja_le.setAlignment(align);
		}
	}

	public void setAdjust(int adjust) {
		if (EC!=null) {
		} else {
			mja_le.setAdjust(adjust);
		}
	}

	public void setForeground(Color c) {
		if (EC!=null) {
			EC.setForeground(c);
		} else {
			mja_le.setForeground(c);
		}
	}

	public void setBackground(Color c) {
		if (EC!=null) {
			EC.setBackground(c);
		} else {
			mja_le.setBackground(c);
		}
	}

	public void requestFocus() {
		if (EC!=null) {
			EC.requestFocus();
		} else {
			mja_le.requestFocus();
		}
	}
}