/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
import java.util.*;
import java.io.*;

public class convertToXML {
	
	static StringBuffer sb=new StringBuffer();
	
	public static void main(String[] args) {
		String str=readFile(args[0]);
		String strlc=str.toLowerCase();
		int k=0;
		int n=0;
		int na=0;
		while ((n=strlc.indexOf("<hr>",n+3))>=0) {
			String auxstr=str.substring(na,n);
			na=n;
			if (k>0) {
				parseUnit(auxstr);
			}
			k++;
		}
		save(args[0]+".xml",sb.toString());
	}
	
	public static void parseUnit(String s) {
		int n=0,na=0;
		String slc=s.toLowerCase();
		int k=0;
		String unitname="";
		while ((n=slc.indexOf("<br>",n+3))>=0) {
			String auxs=s.substring(na,n);
			if (k==0) {
				unitname=parseUnitWithName(auxs);
			} else {
				parseUnitNoName(auxs,unitname);
			}
			k++;
		}
//		System.out.println("-----------------------------------------");
	}
	
	public static String parseUnitWithName(String s) {
		String slc=s.toLowerCase();
		int n1=slc.indexOf("</b>")+4;
		int n2=slc.indexOf("</p>",n1);
		String unitname=s.substring(n1,n2);
		parseUnitNoName(s.substring(n2+4),unitname);
		return unitname;
	}
	
	public static void parseUnitNoName(String s,String unitname) {
		String slc=s.toLowerCase();
		String dl1="window.open('";
		String dl2="'";
		int n1=slc.indexOf(dl1)+dl1.length();
		int n2=slc.indexOf(dl2,n1);
		String href=s.substring(n1,n2);
		n1=0;
		n2=0;
		int k=0;
		while (k<4) {
			n2=href.indexOf("_",n2+1);
			k++;
		}
		String id=href.substring(n1,n2);
		dl1="<img src=\"";
		dl2="\"";
		n1=slc.indexOf(dl1)+dl1.length();
		n2=slc.indexOf(dl2,n1);
		String image=s.substring(n1,n2);
		sb.append(id+" | "+unitname+" | "+image+" | "+href+"\n");
//System.out.println(id+" | "+unitname+" | "+image+" | "+href);
	}


	public static String readFile(String path) {
		try {
			File f=new File(path);
			InputStream is=new FileInputStream(f);
			String s=readInputStream(is);
			return s;
		} catch (IOException e1) {
			return null;
		}
	}

	public static String readInputStream(InputStream is) throws IOException {
		InputStreamReader isr=new InputStreamReader(is,"ISO-8859-1");
		// ISO-8859-1 codification added on ver 3.913 2008-02-15
		BufferedReader br=new BufferedReader(isr);
		StringBuffer sb=new StringBuffer();
		String auxs="";
		do {
			auxs=br.readLine();
			if (auxs!=null) {
				sb.append(auxs+"\n");
			}
		} while (auxs!=null);
		isr.close();
		String s=sb.toString();
		return s;
	}

	static public boolean fileExists(String filename) {
		File f=new File(filename);
		return f.exists();
	}

	static public void delete(String filename) {
		if (fileExists(filename)) {
			File f=new File(filename);
			f.delete();
		}
	}

	static public void save(String filename,String s) {
		delete(filename);
		File f=new File(filename);
		try {
			BufferedWriter bw=new BufferedWriter(new FileWriter(f));
			bw.write(s,0,s.length());
			bw.close();
		} catch (IOException e) {
			System.out.println("could not save file "+filename);
			e.printStackTrace();
		}
	}


}