/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package edu.cr.descartes;

/*------------------------------------------------------------*/
/*                         copyright                          */
/*                          (c) MJA                           */
/*                        Enero de 2001                       */
/*------------------------------------------------------------*/

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.applet.*;
import com.mja.util.*;
import com.mja.gui.*;
import com.mja.lang.*;
import com.mja.file.*;


public class copyright extends Canvas implements MouseListener, MouseMotionListener {

	private static final Cursor hC=new Cursor(Cursor.HAND_CURSOR);

	private static final String imaname[]= {
		"Descartes.png",
		"unam.jpg",
		"imate.png",
		"lite.jpg",
		"arquimedes.jpg",
		"mec.png",
		"cc_by_nc_sa.png",
	};

	private static final String[] url= {
		"http://ProyectoDescartes.org/",
		"http://www.unam.mx/",
		"http://www.matem.unam.mx/",
		"http://www.lite.org.mx/",
		"http://arquimedes.matem.unam.mx/",
		"http://www.ite.educacion.es/",
		"http://ProyectoDescartes.org/",
		"http://descartesjs.org",
		"http://joinup.ec.europa.eu/software/page/eupl/licence-eupl",
		"http://arquimedes.matem.unam.mx/Descartes5/",
		"http://creativecommons.org/licenses/by-nc-sa/2.5/es/",
		"http://creativecommons.org/licenses/by-nc-sa/2.5/es/",
	};

	private static final Color[] gris = {
		new Color(180,185,190),
		new Color(230,235,240),
		new Color(200,205,210),
		new Color(40,40,60),
		new Color(80,30,125)
	};
	private static final int[] d = {-1,1,0};
	private Applet A;
	private int[] X=new int[url.length], Y=new int[url.length],
			dX=new int[url.length],dY=new int[url.length];
	private Image[] img;
	private editFrame ef;
	private boolean useCC=true;

	public copyright(Applet A,String appName,boolean useCC) {
		ef=new editFrame(" Applet "+appName+" v. "+data.Version,"   Ok   ",null,null);
		ef.pack=true;
		this.A=A;
		this.useCC=useCC;
		int dh=(useCC)?55:0;
		int w=720,h=360+dh;
		setSize(w,h);
		ef.setBackground(gris[2]);
		ef.add("Center",this);
		img=new Image[imaname.length];
		for (int i=0;i<imaname.length;i++) {
			try {
				img[i]=Toolkit.getDefaultToolkit().getImage(getClass().getResource("/resources/logos/"+imaname[i]));
				MediaTracker mt=new MediaTracker(this);
				mt.addImage(img[i],i);
				mt.waitForID(i);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		addMouseListener(this);
		addMouseMotionListener(this);		
	}

	public void display() {
		ef.display();
	}
	
	public void dispose() {
		ef.setVisible(false);
		ef.dispose();
		ef=null;
	}

	boolean curAct(Event ev,int X,int Y,int dX,int dY,String str) {
		return false;
	}

	public void paint(Graphics g) {
		int W=getSize().width,H=getSize().height;
		/* ---------------------------- fondo --------------------------- */
		g.setColor(gris[2]);
		g.fillRect(0,0,W,H);
		int fsz=24;
		Font font=mjaFont.makeFont("Serif",Font.BOLD+Font.ITALIC,fsz);
		TFont tf=new TFont(font);
		g.setFont(font);
		g.setColor(gris[0]);
		FontMetrics fm=g.getFontMetrics();
		String MEC_str="Descartes";
		int h=(tf.getAscent()+tf.getDescent()), w=fm.stringWidth(MEC_str), /* w=2*h,*/ dd=0;

		for (int i=0;i<3;i++) {
			g.setColor(gris[i]);
			int y=20,n=0;
			while (y<H) {
				int x=0,m=0;
				while (x<W) {
					if ((m+n)%2==0) {
						if ((m+n)%4==0) {
							dd=d[i];
						} else {
							dd=-d[i];
						}
						g.drawString(MEC_str,x+dd,y+dd);
					}
					x+=w; m++;
				}
				y+=h;n++;
			}
		}

		/* ---------------------------- imgenes --------------------------- */
		g.setColor(Color.white);
		g.fillRect(10,10,W-20,82);
		g.setColor(gris[3]);
		g.drawRect(10,10,W-20,82);
		X[0]=15; Y[0]=15;
		dX[0]=img[0].getWidth(this); dY[0]=img[0].getHeight(this); 
		for (int i=0;i<5;i++) {
			X[i+1]=X[i]+dX[i]+12; Y[i+1]=15;
			dX[i+1]=img[i+1].getWidth(this); dY[i+1]=img[i+1].getHeight(this); 
		}
		for (int i=0;i<6;i++) {
			g.drawImage(img[i],X[i],Y[i],dX[i],dY[i],this);
		}
		g.setColor(gris[4]);
		/* ---------------------------- textos --------------------------- */
		int y=130;
		fsz=24;
		font=mjaFont.makeFont("Serif",Font.ITALIC,fsz);
		tf=new TFont(font);
		g.setFont(font);
		fm=g.getFontMetrics();
		String msg="ProyectoDescartes.org";
		Y[6]=y-tf.getAscent(); dY[6]=tf.getAscent()+tf.getDescent();
		dX[6]=fm.stringWidth(msg); X[6]=(W-dX[6])/2;
		g.drawLine((W-dX[6])/2,y+tf.getDescent(),(W+fm.stringWidth(msg))/2,y+tf.getDescent());
		g.drawString(msg,(W-fm.stringWidth(msg))/2,y);

		y+=40;
		msg="descartesjs.org";
		Y[7]=y-tf.getAscent(); dY[7]=tf.getAscent()+tf.getDescent();
		dX[7]=fm.stringWidth(msg); X[7]=(W-dX[7])/2;
		g.drawLine((W-dX[7])/2,y+tf.getDescent(),(W+fm.stringWidth(msg))/2,y+tf.getDescent());
		g.drawString(msg,(W-fm.stringWidth(msg))/2,y);

		y+=22;
		int x=0;
		int dy=22;
		fsz=16;
		font=mjaFont.makeFont("Serif",Font.PLAIN,fsz);
		g.setFont(font);
		fm=g.getFontMetrics();
		tf=new TFont(font);
		g.setColor(gris[3]);
		y+=dy;
		msg="Diseo: Jos Luis Abreu, Juan Madrigal Muga y Jos R. Galo Snchez";
		g.drawString(msg,(W-fm.stringWidth(msg))/2,y); 
		y+=dy;
		msg="Autores del applet: Jos Luis Abreu Len y Marta Oliver Serrat";
		g.drawString(msg,(W-fm.stringWidth(msg))/2,y); 
		y+=dy;
		msg="con la colaboracin de: Oscar Escamilla Gonzlez y Joel Espinosa Longi";
		g.drawString(msg,(W-fm.stringWidth(msg))/2,y); 
		y+=dy;

// Licencia EUPL 
		y+=dy/2;
		msg="Licencia del applet cedida con arreglo a la ";
		String msg1="EUPL v.1.1";
		int dx=fm.stringWidth(msg); 
		dX[8]=fm.stringWidth(msg1); 
		dY[8]=tf.getAscent()+tf.getDescent(); 
		X[8]=(getSize().width-dX[8]-dx)/2; 
		Y[8]=y-tf.getAscent();
		g.drawString(msg,X[8],y);
		X[8]+=dx;
		g.setColor(gris[4]);
		g.drawString(msg1,X[8],Y[8]+tf.getAscent());
		g.drawLine(X[8],Y[8]+tf.getAscent()+tf.getDescent(),X[8]+dX[8],Y[8]+tf.getAscent()+tf.getDescent());
		g.setColor(Color.black);
		y+=dy;
		
// Cdigo fuente de Descartes
		msg="La documentacin y el cdigo fuente se encuentran en:";
		dX[9]=fm.stringWidth(msg); 
		X[9]=(W-dX[9])/2; 
		Y[9]=y;
		g.drawString(msg,X[9],Y[9]);
		dX[9]=fm.stringWidth(url[9]); 
		X[9]=(W-dX[9])/2;
		g.setColor(gris[4]);
		dY[9]=dy;
		Y[9]=Y[9]+dy-tf.getAscent();
		g.drawString(url[9],X[9],Y[9]+tf.getAscent());
		g.drawLine(X[9],Y[9]+tf.getAscent()+tf.getDescent(),X[9]+dX[9],Y[9]+tf.getAscent()+tf.getDescent());

		if (useCC) {
	// Frase Creative Commons
			y+=40+dy/2;
			msg="Este objeto, creado con Descartes, est licenciado por sus autores como Creative Commons";
			dX[10]=fm.stringWidth(msg); 
			X[10]=(W-dX[10])/2; 
			g.setColor(Color.black);
			g.drawString(msg,X[10],y);
			msg="Creative Commons";
			dx=fm.stringWidth(msg);
			X[10]=X[10]+dX[10]-dx;
			g.setColor(gris[4]);
			g.drawString(msg,X[10],y);
			dX[10]=dx;
			dY[10]=dy; 
			Y[10]=y-(tf.getAscent()-tf.getDescent())/2-dY[10]/2;
			g.drawLine(X[10],y+tf.getDescent(),X[10]+dX[10],y+tf.getDescent());

	// Imagen Creative Commons
			y+=dy/2;
			dX[11]=img[6].getWidth(this); dY[11]=img[6].getHeight(this); 
			X[11]=(getSize().width-dX[11])/2; Y[11]=y-3;
			g.drawImage(img[6],X[11],Y[11],this);

		}
	}

/* ------------------ MouseListener -------------------- */


	public void mousePressed(MouseEvent e) {
		for (int i=0;i<url.length;i++) {
			if (X[i]<=e.getX()&&e.getX()<X[i]+dX[i]&&Y[i]<=e.getY()&&e.getY()<Y[i]+dY[i]) {
				try {
					A.getAppletContext().showDocument(new URL(url[i]),"_blank");
				} catch (MalformedURLException mue) {
					mue.printStackTrace();
				}
			}
		}
	}
	public void mouseReleased(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}

/* ------------------ MouseMotionListener -------------------- */

	public void mouseMoved(MouseEvent e) {
		for (int i=0;i<url.length;i++) {
			if (X[i]<=e.getX()&&e.getX()<X[i]+dX[i]&&Y[i]<=e.getY()&&e.getY()<Y[i]+dY[i]) {
				if (A.getCursor()!=hC) {
					A.showStatus(url[i]);
					setCursor(hC);
				}
				return;
			}
		}
		A.getAppletContext().showStatus("");
		setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
	}
	public void mouseDragged(MouseEvent e) {}

}