/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package edu.ite.items.beans;

import java.io.IOException;
import java.io.StringReader;
import java.util.Vector;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import edu.mec.descartesserver.beans.EsceneBean;

public class Item extends EsceneBean {
	private String prevUrl;
	private String idAutor;
	private String nombreAutor;
	private String id;
	private String url;
	private String fromServer;
	private Metadato[] metadatos;

	
	public static final int FILL_LEVEL_BASICO		= 0;
	public static final int FILL_LEVEL_METADATOS	= 1;
	public static final int FILL_LEVEL_COMPLETO		= 2;
	
	
	
	public Item(String url, String appletCode) {
		super();
		this.url = url;
		this.setHtmlCode(appletCode);
	}
	
	
	public Item(String url, String appletCode, String metadatos) throws SAXException, IOException {
		super();
		this.url = url;
		this.setHtmlCode(appletCode);
		this.metadatos = Metadato.getMetadatosFromXMLString(metadatos);
	}
	
	public Item(String url, String appletCode, Metadato[] metadatos) {
		super();
		this.url = url;
		this.setHtmlCode(appletCode);
		this.metadatos = metadatos;
	}
	public Item(String url, String appletCode, Metadato[] metadatos,
			String[] files) {
		super();
		this.url = url;
		this.setHtmlCode(appletCode);
		this.metadatos = metadatos;
		this.setFiles(files);
	}
	/**
	 * @return the url
	 */
	public String getUrl() {
		if(url==null)
			return "";
		return url;
	}
	/**
	 * @param url the url to set
	 */
	public void setUrl(String url) {
		this.url = url;
	}
	
	/**
	 * @return the metadatos
	 */
	public Metadato[] getMetadatos() {
		if(metadatos == null)
			metadatos = new Metadato[0];
		return metadatos;
	}
	/**
	 * @param metadatos the metadatos to set
	 */
	public void setMetadatos(Metadato[] metadatos) {
		this.metadatos = metadatos;
	}
	


	/**
	 * @return the prevUrl
	 */
	public String getPrevUrl() {
		if(prevUrl==null)
			return "";
		return prevUrl;
	}


	/**
	 * @param prevUrl the prevUrl to set
	 */
	public void setPrevUrl(String prevUrl) {
		this.prevUrl = prevUrl;
	}


	/**
	 * @return the idAutor
	 */
	public String getIdAutor() {
		if(idAutor==null)
			return "";
		return idAutor;
	}


	/**
	 * @param idAutor the idAutor to set
	 */
	public void setIdAutor(String idAutor) {
		this.idAutor = idAutor;
	}


	/**
	 * @return the nombreAutor
	 */
	public String getNombreAutor() {
		if(nombreAutor==null)
			return "";
		return nombreAutor;
	}


	/**
	 * @param nombreAutor the nombreAutor to set
	 */
	public void setNombreAutor(String nombreAutor) {
		this.nombreAutor = nombreAutor;
	}


	/**
	 * @return the id
	 */
	public String getId() {
		if(id==null)
			return "";
		return id;
	}


	/**
	 * @param id the id to set
	 */
	public void setId(String id) {
		this.id = id;
	}
	
	
	
	public void setFromServer(String fromServer) {
		this.fromServer = fromServer;
	}


	public String getFromServer() {
		if(fromServer == null)
			return "";
		return fromServer;
	}


	public static Item[] getItemFromXmlStr(String xml, int fillLevel)
			throws SAXException {
		try {
			StringReader reader = new StringReader(xml);
			InputSource inputSource = new InputSource(reader);
			DocumentBuilderFactory builderFactory = DocumentBuilderFactory
					.newInstance();
			DocumentBuilder builderXML;
			
			builderXML = builderFactory.newDocumentBuilder();
			
			Document domDoc = builderXML.parse(inputSource);
			NodeList listItemXml = domDoc.getElementsByTagName("item");
			if (listItemXml.getLength() <= 0)
				throw new SAXException("No se encuentran nodos <item>");

			Vector<Item> resultados = new Vector<Item>();
			for (int i = 0; i < listItemXml.getLength(); i++) {
				Element itemElement = (Element) listItemXml.item(i);
				Item a = getItemFromXmlNode(itemElement, fillLevel);
				resultados.add(a);
			}
			return resultados.toArray(new Item[resultados.size()]);
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("Error al parsear la cadena :\n"+xml);
			throw new SAXException(e);
		}
	}
	
	public static Item getItemFromXmlNode(Element itemNode, int fillLevel) throws SAXException{
		if(itemNode.getNodeName() != "item")
			throw new InstantiationError("El nodo "+itemNode.getNodeName()+" no es compatible");
		 
		String nombreAutor	= "";
		String idAutor		= ""; 
		String prevUrl		= itemNode.getAttribute("prevUrl");
		String id			= itemNode.getAttribute("id");
		String url			= itemNode.getAttribute("url");
		String from			= itemNode.getAttribute("from");
		String appletCode 	= null;
		Metadato[] metadatos = new Metadato[0];
		
		NodeList listaAutor = itemNode.getElementsByTagName("autor"); 
		
		if(listaAutor.getLength() > 0){
			Element autorElement = (Element) listaAutor.item(0);
			idAutor = autorElement.getAttribute("id");
			nombreAutor = autorElement.getAttribute("nombre");	
		}
		
		if(fillLevel == FILL_LEVEL_METADATOS){
			NodeList metaList = itemNode.getElementsByTagName("metadatos");
			if(metaList.getLength() > 0){
				metadatos = Metadato.getMetadatosFromXMLNode((Element) metaList.item(0));
			}
		}
		Item res = new Item(url,appletCode);
		res.setId(id); 
		res.setFromServer(from);
		res.setPrevUrl(prevUrl); 
		res.setNombreAutor(nombreAutor); 
		res.setIdAutor(idAutor);
		res.setMetadatos(metadatos);
		return res;
	}
	
	
	public String printtoXmlString(){
		String metalist = "";
		Metadato[] array = getMetadatos();
		for (int i = 0; i < array.length; i++) {
			metalist+="\t\t"+array[i].printToXMLString()+"\n";
		}
		
		String res = 
			"<item id='"+getId()+"' from='"+getFromServer()+"' url='"+getUrl()+"'>\n" +
			"\t<autor id='"+getIdAutor()+"' nombre='"+getNombreAutor()+"' />\n"+
			"\t<metadatos>\n"+
			metalist+
			"\t</metadatos>\n"+
			"</item>";
		
		return res;
	}
	
	public String printItem(){
		return
		"ID		= "+this.getId()+"\n"+
		"autor		= "+this.getNombreAutor()+"\n"+
		"from		= "+this.getFromServer()+"\n"+
		"url		= "+this.getUrl()+"\n"+
		"Meta N		= "+this.getMetadatos().length+"\n"+
		"FILES N	= "+this.getFiles().length+"\n"+
		"code = \n"+this.getHtmlCode()+"\n"+
		"";
	}
}