/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package edu.ite.items.metadatos.services.gui;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.io.StringReader;
import java.net.URL;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import edu.ite.items.beans.Metadato;
import edu.ite.items.metadatos.utils.ItemsServicesConnector;



public class MetadatosDialog extends JPanel {
	private static final long serialVersionUID = 1L;
	private HashMap<String,MetadataInput> inputsMeta;
	public JTextField login;
	public JPasswordField pswd; 
	
	
	public MetadatosDialog(URL urlServices) throws IOException, SAXException {
		super();
	
		
		login = new JTextField(10);
		pswd = new JPasswordField(10);
		
		inputsMeta = new HashMap<String, MetadataInput>();
		
		Metadato[] metaArray =
			ItemsServicesConnector.getMetadatosFromServices(urlServices);
		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		Container container = new JPanel();
		JScrollPane scrollPane = new JScrollPane(container);
		container.setLayout(new GridBagLayout());
		GridBagConstraints constraints = new GridBagConstraints();
		scrollPane.setBorder(new TitledBorder(null,"Metadatos",TitledBorder.CENTER,TitledBorder.DEFAULT_POSITION));

		
		
		JPanel datosUsr = new JPanel();
		datosUsr.setLayout(new GridBagLayout());
		agregaCamposUsr(datosUsr);
		
		
		for (int i = 0; i < metaArray.length; i++) {
			Metadato act = metaArray[i];
				
			MetadataInput tmpP = new MetadataInput(act);
			
			JLabel labelAct = tmpP.label; 
			JComponent inputAct = tmpP.input;
			inputsMeta.put(act.getLabel(),tmpP);
			
			constraints.gridy 	= i;
			constraints.gridx	= 0;
			constraints.fill 	= GridBagConstraints.HORIZONTAL;
			constraints.anchor	= GridBagConstraints.WEST;
			constraints.insets	= new Insets(5,0,0,5); 
			constraints.weightx	= 0;
			container.add(labelAct,constraints);
			
			constraints.gridx	= 1;
			constraints.fill 	= GridBagConstraints.HORIZONTAL;
			constraints.anchor	= GridBagConstraints.WEST;
			constraints.weightx	= 1;
			constraints.insets	= new Insets(5,0,0,0);
			container.add(inputAct,constraints);
		}
		
		this.add(datosUsr);
		this.add(scrollPane);
	}
	
	private void agregaCamposUsr(Container container) {
		GridBagConstraints constraints = new GridBagConstraints();
		JLabel labelAct = new JLabel("Usuario :"); 
		JComponent inputAct = this.login;
		
		constraints.gridy 	= 0;
		constraints.gridx	= 0;
		constraints.fill 	= GridBagConstraints.NONE;
		constraints.anchor	= GridBagConstraints.WEST;
		constraints.weightx = 0;
		constraints.insets	= new Insets(5,0,0,5); 
		container.add(labelAct,constraints);
		

		constraints.gridy	= 0;
		constraints.gridx	= 1;
		constraints.fill 	= GridBagConstraints.HORIZONTAL;
		constraints.anchor	= GridBagConstraints.WEST;
		constraints.weightx = 300;
		constraints.insets	= new Insets(5,0,0,0);
		container.add(inputAct,constraints);
		
		
		labelAct = new JLabel("Contrasea :"); 
		inputAct = this.pswd;
		
		constraints.gridy 	= 1;
		constraints.gridx	= 0;
		constraints.fill 	= GridBagConstraints.NONE;
		constraints.anchor	= GridBagConstraints.WEST;
		constraints.weightx = 0;
		constraints.insets	= new Insets(5,0,20,5); 
		container.add(labelAct,constraints);
		

		constraints.gridy	= 1;
		constraints.gridx	= 1;
		constraints.fill 	= GridBagConstraints.HORIZONTAL;
		constraints.anchor	= GridBagConstraints.WEST;
		constraints.weightx = 300;
		constraints.insets	= new Insets(5,0,20,0);
		container.add(inputAct,constraints);
	}

	/**
	 * 
	 * @return Un arreglo de String con los nombre de los metadatos que etan mal o null si todos estan bien.
	 */
	public String[] verificarInputs(){
		Vector<String> tmpNombres = new Vector<String>();
		String tt = new String(this.pswd.getPassword());
		String login = this.login.getText();  
		tt = tt.trim();
		login = login.trim();
		if(tt.length()<=0)
			tmpNombres.add("Contrasea");
		
		if(login.length()<=0)
			tmpNombres.add("Usuario");
		
		
		Iterator<String> keys = inputsMeta.keySet().iterator();
		while(keys.hasNext()){
			String key = keys.next();
			MetadataInput tmpInput  = inputsMeta.get(key);
			if(tmpInput.metaData.getRequiered()){
				String usrVal = tmpInput.getUsrValue().trim();
				if(usrVal.length()<=0){
					tmpNombres.add(tmpInput.label.getText());
				}
			}
		}
		
		
		if(tmpNombres.size()<=0)
			return null;
		return tmpNombres.toArray(new String[tmpNombres.size()]);
	}
	
	
	

	
	public String getUsrData(){
		Iterator<String> keys = inputsMeta.keySet().iterator();
		String machote = "<metadato name='{@name@}' value='{@value@}' />";
		String res = "<metadatos>\n";
		while(keys.hasNext()){
			String key = keys.next();
			MetadataInput metaAct = (MetadataInput) inputsMeta.get(key);
			if(metaAct.modificado){
				String tmpRep = machote.replace("{@name@}", key);
				tmpRep = tmpRep.replace("{@value@}", metaAct.getUsrValue());
				res += "\t"+tmpRep+"\n";
			}
		}
		res+="</metadatos>";
		return res;
	}
	
	public String setUsrData(String xmlMetadatos) throws SAXException, IOException {

		DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builderXML;
		try {
			builderXML = builderFactory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
			throw new RuntimeException(e.getMessage());
		}
		
		StringReader reader = new StringReader(xmlMetadatos);
		InputSource inputSource = new InputSource(reader);
		Document domDoc = builderXML.parse(inputSource);

		NodeList metadatos = domDoc.getElementsByTagName("metadato");
		//Metadato[] resMeta = new Metadato[metadatos.getLength()];
		
		
		for (int i = 0; i < metadatos.getLength(); i++) {
			Element elementAct = (Element) metadatos.item(i);
			
			String name 	= elementAct.getAttribute("name");
			String value	= elementAct.getAttribute("value");
			
			MetadataInput tmpM = inputsMeta.get(name);
			
			if(tmpM == null){
				System.out.println("Se trato de leer la cadena \n"+xmlMetadatos);
				throw new IllegalArgumentException("No se reconoce el metadato '"+name+"'");
			}
			if(value.equals("")){
				System.out.println("Hay un metadato con valor vacio\n"+xmlMetadatos);
			}
			tmpM.setUsrValue(value);
		}
		
		Iterator<String> keys = inputsMeta.keySet().iterator();
		String machote = "<meta name='{@name@}' value='{@value@}' />";
		String res = "<Metadatos>\n";
		while(keys.hasNext()){
			String key = keys.next();
			MetadataInput metaAct = (MetadataInput) inputsMeta.get(key);
			if(metaAct.modificado){
				String tmpRep = machote.replace("{@name@}", key);
				tmpRep = tmpRep.replace("{@value@}", metaAct.getUsrValue());
				res += "\t"+tmpRep+"\n";
			}
		}
		res+="</Metadatos>";
		return res;
	}
	
	public String[] getLoginPassword(){
		String tt = new String(this.pswd.getPassword());
		return new String[]{this.login.getText(), tt}; 
	}
	
	
	
	public void setLoginPassword(String login,String pswd){
		if(pswd != null)
			this.pswd.setText(pswd);
		if(login != null)
			this.login.setText(login);
	}
	public class MetadataInput {
		Metadato metaData;
		JLabel label;
		JComponent input;
		boolean modificado;
		public MetadataInput(Metadato metadato) {
			super();
			if (metadato == null)
				throw new IllegalArgumentException(
						"El metadato no puede ser null");
			
			metaData = metadato;
			
			char[] strLabel = metaData.getLabel().toCharArray();
			strLabel[0]		= Character.toUpperCase(strLabel[0]);
			String tmp		= (new String(strLabel))+" :";
			
			
			
			if(metaData.getDefaultVal().length>1){
				String[] valsOld = metaData.getDefaultVal();
				String[] valsNew = new String[valsOld.length+1];
				System.arraycopy(valsOld, 0, valsNew, 1, valsOld.length);
				valsNew[0] = "";
				JComboBox a = new JComboBox(valsNew);
				a.addActionListener(new ActionListener(){
					public void actionPerformed(ActionEvent e) {modificado = true;}
					});
				input = a;
			} else {
				JTextField a = new JTextField();
				a.getDocument().addDocumentListener(new DocumentListener(){
					public void changedUpdate(DocumentEvent e) {}
					public void insertUpdate(DocumentEvent e) {modificado = true;}
					public void removeUpdate(DocumentEvent e) {insertUpdate(e);}
				});
				input = a;
			}
			
			
			label = new JLabel(tmp);
			label.setLabelFor(input);
			input.setToolTipText(metaData.getDescripcion());
			label.setToolTipText(metaData.getDescripcion());
		}
		
		
		public String getUsrValue(){
			if(input instanceof JComboBox){
				return ((JComboBox)input).getSelectedItem().toString();
			} else {
				return ((JTextField)input).getText();
			}
		}
		
		
		public void setUsrValue(String value){
			modificado = false;
			if(input instanceof JComboBox){
				JComboBox tmpBox = ((JComboBox)input); 
				tmpBox.setSelectedItem(value);
				
				if(!tmpBox.getSelectedItem().equals(value))
					throw new IllegalArgumentException("'"+value+"' no es una opcion permitida para el metadato : '"+metaData.getLabel()+"'");
			} else {
				((JTextField)input).setText(value);
			}
		}
	}
	
	
	
	
	
	
		
	
}