/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
/**
 * 
 */
package edu.ite.items.metadatos.services.gui.componentes.tablebusqueda;

import java.util.Hashtable;
import java.util.Iterator;
import java.util.Vector;

import javax.swing.table.AbstractTableModel;

import edu.ite.items.beans.Item;
import edu.ite.items.beans.Metadato;

/**
 * @author oescamil
 *
 */
public class BusquedaMetadatosTableModel extends AbstractTableModel{
	private static final long serialVersionUID = 1L;
	private Vector<WrapperLLaveValor> columnsName;
	private Item[] rows;
	
	
	
	public BusquedaMetadatosTableModel(Hashtable<String, String> columasExtra){
		this.rows = new Item[0];
		
		
		
		Vector<WrapperLLaveValor> tmpColumnas = new Vector<WrapperLLaveValor>();
		

		WrapperLLaveValor tmp = null;
		
		
		tmp = new WrapperLLaveValor(null,"ID");
		tmpColumnas.add(tmp);
		tmp = new WrapperLLaveValor(null,"Miniatura");
		tmpColumnas.add(tmp);
		tmp = new WrapperLLaveValor(null,"Autor");
		tmpColumnas.add(tmp);
		
		
		
		
		Iterator<String> keys = (Iterator<String>) columasExtra.keys();
		while(keys.hasNext()){
			String key = keys.next();
			tmp = new WrapperLLaveValor(key,columasExtra.get(key));
			tmpColumnas.add(2,tmp);
		}
		
		
		columnsName = tmpColumnas;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getColumnCount()
	 */

	public int getColumnCount() {
		return columnsName.size();
	}
	
	/* (non-Javadoc)
	 * @see javax.swing.table.AbstractTableModel#getColumnName(int)
	 */
	@Override
	public String getColumnName(int column) {
		WrapperLLaveValor tmp = columnsName.get(column); 
		return tmp.value;
	}
	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getRowCount()
	 */
	public int getRowCount() {
		return rows.length;
	}

	/* (non-Javadoc)
	 * @see javax.swing.table.TableModel#getValueAt(int, int)
	 */
	public Object getValueAt(int rowIndex, int columnIndex) {
		Item tmpItem = rows[rowIndex];
		
		boolean esAutor = (getColumnCount()-1) == columnIndex; 
		if(esAutor){
			return "<html><center>"+tmpItem.getNombreAutor()+"</center>";	
		}
		
		switch (columnIndex) {
		case 0:
			return "<html><center>"+tmpItem.getId()+"</center>";
		
		case 1:
			String strRes = "<html><center><img src ='"+tmpItem.getPrevUrl()+"' /></center></html>"; 
			return   strRes;
		default:
			Metadato[] listaMeta = tmpItem.getMetadatos();
			WrapperLLaveValor tmpWrap = columnsName.get(columnIndex);
			String keyMeta = tmpWrap.getKey();
			for (int i = 0; i < listaMeta.length; i++) {
				Metadato metaAct =  listaMeta[i];
				if(keyMeta!=null && keyMeta.equals(metaAct.getLabel())){
					return "<html><center>"+metaAct.getValue()+"</center>";
				}	
			}
			return "Columna invalida :"+columnIndex;
		}
	}
	/**
	 * @return the rows
	 */
	public Item[] getRows() {
		return rows;
	}
	/**
	 * @param rows the rows to set
	 */
	public void setRows(Item[] rows) {
		this.rows = rows;
		fireTableDataChanged();
	}
	private class WrapperLLaveValor{
		private String key;
		/**
		 * @return the key
		 */
		public String getKey() {
			return key;
		}

		/**
		 * @param key the key to set
		 */
		public void setKey(String key) {
			this.key = key;
		}

		/**
		 * @return the value
		 */
		public String getValue() {
			return value;
		}

		/**
		 * @param value the value to set
		 */
		public void setValue(String value) {
			this.value = value;
		}

		private String value;
		
		public WrapperLLaveValor(String llave, String valor){
			this.key = llave;
			this.value = valor;
		}
	}
}