/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package edu.ite.items.services;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.security.InvalidParameterException;
import java.text.NumberFormat;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import java.util.zip.ZipOutputStream;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

import org.xml.sax.SAXException;

import edu.ite.items.beans.Item;
import edu.ite.items.beans.Metadato;
import edu.ite.items.metadatos.services.gui.BusquedaMetadatosGUI;
import edu.ite.items.metadatos.services.gui.MetadatosDialog;
import edu.ite.items.metadatos.services.gui.componentes.tablebusqueda.BusquedaMetadatosTableModel;
import edu.ite.items.metadatos.utils.ItemsServicesConnector;

public class ArquimedesItemsServices {
	private static URL hostService;
	private static String userLogin;
	private static String userPswd;
	private static File ultimoGuardado;
		
	public static Item uploadItemAux(Item item, File docbasedir, String usr, String pswd)
			throws SecurityException, IOException {
		
		try {
			ByteArrayOutputStream byteArrayOutputStream = new ByteArrayOutputStream();
			item.setLocalPath(docbasedir.getAbsolutePath());
			ZipOutputStream  zipOutStream = item.preparaZip(byteArrayOutputStream);
			return ItemsServicesConnector.uploadItem(
					hostService,
					usr,
					pswd, 
					byteArrayOutputStream.toByteArray(),
					item);
			
		} catch (IOException e) {
			e.printStackTrace();
			throw e;
		}
	}

	
	
	
	
	public static Item uploadItem(Item item, File docbasedir)
		throws InvalidParameterException  {
		if(docbasedir==null || !docbasedir.isDirectory())
			throw new InvalidParameterException(docbasedir + " no es un directorio");
		
		try {
			URL servicio = getHostService();
			
			if(servicio == null)
				return null;
			
			MetadatosDialog a = new MetadatosDialog(servicio);
			a.setLoginPassword(userLogin, userPswd);
			
			String strXML = item.printtoXmlString();
			a.setUsrData(strXML);
			String[] opciones = { "Enviar", "Cancelar" };
			JOptionPane pane = new JOptionPane(a, JOptionPane.PLAIN_MESSAGE);
			pane.setOptions(opciones);

			JDialog dialog = pane.createDialog(new JFrame(),"Publicar item");
			dialog.setResizable(true);
			dialog.pack();
			
			boolean terminarP = false;
			while (!terminarP) {
				dialog.setVisible(true);
				Object btnRes = pane.getValue();
				if (btnRes == null) {
					dialog.dispose();
					
					return null;
				} else if (btnRes.equals(opciones[1])) { // Hizo click en el segundo boton
					dialog.dispose();
					return null;
				} else if (btnRes.equals(opciones[0])) { // Hizo click en el primer boton
					String[] inputsMal = a.verificarInputs();
					if (inputsMal != null) {
						String msg = "<html><body>Los campos son obligatorios y no pueden estar vacos:<ul>";
						String listaStr = "";
						for (int i = 0; i < inputsMal.length; i++) {
							listaStr += 
									"<li>"+inputsMal[i]+"</li>";
							if(i>=3){
								listaStr +=	"<li>...</li>";
								break;
							}
						}
						msg += listaStr+"</ul></body></html>";
								
						JOptionPane.showMessageDialog(null, msg);
						terminarP = false;
						continue;
					}
					String nuevosMeta = a.getUsrData();
					
//System.out.println("Prueba de Codificacion"+nuevosMeta);
					Metadato[] nuevos = Metadato.getMetadatosFromXMLString(nuevosMeta);
					item.setMetadatos(nuevos);
					String[] vals = a.getLoginPassword();
					userLogin = vals[0];
					userPswd = vals[1];
					try{
						Item retorno = uploadItemAux(item,docbasedir,userLogin,userPswd); 
						dialog.dispose();
						JOptionPane.showMessageDialog(null,"Item publicado correctamente");
						return retorno; 
					} catch (SecurityException e) {
						e.printStackTrace();
						JOptionPane.showMessageDialog(null, e.getMessage());
						terminarP = false;
						continue;
					} catch (IOException e) {
						JOptionPane.showMessageDialog(null, e.getMessage());
					} catch (UnknownError e) {
						e.printStackTrace();
						JOptionPane.showMessageDialog(null, "Error deconocido","Error",JOptionPane.ERROR_MESSAGE);
					}
				}
				dialog.dispose();
				terminarP = true;
			}
		} catch (IOException e) {
			JOptionPane.showMessageDialog(null, "Error desconocido");
			e.printStackTrace();
		} catch (SAXException e) {
			JOptionPane.showMessageDialog(null, "Error desconocido");
			e.printStackTrace();
		}
		return null;
	}
	
	public static Item searchAndGetItem(File docbasedir)
			throws InvalidParameterException {
		if ((docbasedir != null)&&(!docbasedir.isDirectory())) {
			throw new InvalidParameterException(docbasedir
					+ " no es un directorio.");
		}
		try {
			URL host = getHostService();
			if (host == null)
				return null;
			BusquedaMetadatosGUI a = new BusquedaMetadatosGUI(host);
			String[] opciones = { "Descargar", "Cancelar" };
			JOptionPane pane = new JOptionPane(a, JOptionPane.PLAIN_MESSAGE);
			pane.setOptions(opciones);

			JDialog dialog = pane.createDialog(null,"Seleccionar Item");
			dialog.pack();
			dialog.setSize(920, 650);
			dialog.setLocation(120,80);
			dialog.doLayout();
			a.getSplitPane().setDividerLocation(0.35);
			dialog.setResizable(true);
			boolean bien = false;
			int filaSel = -1;
			Object res = null;
			while (!bien) {
				dialog.setVisible(true);
				filaSel = a.getTablaResultados().getSelectedRow();
				res = pane.getValue();
				// Por si apretaron abrir, pero no selecionaron ningun item
				if ((opciones[0].equals(res) && (filaSel == -1))) {
					JOptionPane.showMessageDialog(dialog,
							"No seleccion ningn item");
					bien = false;
					continue;
				}

				bien = true;
			}

			// Cerraron la ventana o cancelaron
			if ((res == null) || (opciones[1].equals(res)))
				filaSel = -1;

			BusquedaMetadatosTableModel model = (BusquedaMetadatosTableModel) a
					.getTablaResultados().getModel();
			Item itemSel = null;
			if (filaSel >= 0) {
				itemSel = model.getRows()[filaSel];
			}

			dialog.dispose();

//			System.out
//					.println("Termino el programa y la opcion elegida fue : \n"
//							+ "Boton:		" + res + "\n" + "Fila sel:	" + filaSel
//							+ "\n" + "Item Sel:	" + itemSel + " ID = "
//							+ ((itemSel == null) ? "-" : itemSel.getId()));
			
			
			
			
			if (itemSel != null){
				
				
				String itemId = itemSel.getId();
				NumberFormat format = NumberFormat.getIntegerInstance();
				format.setMinimumIntegerDigits(6);
				format.setGroupingUsed(false);
				String dirItemTmp = "item_"+format.format(Integer.parseInt(itemId));
				File tmpFile = null;
				
				if(docbasedir == null){
					JFileChooser fileChooser = new JFileChooser();
					fileChooser.setDialogTitle("Selecciona una carpeta para guardar el item");
					fileChooser.setDialogType(JFileChooser.SAVE_DIALOG);
					fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
					if(ultimoGuardado != null){
						fileChooser.setSelectedFile(ultimoGuardado);
					}
					boolean bienSel = false;
					while(!bienSel){
						int returnVal = fileChooser.showOpenDialog(null);
						if (returnVal == JFileChooser.APPROVE_OPTION) {
							docbasedir = fileChooser.getSelectedFile();
							if(!docbasedir.isDirectory()){
								JOptionPane.showMessageDialog(
										fileChooser,
										"No existe el directorio '"+docbasedir.getCanonicalPath()+"'",
										"Error al escribir en directotio.",
										JOptionPane.ERROR_MESSAGE);
								bienSel = false;
								continue;
							}
							tmpFile = new File(docbasedir,dirItemTmp);
							if(tmpFile.isDirectory()){
								int res2 = JOptionPane.showConfirmDialog(
										fileChooser,
										"El item "+dirItemTmp+" ya existe.\nDesea sobrescribirlo?",
										" Sobrescribir item ?",
										JOptionPane.YES_NO_CANCEL_OPTION);
								if(res2 == JOptionPane.NO_OPTION){
									bienSel = false;
									continue;
								}
								
								if(res2 == JOptionPane.CANCEL_OPTION){
									return null;
								}
							}
							if((!tmpFile.isDirectory())&&(!tmpFile.mkdirs()))
									throw new IOException("No pude crear el directorio '"+tmpFile+"'");
							bienSel = true;
						} else {
							return null;
						}
					}
				} else {
					tmpFile = new File(docbasedir,dirItemTmp);
				}
				
				ultimoGuardado = docbasedir;			
				itemSel = ItemsServicesConnector.downloadItem(host,itemId, tmpFile);
				itemSel.setLocalPath(tmpFile.getAbsolutePath()+File.separatorChar);
			}
			return itemSel;
		} catch (IOException e) {
			return null;
		}
	}

	public static URL getHostService() {
		hostService = ArquimedesItemsServices.usrSeleccionarHost();
		return hostService;
	}

	
	private static JComponent[] getPanelSelecServer() {
		String urlStrAnt = (hostService == null)?"":(hostService.toString()) ;
		Hashtable<String, String> hashHost = null;
		try {
			hashHost = ItemsServicesConnector.getServiceHosts();
		} catch (IOException e1) {}
		
		if(hashHost == null || hashHost.isEmpty())
			return null;
		
		MenuHostItemWrapper selected = new MenuHostItemWrapper();
		Object[] possibilities = null;
		Enumeration<String> keys = hashHost.keys();
		Vector<Object> tmpV = new Vector<Object>();
		
		while(keys.hasMoreElements()){
			MenuHostItemWrapper wrapper = new MenuHostItemWrapper();
			wrapper.hostUrl = keys.nextElement();
			wrapper.hostname = hashHost.get(wrapper.hostUrl);
			tmpV.add(wrapper);
			if(urlStrAnt.equals(wrapper.hostUrl)){
				selected = wrapper;
			}
		}
		possibilities = tmpV.toArray();
			
		JPanel toDialog = new JPanel();
		final JLabel urlSelLabel = new JLabel();
		final JComboBox popupMenu = new JComboBox(possibilities);
		JButton btnAdd = new JButton("Agregar");

		popupMenu.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				MenuHostItemWrapper a = (MenuHostItemWrapper) popupMenu.getSelectedItem();
				if(a!=null)
					urlSelLabel.setText(a.hostUrl);
				else
					urlSelLabel.setText("");
			}
		});
		btnAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				JPanel p = new JPanel();
				p.setLayout(new BoxLayout(p,BoxLayout.Y_AXIS));
				
				JTextField nombreHost = new JTextField();
				JTextField urlHost = new JTextField();
				JLabel l1 = new JLabel("Nombre : ");
				JLabel l2 = new JLabel("URL : ");
				
				Dimension sizeL = new Dimension(60,27);
				l1.setMinimumSize(sizeL);
				l2.setMinimumSize(sizeL);
				l1.setPreferredSize(sizeL);
				l2.setPreferredSize(sizeL);

				
				JPanel pTmp = new JPanel();
				pTmp.setLayout(new BoxLayout(pTmp,BoxLayout.X_AXIS));
				pTmp.setPreferredSize(new Dimension(400,30));
				pTmp.add(l1);
				pTmp.add(nombreHost);
				p.add(pTmp);
				
				pTmp = new JPanel();
				pTmp.setPreferredSize(new Dimension(400,30));
				pTmp.setLayout(new BoxLayout(pTmp,BoxLayout.X_AXIS));
				pTmp.add(l2);
				pTmp.add(urlHost);
				p.add(pTmp);			
				
				String tmpNom = "";
				String tmpUrl = "";
				boolean bien = false;
							
				while (!bien) {
					int opSel = JOptionPane.showOptionDialog(null, p,
							"Agregando nuevo servidor",
							JOptionPane.OK_CANCEL_OPTION,
							JOptionPane.PLAIN_MESSAGE, null, new String[] {
									"Aceptar", "Cancelar" }, "Aceptar");

					if (opSel != 0) {
						return;
					}
					tmpNom = nombreHost.getText().trim();
					tmpUrl = urlHost.getText().trim();
					bien = true;

					if (tmpNom.length() <= 0 || tmpUrl.length() <= 0) {
						JOptionPane.showMessageDialog(null,
								"No puede haber campos vacios");
						bien = false;
					}
					try {
						System.out.println("Probando la URL : ["+tmpUrl+"]");
						URL prueba = new URL(tmpUrl);
						HttpURLConnection conn = (HttpURLConnection) prueba
								.openConnection();
						conn.setDoOutput(true);
						conn.getOutputStream().close();
						conn.disconnect();
					} catch (IOException exp) {
						exp.printStackTrace();
						JOptionPane.showMessageDialog(
								null, 
								"El servidor '"+ tmpUrl+ "' no responde. Por favor seleccione otro.\n"
								+ exp.getMessage(),
								"Error de coneccin",
								JOptionPane.ERROR_MESSAGE);
						bien = false;
					}
				}
				System.out.println("Aceptada. Registrando en CFG usuario");
				ItemsServicesConnector.addNewHost(tmpUrl, tmpNom);
				try{
					Hashtable<String, String> hashHost = ItemsServicesConnector.getServiceHosts(); 
					Enumeration<String> keys = hashHost.keys();
					
					popupMenu.removeAllItems();
					MenuHostItemWrapper sel = null;
					while(keys.hasMoreElements()){
						MenuHostItemWrapper wrapper = new MenuHostItemWrapper();
						wrapper.hostUrl = keys.nextElement();
						wrapper.hostname = hashHost.get(wrapper.hostUrl);
						System.out.println("Agragando a al combobox "+wrapper);
						popupMenu.addItem(wrapper);	
						if(tmpUrl.equals(wrapper.hostUrl))
							sel = wrapper;						
					}
					popupMenu.setSelectedItem(sel);
				}catch(Exception exc){ exc.printStackTrace();}
			}
		});

		
		
		JPanel a = new JPanel();
		a.add(popupMenu);
		a.add(btnAdd);
		a.setAlignmentX(Component.LEFT_ALIGNMENT);
		toDialog.setLayout(new BorderLayout());
		toDialog.add(a,BorderLayout.WEST);
		toDialog.add(urlSelLabel,BorderLayout.SOUTH);
		
		urlSelLabel.setPreferredSize(new Dimension(120,30));
		
		popupMenu.setSelectedItem(selected);
		urlSelLabel.setText(((MenuHostItemWrapper)popupMenu.getSelectedItem()).hostUrl);
		
		return new JComponent[]{toDialog,popupMenu};
	}
	

	
	public static URL usrSeleccionarHost() {
		try {
			JComponent[] tmpPanel = getPanelSelecServer();
			if(tmpPanel == null){
				JOptionPane.showMessageDialog(null, "No se pudo determinar la lista de servidores");
				return null;
			}
			JComponent toDialog = tmpPanel[0];
			JComboBox popupMenu = (JComboBox) tmpPanel[1];
			
			boolean bien = false;
			MenuHostItemWrapper res = null;
			String s = null;
			
			while (!bien) {
				int opSel = JOptionPane.showOptionDialog(
						null,
						toDialog,
						"Servidores ITEms",
						JOptionPane.OK_CANCEL_OPTION,
						JOptionPane.PLAIN_MESSAGE,
						null,
						new String[]{"Aceptar", "Cancelar"},
						"Aceptar");
				
				if(opSel != 0){
					return null;
				}
				
				res = (MenuHostItemWrapper) popupMenu.getSelectedItem();
				bien = (res != null);
				
				if (bien) {
					
					s = res.hostUrl; 
					URL prueba = new URL(s);
					
					try {
						HttpURLConnection conn = (HttpURLConnection) prueba
								.openConnection();
						conn.setDoOutput(true);
						conn.getOutputStream().close();
						conn.disconnect();
					} catch (IOException e) {
						e.printStackTrace();
						JOptionPane.showMessageDialog(
										null,
										"El servidor no responde. Por favor seleccione otro.",
										"Error de coneccin",
										JOptionPane.ERROR_MESSAGE);
						bien = false;
						continue;
					}
				}
				bien = true;
			}
			if (s != null)
				return new URL(s);
			return null;
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

	

	public static void setUserLogin(String userLogin) {
		ArquimedesItemsServices.userLogin = userLogin;
	}

	public static String getUserLogin() {
		return userLogin;
	}

	public static void setUserPswd(String userPswd) {
		ArquimedesItemsServices.userPswd = userPswd;
	}

	public static String getUserPswd() {
		return userPswd;
	}
	
	
	
	public static void main(String[] args) {
		if((args.length>0) && "1".equals(args[0]))
			pruebaUpload();
		else
			pruebaDownload();
	}
	
	private static void pruebaUpload() {
		File codeBase = new File("D:\\Pruebas\\itemUpload\\");
		Item item = null;
		JFileChooser fc = new JFileChooser(codeBase);
		fc.setDialogTitle("De dnde saco los archivos del item ?");
		fc.setDialogType(JFileChooser.OPEN_DIALOG);
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int returnVal = fc.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			codeBase = fc.getSelectedFile();
			item = getItemPruebaGuardar(codeBase);
		} else {
			return;
		}
		
		
		if(item == null){
			System.out.println("el item fue null");
			return;
		}
			
		Item a = ArquimedesItemsServices.uploadItem(item, codeBase);
		if (a == null)
			System.out.println("Se obtuvo el ITEM :" + null);
		else
			System.out.println("Se obtuvo el ITEM :\n" + a.printItem());
	}





	private static Item getItemPruebaGuardar(File codeBase) {
		try {

			Item item = null;
			File index = new File(codeBase, "index.html");
			File info = new File(codeBase, "info.xml");

			FileInputStream fileInputStream;
			StringBuffer buffer;
			int leido;
			
			if(info.isFile()){
				fileInputStream = new FileInputStream(info);
				buffer = new StringBuffer();
				while ((leido = fileInputStream.read()) != -1) {
					buffer.append((char)leido);
				}
				fileInputStream.close();
				
				System.out.println("EL XML DEL ARCHIVO ES \n"+buffer);
				Item[] items = Item.getItemFromXmlStr(buffer.toString(), Item.FILL_LEVEL_METADATOS);
				item = items[0];
			}
			
			if(item == null){
				item = new Item("", "");
			}
			fileInputStream = new FileInputStream(index);
			buffer = new StringBuffer();
			while ((leido = fileInputStream.read()) != -1) {
				buffer.append((char)leido);
			}
			fileInputStream.close();
			item.setHtmlCode(buffer.toString());
			
			Vector<String> files = new Vector<String>();
			Vector<File> filesAux = new Vector<File>();
			
			filesAux.add(codeBase);
			String codeBaseAbs = codeBase.getAbsolutePath();
			while(!filesAux.isEmpty()){
				File actF = filesAux.firstElement();
				filesAux.remove(actF);
				
				File[] lista = actF.listFiles();
				for (int i = 0; i < lista.length; i++) {
					File dentroF = lista[i];
					if(dentroF.isDirectory()){
						filesAux.add(dentroF);
					} else {
						String dentroAbs = dentroF.getAbsolutePath();
						dentroAbs = dentroAbs.replace(codeBaseAbs, "");
						if(dentroAbs.indexOf(File.separatorChar)==0)
							dentroAbs = dentroAbs.substring(1);
						files.add(dentroAbs);
					}
				}
			}
			
			item.setFiles(files.toArray(new String[files.size()]));
			
			return item;
		} catch (IOException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		}
		return null;
	}





	private static void pruebaDownload(){
		File codeBase = new File("D:\\Pruebas\\downloadItems\\");
		JFileChooser fc = new JFileChooser(codeBase);
		fc.setDialogTitle("Donde guardo los archivos del item ?");
		fc.setDialogType(JFileChooser.SAVE_DIALOG);
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
		int returnVal = fc.showOpenDialog(null);
		if (returnVal == JFileChooser.APPROVE_OPTION) {
			codeBase = fc.getSelectedFile();
		} else {
			return;
		}

		Item a = ArquimedesItemsServices.searchAndGetItem(codeBase);
		if (a == null)
			System.out.println("Se obtuvo el ITEM :" + null);
		else
			System.out.println("Se obtuvo el ITEM :\n" + a.printItem());	
	}
}


class MenuHostItemWrapper {
	String hostname;
	String hostUrl;
	
	public String toString(){
		return hostname;
	}
	
	public boolean equals(Object o){
		if(o == null || !(o instanceof MenuHostItemWrapper))
			return false;
		MenuHostItemWrapper comp = (MenuHostItemWrapper)o;
		return (hostname == comp.hostname) && (hostUrl == comp.hostUrl);
	}
}