/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package edu.lite.radial;



import java.io.BufferedReader;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import org.xml.sax.InputSource;


public class RadialServices {
	URL urlToServices;
	static String defaultService = 
		"http://arquimedes.matem.unam.mx/DescartesHTML5/servicioDialogo/RADIAL/php/compararExprConTexto.php";
	String service = defaultService;

	public RadialServices(){
		this(defaultService);
	}

	public RadialServices(String urlService){
		service =  urlService;
		try{
			urlToServices = new URL(service);
		} catch (Exception e){
			System.out.println("Error al crear la clase ");
			e.printStackTrace();
		}
	}
	
	private String respuesta="";
	
	public boolean isCorrect() {
		return respuesta.toLowerCase().indexOf("true")>=0;
	}
	
	public String getCorrection() {
		int ix=respuesta.indexOf("|");
		if (ix>=0) {
			String correction=respuesta.substring(ix+1);
			return correction;
		}
		return "";
	}
	
	public String getAnswer(String pattern, String answer){
		respuesta="false";
		try{
			String urlConParams = urlToServices.toString()+"?"+
			"e="+URLEncoder.encode(pattern,"UTF-8")+"&"+//Patron 
			"o="+URLEncoder.encode(answer,"UTF-8")+"&"+//Cadena a evaluar
			"c=auto"+"&"; //auto,off,on
			URL tmpUrl = new URL(urlConParams);
			URLConnection conn = tmpUrl.openConnection();
			BufferedReader rd = new BufferedReader(new InputStreamReader(conn.getInputStream()));
			StringBuffer sb = new StringBuffer();
			String line;
			while ((line = rd.readLine()) != null){
				sb.append(line);
			}
			respuesta = sb.toString();
//			System.out.println("Respuesta del servidor : "+respuesta);
			return respuesta;
		} catch (MalformedURLException urlException){
			respuesta="false";
			urlException.printStackTrace();
		} catch (IOException e) {
			respuesta="false";
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return respuesta;
	}

	

	/**

	 * @param args

	 */

	public static void main(String[] args) {
		RadialServices rs = new RadialServices();
		String pattern = "(comer:2)and(fruta:2)";
		String words1 = "comer fruta";
		String words2 = "comer Pan";
		System.out.println("Prueba :"+rs.getAnswer(pattern, words1)); 
		System.out.println("Prueba :"+rs.getAnswer(pattern, words2)); 
	}

}

