/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package edu.unam.im.jla;

import java.awt.*;
import java.awt.event.*;

import com.mja.lang.translator;
import com.mja.file.mjaFile;
import com.mja.file.mjaFont;
import com.mja.util.BasicStr;
import com.mja.util.TFont;
import com.mja.cmp.mjaButton;
import com.mja.text.*;
import com.mja.textedit.*;

public class FormulaEditor extends Dialog implements ActionListener, WindowListener, ComponentListener {
	
	static final String FormulaEditorAttributes="fuentes=si colores=si fracciones=si potencias=si radicales=si series=si integrales=si limites=si matrices=si expresiones=no formulas=si caracteres=si unicode=no rtf=no imgenes=no";
	public static FormulaEditor fe;
	private static translator Tr;
	private static Color defaultBGColor=Color.white, defaultFGColor=Color.black;
	private static Color panelBGColor=new Color(0xffffff);
	private static final boolean variableSize=true, onlyFormula=false;
	private static Frame parent=new Frame();
	private static TFont tfont;

	private EditorButtons EB;
	private EditorCanvas EC;
	private Panel SP;
	private mjaButton b_ok,b_cancel;
	private boolean ok=false;
	private String in_formula;

	public static String editFormula(String in_formula) {
		if (fe==null) {
			fe=new FormulaEditor(in_formula);
			fe.pack();
		} else {
			fe.in_formula=in_formula;
		}
		fe.setText(in_formula);
		String out_formula=in_formula;
		fe.setVisible(true);
		if (fe.ok) {
			out_formula=fe.getText();
		}
		fe.stop();
		return out_formula;
	}
	
	public FormulaEditor(String in_formula) {
		super(parent,"Editor de Frmulas",true);
		this.in_formula=in_formula;
		setBackground(panelBGColor);
		setForeground(defaultFGColor);
		if (tfont==null) {
			tfont = new TFont(mjaFont.makeFont("SansSerif",Font.PLAIN,34));
		}
		if (Tr==null) {
			Tr=new translator(null);
		}
		EC=new EditorCanvas(null,parent,Tr,null,null,tfont,defaultFGColor,false,false,variableSize,onlyFormula);
		EC.setBackground(defaultBGColor);
		EC.setSize(760,300);
		EB=new EditorButtons(null,parent,Tr,true,true,true,false);
		EB.setAttributes(FormulaEditorAttributes);
		EB.setEditorCanvas(EC,false);
 		EB.setEditing(true);
		EB.selectChars(EditorButtons.Symbols);
		EB.updateChars();
		EC.addActionListener(EB);
		SP=new Panel();
		SP.setLayout(new FlowLayout(FlowLayout.CENTER,64,8));
		b_ok=new mjaButton("Aceptar");
		b_cancel=new mjaButton("Cancelar");
		b_ok.addActionListener(this);
		b_cancel.addActionListener(this);
		SP.add(b_ok);
		SP.add(b_cancel);
		setLayout(new BorderLayout());
		add("North",EB);
		add("Center",EC);
		add("South",SP);
		Dimension scrsz = Toolkit.getDefaultToolkit().getScreenSize();
		int xE = (scrsz.width - 770) / 2;
		int yE = (scrsz.height - 300) / 4;
		setLocation(xE,yE);
		addWindowListener(this);
		addComponentListener(this);
	}

	public void start() {
		EC.start();
	}
	
	public void stop() {
		EC.stop();
	}

	public void setText(String rtf_str) {
		Text T=new Text(null,tfont,defaultBGColor,defaultFGColor);
		RTF.parseRTF(rtf_str,T);
		T.setTopAndBottomMargin(0);
		T.setLeftMargin(3);
		EC.setText(T);
	}

	public String getText() {
		return EC.toRTF(false);
	}

/* -------------- Action Listener -------------- */

	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==b_ok) {
			ok=true;
		} else if (e.getSource()==b_cancel) {
			ok=false;
		}
		setVisible(false);
	}

/* -------------- Window Listener -------------- */

	public void windowOpened(WindowEvent we) {
	}
	
	public void windowClosed(WindowEvent we) {
	}
	
	public void windowClosing(WindowEvent we) {
		ok=false;
		setVisible(false);
	}
	
	public void windowActivated(WindowEvent we) {
	}
	
	public void windowDeactivated(WindowEvent we) {
	}
	
	public void windowIconified(WindowEvent we) {
	}
	
	public void windowDeiconified(WindowEvent we) {
	}
	
/* -------------- Component Listener -------------- */

	public void componentShown(ComponentEvent ce) {
		start();
	}

	public void componentHidden(ComponentEvent ce) {
	}

	public void componentResized(ComponentEvent ce) {
	}

	public void componentMoved(ComponentEvent ce) {
	}
}