import java.net.*;
import java.io.*;
import java.util.*;

public class importDataToHtml { 

	public static String readInputStream(InputStream is) throws IOException {
		InputStreamReader isr=new InputStreamReader(is,"ISO-8859-1");
		// ISO-8859-1 codification added on ver 3.913 2008-02-15
		BufferedReader br=new BufferedReader(isr);
		StringBuffer sb=new StringBuffer();
		String auxs="";
		do {
			auxs=br.readLine();
			if (auxs!=null) {
				sb.append(auxs+"\n");
			}
		} while (auxs!=null);
		isr.close();
		String s=sb.toString();
		return s;
	}

	public static String readFile(String path) {
		try {
			File f=new File(path);
			InputStream is=new FileInputStream(f);
			String s=readInputStream(is);
			return s;
		} catch (IOException e1) {
			return null;
		}
	}

	public static String[] toStringArray(String s) {
		return toStringArray(s,false);
	}

	public static String[] toStringArray(String s,boolean returnDelims) {
		StringTokenizer st=new StringTokenizer(s,"\n",returnDelims);
		String[] sa=new String[st.countTokens()];
		for (int i=0; i<sa.length; i++) {
			sa[i]=st.nextToken();
		}
		return sa;
	}

	static public boolean fileExists(String filename) {
		File f=new File(filename);
		return f.exists();
	}

	static public void delete(String filename) {
		if (fileExists(filename)) {
			File f=new File(filename);
			f.delete();
		}
	}

	public static String replace(String s,String s1,String s2) {
		if (s!=null&&s.length()>0) {
			String auxs=s;
			int pos=0,l1=s1.length();
			while ((pos=auxs.indexOf(s1,pos))>=0) {
				auxs=auxs.substring(0,pos)+s2+auxs.substring(pos+l1);
				pos+=s2.length();
			}
			return auxs;
		} else {
			return "";
		}
	}

	static public void save(String filename,String str) {
		String[] sa=toStringArray(str);
		String s="";
		for (int i=0;i<sa.length;i++) {
			if( (sa[i].length()>2) && sa[i].startsWith("'") && sa[i].endsWith("'") ) {
				sa[i]=sa[i].substring(1,sa[i].length()-1);
				sa[i]=replace(sa[i],"'","");
				sa[i]="'"+sa[i]+"'";
			}
			s+=sa[i]+"\r\n";
		}
		delete(filename);
		File f=new File(filename);
		try {
			BufferedWriter bw=new BufferedWriter(new FileWriter(f));
			bw.write(s,0,s.length());
			bw.close();
		} catch (IOException e) {
			System.out.println("could not save file "+filename);
			e.printStackTrace();
		}
	}

	static String script_ini="\n<script id=\"";
	static String script_mid1="\" type=\"descartes/vectorFile\">\n";
	static String script_mid="\" type=\"descartes/archivo\">\n";
	static String script_end="</script>\n\n";

	public static void main(String[] args) {
		if (args.length>=3) {
			String data_dir=args[0];
			if (!data_dir.endsWith("/")) {
				data_dir+="/";
			}
			String inputfile=args[1];
			String outputfile=args[2];
			String str0=readFile(inputfile);
			int ix=str0.toLowerCase().indexOf("</body>");
			if (ix<0) {
				ix=str0.toLowerCase().indexOf("</head>");
				if (ix<0) {
					ix=0;
				}
			}
			String str=str0.substring(0,ix)+"\n";
			str+="<!-- DATA for DESCARTES -->\n";
			String str_files=readFile(data_dir+"_data_cfg.txt");
			String[] fa=toStringArray(str_files);
			for (int i=0;i<fa.length;i++) {
				String sf=readFile(data_dir+fa[i]);
				save(data_dir+fa[i],sf);
				if (sf.indexOf("<AUX>")>=0) {
					str+=script_ini+data_dir+fa[i]+script_mid;
				} else {
					str+=script_ini+data_dir+fa[i]+script_mid1;
				}
				str+=sf+script_end;
			}
			str+="<!-- END of DATA for DESCARTES -->\n";
			str+=str0.substring(ix);
			save(outputfile,str);
		} else {
			System.out.println("Use: java importDataToHtml <dir> <inputfile> <outputfile>");
		}
	}
		
}