/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client.admin;

import java.awt.*;
import java.awt.event.*;
import org.cnice.lms.admin.*;
import org.cnice.lms.client.*;

public class AdminFrame extends Frame implements WindowListener {

	public static void main(String[] args) {
		String db_host="";
		String db_initial_port="8082", db_final_port="8082";
		if (args!=null) {
			int i=0;
			while (i<args.length) {
				if (args[i].equals("-HOST")) {
					db_host=args[++i];
				} else if (args[i].equalsIgnoreCase("-INITIAL_PORT")) {
					db_initial_port=args[++i];
				} else if (args[i].equalsIgnoreCase("-FINAL_PORT")) {
					db_final_port=args[++i];
				} else if (args[i].equalsIgnoreCase("-LANGUAGE")) {
					util.setLanguage(args[++i]);
				}
				i++;
			}
		}
		new AdminFrame(db_host,db_initial_port,db_final_port);
	}
	
	public AdminFrame(String db_host,String db_initial_port,String db_final_port) {
		super(AdminPanel.TITLE);
		setLayout(new GridLayout(1,1));
		add(new AdminTool(db_host,db_initial_port,db_final_port));
		addWindowListener(this);
		pack();
		Dimension scrSz=Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((scrSz.width-getSize().width)/2,(scrSz.height-getSize().height)/2);
		show();
	}
	
/* ------------------- WindowListener ---------------- */
	
	public void windowClosing(WindowEvent e){
		System.exit(0);
	}
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}

}