/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client.admin;

import java.awt.*;
import java.awt.event.*;
import java.util.*;

import org.cnice.lms.common.*;
import org.cnice.lms.client.*;

public abstract class AdminPanel extends Panel implements ActionListener, ItemListener {

	public static final String TITLE="LMS Admin Tool";
	public static final Color veryLightGray=new Color(0xe8e8e8);

	public static final int clr=0,qry=1,ins=2,del=3,upd=4;
	public static final String[][] b_names= {
		{"clear","search","insert new","delete","update"},
//		{"limpiar","buscar","insertar nuevo","eliminar","cambiar"}
		{"limpiar","hacer una bsqueda",
			"introducir nuevo registro con estos datos",
			"eliminar",
			"modificar con estos datos "}
	};
	public static final String[] active_name={"active register","registro activo"};

	protected AdminClient client;
	protected AdminTool tool;
	protected Button b_c,b_i,b_d,b_u,b_q,b_cl;
	protected Label lb_ID,lb_active;
	protected java.awt.List list;
	protected Panel SEP;

	private Panel CP;
//	private Label TL;
	private Vector actionListeners;

	public AdminPanel(AdminClient client,AdminTool tool) {
		this.client=client;
		this.tool=tool;
		actionListeners=new Vector();
		setLayout(new GridLayout(1,2));
		Panel EP=new Panel();
		EP.setLayout(new BorderLayout());
//		EP.add("North",TL=new Label());
//		TL.setFont(util.Serif16);
//		TL.setBackground(Color.blue);
//		TL.setForeground(Color.white);
		EP.add("Center",list=new java.awt.List());
		list.setFont(util.Monospaced);
		list.setBackground(veryLightGray);
		list.addActionListener(this);
		list.addItemListener(this);
		SEP=new Panel();
		EP.add("South",SEP);
		SEP.setLayout(new FlowLayout(FlowLayout.CENTER));
		SEP.add(b_cl=new Button(b_names[util.Lang][clr]));
		b_cl.addActionListener(this);

		Panel WP=new Panel();
		add(WP);
		add(EP);
		WP.setLayout(new BorderLayout());
		CP=new Panel();
		Panel SP=new Panel();
		WP.add("Center",CP);
		WP.add("South",SP);
		CP.setLayout(new GridBagLayout());
		SP.setLayout(new GridBagLayout());

		b_c=new Button(b_names[util.Lang][clr]);
		b_q=new Button(b_names[util.Lang][qry]);
		b_i=new Button(b_names[util.Lang][ins]);
		b_d=new Button(b_names[util.Lang][del]);
		b_u=new Button(b_names[util.Lang][upd]);
		b_c.addActionListener(this);
		b_q.addActionListener(this);
		b_i.addActionListener(this);
		b_d.addActionListener(this);
		b_u.addActionListener(this);
		lb_ID=new Label();
		lb_ID.setAlignment(Label.CENTER);
		lb_ID.setBackground(veryLightGray);
		lb_ID.setForeground(Color.black);
		lb_active=new Label(active_name[util.Lang]);
		lb_active.setAlignment(Label.CENTER);

//		addToGBL(SP,b_c,0,1,1);
//		addToGBL(SP,b_q,0,2,1);
//		addToGBL(SP,b_i,0,3,1);
//		addToGBL(SP,b_d,1,1,1);
//		addToGBL(SP,lb_ID,1,2,1);
//		addToGBL(SP,b_u,1,3,1);
		addToGBL(SP,b_c,0,0,2,2,12);
		addToGBL(SP,b_q,1,0,2,2,12);
		addToGBL(SP,b_i,2,0,2,2,12);
		addToGBL(SP,lb_active,3,0,1,2,12);
		addToGBL(SP,lb_ID,3,1,1,2,12);
		addToGBL(SP,b_d,4,0,1,2,12);
		addToGBL(SP,b_u,4,1,1,2,12);

		if (!client.getUserType().equals(AdminClient.userTypeNames[0][AdminClient.admin])) {
			b_i.setEnabled(false);
			b_u.setEnabled(false);
			b_d.setEnabled(false);
		}

	}

	private static void addToGBL(Panel P,Component C,int L,int x,int w) {
		addToGBL(P,C,L,x,w,8,12);
	}
	private static void addToGBL(Panel P,Component C,int L,int x,int w,int v,int h) {
		if (C instanceof TextField) {
			C.setFont(util.Monospaced);
		}
		if (C instanceof Label) {
			((Label)C).setAlignment(Label.CENTER);
		} else if (C instanceof Button) {
//			((Button)C).addActionListener(this);
		}
		GridBagConstraints gbc=new GridBagConstraints();
		gbc.fill=GridBagConstraints.BOTH;
		gbc.insets=new Insets(v,h,v,h);
		gbc.gridy=L;
		gbc.gridx=x; gbc.gridwidth=w;
		P.add(C,gbc);
	}

	String getSelectedId() {
		return lb_ID.getText();
	}

	int getSelectedIndex() {
		return list.getSelectedIndex();
	}

	String getSelectedItem() {
		return list.getSelectedItem();
	}

	void add(Component C,int line,int x, int w) {
		addToGBL(CP,C,line,x,w);
	}

	void add(Component C,int line,int x, int w,int v,int h) {
		addToGBL(CP,C,line,x,w,v,h);
	}

	abstract void refresh(SqlValueArray va);
	abstract void clear();
	abstract String QueryStr();
	abstract String InsertStr();
	abstract String UpdateStr();
	abstract String DeleteStr();
	abstract String outputStr(SqlValueArray va);

	String insertOK() {
		return "\n El nuevo elemento ha sido dado de alta.";
	}

	String insertKO() {
		return "\n No se ha podido insertar este nuevo elemento.";
	}

	String updateOK() {
		return "\n Los datos de este elemento se han modificado.\n";
	}

	String updateKO() {
		return "\n No se han podido modificar los datos de este elemento.";
	}

	String deleteOK() {
		return "\n El elemento se ha eliminado.";
	}

	String deleteKO() {
		return "\n No se ha podido eliminar este elemento.";
	}

	String idNeeded() {
		return "\n Hay que seleccionar un elemento de la lista (con doble clic).";
	}

	SqlResult values;

	public void actionPerformed(ActionEvent e){
		if (e.getSource()==b_q) {
			list.removeItemListener(this);
			list.removeAll();
			values=null;
			try {
				values = client.executeQuery(QueryStr());
				if (values!=null) {
					for (int n=0;n<values.size();n++) {
						list.add(outputStr(values.valueAt(n)));
					}
				}
			} catch (Exception ex) {
				ex.printStackTrace ();
			}
			list.addItemListener(this);
		} else if (e.getSource()==b_i) {
			try {
				int n=client.executeUpdate(InsertStr(),null);
				// limpiar ventana y ensear el nuevo
				actionPerformed(new ActionEvent(b_cl,ActionEvent.ACTION_PERFORMED,""));
				actionPerformed(new ActionEvent(b_q,ActionEvent.ACTION_PERFORMED,""));
				util.showMessage(TITLE,insertOK(),3,insertOK().length()+8);
			} catch (Exception ex) {
				util.showMessage(TITLE,insertKO()+"\n\n"+ex.getMessage(),7,80);
			}
		} else if (e.getSource()==b_u) {
			if (lb_ID.getText().length()>0) {
				try {
					int n=client.executeUpdate(UpdateStr(),null);
					// limpiar ventana y ensear el nuevo
					actionPerformed(new ActionEvent(b_cl,ActionEvent.ACTION_PERFORMED,""));
					actionPerformed(new ActionEvent(b_q,ActionEvent.ACTION_PERFORMED,""));
					util.showMessage(TITLE,updateOK(),3,updateOK().length()+8);
				} catch (Exception ex) {
					util.showMessage(TITLE,updateKO()+"\n\n"+ex.getMessage(),7,80);
				}
			} else {
				util.showMessage(TITLE,idNeeded(),3,80);
			}
		} else if (e.getSource()==b_d) {
			if (lb_ID.getText().length()>0) {
				try {
					int n=client.executeUpdate(DeleteStr(),null);
					// limpiar ventana
					actionPerformed(new ActionEvent(b_cl,ActionEvent.ACTION_PERFORMED,""));
					util.showMessage(TITLE,deleteOK(),3,deleteOK().length()+8);
				} catch (Exception ex) {
					util.showMessage(TITLE,deleteKO()+"\n\n"+ex.getMessage(),7,80);
				}
			} else {
				util.showMessage(TITLE,idNeeded(),3,80);
			}
		} else if (e.getSource()==b_c) {
			clear();
		} else if (e.getSource()==b_cl) {
			list.removeItemListener(this);
			list.removeAll();
			list.addItemListener(this);
		} else if (e.getSource()==list) {
			callActionListeners();
		}
	}

	public void addActionListener(ActionListener al) {
		actionListeners.addElement(al);
	}

	private void callActionListeners() {
		for (int i=0;i<actionListeners.size();i++) {
			((ActionListener) actionListeners.elementAt(i)).actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,""));
		}
	}

	public void itemStateChanged(ItemEvent e) {
		if (e.getSource()==list && e.getStateChange()==e.SELECTED) {
			refresh(values.valueAt(list.getSelectedIndex()));
		}
	}

}