/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client.admin;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

import org.cnice.lms.common.*;
import org.cnice.lms.client.*;

public class CoursesPanel extends AdminPanel {
	
	private TextField tf_level,tf_courseName;
	private Checkbox chbx_courseActive;
	private static final int level=0,course=1,active=2;
	private static final String[][] names={
		{"Level","Course","Active"},
		{"Nivel","Curso","Activo"}
	};


	public CoursesPanel(AdminClient client,AdminTool tool) {
		super(client,tool);
		int line=0;
		add(new Label(names[util.Lang][level]),line,0,1);
		add(tf_level=new TextField(36),line,1,4);
		line++;
		add(new Label(names[util.Lang][course]),line,0,1);
		add(tf_courseName=new TextField(36),line,1,4);
		line++;
		add(chbx_courseActive=new Checkbox(names[util.Lang][active]),line,2,1);
		chbx_courseActive.setState(true);
		clear();
	}

	void refresh(SqlValueArray va) {
		tf_level.setText(va.getString("level"));
		tf_courseName.setText(va.getString("name"));
		chbx_courseActive.setState(va.getInt("active")==1);
		lb_ID.setText(va.getString("id"));
	}

	void clear() {	
		lb_ID.setText("");
		tf_level.setText("");
		tf_courseName.setText("");
		chbx_courseActive.setState(true);
	}
	
	
	String outputStr(SqlValueArray va) {
		return va.getString("name");
	}
	
	String QueryStr() {
		String query="select * from courses where";
		query+=" level like '"+util.getInfo(tf_level)+"'";
		query+=" and name like '"+util.getInfo(tf_courseName)+"'";
		query+=" and active="+util.getInfo(chbx_courseActive);
		query+=" order by name";
		return query;
	}

	String InsertStr() {
		String s="insert into courses (level,name,active) values (";
		s+="'"+tf_level.getText()+"'";
		s+=",'"+tf_courseName.getText()+"'";
		s+=",'"+util.getInfo(chbx_courseActive)+"'";
		s+=")";
		return s;
	}
	
	String UpdateStr() {
		String s="update courses set ";
		s+="level='"+tf_level.getText()+"'";
		s+=",name='"+tf_courseName.getText()+"'";
		s+=",active="+util.getInfo(chbx_courseActive);
		s+=" where id="+lb_ID.getText();
		return s;
	}
	
	String DeleteStr() {
		return "delete from courses where id="+lb_ID.getText();
	}
	
	public void actionPerformed(ActionEvent e){
		super.actionPerformed(e);
		if (e.getSource()==b_i||e.getSource()==b_u||e.getSource()==b_d) {
			tool.refreshCourses();
		}
	}
	
}