/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client.admin;

import java.awt.*;
import java.awt.event.*;

import org.cnice.lms.common.*;
import org.cnice.lms.client.*;

public class LearnersPanel extends AdminPanel {
	
	private AdminChoice ch_learner_learner,ch_learner_course,ch_learner_tutor;
	private Checkbox chbx_learnerActive;
	private static final int lrn=0,tut=1,course=2,active=3;
	private static final String[][] names={
		{"Learner","Tutor","Course","Active"},
		{"Alumno","Tutor","Curso","Activo"}
	};

	public LearnersPanel(AdminClient client,AdminTool tool) {
		super(client,tool);
		int line=0;
		add(new Label(names[util.Lang][lrn]),line,0,1);
		add(ch_learner_learner=new AdminChoice(),line,1,3);
		client.getUsers(AdminClient.learner,ch_learner_learner);
		line++;
		add(new Label(names[util.Lang][course]),line,0,1);
		add(ch_learner_course=new AdminChoice(),line,1,3);
		ch_learner_course.addItemListener(this);
		client.getCourses(ch_learner_course);
		line++;
		add(new Label(names[util.Lang][tut]),line,0,1);
		add(ch_learner_tutor=new AdminChoice(),line,1,3);
		client.getUsers(AdminClient.tutor,ch_learner_tutor);
		line++;
		add(chbx_learnerActive=new Checkbox(names[util.Lang][active]),line,1,1);
		chbx_learnerActive.setState(true);

		if (client.getUserType().equals(AdminClient.userTypeNames[0][AdminClient.tutor])) {
			ch_learner_tutor.selectById(client.getUserID());
			ch_learner_tutor.setEnabled(false);
		} else if (client.getUserType().equals(AdminClient.userTypeNames[0][AdminClient.learner])) {
			ch_learner_learner.selectById(client.getUserID());
			ch_learner_learner.setEnabled(false);
		}

		clear();
	}
	
	public void refreshCourses() {
		client.getCourses(ch_learner_course);
	}
	
	public void refreshUsers() {
		client.getUsers(AdminClient.learner,ch_learner_learner);
		client.getUsers(AdminClient.tutor,ch_learner_tutor);
	}
	
	private String last_activity;
	String getLastActivity() {
		return last_activity;
	}

	void refresh(SqlValueArray va) {
		lb_ID.setText(va.getString("id"));
		try {
			SqlResult values=client.executeQuery("select users.lastname,users.firstname from users"+
			" where users.id='"+va.getString("tutor_userid")+"'");
			SqlValueArray vatutor=values.valueAt(0);
			ch_learner_course.selectById(va.getString("courseid"));
			if (ch_learner_tutor.isEnabled()) {
				client.getTutors(va.getString("courseid"),ch_learner_tutor);
			}
			chbx_learnerActive.setState(va.getInt("active")==1);
			selectLearnerById(va.getString("userid"));
			selectTutorById(va.getString("tutor_userid"));
			last_activity=va.getString("last_activity");
		} catch (Exception e) {
			System.out.println(e.getMessage());
			System.out.println("in LearnerPanel.refresh");
		}
	}

	void selectLearnerById(String id) {	
		if (ch_learner_learner.isEnabled()) {
			ch_learner_learner.selectById(id);
		}
	}

	void selectTutorById(String id) {	
		if (ch_learner_tutor.isEnabled()) {
			ch_learner_tutor.selectById(id);
		}
	}

	void selectCourseById(String id) {	
		ch_learner_course.selectById(id);
	}

	String getSelectedLearnerId() {
		return ch_learner_learner.getSelectedId();
	}
	String getSelectedTutorId() {
		return ch_learner_tutor.getSelectedId();
	}

	String getSelectedCourseId() {
		return ch_learner_course.getSelectedId();
	}

	void clear() {	
		lb_ID.setText("");
		selectLearnerById("");
		if (ch_learner_tutor.isEnabled()) {
			client.getTutors("",ch_learner_tutor);
		}
		selectTutorById("");
		selectCourseById("");
		chbx_learnerActive.setState(true);
	}
	
	
	String outputStr(SqlValueArray va) {
		return va.getString("lastname")+" "+va.getString("firstname")+" "+va.getString("name");
	}
	
	String QueryStr() {
		String learner_userid=ch_learner_learner.getSelectedId();
		String courseid=ch_learner_course.getSelectedId();
		String tutor_userid=ch_learner_tutor.getSelectedId();

		String query="select distinct learners.id,learners.userid,learners.courseid,learners.tutor_userid,users.lastname,users.firstname,courses.name,learners.active,learners.last_activity from courses,users,learners where";
		String nextstr="";
		if (learner_userid.length()>0) {
			query+=" learners.userid="+learner_userid;
			nextstr=" and";
		}
		if (courseid.length()>0) {
			query+=nextstr+" learners.courseid="+courseid;
			nextstr=" and";
		}
		if (tutor_userid.length()>0) {
			query+=nextstr+" learners.tutor_userid="+tutor_userid;
			nextstr=" and";
		}
		query+=nextstr+" users.id=learners.userid";
		query+=" and courses.id=learners.courseid";			
		query+=" and learners.active="+util.getInfo(chbx_learnerActive);
		query+=" order by learners.id";
		return query;
	}

	String InsertStr() {
		if (ch_learner_learner.getSelectedId().length()>0&&ch_learner_course.getSelectedId().length()>0&&ch_learner_tutor.getSelectedId().length()>0) {		
			String s="insert into learners (userid,courseid,tutor_userid,active) values (";
			s+="'"+ch_learner_learner.getSelectedId()+"'";
			s+=",'"+ch_learner_course.getSelectedId()+"'";
			s+=",'"+ch_learner_tutor.getSelectedId()+"'";
			s+=",'"+util.getInfo(chbx_learnerActive)+"'";
			s+=")";
			return s;
		} else {
			return "";
		}
	}
	
	String UpdateStr() {
		if (ch_learner_learner.getSelectedId().length()>0&&ch_learner_course.getSelectedId().length()>0&&ch_learner_tutor.getSelectedId().length()>0) {		
			String s="update learners set ";
			s+="userid='"+ch_learner_learner.getSelectedId()+"'";
			s+=",courseid='"+ch_learner_course.getSelectedId()+"'";
			s+=",tutor_userid='"+ch_learner_tutor.getSelectedId()+"'";
			s+=",active="+util.getInfo(chbx_learnerActive);
			s+=" where id="+lb_ID.getText();
			return s;
		} else {
			return "";
		}
	}
	
	String DeleteStr() {
		return "delete from learners where id="+lb_ID.getText();
	}
	
	public void itemStateChanged(ItemEvent e) {
		super.itemStateChanged(e);
		if (e.getSource()==ch_learner_course && ch_learner_tutor.isEnabled()) {
			client.getTutors(ch_learner_course.getSelectedId(),ch_learner_tutor);
		}
	}
	
	public void actionPerformed(ActionEvent e){
		super.actionPerformed(e);
		if (e.getSource()==list) {
			tool.goToActivities(ch_learner_learner.getSelectedId(),
				ch_learner_course.getSelectedId(),
				ch_learner_tutor.getSelectedId());
		}
	}
	
}