/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client.admin;

import java.awt.*;
import java.awt.event.*;

import org.cnice.lms.common.*;
import org.cnice.lms.client.*;

public class TutorsPanel extends AdminPanel {
	
	private AdminChoice ch_tutor_course,ch_tutor_tutor;
	private Checkbox chbx_tutorActive;
	private static final int tut=0,course=1,active=2;
	private static final String[][] names={
		{"Tutor","Course","Active"},
		{"Tutor","Curso","Activo"}
	};

	public TutorsPanel(AdminClient client,AdminTool tool) {
		super(client,tool);
		int line=0;
		add(new Label(names[util.Lang][tut]),line,0,1);
		add(ch_tutor_tutor=new AdminChoice(),line,1,3);
		client.getUsers(AdminClient.tutor,ch_tutor_tutor);
		line++;
		add(new Label(names[util.Lang][course]),line,0,1);
		add(ch_tutor_course=new AdminChoice(),line,1,3);
		client.getCourses(ch_tutor_course);
		line++;
		add(chbx_tutorActive=new Checkbox(names[util.Lang][active]),line,1,1);
		chbx_tutorActive.setState(true);
		if (client.getUserType().equals(AdminClient.userTypeNames[0][AdminClient.tutor])) {
			ch_tutor_tutor.selectById(client.getUserID());
			ch_tutor_tutor.setEnabled(false);
		}
		clear();
	}

	public void refreshCourses() {
		client.getCourses(ch_tutor_course);
	}
	
	public void refreshUsers() {
		client.getUsers(AdminClient.tutor,ch_tutor_tutor);
	}
	
	void refresh(SqlValueArray va) {
		ch_tutor_course.selectById(va.getString("courseid"));
		ch_tutor_tutor.selectById(va.getString("userid"));
		chbx_tutorActive.setState(va.getInt("active")==1);
		lb_ID.setText(va.getString("id"));
	}
	
	void selectTutorById(String id) {
		if (ch_tutor_tutor.isEnabled()) {
			ch_tutor_tutor.selectById(id);
		}
	}

	void selectCourseById(String id) {
		ch_tutor_course.selectById(id);
	}
	
	String getSelectedTutorId() {
		return ch_tutor_tutor.getSelectedId();
	}

	String getSelectedCourseId() {
		return ch_tutor_course.getSelectedId();
	}

	void clear() {	
		lb_ID.setText("");
		selectTutorById("");
		selectCourseById("");
		chbx_tutorActive.setState(true);
	}
	
	String outputStr(SqlValueArray va) {
		return va.getString("lastname")+" "+va.getString("firstname")+" "+va.getString("name");
	}
	
	String QueryStr() {
		String query="select distinct tutors.id,tutors.userid,tutors.courseid,tutors.active,users.lastname,users.firstname,courses.name from courses,users,tutors where";
		if (ch_tutor_course.getSelectedItem().length()>0 && ch_tutor_tutor.getSelectedItem().length()>0) {
			query+=" courses.id="+ch_tutor_course.getSelectedId();
			query+=" and users.id="+ch_tutor_tutor.getSelectedId();
			query+=" and courses.id=tutors.courseid";
			query+=" and users.id=tutors.userid";
		} else if (ch_tutor_course.getSelectedItem().length()>0) {
			query+=" courses.id="+ch_tutor_course.getSelectedId();
			query+=" and courses.id=tutors.courseid";
			query+=" and users.id=tutors.userid";
		} else if (ch_tutor_tutor.getSelectedItem().length()>0) {
			query+=" users.id="+ch_tutor_tutor.getSelectedId();
			query+=" and courses.id=tutors.courseid";
			query+=" and users.id=tutors.userid";
		} else {
			query+=" courses.id=tutors.courseid and users.id=tutors.userid";
		}
		query+=" and tutors.active="+util.getInfo(chbx_tutorActive);
		query+=" order by tutors.id";
		return query;
	}

	String InsertStr() {
		String s="insert into tutors (courseid,userid,active) values (";
		s+="'"+ch_tutor_course.getSelectedId()+"'";
		s+=",'"+ch_tutor_tutor.getSelectedId()+"'";
		s+=",'"+util.getInfo(chbx_tutorActive)+"'";
		s+=")";
		return s;
	}
	
	String UpdateStr() {
		return "";
	}

	String DeleteStr() {
		return "delete from tutors where id="+lb_ID.getText();
	}
	
}