/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client.admin;

import java.awt.*;
import java.awt.event.*;

import org.cnice.lms.common.*;
import org.cnice.lms.client.*;

public class UsersPanel extends AdminPanel {
	
	private Choice ch_userType;
	private TextField tf_login, tf_password, tf_lastname, tf_firstname, tf_email;
	private static final int usr=0,pwd=1,lnm=2,fnm=3,eml=4,typ=5;
	private static final String[][] names={
		{"Login","Password","Last Name","First Name","E-mail","Type"},
		{"Usuario","Contrasea","Apellidos","Nombres","E-mail","Tipo"}
	};

	public UsersPanel(AdminClient client,AdminTool tool) {
		super(client,tool);
		int line=0;
		add(new Label(names[util.Lang][usr]),line,0,1);
		add(tf_login=new TextField(9),line,1,1);
		line++;
		add(new Label(names[util.Lang][pwd]),line,0,1);
		add(tf_password=new TextField(9),line,1,1);
		line++;
		add(new Label(names[util.Lang][lnm]),line,0,1);
		add(tf_lastname=new TextField(25),line,1,2);
		line++;
		add(new Label(names[util.Lang][fnm]),line,0,1);
		add(tf_firstname=new TextField(25),line,1,2);
		line++;
		add(new Label(names[util.Lang][eml]),line,0,1);
		add(tf_email=new TextField(25),line,1,2);
		line++;
		add(new Label(names[util.Lang][typ]),line,0,1);
		add(ch_userType=new Choice(),line,1,1);
		ch_userType.addItem("");
		for (int i=0;i<Client.userTypeNames[0].length;i++) {
			ch_userType.addItem(Client.userTypeNames[util.Lang][i]);
		}
		clear();
	}

	String getUserType() {
		return ch_userType.getSelectedItem();
	}
	
	void clear() {	
		tf_login.setText("");
		tf_password.setText("");
		tf_lastname.setText("");
		tf_firstname.setText("");
		tf_email.setText("");
		ch_userType.select("");
		lb_ID.setText("");
	}
	
	void refresh(SqlValueArray va) {
		lb_ID.setText(va.getString("id"));
		tf_login.setText(va.getString("login"));
		tf_password.setText(va.getString("password"));
		tf_lastname.setText(va.getString("lastname"));
		tf_firstname.setText(va.getString("firstname"));
		tf_email.setText(va.getString("email"));
		ch_userType.select(Client.getUserTypeName(va.getString("type")));
	}
	
	String outputStr(SqlValueArray va) {
		return va.getString("lastname")+" "+va.getString("firstname");
	}
	
	String QueryStr() {
		String query="select * from users where";
		query+=" type like '"+util.getInfo(ch_userType)+"'";
		query+=" and login like '"+util.getInfo(tf_login)+"'";
		query+=" and password like '"+util.getInfo(tf_password)+"'";
		query+=" and lastname like '"+util.getInfo(tf_lastname)+"'";
		query+=" and firstname like '"+util.getInfo(tf_firstname)+"'";
		query+=" and email like '"+util.getInfo(tf_email)+"'";
		query+=" order by lastname";
		return query;
	}
	
	String InsertStr() {
		String s="insert into users (login,password,lastname,firstname,email,type) values (";
		s+="'"+tf_login.getText()+"'";
		s+=",'"+tf_password.getText()+"'";
		s+=",'"+tf_lastname.getText()+"'";
		s+=",'"+tf_firstname.getText()+"'";
		s+=",'"+tf_email.getText()+"'";
		s+=",'"+Client.getUserType(ch_userType.getSelectedItem())+"'";
		s+=")";
		return s;
	}
	
	String UpdateStr() {
		String s="update users set ";
		s+="login='"+tf_login.getText()+"'";
		s+=",password='"+tf_password.getText()+"'";
		s+=",lastname='"+tf_lastname.getText()+"'";
		s+=",firstname='"+tf_firstname.getText()+"'";
		s+=",email='"+tf_email.getText()+"'";
		s+=",type='"+Client.getUserType(ch_userType.getSelectedItem())+"'";
		s+=" where id="+lb_ID.getText();
		return s;
	}
	
	String DeleteStr() {
		return "delete from users where id="+lb_ID.getText();
	}
	
	public void actionPerformed(ActionEvent e){
		super.actionPerformed(e);
		if (e.getSource()==b_i||e.getSource()==b_u||e.getSource()==b_d) {
			tool.refreshUsers();
		}
	}
	
}