/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.lms.client;
/*
 * @(#)util.java  5 Nov 2002
 *
 * This software is property of CNICE
 *
 */
 
import java.util.*;
import java.awt.*;
import java.awt.event.*;

/**
 *
 * @version	 5 Nov 2002
 * @author Jose-Luis Abreu
 */
public class util {
	
	public static final int NormalText=0, PasswordText=1;
	public static final Font Monospaced=new Font("Monospaced",Font.PLAIN,15);
	public static final Font Serif=new Font("Serif",Font.PLAIN,15);
	public static final Font SansSerif=new Font("SansSerif",Font.PLAIN,15);
	public static final Font Monospaced16=new Font("Monospaced",Font.BOLD,16);
	public static final Font Serif16=new Font("Serif",Font.BOLD,16);
	public static final Font SansSerif16=new Font("SansSerif",Font.BOLD,16);

	public static String[] langs={"English","Espaol"};
	public static int Lang=1;
	public static final int usr=0,pwd=1,ok=2,cancel=3;
	public static final String[][] names={
		{"login","password","ok","cancel"},
		{"usuario","contrasea","aceptar","cancelar"}
	};
	public static void setLanguage(String l) {
		if (l!=null) {
			for (int i=0;i<langs.length;i++) {
				if (l.equalsIgnoreCase(langs[i])) {
					Lang=i;
				}
			}
		} else {
			Lang=0;
		}
	}
	

//	public static String getFirstToken(String s) {
//		int n=s.indexOf(' ');
//		if (n>0) {
//			return s.substring(0,n);
//		} else {
//			return s;
//		}
//	}
//	
//	public static String dropFirstToken(String s) {
//		int n=s.indexOf(' ');
//		if (n>=0) {
//			return s.substring(n+1);
//		} else {
//			return "";
//		}
//	}
//	
	public static String getInfo (int option,String title,String message,String defaultValue) {
		getInfoDialog gid=new getInfoDialog(option,title,message,defaultValue);
		gid.show();
		String s=gid.value;
		gid.dispose();
		return s;
	}
	
	public static void showMessage(String title,String msg,int rows, int columns) {
		msgDialog md=new msgDialog(title,msg,rows,columns);
		md.show();
		md.dispose();
	}
		
	public static void showMessage(String title,String msg) {
		showMessage(title,msg,5,50);
	}
		
	public static String getInfo(Component C) {
		String s="";
		if (C instanceof TextField) {
			s=((TextField) C).getText();
		} else if (C instanceof Choice) {
			s=((Choice) C).getSelectedItem();
		} else if (C instanceof Checkbox) {
			if (((Checkbox) C).getState()) {
				return "1";
			} else {
				return "0";
			}
		}
		if (s==null||s.length()==0) {
			s="%";
		} else {
			if (s.indexOf("%")<0) {
				s="%"+s+"%";
			}
		}
		return s;
	}

}

class getInfoDialog extends Dialog implements ActionListener {
	
	String value;
	private TextField textField;
	private Button ok_b, cancel_b;
	private int option=util.NormalText;

	getInfoDialog(int option,String title,String message,String defaultValue) {
		super(new Frame());
		setFont(util.Monospaced);
		setModal(true);
		setTitle(title);
		setLayout(new GridLayout(1,1));
		Label label = new Label(message);
		this.option=option;
		
		ok_b=new Button(util.names[util.Lang][util.ok]);
		cancel_b=new Button(util.names[util.Lang][util.cancel]);
		ok_b.addActionListener(this);
		cancel_b.addActionListener(this);
		Panel sp=new Panel();
		sp.setLayout(new GridLayout(1,2));
		sp.add(ok_b);
		sp.add(cancel_b);
		
		textField = new TextField(10);
		textField.setFont(util.Monospaced);
		textField.addActionListener(this);
		textField.setText(defaultValue);
		Panel cp=new Panel();
		cp.setLayout(new FlowLayout(FlowLayout.LEFT,5,10));
		Panel contentPane = new Panel(new BorderLayout());
		cp.add(label);
		cp.add(textField);
		if (option==util.PasswordText) {
			textField.setEchoChar('*');
		}
		contentPane.add(cp, BorderLayout.CENTER);
		contentPane.add(sp, BorderLayout.SOUTH);
		
		add(contentPane);
		pack();
		Dimension d=getSize();
		Dimension sz=Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((sz.width-d.width)/2,(sz.height-d.height)/2);
	}
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==textField) {
			value=textField.getText();
			setVisible(false);
		} else if (e.getSource()==ok_b) {
			value=textField.getText();
			setVisible(false);
		} else if (e.getSource()==cancel_b) {
			value=null;
			setVisible(false);
		}
	}
		
}

class msgDialog extends Dialog implements ActionListener, WindowListener, KeyListener {
	
	private TextArea textArea;
	private Button ok_b;

	msgDialog(String title,String msg,int rows,int columns) {
		super(new Frame());
		setFont(util.Monospaced);
		setModal(true);
		setTitle(title);
		setLayout(new BorderLayout());
		Panel CP=new Panel();
		CP.setLayout(new FlowLayout(FlowLayout.CENTER));
		CP.add(textArea=new TextArea(rows,columns));
		textArea.setFont(util.Monospaced);
		textArea.setEditable(false);
		textArea.setText(msg);
		add("Center",CP);
		Panel SP=new Panel();
		SP.setLayout(new FlowLayout(FlowLayout.CENTER));
		SP.add(ok_b=new Button(util.names[util.Lang][util.ok]));
		add("South",SP);
		ok_b.addActionListener(this);
		pack();
		Dimension d=getSize();
		Dimension sz=Toolkit.getDefaultToolkit().getScreenSize();
		setLocation((sz.width-d.width)/2,(sz.height-d.height)/2);
		ok_b.addKeyListener(this);
		addWindowListener(this);
	}
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==ok_b) {
			setVisible(false);
		} 
	}
		
/* ------------------- WindowListener ---------------- */
	
	public void windowClosing(WindowEvent e){
		setVisible(false);
	}
    public void windowOpened(WindowEvent e){
		ok_b.requestFocus();
    }
    public void windowActivated(WindowEvent e){
		ok_b.requestFocus();
    }
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}

    /* ----------------------- Key Listener ----------------------- */
    
    public void keyTyped(KeyEvent e) {}
    
    public void keyPressed(KeyEvent e) {
		if (e.getKeyCode()==KeyEvent.VK_ENTER) {
			setVisible(false);
		}
    }
   
    public void keyReleased(KeyEvent e) {}
    
}