/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.rad.client.learner;

/*
 * @(#)LearnerClient.java
 */

/**
 * @version	1.0  Ene 2007
 * @administrator: Jose-Luis Abreu
 */

import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;

//import org.cnice.rad.learner.*;
import org.cnice.rad.common.*;
import org.cnice.rad.client.*;
import org.cnice.rad.learner.*;

import com.mja.text.*;
import com.mja.parser.*;
import com.mja.util.*;

public class LearnerClient extends Client {
	
	private static volatile LearnerClient cl;
	private static volatile ClientDialog cd;
	public static boolean tiempoReal = false;

	public static LearnerClient client() {
		return cl;
	}
	
	private String[] alumnos;

	public static synchronized void initRAD(String nombre_equipo,String host) {
		int initial_port=8082;
		int final_port=8082;
		if (cl==null) {
			try {
				tracePrint("Connecting "+nombre_equipo+" to server "+host+" at port "+initial_port);
				cl=new LearnerClient(nombre_equipo,host,initial_port,final_port);
				cl.connect();
				if (cl.isConnected()) {
					if (cd==null) {
						cd=new ClientDialog(cl);
						tracePrint("conectado al RAD");
					} else {
						cd.setClient(cl);
					}
					boolean ok=cd.getSesionEquipo();
					if (ok) {
						cl.setLog(System.out);
						cl.alumnos=cd.getAlumnos();
					} else {
						cl=null;
					}
					String equipo="";
					if (BasicStr.hasContent(nombre_equipo)) {
						equipo=nombre_equipo+" ";
					}
					System.out.println(equipo+"conectado al servidor RAD "+host);
				} else {
					tracePrint("connexion to RAD failed");
					cl=null;
				}
			} catch (Exception e) {
				e.printStackTrace();
				cl=null;
			}
		}
	}
	
	public String[] getAlumnos() {
		return alumnos;
	}

	private PrintStream logps;
	private StringBuffer loginfo;

	public LearnerClient(String nom_equip,String host,int initial_port,int final_port) {
		super(nom_equip,host,initial_port,final_port);
	}

	public void setUser(String user_login,String user_password) {
		super.setUser(user_login,user_password);
		if (user_login!=null&&user_login.length()>0) {
			loginfo = new StringBuffer();
		}
	}

	public void setLog(String fileName) {
		if (fileName!=null) {
			try {
				fileName=fileName.replace('/',File.separatorChar);
				String dname=fileName;
				int p=dname.lastIndexOf(File.separatorChar);
				if (p>=0) {
					dname=dname.substring(0,p+1);
				}
				File f=new File(dname);
				f.mkdirs();
				logps = new PrintStream(
					new BufferedOutputStream(
					new FileOutputStream(fileName,true)));
			} catch (Exception e) {
				System.out.println(e);
			}
		}
	}

	public void setLog(PrintStream ps) {
		logps=ps;
	}

	private void logprintln(String id,String s) {
		if (loginfo!=null) {
			loginfo.append(s+"\n");
//			if (isConnected()&&id!=null) {
//				updateActivity(id,s+"\n");
//			}
		}
	}

	public void ProgramFinish() {
		if (logps!=null) {
			try {
				if (isConnected()) {
					try{
						boolean ok=executeCloseSesionEquipo(cd.id_sesion_equipo);
					} catch (Exception ex) {
						tracePrint(ex);
					}
				}
				logps.close();
			} catch (Exception e) {
				System.out.println(e);
			}
		}
	}

	/**
	 * Abre una actividad para la escena definida por :
	 * location (la direccin absoluta de la pgina donde se encuentra la escena)
	 * name 	(el nombre de la escena)
	 * code 	(el cdigo del applet de la escena)
	 * Antes de abrir la Actividad verifica si la escena est ya registrada
	 * y si no lo est la registra. 
	 * inoind e infoest son datos necesaros para registrar la escena
	 * pero no hace falta checar que sean iguales a los de la escena
	 * identificada por location,name y code
	 * Una vez la escena est registrada debe obtener su id para usarlo 
	 * al crear la Actividad.
	 */
	 
	private String infoind="",infoest="";

	public Actividad RADInitialize(String codebase, String filepath,String name,String appletcode,String infoind,String infoest) {
		String[] info=null;
		Actividad a=null;
		if (isConnected()) {
			try{
				String date=SqlMetadata.getDateTimeString();
				info = executeInsertActividad(cd.id_sesion_equipo,
					date,codebase,filepath,name,appletcode,infoind,infoest);
				this.infoind=infoind;
				this.infoest=infoest;
			} catch (Exception ex) {
				tracePrint(ex);
			}
		}
		if (info!=null) {
			a=new Actividad(info[0]);
		}
		return a;
	}

    private String[] executeInsertActividad(String id_sesion_equipo,String date,
    	String codebase,String filepath,String name,String appletcode,String infoind,String infoest) throws Exception {
		Message request = new InsertActivityRequest(user_login,user_password,
			id_sesion_equipo,date,codebase,filepath,name,appletcode,infoind,infoest);
		Message response = sendRequest(request);
		if(response==null) throw new Exception("Unreachable destination");

		if(response.getType()==Message.INSERTACTIVITY_RESPONSE){
		    return ((InsertActivityResponse) response).getInfo();
		}
		if(response.getType()==Message.EXCEPTION_RESPONSE){
			throw new Exception(((ExceptionResponse) response).getExceptionMessage());
		}
		tracePrint("Unexpected Response Type");
		return null;
    }

	
	/**
	 * Da por terminada una actividad
	 * ac es la Actividad que debe dar por terminada
	 * Al dar por terminda la actividad deben registrarse sus campos 
	 * de nota, aciertos y errores con los valores indicados
	 */

	public void RADFinish(Actividad ac,Parser parser,int nota,int aciertos,int errores) {
		if (isConnected()&&ac.getID()!=null) {
			try{
		    	Parser p=new Parser(0);
		    	Text T=new Text(p);
		    	RTF.parseRTF(infoind,T);
		    	RTF.parseRTF(infoest,T);
				String[][] finalVars=p.getVariables();
				for (int i=0;i<finalVars.length;i++) {
//					finalVars[i][1]=BasicStr.DoubleToString(parser.Var(finalVars[i][0]).r,6,false,".");
					finalVars[i][1]=Double.toString(parser.Var(finalVars[i][0]).getDouble());
				}
				long t0=ac.getInitialMillis();
				long t=System.currentTimeMillis();
				long sec=(t-t0)/1000;
				long centisec=(t-t0)/10-sec*100;
			    executeUpdateActivity(ac.getID(),"auto","final",sec,centisec,finalVars);
				String date=SqlMetadata.getDateTimeString();
			    executeCloseActivity(ac.getID(),date,nota,aciertos,errores);
			} catch (Exception ex) {
				tracePrint(ex);
			}
		}
	}
	
    private void executeCloseActivity(String id,String date,
    	int nota,int aciertos,int errores) throws Exception {

		Message request = new CloseActivityRequest(user_login,user_password,
			id,date,nota,aciertos,errores);
			
		if(tiempoReal) {
			sendRequest(request);
		} else {
			queueRequest(request);		
			sendQueue();
		}

/*

		Message response = sendRequest(request);
		if(response==null) throw new Exception("Unreachable destination");

		if(response.getType()==Message.CLOSEACTIVITY_RESPONSE){
		    return;
		}
		if(response.getType()==Message.EXCEPTION_RESPONSE){
			throw new Exception(((ExceptionResponse) response).getExceptionMessage());
		}
		tracePrint("Unexpected Response Type");

*/		
    }

	/**
	 * Registra una accin dentro de la actividad ac
	 * Si s !=null registra los parmetros definidos
	 * por las parejas (nombre,valor) formadas por
	 * (s[0][n],s[1][n]) para n de 0 a s[0].length-1
	 */

	public void RADAddAction(Actividad ac,String tipo,String name,String[][] parametros) {
		if (isConnected()&& (ac!=null) &&ac.getID()!=null) {
			try{
				long t0=ac.getInitialMillis();
				long t=System.currentTimeMillis();
				long sec=(t-t0)/1000;
				long centisec=(t-t0)/10-sec*100;
			    executeUpdateActivity(ac.getID(),tipo,name,sec,centisec,parametros);
			} catch (Exception ex) {
				tracePrint(ex);
			}
		}
	}

    private void executeUpdateActivity(String id,String tipo,String name,long sec,long centisec,
    	String[][] parametros) throws Exception {
		Message request = new UpdateActivityRequest(user_login,user_password,
			id,tipo,name,Long.toString(sec),Long.toString(centisec),parametros);
			

		
		if(tiempoReal)
			sendRequest(request);
		else
			queueRequest(request);	
		
		/*		
		Message response = sendRequest(request);
		if(response==null) throw new Exception("Unreachable destination");

		if(response.getType()==Message.UPDATEACTIVITY_RESPONSE){
		    return;
		}
		if(response.getType()==Message.EXCEPTION_RESPONSE){
			throw new Exception(((ExceptionResponse) response).getExceptionMessage());
		}
		tracePrint("Unexpected Response Type");
*/
    }

    private boolean executeCloseSesionEquipo(String id_sesion_equipo) throws Exception {
		Message request = new CloseSesionEquipoRequest(
				user_login,user_password,
				id_sesion_equipo);
		Message response = sendRequest(request);
		if(response==null) throw new Exception("Unreachable destination");

		if(response.getType()==Message.CLOSESESIONEQUIPO_RESPONSE){
		    return true;
		}
		if(response.getType()==Message.EXCEPTION_RESPONSE){
			throw new Exception(((ExceptionResponse) response).getExceptionMessage());
		}
		tracePrint("Unexpected Response Type");
		return false;
    }
}