/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.rad.common;

/*
 * @(#)Message.java
 */

/**
 * @version	1.0  Ene 2007
 * @administrator: Jose-Luis Abreu
 */

import java.io.Serializable;

public abstract class Message implements Serializable {

	public static final int
		EXCEPTION_RESPONSE         = 0,
		HELLO_REQUEST               = 1, HELLO_RESPONSE               = 2,
		USERDATA_REQUEST            = 3, USERDATA_RESPONSE            = 4,
		QUERY_REQUEST               = 5, QUERY_RESPONSE               = 6,
		UPDATE_REQUEST              = 7, UPDATE_RESPONSE              = 8,
		CLOSESERVER_REQUEST         = 9, CLOSESERVER_RESPONSE         =10,
		CREATESESIONGRUPO_REQUEST   =11, CREATESESIONGRUPO_RESPONSE   =12,
		CLOSESESIONGRUPO_REQUEST    =13, CLOSESESIONGRUPO_RESPONSE    =14,
		INSERTACTIVITY_REQUEST      =15, INSERTACTIVITY_RESPONSE      =16,
		CLOSEACTIVITY_REQUEST       =17, CLOSEACTIVITY_RESPONSE       =18,
		UPDATEACTIVITY_REQUEST      =19, UPDATEACTIVITY_RESPONSE      =20,
		CLOSESESIONEQUIPO_REQUEST   =21, CLOSESESIONEQUIPO_RESPONSE   =22,
		CREATESESIONEQUIPO_REQUEST  =23, CREATESESIONEQUIPO_RESPONSE  =24;

	public String login, password;

	public Message(String login,String password) {
		this.login=login;
		this.password=password;
	}

	abstract public int getType();

    public String getMessageName(){
		if(getType()==Message.EXCEPTION_RESPONSE){
		   	return "exception response";
		}
		if(getType()==Message.HELLO_REQUEST){
		   	return "hello request";
		}
		if(getType()==Message.HELLO_RESPONSE){
		   	return "hello response";
		}
		if(getType()==Message.USERDATA_REQUEST){
		   	return "user data request";
		}
		if(getType()==Message.USERDATA_RESPONSE){
		   	return "user data response";
		}
		if(getType()==Message.QUERY_REQUEST){
		   	return "query request";
		}
		if(getType()==Message.QUERY_RESPONSE){
		   	return "query response";
		}
		if(getType()==Message.UPDATE_REQUEST){
		   	return "update request";
		}
		if(getType()==Message.UPDATE_RESPONSE){
		   	return "update response";
		}
		if(getType()==Message.CLOSESERVER_REQUEST){
		    return "closeserver request";
		}
		if(getType()==Message.CLOSESERVER_RESPONSE){
		    return "closeserver response";
		}
		if(getType()==Message.CREATESESIONGRUPO_REQUEST){
		    return "create sesion grupo request";
		}
		if(getType()==Message.CREATESESIONGRUPO_RESPONSE){
		    return "create sesion grupo response";
		}
		if(getType()==Message.CLOSESESIONGRUPO_REQUEST){
		    return "close sesion grupo request";
		}
		if(getType()==Message.CLOSESESIONGRUPO_RESPONSE){
		    return "close sesion grupo response";
		}
		if(getType()==Message.INSERTACTIVITY_REQUEST){
		    return "insert activity request";
		}
		if(getType()==Message.INSERTACTIVITY_RESPONSE){
		    return "insert activity response";
		}
		if(getType()==Message.CLOSEACTIVITY_REQUEST){
		    return "close activity request";
		}
		if(getType()==Message.CLOSEACTIVITY_RESPONSE){
		    return "close activity response";
		}
		if(getType()==Message.UPDATEACTIVITY_REQUEST){
		    return "update activity request";
		}
		if(getType()==Message.UPDATEACTIVITY_RESPONSE){
		    return "update activity response";
		}
		if(getType()==Message.CLOSESESIONEQUIPO_REQUEST){
		    return "close sesion equipo request";
		}
		if(getType()==Message.CLOSESESIONEQUIPO_RESPONSE){
		    return "close sesion equipo response";
		}
		if(getType()==Message.CREATESESIONEQUIPO_REQUEST){
		    return "create sesion equipo request";
		}
		if(getType()==Message.CREATESESIONEQUIPO_RESPONSE){
		    return "create sesion equipo response";
		}
		return ("unknown type: " + getType());
    }

}