/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.rad.common;

/*
 * @(#)SqlValue.java
 */

/**
 * @version	1.0  Ene 2007
 * @administrator: Jose-Luis Abreu
 */

import java.io.Serializable;

public class SqlValue implements Serializable {

	private int type; // INTEGER, VARCHAR, DATE, TIME, TIMESTAMP, BLOB
	private int integer_value;
	private String string_value;
	private byte[] bytes_value;

	public SqlValue(int type,int value) {
		this.type=type;
		this.integer_value=value;
		try {
			string_value=String.valueOf(value);
			bytes_value=string_value.getBytes();
		} catch (Exception ex) {
		}
	}

	public SqlValue(int type,byte[] value) {
		this.type=type;
		this.bytes_value=value;
		string_value=new String(value);
	}

	public SqlValue(int type,String value) {
		this.type=type;
		this.string_value=value;
		try {
			bytes_value=value.getBytes();
			integer_value=Integer.parseInt(value);
		} catch (Exception ex) {
		}
	}

	public int getType() {
		return type;
	}

	public int getInt() {
		return integer_value;
	}

	public byte[] getBytes() {
		return bytes_value;
	}

	public String getString() {
		switch (type) {
		case SqlMetadata.INTEGER: return String.valueOf(integer_value);
		case SqlMetadata.DATE   :
		case SqlMetadata.TIME   :
		case SqlMetadata.TIMESTAMP   :
		case SqlMetadata.VARCHAR: return string_value;
		case SqlMetadata.LONGVARBINARY   : return new String(bytes_value);
		default                 : return string_value;
		}
	}
}