/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.rad.server;

/*
 * @(#)Server.java
 */

/**
 * @version	1.0  Ene 2007
 * @administrator: Jose-Luis Abreu
 */

import java.io.*;
import java.net.*;
import java.sql.*;

public class Server implements Runnable {
	
	private boolean standAlone=false;
	
	public static void main(String[] args) {
	    try {
	        SaveOutput.start("RADServer.log");
	    } catch (Exception e) {
	        e.printStackTrace();
	    }
	    System.out.println();
	    System.out.println("RAD Server version 08-06-22");

		String db_driver="org.gjt.mm.mysql.Driver";
		String db_host="jdbc:mysql://localhost/RAD";
		String db_user="RADServer";
		String db_password="cnice080622";
		String db_initial_port="8082",db_final_port="8082";
		boolean crearSesionDeGrupo=false;
		if (args!=null) {
			int i=0;
			while (i<args.length) {
				if (args[i].equals("-DRIVER")) {
					db_driver=args[++i];
				} else if (args[i].equals("-HOST")) {
					db_host=args[++i];
				} else if (args[i].equals("-INITIAL_PORT")) {
					db_initial_port=args[++i];
				} else if (args[i].equals("-FINAL_PORT")) {
					db_final_port=args[++i];
				} else if (args[i].equals("-GRUPO")) {
					crearSesionDeGrupo=true;
				}
				i++;
			}
		}

 		Server server=new Server(db_driver,db_host,db_user,db_password,db_initial_port,db_final_port);
 		server.standAlone=true;
	    if (crearSesionDeGrupo) {
	    	new Thread(server).start();
	    }
		try{
		    server.startProcessing();
		} catch(IOException ioe){
		    System.err.println(ioe);
		    ioe.printStackTrace();
		}
	}
	
	public void run() {
		try {
			Thread.sleep(500);
		   	CrearSesionGrupo.crear(false);
		} catch (InterruptedException e) {
		}
	}

	String db_driver, db_host, db_user, db_password, db_initial_port, db_final_port;

	public Server(String db_driver,String db_host,
    	String db_user, String db_password, String db_initial_port, String db_final_port) {
    	this.db_driver=db_driver;
    	this.db_host=db_host;
    	this.db_user=db_user;
    	this.db_password=db_password;
    	this.db_initial_port=db_initial_port;
    	this.db_final_port=db_final_port;
	}

	public static String getMemoryString() {
		Runtime rt=Runtime.getRuntime();
		long total=rt.totalMemory()/1024;
		long used=(rt.totalMemory()-rt.freeMemory())/1024;
		return Long.toString(used)+" / "+Long.toString(total);
	}
	
	private volatile boolean pleaseStop=false;
	
	boolean pleaseStop() {
		return pleaseStop;
	}
	
	public void stop() {
		pleaseStop=true;
	}
	
	public ServerSocket ss;

    public void startProcessing() throws IOException {
    	int PORT = (new Integer(db_initial_port)).intValue();
    	int end_PORT=(new Integer(db_final_port)).intValue();
    	boolean portok=false;
    	while (!portok) {
			try {
				ss = new ServerSocket(PORT);
				System.out.println("Listening on port="+PORT+"\n");
				portok=true;
			} catch (IOException ex) {
				if (PORT==end_PORT) {
					System.out.println("No port available");
					throw ex;
				}
				PORT++;
			}
		}
		try {
		    while(!pleaseStop()) {
				// Blocks until a connection occurs:
System.out.println(getMemoryString()+"   threads:"+Thread.activeCount());
				Socket socket = ss.accept();
				System.out.print("Accept ");
				try {
					DatabaseConnection dbc= new DatabaseConnection(db_driver,db_host,
						db_user,db_password,db_initial_port,db_final_port);
					if (dbc.driverIsLoaded()&&dbc.isConnected()) {
			    		ServeOneRequest server =  new ServeOneRequest(this,dbc,socket);
			    		new Thread(server).start();
			    	}
				} catch(IOException e) {
			    	// If it fails, close the socket,
			    	// otherwise the thread will close it:
			    	socket.close();
					System.out.println("Failure, connection closed.\n");
				}
		    }
		} catch (SocketException se) {
			System.out.println(se.getMessage());
		} finally {
			if (ss!=null) {
			    ss.close();
			    ss=null;
			}
		    System.out.println("RAD cerrado");
		}
	    System.out.println("RAD finalizado");
    }

    void shutdown() {
		SaveOutput.stop();
    	if (ss!=null) {
    		try {
	    		ss.close();
    		} catch (Exception e) {
    			e.printStackTrace();
    		}
    	}
		if (standAlone) {
			System.exit(0);
		}
    }
    
}

class Quiter extends Thread {

	BufferedReader br;

	Quiter() {
		br=new BufferedReader(new InputStreamReader(System.in));
		this.start();
	}

	public void run() {
		try {
			String str=br.readLine();
		} catch (IOException ioe) {
		} finally {
			System.exit(0);
		}
	}

}