/*
_____________________________________________

Descartes. Interactive Mathematics for Teaching and Learning
This program is free software; you can redistribute it and/or 
modify it under the terms of the European Public License 
(EUPL) v 1.1 as published by the IDABC (see http://ec.europa.eu/idabc/). 

Developing institutions
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Software development: Jos Luis Abreu Len, Marta Oliver Serrat
Functional Design: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Copyright by Ministerio de Educacin de Espaa.

This programme is distributed in good faith, but WITHOUT ANY WARRANTY, not even
with the implicit warranties of USABILITY or FITNESS FOR A CONCRETE PURPOSE.
For more information consult the EUPL License European Public License. 

You should have received a copy of the EUPL European Public License along with this 
program. If not, see http://ec.europa.eu/idabc/servlets/Docbb6d.pdf?id=31979
_____________________________________________

Descartes. Matemticas interactivas para la enseanza y el aprendizaje
Este programa es software libre; usted tiene derecho a redistribuirlo y/o
a modificarlo bajo los trminos de la Licencia pblica europea 
(EUPL) v 1.1 publicados por la IDABC (ver  http://ec.europa.eu/idabc/).

Instituciones desarrolladoras:
- Instituto de Tecnologas Educativas del Ministerio de Educacin de Espaa
- Instituto de Matemticas de la Universidad Nacional Autnoma de Mxico

Desarrollo de software: Jos Luis Abreu Len, Marta Oliver Serrat
Diseo funcional: Jos Luis Abreu Len, Juan Madrigal Muga, Jos R. Galo Snchez

Derechos de explotacin propiedad del Ministerio de Educacin de Espaa.

Este programa se distribuye de buena fe, pero SIN NINGUNA GARANTA, incluso sin 
las presuntas garantas implcitas de USABILIDAD o ADECUACIN A PROPSITO CONCRETO. 
Para mas informacin consulte la Licencia EUPL European Public License.

Usted debe haber recibido una copia de la Licencia EUPLjunto con este 
programa, si por algn motivo no le es posible visualizarla, puede consultarla en
la siguiente URL: http://ec.europa.eu/idabc/servlets/Docb4f4.pdf?id=31980
_____________________________________________

*/
package org.cnice.rad.server;

/*
 * @(#)ServerClose.java
 */

/**
 * @version	1.0  Ene 2007
 * @administrator: Jose-Luis Abreu
 */

import java.net.*;
import java.io.*;
import org.cnice.rad.common.*;

public class ServerClose {

	public static void main(String[] args) {
		String db_host="";
		String db_initial_port="8082", db_final_port="8082";
		String login="RADServer";
		String password="cnice080622";
		if (args!=null) {
			int i=0;
			while (i<args.length) {
				if (args[i].equals("-HOST")) {
					db_host=args[++i];
				} else if (args[i].equals("-INITIAL_PORT")) {
					db_initial_port=args[++i];
				} else if (args[i].equals("-FINAL_PORT")) {
					db_final_port=args[++i];
				} else if (args[i].equals("-LOGIN")) {
					login=args[++i];
				} else if (args[i].equals("-PASSWORD")) {
					password=args[++i];
				}
				i++;
			}
		}
		new ServerClose(db_host,db_initial_port,db_final_port,login,password);
		System.exit(0);
	}

	private String host,login,password;
	private int initial_port, final_port;
	private int PORT;
	
	public ServerClose(String db_host,String db_initial_port,String db_final_port,
		String login,String password) {
System.out.println("Server Close "+login+" "+password);
		this.host=db_host;
		this.initial_port=(new Integer(db_initial_port)).intValue();
		this.final_port=(new Integer(db_final_port)).intValue();
		this.login=login;
		this.password=password;
		if (!isDBOn()) {
			System.out.println("No server listening");
		} else {
			boolean ok=false;
			try {
				ok=executeCerrarSesionesGrupos();
			} catch (Exception e) {
				System.out.println(e);
			}
			if (ok) {
				System.out.println("Cerrar Sesion Grupo executed");
			} else {
				System.out.println("Problem encountered on Cerrar Sesion Grupo execution");
			}
			ok=false;
			try {
				ok=executeCloseServer();
			} catch (Exception e) {
				System.out.println(e);
			}
			if (ok) {
				System.out.println("Close Server executed");
			} else {
				System.out.println("Problem encountered on Close Server execution");
			}
		}
//		System.exit(0);
	}

	private boolean isDBOn() {
		try{
			executeHello();
			return true;
		} catch(Exception ex){
			ex.printStackTrace();
		}
		return false;
	}

    private void executeHello() throws Exception {
		InetAddress addr=null;
		Socket socket=null;
	    ObjectInputStream in=null;
    	ObjectOutputStream out=null;
		Message request = new HelloRequest();
		try{
		    if (host==null || host.equals("")) {
				addr = InetAddress.getByName(null);
		    } else {
				addr = InetAddress.getByName(host);
			}
			System.out.println("InetAddress="+addr);
		} catch(UnknownHostException uhe){
		    throw uhe;
		}
		PORT=initial_port;
		boolean portok=false;
		while (!portok) {
			while (true) {
				try {
					socket = new Socket(addr,PORT);
					break;
				} catch(IOException e) {
					if (PORT==final_port) {
						System.out.println("No port available");
						throw e;
					}
					PORT++;
				}
			}
			if (socket==null) {
				throw new Exception("Establishment of connection is impossible");
			}
			try {
			    out = new ObjectOutputStream(socket.getOutputStream());
			    out.flush();
			    in = new ObjectInputStream(socket.getInputStream());
			    out.writeObject(request);
			    out.flush();
			    Message response = null;
			    try{
					response=(Message)in.readObject();
			    } catch(ClassNotFoundException ce){
					System.out.println("Unknown Object received");
					socket.close();
					throw ce;
			    }
			    socket.close();
				if(response.getType()==Message.HELLO_RESPONSE){
					portok=true;
				} else {
				}
			} catch(IOException e) {
			    try {
					socket.close();
			    } catch(IOException e2) {
					System.out.println("Socket not closed");
					throw e2;
			    }
			}
			if (!portok) {
				if (PORT==final_port) {
					System.out.println("No port available");
					throw new Exception("No port available");
				}
				PORT++;
			}
		}
    }

    private Message sendRequest(Message msg) throws Exception {
		InetAddress addr=null;
		Socket socket=null;
		try{
		    if (host==null || host.equals("")) {
				addr = InetAddress.getByName(null);
		    } else {
				addr = InetAddress.getByName(host);
			}
		} catch(UnknownHostException ue){
		    System.err.println("Unable to get localhost direction "+host);
		    return null;
		}
		try {
			socket = new Socket(addr,PORT);
		} catch(IOException e) {
	    	System.out.println("Socket failed");
		}
		if (socket==null) {
			throw new Exception("Establishment of connection is impossible");
		}
	    ObjectInputStream in=null;
    	ObjectOutputStream out=null;
		try {
		    out = new ObjectOutputStream(socket.getOutputStream());
		    out.flush();
		    //Hay que poner el out primero porque si no podemos tener un deadlock
		    //Si cliente y servidor esperan por el in primero.
		    in = new ObjectInputStream(socket.getInputStream());
		    out.writeObject(msg);
		    out.flush();
		    Message msg2 = null;
		    try{
				msg2=(Message)in.readObject();
		    } catch(ClassNotFoundException ce){
				System.err.println("Unknown Object received");
				ce.printStackTrace();
				socket.close();
				return null;
		    }
		    socket.close();
		    return msg2;

		} catch(IOException e) {
		    // The socket should be closed on any
		    // failures other than the socket
		    // constructor:
		    try {
				socket.close();
		    } catch(IOException e2) {
				System.err.println("Socket not closed");
		    }
		}
		return null;
    }

    public boolean executeCerrarSesionesGrupos() throws Exception {
		Message request = new CerrarSesionGrupoRequest(login,password,"");
		Message response = sendRequest(request);
		if(response==null) throw new Exception("Unreachable destination");

		if(response.getType()==Message.CLOSESESIONGRUPO_RESPONSE){
		    return true;
		}
		if(response.getType()==Message.EXCEPTION_RESPONSE){
			throw new Exception(((ExceptionResponse) response).getExceptionMessage());
		}
		System.out.println("Unexpected Response Type "+response.getType());
		return false;
    }

    public boolean executeCloseServer() throws Exception {
		Message request = new CloseServerRequest(login,password);
		Message response = sendRequest(request);
		if(response==null) throw new Exception("Unreachable destination");

		if(response.getType()==Message.CLOSESERVER_RESPONSE){
		    return true;
		}
		if(response.getType()==Message.EXCEPTION_RESPONSE){
			throw new Exception(((ExceptionResponse) response).getExceptionMessage());
		}
		System.out.println("Unexpected Response Type "+response.getType());
		return false;
    }
    
}